import { EChartsOptions } from './echarts-options';
export declare type OptionDelegate = (options: EChartsOptions) => void;
export declare class EChartsService {
    private myECharts;
    setCharts(value: any): void;
    getECharts(): any;
    setOption(option: EChartsOptions, notMerge?: boolean, lazyUpdate?: boolean): void;
    getWidth(): number;
    getHeight(): number;
    getDom(): HTMLCanvasElement | HTMLDivElement;
    getOption(): EChartsOptions;
    resize(): void;
    dispatchAction(payload: Object): void;
    on(eventName: string, handler: Function, context?: Object): void;
    off(eventName: string, handler?: Function): void;
    convertToPixel(finder: {
        seriesIndex?: number;
        seriesId?: string;
        seriesName?: string;
        geoIndex?: number;
        geoId?: string;
        geoName?: string;
        xAxisIndex?: number;
        xAxisId?: string;
        xAxisName?: string;
        yAxisIndex?: number;
        yAxisId?: string;
        yAxisName?: string;
        gridIndex?: number;
        gridId?: string;
        gridName?: string;
    } | string, value: Array<any> | string): Array<any> | string;
    convertFromPixel(finder: {
        seriesIndex?: number;
        seriesId?: string;
        seriesName?: string;
        geoIndex?: number;
        geoId?: string;
        geoName?: string;
        xAxisIndex?: number;
        xAxisId?: string;
        xAxisName?: string;
        yAxisIndex?: number;
        yAxisId?: string;
        yAxisName?: string;
        gridIndex?: number;
        gridId?: string;
        gridName?: string;
    } | string, value: Array<any> | string): Array<any> | string;
    containPixel(finder: {
        seriesIndex?: number;
        seriesId?: string;
        seriesName?: string;
        geoIndex?: number;
        geoId?: string;
        geoName?: string;
        xAxisIndex?: number;
        xAxisId?: string;
        xAxisName?: string;
        yAxisIndex?: number;
        yAxisId?: string;
        yAxisName?: string;
        gridIndex?: number;
        gridId?: string;
        gridName?: string;
    } | string, value: Array<any>): Array<any>;
    showLoading(type?: string, opts?: Object): void;
    hideLoading(): void;
    getDataURL(opts: {
        type?: string;
        pixelRatio?: number;
        backgroundColor?: string;
        excludeComponents?: Array<string>;
    }): string;
    getConnectedDataURL(opts: {
        type?: string;
        pixelRatio?: number;
        backgroundColor?: string;
        excludeComponents?: Array<string>;
    }): string;
    clear(): void;
    dispose(): void;
    isDisposed(): boolean;
}
