import { OnInit, EventEmitter } from '@angular/core';
import { Moment } from 'moment';
import 'moment/locale/zh-cn';
export interface MonthInterface {
    index: number;
    name: string;
    isCurrentMonth: boolean;
    isSelectedMonth: boolean;
}
export interface DayInterface {
    number: number;
    isLastMonth: boolean;
    isNextMonth: boolean;
    isCurrentDay: boolean;
    isSelectedDay: boolean;
    distanceStartDay: number;
    isMiddleDay: boolean;
    title: string;
    date: Moment;
}
export interface WeekInterface {
    days: Array<DayInterface>;
}
export declare class DatepickerComponent implements OnInit {
    _el: HTMLElement;
    _weeksCalendar: Array<WeekInterface>;
    _listOfWeekName: Array<string>;
    _listOfMonthName: Array<string>;
    _listOfYearName: Array<string>;
    _yearUnit: string;
    _monthUnit: string;
    _showMonth: number;
    _showYear: number;
    _nowMonth: number;
    _value: Date;
    _locale: string;
    nzValue: Date;
    nzClearTime: boolean;
    nzShowYear: number;
    nzShowMonth: number;
    nzClickDay: EventEmitter<any>;
    nzMouseDay: EventEmitter<any>;
    constructor();
    ngOnInit(): void;
    _buildCalendar(): void;
    _generateYears(year: any): any[];
    _buildMonth(d: Moment): Array<WeekInterface>;
    _removeTime(date: any): any;
    _buildWeek(date: Moment, month: Moment): Array<DayInterface>;
    _clickDay($event: any, day: any): void;
    _mouseDay($event: any, day: any): void;
}
