import { EventEmitter, AfterViewInit, ElementRef, Renderer2, OnChanges, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class EditorComponent implements AfterViewInit, ControlValueAccessor, OnChanges {
    private elemRef;
    private doc;
    private render;
    editor: any;
    editorElem: HTMLElement;
    emptyArray: any[];
    content: any;
    defatulModules: {
        toolbar: (string[] | {
            'header': number;
        }[] | {
            'list': string;
        }[] | {
            'script': string;
        }[] | {
            'indent': string;
        }[] | {
            'direction': string;
        }[] | {
            'size': (string | boolean)[];
        }[] | {
            'header': (number | boolean)[];
        }[] | ({
            'color': any[];
        } | {
            'background': any[];
        })[] | {
            'font': any[];
        }[] | {
            'align': any[];
        }[])[];
    };
    theme: string;
    modules: {
        [index: string]: Object;
    };
    readOnly: boolean;
    placeholder: string;
    maxLength: number;
    minLength: number;
    required: boolean;
    formats: string[];
    style: any;
    strict: boolean;
    scrollingContainer: HTMLElement | string;
    bounds: HTMLElement | string;
    onEditorCreated: EventEmitter<any>;
    onContentChanged: EventEmitter<any>;
    onSelectionChanged: EventEmitter<any>;
    onModelChange: Function;
    onModelTouched: Function;
    constructor(elemRef: ElementRef, doc: any, render: Renderer2);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    writeValue(currentValue: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    validate(): Object;
}
