import { OnInit, EventEmitter, ElementRef } from '@angular/core';
export declare class PaginationComponent implements OnInit {
    private _elementRef;
    private _currentPage;
    private _pageSize;
    private _pageSizeOptions;
    private _total;
    private _showSizeChanger;
    private _showQuickJumper;
    private _showTotal;
    private _pageCount;
    private _isShowJumpPrev;
    private _isShowJumpNext;
    private _renderPages;
    private _simpleType;
    private _nzSize;
    private _el;
    /**
     * 当前页码
     */
    currentPage: number;
    /**
     * 数据总数
     */
    total: number;
    /**
     * 每页数据条数
     */
    pageSize: number;
    /**
     * 每页数据条数配置可选项
     */
    pageSizeOptions: Array<number>;
    /**
     * 是否可以更改每页数据条数
     */
    showSizeChanger: boolean | string;
    /**
     * 是否显示快速跳页
     */
    showQuickJumper: boolean | string;
    /**
     * 是否显示数据总数
     */
    showTotal: boolean | string;
    /**
     * 简单模式开关
     */
    simpleType: boolean | string;
    /**
     * 迷你模式开关
     */
    nzSize: string;
    /**
     * 切换页码时触发
     */
    onCurrentPageChange: EventEmitter<{}>;
    /**
     * 切换每页数据条数时触发
     */
    onPageSizeChange: EventEmitter<{}>;
    constructor(_elementRef: ElementRef);
    ngOnInit(): void;
    /**
     * 计算要渲染的中间页码
     */
    private _resetRenderPages();
    private _jump2Page(value);
    private _pageSizeChange($event);
    private readonly _pageSizeHalf;
}
