/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
export class SelectableItem {
    /**
     * @param {?} id
     * @param {?} text
     * @param {?} py
     * @param {?} firstPy
     * @param {?} data
     * @param {?} svc
     */
    constructor(id, text, py, firstPy, data, svc) {
        this.id = id;
        this.text = text;
        this.py = py;
        this.firstPy = firstPy;
        this.data = data;
        this.svc = svc;
        this._selected = false;
        this.isOpen = false;
        this.matchFilter = true;
        this.isVisible = false;
    }
    /**
     * @return {?}
     */
    get hasChild() {
        return this.children && this.children.length > 0;
    }
    /**
     * @return {?}
     */
    get checked() {
        if (this.hasChild && this.svc.Configuration.allowMultiple) {
            if (this.children.every((child) => child.selected)) {
                return true;
            }
            else if (this.children.every((child) => child.selected === false)) {
                return this._selected;
            }
            return null;
        }
        return this._selected;
    }
    /**
     * @return {?}
     */
    get selected() {
        if (this.hasChild && this.svc.Configuration.allowMultiple) {
            if (this.children.some((child) => child.selected)) {
                if (this.svc.Configuration.allowParentSelection) {
                    this._selected = false;
                }
                return true;
            }
            else if (this.children.every((child) => child.selected === false)) {
                if (this.svc.Configuration.allowParentSelection) {
                    return this._selected;
                }
                else {
                    return this._selected = false;
                }
            }
            return false;
        }
        else if (this.hasChild && this._selected === true) {
            for (const /** @type {?} */ itm of this.children) {
                itm.selected = false;
            }
        }
        return this._selected;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set selected(value) {
        if (this.hasChild) {
            // if (this.hasChild && !this.svc.Configuration.allowParentSelection) {
            if (value !== null) {
                this.children.forEach((child) => child.selected = value);
            }
        }
        else {
            this._selected = value;
        }
    }
}
function SelectableItem_tsickle_Closure_declarations() {
    /** @type {?} */
    SelectableItem.prototype._selected;
    /** @type {?} */
    SelectableItem.prototype.children;
    /** @type {?} */
    SelectableItem.prototype.isOpen;
    /** @type {?} */
    SelectableItem.prototype.matchFilter;
    /** @type {?} */
    SelectableItem.prototype.isVisible;
    /** @type {?} */
    SelectableItem.prototype.id;
    /** @type {?} */
    SelectableItem.prototype.text;
    /** @type {?} */
    SelectableItem.prototype.py;
    /** @type {?} */
    SelectableItem.prototype.firstPy;
    /** @type {?} */
    SelectableItem.prototype.data;
    /** @type {?} */
    SelectableItem.prototype.svc;
}
//# sourceMappingURL=selectable-item.js.map