import { Subject } from 'rxjs/Subject';
import { SelectableItem } from './models/selectable-item';
import { SelectOption } from './models/select-option';
import { ChineseToPinyinService } from '../core/service/chineseToPinyin.service';
export declare type OptionDelegate = (options: SelectOption) => void;
export declare class SelectService {
    private ctp;
    modelChanged$: Subject<any>;
    private _items;
    private _options;
    close(): void;
    open(): void;
    toggleOpen(): void;
    setItems(value: any[]): void;
    getInternalItems(): SelectableItem[];
    constructor(ctp: ChineseToPinyinService);
    setSelection(values: any | any[]): void;
    getSelection(): any | any[];
    getInternalSelection(): SelectableItem[];
    toggleItemSelection(item: SelectableItem): void;
    setAllUnselected(items: SelectableItem[]): void;
    setConfiguration(delegate: OptionDelegate, processItems: boolean): void;
    readonly Configuration: SelectOption;
    private toSelectableItems(sources);
    /**
     * 获取选中的项
     */
    private getSelectedItems(array);
    private reconfigure(processItems);
    private checkConfig();
    private getModel();
    private getItemForModel(value, array);
}
