import { TableService } from './../table.service';
import { ElementRef, OnInit, AfterViewInit, EventEmitter, Renderer2 } from '@angular/core';
import 'rxjs/add/operator/distinctUntilChanged';
export declare class DataTableComponent implements OnInit, AfterViewInit {
    private _elementRef;
    private render;
    private tableService;
    /** 渲染用data*/
    data: any[];
    /** 未分页原始数据*/
    _dataSet: any[];
    _el: HTMLElement;
    /** 分页设置*/
    _current: number;
    _total: number;
    _pageSize: number;
    _showLoading: boolean;
    _isInit: boolean;
    _isAjax: boolean;
    /**
     * 更改分页大小时触发
     */
    pageSizeChange: EventEmitter<any>;
    /**
     * 页码变化时触发事件
     */
    currentPageChange: EventEmitter<any>;
    /**
     * 表中数据更新时触发
     */
    dataChange: EventEmitter<any>;
    /**
     * 用户点击页码时触发
     */
    currentPageChangeClick: EventEmitter<any>;
    /**
     * 是否显示边框
     */
    showBordered: boolean;
    /**
     * 组件ui大小（small-middle-default）
     */
    nzSize: string;
    /**
     * 是否显示无数据时自定义的提示信息
     */
    customNoResult: boolean;
    /**
     * 是否显示分页
     * @memberof DataTableComponent
     */
    showPagination: boolean;
    /**
     * 是否显示“加载中”状态
     * @memberof DataTableComponent
     */
    showLoading: boolean;
    showSizeChanger: boolean;
    showQuickJumper: boolean;
    showTotal: boolean;
    showFooter: boolean;
    showTitle: boolean;
    /**
     * 是否固定表头只滚动内容
     * @memberof DataTableComponent
     */
    fixMode: boolean;
    maxHeight: string;
    /**
     * 是否使用hover十字线聚焦样式
     * @memberof DataTableComponent
     */
    crossMode: boolean;
    /**
     * 异步数据
     * @memberof DataTableComponent
     */
    asyncData: any[];
    /** 同步静态数据 */
    dataSource: any[];
    currentPage: number;
    pageSize: number;
    total: number;
    constructor(_elementRef: ElementRef, render: Renderer2, tableService: TableService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    pageChangeClick(value: any): void;
    onScroll($event: any): void;
    _generateData(forceRefresh?: boolean): void;
}
