/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
export class SelectOption {
    constructor() {
        this.idProperty = 'id';
        this.textProperty = 'name';
        this.childProperty = null;
        this.allowMultiple = true;
        this.closeOnSelection = true;
        this.items = [];
        this.isOpen = false;
        this.filter = '';
        this.allowParentSelection = true;
    }
    /**
     * @return {?}
     */
    isHierarchy() {
        return this.childProperty && this.childProperty.trim().length > 0;
    }
    /**
     * @return {?}
     */
    displayCheckbox() {
        return this.allowMultiple && this.isHierarchy();
    }
    /**
     * @return {?}
     */
    isValid() {
        // Check id property value
        return this.idProperty && this.idProperty.trim().length > 0 &&
            // Check text property value
            this.textProperty && this.textProperty.trim().length > 0 &&
            // Check items value
            this.items && Array.isArray(this.items) && this.items.length > 0;
    }
}
function SelectOption_tsickle_Closure_declarations() {
    /** @type {?} */
    SelectOption.prototype.idProperty;
    /** @type {?} */
    SelectOption.prototype.textProperty;
    /** @type {?} */
    SelectOption.prototype.childProperty;
    /** @type {?} */
    SelectOption.prototype.allowMultiple;
    /** @type {?} */
    SelectOption.prototype.closeOnSelection;
    /** @type {?} */
    SelectOption.prototype.items;
    /** @type {?} */
    SelectOption.prototype.model;
    /** @type {?} */
    SelectOption.prototype.isOpen;
    /** @type {?} */
    SelectOption.prototype.filter;
    /** @type {?} */
    SelectOption.prototype.allowParentSelection;
    /** @type {?} */
    SelectOption.prototype.maxVisibleItemCount;
}
//# sourceMappingURL=select-option.js.map