import { ElementRef, AfterContentChecked } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { SelectableItem } from './models/selectable-item';
import { SelectService } from './select.service';
import { TreeSelectDefaultOptions } from './models/tree-select-default-options';
export declare const CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR: any;
export declare class TreeSelectComponent implements ControlValueAccessor, AfterContentChecked {
    private svc;
    private defaultOpts;
    private eleRef;
    onTouchedCallback: () => void;
    showMoreLink: boolean;
    moreLoaded: boolean;
    disabled: boolean;
    placeholder: string;
    filterPlaceholder: string;
    allowFilter: boolean;
    maxHeight: number;
    width: number;
    className: string;
    private _isOpen;
    private onChangeCallback;
    private haveFocus;
    private inputFocus;
    items: any[];
    idField: string;
    textField: string;
    allowParentSelection: boolean;
    childrenField: string;
    multiple: boolean;
    maxVisibleItemCount: number;
    readonly internalItems: SelectableItem[];
    readonly selection: SelectableItem[];
    filter: string;
    constructor(svc: SelectService, defaultOpts: TreeSelectDefaultOptions, eleRef: ElementRef);
    keyUp($event: any): void;
    toggle($event: any): void;
    removeItem($event: any, item: SelectableItem): void;
    clearAll($event: any): void;
    readonly isOpen: boolean;
    clickedOutside($event: any): void;
    _style(): any;
    onTouched(): void;
    setInputFocus(): void;
    setInputFocusOut(): void;
    /**
     * Write a new value to the element.
     *
     * @memberof TreeSelectComponent
     */
    writeValue(value: any): void;
    /**
     * Set the function to be called when the control receives a change event.
     *
     */
    registerOnChange(fn: any): void;
    /**
     * Set the function to be called when the control receives a touch event.
     *
     */
    registerOnTouched(fn: any): void;
    /**
     * This function is called when the control status changes to or from "DISABLED".
     * Depending on the value, it will enable or disable the appropriate DOM element.
     *
     */
    setDisabledState?(isDisabled: boolean): void;
    /**
     * This finction is called when user click on show more link.
     *
     */
    loadMore($event: any): void;
    ngAfterContentChecked(): void;
    private ProcessMatchFilterTreeItem(tree, filter);
}
