import { OnInit, OnDestroy, NgZone, ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { ScriptService } from './script.service';
import { UEditorConfig } from './ueditor.config';
export declare type EVENT_TPYES = 'destroy' | 'reset' | 'focus' | 'langReady' | 'beforeExecCommand' | 'afterExecCommand' | 'firstBeforeExecCommand' | 'beforeGetContent' | 'afterGetContent' | 'getAllHtml' | 'beforeSetContent' | 'afterSetContent' | 'selectionchange' | 'beforeSelectionChange' | 'afterSelectionChange';
export declare class UEditorComponent implements OnInit, OnDestroy, ControlValueAccessor {
    private ss;
    private defaultConfig;
    private zone;
    private render;
    private instance;
    private value;
    private path;
    private events;
    loading: boolean;
    id: string;
    config: any;
    loadingTip: string;
    style: any;
    host: ElementRef;
    onPreReady: EventEmitter<UEditorComponent>;
    onReady: EventEmitter<UEditorComponent>;
    onDestroy: EventEmitter<any>;
    onContentChange: EventEmitter<any>;
    onChange: Function;
    onTouched: Function;
    constructor(ss: ScriptService, defaultConfig: UEditorConfig, zone: NgZone, render: Renderer2);
    ngOnInit(): void;
    init(options?: any): void;
    private updateValue(value);
    private destroy();
    /**
     * 获取UE实例
     *
     */
    readonly Instance: any;
    /**
     * 设置编辑语言
     */
    setLang(lang: 'zh-cn' | 'en'): void;
    /**
      * 添加编辑器事件
      */
    addListener(eventName: EVENT_TPYES, fn: Function): void;
    /**
     * 移除编辑器事件
     */
    removeListener(eventName: EVENT_TPYES): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
}
