import { OnInit, OnChanges, SimpleChanges, EventEmitter, Renderer2 } from '@angular/core';
import { UploadOptionType } from './upload-option-type';
import { DomSanitizer } from '@angular/platform-browser';
import { NzMessageService } from 'ng-zorro-antd';
import { UploadService } from './upload.service';
export declare class UploadComponent implements OnInit, OnChanges {
    sanitizer: DomSanitizer;
    private _message;
    _us: UploadService;
    renderer: Renderer2;
    files: any[];
    messages: any[];
    /**
     * 默认上传的最大尺寸
     */
    protected maxFileSize: number;
    options: UploadOptionType;
    fileList: Object[];
    onSelect: EventEmitter<{}>;
    onError: EventEmitter<{}>;
    onSuccess: EventEmitter<{}>;
    removeFile: EventEmitter<{}>;
    onPreviewPicture: EventEmitter<{}>;
    selectInput: any;
    constructor(sanitizer: DomSanitizer, _message: NzMessageService, _us: UploadService, renderer: Renderer2);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    selectFile(): void;
    /**
     * 选择文件
     * @param event
     */
    onFileSelect(event: any): void;
    /**
     * 上传文件
     */
    upload(name: string, file: any): void;
    /**
     * 验证传入的文件，是否符合
     */
    validate(file: File): boolean;
    /**
     * 文件类型的验证
     */
    private isFileTypeValid(file);
    /**
     * 删除文件
     */
    remove(i: number, file: any): void;
    getTypeClass(fileType: string): string;
    isWildcard(fileType: string): boolean;
    getFileExtension(file: File): string;
    isImage(file: File): boolean;
    onImageLoad(img: any): void;
    formatSize(bytes: any): string;
    hasFiles(): boolean;
    previewPicture(file: File): void;
    imageError(e: any, url: any): void;
    matchPicture(fileExt: any): string;
}
