(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-zorro-antd'), require('rxjs/Observable'), require('rxjs/observable/fromEvent'), require('rxjs/Subject'), require('rxjs/add/operator/distinctUntilChanged'), require('@angular/forms'), require('@angular/common'), require('rxjs/add/observable/fromEvent'), require('rxjs/add/operator/debounceTime'), require('@angular/platform-browser'), require('@angular/animations'), require('moment'), require('moment/locale/zh-cn')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'ng-zorro-antd', 'rxjs/Observable', 'rxjs/observable/fromEvent', 'rxjs/Subject', 'rxjs/add/operator/distinctUntilChanged', '@angular/forms', '@angular/common', 'rxjs/add/observable/fromEvent', 'rxjs/add/operator/debounceTime', '@angular/platform-browser', '@angular/animations', 'moment', 'moment/locale/zh-cn'], factory) :
	(factory((global.ngxBangUi = {}),global.ng.core,global.ngZorro.antd,global.Rx,global.Rx.Observable,global.Rx,global.Rx.Observable.prototype,global.ng.forms,global.ng.common,global.Rx.Observable,global.Rx.Observable.prototype,global.ng.platformBrowser,global.ng.animations,global.moment));
}(this, (function (exports,core,ngZorroAntd,Observable,fromEvent,Subject,distinctUntilChanged,forms,common,fromEvent$2,debounceTime,platformBrowser,animations,moment) { 'use strict';

moment = moment && moment.hasOwnProperty('default') ? moment['default'] : moment;

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var RowIndentComponent = (function () {
    function RowIndentComponent() {
        this._rowIndent = true;
    }
    Object.defineProperty(RowIndentComponent.prototype, "paddingLeft", {
        /**
         * @return {?}
         */
        get: function () {
            return this.indentSize * 20;
        },
        enumerable: true,
        configurable: true
    });
    return RowIndentComponent;
}());
RowIndentComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-row-indent',
                template: ""
            },] },
];
/** @nocollapse */
RowIndentComponent.ctorParameters = function () { return []; };
RowIndentComponent.propDecorators = {
    "indentSize": [{ type: core.Input },],
    "paddingLeft": [{ type: core.HostBinding, args: ["style.paddingLeft.px",] },],
    "_rowIndent": [{ type: core.HostBinding, args: ["class.ant-table-row-indent",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var RowExpandIconComponent = (function () {
    function RowExpandIconComponent() {
        this.isExpand = false;
        this.isShowExpand = false;
        this.isExpandChange = new core.EventEmitter();
        this._expandIcon = true;
    }
    Object.defineProperty(RowExpandIconComponent.prototype, "expanded", {
        /**
         * @return {?}
         */
        get: function () {
            return this.isExpand && !this.isShowExpand;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RowExpandIconComponent.prototype, "collapsed", {
        /**
         * @return {?}
         */
        get: function () {
            return !this.isExpand && !this.isShowExpand;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    RowExpandIconComponent.prototype.onClick = function () {
        this.isExpand = !this.isExpand;
        this.isExpandChange.emit(this.isExpand);
    };
    return RowExpandIconComponent;
}());
RowExpandIconComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-row-expand-icon',
                template: ""
            },] },
];
/** @nocollapse */
RowExpandIconComponent.ctorParameters = function () { return []; };
RowExpandIconComponent.propDecorators = {
    "isExpand": [{ type: core.Input },],
    "isShowExpand": [{ type: core.Input }, { type: core.HostBinding, args: ['class.ant-table-row-spaced',] },],
    "isExpandChange": [{ type: core.Output },],
    "expanded": [{ type: core.HostBinding, args: ["class.ant-table-row-expanded",] },],
    "collapsed": [{ type: core.HostBinding, args: ["class.ant-table-row-collapsed",] },],
    "_expandIcon": [{ type: core.HostBinding, args: ["class.ant-table-row-expand-icon",] },],
    "onClick": [{ type: core.HostListener, args: ['click',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DraggbleDirective = (function () {
    /**
     * @param {?} elementRef
     */
    function DraggbleDirective(elementRef) {
        this.dragX = true;
        this.dragY = true;
        this.dragStart = new core.EventEmitter();
        this.dragging = new core.EventEmitter();
        this.dragEnd = new core.EventEmitter();
        this.isDragging = false;
        this._element = elementRef.nativeElement;
    }
    /**
     * @return {?}
     */
    DraggbleDirective.prototype.ngOnInit = function () {
        var /** @type {?} */ handle = document.createElement('span');
        handle.setAttribute('class', 'drag-handle');
        this._element.appendChild(handle);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    DraggbleDirective.prototype.ngOnChanges = function (changes) {
        if (changes['dragEventTarget'] && changes['dragEventTarget'].currentValue && this.dragModel.dragging) {
            this.onMousedown(changes['dragEventTarget'].currentValue);
        }
    };
    /**
     * @return {?}
     */
    DraggbleDirective.prototype.ngOnDestroy = function () { };
    /**
     * @param {?} event
     * @return {?}
     */
    DraggbleDirective.prototype.onMousedown = function (event) {
        var _this = this;
        // 只拖拽表头内部的文字
        var /** @type {?} */ isDragElm = ((event.target)).classList.contains('draggable');
        if (isDragElm && (this.dragX || this.dragY)) {
            event.preventDefault();
            this.isDragging = true;
            var /** @type {?} */ mouseDownPos_1 = { x: event.clientX, y: event.clientY };
            var /** @type {?} */ mouseup = Observable.Observable.create(fromEvent.fromEvent(document, 'mouseup'));
            this.subscription = mouseup
                .subscribe(function (ev) { return _this.onMouseup(ev); });
            var /** @type {?} */ mouseMoveSub = Observable.Observable.create(fromEvent.fromEvent(document, 'mousemove')).takeUntil(mouseup)
                .subscribe(function (ev) { return _this.move(ev, mouseDownPos_1); });
            this.subscription.add(mouseMoveSub);
            this.dragStart.emit({
                event: event,
                element: this._element,
                model: this.dragModel
            });
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    DraggbleDirective.prototype.onMouseup = function (event) {
        if (!this.isDragging) {
            return;
        }
        this.isDragging = false;
        this._element.classList.remove('dragging');
        if (this.subscription) {
            this._destroySubscription();
            this.dragEnd.emit({
                event: event,
                element: this._element,
                model: this.dragModel
            });
        }
    };
    /**
     * @param {?} event
     * @param {?} mouseDownPos
     * @return {?}
     */
    DraggbleDirective.prototype.move = function (event, mouseDownPos) {
        if (!this.isDragging) {
            return;
        }
        var /** @type {?} */ x = event.clientX - mouseDownPos.x;
        var /** @type {?} */ y = event.clientY - mouseDownPos.y;
        if (this.dragX) {
            this._element.style.left = x + "px";
        }
        if (this.dragY) {
            this._element.style.top = y + "px";
        }
        this._element.classList.add('dragging');
        this.dragging.emit({
            event: event,
            element: this._element,
            model: this.dragModel
        });
    };
    /**
     * @return {?}
     */
    DraggbleDirective.prototype._destroySubscription = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
            this.subscription = undefined;
        }
    };
    return DraggbleDirective;
}());
DraggbleDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[buiDraggble]'
            },] },
];
/** @nocollapse */
DraggbleDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
DraggbleDirective.propDecorators = {
    "dragEventTarget": [{ type: core.Input },],
    "dragModel": [{ type: core.Input },],
    "dragX": [{ type: core.Input },],
    "dragY": [{ type: core.Input },],
    "dragStart": [{ type: core.Output },],
    "dragging": [{ type: core.Output },],
    "dragEnd": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TableService = (function () {
    function TableService() {
        this.mouseoverSubject = new Subject.Subject();
        this.mouseover$ = this.mouseoverSubject.asObservable();
    }
    /**
     * @param {?} columnIndex
     * @return {?}
     */
    TableService.prototype.setupHover = function (columnIndex) {
        this.mouseoverSubject.next(columnIndex);
    };
    return TableService;
}());
TableService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
TableService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTableComponent = (function () {
    /**
     * @param {?} _elementRef
     * @param {?} render
     * @param {?} tableService
     */
    function DataTableComponent(_elementRef, render, tableService) {
        this._elementRef = _elementRef;
        this.render = render;
        this.tableService = tableService;
        /**
         * 渲染用data
         */
        this.data = [];
        /**
         * 未分页原始数据
         */
        this._dataSet = [];
        /**
         * 分页设置
         */
        this._current = 1;
        this._pageSize = 10;
        this._isInit = false;
        this._isAjax = false;
        /**
         * 更改分页大小时触发
         */
        this.pageSizeChange = new core.EventEmitter();
        /**
         * 页码变化时触发事件
         */
        this.currentPageChange = new core.EventEmitter();
        /**
         * 表中数据更新时触发
         */
        this.dataChange = new core.EventEmitter();
        /**
         * 用户点击页码时触发
         */
        this.currentPageChangeClick = new core.EventEmitter();
        /**
         * 是否显示边框
         */
        this.showBordered = false;
        /**
         * 是否显示无数据时自定义的提示信息
         */
        this.customNoResult = false;
        /**
         * 是否显示分页
         * \@memberof DataTableComponent
         */
        this.showPagination = true;
        this.showSizeChanger = false;
        this.showQuickJumper = false;
        this.showTotal = false;
        this.showFooter = false;
        this.showTitle = false;
        /**
         * 是否固定表头只滚动内容
         * \@memberof DataTableComponent
         */
        this.fixMode = false;
        this.maxHeight = '600px';
        /**
         * 是否使用hover十字线聚焦样式
         * \@memberof DataTableComponent
         */
        this.crossMode = false;
        this._el = this._elementRef.nativeElement;
    }
    Object.defineProperty(DataTableComponent.prototype, "showLoading", {
        /**
         * @return {?}
         */
        get: function () {
            return this._showLoading;
        },
        /**
         * 是否显示“加载中”状态
         * \@memberof DataTableComponent
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._showLoading = value;
        },
        enumerable: true,
        configurable: true
    });
    
    
    Object.defineProperty(DataTableComponent.prototype, "asyncData", {
        /**
         * 异步数据
         * \@memberof DataTableComponent
         * @return {?}
         */
        get: function () {
            return this.data;
        },
        /**
         * @param {?} data
         * @return {?}
         */
        set: function (data) {
            this._isAjax = true;
            this.data = data;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableComponent.prototype, "dataSource", {
        /**
         * 同步静态数据
         * @return {?}
         */
        get: function () {
            return this._dataSet;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._dataSet = value;
            this.total = this._dataSet.length;
            this._generateData(true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableComponent.prototype, "currentPage", {
        /**
         * @return {?}
         */
        get: function () {
            return this._current;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this._current === value) {
                return;
            }
            this._current = value;
            this._generateData();
            this.currentPageChange.emit(this.currentPage);
        },
        enumerable: true,
        configurable: true
    });
    
    
    Object.defineProperty(DataTableComponent.prototype, "pageSize", {
        /**
         * @return {?}
         */
        get: function () {
            return this._pageSize;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this._pageSize === value) {
                return;
            }
            this._pageSize = value;
            this._generateData();
            if (this._isInit) {
                this.pageSizeChange.emit(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    
    
    Object.defineProperty(DataTableComponent.prototype, "total", {
        /**
         * @return {?}
         */
        get: function () {
            return this._total;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this._total === value) {
                return;
            }
            this._total = value;
        },
        enumerable: true,
        configurable: true
    });
    
    /**
     * @return {?}
     */
    DataTableComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.crossMode) {
            var /** @type {?} */ $table = this._el.querySelector('table');
            this.render.listen($table, 'mouseover', function (event) {
                var /** @type {?} */ $target = event.target;
                if ($target.tagName === 'TD' || $target.tagName === 'TH') {
                    var /** @type {?} */ index = Array.from($target.parentNode.children).indexOf($target);
                    _this.tableService.setupHover(index);
                }
            });
            this.render.listen($table, 'mouseleave', function () {
                _this.tableService.setupHover(-1);
            });
            this.tableService.mouseover$.distinctUntilChanged()
                .subscribe(function (index) {
                var /** @type {?} */ orgCols = Array.from(_this._el.querySelectorAll('.hover-col'));
                orgCols.map(function (col) {
                    col.classList.remove('hover-col');
                });
                if (index >= 0) {
                    var /** @type {?} */ trs = Array.from(_this._el.querySelectorAll('tr'));
                    trs.map(function (tr) {
                        tr.children[index].classList.add('hover-col');
                    });
                }
            });
        }
    };
    /**
     * @return {?}
     */
    DataTableComponent.prototype.ngAfterViewInit = function () {
        this._isInit = true;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DataTableComponent.prototype.pageChangeClick = function (value) {
        this.currentPage = value;
        this.currentPageChangeClick.emit(value);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    DataTableComponent.prototype.onScroll = function ($event) {
        var /** @type {?} */ top = event.srcElement.scrollTop;
        this._el.querySelector('[bui-thead]').setAttribute('style', 'transform:translateY(' + top + 'px)');
    };
    /**
     * @param {?=} forceRefresh
     * @return {?}
     */
    DataTableComponent.prototype._generateData = function (forceRefresh) {
        if (forceRefresh === void 0) { forceRefresh = false; }
        if (!this._isAjax) {
            if (this.showPagination) {
                if (forceRefresh) {
                    this.currentPage = 1;
                }
                this.data = this._dataSet.slice((this.currentPage - 1) * this.pageSize, this.currentPage * this.pageSize);
            }
            else {
                this.data = this._dataSet;
            }
            this.dataChange.emit(this.data);
        }
    };
    return DataTableComponent;
}());
DataTableComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-table',
                encapsulation: core.ViewEncapsulation.None,
                template: "<div class=\"ant-table-wrapper\" [class.ant-table-empty]=\"data.length==0\">\n  <nz-spin [nzSpinning]=\"showLoading\">\n    <div>\n      <div class=\"ant-table\" [class.ant-table-bordered]=\"showBordered\" [class.ant-table-large]=\"(nzSize!=='middle')&&(nzSize!=='small')\"\n        [class.ant-table-middle]=\"nzSize=='middle'\" [class.ant-table-small]=\"nzSize=='small'\">\n        <div class=\"ant-table-title\" *ngIf=\"showTitle\">\n          <ng-content select=\"[bui-table-title]\"></ng-content>\n        </div>\n        <div class=\"ant-table-content\" [class.fix-mode]=\"fixMode\" [class.cross-mode]=\"crossMode\" [style.maxHeight]=\"fixMode?maxHeight:'100%'\"\n          [style.overflow]=\"fixMode?'auto':'hidden'\" (scroll)=\"onScroll($event)\">\n          <div class=\"ant-table-body\">\n            <table>\n              <ng-content></ng-content>\n            </table>\n          </div>\n          <div class=\"ant-table-placeholder\" *ngIf=\"data.length==0 && !customNoResult\">\n            <span>\u6CA1\u6709\u6570\u636E</span>\n          </div>\n          <div class=\"ant-table-placeholder\" *ngIf=\"data.length==0 && customNoResult\">\n            <ng-content select=\"[noResult]\"></ng-content>\n          </div>\n        </div>\n        <div class=\"ant-table-footer\" *ngIf=\"showFooter\">\n          <ng-content select=\"[bui-table-footer]\"></ng-content>\n        </div>\n      </div>\n    </div>\n  </nz-spin>\n  <bui-pagination *ngIf=\"showPagination&&data.length\" class=\"ant-table-pagination\" [showSizeChanger]=\"showSizeChanger\" [showQuickJumper]=\"showQuickJumper\"\n    [showTotal]=\"showTotal\" [nzSize]=\"(nzSize=='middle'||nzSize=='small')?'small':''\" [(pageSize)]=\"pageSize\" [total]=\"total\"\n    [(currentPage)]=\"currentPage\" (onCurrentPageChange)=\"pageChangeClick($event)\">\n  </bui-pagination>\n</div>\n",
                styles: [
                    ".ant-table-wrapper {\n  zoom: 1;\n}\n.ant-table-wrapper:before,\n.ant-table-wrapper:after {\n  content: \" \";\n  display: table;\n}\n.ant-table-wrapper:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-table {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.65);\n  overflow: hidden;\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  /* fix firefox scrollbar bug */\n}\n.ant-table-body {\n  transition: opacity 0.3s ease;\n}\n.ant-table table {\n  width: 100%;\n  border-collapse: separate;\n  border-spacing: 0;\n  text-align: left;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-thead > tr > th {\n  position: relative;\n  background: #f7f7f7;\n  font-weight: 500;\n  transition: background .3s ease;\n  text-align: left;\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-table-thead > tr > th[colspan] {\n  text-align: center;\n}\n.ant-table-thead > tr > th .anticon-filter,\n.ant-table-thead > tr > th .ant-table-filter-icon {\n  position: relative;\n  margin-left: 4px;\n  font-size: 12px;\n  cursor: pointer;\n  color: #aaa;\n  transition: all .3s;\n  width: 14px;\n}\n.ant-table-thead > tr > th .anticon-filter:hover,\n.ant-table-thead > tr > th .ant-table-filter-icon:hover {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-thead > tr > th .ant-table-filter-icon:after {\n  content: '';\n  position: absolute;\n  width: 14px;\n  height: 50px;\n  left: 0;\n  top: -19px;\n}\n.ant-table-thead > tr > th .ant-table-filter-selected.anticon-filter {\n  color: #108ee9;\n}\n.ant-table-thead > tr > th .drag-handle {\n  visibility: hidden;\n  opacity: 0;\n  position: absolute;\n  right: 0;\n  top: 0;\n  height: 100%;\n  width: 3px;\n  border-left: 1px solid #e5e5e5;\n  border-right: 1px solid #e5e5e5;\n  transition: all .3s;\n}\n.ant-table-thead > tr > th .drag-handle:hover {\n  border-left: 1px solid #ddd;\n  border-right: 1px solid #ddd;\n  cursor: ew-resize;\n}\n.ant-table-thead > tr > th:hover .drag-handle {\n  visibility: visible;\n  opacity: 1;\n}\n.ant-table-tbody > tr > td {\n  border-bottom: 1px solid #e9e9e9;\n  transition: all .3s;\n}\n.ant-table-thead > tr,\n.ant-table-tbody > tr {\n  transition: all .3s;\n}\n.ant-table-thead > tr.ant-table-row-hover > td,\n.ant-table-tbody > tr.ant-table-row-hover > td,\n.ant-table-thead > tr:hover > td,\n.ant-table-tbody > tr:hover > td {\n  background: #ecf6fd;\n}\n.ant-table-thead > tr:hover {\n  background: none;\n}\n.ant-table-footer {\n  padding: 16px 8px;\n  background: #f7f7f7;\n  border-radius: 0 0 4px 4px;\n  position: relative;\n}\n.ant-table-footer:before {\n  content: '';\n  height: 1px;\n  background: #f7f7f7;\n  position: absolute;\n  top: -1px;\n  width: 100%;\n  left: 0;\n}\n.ant-table.ant-table-bordered .ant-table-footer {\n  border: 1px solid #e9e9e9;\n}\n.ant-table-title {\n  padding: 16px 0;\n  position: relative;\n  top: 1px;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table.ant-table-bordered .ant-table-title {\n  border: 1px solid #e9e9e9;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-table-title + .ant-table-content {\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-bordered .ant-table-title + .ant-table-content,\n.ant-table-bordered .ant-table-title + .ant-table-content table {\n  border-radius: 0;\n}\n.ant-table-without-column-header .ant-table-title + .ant-table-content,\n.ant-table-without-column-header table {\n  border-radius: 0;\n}\n.ant-table-tbody > tr.ant-table-row-selected {\n  background: #fafafa;\n}\n.ant-table-thead > tr > th.ant-table-column-sort {\n  background: #eee;\n}\n.ant-table-thead > tr > th,\n.ant-table-tbody > tr > td {\n  padding: 16px 8px;\n  word-break: break-all;\n}\n.ant-table-thead > tr > th.ant-table-selection-column-custom {\n  padding-left: 16px;\n  padding-right: 0;\n}\n.ant-table-thead > tr > th.ant-table-selection-column,\n.ant-table-tbody > tr > td.ant-table-selection-column {\n  text-align: center;\n  min-width: 62px;\n  width: 62px;\n}\n.ant-table-expand-icon-th,\n.ant-table-row-expand-icon-cell {\n  text-align: center;\n  min-width: 50px;\n  width: 50px;\n}\n.ant-table-header {\n  background: #f7f7f7;\n  overflow: hidden;\n}\n.ant-table-header table {\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-loading {\n  position: relative;\n}\n.ant-table-loading .ant-table-body {\n  background: #fff;\n  opacity: 0.5;\n}\n.ant-table-loading .ant-table-spin-holder {\n  height: 20px;\n  line-height: 20px;\n  left: 50%;\n  top: 50%;\n  margin-left: -30px;\n  position: absolute;\n}\n.ant-table-loading .ant-table-with-pagination {\n  margin-top: -20px;\n}\n.ant-table-loading .ant-table-without-pagination {\n  margin-top: 10px;\n}\n.ant-table-middle .ant-table-thead > tr > th:not(.ant-table-selection-column),\n.ant-table-middle .ant-table-tbody > tr > td {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-title,\n.ant-table-middle .ant-table-footer {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-column-sorter-up:after {\n  top: -13px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-middle .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 38px;\n  top: -13px;\n}\n.ant-table-small {\n  border: 1px solid #e9e9e9;\n  border-radius: 4px;\n}\n.ant-table-small .ant-table-header > table,\n.ant-table-small .ant-table-body > table {\n  border: 0;\n  padding: 0 8px;\n}\n.ant-table-small .ant-table-thead > tr > th {\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-tbody > tr > td {\n  padding: 6px 8px;\n}\n.ant-table-small .ant-table-title,\n.ant-table-small .ant-table-footer,\n.ant-table-small .ant-table-thead > tr > th:not(.ant-table-selection-column) {\n  padding: 10px 8px;\n}\n.ant-table-small .ant-table-title {\n  border-bottom: 1px solid #e9e9e9;\n  top: 0;\n}\n.ant-table-small .ant-table-header {\n  background: #fff;\n}\n.ant-table-small .ant-table-header table {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-placeholder,\n.ant-table-small .ant-table-row:last-child td {\n  border-bottom: 0;\n}\n.ant-table-small .ant-table-column-sorter-up:after {\n  top: -14px;\n  height: 13px;\n}\n.ant-table-small .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-small .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-small .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 39px;\n  top: -14px;\n}\n.ant-table-column-sorter {\n  position: relative;\n  margin-left: 4px;\n  display: inline-block;\n  width: 14px;\n  height: 14px;\n  vertical-align: middle;\n  text-align: center;\n}\n.ant-table-column-sorter-up,\n.ant-table-column-sorter-down {\n  line-height: 4px;\n  display: block;\n  width: 14px;\n  cursor: pointer;\n}\n.ant-table-column-sorter-up:hover .anticon,\n.ant-table-column-sorter-down:hover .anticon {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-column-sorter-up.on .anticon-caret-up,\n.ant-table-column-sorter-down.on .anticon-caret-up,\n.ant-table-column-sorter-up.on .anticon-caret-down,\n.ant-table-column-sorter-down.on .anticon-caret-down {\n  color: #108ee9;\n}\n.ant-table-column-sorter-up:after,\n.ant-table-column-sorter-down:after {\n  position: absolute;\n  content: '';\n  height: 20px;\n  width: 14px;\n  left: 0;\n}\n.ant-table-column-sorter-up:after {\n  top: -19px;\n}\n.ant-table-column-sorter-down:after {\n  bottom: -17px;\n}\n.ant-table-column-sorter .anticon-caret-up,\n.ant-table-column-sorter .anticon-caret-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  line-height: 6px;\n  height: 6px;\n  color: #aaa;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  filter: none;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  font-size: 12px;\n}\n.ant-table-column-sorter .anticon-caret-up:before,\n.ant-table-column-sorter .anticon-caret-down:before {\n  -moz-transform-origin: 53% 50%;\n  /* fix firefox position */\n}\n.ant-table-bordered .ant-table-header > table,\n.ant-table-bordered .ant-table-body > table,\n.ant-table-bordered .ant-table-fixed-left table,\n.ant-table-bordered .ant-table-fixed-right table {\n  border: 1px solid #e9e9e9;\n  border-right: 0;\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-empty .ant-table-placeholder {\n  border-left: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-header > table {\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body > table {\n  border-top: 0;\n  border-top-left-radius: 0;\n  border-top-right-radius: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body-inner > table {\n  border-top: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-placeholder {\n  border: 0;\n}\n.ant-table-bordered .ant-table-thead > tr > th {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-bordered .ant-table-thead > tr > th,\n.ant-table-bordered .ant-table-tbody > tr > td {\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small {\n  border-right: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-header > table,\n.ant-table-bordered.ant-table-small .ant-table-body > table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-left table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-right table {\n  border: 0;\n  padding: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-title {\n  border: 0;\n  border-bottom: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer {\n  border: 0;\n  border-top: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer:before {\n  display: none;\n}\n.ant-table-bordered.ant-table-small .ant-table-placeholder {\n  border-left: 0;\n  border-bottom: 0;\n}\n.ant-table-placeholder {\n  position: relative;\n  padding: 16px 8px;\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n  text-align: center;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-table-placeholder .anticon {\n  margin-right: 4px;\n}\n.ant-table-pagination {\n  margin: 16px 0;\n  float: right;\n}\n.ant-table-filter-dropdown {\n  min-width: 96px;\n  margin-left: -8px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu {\n  border: 0;\n  box-shadow: none;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-without-submenu {\n  max-height: 400px;\n  overflow-x: hidden;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item > label + span {\n  padding: 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-sub {\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu .ant-dropdown-submenu-contain-selected .ant-dropdown-menu-submenu-title:after {\n  color: #108ee9;\n  font-weight: bold;\n  text-shadow: 0 0 2px #d2eafb;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item {\n  overflow: hidden;\n}\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-item:last-child,\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-submenu:last-child .ant-dropdown-menu-submenu-title {\n  border-radius: 0;\n}\n.ant-table-filter-dropdown-btns {\n  overflow: hidden;\n  padding: 7px 8px;\n  border-top: 1px solid #e9e9e9;\n}\n.ant-table-filter-dropdown-link {\n  color: #108ee9;\n}\n.ant-table-filter-dropdown-link:hover {\n  color: #49a9ee;\n}\n.ant-table-filter-dropdown-link:active {\n  color: #0e77ca;\n}\n.ant-table-filter-dropdown-link.confirm {\n  float: left;\n}\n.ant-table-filter-dropdown-link.clear {\n  float: right;\n}\n.ant-table-selection-select-all-custom {\n  margin-right: 4px !important;\n}\n.ant-table-selection .anticon-down {\n  color: #aaa;\n  transition: all .3s;\n}\n.ant-table-selection-menu {\n  min-width: 96px;\n  margin-top: 5px;\n  margin-left: -30px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-selection-menu .ant-action-down {\n  color: #aaa;\n}\n.ant-table-selection-down {\n  cursor: pointer;\n  padding: 0;\n  display: inline-block;\n  line-height: 1;\n}\n.ant-table-selection-down:hover .anticon-down {\n  color: #666;\n}\n.ant-table-row-expand-icon {\n  cursor: pointer;\n  display: inline-block;\n  width: 17px;\n  height: 17px;\n  text-align: center;\n  line-height: 14px;\n  border: 1px solid #e9e9e9;\n  user-select: none;\n  background: #fff;\n}\n.ant-table-row-expanded:after {\n  content: '-';\n}\n.ant-table-row-collapsed:after {\n  content: '+';\n}\n.ant-table-row-spaced {\n  visibility: hidden;\n}\n.ant-table-row-spaced:after {\n  content: '.';\n}\n.ant-table-row[class*=\"ant-table-row-level-0\"] .ant-table-selection-column > span {\n  display: inline-block;\n}\ntr.ant-table-expanded-row,\ntr.ant-table-expanded-row:hover {\n  background: #fbfbfb;\n}\n.ant-table .ant-table-row-indent + .ant-table-row-expand-icon {\n  margin-right: 8px;\n}\n.ant-table-scroll {\n  overflow: auto;\n  overflow-x: hidden;\n}\n.ant-table-scroll table {\n  width: auto;\n  min-width: 100%;\n}\n.ant-table-body-inner {\n  height: 100%;\n}\n.ant-table-fixed-header > .ant-table-content > .ant-table-scroll > .ant-table-body {\n  position: relative;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-body-inner {\n  overflow: scroll;\n}\n.ant-table-fixed-header .ant-table-scroll .ant-table-header {\n  overflow: scroll;\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-header.ant-table-empty .ant-table-scroll .ant-table-body {\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-right {\n  position: absolute;\n  top: 0;\n  overflow: hidden;\n  transition: box-shadow 0.3s ease;\n  border-radius: 0;\n}\n.ant-table-fixed-left table,\n.ant-table-fixed-right table {\n  width: auto;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-outer .ant-table-fixed,\n.ant-table-fixed-header .ant-table-fixed-right .ant-table-body-outer .ant-table-fixed {\n  border-radius: 0;\n}\n.ant-table-fixed-left {\n  left: 0;\n  box-shadow: 6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-left .ant-table-header {\n  overflow-y: hidden;\n}\n.ant-table-fixed-left .ant-table-body-inner {\n  margin-right: -20px;\n  padding-right: 20px;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-inner {\n  padding-right: 0;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-left table {\n  border-radius: 4px 0 0 0;\n}\n.ant-table-fixed-right {\n  right: 0;\n  box-shadow: -6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-right,\n.ant-table-fixed-right table {\n  border-radius: 0 4px 0 0;\n}\n.ant-table-fixed-right .ant-table-expanded-row {\n  color: transparent;\n  pointer-events: none;\n}\n.ant-table.ant-table-scroll-position-left .ant-table-fixed-left {\n  box-shadow: none;\n}\n.ant-table.ant-table-scroll-position-right .ant-table-fixed-right {\n  box-shadow: none;\n}\n",
                    ".ant-table-wrapper {\n  zoom: 1;\n}\n.ant-table-wrapper:before,\n.ant-table-wrapper:after {\n  content: \" \";\n  display: table;\n}\n.ant-table-wrapper:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-table {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.65);\n  overflow: hidden;\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  /* fix firefox scrollbar bug */\n}\n.ant-table-body {\n  transition: opacity 0.3s ease;\n}\n.ant-table table {\n  width: 100%;\n  border-collapse: separate;\n  border-spacing: 0;\n  text-align: left;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-thead > tr > th {\n  position: relative;\n  background: #f7f7f7;\n  font-weight: 500;\n  transition: background .3s ease;\n  text-align: left;\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-table-thead > tr > th[colspan] {\n  text-align: center;\n}\n.ant-table-thead > tr > th .anticon-filter,\n.ant-table-thead > tr > th .ant-table-filter-icon {\n  position: relative;\n  margin-left: 4px;\n  font-size: 12px;\n  cursor: pointer;\n  color: #aaa;\n  transition: all .3s;\n  width: 14px;\n}\n.ant-table-thead > tr > th .anticon-filter:hover,\n.ant-table-thead > tr > th .ant-table-filter-icon:hover {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-thead > tr > th .ant-table-filter-icon:after {\n  content: '';\n  position: absolute;\n  width: 14px;\n  height: 50px;\n  left: 0;\n  top: -19px;\n}\n.ant-table-thead > tr > th .ant-table-filter-selected.anticon-filter {\n  color: #108ee9;\n}\n.ant-table-thead > tr > th .drag-handle {\n  visibility: hidden;\n  opacity: 0;\n  position: absolute;\n  right: 0;\n  top: 0;\n  height: 100%;\n  width: 3px;\n  border-left: 1px solid #e5e5e5;\n  border-right: 1px solid #e5e5e5;\n  transition: all .3s;\n}\n.ant-table-thead > tr > th .drag-handle:hover {\n  border-left: 1px solid #ddd;\n  border-right: 1px solid #ddd;\n  cursor: ew-resize;\n}\n.ant-table-thead > tr > th:hover .drag-handle {\n  visibility: visible;\n  opacity: 1;\n}\n.ant-table-tbody > tr > td {\n  border-bottom: 1px solid #e9e9e9;\n  transition: all .3s;\n}\n.ant-table-thead > tr,\n.ant-table-tbody > tr {\n  transition: all .3s;\n}\n.ant-table-thead > tr.ant-table-row-hover > td,\n.ant-table-tbody > tr.ant-table-row-hover > td,\n.ant-table-thead > tr:hover > td,\n.ant-table-tbody > tr:hover > td {\n  background: #ecf6fd;\n}\n.ant-table-thead > tr:hover {\n  background: none;\n}\n.ant-table-footer {\n  padding: 16px 8px;\n  background: #f7f7f7;\n  border-radius: 0 0 4px 4px;\n  position: relative;\n}\n.ant-table-footer:before {\n  content: '';\n  height: 1px;\n  background: #f7f7f7;\n  position: absolute;\n  top: -1px;\n  width: 100%;\n  left: 0;\n}\n.ant-table.ant-table-bordered .ant-table-footer {\n  border: 1px solid #e9e9e9;\n}\n.ant-table-title {\n  padding: 16px 0;\n  position: relative;\n  top: 1px;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table.ant-table-bordered .ant-table-title {\n  border: 1px solid #e9e9e9;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-table-title + .ant-table-content {\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-bordered .ant-table-title + .ant-table-content,\n.ant-table-bordered .ant-table-title + .ant-table-content table {\n  border-radius: 0;\n}\n.ant-table-without-column-header .ant-table-title + .ant-table-content,\n.ant-table-without-column-header table {\n  border-radius: 0;\n}\n.ant-table-tbody > tr.ant-table-row-selected {\n  background: #fafafa;\n}\n.ant-table-thead > tr > th.ant-table-column-sort {\n  background: #eee;\n}\n.ant-table-thead > tr > th,\n.ant-table-tbody > tr > td {\n  padding: 16px 8px;\n  word-break: break-all;\n}\n.ant-table-thead > tr > th.ant-table-selection-column-custom {\n  padding-left: 16px;\n  padding-right: 0;\n}\n.ant-table-thead > tr > th.ant-table-selection-column,\n.ant-table-tbody > tr > td.ant-table-selection-column {\n  text-align: center;\n  min-width: 62px;\n  width: 62px;\n}\n.ant-table-expand-icon-th,\n.ant-table-row-expand-icon-cell {\n  text-align: center;\n  min-width: 50px;\n  width: 50px;\n}\n.ant-table-header {\n  background: #f7f7f7;\n  overflow: hidden;\n}\n.ant-table-header table {\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-loading {\n  position: relative;\n}\n.ant-table-loading .ant-table-body {\n  background: #fff;\n  opacity: 0.5;\n}\n.ant-table-loading .ant-table-spin-holder {\n  height: 20px;\n  line-height: 20px;\n  left: 50%;\n  top: 50%;\n  margin-left: -30px;\n  position: absolute;\n}\n.ant-table-loading .ant-table-with-pagination {\n  margin-top: -20px;\n}\n.ant-table-loading .ant-table-without-pagination {\n  margin-top: 10px;\n}\n.ant-table-middle .ant-table-thead > tr > th:not(.ant-table-selection-column),\n.ant-table-middle .ant-table-tbody > tr > td {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-title,\n.ant-table-middle .ant-table-footer {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-column-sorter-up:after {\n  top: -13px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-middle .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 38px;\n  top: -13px;\n}\n.ant-table-small {\n  border: 1px solid #e9e9e9;\n  border-radius: 4px;\n}\n.ant-table-small .ant-table-header > table,\n.ant-table-small .ant-table-body > table {\n  border: 0;\n  padding: 0 8px;\n}\n.ant-table-small .ant-table-thead > tr > th {\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-tbody > tr > td {\n  padding: 6px 8px;\n}\n.ant-table-small .ant-table-title,\n.ant-table-small .ant-table-footer,\n.ant-table-small .ant-table-thead > tr > th:not(.ant-table-selection-column) {\n  padding: 10px 8px;\n}\n.ant-table-small .ant-table-title {\n  border-bottom: 1px solid #e9e9e9;\n  top: 0;\n}\n.ant-table-small .ant-table-header {\n  background: #fff;\n}\n.ant-table-small .ant-table-header table {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-placeholder,\n.ant-table-small .ant-table-row:last-child td {\n  border-bottom: 0;\n}\n.ant-table-small .ant-table-column-sorter-up:after {\n  top: -14px;\n  height: 13px;\n}\n.ant-table-small .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-small .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-small .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 39px;\n  top: -14px;\n}\n.ant-table-column-sorter {\n  position: relative;\n  margin-left: 4px;\n  display: inline-block;\n  width: 14px;\n  height: 14px;\n  vertical-align: middle;\n  text-align: center;\n}\n.ant-table-column-sorter-up,\n.ant-table-column-sorter-down {\n  line-height: 4px;\n  display: block;\n  width: 14px;\n  cursor: pointer;\n}\n.ant-table-column-sorter-up:hover .anticon,\n.ant-table-column-sorter-down:hover .anticon {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-column-sorter-up.on .anticon-caret-up,\n.ant-table-column-sorter-down.on .anticon-caret-up,\n.ant-table-column-sorter-up.on .anticon-caret-down,\n.ant-table-column-sorter-down.on .anticon-caret-down {\n  color: #108ee9;\n}\n.ant-table-column-sorter-up:after,\n.ant-table-column-sorter-down:after {\n  position: absolute;\n  content: '';\n  height: 20px;\n  width: 14px;\n  left: 0;\n}\n.ant-table-column-sorter-up:after {\n  top: -19px;\n}\n.ant-table-column-sorter-down:after {\n  bottom: -17px;\n}\n.ant-table-column-sorter .anticon-caret-up,\n.ant-table-column-sorter .anticon-caret-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  line-height: 6px;\n  height: 6px;\n  color: #aaa;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  filter: none;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  font-size: 12px;\n}\n.ant-table-column-sorter .anticon-caret-up:before,\n.ant-table-column-sorter .anticon-caret-down:before {\n  -moz-transform-origin: 53% 50%;\n  /* fix firefox position */\n}\n.ant-table-bordered .ant-table-header > table,\n.ant-table-bordered .ant-table-body > table,\n.ant-table-bordered .ant-table-fixed-left table,\n.ant-table-bordered .ant-table-fixed-right table {\n  border: 1px solid #e9e9e9;\n  border-right: 0;\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-empty .ant-table-placeholder {\n  border-left: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-header > table {\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body > table {\n  border-top: 0;\n  border-top-left-radius: 0;\n  border-top-right-radius: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body-inner > table {\n  border-top: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-placeholder {\n  border: 0;\n}\n.ant-table-bordered .ant-table-thead > tr > th {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-bordered .ant-table-thead > tr > th,\n.ant-table-bordered .ant-table-tbody > tr > td {\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small {\n  border-right: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-header > table,\n.ant-table-bordered.ant-table-small .ant-table-body > table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-left table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-right table {\n  border: 0;\n  padding: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-title {\n  border: 0;\n  border-bottom: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer {\n  border: 0;\n  border-top: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer:before {\n  display: none;\n}\n.ant-table-bordered.ant-table-small .ant-table-placeholder {\n  border-left: 0;\n  border-bottom: 0;\n}\n.ant-table-placeholder {\n  position: relative;\n  padding: 16px 8px;\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n  text-align: center;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-table-placeholder .anticon {\n  margin-right: 4px;\n}\n.ant-table-pagination {\n  margin: 16px 0;\n  float: right;\n}\n.ant-table-filter-dropdown {\n  min-width: 96px;\n  margin-left: -8px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu {\n  border: 0;\n  box-shadow: none;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-without-submenu {\n  max-height: 400px;\n  overflow-x: hidden;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item > label + span {\n  padding: 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-sub {\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu .ant-dropdown-submenu-contain-selected .ant-dropdown-menu-submenu-title:after {\n  color: #108ee9;\n  font-weight: bold;\n  text-shadow: 0 0 2px #d2eafb;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item {\n  overflow: hidden;\n}\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-item:last-child,\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-submenu:last-child .ant-dropdown-menu-submenu-title {\n  border-radius: 0;\n}\n.ant-table-filter-dropdown-btns {\n  overflow: hidden;\n  padding: 7px 8px;\n  border-top: 1px solid #e9e9e9;\n}\n.ant-table-filter-dropdown-link {\n  color: #108ee9;\n}\n.ant-table-filter-dropdown-link:hover {\n  color: #49a9ee;\n}\n.ant-table-filter-dropdown-link:active {\n  color: #0e77ca;\n}\n.ant-table-filter-dropdown-link.confirm {\n  float: left;\n}\n.ant-table-filter-dropdown-link.clear {\n  float: right;\n}\n.ant-table-selection-select-all-custom {\n  margin-right: 4px !important;\n}\n.ant-table-selection .anticon-down {\n  color: #aaa;\n  transition: all .3s;\n}\n.ant-table-selection-menu {\n  min-width: 96px;\n  margin-top: 5px;\n  margin-left: -30px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-selection-menu .ant-action-down {\n  color: #aaa;\n}\n.ant-table-selection-down {\n  cursor: pointer;\n  padding: 0;\n  display: inline-block;\n  line-height: 1;\n}\n.ant-table-selection-down:hover .anticon-down {\n  color: #666;\n}\n.ant-table-row-expand-icon {\n  cursor: pointer;\n  display: inline-block;\n  width: 17px;\n  height: 17px;\n  text-align: center;\n  line-height: 14px;\n  border: 1px solid #e9e9e9;\n  user-select: none;\n  background: #fff;\n}\n.ant-table-row-expanded:after {\n  content: '-';\n}\n.ant-table-row-collapsed:after {\n  content: '+';\n}\n.ant-table-row-spaced {\n  visibility: hidden;\n}\n.ant-table-row-spaced:after {\n  content: '.';\n}\n.ant-table-row[class*=\"ant-table-row-level-0\"] .ant-table-selection-column > span {\n  display: inline-block;\n}\ntr.ant-table-expanded-row,\ntr.ant-table-expanded-row:hover {\n  background: #fbfbfb;\n}\n.ant-table .ant-table-row-indent + .ant-table-row-expand-icon {\n  margin-right: 8px;\n}\n.ant-table-scroll {\n  overflow: auto;\n  overflow-x: hidden;\n}\n.ant-table-scroll table {\n  width: auto;\n  min-width: 100%;\n}\n.ant-table-body-inner {\n  height: 100%;\n}\n.ant-table-fixed-header > .ant-table-content > .ant-table-scroll > .ant-table-body {\n  position: relative;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-body-inner {\n  overflow: scroll;\n}\n.ant-table-fixed-header .ant-table-scroll .ant-table-header {\n  overflow: scroll;\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-header.ant-table-empty .ant-table-scroll .ant-table-body {\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-right {\n  position: absolute;\n  top: 0;\n  overflow: hidden;\n  transition: box-shadow 0.3s ease;\n  border-radius: 0;\n}\n.ant-table-fixed-left table,\n.ant-table-fixed-right table {\n  width: auto;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-outer .ant-table-fixed,\n.ant-table-fixed-header .ant-table-fixed-right .ant-table-body-outer .ant-table-fixed {\n  border-radius: 0;\n}\n.ant-table-fixed-left {\n  left: 0;\n  box-shadow: 6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-left .ant-table-header {\n  overflow-y: hidden;\n}\n.ant-table-fixed-left .ant-table-body-inner {\n  margin-right: -20px;\n  padding-right: 20px;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-inner {\n  padding-right: 0;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-left table {\n  border-radius: 4px 0 0 0;\n}\n.ant-table-fixed-right {\n  right: 0;\n  box-shadow: -6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-right,\n.ant-table-fixed-right table {\n  border-radius: 0 4px 0 0;\n}\n.ant-table-fixed-right .ant-table-expanded-row {\n  color: transparent;\n  pointer-events: none;\n}\n.ant-table.ant-table-scroll-position-left .ant-table-fixed-left {\n  box-shadow: none;\n}\n.ant-table.ant-table-scroll-position-right .ant-table-fixed-right {\n  box-shadow: none;\n}\n"
                ],
                providers: [TableService]
            },] },
];
/** @nocollapse */
DataTableComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core.Renderer2, },
    { type: TableService, },
]; };
DataTableComponent.propDecorators = {
    "pageSizeChange": [{ type: core.Output },],
    "currentPageChange": [{ type: core.Output },],
    "dataChange": [{ type: core.Output },],
    "currentPageChangeClick": [{ type: core.Output },],
    "showBordered": [{ type: core.Input },],
    "nzSize": [{ type: core.Input },],
    "customNoResult": [{ type: core.Input },],
    "showPagination": [{ type: core.Input },],
    "showLoading": [{ type: core.Input },],
    "showSizeChanger": [{ type: core.Input },],
    "showQuickJumper": [{ type: core.Input },],
    "showTotal": [{ type: core.Input },],
    "showFooter": [{ type: core.Input },],
    "showTitle": [{ type: core.Input },],
    "fixMode": [{ type: core.Input },],
    "maxHeight": [{ type: core.Input },],
    "crossMode": [{ type: core.Input },],
    "asyncData": [{ type: core.Input },],
    "dataSource": [{ type: core.Input },],
    "currentPage": [{ type: core.Input },],
    "pageSize": [{ type: core.Input },],
    "total": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataThDirective = (function () {
    /**
     * @param {?} _elementRef
     */
    function DataThDirective(_elementRef) {
        this._elementRef = _elementRef;
        this._el = this._elementRef.nativeElement;
    }
    return DataThDirective;
}());
DataThDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[bui-th]'
            },] },
];
/** @nocollapse */
DataThDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
DataThDirective.propDecorators = {
    "checkbox": [{ type: core.Input }, { type: core.HostBinding, args: ["class.ant-table-selection-column",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTdDirective = (function () {
    /**
     * @param {?} _elementRef
     */
    function DataTdDirective(_elementRef) {
        this._elementRef = _elementRef;
        this._el = this._elementRef.nativeElement;
    }
    return DataTdDirective;
}());
DataTdDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[bui-td]'
            },] },
];
/** @nocollapse */
DataTdDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
DataTdDirective.propDecorators = {
    "checkbox": [{ type: core.Input }, { type: core.HostBinding, args: ["class.ant-table-selection-column",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTheadDirective = (function () {
    function DataTheadDirective() {
    }
    return DataTheadDirective;
}());
DataTheadDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[bui-thead]'
            },] },
];
/** @nocollapse */
DataTheadDirective.ctorParameters = function () { return []; };
DataTheadDirective.propDecorators = {
    "true": [{ type: core.HostBinding, args: ["class.ant-table-thead",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTbodyDirective = (function () {
    function DataTbodyDirective() {
    }
    return DataTbodyDirective;
}());
DataTbodyDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[bui-tbody]'
            },] },
];
/** @nocollapse */
DataTbodyDirective.ctorParameters = function () { return []; };
DataTbodyDirective.propDecorators = {
    "true": [{ type: core.HostBinding, args: ["class.ant-table-tbody",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTbodyTrDirective = (function () {
    function DataTbodyTrDirective() {
    }
    return DataTbodyTrDirective;
}());
DataTbodyTrDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[bui-tbody-tr]'
            },] },
];
/** @nocollapse */
DataTbodyTrDirective.ctorParameters = function () { return []; };
DataTbodyTrDirective.propDecorators = {
    "true": [{ type: core.HostBinding, args: ["class.ant-table-row",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataDividerDirective = (function () {
    function DataDividerDirective() {
    }
    return DataDividerDirective;
}());
DataDividerDirective.decorators = [
    { type: core.Directive, args: [{
                // tslint:disable-next-line:directive-selector
                selector: '[bui-divider]'
            },] },
];
/** @nocollapse */
DataDividerDirective.ctorParameters = function () { return []; };
DataDividerDirective.propDecorators = {
    "true": [{ type: core.HostBinding, args: ["class.ant-divider",] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DataTableSortComponent = (function () {
    /**
     * @param {?} dataThDirective
     * @param {?} _renderer
     */
    function DataTableSortComponent(dataThDirective, _renderer) {
        this.dataThDirective = dataThDirective;
        this._renderer = _renderer;
        this._value = null;
        /**
         * 改变排序方向时触发事件
         */
        this.sortValueChange = new core.EventEmitter();
    }
    Object.defineProperty(DataTableSortComponent.prototype, "sortValue", {
        /**
         * 设置排序方向，ascend-升序，descend-降序
         * \@readonly
         * \@memberof DataTableSortComponent
         * @return {?}
         */
        get: function () {
            return this._value;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._value = value;
            if ((this._value !== 'ascend') && (this._value !== 'descend')) {
                if (this.dataThDirective) {
                    this._renderer.removeClass(this.dataThDirective._el, 'ant-table-column-sort');
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    DataTableSortComponent.prototype._setValue = function (value) {
        if (this.sortValue === value) {
            this.sortValue = null;
            if (this.dataThDirective) {
                this._renderer.removeClass(this.dataThDirective._el, 'ant-table-column-sort');
            }
        }
        else {
            this.sortValue = value;
            if (this.dataThDirective) {
                this._renderer.addClass(this.dataThDirective._el, 'ant-table-column-sort');
            }
        }
        this.sortValueChange.emit(this.sortValue);
    };
    /**
     * @return {?}
     */
    DataTableSortComponent.prototype.ngOnInit = function () {
    };
    return DataTableSortComponent;
}());
DataTableSortComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'table-sort',
                encapsulation: core.ViewEncapsulation.None,
                template: "\n    <div class=\"ant-table-column-sorter\">\n      <span class=\"ant-table-column-sorter-up\" [ngClass]=\"{'on':_value == 'ascend'}\" title=\"\u2191\" (click)=\"_setValue('ascend')\">\n        <i class=\"anticon anticon-caret-up\"></i>\n      </span>\n      <span class=\"ant-table-column-sorter-down\" [ngClass]=\"{'on':_value == 'descend'}\" title=\"\u2193\" (click)=\"_setValue('descend')\">\n        <i class=\"anticon anticon-caret-down\"></i>\n      </span>\n    </div>\n  ",
                styles: [
                    ".ant-table-wrapper {\n  zoom: 1;\n}\n.ant-table-wrapper:before,\n.ant-table-wrapper:after {\n  content: \" \";\n  display: table;\n}\n.ant-table-wrapper:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-table {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.65);\n  overflow: hidden;\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  /* fix firefox scrollbar bug */\n}\n.ant-table-body {\n  transition: opacity 0.3s ease;\n}\n.ant-table table {\n  width: 100%;\n  border-collapse: separate;\n  border-spacing: 0;\n  text-align: left;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-thead > tr > th {\n  position: relative;\n  background: #f7f7f7;\n  font-weight: 500;\n  transition: background .3s ease;\n  text-align: left;\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-table-thead > tr > th[colspan] {\n  text-align: center;\n}\n.ant-table-thead > tr > th .anticon-filter,\n.ant-table-thead > tr > th .ant-table-filter-icon {\n  position: relative;\n  margin-left: 4px;\n  font-size: 12px;\n  cursor: pointer;\n  color: #aaa;\n  transition: all .3s;\n  width: 14px;\n}\n.ant-table-thead > tr > th .anticon-filter:hover,\n.ant-table-thead > tr > th .ant-table-filter-icon:hover {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-thead > tr > th .ant-table-filter-icon:after {\n  content: '';\n  position: absolute;\n  width: 14px;\n  height: 50px;\n  left: 0;\n  top: -19px;\n}\n.ant-table-thead > tr > th .ant-table-filter-selected.anticon-filter {\n  color: #108ee9;\n}\n.ant-table-thead > tr > th .drag-handle {\n  visibility: hidden;\n  opacity: 0;\n  position: absolute;\n  right: 0;\n  top: 0;\n  height: 100%;\n  width: 3px;\n  border-left: 1px solid #e5e5e5;\n  border-right: 1px solid #e5e5e5;\n  transition: all .3s;\n}\n.ant-table-thead > tr > th .drag-handle:hover {\n  border-left: 1px solid #ddd;\n  border-right: 1px solid #ddd;\n  cursor: ew-resize;\n}\n.ant-table-thead > tr > th:hover .drag-handle {\n  visibility: visible;\n  opacity: 1;\n}\n.ant-table-tbody > tr > td {\n  border-bottom: 1px solid #e9e9e9;\n  transition: all .3s;\n}\n.ant-table-thead > tr,\n.ant-table-tbody > tr {\n  transition: all .3s;\n}\n.ant-table-thead > tr.ant-table-row-hover > td,\n.ant-table-tbody > tr.ant-table-row-hover > td,\n.ant-table-thead > tr:hover > td,\n.ant-table-tbody > tr:hover > td {\n  background: #ecf6fd;\n}\n.ant-table-thead > tr:hover {\n  background: none;\n}\n.ant-table-footer {\n  padding: 16px 8px;\n  background: #f7f7f7;\n  border-radius: 0 0 4px 4px;\n  position: relative;\n}\n.ant-table-footer:before {\n  content: '';\n  height: 1px;\n  background: #f7f7f7;\n  position: absolute;\n  top: -1px;\n  width: 100%;\n  left: 0;\n}\n.ant-table.ant-table-bordered .ant-table-footer {\n  border: 1px solid #e9e9e9;\n}\n.ant-table-title {\n  padding: 16px 0;\n  position: relative;\n  top: 1px;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table.ant-table-bordered .ant-table-title {\n  border: 1px solid #e9e9e9;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-table-title + .ant-table-content {\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-bordered .ant-table-title + .ant-table-content,\n.ant-table-bordered .ant-table-title + .ant-table-content table {\n  border-radius: 0;\n}\n.ant-table-without-column-header .ant-table-title + .ant-table-content,\n.ant-table-without-column-header table {\n  border-radius: 0;\n}\n.ant-table-tbody > tr.ant-table-row-selected {\n  background: #fafafa;\n}\n.ant-table-thead > tr > th.ant-table-column-sort {\n  background: #eee;\n}\n.ant-table-thead > tr > th,\n.ant-table-tbody > tr > td {\n  padding: 16px 8px;\n  word-break: break-all;\n}\n.ant-table-thead > tr > th.ant-table-selection-column-custom {\n  padding-left: 16px;\n  padding-right: 0;\n}\n.ant-table-thead > tr > th.ant-table-selection-column,\n.ant-table-tbody > tr > td.ant-table-selection-column {\n  text-align: center;\n  min-width: 62px;\n  width: 62px;\n}\n.ant-table-expand-icon-th,\n.ant-table-row-expand-icon-cell {\n  text-align: center;\n  min-width: 50px;\n  width: 50px;\n}\n.ant-table-header {\n  background: #f7f7f7;\n  overflow: hidden;\n}\n.ant-table-header table {\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-loading {\n  position: relative;\n}\n.ant-table-loading .ant-table-body {\n  background: #fff;\n  opacity: 0.5;\n}\n.ant-table-loading .ant-table-spin-holder {\n  height: 20px;\n  line-height: 20px;\n  left: 50%;\n  top: 50%;\n  margin-left: -30px;\n  position: absolute;\n}\n.ant-table-loading .ant-table-with-pagination {\n  margin-top: -20px;\n}\n.ant-table-loading .ant-table-without-pagination {\n  margin-top: 10px;\n}\n.ant-table-middle .ant-table-thead > tr > th:not(.ant-table-selection-column),\n.ant-table-middle .ant-table-tbody > tr > td {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-title,\n.ant-table-middle .ant-table-footer {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-column-sorter-up:after {\n  top: -13px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-middle .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 38px;\n  top: -13px;\n}\n.ant-table-small {\n  border: 1px solid #e9e9e9;\n  border-radius: 4px;\n}\n.ant-table-small .ant-table-header > table,\n.ant-table-small .ant-table-body > table {\n  border: 0;\n  padding: 0 8px;\n}\n.ant-table-small .ant-table-thead > tr > th {\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-tbody > tr > td {\n  padding: 6px 8px;\n}\n.ant-table-small .ant-table-title,\n.ant-table-small .ant-table-footer,\n.ant-table-small .ant-table-thead > tr > th:not(.ant-table-selection-column) {\n  padding: 10px 8px;\n}\n.ant-table-small .ant-table-title {\n  border-bottom: 1px solid #e9e9e9;\n  top: 0;\n}\n.ant-table-small .ant-table-header {\n  background: #fff;\n}\n.ant-table-small .ant-table-header table {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-placeholder,\n.ant-table-small .ant-table-row:last-child td {\n  border-bottom: 0;\n}\n.ant-table-small .ant-table-column-sorter-up:after {\n  top: -14px;\n  height: 13px;\n}\n.ant-table-small .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-small .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-small .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 39px;\n  top: -14px;\n}\n.ant-table-column-sorter {\n  position: relative;\n  margin-left: 4px;\n  display: inline-block;\n  width: 14px;\n  height: 14px;\n  vertical-align: middle;\n  text-align: center;\n}\n.ant-table-column-sorter-up,\n.ant-table-column-sorter-down {\n  line-height: 4px;\n  display: block;\n  width: 14px;\n  cursor: pointer;\n}\n.ant-table-column-sorter-up:hover .anticon,\n.ant-table-column-sorter-down:hover .anticon {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-column-sorter-up.on .anticon-caret-up,\n.ant-table-column-sorter-down.on .anticon-caret-up,\n.ant-table-column-sorter-up.on .anticon-caret-down,\n.ant-table-column-sorter-down.on .anticon-caret-down {\n  color: #108ee9;\n}\n.ant-table-column-sorter-up:after,\n.ant-table-column-sorter-down:after {\n  position: absolute;\n  content: '';\n  height: 20px;\n  width: 14px;\n  left: 0;\n}\n.ant-table-column-sorter-up:after {\n  top: -19px;\n}\n.ant-table-column-sorter-down:after {\n  bottom: -17px;\n}\n.ant-table-column-sorter .anticon-caret-up,\n.ant-table-column-sorter .anticon-caret-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  line-height: 6px;\n  height: 6px;\n  color: #aaa;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  filter: none;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  font-size: 12px;\n}\n.ant-table-column-sorter .anticon-caret-up:before,\n.ant-table-column-sorter .anticon-caret-down:before {\n  -moz-transform-origin: 53% 50%;\n  /* fix firefox position */\n}\n.ant-table-bordered .ant-table-header > table,\n.ant-table-bordered .ant-table-body > table,\n.ant-table-bordered .ant-table-fixed-left table,\n.ant-table-bordered .ant-table-fixed-right table {\n  border: 1px solid #e9e9e9;\n  border-right: 0;\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-empty .ant-table-placeholder {\n  border-left: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-header > table {\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body > table {\n  border-top: 0;\n  border-top-left-radius: 0;\n  border-top-right-radius: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body-inner > table {\n  border-top: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-placeholder {\n  border: 0;\n}\n.ant-table-bordered .ant-table-thead > tr > th {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-bordered .ant-table-thead > tr > th,\n.ant-table-bordered .ant-table-tbody > tr > td {\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small {\n  border-right: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-header > table,\n.ant-table-bordered.ant-table-small .ant-table-body > table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-left table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-right table {\n  border: 0;\n  padding: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-title {\n  border: 0;\n  border-bottom: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer {\n  border: 0;\n  border-top: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer:before {\n  display: none;\n}\n.ant-table-bordered.ant-table-small .ant-table-placeholder {\n  border-left: 0;\n  border-bottom: 0;\n}\n.ant-table-placeholder {\n  position: relative;\n  padding: 16px 8px;\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n  text-align: center;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-table-placeholder .anticon {\n  margin-right: 4px;\n}\n.ant-table-pagination {\n  margin: 16px 0;\n  float: right;\n}\n.ant-table-filter-dropdown {\n  min-width: 96px;\n  margin-left: -8px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu {\n  border: 0;\n  box-shadow: none;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-without-submenu {\n  max-height: 400px;\n  overflow-x: hidden;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item > label + span {\n  padding: 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-sub {\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu .ant-dropdown-submenu-contain-selected .ant-dropdown-menu-submenu-title:after {\n  color: #108ee9;\n  font-weight: bold;\n  text-shadow: 0 0 2px #d2eafb;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item {\n  overflow: hidden;\n}\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-item:last-child,\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-submenu:last-child .ant-dropdown-menu-submenu-title {\n  border-radius: 0;\n}\n.ant-table-filter-dropdown-btns {\n  overflow: hidden;\n  padding: 7px 8px;\n  border-top: 1px solid #e9e9e9;\n}\n.ant-table-filter-dropdown-link {\n  color: #108ee9;\n}\n.ant-table-filter-dropdown-link:hover {\n  color: #49a9ee;\n}\n.ant-table-filter-dropdown-link:active {\n  color: #0e77ca;\n}\n.ant-table-filter-dropdown-link.confirm {\n  float: left;\n}\n.ant-table-filter-dropdown-link.clear {\n  float: right;\n}\n.ant-table-selection-select-all-custom {\n  margin-right: 4px !important;\n}\n.ant-table-selection .anticon-down {\n  color: #aaa;\n  transition: all .3s;\n}\n.ant-table-selection-menu {\n  min-width: 96px;\n  margin-top: 5px;\n  margin-left: -30px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-selection-menu .ant-action-down {\n  color: #aaa;\n}\n.ant-table-selection-down {\n  cursor: pointer;\n  padding: 0;\n  display: inline-block;\n  line-height: 1;\n}\n.ant-table-selection-down:hover .anticon-down {\n  color: #666;\n}\n.ant-table-row-expand-icon {\n  cursor: pointer;\n  display: inline-block;\n  width: 17px;\n  height: 17px;\n  text-align: center;\n  line-height: 14px;\n  border: 1px solid #e9e9e9;\n  user-select: none;\n  background: #fff;\n}\n.ant-table-row-expanded:after {\n  content: '-';\n}\n.ant-table-row-collapsed:after {\n  content: '+';\n}\n.ant-table-row-spaced {\n  visibility: hidden;\n}\n.ant-table-row-spaced:after {\n  content: '.';\n}\n.ant-table-row[class*=\"ant-table-row-level-0\"] .ant-table-selection-column > span {\n  display: inline-block;\n}\ntr.ant-table-expanded-row,\ntr.ant-table-expanded-row:hover {\n  background: #fbfbfb;\n}\n.ant-table .ant-table-row-indent + .ant-table-row-expand-icon {\n  margin-right: 8px;\n}\n.ant-table-scroll {\n  overflow: auto;\n  overflow-x: hidden;\n}\n.ant-table-scroll table {\n  width: auto;\n  min-width: 100%;\n}\n.ant-table-body-inner {\n  height: 100%;\n}\n.ant-table-fixed-header > .ant-table-content > .ant-table-scroll > .ant-table-body {\n  position: relative;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-body-inner {\n  overflow: scroll;\n}\n.ant-table-fixed-header .ant-table-scroll .ant-table-header {\n  overflow: scroll;\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-header.ant-table-empty .ant-table-scroll .ant-table-body {\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-right {\n  position: absolute;\n  top: 0;\n  overflow: hidden;\n  transition: box-shadow 0.3s ease;\n  border-radius: 0;\n}\n.ant-table-fixed-left table,\n.ant-table-fixed-right table {\n  width: auto;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-outer .ant-table-fixed,\n.ant-table-fixed-header .ant-table-fixed-right .ant-table-body-outer .ant-table-fixed {\n  border-radius: 0;\n}\n.ant-table-fixed-left {\n  left: 0;\n  box-shadow: 6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-left .ant-table-header {\n  overflow-y: hidden;\n}\n.ant-table-fixed-left .ant-table-body-inner {\n  margin-right: -20px;\n  padding-right: 20px;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-inner {\n  padding-right: 0;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-left table {\n  border-radius: 4px 0 0 0;\n}\n.ant-table-fixed-right {\n  right: 0;\n  box-shadow: -6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-right,\n.ant-table-fixed-right table {\n  border-radius: 0 4px 0 0;\n}\n.ant-table-fixed-right .ant-table-expanded-row {\n  color: transparent;\n  pointer-events: none;\n}\n.ant-table.ant-table-scroll-position-left .ant-table-fixed-left {\n  box-shadow: none;\n}\n.ant-table.ant-table-scroll-position-right .ant-table-fixed-right {\n  box-shadow: none;\n}\n"
                ]
            },] },
];
/** @nocollapse */
DataTableSortComponent.ctorParameters = function () { return [
    { type: DataThDirective, decorators: [{ type: core.Host }, { type: core.Optional },] },
    { type: core.Renderer2, },
]; };
DataTableSortComponent.propDecorators = {
    "sortValueChange": [{ type: core.Output },],
    "sortValue": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PaginationComponent = (function () {
    /**
     * @param {?} _elementRef
     */
    function PaginationComponent(_elementRef) {
        this._elementRef = _elementRef;
        this._currentPage = 1;
        this._pageSize = 10;
        this._pageSizeOptions = [10, 20, 30, 50];
        this._total = 0;
        this._isShowJumpPrev = false;
        this._isShowJumpNext = false;
        this._renderPages = [];
        this._simpleType = false;
        this._nzSize = '';
        /**
         * 切换页码时触发
         */
        this.onCurrentPageChange = new core.EventEmitter();
        /**
         * 切换每页数据条数时触发
         */
        this.onPageSizeChange = new core.EventEmitter();
        this._el = this._elementRef.nativeElement;
    }
    Object.defineProperty(PaginationComponent.prototype, "currentPage", {
        /**
         * 当前页码
         * @return {?}
         */
        get: function () {
            return this._currentPage;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            value -= 0;
            if ((typeof value !== 'number') || (value === this._currentPage)) {
                return;
            }
            if (value > this._pageCount || value < 1) {
                return;
            }
            this._currentPage = value;
            this._resetRenderPages();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "total", {
        /**
         * 数据总数
         * @return {?}
         */
        get: function () {
            return this._total;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if ((typeof value !== 'number') || (value === this._total)) {
                return;
            }
            this._total = value;
            this._resetRenderPages();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "pageSize", {
        /**
         * 每页数据条数
         * @return {?}
         */
        get: function () {
            return this._pageSize;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._pageSize = value || this.pageSizeOptions[0];
            this._resetRenderPages();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "pageSizeOptions", {
        /**
         * 每页数据条数配置可选项
         * @return {?}
         */
        get: function () {
            return this._pageSizeOptions;
        },
        /**
         * @param {?} list
         * @return {?}
         */
        set: function (list) {
            if (list.length > 0) {
                this._pageSizeOptions = list;
                this._resetRenderPages();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "showSizeChanger", {
        /**
         * 是否可以更改每页数据条数
         * @return {?}
         */
        get: function () {
            return this._showSizeChanger;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value === '') {
                this._showSizeChanger = true;
            }
            else {
                this._showSizeChanger = (value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "showQuickJumper", {
        /**
         * @return {?}
         */
        get: function () {
            return this._showQuickJumper;
        },
        /**
         * 是否显示快速跳页
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value === '') {
                this._showQuickJumper = true;
            }
            else {
                this._showQuickJumper = (value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "showTotal", {
        /**
         * @return {?}
         */
        get: function () {
            return this._showTotal;
        },
        /**
         * 是否显示数据总数
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value === '') {
                this._showTotal = true;
            }
            else {
                this._showTotal = (value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "simpleType", {
        /**
         * @return {?}
         */
        get: function () {
            return this._simpleType;
        },
        /**
         * 简单模式开关
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value === '') {
                this._simpleType = true;
            }
            else {
                this._simpleType = (value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PaginationComponent.prototype, "nzSize", {
        /**
         * @return {?}
         */
        get: function () {
            return this._nzSize;
        },
        /**
         * 迷你模式开关
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._nzSize = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    PaginationComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this._pageSizeOptions.findIndex(function (value) { return value === _this.pageSize; }) < 0) {
            this._pageSizeOptions.push(this.pageSize);
        }
        this._pageSizeOptions.sort(function (a, b) { return a - b; });
        this._resetRenderPages();
    };
    /**
     * 计算要渲染的中间页码
     * @return {?}
     */
    PaginationComponent.prototype._resetRenderPages = function () {
        this._pageCount = Math.ceil(this._total / this._pageSize);
        this._isShowJumpPrev = this._pageCount > 5 && (this._currentPage - 2) > 1;
        this._isShowJumpNext = this._pageCount > 5 && (this._currentPage + 2) < (this._pageCount - 1);
        var /** @type {?} */ pages = [];
        if (this._pageCount > 2) {
            // 两页以上才显示中间页码
            var /** @type {?} */ index = 1;
            if (this._currentPage - 2 >= 1) {
                index = this._currentPage - 2;
            }
            if (this._pageCount - this._currentPage <= 2) {
                index = this._pageCount - 4;
            }
            if (index < 1) {
                index = 1;
            }
            do {
                pages.push(index);
                index++;
            } while (index < this._pageCount && pages.length < 5);
            if (pages[0] === 1) {
                pages.shift();
            }
            if (pages[pages.length - 1] === this._pageCount) {
                pages.pop();
            }
            this._renderPages = pages;
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    PaginationComponent.prototype._jump2Page = function (value) {
        if (value > this._pageCount) {
            this.currentPage = this._pageCount;
        }
        else if (value < 1) {
            this.currentPage = 1;
        }
        else {
            this.currentPage = value;
        }
        this.onCurrentPageChange.emit(this.currentPage);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    PaginationComponent.prototype._pageSizeChange = function ($event) {
        this.pageSize = $event;
        this.onPageSizeChange.emit($event);
    };
    Object.defineProperty(PaginationComponent.prototype, "_pageSizeHalf", {
        /**
         * @return {?}
         */
        get: function () {
            return Math.round(this._pageSize / 2);
        },
        enumerable: true,
        configurable: true
    });
    return PaginationComponent;
}());
PaginationComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-pagination',
                template: "<ul class=\"ant-pagination\"  [class.mini]=\"nzSize==='small'\" *ngIf=\"!simpleType\">\n  <li class=\"ant-pagination-prev\" [class.ant-pagination-disabled]=\"_currentPage===1\" title=\"\u4E0A\u4E00\u9875\"\n  (click)=\"_jump2Page(_currentPage-1)\">\n    <a></a>\n  </li>\n  <li class=\"ant-pagination-item\" title=\"\u7B2C\u4E00\u9875\"\n      [class.ant-pagination-item-active]=\"_currentPage===1\" \n      (click)=\"_jump2Page(1)\">\n    <a>1</a>\n  </li>\n  <li *ngIf=\"_isShowJumpPrev\" class=\"ant-pagination-jump-prev\" title=\"\u5411\u524D {{_pageSizeHalf}} \u9875\"\n    (click)=\"_jump2Page(_currentPage - _pageSizeHalf)\">\n    <a></a>\n  </li>\n  <li *ngFor=\"let page of _renderPages\" class=\"ant-pagination-item\" title=\"{{page}}\"\n      [class.ant-pagination-item-active]=\"_currentPage===page\" \n      (click)=\"_jump2Page(page)\">\n    <a>{{page}}</a>\n  </li>\n  <li *ngIf=\"_isShowJumpNext\" class=\"ant-pagination-jump-next\" title=\"\u5411\u540E {{_pageSizeHalf}} \u9875\" \n      (click)=\"_jump2Page(_currentPage+_pageSizeHalf)\">\n    <a></a>\n  </li>\n  <li *ngIf=\"_pageCount>=2\" class=\"ant-pagination-item\" title=\"\u6700\u540E\u4E00\u9875: {{_pageCount}}\"\n      [class.ant-pagination-item-active]=\"_currentPage===_pageCount\"\n      (click)=\"_jump2Page(_pageCount)\">\n    <a>{{_pageCount}}</a>\n  </li>\n  <li class=\"ant-pagination-next\" title=\"\u4E0B\u4E00\u9875\"\n      [class.ant-pagination-disabled]=\"_currentPage===_pageCount\"\n      (click)=\"_jump2Page(_currentPage+1)\">\n    <a></a>\n  </li>\n  <div class=\"ant-pagination-options\">\n    <nz-select\n      *ngIf=\"showSizeChanger\"\n      class=\"ant-pagination-options-size-changer\"\n      [nzSize]=\"nzSize =='small'?'small':''\"\n      [ngModel]=\"_pageSize\"\n      (ngModelChange)=\"_pageSizeChange($event)\">\n      <nz-option\n        *ngFor=\"let option of _pageSizeOptions\"\n        [nzLabel]=\"option+ '\u6761/\u9875'\"\n        [nzValue]=\"option\">\n      </nz-option>\n    </nz-select>\n  </div>\n  <span class=\"ant-pagination-total-text\" *ngIf=\"showTotal\">\u5171 {{_total}} \u6761</span>\n  <div class=\"ant-pagination-options-quick-jumper\" *ngIf=\"showQuickJumper\">\n    \u8DF3\u81F3<input [(ngModel)]=\"currentPage\">\u9875\n  </div>\n</ul>\n\n<ul class=\"ant-pagination ant-pagination-simple\" *ngIf=\"simpleType\">\n  <li\n    title=\"\u4E0A\u4E00\u9875\"\n    class=\"ant-pagination-prev\"\n    (click)=\"_jump2Page(_currentPage-1)\"\n    [class.ant-pagination-disabled]=\"_currentPage===1\">\n    <a></a>\n  </li>\n  <li [attr.title]=\"_currentPage +'/'+ _pageCount\" class=\"ant-pagination-simple-pager\">\n    <input [(ngModel)]=\"currentPage\" size=\"3\"><span class=\"ant-pagination-slash\">\uFF0F</span>{{_pageCount}}\n  </li>\n  <li\n    title=\"\u4E0B\u4E00\u9875\"\n    class=\"ant-pagination-next\"\n    (click)=\"_jump2Page(_currentPage+1)\"\n    [class.ant-pagination-disabled]=\"_currentPage===_pageCount\">\n    <a></a>\n  </li>\n</ul> ",
                styles: [".ant-pagination {\n  font-size: 12px;\n}\n.ant-pagination:after {\n  content: \" \";\n  display: block;\n  height: 0;\n  clear: both;\n  overflow: hidden;\n  visibility: hidden;\n}\n.ant-pagination-total-text {\n  display: inline-block;\n  vertical-align: middle;\n  height: 28px;\n  line-height: 28px;\n  margin-right: 8px;\n}\n.ant-pagination-item {\n  cursor: pointer;\n  border-radius: 4px;\n  user-select: none;\n  min-width: 28px;\n  height: 28px;\n  line-height: 28px;\n  text-align: center;\n  list-style: none;\n  display: inline-block;\n  vertical-align: middle;\n  border: 1px solid #d9d9d9;\n  background-color: #fff;\n  margin-right: 8px;\n  font-family: Arial;\n  outline: 0;\n}\n.ant-pagination-item a {\n  text-decoration: none;\n  color: rgba(0, 0, 0, 0.65);\n  transition: none;\n  margin: 0 6px;\n}\n.ant-pagination-item:focus,\n.ant-pagination-item:hover {\n  transition: all .3s;\n  border-color: #108ee9;\n}\n.ant-pagination-item:focus a,\n.ant-pagination-item:hover a {\n  color: #108ee9;\n}\n.ant-pagination-item-active {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-pagination-item-active:focus,\n.ant-pagination-item-active:hover {\n  background-color: #49a9ee;\n  border-color: #49a9ee;\n}\n.ant-pagination-item-active a,\n.ant-pagination-item-active:focus a,\n.ant-pagination-item-active:hover a {\n  color: #fff;\n}\n.ant-pagination-jump-prev,\n.ant-pagination-jump-next {\n  outline: 0;\n}\n.ant-pagination-jump-prev:after,\n.ant-pagination-jump-next:after {\n  content: \"\u2022\u2022\u2022\";\n  display: block;\n  letter-spacing: 2px;\n  color: rgba(0, 0, 0, 0.25);\n  text-align: center;\n}\n.ant-pagination-jump-prev:focus:after,\n.ant-pagination-jump-next:focus:after,\n.ant-pagination-jump-prev:hover:after,\n.ant-pagination-jump-next:hover:after {\n  color: #108ee9;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  letter-spacing: -1px;\n  font-family: \"anticon\";\n}\n:root .ant-pagination-jump-prev:focus:after,\n:root .ant-pagination-jump-next:focus:after,\n:root .ant-pagination-jump-prev:hover:after,\n:root .ant-pagination-jump-next:hover:after {\n  filter: none;\n}\n:root .ant-pagination-jump-prev:focus:after,\n:root .ant-pagination-jump-next:focus:after,\n:root .ant-pagination-jump-prev:hover:after,\n:root .ant-pagination-jump-next:hover:after {\n  font-size: 12px;\n}\n.ant-pagination-jump-prev:focus:after,\n.ant-pagination-jump-prev:hover:after {\n  content: \"\\e620\\e620\";\n}\n.ant-pagination-jump-next:focus:after,\n.ant-pagination-jump-next:hover:after {\n  content: \"\\e61f\\e61f\";\n}\n.ant-pagination-prev,\n.ant-pagination-jump-prev,\n.ant-pagination-jump-next {\n  margin-right: 8px;\n}\n.ant-pagination-prev,\n.ant-pagination-next,\n.ant-pagination-jump-prev,\n.ant-pagination-jump-next {\n  font-family: Arial;\n  cursor: pointer;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 4px;\n  list-style: none;\n  min-width: 28px;\n  height: 28px;\n  line-height: 28px;\n  text-align: center;\n  transition: all .3s;\n  display: inline-block;\n  vertical-align: middle;\n}\n.ant-pagination-prev,\n.ant-pagination-next {\n  border: 1px solid #d9d9d9;\n  background-color: #fff;\n  outline: 0;\n}\n.ant-pagination-prev a,\n.ant-pagination-next a {\n  color: rgba(0, 0, 0, 0.65);\n  outline: none;\n}\n.ant-pagination-prev a:after,\n.ant-pagination-next a:after {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: block;\n  height: 26px;\n  line-height: 26px;\n  font-family: \"anticon\";\n  text-align: center;\n}\n:root .ant-pagination-prev a:after,\n:root .ant-pagination-next a:after {\n  filter: none;\n}\n:root .ant-pagination-prev a:after,\n:root .ant-pagination-next a:after {\n  font-size: 12px;\n}\n.ant-pagination-prev:focus,\n.ant-pagination-next:focus,\n.ant-pagination-prev:hover,\n.ant-pagination-next:hover {\n  border-color: #108ee9;\n}\n.ant-pagination-prev:focus a,\n.ant-pagination-next:focus a,\n.ant-pagination-prev:hover a,\n.ant-pagination-next:hover a {\n  color: #108ee9;\n}\n.ant-pagination-prev a:after {\n  content: \"\\e620\";\n  display: block;\n}\n.ant-pagination-next a:after {\n  content: \"\\e61f\";\n  display: block;\n}\n.ant-pagination-disabled {\n  cursor: not-allowed;\n}\n.ant-pagination-disabled:hover {\n  border-color: #d9d9d9;\n}\n.ant-pagination-disabled:hover a {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-pagination-disabled a {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-pagination-slash {\n  margin: 0 10px 0 5px;\n}\n.ant-pagination-options {\n  display: inline-block;\n  vertical-align: middle;\n  margin-left: 16px;\n}\n.ant-pagination-options-size-changer {\n  display: inline-block;\n  margin-right: 8px;\n}\n.ant-pagination-options-quick-jumper {\n  display: inline-block;\n  height: 28px;\n  line-height: 28px;\n  vertical-align: middle;\n}\n.ant-pagination-options-quick-jumper input {\n  position: relative;\n  display: inline-block;\n  padding: 4px 7px;\n  width: 100%;\n  height: 28px;\n  cursor: text;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n  transition: all .3s;\n  margin: 0 8px;\n  width: 50px;\n}\n.ant-pagination-options-quick-jumper input::-moz-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n  opacity: 1;\n}\n.ant-pagination-options-quick-jumper input:-ms-input-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-pagination-options-quick-jumper input::-webkit-input-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-pagination-options-quick-jumper input:hover {\n  border-color: #49a9ee;\n}\n.ant-pagination-options-quick-jumper input:focus {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-pagination-options-quick-jumper input-disabled {\n  background-color: #f7f7f7;\n  opacity: 1;\n  cursor: not-allowed;\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-pagination-options-quick-jumper input-disabled:hover {\n  border-color: #e2e2e2;\n}\ntextarea.ant-pagination-options-quick-jumper input {\n  max-width: 100%;\n  height: auto;\n  vertical-align: bottom;\n}\n.ant-pagination-options-quick-jumper input-lg {\n  padding: 6px 7px;\n  height: 32px;\n}\n.ant-pagination-options-quick-jumper input-sm {\n  padding: 1px 7px;\n  height: 22px;\n}\n.ant-pagination-simple .ant-pagination-prev,\n.ant-pagination-simple .ant-pagination-next {\n  border: 0;\n  height: 24px;\n  line-height: 24px;\n  margin: 0;\n  font-size: 18px;\n}\n.ant-pagination-simple .ant-pagination-simple-pager {\n  display: inline-block;\n  vertical-align: middle;\n  margin-right: 8px;\n}\n.ant-pagination-simple .ant-pagination-simple-pager input {\n  margin: 0 8px;\n  box-sizing: border-box;\n  background-color: #fff;\n  border-radius: 4px;\n  border: 1px solid #d9d9d9;\n  outline: none;\n  padding: 5px 8px;\n  height: 24px;\n  text-align: center;\n  transition: border-color 0.3s;\n}\n.ant-pagination-simple .ant-pagination-simple-pager input:hover {\n  border-color: #108ee9;\n}\n.ant-pagination.mini .ant-pagination-total-text {\n  height: 20px;\n  line-height: 20px;\n}\n.ant-pagination.mini .ant-pagination-item {\n  border: 0;\n  margin: 0;\n  min-width: 20px;\n  height: 20px;\n  line-height: 20px;\n}\n.ant-pagination.mini .ant-pagination-prev,\n.ant-pagination.mini .ant-pagination-next {\n  margin: 0;\n  min-width: 20px;\n  height: 20px;\n  line-height: 20px;\n  border: 0;\n}\n.ant-pagination.mini .ant-pagination-prev a:after,\n.ant-pagination.mini .ant-pagination-next a:after {\n  height: 20px;\n  line-height: 20px;\n}\n.ant-pagination.mini .ant-pagination-jump-prev,\n.ant-pagination.mini .ant-pagination-jump-next {\n  height: 20px;\n  line-height: 20px;\n}\n.ant-pagination.mini .ant-pagination-options {\n  margin-left: 8px;\n}\n.ant-pagination.mini .ant-pagination-options-quick-jumper {\n  height: 20px;\n  line-height: 20px;\n  vertical-align: middle;\n}\n.ant-pagination.mini .ant-pagination-options-quick-jumper input {\n  padding: 1px 7px;\n  height: 22px;\n  width: 44px;\n}\n@media only screen and (max-width: 1024px) {\n  .ant-pagination-item-after-jump-prev,\n  .ant-pagination-item-before-jump-next {\n    display: none;\n  }\n}\n"]
                // encapsulation: ViewEncapsulation.None,
                // changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
PaginationComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
PaginationComponent.propDecorators = {
    "currentPage": [{ type: core.Input },],
    "total": [{ type: core.Input },],
    "pageSize": [{ type: core.Input },],
    "pageSizeOptions": [{ type: core.Input },],
    "showSizeChanger": [{ type: core.Input },],
    "showQuickJumper": [{ type: core.Input },],
    "showTotal": [{ type: core.Input },],
    "simpleType": [{ type: core.Input },],
    "nzSize": [{ type: core.Input },],
    "onCurrentPageChange": [{ type: core.Output },],
    "onPageSizeChange": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS = [PaginationComponent];
var PaginationModule = (function () {
    function PaginationModule() {
    }
    return PaginationModule;
}());
PaginationModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    ngZorroAntd.NzSelectModule
                ],
                exports: COMPONENTS.slice(),
                declarations: COMPONENTS.slice(),
                entryComponents: COMPONENTS.slice()
            },] },
];
/** @nocollapse */
PaginationModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TableModule = (function () {
    function TableModule() {
    }
    return TableModule;
}());
TableModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    PaginationModule,
                    ngZorroAntd.NzSpinModule
                ],
                declarations: [
                    DataTableComponent,
                    DataThDirective,
                    DataTdDirective,
                    DataTheadDirective,
                    DataTbodyDirective,
                    DataTbodyTrDirective,
                    DataDividerDirective,
                    DraggbleDirective,
                    DataTableSortComponent,
                    RowExpandIconComponent,
                    RowIndentComponent
                ],
                exports: [
                    DataTableComponent,
                    DataTableSortComponent,
                    DataThDirective,
                    DataTdDirective,
                    DataTheadDirective,
                    DataTbodyDirective,
                    DataTbodyTrDirective,
                    DataDividerDirective,
                    DraggbleDirective,
                    DataTableSortComponent,
                    RowExpandIconComponent,
                    RowIndentComponent
                ]
            },] },
];
/** @nocollapse */
TableModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ButtonComponent = (function () {
    /**
     * @param {?} _element
     */
    function ButtonComponent(_element) {
        this._element = _element;
        this._size = '';
        this._disabled = false;
        // 种类：primary | dashed | danger | default
        this.type = 'primary';
        // 按钮尺寸: large | default | small
        this.size = '';
        this.shape = '';
        this._element = _element;
    }
    Object.defineProperty(ButtonComponent.prototype, "loading", {
        /**
         * value 可能的值 boolean / { delay: number }
         * \@memberof ButtonComponent
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            var _this = this;
            if (!value) {
                return;
            }
            if (value && (typeof value === 'string' || value === true)) {
                this._loading = 'true';
                return;
            }
            if (value && typeof value === 'object') {
                setTimeout(function () {
                    _this._loading = 'true';
                }, value.delay);
            }
        },
        enumerable: true,
        configurable: true
    });
    
    Object.defineProperty(ButtonComponent.prototype, "disabled", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value && value === 'true') {
                this._disabled = true;
            }
            else {
                this._disabled = false;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ButtonComponent.prototype, "icon", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (!value) {
                this._icon = false;
                return;
            }
            this._icon = 'anticon-' + value;
        },
        enumerable: true,
        configurable: true
    });
    
    /**
     * @return {?}
     */
    ButtonComponent.prototype.changeClicking = function () {
        var _this = this;
        if (this._loading === 'true') {
            return;
        }
        this.clicking = 'true';
        setTimeout(function () {
            _this.clicking = 'false';
        }, 400);
    };
    /**
     * @return {?}
     */
    ButtonComponent.prototype.ngOnInit = function () {
        var _this = this;
        Observable.Observable.fromEvent(this._element.nativeElement, 'click').debounceTime(200).subscribe(function (data) {
            _this.changeClicking();
        });
    };
    /**
     * @return {?}
     */
    ButtonComponent.prototype.ngOnDestroy = function () {
    };
    return ButtonComponent;
}());
ButtonComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-button',
                template: "<button [disabled]=\"_disabled\" type=\"button\" [class]=\"'ant-btn ant-btn-' + type\" [ngClass]=\"{'ant-btn-sm': size === 'small' , 'ant-btn-lg': size === 'large',\n            'ant-btn-loading': _loading === 'true',\n            'ant-btn-clicked':clicking === 'true',\n            'ant-btn-circle':shape === 'circle',\n            'ant-btn-background-ghost':ghost === 'true'\n\n}\" class=\"ant-btn\"><i *ngIf=\"_icon && !_loading\" [class]=\"'anticon '+ _icon\"></i><i *ngIf=\"_icon && _loading\" class=\"anticon anticon-spin anticon-loading\"></i><ng-content></ng-content>\n</button>",
                styles: [".ant-btn {\n  display: inline-block;\n  margin-bottom: 0;\n  font-weight: 500;\n  text-align: center;\n  touch-action: manipulation;\n  cursor: pointer;\n  background-image: none;\n  border: 1px solid transparent;\n  white-space: nowrap;\n  line-height: 1.5;\n  padding: 0 15px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 28px;\n  user-select: none;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  position: relative;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n  border-color: #d9d9d9;\n}\n.ant-btn > .anticon {\n  line-height: 1;\n}\n.ant-btn,\n.ant-btn:active,\n.ant-btn:focus {\n  outline: 0;\n}\n.ant-btn:not([disabled]):hover {\n  text-decoration: none;\n}\n.ant-btn:not([disabled]):active {\n  outline: 0;\n  transition: none;\n}\n.ant-btn.disabled,\n.ant-btn[disabled] {\n  cursor: not-allowed;\n}\n.ant-btn.disabled > *,\n.ant-btn[disabled] > * {\n  pointer-events: none;\n}\n.ant-btn-lg {\n  padding: 0 15px;\n  font-size: 14px;\n  border-radius: 4px;\n  height: 32px;\n}\n.ant-btn-sm {\n  padding: 0 7px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 22px;\n}\n.ant-btn > a:only-child {\n  color: currentColor;\n}\n.ant-btn > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn:hover,\n.ant-btn:focus {\n  color: #108ee9;\n  background-color: #fff;\n  border-color: #108ee9;\n}\n.ant-btn:hover > a:only-child,\n.ant-btn:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn:hover > a:only-child:after,\n.ant-btn:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn:active,\n.ant-btn.active {\n  color: #0e77ca;\n  background-color: #fff;\n  border-color: #0e77ca;\n}\n.ant-btn:active > a:only-child,\n.ant-btn.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn:active > a:only-child:after,\n.ant-btn.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn.disabled,\n.ant-btn[disabled],\n.ant-btn.disabled:hover,\n.ant-btn[disabled]:hover,\n.ant-btn.disabled:focus,\n.ant-btn[disabled]:focus,\n.ant-btn.disabled:active,\n.ant-btn[disabled]:active,\n.ant-btn.disabled.active,\n.ant-btn[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn.disabled > a:only-child,\n.ant-btn[disabled] > a:only-child,\n.ant-btn.disabled:hover > a:only-child,\n.ant-btn[disabled]:hover > a:only-child,\n.ant-btn.disabled:focus > a:only-child,\n.ant-btn[disabled]:focus > a:only-child,\n.ant-btn.disabled:active > a:only-child,\n.ant-btn[disabled]:active > a:only-child,\n.ant-btn.disabled.active > a:only-child,\n.ant-btn[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn.disabled > a:only-child:after,\n.ant-btn[disabled] > a:only-child:after,\n.ant-btn.disabled:hover > a:only-child:after,\n.ant-btn[disabled]:hover > a:only-child:after,\n.ant-btn.disabled:focus > a:only-child:after,\n.ant-btn[disabled]:focus > a:only-child:after,\n.ant-btn.disabled:active > a:only-child:after,\n.ant-btn[disabled]:active > a:only-child:after,\n.ant-btn.disabled.active > a:only-child:after,\n.ant-btn[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn:hover,\n.ant-btn:focus,\n.ant-btn:active,\n.ant-btn.active {\n  background: #fff;\n}\n.ant-btn-primary {\n  color: #fff;\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-btn-primary > a:only-child {\n  color: currentColor;\n}\n.ant-btn-primary > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-primary:hover,\n.ant-btn-primary:focus {\n  color: #fff;\n  background-color: #49a9ee;\n  border-color: #49a9ee;\n}\n.ant-btn-primary:hover > a:only-child,\n.ant-btn-primary:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-primary:hover > a:only-child:after,\n.ant-btn-primary:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-primary:active,\n.ant-btn-primary.active {\n  color: #fff;\n  background-color: #0e77ca;\n  border-color: #0e77ca;\n}\n.ant-btn-primary:active > a:only-child,\n.ant-btn-primary.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-primary:active > a:only-child:after,\n.ant-btn-primary.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-primary.disabled,\n.ant-btn-primary[disabled],\n.ant-btn-primary.disabled:hover,\n.ant-btn-primary[disabled]:hover,\n.ant-btn-primary.disabled:focus,\n.ant-btn-primary[disabled]:focus,\n.ant-btn-primary.disabled:active,\n.ant-btn-primary[disabled]:active,\n.ant-btn-primary.disabled.active,\n.ant-btn-primary[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-primary.disabled > a:only-child,\n.ant-btn-primary[disabled] > a:only-child,\n.ant-btn-primary.disabled:hover > a:only-child,\n.ant-btn-primary[disabled]:hover > a:only-child,\n.ant-btn-primary.disabled:focus > a:only-child,\n.ant-btn-primary[disabled]:focus > a:only-child,\n.ant-btn-primary.disabled:active > a:only-child,\n.ant-btn-primary[disabled]:active > a:only-child,\n.ant-btn-primary.disabled.active > a:only-child,\n.ant-btn-primary[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-primary.disabled > a:only-child:after,\n.ant-btn-primary[disabled] > a:only-child:after,\n.ant-btn-primary.disabled:hover > a:only-child:after,\n.ant-btn-primary[disabled]:hover > a:only-child:after,\n.ant-btn-primary.disabled:focus > a:only-child:after,\n.ant-btn-primary[disabled]:focus > a:only-child:after,\n.ant-btn-primary.disabled:active > a:only-child:after,\n.ant-btn-primary[disabled]:active > a:only-child:after,\n.ant-btn-primary.disabled.active > a:only-child:after,\n.ant-btn-primary[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-group .ant-btn-primary:not(:first-child):not(:last-child) {\n  border-right-color: #0e77ca;\n  border-left-color: #0e77ca;\n}\n.ant-btn-group .ant-btn-primary:not(:first-child):not(:last-child):disabled {\n  border-color: #d9d9d9;\n}\n.ant-btn-group .ant-btn-primary:first-child:not(:last-child) {\n  border-right-color: #0e77ca;\n}\n.ant-btn-group .ant-btn-primary:first-child:not(:last-child)[disabled] {\n  border-right-color: #d9d9d9;\n}\n.ant-btn-group .ant-btn-primary:last-child:not(:first-child),\n.ant-btn-group .ant-btn-primary + .ant-btn-primary {\n  border-left-color: #0e77ca;\n}\n.ant-btn-group .ant-btn-primary:last-child:not(:first-child)[disabled],\n.ant-btn-group .ant-btn-primary + .ant-btn-primary[disabled] {\n  border-left-color: #d9d9d9;\n}\n.ant-btn-ghost {\n  color: rgba(0, 0, 0, 0.65);\n  background-color: transparent;\n  border-color: #d9d9d9;\n}\n.ant-btn-ghost > a:only-child {\n  color: currentColor;\n}\n.ant-btn-ghost > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-ghost:hover,\n.ant-btn-ghost:focus {\n  color: #108ee9;\n  background-color: transparent;\n  border-color: #108ee9;\n}\n.ant-btn-ghost:hover > a:only-child,\n.ant-btn-ghost:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-ghost:hover > a:only-child:after,\n.ant-btn-ghost:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-ghost:active,\n.ant-btn-ghost.active {\n  color: #0e77ca;\n  background-color: transparent;\n  border-color: #0e77ca;\n}\n.ant-btn-ghost:active > a:only-child,\n.ant-btn-ghost.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-ghost:active > a:only-child:after,\n.ant-btn-ghost.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-ghost.disabled,\n.ant-btn-ghost[disabled],\n.ant-btn-ghost.disabled:hover,\n.ant-btn-ghost[disabled]:hover,\n.ant-btn-ghost.disabled:focus,\n.ant-btn-ghost[disabled]:focus,\n.ant-btn-ghost.disabled:active,\n.ant-btn-ghost[disabled]:active,\n.ant-btn-ghost.disabled.active,\n.ant-btn-ghost[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-ghost.disabled > a:only-child,\n.ant-btn-ghost[disabled] > a:only-child,\n.ant-btn-ghost.disabled:hover > a:only-child,\n.ant-btn-ghost[disabled]:hover > a:only-child,\n.ant-btn-ghost.disabled:focus > a:only-child,\n.ant-btn-ghost[disabled]:focus > a:only-child,\n.ant-btn-ghost.disabled:active > a:only-child,\n.ant-btn-ghost[disabled]:active > a:only-child,\n.ant-btn-ghost.disabled.active > a:only-child,\n.ant-btn-ghost[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-ghost.disabled > a:only-child:after,\n.ant-btn-ghost[disabled] > a:only-child:after,\n.ant-btn-ghost.disabled:hover > a:only-child:after,\n.ant-btn-ghost[disabled]:hover > a:only-child:after,\n.ant-btn-ghost.disabled:focus > a:only-child:after,\n.ant-btn-ghost[disabled]:focus > a:only-child:after,\n.ant-btn-ghost.disabled:active > a:only-child:after,\n.ant-btn-ghost[disabled]:active > a:only-child:after,\n.ant-btn-ghost.disabled.active > a:only-child:after,\n.ant-btn-ghost[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-dashed {\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n  border-color: #d9d9d9;\n  border-style: dashed;\n}\n.ant-btn-dashed > a:only-child {\n  color: currentColor;\n}\n.ant-btn-dashed > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-dashed:hover,\n.ant-btn-dashed:focus {\n  color: #108ee9;\n  background-color: #fff;\n  border-color: #108ee9;\n}\n.ant-btn-dashed:hover > a:only-child,\n.ant-btn-dashed:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-dashed:hover > a:only-child:after,\n.ant-btn-dashed:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-dashed:active,\n.ant-btn-dashed.active {\n  color: #0e77ca;\n  background-color: #fff;\n  border-color: #0e77ca;\n}\n.ant-btn-dashed:active > a:only-child,\n.ant-btn-dashed.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-dashed:active > a:only-child:after,\n.ant-btn-dashed.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-dashed.disabled,\n.ant-btn-dashed[disabled],\n.ant-btn-dashed.disabled:hover,\n.ant-btn-dashed[disabled]:hover,\n.ant-btn-dashed.disabled:focus,\n.ant-btn-dashed[disabled]:focus,\n.ant-btn-dashed.disabled:active,\n.ant-btn-dashed[disabled]:active,\n.ant-btn-dashed.disabled.active,\n.ant-btn-dashed[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-dashed.disabled > a:only-child,\n.ant-btn-dashed[disabled] > a:only-child,\n.ant-btn-dashed.disabled:hover > a:only-child,\n.ant-btn-dashed[disabled]:hover > a:only-child,\n.ant-btn-dashed.disabled:focus > a:only-child,\n.ant-btn-dashed[disabled]:focus > a:only-child,\n.ant-btn-dashed.disabled:active > a:only-child,\n.ant-btn-dashed[disabled]:active > a:only-child,\n.ant-btn-dashed.disabled.active > a:only-child,\n.ant-btn-dashed[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-dashed.disabled > a:only-child:after,\n.ant-btn-dashed[disabled] > a:only-child:after,\n.ant-btn-dashed.disabled:hover > a:only-child:after,\n.ant-btn-dashed[disabled]:hover > a:only-child:after,\n.ant-btn-dashed.disabled:focus > a:only-child:after,\n.ant-btn-dashed[disabled]:focus > a:only-child:after,\n.ant-btn-dashed.disabled:active > a:only-child:after,\n.ant-btn-dashed[disabled]:active > a:only-child:after,\n.ant-btn-dashed.disabled.active > a:only-child:after,\n.ant-btn-dashed[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-danger {\n  color: #f04134;\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-danger > a:only-child {\n  color: currentColor;\n}\n.ant-btn-danger > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-danger:hover,\n.ant-btn-danger:focus {\n  color: #fff;\n  background-color: #f04134;\n  border-color: #f04134;\n}\n.ant-btn-danger:hover > a:only-child,\n.ant-btn-danger:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-danger:hover > a:only-child:after,\n.ant-btn-danger:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-danger:active,\n.ant-btn-danger.active {\n  color: #fff;\n  background-color: #d73435;\n  border-color: #d73435;\n}\n.ant-btn-danger:active > a:only-child,\n.ant-btn-danger.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-danger:active > a:only-child:after,\n.ant-btn-danger.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-danger.disabled,\n.ant-btn-danger[disabled],\n.ant-btn-danger.disabled:hover,\n.ant-btn-danger[disabled]:hover,\n.ant-btn-danger.disabled:focus,\n.ant-btn-danger[disabled]:focus,\n.ant-btn-danger.disabled:active,\n.ant-btn-danger[disabled]:active,\n.ant-btn-danger.disabled.active,\n.ant-btn-danger[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-danger.disabled > a:only-child,\n.ant-btn-danger[disabled] > a:only-child,\n.ant-btn-danger.disabled:hover > a:only-child,\n.ant-btn-danger[disabled]:hover > a:only-child,\n.ant-btn-danger.disabled:focus > a:only-child,\n.ant-btn-danger[disabled]:focus > a:only-child,\n.ant-btn-danger.disabled:active > a:only-child,\n.ant-btn-danger[disabled]:active > a:only-child,\n.ant-btn-danger.disabled.active > a:only-child,\n.ant-btn-danger[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-danger.disabled > a:only-child:after,\n.ant-btn-danger[disabled] > a:only-child:after,\n.ant-btn-danger.disabled:hover > a:only-child:after,\n.ant-btn-danger[disabled]:hover > a:only-child:after,\n.ant-btn-danger.disabled:focus > a:only-child:after,\n.ant-btn-danger[disabled]:focus > a:only-child:after,\n.ant-btn-danger.disabled:active > a:only-child:after,\n.ant-btn-danger[disabled]:active > a:only-child:after,\n.ant-btn-danger.disabled.active > a:only-child:after,\n.ant-btn-danger[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-circle,\n.ant-btn-circle-outline {\n  width: 28px;\n  padding: 0;\n  font-size: 14px;\n  border-radius: 50%;\n  height: 28px;\n}\n.ant-btn-circle.ant-btn-lg,\n.ant-btn-circle-outline.ant-btn-lg {\n  width: 32px;\n  padding: 0;\n  font-size: 16px;\n  border-radius: 50%;\n  height: 32px;\n}\n.ant-btn-circle.ant-btn-sm,\n.ant-btn-circle-outline.ant-btn-sm {\n  width: 22px;\n  padding: 0;\n  font-size: 12px;\n  border-radius: 50%;\n  height: 22px;\n}\n.ant-btn:before {\n  position: absolute;\n  top: -1px;\n  left: -1px;\n  bottom: -1px;\n  right: -1px;\n  background: #fff;\n  opacity: 0.35;\n  content: '';\n  border-radius: inherit;\n  z-index: 1;\n  transition: opacity .2s;\n  pointer-events: none;\n  display: none;\n}\n.ant-btn .anticon {\n  transition: margin-left 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-btn.ant-btn-loading:before {\n  display: block;\n}\n.ant-btn.ant-btn-loading:not(.ant-btn-circle):not(.ant-btn-circle-outline) {\n  padding-left: 29px;\n  pointer-events: none;\n  position: relative;\n}\n.ant-btn.ant-btn-loading:not(.ant-btn-circle):not(.ant-btn-circle-outline) .anticon {\n  margin-left: -14px;\n}\n.ant-btn-sm.ant-btn-loading:not(.ant-btn-circle):not(.ant-btn-circle-outline) {\n  padding-left: 24px;\n}\n.ant-btn-sm.ant-btn-loading:not(.ant-btn-circle):not(.ant-btn-circle-outline) .anticon {\n  margin-left: -17px;\n}\n.ant-btn:not(.ant-btn-circle):not(.ant-btn-circle-outline).ant-btn-icon-only {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-btn:focus > span,\n.ant-btn:active > span {\n  position: relative;\n}\n.ant-btn > .anticon + span,\n.ant-btn > span + .anticon {\n  margin-left: 0.5em;\n}\n.ant-btn-clicked:after {\n  content: '';\n  position: absolute;\n  top: -1px;\n  left: -1px;\n  bottom: -1px;\n  right: -1px;\n  border-radius: inherit;\n  border: 0 solid #108ee9;\n  opacity: 0.4;\n  animation: buttonEffect .4s;\n  display: block;\n}\n.ant-btn-danger.ant-btn-clicked:after {\n  border-color: #f04134;\n}\n.ant-btn-background-ghost {\n  background: transparent!important;\n  border-color: #fff;\n  color: #fff;\n}\n.ant-btn-background-ghost.ant-btn-primary {\n  color: #108ee9;\n  background-color: transparent;\n  border-color: #108ee9;\n}\n.ant-btn-background-ghost.ant-btn-primary > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-primary > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-primary:hover,\n.ant-btn-background-ghost.ant-btn-primary:focus {\n  color: #49a9ee;\n  background-color: transparent;\n  border-color: #49a9ee;\n}\n.ant-btn-background-ghost.ant-btn-primary:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-primary:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-primary:active,\n.ant-btn-background-ghost.ant-btn-primary.active {\n  color: #0e77ca;\n  background-color: transparent;\n  border-color: #0e77ca;\n}\n.ant-btn-background-ghost.ant-btn-primary:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-primary:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-primary.disabled,\n.ant-btn-background-ghost.ant-btn-primary[disabled],\n.ant-btn-background-ghost.ant-btn-primary.disabled:hover,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:hover,\n.ant-btn-background-ghost.ant-btn-primary.disabled:focus,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:focus,\n.ant-btn-background-ghost.ant-btn-primary.disabled:active,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:active,\n.ant-btn-background-ghost.ant-btn-primary.disabled.active,\n.ant-btn-background-ghost.ant-btn-primary[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-background-ghost.ant-btn-primary.disabled > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary[disabled] > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary.disabled:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary.disabled:focus > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:focus > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary.disabled:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary.disabled.active > a:only-child,\n.ant-btn-background-ghost.ant-btn-primary[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-primary.disabled > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary[disabled] > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary.disabled:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary.disabled:focus > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:focus > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary.disabled:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary[disabled]:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary.disabled.active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-primary[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-danger {\n  color: #f04134;\n  background-color: transparent;\n  border-color: #f04134;\n}\n.ant-btn-background-ghost.ant-btn-danger > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-danger > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-danger:hover,\n.ant-btn-background-ghost.ant-btn-danger:focus {\n  color: #f46e65;\n  background-color: transparent;\n  border-color: #f46e65;\n}\n.ant-btn-background-ghost.ant-btn-danger:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger:focus > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-danger:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-danger:active,\n.ant-btn-background-ghost.ant-btn-danger.active {\n  color: #d73435;\n  background-color: transparent;\n  border-color: #d73435;\n}\n.ant-btn-background-ghost.ant-btn-danger:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger.active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-danger:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-btn-background-ghost.ant-btn-danger.disabled,\n.ant-btn-background-ghost.ant-btn-danger[disabled],\n.ant-btn-background-ghost.ant-btn-danger.disabled:hover,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:hover,\n.ant-btn-background-ghost.ant-btn-danger.disabled:focus,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:focus,\n.ant-btn-background-ghost.ant-btn-danger.disabled:active,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:active,\n.ant-btn-background-ghost.ant-btn-danger.disabled.active,\n.ant-btn-background-ghost.ant-btn-danger[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-btn-background-ghost.ant-btn-danger.disabled > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger[disabled] > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger.disabled:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:hover > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger.disabled:focus > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:focus > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger.disabled:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:active > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger.disabled.active > a:only-child,\n.ant-btn-background-ghost.ant-btn-danger[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-btn-background-ghost.ant-btn-danger.disabled > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger[disabled] > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger.disabled:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:hover > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger.disabled:focus > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:focus > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger.disabled:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger[disabled]:active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger.disabled.active > a:only-child:after,\n.ant-btn-background-ghost.ant-btn-danger[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n@keyframes buttonEffect {\n  to {\n    opacity: 0;\n    top: -6px;\n    left: -6px;\n    bottom: -6px;\n    right: -6px;\n    border-width: 6px;\n  }\n}\n"]
            },] },
];
/** @nocollapse */
ButtonComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
ButtonComponent.propDecorators = {
    "type": [{ type: core.Input },],
    "size": [{ type: core.Input },],
    "ghost": [{ type: core.Input },],
    "shape": [{ type: core.Input },],
    "loading": [{ type: core.Input },],
    "disabled": [{ type: core.Input },],
    "icon": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ButtonGrouppComponent = (function () {
    function ButtonGrouppComponent() {
        this.size = '';
    }
    return ButtonGrouppComponent;
}());
ButtonGrouppComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-button-groupp',
                template: "<div class=\"ant-btn-group\" [ngClass]=\"{'ant-btn-group-sm': size === 'small' , 'ant-btn-group-lg': size === 'large'\n\n}\">\n    <ng-content></ng-content>\n</div>",
                styles: ["::ng-deep .ant-btn-group {\n  position: relative;\n  display: inline-block;\n  font-size: 0px;\n}\n::ng-deep .ant-btn-group > .ant-btn {\n  position: relative;\n  z-index: 1;\n}\n::ng-deep .ant-btn-group > .ant-btn:hover,\n::ng-deep .ant-btn-group > .ant-btn:focus,\n::ng-deep .ant-btn-group > .ant-btn:active,\n::ng-deep .ant-btn-group > .ant-btn.active {\n  z-index: 2;\n}\n::ng-deep .ant-btn-group > .ant-btn:disabled {\n  z-index: 0;\n}\n::ng-deep .ant-btn-group-lg > .ant-btn {\n  padding: 0 15px;\n  font-size: 14px;\n  border-radius: 4px;\n  height: 32px;\n}\n::ng-deep .ant-btn-group-sm > .ant-btn {\n  padding: 0 7px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 22px;\n}\n::ng-deep .ant-btn-group-sm > .ant-btn > .anticon {\n  font-size: 12px;\n}\n::ng-deep .ant-btn-group ant-button .ant-btn + ant-button .ant-btn,\nant-button .ant-btn + ::ng-deep .ant-btn-group,\n::ng-deep .ant-btn-group ant-button + .ant-btn,\n::ng-deep .ant-btn-group ant-button + ::ng-deep .ant-btn-group ant-button {\n  margin-left: -1px;\n}\n::ng-deep .ant-btn-group ant-button {\n  box-sizing: border-box;\n}\n::ng-deep .ant-btn-group ant-button:not(:first-child):not(:last-child) .ant-btn {\n  border-radius: 0;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ant-button:first-child:not(:last-child) > .ant-btn {\n  margin-left: 0;\n  border-bottom-right-radius: 0;\n  border-top-right-radius: 0;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ant-button:last-child:not(:first-child) > .ant-btn {\n  border-bottom-left-radius: 0;\n  border-top-left-radius: 0;\n  padding-left: 8px;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group {\n  float: left;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:not(:first-child):not(:last-child) .ant-btn {\n  border-radius: 0;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:first-child:not(:last-child) > .ant-btn:last-child {\n  border-bottom-right-radius: 0;\n  border-top-right-radius: 0;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:last-child:not(:first-child) .ant-btn:first-child {\n  border-bottom-left-radius: 0;\n  border-top-left-radius: 0;\n  padding-left: 8px;\n}\n@keyframes buttonEffect {\n  to {\n    opacity: 0;\n    top: -6px;\n    left: -6px;\n    bottom: -6px;\n    right: -6px;\n    border-width: 6px;\n  }\n}\n"]
            },] },
];
/** @nocollapse */
ButtonGrouppComponent.ctorParameters = function () { return []; };
ButtonGrouppComponent.propDecorators = {
    "size": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$1 = [ButtonGrouppComponent, ButtonComponent];
var ButtonModule = (function () {
    function ButtonModule() {
    }
    return ButtonModule;
}());
ButtonModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                exports: COMPONENTS$1.slice(),
                declarations: COMPONENTS$1.slice(),
                entryComponents: COMPONENTS$1.slice()
            },] },
];
/** @nocollapse */
ButtonModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var StepsComponent = (function () {
    /**
     * @param {?} renderer
     */
    function StepsComponent(renderer) {
        this.renderer = renderer;
        this._current = 0;
    }
    Object.defineProperty(StepsComponent.prototype, "current", {
        /**
         * 指定当前步骤，从 0 开始记数。在子 Step 元素中，可以通过 status 属性覆盖状态
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (isNaN(value)) {
                this._current = 0;
                return;
            }
            this._current = value;
        },
        enumerable: true,
        configurable: true
    });
    
    /**
     * @return {?}
     */
    StepsComponent.prototype.ngOnInit = function () {
    };
    /**
     * @return {?}
     */
    StepsComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var /** @type {?} */ stepItems = this.stepItems['_results'];
        var /** @type {?} */ _lastItemWidth = (stepItems[stepItems.length - 1].nativeElement.clientWidth + 1) / (stepItems.length - 1);
        stepItems.forEach(function (e, index, arr) {
            _this.setStyle(e.nativeElement, { 'marginRight': "-" + _lastItemWidth + "px" });
            if (_this.progressDot) {
                _this.setStyle(e.nativeElement.firstElementChild, { 'paddingRight': _lastItemWidth + "px" });
            }
            else {
                _this.setStyle(e.nativeElement.firstElementChild, { 'paddingRight': _lastItemWidth + 10 + "px" });
            }
        });
    };
    /**
     * @param {?} el
     * @param {?} obj
     * @return {?}
     */
    StepsComponent.prototype.setStyle = function (el, obj) {
        for (var /** @type {?} */ key in obj) {
            if (obj.hasOwnProperty(key)) {
                this.renderer.setElementStyle(el, key, obj[key]);
            }
        }
    };
    return StepsComponent;
}());
StepsComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-steps',
                template: "\n\n  <div class=\"ant-steps ant-steps-horizontal ant-steps-label-horizontal\"\n       [ngClass]=\"{\n       'ant-steps-small':size == 'small',\n       'ant-steps-vertical':direction == 'vertical',\n       'ant-steps-dot':progressDot\n       }\">\n      <div class=\"ant-steps-item\"\n           *ngFor=\"let item of model;let i = index;\"\n           [ngStyle]=\"{width:i<model.length-1?((100/(model.length-1))+'%'):''}\"\n           [ngClass]=\"{\n           'ant-steps-status-wait':(status=='wait' && i == _current) || i>_current,\n           'ant-steps-status-finish':(status=='finish'&& i == _current) || i < _current,\n           'ant-steps-status-error':status=='error' && i == _current,\n           'ant-steps-status-process':(status=='process'|| !status) && i == _current,\n           'ant-steps-next-error':status=='error' && i == (_current-1)\n           }\" #stepItem>\n        <div class=\"ant-steps-tail\"><i></i></div>\n        <div class=\"ant-steps-step\">\n          <div class=\"ant-steps-head\">\n            <div class=\"ant-steps-head-inner\">\n              <span class=\"ant-steps-icon\"\n                [ngClass]=\"{\n                    'anticon-check':(i<_current || (status == 'finish'&& i == _current))&&!progressDot,\n                    'anticon-cross': (status == 'error'&& i == _current)&&!progressDot,\n                    'anticon anticon-check':(i<_current || ((status == 'finish' || status == 'error')&& i == _current))&&!progressDot\n                    }\">\n                <span *ngIf=\"progressDot\" class=\"ant-steps-icon-dot\"></span>\n                {{progressDot?'':((i < _current || (status=='finish' || status=='error') && i == _current)?'':(i+1))}}\n              </span>\n            </div>\n          </div>\n          <div class=\"ant-steps-main\">\n            <div class=\"ant-steps-title\">{{item.title}}</div>\n            <div class=\"ant-steps-description\">{{item.description}}</div>\n          </div>\n        </div>\n      </div>\n  </div>\n\n\n\n\n\n\n",
                styles: [".ant-steps {\n  font-size: 0;\n  line-height: 1.5;\n}\n.ant-steps .ant-steps-item {\n  position: relative;\n  display: inline-block;\n  vertical-align: top;\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner {\n  border-color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner > .ant-steps-icon {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: rgba(0, 0, 0, 0.25);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-title {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-description {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner {\n  border-color: #108ee9;\n  background-color: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon {\n  color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-title {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-description {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner {\n  border-color: #108ee9;\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner > .ant-steps-icon {\n  color: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-tail > i:after {\n  width: 100%;\n  background: #108ee9;\n  transition: all .6s;\n  opacity: 1;\n  box-shadow: 0 0 0 0 #108ee9;\n  animation: tailEffect .4s;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-title {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-description {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner {\n  border-color: #f04134;\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner > .ant-steps-icon {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-title {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-description {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-next-error .ant-steps-tail > i,\n.ant-steps .ant-steps-item.ant-steps-next-error .ant-steps-tail > i:after {\n  background-color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-custom .ant-steps-head-inner {\n  background: none;\n  border: 0;\n  width: auto;\n  height: auto;\n}\n.ant-steps .ant-steps-item.ant-steps-custom .ant-steps-head-inner > .ant-steps-icon {\n  font-size: 26px;\n  width: 26px;\n  height: 26px;\n}\n.ant-steps .ant-steps-item.ant-steps-custom.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon {\n  color: #108ee9;\n}\n.ant-steps .ant-steps-head,\n.ant-steps .ant-steps-main {\n  position: relative;\n  display: inline-block;\n  vertical-align: top;\n}\n.ant-steps .ant-steps-head {\n  background: #fff;\n}\n.ant-steps .ant-steps-head-inner {\n  display: block;\n  border: 1px solid rgba(0, 0, 0, 0.25);\n  width: 26px;\n  height: 26px;\n  line-height: 23px;\n  text-align: center;\n  border-radius: 26px;\n  font-size: 14px;\n  margin-right: 8px;\n  transition: background-color 0.3s ease, border-color 0.3s ease;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon {\n  line-height: 1;\n  color: #108ee9;\n  position: relative;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon {\n  font-size: 12px;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon-cross,\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon-check {\n  font-weight: bold;\n}\n.ant-steps .ant-steps-title {\n  font-size: 14px;\n  line-height: 26px;\n  color: rgba(0, 0, 0, 0.65);\n  font-weight: bold;\n  background-color: #fff;\n  display: inline-block;\n  padding-right: 10px;\n}\n.ant-steps .ant-steps-title > a:first-child:last-child {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item:last-child .ant-steps-title {\n  padding-right: 0;\n  width: 100%;\n}\n.ant-steps .ant-steps-item:last-child .ant-steps-tail {\n  display: none;\n}\n.ant-steps .ant-steps-description {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-tail {\n  position: absolute;\n  left: 0;\n  width: 100%;\n  top: 13px;\n  padding: 0 10px;\n}\n.ant-steps .ant-steps-tail > i {\n  display: inline-block;\n  vertical-align: top;\n  background: #e9e9e9;\n  height: 1px;\n  border-radius: 1px;\n  width: 100%;\n  position: relative;\n}\n.ant-steps .ant-steps-tail > i:after {\n  position: absolute;\n  content: '';\n  top: 0;\n  width: 0;\n  background: #e9e9e9;\n  height: 100%;\n  opacity: 0;\n}\n.ant-steps.ant-steps-small .ant-steps-head-inner {\n  border: 1px solid rgba(0, 0, 0, 0.25);\n  width: 18px;\n  height: 18px;\n  line-height: 15px;\n  text-align: center;\n  border-radius: 18px;\n  font-size: 12px;\n  margin-right: 10px;\n}\n.ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 9px 9;\n  transform: scale(0.75) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  top: 0;\n}\n:root .ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  filter: none;\n}\n:root .ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  font-size: 12px;\n}\n.ant-steps.ant-steps-small .ant-steps-main {\n  margin-top: 0;\n}\n.ant-steps.ant-steps-small .ant-steps-title {\n  font-size: 12px;\n  line-height: 18px;\n  color: rgba(0, 0, 0, 0.65);\n  font-weight: bold;\n}\n.ant-steps.ant-steps-small .ant-steps-description {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps.ant-steps-small .ant-steps-tail {\n  top: 8px;\n  padding: 0 8px;\n}\n.ant-steps.ant-steps-small .ant-steps-tail > i {\n  height: 1px;\n  border-radius: 1px;\n  width: 100%;\n}\n.ant-steps.ant-steps-small .ant-steps-custom .ant-steps-head-inner > .ant-steps-icon {\n  font-size: 18px;\n  width: 18px;\n  height: 18px;\n}\n.ant-steps-vertical > .ant-steps-item {\n  display: block;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail {\n  position: absolute;\n  left: 13px;\n  top: 0;\n  height: 100%;\n  width: 1px;\n  padding: 30px 0 4px;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail > i {\n  height: 100%;\n  width: 1px;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail > i:after {\n  height: 0;\n  width: 100%;\n}\n.ant-steps-vertical .ant-steps-status-finish .ant-steps-tail > i:after {\n  height: 100%;\n}\n.ant-steps-vertical .ant-steps-head {\n  float: left;\n}\n.ant-steps-vertical .ant-steps-head-inner {\n  margin-right: 16px;\n}\n.ant-steps-vertical .ant-steps-main {\n  min-height: 47px;\n  overflow: hidden;\n  display: block;\n}\n.ant-steps-vertical .ant-steps-main .ant-steps-title {\n  line-height: 26px;\n}\n.ant-steps-vertical .ant-steps-main .ant-steps-description {\n  padding-bottom: 12px;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-tail {\n  position: absolute;\n  left: 9px;\n  top: 0;\n  padding: 22px 0 4px;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-tail > i {\n  height: 100%;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-title {\n  line-height: 18px;\n}\n.ant-steps-horizontal.ant-steps-hidden {\n  visibility: hidden;\n}\n.ant-steps-horizontal .ant-steps-description {\n  max-width: 120px;\n}\n.ant-steps-horizontal .ant-steps-item:not(:first-child) .ant-steps-head {\n  padding-left: 10px;\n  margin-left: -10px;\n}\n.ant-steps-dot .ant-steps-item .ant-steps-step {\n  display: inline-block;\n  text-align: center;\n  width: 120px;\n}\n.ant-steps-dot .ant-steps-item:not(:first-child) .ant-steps-head {\n  margin-left: 0;\n  padding-left: 0;\n}\n.ant-steps-dot .ant-steps-tail {\n  margin: 0 0 0 60px;\n  padding: 0;\n  width: 100%;\n  top: 1px;\n}\n.ant-steps-dot .ant-steps-tail > i {\n  height: 3px;\n}\n.ant-steps-dot .ant-steps-head {\n  display: inline-block;\n  padding-right: 0;\n}\n.ant-steps-dot .ant-steps-head-inner {\n  margin: 0 auto;\n  width: 5px;\n  height: 5px;\n  line-height: 5px;\n  border: 0;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot {\n  float: left;\n  width: 100%;\n  height: 100%;\n  border-radius: 2.5px;\n  position: relative;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot:after {\n  content: '';\n  background: rgba(255, 255, 255, 0.001);\n  width: 40px;\n  height: 24px;\n  position: absolute;\n  top: -8px;\n  left: -16px;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot:hover {\n  transform: scale(1.3);\n}\n.ant-steps-dot .ant-steps-main {\n  display: block;\n  margin-top: 10px;\n}\n.ant-steps-dot .ant-steps-main .ant-steps-title {\n  padding-right: 0;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head {\n  top: -1px;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head-inner {\n  width: 7px;\n  height: 7px;\n  line-height: 7px;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head-inner .ant-steps-icon-dot {\n  border-radius: 3.5px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-tail {\n  left: 2px;\n  height: 100%;\n  padding: 0;\n  top: 15px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-tail > i {\n  height: 100%;\n  width: 3px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-head {\n  top: 12px;\n  left: 1px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-status-process .ant-steps-head {\n  left: 0;\n}\n@keyframes tailEffect {\n  to {\n    box-shadow: 0 0 3px 3px transparent;\n  }\n}\n"],
                providers: []
            },] },
];
/** @nocollapse */
StepsComponent.ctorParameters = function () { return [
    { type: core.Renderer, },
]; };
StepsComponent.propDecorators = {
    "model": [{ type: core.Input },],
    "current": [{ type: core.Input },],
    "status": [{ type: core.Input },],
    "direction": [{ type: core.Input },],
    "size": [{ type: core.Input },],
    "progressDot": [{ type: core.Input },],
    "stepItems": [{ type: core.ViewChildren, args: ['stepItem',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//
var StepsModule = (function () {
    function StepsModule() {
    }
    return StepsModule;
}());
StepsModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [StepsComponent],
                exports: [StepsComponent]
            },] },
];
/** @nocollapse */
StepsModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
core.Injectable();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UploadService = (function () {
    function UploadService() {
        this.subject$ = new Subject.Subject();
    }
    /**
     * @param {?} content
     * @return {?}
     */
    UploadService.prototype.broadcast = function (content) {
        this.subject$.next(content);
    };
    return UploadService;
}());
UploadService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
UploadService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UploadComponent = (function () {
    /**
     * @param {?} sanitizer
     * @param {?} _message
     * @param {?} _us
     * @param {?} renderer
     */
    function UploadComponent(sanitizer, _message, _us, renderer) {
        this.sanitizer = sanitizer;
        this._message = _message;
        this._us = _us;
        this.renderer = renderer;
        this.files = [];
        this.messages = [];
        this.onSelect = new core.EventEmitter();
        this.onError = new core.EventEmitter();
        this.onSuccess = new core.EventEmitter();
        this.removeFile = new core.EventEmitter();
        this.onPreviewPicture = new core.EventEmitter();
    }
    /**
     * @return {?}
     */
    UploadComponent.prototype.ngOnInit = function () {
        this.maxFileSize = this.options.maxFileSize || 2000000;
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    UploadComponent.prototype.ngOnChanges = function (changes) {
        if (changes['fileList']) {
            this.fileList = changes['fileList'].currentValue;
        }
        else {
            // this.fileList = [];
        }
    };
    /**
     * @return {?}
     */
    UploadComponent.prototype.selectFile = function () {
        this.selectInput.nativeElement.click();
    };
    /**
     * 选择文件
     * @param {?} event
     * @return {?}
     */
    UploadComponent.prototype.onFileSelect = function (event) {
        this.files = [];
        var /** @type {?} */ files = event.dataTransfer ? event.dataTransfer.files : event.target.files;
        for (var /** @type {?} */ i = 0; i < files.length; i++) {
            this.messages = [];
            var /** @type {?} */ file = files[i];
            this.onSelect.emit({ file: file, files: files });
            if (this.validate(file)) {
                /**
                         * 过滤上传的文件格式等
                         */
                if (this.messages[0].type === 'genre') {
                    this._message.error('您这个' + file.name + '上传类型不符合', { nzDuration: 2000 });
                }
                if (this.messages[0].type === 'size') {
                    this._message.error('您这个' + this.messages[0].name + '文件大小过大', { nzDuration: 2000 });
                }
            }
            else {
                if (this.isImage(file)) {
                    file.objectURL = this.sanitizer.bypassSecurityTrustUrl((window.URL.createObjectURL(files[i])));
                }
                else {
                    var /** @type {?} */ fileExt = file.name.substring(file.name.lastIndexOf('.') + 1);
                    file.objectURL = this.matchPicture(fileExt);
                }
                file.status = 'uploading';
                this.files.push(files[i]);
                this.fileList.push(files[i]);
                event.target.value = '';
            }
        }
        if (this.hasFiles()) {
            for (var /** @type {?} */ i = 0; i < this.files.length; i++) {
                this.upload(this.files[i].name, this.files[i]);
            }
        }
        // group1/M00/17/7F/rB9kmlmNfZCAIL0oAAzodQCbVVc825.jpg
    };
    /**
     * 上传文件
     * @param {?} name
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.upload = function (name, file) {
        var _this = this;
        var /** @type {?} */ xhr = new XMLHttpRequest(), /** @type {?} */ formData = new FormData();
        if (this.options.setParameter) {
            for (var /** @type {?} */ key in this.options.setParameter) {
                if (this.options.setParameter.hasOwnProperty(key)) {
                    if (key === 'savepath') {
                        this.options.setParameter[key] = this.options.setParameter[key] + name;
                    }
                    formData.append(key, this.options.setParameter[key]);
                }
            }
        }
        formData.append('file', file);
        xhr.upload.addEventListener('progress', function (e) {
            if (e.lengthComputable) {
                file.progress = Math.round((e.loaded * 100) / e.total);
            }
        }, false);
        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4) {
                file.progress = 0;
                if (xhr.status >= 200 && xhr.status < 300) {
                    var /** @type {?} */ data = JSON.parse(xhr.response);
                    if (data.Success || data.result === 0) {
                        _this.onSuccess.emit({ data: data, files: _this.files });
                        file.path = _this.options.previewUrlPrex + (data.Data ? data.Data[0] : data.data[0].Url);
                        file.status = 'done';
                        return;
                    }
                    _this.onError.emit({ data: JSON.parse(xhr.response), files: _this.files });
                    // this._message.error(data.Message?data.Message:data.message);
                    file.status = 'error';
                }
                else {
                    file.status = 'error';
                }
            }
        };
        var /** @type {?} */ method = this.options.method || 'post';
        xhr.open(method, this.options.url, true);
        if (this.options.headerOptions) {
            for (var /** @type {?} */ key in this.options.headerOptions) {
                if (this.options.headerOptions.hasOwnProperty(key)) {
                    xhr.setRequestHeader(key, this.options.headerOptions[key]);
                }
            }
        }
        xhr.send(formData);
    };
    /**
     * 验证传入的文件，是否符合
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.validate = function (file) {
        if (this.options.accept && !this.isFileTypeValid(file)) {
            this.messages.push({
                type: 'genre',
                summary: file.name,
                detail: this.options.accept,
                name: file.name
            });
            return true;
        }
        if (file.size > this.maxFileSize) {
            this.messages.push({
                type: 'size',
                summary: this.formatSize(file.size),
                detail: this.formatSize(this.maxFileSize),
                name: file.name
            });
            return true;
        }
        return false;
    };
    /**
     * 文件类型的验证
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.isFileTypeValid = function (file) {
        var /** @type {?} */ acceptableTypes = this.options.accept.split(',');
        for (var _i = 0, acceptableTypes_1 = acceptableTypes; _i < acceptableTypes_1.length; _i++) {
            var type = acceptableTypes_1[_i];
            var /** @type {?} */ acceptable = this.isWildcard(type) ? this.getTypeClass(file.type) === this.getTypeClass(type)
                : this.getFileExtension(file) === type || file.type === type;
            if (acceptable) {
                return true;
            }
        }
        return false;
    };
    /**
     * 删除文件
     * @param {?} i
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.remove = function (i, file) {
        var _this = this;
        this.removeFile.emit({ file: file });
        var /** @type {?} */ unsubscibe = this._us.subject$.subscribe(function (data) {
            if (data) {
                _this.fileList.splice(i, 1);
                unsubscibe.unsubscribe();
            }
            else {
                _this._message.error('删除失败,请重试');
            }
        });
    };
    /**
     * @param {?} fileType
     * @return {?}
     */
    UploadComponent.prototype.getTypeClass = function (fileType) {
        return fileType.substring(0, fileType.indexOf('/'));
    };
    /**
     * @param {?} fileType
     * @return {?}
     */
    UploadComponent.prototype.isWildcard = function (fileType) {
        return fileType.indexOf('*') !== -1;
    };
    /**
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.getFileExtension = function (file) {
        return file.name.split('.').pop();
    };
    /**
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.isImage = function (file) {
        return /^image\//.test(file.type);
    };
    /**
     * @param {?} img
     * @return {?}
     */
    UploadComponent.prototype.onImageLoad = function (img) {
        window.URL.revokeObjectURL(img.src);
    };
    /**
     * @param {?} bytes
     * @return {?}
     */
    UploadComponent.prototype.formatSize = function (bytes) {
        if (bytes === 0) {
            return '0 B';
        }
        var /** @type {?} */ k = 1000, /** @type {?} */ dm = 3, /** @type {?} */ sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'], /** @type {?} */ i = Math.floor(Math.log(bytes) / Math.log(k));
        return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
    };
    /**
     * @return {?}
     */
    UploadComponent.prototype.hasFiles = function () {
        return this.files && this.files.length > 0;
    };
    /**
     * @param {?} file
     * @return {?}
     */
    UploadComponent.prototype.previewPicture = function (file) {
        this.onPreviewPicture.emit({ file: file });
    };
    /**
     * @param {?} e
     * @param {?} url
     * @return {?}
     */
    UploadComponent.prototype.imageError = function (e, url) {
        var /** @type {?} */ fileExt = url.substring(url.lastIndexOf('.') + 1);
        e.srcElement.src = this.matchPicture(fileExt);
    };
    /**
     * @param {?} fileExt
     * @return {?}
     */
    UploadComponent.prototype.matchPicture = function (fileExt) {
        var /** @type {?} */ fileImgSrc = './../../assets/images/';
        if (fileExt === 'doc' || fileExt === 'docx' || fileExt === 'rtf') {
            return fileImgSrc + "word.png";
        }
        else if (fileExt === 'ppt' || fileExt === 'pptx') {
            return fileImgSrc + "ppt.png";
        }
        else if (fileExt === 'txt') {
            return fileImgSrc + "txt.png";
        }
        else if (fileExt === 'xls' || fileExt === 'xlsx') {
            return fileImgSrc + "xls.png";
        }
        else if (fileExt === 'ttf') {
            return fileImgSrc + "ttf.png";
        }
        else if (fileExt === 'zip') {
            return fileImgSrc + "zip.png";
        }
        else if (fileExt === 'rar') {
            return fileImgSrc + "rar.png";
        }
        else if (fileExt === 'psd') {
            return fileImgSrc + "psd.png";
        }
        else if (fileExt === 'swf') {
            return fileImgSrc + "swf.png";
        }
        else if (fileExt === 'txt') {
            return fileImgSrc + "txt.png";
        }
        else {
            return fileImgSrc + "other.png";
        }
    };
    return UploadComponent;
}());
UploadComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-upload',
                template: "<div class=\"ant-upload ant-upload-select ant-upload-select-text\" (click)=\"selectFile()\">\n  <span tabindex=\"0\" class=\"ant-upload\" role=\"button\">\n    <input #selectInput [accept]=\"options.accept\" style=\"display: none;\" type=\"file\"\n           [multiple]=\"options.multiple\"\n           (change)=\"onFileSelect($event)\">\n    <ng-content></ng-content>\n  </span>\n</div>\n<div class=\"ant-upload-list\"\n     [ngClass]=\"{\n       'ant-upload-list-text':this.options.listType=='text' || !this.options.listType,\n       'ant-upload-list-picture':this.options.listType == 'picture'\n      }\">\n  <div class=\"ant-upload-list-item \"\n       [ngClass]=\"{\n         'ant-upload-list-item-uploading':file.status == 'uploading',\n         'ant-upload-list-item-done':file.status == 'done',\n         'ant-upload-list-item-error':file.status == 'error'\n        }\" \n       *ngFor=\"let file of fileList;let i = index;\">\n    <div class=\"ant-upload-list-item-info\">\n      <span>\n        <i class=\"anticon anticon-paper-clip\" \n           *ngIf=\"this.options.listType == 'text' || !this.options.listType\"></i>\n        <a class=\"ant-upload-list-item-thumbnail\" \n           href=\"javascript:void(0);\"\n           *ngIf=\"this.options.listType == 'picture'\"\n           rel=\"noopener noreferrer\" (click)=\"previewPicture(file)\">\n          <img [src]=\"file.objectURL?file.objectURL:(file.thumbUrl?file.thumbUrl:file.path)\" [alt]=\"file.name\" (error)=\"imageError($event,file.path)\">\n        </a>\n        <a href=\"javascript:void(0);\"\n           rel=\"noopener noreferrer\"\n           class=\"ant-upload-list-item-name\"\n           [title]=\"file.name\" (click)=\"previewPicture(file)\">{{file.name}}</a>\n      </span>\n      <div class=\"ant-upload-list-item-progress\" *ngIf=\"file.status == 'uploading'\" >\n        <nz-progress [ngModel]=\"file.progress || 0\" [nzShowInfo]=\"false\" [nzStrokeWidth]=\"2\"></nz-progress>\n      </div>\n    </div>\n    <i title=\"\u5220\u9664\u6587\u4EF6\" class=\"anticon anticon-cross\" (click)=\"remove(i,file)\"></i></div>\n</div>\n\n\n\n\n",
                styles: [".ant-upload {\n  font-size: 12px;\n  outline: 0;\n}\n.ant-upload-btn {\n  display: block;\n  width: 100%;\n  outline: none;\n}\n.ant-upload input[type=\"file\"] {\n  cursor: pointer;\n}\n.ant-upload.ant-upload-select {\n  display: inline-block;\n}\n.ant-upload.ant-upload-select-picture-card {\n  border: 1px dashed #d9d9d9;\n  width: 96px;\n  height: 96px;\n  border-radius: 4px;\n  background-color: #fbfbfb;\n  text-align: center;\n  cursor: pointer;\n  transition: border-color 0.3s ease;\n  display: inline-block;\n  vertical-align: top;\n  margin-right: 8px;\n  margin-bottom: 8px;\n}\n.ant-upload.ant-upload-select-picture-card > .ant-upload {\n  display: block;\n  width: 100%;\n  height: 100%;\n  padding: 20px 0;\n}\n.ant-upload.ant-upload-select-picture-card:hover {\n  border-color: #108ee9;\n}\n.ant-upload.ant-upload-drag {\n  border: 1px dashed #d9d9d9;\n  transition: border-color 0.3s ease;\n  cursor: pointer;\n  border-radius: 4px;\n  text-align: center;\n  width: 100%;\n  height: 100%;\n  position: relative;\n}\n.ant-upload.ant-upload-drag.ant-upload-drag-hover:not(.ant-upload-disabled) {\n  border: 2px dashed #49a9ee;\n}\n.ant-upload.ant-upload-drag.ant-upload-disabled {\n  cursor: not-allowed;\n}\n.ant-upload.ant-upload-drag .ant-upload-btn {\n  display: table;\n  height: 100%;\n}\n.ant-upload.ant-upload-drag .ant-upload-drag-container {\n  display: table-cell;\n  vertical-align: middle;\n}\n.ant-upload.ant-upload-drag:not(.ant-upload-disabled):hover {\n  border-color: #49a9ee;\n}\n.ant-upload.ant-upload-drag p.ant-upload-drag-icon {\n  height: 60px;\n  margin-bottom: 24px;\n}\n.ant-upload.ant-upload-drag p.ant-upload-drag-icon .anticon {\n  font-size: 80px;\n  margin-top: -5px;\n  color: #49a9ee;\n}\n.ant-upload.ant-upload-drag p.ant-upload-text {\n  font-size: 14px;\n}\n.ant-upload.ant-upload-drag p.ant-upload-hint {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-upload.ant-upload-drag .anticon-plus {\n  font-size: 30px;\n  transition: all 0.3s ease;\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-upload.ant-upload-drag .anticon-plus:hover {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-upload.ant-upload-drag:hover .anticon-plus {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-upload-list {\n  overflow: hidden;\n}\n.ant-upload-list-item {\n  overflow: hidden;\n  margin-top: 8px;\n  font-size: 12px;\n  position: relative;\n  height: 24px;\n}\n.ant-upload-list-item-name {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  padding-left: 16px;\n  width: 100%;\n  display: inline-block;\n}\n.ant-upload-list-item-info {\n  line-height: 24px;\n  padding: 0 12px 0 4px;\n  transition: background-color 0.3s;\n}\n.ant-upload-list-item-info .anticon-loading,\n.ant-upload-list-item-info .anticon-paper-clip {\n  margin-right: 4px;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n  position: absolute;\n  top: 5.5px;\n}\n.ant-upload-list-item .anticon-cross {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  transition: all .3s;\n  opacity: 0;\n  cursor: pointer;\n  position: absolute;\n  top: 0;\n  right: 4px;\n  color: rgba(0, 0, 0, 0.43);\n  line-height: 24px;\n}\n:root .ant-upload-list-item .anticon-cross {\n  filter: none;\n}\n:root .ant-upload-list-item .anticon-cross {\n  font-size: 12px;\n}\n.ant-upload-list-item .anticon-cross:hover {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-upload-list-item:hover .ant-upload-list-item-info {\n  background-color: #ecf6fd;\n}\n.ant-upload-list-item:hover .anticon-cross {\n  opacity: 1;\n}\n.ant-upload-list-item-error,\n.ant-upload-list-item-error .anticon-paper-clip,\n.ant-upload-list-item-error .ant-upload-list-item-name {\n  color: #f04134;\n}\n.ant-upload-list-item-error .anticon-cross {\n  opacity: 1;\n  color: #f04134 !important;\n}\n.ant-upload-list-item-progress {\n  line-height: 0;\n  font-size: 12px;\n  position: absolute;\n  width: 100%;\n  bottom: 0;\n}\n.ant-upload-list-picture .ant-upload-list-item,\n.ant-upload-list-picture-card .ant-upload-list-item {\n  padding: 8px;\n  border-radius: 4px;\n  border: 1px solid #d9d9d9;\n  height: 66px;\n  position: relative;\n}\n.ant-upload-list-picture .ant-upload-list-item:hover,\n.ant-upload-list-picture-card .ant-upload-list-item:hover {\n  background: transparent;\n}\n.ant-upload-list-picture .ant-upload-list-item-error,\n.ant-upload-list-picture-card .ant-upload-list-item-error {\n  border-color: #f04134;\n}\n.ant-upload-list-picture .ant-upload-list-item-info,\n.ant-upload-list-picture-card .ant-upload-list-item-info {\n  padding: 0;\n}\n.ant-upload-list-picture .ant-upload-list-item:hover .ant-upload-list-item-info,\n.ant-upload-list-picture-card .ant-upload-list-item:hover .ant-upload-list-item-info {\n  background: transparent;\n}\n.ant-upload-list-picture .ant-upload-list-item-uploading,\n.ant-upload-list-picture-card .ant-upload-list-item-uploading {\n  border-style: dashed;\n}\n.ant-upload-list-picture .ant-upload-list-item-thumbnail,\n.ant-upload-list-picture-card .ant-upload-list-item-thumbnail {\n  width: 48px;\n  height: 48px;\n  position: absolute;\n  top: 8px;\n  left: 8px;\n}\n.ant-upload-list-picture .ant-upload-list-item-thumbnail img,\n.ant-upload-list-picture-card .ant-upload-list-item-thumbnail img {\n  width: 48px;\n  height: 48px;\n  display: block;\n  overflow: hidden;\n  border-radius: 4px;\n}\n.ant-upload-list-picture .ant-upload-list-item-thumbnail.anticon:before,\n.ant-upload-list-picture-card .ant-upload-list-item-thumbnail.anticon:before {\n  line-height: 48px;\n  font-size: 24px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-upload-list-picture .ant-upload-list-item-name,\n.ant-upload-list-picture-card .ant-upload-list-item-name {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  margin: 0 0 0 8px;\n  line-height: 44px;\n  transition: all .3s;\n  padding-left: 48px;\n  padding-right: 8px;\n  max-width: 100%;\n  display: inline-block;\n  box-sizing: border-box;\n}\n.ant-upload-list-picture .ant-upload-list-item-uploading .ant-upload-list-item-name,\n.ant-upload-list-picture-card .ant-upload-list-item-uploading .ant-upload-list-item-name {\n  line-height: 28px;\n}\n.ant-upload-list-picture .ant-upload-list-item-progress,\n.ant-upload-list-picture-card .ant-upload-list-item-progress {\n  padding-left: 56px;\n  margin-top: 0;\n}\n.ant-upload-list-picture .anticon-cross,\n.ant-upload-list-picture-card .anticon-cross {\n  position: absolute;\n  right: 8px;\n  top: 8px;\n  line-height: 1;\n}\n.ant-upload-list-picture-card {\n  display: inline;\n}\n.ant-upload-list-picture-card .ant-upload-list-item {\n  float: left;\n  width: 96px;\n  height: 96px;\n  margin: 0 8px 8px 0;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-info {\n  height: 100%;\n  position: relative;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-info:before {\n  content: ' ';\n  position: absolute;\n  z-index: 1;\n  background-color: rgba(0, 0, 0, 0.5);\n  transition: all .3s;\n  width: 100%;\n  height: 100%;\n  opacity: 0;\n}\n.ant-upload-list-picture-card .ant-upload-list-item:hover .ant-upload-list-item-info:before {\n  opacity: 1;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-actions {\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  transform: translate(-50%, -50%);\n  z-index: 10;\n  white-space: nowrap;\n  opacity: 0;\n  transition: all .3s;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-actions .anticon-eye-o,\n.ant-upload-list-picture-card .ant-upload-list-item-actions .anticon-delete {\n  z-index: 10;\n  transition: all .3s;\n  cursor: pointer;\n  font-size: 16px;\n  width: 16px;\n  color: rgba(255, 255, 255, 0.91);\n  margin: 0 4px;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-actions .anticon-eye-o:hover,\n.ant-upload-list-picture-card .ant-upload-list-item-actions .anticon-delete:hover {\n  color: #fff;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-info:hover + .ant-upload-list-item-actions,\n.ant-upload-list-picture-card .ant-upload-list-item-actions:hover {\n  opacity: 1;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-thumbnail,\n.ant-upload-list-picture-card .ant-upload-list-item-thumbnail img {\n  display: block;\n  width: 100%;\n  height: 100%;\n  position: static;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-name {\n  display: none;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-uploading.ant-upload-list-item {\n  background-color: #fbfbfb;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-uploading .ant-upload-list-item-info {\n  height: auto;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-uploading .ant-upload-list-item-info:before,\n.ant-upload-list-picture-card .ant-upload-list-item-uploading .ant-upload-list-item-info .anticon-eye-o,\n.ant-upload-list-picture-card .ant-upload-list-item-uploading .ant-upload-list-item-info .anticon-delete {\n  display: none;\n}\n.ant-upload-list-picture-card .ant-upload-list-item-uploading-text {\n  margin-top: 18px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-upload-list-picture-card .ant-upload-list-item-progress {\n  padding-left: 0;\n}\n.ant-upload-list .ant-upload-success-icon {\n  color: #00a854;\n  font-weight: bold;\n}\n.ant-upload-list .ant-upload-animate-enter,\n.ant-upload-list .ant-upload-animate-leave,\n.ant-upload-list .ant-upload-animate-inline-enter,\n.ant-upload-list .ant-upload-animate-inline-leave {\n  animation-duration: .3s;\n  animation-fill-mode: cubic-bezier(0.78, 0.14, 0.15, 0.86);\n}\n.ant-upload-list .ant-upload-animate-enter {\n  animation-name: uploadAnimateIn;\n}\n.ant-upload-list .ant-upload-animate-leave {\n  animation-name: uploadAnimateOut;\n}\n.ant-upload-list .ant-upload-animate-inline-enter {\n  animation-name: uploadAnimateInlineIn;\n}\n.ant-upload-list .ant-upload-animate-inline-leave {\n  animation-name: uploadAnimateInlineOut;\n}\n@keyframes uploadAnimateIn {\n  from {\n    height: 0;\n    margin: 0;\n    opacity: 0;\n    padding: 0;\n  }\n}\n@keyframes uploadAnimateOut {\n  to {\n    height: 0;\n    margin: 0;\n    padding: 0;\n    opacity: 0;\n  }\n}\n@keyframes uploadAnimateInlineIn {\n  from {\n    width: 0;\n    height: 0;\n    margin: 0;\n    opacity: 0;\n    padding: 0;\n  }\n}\n@keyframes uploadAnimateInlineOut {\n  to {\n    width: 0;\n    height: 0;\n    margin: 0;\n    padding: 0;\n    opacity: 0;\n  }\n}\n"],
                providers: []
            },] },
];
/** @nocollapse */
UploadComponent.ctorParameters = function () { return [
    { type: platformBrowser.DomSanitizer, },
    { type: ngZorroAntd.NzMessageService, },
    { type: UploadService, },
    { type: core.Renderer2, },
]; };
UploadComponent.propDecorators = {
    "options": [{ type: core.Input },],
    "fileList": [{ type: core.Input },],
    "onSelect": [{ type: core.Output },],
    "onError": [{ type: core.Output },],
    "onSuccess": [{ type: core.Output },],
    "removeFile": [{ type: core.Output },],
    "onPreviewPicture": [{ type: core.Output },],
    "selectInput": [{ type: core.ViewChild, args: ['selectInput',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UploadModule = (function () {
    function UploadModule() {
    }
    return UploadModule;
}());
UploadModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ngZorroAntd.NzMessageModule,
                    forms.FormsModule,
                    ngZorroAntd.NzProgressModule
                ],
                declarations: [UploadComponent],
                exports: [UploadComponent],
                providers: [UploadService, ngZorroAntd.NzMessageService]
            },] },
];
/** @nocollapse */
UploadModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AvatarComponent = (function () {
    /**
     * @param {?} renderer
     */
    function AvatarComponent(renderer) {
        this.renderer = renderer;
        this._classtype = false;
        this._iconimage = false;
        this.shape = 'circle';
        // 形状：circle | square
        this.size = '';
        // 大小 ：large | small | default
        this.src = '';
    }
    Object.defineProperty(AvatarComponent.prototype, "icon", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (!value) {
                this._icon = false;
                return;
            }
            this._icon = 'anticon-' + value;
        },
        enumerable: true,
        configurable: true
    });
    
    /**
     * @return {?}
     */
    AvatarComponent.prototype.ngOnInit = function () {
    };
    /**
     * @return {?}
     */
    AvatarComponent.prototype.ngAfterViewInit = function () {
        console.log(this);
        // 遍历新增class样式
        for (var /** @type {?} */ i in this.classType) {
            this.setEleCss(this.classTypeEl, i, this.classType[i]);
        }
        if (this.iconImage) {
            this.renderer.setElementAttribute(this.linkRelEl.nativeElement, 'src', this.iconImage.src);
        }
    };
    /**
     * @param {?} el
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    AvatarComponent.prototype.setEleCss = function (el, key, value) {
        this.renderer.setElementStyle(el.nativeElement, key, value);
    };
    return AvatarComponent;
}());
AvatarComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-avatar',
                template: "<span [ngClass]=\"{'ant-avatar-sm': size == 'small','ant-avatar-lg':size == 'large','ant-avatar-square':shape == 'square','ant-avatar-circle':shape=='circle','ant-avatar-icon':_icon,'ant-avatar-classtype':_classtype}\" class=\"ant-avatar\" #classType>\n    <i *ngIf=\"_icon\" [class]=\"'anticon '+ _icon\"></i>\n    <img *ngIf='iconImage' #linkRel/>\n<ng-content></ng-content>\n</span>",
                styles: [".ant-avatar {\n  display: inline-block;\n  text-align: center;\n  background: #ccc;\n  color: #fff;\n  white-space: nowrap;\n  position: relative;\n  overflow: hidden;\n  width: 32px;\n  height: 32px;\n  line-height: 32px;\n  border-radius: 16px;\n}\n.ant-avatar > * {\n  line-height: 32px;\n}\n.ant-avatar.ant-avatar-icon {\n  font-size: 18px;\n}\n.ant-avatar-lg {\n  width: 40px;\n  height: 40px;\n  line-height: 40px;\n  border-radius: 20px;\n}\n.ant-avatar-lg > * {\n  line-height: 40px;\n}\n.ant-avatar-lg.ant-avatar-icon {\n  font-size: 24px;\n}\n.ant-avatar-sm {\n  width: 24px;\n  height: 24px;\n  line-height: 24px;\n  border-radius: 12px;\n}\n.ant-avatar-sm > * {\n  line-height: 24px;\n}\n.ant-avatar-sm.ant-avatar-icon {\n  font-size: 14px;\n}\n.ant-avatar-square {\n  border-radius: 4px;\n}\n.ant-avatar > img {\n  width: 100%;\n  height: 100%;\n  display: block;\n}\n"]
            },] },
];
/** @nocollapse */
AvatarComponent.ctorParameters = function () { return [
    { type: core.Renderer, },
]; };
AvatarComponent.propDecorators = {
    "shape": [{ type: core.Input },],
    "size": [{ type: core.Input },],
    "src": [{ type: core.Input },],
    "classType": [{ type: core.Input },],
    "linkRel": [{ type: core.Input },],
    "icon": [{ type: core.Input },],
    "iconImage": [{ type: core.Input },],
    "classTypeEl": [{ type: core.ViewChild, args: ['classType',] },],
    "linkRelEl": [{ type: core.ViewChild, args: ['linkRel',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AvatarModule = (function () {
    function AvatarModule() {
    }
    return AvatarModule;
}());
AvatarModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                exports: [AvatarComponent],
                declarations: [AvatarComponent],
                entryComponents: [AvatarComponent]
            },] },
];
/** @nocollapse */
AvatarModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DropDownAnimation = animations.trigger('dropDownAnimation', [
    animations.state('bottom', animations.style({
        opacity: 1,
        transform: 'scaleY(1)',
        transformOrigin: '0% 0%'
    })),
    animations.transition('void => bottom', [
        animations.style({
            opacity: 0,
            transform: 'scaleY(0)',
            transformOrigin: '0% 0%'
        }),
        animations.animate('150ms cubic-bezier(0.25, 0.8, 0.25, 1)')
    ]),
    animations.state('top', animations.style({
        opacity: 1,
        transform: 'scaleY(1)',
        transformOrigin: '0% 100%'
    })),
    animations.transition('void => top', [
        animations.style({
            opacity: 0,
            transform: 'scaleY(0)',
            transformOrigin: '0% 100%'
        }),
        animations.animate('150ms cubic-bezier(0.25, 0.8, 0.25, 1)')
    ]),
    animations.transition('* => void', [
        animations.animate('250ms 100ms linear', animations.style({ opacity: 0 }))
    ])
]);
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TagAnimation = animations.trigger('tagAnimation', [
    animations.state('*', animations.style({ opacity: 1, transform: 'scale(1)' })),
    animations.transition('void => *', [
        animations.style({ opacity: 0, transform: 'scale(0)' }),
        animations.animate('150ms linear')
    ]),
    animations.state('void', animations.style({ opacity: 0, transform: 'scale(0)' })),
    animations.transition('* => void', [
        animations.style({ opacity: 1, transform: 'scale(1)' }),
        animations.animate('150ms linear')
    ])
]);
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ChineseToPinyinService = (function () {
    function ChineseToPinyinService() {
        this.MatchingTable = {
            "A": "\u5391\u5416\u554A\u55C4\u9312\u9515",
            "Ai": "\u4F0C\u50FE\u51D2\u53C6\u54C0\u54CE\u5509\u5540\u55CC\u55F3\u560A\u566F\u57C3\u5867\u58D2\u5A3E\u5AD2\u5B21\u5D66\u611B\u61D3\u61DD\u6328\u6371\u6571\u6573\u6639\u66A7\u66D6\u6B38\u6BD0\u6EB0\u6EBE\u6FED\u7231\u7477\u74A6\u764C\u7691\u769A\u76A7\u77B9\u77EE\u7839\u784B\u788D\u7919\u853C\u8586\u85F9\u8B6A\u8B7A\u8CF9\u8EB7\u9384\u9440\u953F\u9698\u972D\u9744\u9749\u9932\u99A4\u9C6B\u9D31",
            "An": "\u4F92\u4FFA\u5111\u5535\u557D\u57B5\u57EF\u5813\u5A69\u5A95\u5B89\u5CB8\u5CD6\u5EB5\u6309\u63DE\u667B\u6697\u6848\u6849\u6C28\u6D1D\u72B4\u73B5\u75F7\u76E6\u76EB\u7F6F\u80FA\u8164\u834C\u83F4\u843B\u844A\u84ED\u8A9D\u8AF3\u8C19\u8C7B\u8C8B\u92A8\u930C\u94F5\u95C7\u968C\u96F8\u978C\u978D\u97FD\u99A3\u9B9F\u9D6A\u9D95\u9E4C\u9EEF",
            "Ang": "\u5C87\u6602\u663B\u678A\u76CE\u80AE\u91A0\u9AAF",
            "Ao": "\u50B2\u51F9\u53AB\u55F7\u55F8\u5773\u5787\u58BA\u5961\u5965\u5967\u5AAA\u5ABC\u5AEF\u5C99\u5CB0\u5D85\u5DB4\u5ED2\u6160\u61CA\u6277\u629D\u646E\u64D9\u6556\u67EA\u6EF6\u6F9A\u6FB3\u71AC\u720A\u7352\u7353\u7488\u78DD\u7FF1\u7FF6\u7FFA\u8071\u82BA\u851C\u87AF\u8884\u8956\u8B37\u8B38\u8EEA\u9068\u93CA\u93D6\u957A\u969E\u9A41\u9A9C\u9C32\u9CCC\u9DD4\u9F07",
            "Ba": "\u4EC8\u516B\u53D0\u53ED\u5427\u54F5\u575D\u577A\u57BB\u58A2\u58E9\u593F\u59AD\u5C9C\u5DF4\u5F1D\u628A\u629C\u62D4\u634C\u6733\u6B1B\u705E\u70A6\u7238\u72AE\u7390\u75A4\u7679\u77F2\u7B06\u7C91\u7D26\u7F62\u7F77\u7F93\u80C8\u82AD\u8307\u83DD\u8686\u8987\u8A59\u8C5D\u8DC1\u8DCB\u8EF7\u91DB\u91DF\u9200\u94AF\u9738\u9776\u98B0\u9B43\u9B5E\u9B81\u9C83\u9C85\u9F25",
            "Bai": "\u4F70\u5161\u5457\u5504\u5E8D\u62DC\u62DD\u6300\u636D\u63B0\u6446\u64FA\u6557\u67CF\u6822\u7308\u74F8\u767D\u767E\u7A17\u7AE1\u7CA8\u7CBA\u7D54\u85AD\u896C\u8D01\u8D25\u9781\u97DB",
            "Ban": "\u4F34\u529E\u534A\u5742\u59C5\u5C85\u6011\u626E\u6273\u62CC\u642C\u653D\u6591\u6592\u6604\u670C\u677F\u6E74\u7248\u73ED\u74E3\u74EA\u7622\u764D\u79DA\u7C84\u7D46\u7ECA\u8228\u822C\u8742\u8781\u878C\u8929\u8FA6\u8FAC\u9211\u9261\u94A3\u95C6\u962A\u977D\u9812\u9881\u9B6C",
            "Bang": "\u508D\u57B9\u585D\u5CC0\u5E2E\u5E47\u5E5A\u5E6B\u5FAC\u6360\u6886\u68D2\u68D3\u699C\u6D5C\u7253\u73A4\u7865\u7A16\u7D81\u7E0D\u7ED1\u8255\u84A1\u868C\u872F\u8B17\u8C24\u90A6\u90AB\u938A\u9551\u97A4",
            "Bao": "\u4F68\u4FDD\u5124\u525D\u52F9\u52FD\u5305\u5822\u5831\u5AAC\u5AD1\u5B62\u5B9D\u5BDA\u5BF3\u5BF6\u5FC1\u6009\u62A5\u62B1\u66D3\u7172\u7206\u73E4\u7A87\u7B23\u7DE5\u80DE\u82DE\u83E2\u8421\u8446\u8554\u85F5\u8663\u888C\u8912\u8913\u8943\u8C79\u8CF2\u8DB5\u924B\u9464\u94C7\u95C1\u96F9\u974C\u9764\u98F9\u98FD\u9971\u99C2\u9AB2\u9AF1\u9B91\u9C8D\u9CF5\u9D07\u9E28\u9F59\u9F85",
            "Bo": "\u4EB3\u4EE2\u4FBC\u50E0\u50F0\u52C3\u535A\u5575\u5697\u58C6\u5B5B\u5B79\u5D93\u5E1B\u613D\u61EA\u62E8\u632C\u640F\u64A5\u64AD\u64D8\u67ED\u6872\u6A97\u6B02\u6CE2\u6D61\u6DFF\u6E24\u6E50\u717F\u7254\u72A6\u72BB\u72DB\u733C\u73BB\u74DD\u74DF\u7676\u7677\u76CB\u7835\u7886\u78FB\u7921\u7934\u79E1\u7B94\u7BA5\u7C19\u7C38\u7CEA\u7D34\u7F3D\u80C9\u8116\u818A\u8236\u824A\u82E9\u83E0\u8467\u8514\u8617\u86BE\u889A\u88AF\u88B0\u894F\u896E\u8B52\u8C70\u8DDB\u8E23\u8E73\u90E3\u9238\u9251\u9262\u92CD\u939B\u946E\u94B5\u94B9\u94C2\u9548\u9911\u993A\u997D\u998E\u999B\u999E\u99C1\u99EE\u9A4B\u9A73\u9AC6\u9AC9\u9B8A\u9C4D\u9C8C\u9D53\u9E41",
            "Bei": "\u4FFB\u500D\u505D\u5079\u5099\u50C3\u5317\u5351\u55BA\u5907\u6096\u60B2\u60EB\u6102\u618A\u63F9\u6601\u676F\u686E\u6896\u7119\u726C\u7295\u72C8\u72FD\u73FC\u7432\u76C3\u7891\u789A\u7999\u7CD2\u80CC\u82DD\u84D3\u85E3\u86FD\u88AB\u8919\u8A96\u8C9D\u8D1D\u8EF0\u8F29\u8F88\u90B6\u9101\u9273\u92C7\u943E\u94A1\u9642\u97B4\u9AB3\u9D6F\u9E4E",
            "Ben": "\u5034\u574C\u5954\u5959\u6379\u64AA\u672C\u6873\u694D\u6CCD\u6E00\u7287\u7356\u755A\u7B28\u82EF\u8CC1\u8D32\u8F3D\u9029\u931B\u951B",
            "Beng": "\u4F3B\u5623\u57C4\u57F2\u5874\u595F\u5D29\u5D6D\u6CF5\u7423\u742B\u750F\u752D\u75ED\u794A\u7D63\u7DB3\u7E43\u7EF7\u83F6\u8DF0\u8E66\u8FF8\u902C\u93F0\u955A\u958D\u979B",
            "Bi": "\u4F4A\u4F56\u4FFE\u506A\u5302\u5315\u5421\u54D4\u555A\u55F6\u5752\u581B\u58C1\u5936\u5970\u59A3\u59BC\u5A62\u5B16\u5B36\u5C44\u5E01\u5E63\u5E64\u5E87\u5EB3\u5EE6\u5F0A\u5F3B\u5F3C\u5F43\u5F7C\u5FC5\u602D\u610A\u610E\u655D\u6583\u673C\u6788\u67C0\u67F2\u6890\u6945\u6BD4\u6BD5\u6BD6\u6BD9\u6BF4\u6C98\u6E62\u6ED7\u6EED\u6F77\u6FDE\u714F\u719A\u72F4\u7358\u7359\u73CC\u74A7\u7540\u7541\u7562\u7595\u75AA\u75F9\u75FA\u7680\u7695\u78A7\u7986\u79D5\u7A2B\u7B14\u7B46\u7B5A\u7B85\u7B86\u7BE6\u7BF3\u7C83\u7C8A\u7DBC\u7E2A\u7E74\u7F7C\u805B\u80C7\u8177\u822D\u82FE\u835C\u8378\u8406\u841E\u84D6\u84FD\u853D\u859C\u870C\u8795\u8890\u88E8\u8945\u895E\u8963\u89F1\u8A56\u8BD0\u8C4D\u8C8F\u8CB1\u8D14\u8D51\u8DF8\u8E55\u8E83\u8E84\u903C\u907F\u90B2\u9119\u9128\u912A\u924D\u939E\u93CE\u9434\u94CB\u9587\u9589\u959F\u95ED\u965B\u979E\u97B8\u97E0\u98F6\u9946\u999D\u99DC\u9A46\u9AC0\u9AF2\u9B53\u9B85\u9C0F\u9CBE\u9D56\u9DDD\u9DE9\u9F0A\u9F3B",
            "Bian": "\u533E\u535E\u53D8\u5909\u5CC5\u5F01\u5FA7<strong></strong>\u5FED\u60FC\u6283\u62DA\u63D9\u662A\u6C73\u6C74\u709E\u7178\u7251\u7335\u7371\u7502\u782D\u78A5\u7A28\u7A86\u7B3E\u7BAF\u7C69\u7CC4\u7DE8\u7DF6\u7F0F\u7F16\u8251\u82C4\u8439\u85CA\u8759\u890A\u898D\u8B8A\u8CB6\u8D2C\u8FA1\u8FA7\u8FA8\u8FA9\u8FAA\u8FAB\u8FAE\u8FAF\u8FB9\u904D\u9089\u908A\u91C6\u937D\u959E\u97AD\u9828\u9BFE\u9BFF\u9CCA\u9D18",
            "Biao": "\u4FF5\u5126\u5882\u5A4A\u5E56\u5F6A\u647D\u6753\u6807\u6A19\<strong></strong>u6AA6\u6DF2\u6EEE\u700C\u706C\u719B\u7202\u730B\u762D\u7A6E\u813F\u8198\u81D5\u8508\u85E8\u8868\u88F1\u893E\u8AD8\u8B24\u8D06\u9336\u93E2\u9463\u9556\u9573\u98AE\u98B7\u98C6\u98C7\u98C8\u98CA\u98D1\u98D9\u98DA\u9A43\u9A6B\u9A89\u9ADF\u9C3E\u9CD4\u9E83",
            "Bie": "\u5225\u522B\u5487\u5F46\u5FB6\u618B\u762A\u765F\u8382\u864C\u86C2\u87DE\u8952\u8E69\u9C49\u9CD6\u9F08\u9F9E",
            "Bin": "\u50A7\u5110\u5BBE\u5F6C\u6448\u64EF\u658C\u6915\u69DF\u6BA1\u6BAF\u6C1E\u6C43\u6EE8\u6FD2\u6FF1\u6FF5\u7015\u7478\u74B8\u780F\u7E7D\u7F24\u8191\u81CF\u8668\u8819\u8C69\u8C73\u8CD3\u8CD4\u90A0\u944C\u9554\u9726\u986E\u9ACC\u9AD5\u9AE9\u9B02\u9B13\u9B22",
            "Bing": "\u4E19\u4E26\u4ECC\u4F75\u5002\u504B\u50A1\u5175\u51AB\u51B0\u57AA\u5BCE\u5E76\u5E77\u5EB0\u6032\u62A6\u63A4\u6452\u661E\u663A\u67C4\u681F\u6824\u68B9\u68C5\u6AB3\u6C37\u70B3\u71F7\u75C5\u772A\u7980\u79C9\u7A89\u7ADD\u82EA\u86C3\u8A81\u90B4\u9235\u927C\u92F2\u9643\u9750\u9786\u9905\u9920\u997C\u9BA9",
            "Bu": "\u4E0D\u4F48\u52CF\u535F\u5425\u5498\u54FA\u57D7\u57E0\u5CEC\u5E03\u5EAF\u5ECD\u6016\u6091\u6355\u6357\u6661\u6B65\u6B68\u6B69\u735B\u74FF\u7BF0\u7C3F\u8379\u8500\u8865\u88DC\u8AA7\u8E04\u8F50\u900B\u90E8\u90F6\u91AD\u9208\u923D\u949A\u94B8\u9914\u9922\u9CEA\u9D4F\u9E14",
            "Ca": "\u5693\u56C3\u64E6\u6503\u7924\u7938\u906A",
            "Cai": "\u4E72\u5038\u5072\u57F0\u5A47\u5BC0\u5F69\u621D\u624D\u63A1\u6750\u68CC\u731C\u776C\u7DB5\u7E29\u7E94\u83DC\u8521\u88C1\u8CA1\u8D22\u8DF4\u8E29\u91C7",
            "Can": "\u50AA\u510F\u53C2\u53C3\u53C4\u53C5\u55B0\u5646\u5B20\u60E8\u60ED\u6158\u6159\u615A\u61AF\u6701\u6B8B\u6B98\u6E4C\u6FAF\u707F\u71E6\u7218\u74A8\u7A47\u7CB2\u8592\u8695\u8745\u8836\u883A\u8B32\u98E1\u9910\u9A42\u9A96\u9EEA\u9EF2",
            "Cang": "\u4ED3\u4EFA\u5009\u5096\u51D4\u5328\u5D62\u6B0C\u6CA7\u6EC4\u6FF8\u734A\u7F49\u8231\u8259\u82CD\u84BC\u8535\u87A5\u8CF6\u9476\u9DAC\u9E27",
            "Cao": "\u5608\u5D86\u613A\u61C6\u64A1\u64CD\u66F9\u66FA\u69FD\u6F15\u7CD9\u808F\u825A\u8278\u8279\u8349\u84F8\u87AC\u893F\u8959\u9135\u93EA\u9A32\u9F1C",
            "Ce": "\u4FA7\u5074\u518A\u518C\u5395\u53A0\u5884\u5EC1\u607B\u60FB\u61A1\u62FA\u6547\u6D4B\u6E2C\u755F\u7B27\u7B56\u7B5E\u7B74\u7BA3\u7C0E\u7CA3\u835D\u8417\u8434\u84DB",
            "Ceng": "\u4E7D\u5C42\u5C64\u5CBE\u5D92\u7320\u785B\u7873\u7AF2\u8E6D\u9A53",
            "Cha": "\u4F98\u505B\u524E\u53C9\u55CF\u579E\u597C\u59F9\u5BDF\u5C94\u5D56\u6260\u6271\u62C6\u633F\u63D2\u63F7\u643D\u6748\u67E5\u67FB\u69CE\u6AAB\u6C4A\u7339\u7580\u78B4\u79C5\u7D01\u809E\u81FF\u8256\u8286\u832C\u8336\u8869\u8928\u8A0D\u8A67\u8A6B\u8BE7\u8E45\u91F5\u929F\u9364\u9388\u9454\u9497\u9538\u9572\u976B\u9937\u9987",
            "Chai": "\u4FAA\u5115\u52D1\u558D\u56C6\u67F4\u72B2\u7625\u7961\u831D\u867F\u8806\u8883\u8C7A",
            "Chan": "\u4E33\u4EA7\u50DD\u5103\u5133\u5181\u522C\u5257\u5277\u5296\u56B5\u56C5\u58E5\u5A75\u5B0B\u5D7C\u5DC9\u5E5D\u5E68\u5EDB\u5FCF\u61F4\u61FA\u63BA\u6400\u644C\u6472\u647B\u6519\u65F5\u68B4\u68CE\u6B03\u6BDA\u6D50\u6E79\u6EFB\u6F79\u6F7A\u700D\u703A\u705B\u7158\u71C0\u7351\u7522\u7523\u785F\u78DB\u79AA\u7C05\u7DFE\u7E5F\u7E75\u7E8F\u7E92\u7F20\u7FBC\u826C\u8487\u8546\u8749\u874A\u87EC\u87FE\u88E7\u895C\u8998\u89C7\u8A97\u8AC2\u8B42\u8B87\u8B92\u8C04\u8C17\u8E94\u8FBF\u913D\u9141\u91A6\u92CB\u92D3\u93DF\u9471\u94F2\u9561\u9575\u95B3\u95E1\u9610\u97C2\u986B\u995E\u998B",
            "Chang": "\u4EE7\u4F25\u5000\u5021\u507F\u50D8\u511F\u514F\u5382\u53B0\u5531\u5617\u5690\u573A\u5834\u5872\u5A3C\u5AE6\u5C1D\u5E38\u5EE0\u5F9C\u6005\u60B5\u60DD\u655E\u660C\u6636\u667F\u66A2\u6919\u6C05\u6DD0\u7316\u739A\u7429\u7452\u747A\u74FA\u751E\u7545\u757C\u80A0\u8178\u8193\u82CC\u83D6\u8407\u87D0\u88EE\u8AAF\u92F9\u92FF\u9329\u93DB\u9520\u9577\u9578\u957F\u95B6\u960A\u97D4\u9B2F\u9BE7\u9C68\u9CB3\u9CBF\u9F1A",
            "Chao": "\u4EE6\u4EEF\u5435\u5DD0\u5DE2\u5DE3\u5F28\u600A\u6284\u6641\u671D\u6A14\u6B29\u6F05\u6F6E\u7092\u712F\u717C\u724A\u7727\u7AB2\u7E5B\u7F7A\u8016\u89D8\u8A2C\u8B3F\u8D85\u8F48\u911B\u9214\u949E\u9EA8\u9F02\u9F0C",
            "Che": "\u4F21\u4FE5\u5056\u52F6\u5513\u577C\u5972\u5C6E\u5F7B\u5FB9\u626F\u63A3\u64A4\u64A6\u6F88\u70E2\u70F2\u7221\u77AE\u7817\u7868\u7869\u8045\u8397\u86FC\u8ECA\u8FE0\u9819",
            "Chen": "\u512D\u55D4\u56AB\u5875\u588B\u5926\u5BB8\u5C18\u5FF1\u6116\u62BB\u63E8\u6550\u6668\u66DF\u68FD\u6987\u6A04\u6AEC\u6C89\u70E5\u7141\u741B\u75A2\u760E\u778B\u7876\u789C\u78E3\u7A31\u7D9D\u81E3\u831E\u8380\u8390\u852F\u85BC\u87B4\u886C\u896F\u8A26\u8AC3\u8AF6\u8B13\u8B96\u8C0C\u8C36\u8CDD\u8D02\u8D81\u8D82\u8DBB\u8E38\u8ED9\u8FB0\u8FE7\u90F4\u9202\u95EF\u9648\u9673\u9703\u9DD0\u9E8E\u9F53\u9F54\u9F80",
            "Cheng": "\u4E1E\u4E57\u4FB1\u5041\u5448\u57CE\u57D5\u5818\u584D\u5856\u5A0D\u5BAC\u5CF8\u5EB1\u5F8E\u609C\u60E9\u6186\u6195\u61F2\u6210\u627F\u6330\u6381\u645A\u6490\u6491\u673E\u67A8\u67FD\u68D6\u68E6\u6909\u6A55\u6A59\u6A89\u6A99\u6CDF\u6D06\u6D7E\u6E97\u6F82\u7013\u722F\u725A\u73F5\u73F9\u7424\u757B\u7748\u77A0\u7880\u79E4\u7A0B\u7A6A\u7A9A\u7AC0\u7B6C\u7D7E\u7DFD\u8100\u812D\u837F\u8670\u86CF\u87F6\u88CE\u8AA0\u8BDA\u8D6A\u8D6C\u901E\u90D5\u9172\u92EE\u93F3\u93FF\u943A\u94D6\u9637\u9757\u9833\u9953\u9A01\u9A2C\u9A8B\u9BCE",
            "Chi": "\u4F88\u4F99\u4FFF\u50BA\u52C5\u5376\u53F1\u53FA\u5403\u544E\u54E7\u557B\u55AB\u55E4\u5644\u5758\u5791\u5880\u599B\u5AB8\u5C3A\u5CBB\u5F1B\u5F68\u5F72\u5F73\u605C\u6065\u6157\u618F\u61D8\u62B6\u62F8\u6301\u645B\u6521\u6555\u65A5\u6758\u6B3C\u6B6D\u6B6F\u6C60\u6CDC\u6DD4\u6E41\u6F26\u707B\u70BD\u70FE\u71BE\u74FB\u75D3\u75F4\u75F8\u761B\u7661\u7735\u779D\u7AFE\u7B1E\u7B42\u7BEA\u7C9A\u7CE6\u7D7A\u7FC4\u7FC5\u7FE4\u7FE8\u801B\u803B\u8094\u80E3\u80F5\u815F\u830C\u834E\u8687\u86A9\u86B3\u87AD\u88B2\u88B3\u88ED\u892B\u8A35\u8ABA\u8B18\u8C49\u8CBE\u8D64\u8D7F\u8D8D\u8DA9\u8DEE\u8E1F\u8FDF\u8FE3\u9045\u905F\u906B\u9072\u9253\u9279\u9290\u96F4\u98ED\u994E\u996C\u99B3\u9A70\u9B51\u9D1F\u9D44\u9D92\u9DD8\u9E31\u9EB6\u9ED0\u9F52\u9F5D\u9F7F",
            "Chong": "\u5145\u51B2\u5603\u57EB\u5BA0\u5BF5\u5D07\u5D08\u5FB8\u5FE1\u6183\u61A7\u63F0\u644F\u6C96\u6D7A\u6F34\u721E\u73EB\u7DDF\u7F7F\u7FC0\u8202\u825F\u833A\u866B\u8769\u87F2\u885D\u8908\u8E56\u9283\u94F3\u9680",
            "Chou": "\u4E11\u4E12\u4EC7\u4FB4\u4FE6\u5062\u5114\u541C\u5B26\u5E31\u5E6C\u60C6\u6101\u61E4\u62BD\u640A\u677D\u6826\u6906\u6BA0\u71FD\u72A8\u72AB\u7574\u7587\u7633\u7697\u7785\u77C1\u7A20\u7B79\u7BD8\u7C4C\u7D2C\u7D52\u7DA2\u7EF8\u81F0\u83D7\u85B5\u88EF\u8A76\u8B8E\u8B90\u8E0C\u8E8A\u905A\u9167\u916C\u919C\u91BB\u96D4\u96E0\u9B57",
            "Chu": "\u4E8D\u4FF6\u5097\u50A8\u510A\u5132\u51E6\u51FA\u520D\u521D\u53A8\u563C\u57F1\u5904\u5C80\u5E6E\u5EDA\u6035\u61B7\u61E8\u62C0\u640B\u6410\u6474\u654A\u65B6\u6775\u6918\u695A\u696E\u698B\u6A17\u6A71\u6A7B\u6A9A\u6AC9\u6AE5\u6B2A\u6B5C\u6EC0\u6EC1\u6FCB\u7293\u73FF\u7421\u74B4\u77D7\u7840\u790E\u7987\u7ACC\u7AD0\u7BE8\u7D40\u7ECC\u8021\u81C5\u82BB\u84A2\u84AD\u854F\u8655\u870D\u87F5\u891A\u89E6\u89F8\u8AD4\u8C56\u8C60\u8C99\u8D8E\u8E00\u8E70\u8E87\u8E95\u9110\u924F\u92E4\u9504\u95A6\u9664\u96CF\u96DB\u9DB5\u9EDC\u9F63\u9F6D\u9F7C",
            "Chuan": "\u4E32\u4F20\u50B3\u50E2\u5276\u5598\u570C\u5DDB\u5DDD\u66B7\u693D\u6B42\u6C1A\u6C4C\u732D\u7394\u744F\u7A7F\u7BC5\u821B\u8221\u8229\u8239\u8348\u8CD7\u8F32\u9044\u91E7\u948F\u9569\u9DA8",
            "Chuang": "\u50B8\u5205\u521B\u5231\u524F\u5259\u5275\u5647\u56F1\u5E8A\u6006\u6134\u6450\u6F3A\u7240\u724E\u7255\u75AE\u7621\u78E2\u7A93\u7A97\u7ABB\u95D6",
            "Chui": "\u5015\u5439\u5782\u57C0\u6376\u6425\u6858\u68F0\u69CC\u708A\u7BA0\u8144\u83D9\u9318\u939A\u9524\u9672\u9840\u9FA1",
            "Chun": "\u5046\u5507\u583E\u5A8B\u60F7\u65FE\u6625\u6699\u6776\u693F\u69C6\u6A41\u6AC4\u6D71\u6DF3\u6E7B\u6EE3\u6F18\u7289\u7443\u7776\u7BBA\u7D14\u7EAF\u8123\u83BC\u8405\u8436\u8493\u84F4\u877D\u8822\u8CF0\u8E33\u8F34\u9187\u9195\u931E\u9659\u9BD9\u9C06\u9D89\u9D9E\u9E51",
            "Chuo": "\u56BD\u5A15\u5A16\u60D9\u6233\u64C9\u6B60\u6DB0\u78ED\u7DBD\u814F\u8DA0\u8E14\u8F1F\u8F8D\u8FB5\u8FB6\u9034\u916B\u9461\u9F6A\u9F71\u9F8A",
            "Ci": "\u4F4C\u4F7D\u5068\u523A\u523E\u5472\u55ED\u5790\u5832\u5B28\u5E9B\u6148\u673F\u67CC\u6828\u6B21\u6B64\u6CDA\u6FE8\u73BC\u73C1\u74F7\u7506\u75B5\u7689\u78C1\u7920\u7960\u7CCD\u7D58\u7E12\u8308\u8326\u8328\u83BF\u858B\u86D3\u8786\u8800\u8A5E\u8BCD\u8CDC\u8D50\u8D80\u8DD0\u8F9D\u8F9E\u8FA4\u8FAD\u9236\u96CC\u98FA\u9908\u9AB4\u9D1C\u9DBF\u9DC0\u9E5A",
            "Cong": "\u4E1B\u4ECE\u5306\u53E2\u56EA\u5A43\u5B6E\u5F93\u5F96\u5F9E\u5FE9\u6031\u60A4\u60B0\u6152\u6181\u66B0\u68C7\u6964\u6A05\u6A2C\u6A37\u6B09\u6DD9\u6F0E\u6F17\u6F40\u6F48\u6F68\u7047\u7127\u719C\u721C\u742E\u747D\u7481\u779B\u7BF5\u7DEB\u7E71\u8061\u8066\u806A\u8070\u82C1\u8310\u8471\u84EF\u8525\u85C2\u87CC\u8AB4\u8B25\u8CE8\u8CE9\u93E6\u9A18\u9A44\u9AA2",
            "Cu": "\u4FC3\u5648\u5AA8\u5F82\u61B1\u6B82\u731D\u7604\u762F\u7C07\u7C97\u7E2C\u851F\u89D5\u8A8E\u8D97\u8E27\u8E59\u8E74\u8E75\u9162\u918B\u9863\u9E81\u9E84\u9EA4\u9F00",
            "Cuan": "\u5DD1\u64BA\u6505\u651B\u6AD5\u6B11\u6BA9\u6C46\u71B6\u7228\u7A73\u7A9C\u7AC4\u7BE1\u7BF9\u7C12\u8E7F\u8EA5\u9479",
            "Cui": "\u4E7C\u4F1C\u5005\u50AC\u51D7\u5550\u555B\u5894\u5D14\u5D89\u5FF0\u60B4\u615B\u6467\u69B1\u69EF\u6BF3\u6DEC\u6F3C\u7120\u7355\u7480\u75A9\u7601\u76A0\u78EA\u7AC1\u7CB9\u7D23\u7DB7\u7E17\u7F1E\u7FC6\u7FE0\u8103\u8106\u81AC\u81B5\u81CE\u8403\u894A\u8DA1\u93D9\u9847",
            "Cun": "\u520C\u540B\u58AB\u5B58\u5BF8\u5FD6\u62F5\u6751\u6F8A\u76B4\u7AF4\u7C7F\u8E06\u90A8",
            "Cuo": "\u5249\u5252\u539D\u590E\u5D6F\u5D73\u632B\u63AA\u6413\u68E4\u7473\u75E4\u7749\u77EC\u78CB\u811E\u839D\u83A1\u84AB\u84CC\u8516\u8658\u8E49\u902A\u9073\u919D\u92BC\u932F\u9509\u9519\u9ACA\u9E7A\u9E7E\u9F79",
            "Da": "\u4EA3\u5273\u5312\u547E\u5491\u54D2\u55D2\u5660\u57AF\u58B6\u59B2\u601B\u6253\u642D\u6498\u6A7D\u6E9A\u709F\u71F5\u7563\u7629\u7714\u7B2A\u7B54\u7E68\u7F8D\u8037\u8345\u8359\u8598\u87FD\u8921\u8A5A\u8DF6\u8E82\u8FBE\u8FCF\u8FD6\u9039\u9054\u9389\u939D\u943D\u977C\u9791\u97C3\u9F96\u9F98",
            "Dai": "\u4EE3\u4FA2\u50A3\u53C7\u5446\u5454\u5788\u57ED\u5CB1\u5E12\u5E26\u5E2F\u5E36\u5ED7\u5F85\u6020\u61DB\u6234\u66C3\u67CB\u6B79\u6B86\u6C4F\u703B\u7343\u73B3\u7447\u7519\u7C24\u7D3F\u7DFF\u7ED0\u825C\u86AE\u888B\u8976\u8CB8\u8D37\u8E5B\u8ED1\u8EDA\u8EE9\u8F6A\u8FE8\u902E\u9734\u9746\u9B98\u9D0F\u9EDB\u9EF1",
            "Dan": "\u4E39\u4EB6\u4F14\u4F46\u50E4\u510B\u5210\u52EF\u5330\u5358\u5556\u5557\u557F\u55AE\u563E\u5649\u56AA\u5989\u5A85\u5E0E\u5F39\u5F48\u60EE\u619A\u61BA\u62C5\u63B8\u64A3\u64D4\u65E6\u67E6\u6B9A\u6BAB\u6C2E\u6C8A\u6CF9\u6DE1\u6FB8\u6FB9\u72DA\u73AC\u74ED\u7514\u758D\u75B8\u7605\u7649\u765A\u7708\u7803\u79AB\u7A9E\u7BAA\u7C1E\u7D1E\u803C\u803D\u8043\u8078\u80C6\u8145\u81BD\u840F\u86CB\u8711\u8874\u891D\u894C\u89DB\u8A11\u8A95\u8BDE\u8D09\u8EAD\u90F8\u9132\u9156\u972E\u9815\u9924\u994F\u99BE\u99F3\u9AE7\u9D20\u9ED5",
            "Dang": "\u5105\u515A\u51FC\u5679\u5735\u57B1\u58CB\u5A78\u5B95\u5F53\u6321\u64CB\u6529\u6863\u6A94\u6B13\u6C39\u6F52\u6FA2\u7059\u73F0\u7497\u74AB\u74FD\u7576\u76EA\u778A\u7800\u78AD\u7911\u7B5C\u7C1C\u7C39\u8261\u8361\u83EA\u8569\u862F\u87F7\u88C6\u8960\u8B61\u8B9C\u8C20\u8DA4\u903F\u95E3\u96FC\u9EE8",
            "Dao": "\u5012\u5200\u5202\u5230\u5675\u58D4\u5BB2\u5BFC\u5C0E\u5C76\u5C9B\u5CF6\u5D8B\u5D8C\u5DB9\u5FC9\u60BC\u6363\u636F\u6417\u64E3\u6737\u6921\u69DD\u6AA4\u6C18\u7118\u71FE\u74D9\u76D7\u76DC\u7977\u7982\u79B1\u7A32\u7A3B\u7E9B\u7FE2\u7FFF\u8220\u83FF\u885C\u885F\u8E48\u8EC7\u9053\u91D6\u9666\u969D\u96AF\u9B5B\u9C7D",
            "De": "\u561A\u5FB3\u5FB7\u6074\u60B3\u60EA\u6DC2\u9340\u951D",
            "Deng": "\u50DC\u51F3\u5654\u58B1\u5B01\u5D9D\u6225\u6AC8\u706F\u71C8\u7492\u767B\u77AA\u78F4\u7AF3\u7B49\u7C26\u8260\u89B4\u8C4B\u8E6C\u9093\u9127\u9419\u956B\u96A5",
            "Di": "\u4EFE\u4F4E\u4FE4\u5059\u50C0\u538E\u5467\u5519\u5547\u5572\u5600\u5681\u5730\u5754\u577B\u57CA\u57DE\u5824\u5891\u58AC\u5943\u5A23\u5A82\u5AE1\u5DB3\u5E1D\u5E95\u5EF8\u5F1A\u5F1F\u5F24\u5F7D\u601F\u6178\u62B5\u62DE\u638B\u6455\u654C\u6575\u65F3\u6755\u67A4\u67E2\u688A\u6891\u68E3\u6C10\u6DA4\u6ECC\u6EF4\u710D\u7274\u72C4\u7393\u750B\u7731\u7747\u7825\u78B2\u78FE\u7976\u7998\u7B1B\u7B2C\u7BF4\u7C74\u7CF4\u7DE0\u7F14\u7F9D\u805C\u8091\u8163\u82D0\u82D6\u837B\u83C2\u83E7\u8482\u850B\u8510\u8515\u85E1\u8743\u87AE\u889B\u89BF\u89CC\u89DD\u8A46\u8AE6\u8BCB\u8C1B\u8C74\u8D86\u8E36\u8EE7\u8FEA\u9012\u9013\u905E\u9070\u90B8\u91F1\u926A\u9349\u93D1\u955D\u963A\u9684\u976E\u97AE\u9814\u99B0\u9AB6\u9AE2\u9B61\u9BF3\u9E10",
            "Dian": "\u4F43\u508E\u5178\u53A7\u5538\u576B\u57AB\u588A\u58C2\u594C\u5960\u5A5D\u5A70\u5D6E\u5DC5\u5DD3\u5DD4\u5E97\u60E6\u6242\u6382\u6527\u6541\u655F\u6923\u69D9\u6A42\u6BBF\u6DC0\u6EC7\u6FB1\u70B9\u73B7\u7414\u7535\u7538\u7628\u765C\u766B\u7672\u7898\u78F9\u7C1F\u84A7\u8547\u8714\u8E2E\u8E4E\u923F\u963D\u96FB\u975B\u985A\u985B\u98A0\u9A54\u9EDE\u9F7B",
            "Diao": "\u4F04\u51CB\u5201\u521F\u53FC\u540A\u595D\u5C4C\u5F14\u5F34\u5F6B\u625A\u6389\u6BA6\u6C48\u7431\u7639\u7797\u7889\u7A8E\u7AB5\u7AE8\u7C13\u84E7\u85CB\u866D\u86C1\u8A0B\u8ABF\u8C82\u91E3\u921F\u92B1\u92FD\u9443\u9493\u94DE\u96D5\u96FF\u9B89\u9BDB\u9CB7\u9CED\u9D70\u9F26",
            "Die": "\u53E0\u54CB\u5551\u558B\u56B8\u57A4\u581E\u5CCC\u5D7D\u5E49\u604E\u60F5\u621C\u6315\u63F2\u6633\u66E1\u66E2\u6B9C\u6C0E\u7239\u7243\u7252\u74DE\u7573\u7582\u7589\u758A\u7723\u7730\u789F\u7D70\u7ED6\u800A\u800B\u80C5\u81F7\u8253\u82F5\u8728\u8776\u890B\u893A\u8A44\u8ADC\u8C0D\u8D83\u8DCC\u8E40\u8FED\u957B\u9C08\u9CBD",
            "Ding": "\u4E01\u4EC3\u53EE\u5576\u5975\u5B9A\u5D7F\u5E04\u5FCA\u6917\u738E\u753C\u7594\u76EF\u77F4\u7887\u78A0\u78F8\u8035\u8062\u8063\u815A\u8423\u85A1\u8A02\u8BA2\u914A\u91D8\u9320\u9424\u9489\u952D\u976A\u9802\u9841\u9876\u98E3\u9964\u9F0E\u9F11",
            "Dong": "\u4E1C\u4F97\u5032\u50CD\u51AC\u51BB\u51CD\u52A8\u52D5\u549A\u578C\u57EC\u58A5\u59DB\u5A3B\u5B1E\u5CBD\u5CD2\u5CDD\u5D20\u5D2C\u606B\u61C2\u6219\u630F\u6638\u6771\u680B\u68DF\u6C21\u6C2D\u6D1E\u6DB7\u6E69\u7850\u7B17\u7BBD\u80E8\u80F4\u8156\u82F3\u83C4\u8463\u856B\u8740\u8A77\u8ACC\u8FF5\u9718\u99E7\u9B97\u9BDF\u9D87\u9DAB\u9E2B\u9F15",
            "Dou": "\u4E67\u515C\u5160\u5245\u543A\u5517\u6296\u6597\u65A3\u6793\u68AA\u6A77\u6BED\u6D62\u75D8\u7AA6\u7AC7\u7BFC\u8130\u8254\u8373\u8538\u86AA\u8C46\u9017\u90D6\u9158\u9204\u92C0\u94AD\u9597\u95D8\u9627\u9661\u9916\u997E\u9B25\u9B26\u9B2A\u9B2C\u9B2D",
            "Du": "\u51DF\u5262\u5335\u53BE\u561F\u5835\u5992\u59AC\u5B3B\u5E3E\u675C\u691F\u6ADD\u6BAC\u6BB0\u6BD2\u6D9C\u6E0E\u6E21\u7006\u724D\u7258\u728A\u72A2\u72EC\u7368\u743D\u74C4\u76BE\u7763\u7779\u79FA\u7B03\u7BE4\u809A\u828F\u8370\u8773\u8799\u8827\u8839\u88FB\u89A9\u8AAD\u8B80\u8B9F\u8BFB\u8C44\u8CED\u8D15\u8D4C\u918F\u9316\u934D\u945F\u9540\u95CD\u9607\u976F\u97C7\u97E3\u97E5\u9A33\u9AD1\u9EE9\u9EF7",
            "Duan": "\u5073\u5845\u5A8F\u65AD\u65B7\u6934\u6BB5\u6BC8\u7145\u7456\u77ED\u78AB\u7AEF\u7C16\u7C6A\u7DDE\u7F0E\u8011\u8176\u846E\u890D\u8E96\u935B\u9374\u953B",
            "Dui": "\u514A\u514C\u5151\u53FE\u5796\u5806\u5860\u5BF9\u5BFE\u5C0D\u5D5F\u603C\u619D\u61DF\u6FE7\u7029\u75FD\u7893\u78D3\u794B\u7D90\u85B1\u8B48\u8B75\u9413\u941C\u9566\u961F\u966E\u968A\u9827\u9D2D",
            "Dun": "\u4F05\u5428\u5678\u58A9\u58AA\u58FF\u5E89\u60C7\u619E\u6489\u64B4\u6566\u6A54\u6C8C\u6F61\u7096\u71C9\u729C\u7364\u76F9\u76FE\u7818\u78B7\u7905\u815E\u8733\u8DB8\u8E32\u8E72\u8E7E\u8E89\u9007\u9041\u906F\u920D\u949D\u9813\u987F\u9A50",
            "Duo": "\u4EB8\u4EDB\u51D9\u5234\u5241\u525F\u526B\u5484\u54C6\u54DA\u55A5\u5689\u56B2\u579B\u579C\u57F5\u5815\u58AE\u58AF\u591A\u591B\u593A\u596A\u5C2E\u5D1C\u5D9E\u60F0\u619C\u6305\u6306\u6387\u6553\u655A\u6560\u656A\u6735\u6736\u67EE\u6857\u692F\u6BF2\u6CB2\u75E5\u7D9E\u7F0D\u8235\u8324\u88F0\u8D93\u8DE2\u8DE5\u8DFA\u8E31\u8EB1\u8EB2\u8EC3\u922C\u9438\u94CE\u964A\u964F\u98FF\u9973\u9B0C\u9BB5\u9D7D",
            "E": "\u4FC4\u5054\u50EB\u530E\u537E\u5384\u542A\u5443\u545D\u54A2\u54B9\u5641\u5669\u56EE\u57A9\u580A\u582E\u59B8\u59BF\u59F6\u5A25\u5A3F\u5A40\u5C59\u5C75\u5C8B\u5CC9\u5CE8\u5CE9\u5D3F\u5EC5\u6076\u60AA\u60E1\u6115\u6239\u627C\u6424\u6439\u64DC\u6799\u6AEE\u6B5E\u6B7A\u6D90\u6E42\u73F4\u7427\u7692\u774B\u7808\u7810\u7828\u7846\u78C0\u816D\u82CA\u83AA\u843C\u855A\u8685\u86FE\u8741\u89A8\u8A1B\u8A7B\u8A90\u8AE4\u8B4C\u8B8D\u8BB9\u8C14\u8C5F\u8EDB\u8EF6\u8F6D\u8FD7\u904C\u904F\u907B\u9102\u920B\u92E8\u9354\u9469\u9507\u9537\u95BC\u960F\u9628\u9638\u981E\u981F\u984D\u984E\u989A\u989D\u9913\u9929\u997F\u9A00\u9B64\u9C10\u9C77\u9CC4\u9D48\u9D5D\u9D5E\u9D9A\u9E45\u9E57\u9F76",
            "En": "\u5940\u5CCE\u6069\u6441\u717E\u84BD",
            "Er": "\u4E7B\u4E8C\u4ED2\u4F74\u4F95\u513F\u5150\u5152\u5235\u54A1\u5532\u5C12\u5C13\u5C14\u5CCF\u5F0D\u5F10\u65D5\u682D\u682E\u6A32\u6BE6\u6D0F\u6D31\u723E\u73E5\u7CAB\u800C\u800F\u8033\u804F\u80F9\u834B\u85BE\u8848\u88BB\u8A80\u8CAE\u8CB3\u8D30\u8DB0\u8F00\u8F5C\u8FE9\u9087\u927A\u94D2\u9651\u96AD\u990C\u9975\u99EC\u9AF5\u9B9E\u9C95\u9D2F\u9E38",
            "Fa": "\u4E4F\u4F10\u4F71\u50A0\u53D1\u57A1\u59C2\u5F42\u6830\u6A43\u6CB7\u6CD5\u704B\u73D0\u743A\u75BA\u767A\u767C\u7782\u781D\u7B4F\u7F5A\u7F70\u7F78\u8337\u85C5\u9197\u9345\u95A5\u9600\u9AEA\u9AEE",
            "Fan": "\u4EEE\u51E1\u51E2\u51E3\u52EB\u5325\u53CD\u5643\u58A6\u597F\u5B0E\u5B0F\u5B14\u5E06\u5E61\u5FDB\u61A3\u6255\u65D9\u65DB\u674B\u67C9\u68B5\u68E5\u6A0A\u6A4E\u6C3E\u6C4E\u6CDB\u6EFC\u702A\u703F\u70E6\u7169\u71D4\u72AF\u72BF\u74A0\u7548\u756A\u76D5\u77FE\u792C\u7B32\u7B35\u7BC4\u7C53\u7C75\u7DD0\u7E41\u7E59\u7FB3\u7FFB\u81B0\u8224\u8227\u8303\u8543\u85A0\u85E9\u8629\u881C\u894E\u8A09\u8CA9\u8D29\u8E6F\u8ED3\u8EEC\u8F53\u8FBA\u8FD4\u91E9\u9407\u9492\u98BF\u98DC\u98EF\u98F0\u996D\u9C55\u9DED",
            "Fang": "\u4EFF\u5023\u531A\u574A\u57C5\u580F\u59A8\u5F77\u623F\u653E\u65B9\u65CA\u6609\u6618\u678B\u6DD3\u7265\u74EC\u7706\u7D21\u7EBA\u80AA\u822B\u82B3\u8684\u8A2A\u8BBF\u8DBD\u90A1\u9201\u933A\u94AB\u9632\u9AE3\u9B74\u9C82\u9D0B\u9DAD",
            "Fei": "\u4FF7\u5255\u532A\u539E\u5420\u5561\u595C\u5983\u5A53\u5A54\u5C5D\u5E9F\u5EC3\u5EE2\u60B1\u6249\u6590\u6632\u6683\u66CA\u670F\u676E\u68D0\u69A7\u6AE0\u6CB8\u6DDD\u6E04\u6FF7\u72D2\u7306\u75BF\u75F1\u7648\u7BDA\u7DCB\u7EEF\u7FE1\u80A5\u80BA\u80D0\u8153\u83F2\u8409\u855C\u855F\u871A\u8730\u87E6\u88F6\u8AB9\u8BFD\u8CBB\u8D39\u9428\u9544\u970F\u9745\u975E\u975F\u98DB\u98DD\u98DE\u9925\u99A1\u9A11\u9A1B\u9BE1\u9CB1\u9F23",
            "Fen": "\u4EFD\u507E\u50E8\u5206\u5429\u5746\u574B\u575F\u58B3\u594B\u596E\u59A2\u5C8E\u5E09\u5E69\u5F05\u5FFF\u6124\u61A4\u6610\u6706\u678C\u68A4\u68FB\u68FC\u6A68\u6C1B\u6C7E\u7035\u7083\u711A\u71CC\u71D3\u73A2\u7793\u79CE\u7AD5\u7C89\u7CAA\u7CDE\u7D1B\u7EB7\u7F92\u7FB5\u7FC2\u80A6\u81B9\u82AC\u84B6\u8561\u86A0\u86A1\u886F\u8A1C\u8C6E\u8C76\u8EAE\u8F52\u915A\u9216\u943C\u96AB\u96F0\u9934\u9959\u999A\u99A9\u9B75\u9C5D\u9CBC\u9CFB\u9EC2\u9EFA\u9F16\u9F22",
            "Feng": "\u4E30\u4EF9\u4FF8\u5051\u50FC\u51AF\u51E4\u51E8\u51EC\u51EE\u552A\u5838\u5906\u5949\u59A6\u5BF7\u5C01\u5CEF\u5CF0\u5D36\u6340\u6453\u67AB\u687B\u6953\u6A92\u6CA3\u6CA8\u6D72\u6E22\u6E57\u6E84\u7043\u70FD\u7128\u7148\u728E\u7326\u7412\u74F0\u752E\u75AF\u760B\u76FD\u781C\u78B8\u7BC8\u7D98\u7E2B\u7F1D\u8242\u8451\u8615\u8634\u8702\u8982\u8AF7\u8BBD\u8C50\u8CF5\u8D57\u9022\u9137\u9146\u92D2\u93BD\u93E0\u950B\u974A\u98A8\u98CC\u98CE\u99AE\u9CEF\u9CF3\u9D0C\u9EB7",
            "Fu": "\u4E40\u4ED8\u4F0F\u4F15\u4FCC\u4FD8\u4FEF\u5069\u5085\u51A8\u51B9\u51EB\u521C\u526F\u5310\u544B\u5452\u5488\u5490\u54F9\u577F\u5798\u590D\u592B\u5987\u598B\u59C7\u5A10\u5A4F\u5A66\u5A8D\u5B5A\u5B75\u5BCC\u5C03\u5CAA\u5CCA\u5DFF\u5E17\u5E45\u5E5E\u5E9C\u5F17\u5F23\u5F7F\u5FA9\u6024\u602B\u61EF\u6276\u629A\u62C2\u62CA\u636C\u64AB\u6577\u65A7\u65C9\u670D\u678E\u67B9\u67CE\u67EB\u683F\u6874\u68F4\u6928\u6931\u6991\u6C1F\u6CED\u6D11\u6D6E\u6DAA\u6ECF\u6F93\u70A5\u70F0\u7124\u7236\u7324\u739E\u73B8\u7408\u752B\u7536\u7549\u7550\u7557\u7641\u76D9\u7806\u7829\u7953\u7954\u798F\u79A3\u79FF\u7A03\u7A2A\u7ACE\u7B26\u7B30\u7B5F\u7B99\u7C20\u7CB0\u7CD0\u7D28\u7D31\u7D3C\u7D65\u7D8D\u7D92\u7DEE\u7E1B\u7EC2\u7ECB\u7F1A\u7F58\u7F66\u7FC7\u80A4\u80D5\u8150\u8151\u8179\u819A\u8240\u8274\u8299\u82A3\u82BE\u82FB\u8300\u832F\u8342\u8374\u83A9\u83D4\u842F\u844D\u8567\u8659\u86A5\u86A8\u86B9\u86D7\u8705\u8709\u875C\u8760\u876E\u886D\u889D\u88B1\u8907\u8914\u8946\u8965\u8984\u8986\u8A03\u8A42\u8AE8\u8BA3\u8C67\u8CA0\u8CE6\u8CFB\u8D1F\u8D4B\u8D59\u8D74\u8DBA\u8DD7\u8E3E\u8F14\u8F39\u8F3B\u8F85\u8F90\u909E\u90D9\u90DB\u911C\u915C\u91DC\u91E1\u9207\u9258\u925C\u9351\u9362\u961C\u961D\u9644\u965A\u97CD\u97E8\u98AB\u99A5\u99D9\u9A78\u9AF4\u9B34\u9B84\u9B92\u9BB2\u9C12\u9C8B\u9CC6\u9CE7\u9CEC\u9CFA\u9D14\u9D69\u9D9D\u9EA9\u9EAC\u9EB1\u9EB8\u9EFB\u9EFC",
            "Ga": "\u4F3D\u560E\u5620\u5676\u5C15\u5C1C\u5C2C\u65EE\u738D\u91D3\u9337\u9486\u9B40",
            "Gai": "\u4E10\u4E62\u4F85\u5303\u5304\u5793\u59DF\u5CD0\u5FCB\u6224\u6461\u6539\u6650\u675A\u6982\u69E9\u69EA\u6E89\u6F11\u74C2\u7561\u76D6\u7974\u7D60\u7D6F\u8344\u8462\u84CB\u8A72\u8BE5\u8C65\u8CC5\u8CCC\u8D45\u90C2\u9223\u9385\u9499\u9654\u9691",
            "Gan": "\u4E81\u4EE0\u501D\u51CE\u51F2\u5769\u5C32\u5C34\u5C36\u5C37\u5E72\u5E79\u5FD3\u611F\u64C0\u653C\u6562\u65F0\u6746\u67D1\u687F\u69A6\u6A44\u6A8A\u6C75\u6CD4\u6DE6\u6F27\u6F89\u7068\u7395\u7518\u75B3\u76AF\u76F0\u77F8\u79C6\u7A08\u7AFF\u7B34\u7B78\u7C33\u7C93\u7D3A\u7EC0\u809D\u8289\u82F7\u8866\u8A4C\u8D1B\u8D63\u8D76\u8D95\u8FC0\u9150\u9AAD\u9B50\u9C64\u9CE1\u9CF1",
            "Gang": "\u5188\u51AE\u521A\u525B\u5808\u583D\u5C97\u5CA1\u5D17\u6206\u6207\u6386\u6760\u68E1\u69D3\u6E2F\u7135\u7268\u7285\u7598\u77FC\u7B7B\u7DB1\u7EB2\u7F38\u7F41\u7F53\u7F61\u809B\u91ED\u92FC\u93A0\u94A2\u962C",
            "Gong": "\u4F9B\u515D\u5163\u516C\u5171\u529F\u5311\u5314\u53B7\u551D\u5868\u5BAB\u5BAE\u5DE5\u5DE9\u5E4A\u5EFE\u5F13\u606D\u6129\u6150\u62F1\u62F2\u653B\u675B\u6831\u6C5E\u7195\u73D9\u78BD\u7BE2\u7CFC\u7FBE\u80B1\u86A3\u89E5\u89F5\u8CA2\u8D11\u8D21\u8EAC\u8EB3\u8F01\u978F\u9AF8\u9F8F\u9F94\u9F9A",
            "Gao": "\u52C2\u543F\u544A\u5930\u5CFC\u641E\u66A0\u6772\u69C0\u69C1\u69D4\u69F9\u6A70\u6ABA\u6ADC\u6EDC\u7354\u768B\u7690\u776A\u777E\u796E\u7970\u799E\u7A01\u7A3E\u7A3F\u7B76\u7BD9\u7CD5\u7E1E\u7F1F\u7F94\u7F99\u818F\u81EF\u83D2\u85C1\u85F3\u8AA5\u8BF0\u90DC\u92EF\u93AC\u9506\u9550\u97DF\u993B\u9AD8\u9AD9\u9DCE\u9DF1\u9F1B",
            "Ge": "\u4E2A\u4F6E\u500B\u5272\u530C\u5404\u5444\u54E5\u54FF\u55DD\u572A\u5865\u5F41\u6105\u6208\u6213\u6228\u630C\u6401\u643F\u64F1\u654B\u683C\u69C5\u6ACA\u6B4C\u6EC6\u6ED2\u726B\u7271\u72B5\u7366\u7599\u784C\u7B87\u7D07\u7EA5\u8090\u80F3\u8188\u81F5\u8238\u8316\u845B\u867C\u86D2\u86E4\u88BC\u88D3\u89E1\u8AFD\u8B0C\u8F35\u8F55\u927B\u9398\u93B6\u94EC\u9549\u95A3\u95A4\u9601\u9694\u9788\u97B7\u97D0\u97DA\u9A14\u9ABC\u9B32\u9BAF\u9C2A\u9D10\u9D1A\u9D3F\u9E3D",
            "Gei": "\u7D66",
            "Gen": "\u4E98\u54CF\u63EF\u6404\u6839\u826E\u831B\u8DDF",
            "Geng": "\u4E99\u522F\u54FD\u5579\u55BC\u55F0\u57C2\u5829\u5CFA\u5E9A\u632D\u63B6\u66F4\u6897\u6929\u6D6D\u713F\u754A\u7D5A\u7D86\u7DEA\u7E06\u7EE0\u7FAE\u7FB9\u8015\u803F\u8384\u83EE\u8CE1\u8D53\u90E0\u9ABE\u9BC1\u9CA0\u9D8A\u9E52",
            "Gou": "\u4F5D\u5193\u52FE\u5778\u57A2\u591F\u5920\u59E4\u5ABE\u5CA3\u5F40\u6406\u6480\u6784\u69CB\u6C9F\u6E9D\u7179\u72D7\u73BD\u7B31\u7BDD\u7C3C\u7DF1\u7F11\u8007\u8008\u8009\u82DF\u8329\u86BC\u88A7\u8920\u89AF\u89CF\u8A3D\u8A6C\u8BDF\u8C7F\u8CFC\u8D2D\u9058\u920E\u9264\u94A9\u96CA\u97B2\u97DD",
            "Gu": "\u4F30\u50A6\u50F1\u51C5\u53E4\u5495\u5502\u5503\u5552\u560F\u56FA\u580C\u5903\u59D1\u5AF4\u5B64\u5C33\u5CE0\u5D13\u5D2E\u6018\u6132\u6262\u6545\u67E7\u688F\u68DD\u6996\u69BE\u6A6D\u6BC2\u6C69\u6CBD\u6CD2\u6DC8\u6FF2\u7014\u7138\u726F\u727F\u75FC\u76B7\u76EC\u77BD\u7872\u797B\u7A12\u7A40\u7B1F\u7B8D\u7B9B\u7BD0\u7CD3\u7E0E\u7F5B\u7F5F\u7F96\u80A1\u8135\u81CC\u83C7\u83F0\u84C7\u85A3\u86C4\u86CA\u86CC\u8831\u89DA\u8A41\u8BC2\u8C37\u8EF1\u8EF2\u8F42\u8F71\u8F9C\u9027\u9164\u9232\u9237\u932E\u94B4\u9522\u96C7\u980B\u9867\u987E\u9936\u9989\u9AA8\u9B95\u9BDD\u9CB4\u9D23\u9D60\u9DBB\u9E2A\u9E58\u9F13\u9F14",
            "Gua": "\u518E\u522E\u5250\u526E\u5280\u5366\u53E7\u5569\u576C\u5BE1\u6302\u639B\u6B44\u713B\u7171\u74DC\u7D53\u7DFA\u7F63\u7F6B\u80CD\u82FD\u8902\u8A7F\u8BD6\u8D8F\u92BD\u98AA\u98B3\u9A27\u9D30\u9E39",
            "Guai": "\u4E56\u53CF\u592C\u602A\u6060\u62D0\u67B4\u67FA\u7B89",
            "Guan": "\u4E31\u500C\u5173\u51A0\u535D\u5B98\u60B9\u60BA\u60EF\u6163\u63BC\u645C\u68FA\u6A0C\u6BCC\u6CF4\u6DAB\u6F45\u704C\u721F\u742F\u74D8\u75EF\u761D\u764F\u76E5\u77D4\u7936\u797C\u7AA4\u7B66\u7BA1\u7F46\u7F50\u8218\u8416\u8484\u898C\u89B3\u89C0\u89C2\u8CAB\u8D2F\u8E80\u8F28\u9066\u9327\u93C6\u9475\u95A2\u95D7\u95DC\u96DA\u9928\u9986\u9C25\u9C5E\u9C79\u9CCF\u9CE4\u9E1B\u9E73",
            "Guang": "\u4F8A\u4FC7\u50D9\u5149\u54A3\u5799\u59EF\u5E7F\u5E83\u5EE3\u6497\u6844\u6B1F\u6D38\u706E\u7097\u709A\u709B\u70E1\u72B7\u7377\u73D6\u7844\u80F1\u81E6\u81E9\u832A\u8F04\u901B\u92A7\u9EC6",
            "Gui": "\u4E80\u4F79\u523D\u523F\u528A\u528C\u5326\u532D\u53AC\u572D\u579D\u59AB\u59FD\u5AAF\u5AE2\u5B00\u5B84\u5DB2\u5DC2\u5E30\u5E8B\u5EAA\u5F52\u6051\u646B\u648C\u6530\u6531\u660B\u6677\u67DC\u6842\u691D\u6922\u69F6\u69FB\u69FC\u6AC3\u6AF7\u6B78\u6C3F\u6E40\u6E8E\u7085\u73EA\u7470\u749D\u74CC\u7678\u7688\u7786\u77A1\u77B6\u7845\u796A\u79AC\u7A90\u7B40\u7C02\u7C0B\u80FF\u81AD\u8325\u84D5\u86EB\u87E1\u88BF\u8958\u898F\u89C4\u89E4\u8A6D\u8BE1\u8CB4\u8D35\u8DEA\u8ECC\u8F68\u90BD\u90CC\u95A8\u95FA\u9652\u97BC\u9A29\u9B36\u9B39\u9B3C\u9BAD\u9C56\u9C65\u9C91\u9CDC\u9F9C",
            "Gun": "\u4E28\u60C3\u68CD\u68DE\u6EDA\u6EFE\u74AD\u7754\u7774\u78D9\u7DC4\u7DF7\u7EF2\u84D8\u8509\u886E\u889E\u88F7\u8B34\u8F25\u8F8A\u9B8C\u9BC0\u9CA7",
            "Guo": "\u5459\u54BC\u556F\u5613\u56EF\u56F6\u56FB\u56FD\u5700\u570B\u57DA\u581D\u588E\u5D1E\u5E3C\u5E57\u5F49\u5F4D\u60C8\u6156\u63B4\u6451\u679C\u6901\u6947\u69E8\u6DC9\u6F0D\u6FC4\u7313\u7611\u7CBF\u7DB6\u8052\u805D\u8142\u8158\u8195\u83D3\u852E\u8662\u873E\u8748\u87C8\u88F9\u8901\u8F20\u8FC7\u904E\u90ED\u921B\u934B\u9439\u9505\u991C\u9983\u9998",
            "Ha": "\u4E37\u54C8\u598E\u927F\u94EA",
            "Hai": "\u4E64\u4EA5\u548D\u55D0\u55E8\u56A1\u5870\u5B69\u5BB3\u6C26\u6D77\u70F8\u80F2\u917C\u91A2\u9900\u995A\u99ED\u99F4\u9A87\u9AB8",
            "Han": "\u4F44\u50BC\u516F\u51FD\u51FE\u5388\u542B\u5481\u54FB\u5505\u558A\u5705\u57BE\u5A22\u5AE8\u5BD2\u5C7D\u5D21\u5D45\u608D\u61A8\u61BE\u625E\u634D\u6496\u64BC\u65F1\u6657\u6658\u6665\u66B5\u6892\u6C49\u6C57\u6D5B\u6D6B\u6D86\u6DB5\u6DCA\u6F22\u6F8F\u701A\u710A\u7113\u71AF\u7233\u7302\u7400\u751D\u7694\u7745\u7B68\u7F55\u7FF0\u80A3\u839F\u83E1\u850A\u862B\u8677\u86B6\u86FF\u872C\u872D\u8792\u8B40\u8C3D\u8C43\u9097\u90AF\u9163\u91EC\u92B2\u92CE\u92E1\u9588\u95EC\u96D7\u97D3\u97E9\u9807\u9837\u9844\u9878\u9894\u99A0\u99AF\u99FB\u9B2B\u9B7D\u9DBE\u9F3E",
            "Hen": "\u4F77\u5F88\u6068\u62EB\u72E0\u75D5\u8A6A\u978E",
            "Hang": "\u57B3\u592F\u5994\u65BB\u676D\u6C86\u7B10\u7B55\u7D4E\u7ED7\u822A\u82C0\u86A2\u8CA5\u8FD2\u980F\u9883\u9B67",
            "Hao": "\u5090\u512B\u515E\u53F7\u54E0\u55E5\u5637\u5651\u5686\u568E\u58D5\u597D\u604F\u608E\u660A\u6626\u6667\u66A4\u66AD\u66CD\u6903\u6BEB\u6D69\u6DCF\u6EC8\u6F94\u6FE0\u704F\u705D\u7346\u734B\u7693\u769C\u769E\u76A1\u76A5\u79CF\u7AD3\u7C47\u8017\u8055\u8320\u84BF\u8583\u8585\u85A7\u865F\u869D\u8814\u8B79\u8C6A\u90DD\u9865\u98A2\u9C1D",
            "He": "\u4F55\u4F6B\u52BE\u5408\u5475\u548A\u54EC\u555D\u559D\u55C3\u55EC\u578E\u58D1\u59C0\u5BC9\u5CC6\u60D2\u62B2\u6546\u66F7\u67C7\u6838\u6941\u6B31\u6BFC\u6CB3\u6DB8\u6E2E\u6E7C\u6F95\u7103\u7142\u7186\u7187\u71FA\u7200\u72E2\u764B\u76AC\u76C7\u76C9\u76CD\u76D2\u788B\u7909\u79BE\u79F4\u7BD5\u7C7A\u7CAD\u7FEE\u7FEF\u8377\u83CF\u8402\u86B5\u879B\u881A\u8894\u8910\u8988\u8A36\u8A38\u8A65\u8BC3\u8C88\u8CC0\u8D3A\u8D6B\u90C3\u924C\u9449\u95A1\u95D4\u9602\u9616\u96BA\u974D\u974E\u974F\u97A8\u981C\u988C\u9978\u9B7A\u9C84\u9DA1\u9DB4\u9E16\u9E56\u9E64\u9EA7\u9F43\u9F55\u9F81\u9FA2",
            "Hei": "\u563F\u5B12\u6F76\u9ED1\u9ED2",
            "Heng": "\u4EA8\u54FC\u5548\u56CD\u583C\u59EE\u6046\u6052\u6099\u6841\u6A2A\u6A6B\u6DA5\u70C6\u73E9\u80FB\u811D\u8605\u8861\u9445\u9D34\u9D46\u9E3B",
            "Hong": "\u4EDC\u53FF\u5430\u54C4\u55CA\u569D\u57AC\u5985\u5A02\u5B8F\u5B96\u5F18\u5F4B\u63C8\u6494\u664E\u6C6F\u6CD3\u6D2A\u6D64\u6E31\u6E39\u6F42\u6F8B\u6F92\u7074\u70D8\u7122\u7392\u739C\u7854\u7861\u7AD1\u7AE4\u7BCA\u7CA0\u7D05\u7D18\u7D2D\u7D8B\u7EAE\u7FC3\u7FDD\u803E\u82F0\u836D\u8452\u8453\u857B\u85A8\u8679\u8A07\u8A0C\u8BA7\u8C39\u8C3C\u8C3E\u8EE3\u8F37\u8F5F\u8F70\u921C\u9277\u92BE\u92D0\u9367\u958E\u95A7\u95C0\u95C2\u95F3\u9710\u971F\u9783\u9B28\u9B5F\u9D3B\u9E3F\u9EC9\u9ECC",
            "Hou": "\u4FAF\u5019\u539A\u540E\u543C\u543D\u5589\u5795\u5820\u5E3F\u5F8C\u6D09\u72BC\u7334\u760A\u777A\u77E6\u7BCC\u7CC7\u7FED\u8454\u8C5E\u9005\u90C8\u9107\u9297\u936D\u9931\u9ABA\u9B9C\u9BF8\u9C5F\u9C8E\u9C98\u9F41",
            "Hu": "\u4E4E\u4E55\u4E92\u51B1\u51B4\u5322\u532B\u547C\u552C\u553F\u5596\u5611\u561D\u569B\u56EB\u5780\u58F6\u58F7\u58FA\u5A5F\u5AA9\u5AED\u5AEE\u5BE3\u5CB5\u5E0D\u5E60\u5F16\u5F27\u5FFD\u6019\u6057\u60DA\u6236\u6237\u6238\u623D\u6248\u6287\u62A4\u6430\u6462\u659B\u6608\u6612\u66F6\u6791\u695C\u69F2\u69F4\u6B51\u6C7B\u6C8D\u6CAA\u6CD8\u6D52\u6DF4\u6E56\u6EEC\u6EF8\u6EF9\u702B\u70C0\u7100\u7173\u71A9\u72D0\u7322\u7425\u745A\u74E0\u74F3\u795C\u7B0F\u7B8E\u7BB6\u7C04\u7C90\u7CCA\u7D57\u7D94\u7E20\u80E1\u81B4\u8290\u82F8\u8400\u846B\u851B\u8530\u864D\u864E\u8656\u865D\u8774\u879C\u885A\u89F3\u8B3C\u8B77\u8EE4\u8F77\u9120\u9190\u933F\u9359\u9378\u96D0\u96FD\u97C4\u9800\u9836\u992C\u9B0D\u9B71\u9BF1\u9C17\u9C6F\u9CE0\u9CF8\u9D98\u9DA6\u9DAE\u9E0C\u9E55\u9E71",
            "Hua": "\u5212\u5283\u5316\u534E\u54D7\u5629\u57D6\u59E1\u5A72\u5A73\u5AFF\u5B05\u5D0B\u6466\u64B6\u6779\u6866\u691B\u69EC\u6A3A\u6ED1\u6F85\u733E\u748D\u753B\u756B\u7575\u7874\u78C6\u7CC0\u7E63\u8219\u82B1\u82B2\u83EF\u8550\u8624\u8633\u8796\u89DF\u8A71\u8AAE\u8AD9\u8AE3\u8B41\u8BDD\u92D8\u9335\u93F5\u94E7\u9A4A\u9A85\u9DE8\u9ECA",
            "Huai": "\u54B6\u574F\u58CA\u58DE\u5F8A\u6000\u61D0\u61F7\u69D0\u6AF0\u6DEE\u7024\u8032\u8639\u863E\u8922\u8931\u8E1D",
            "Huan": "\u5524\u559A\u559B\u56BE\u581A\u5942\u5950\u5BA6\u5BCF\u5BF0\u5CD8\u5D48\u5E7B\u60A3\u610C\u61C1\u61FD\u6362\u63DB\u64D0\u650C\u6853\u6899\u69F5\u6B22\u6B25\u6B53\u6B61\u6D39\u6D63\u6DA3\u6E19\u6F36\u6FA3\u6FB4\u70C9\u7115\u7165\u72DF\u737E\u73AF\u744D\u74B0\u74DB\u75EA\u7613\u7746\u77A3\u7CEB\u7D59\u7D84\u7DE9\u7E6F\u7F13\u7F33\u7FA6\u8092\u8341\u8408\u8411\u85E7\u8B99\u8C62\u8C72\u8C86\u8C9B\u8F10\u8F58\u8FD8\u902D\u9084\u90C7\u9144\u9370\u9436\u953E\u956E\u95E4\u961B\u96C8\u9A69\u9B1F\u9BC7\u9BF6\u9C00\u9CA9\u9D05\u9D4D\u9E6E",
            "Huang": "\u505F\u5164\u51F0\u55A4\u582D\u5843\u58B4\u595B\u5A93\u5BBA\u5D32\u5DDF\u5E4C\u5FA8\u6033\u604D\u60F6\u6130\u614C\u63D8\u6643\u6644\u66C2\u671A\u697B\u69A5\u6ACE\u6E5F\u6EC9\u6F62\u70BE\u714C\u7180\u71BF\u735A\u745D\u749C\u7640\u7687\u769D\u76A9\u78FA\u7A54\u7BC1\u7C27\u7E28\u8093\u824E\u8352\u845F\u8757\u87E5\u8841\u8A64\u8AFB\u8B0A\u8C0E\u8DAA\u9051\u9360\u93A4\u9404\u953D\u968D\u97F9\u992D\u9A1C\u9C09\u9C51\u9CC7\u9DEC\u9EC3\u9EC4",
            "Hui": "\u4F6A\u50E1\u5136\u532F\u5349\u54B4\u54D5\u5599\u5612\u5645\u5655\u5666\u5696\u56D8\u56DE\u56EC\u571A\u5A4E\u5A88\u5B48\u5BED\u5C77\u5E51\u5EFB\u5EFD\u5F57\u5F59\u5F5A\u5FBB\u5FBD\u605A\u605B\u6062\u6075\u6094\u60E0\u6167\u6193\u61F3\u62FB\u6325\u63EE\u649D\u6656\u6666\u6689\u66B3\u6703\u694E\u69E5\u6A5E\u6A85\u6A93\u6A9C\u6AD8\u6BC0\u6BC1\u6BC7\u6C47\u6CCB\u6D03\u6D04\u6D4D\u6E4F\u6ED9\u6F53\u6FAE\u7008\u7070\u7073\u70E0\u70E3\u70E9\u70EA\u7147\u71EC\u71F4\u7369\u73F2\u743F\u74A4\u74AF\u75D0\u7623\u7773\u77BA\u7988\u79FD\u7A62\u7BF2\u7D75\u7E62\u7E6A\u7ED8\u7F0B\u7FD9\u7FDA\u7FEC\u7FFD\u8294\u8334\u835F\u8527\u8559\u8588\u8589\u85F1\u867A\u8698\u86D4\u86D5\u8716\u879D\u87EA\u8886\u8918\u8A6F\u8A7C\u8AA8\u8AF1\u8B53\u8B6D\u8B6E\u8B7F\u8BB3\u8BD9\u8BF2\u8C57\u8CC4\u8D3F\u8F1D\u8F89\u8FF4\u9025\u93F8\u942C\u95E0\u9613\u9693\u96B3\u9767\u97E2\u982E\u986A\u992F\u9BB0\u9C34\u9EBE",
            "Hun": "\u4FD2\u5031\u5702\u5A5A\u5FF6\u60DB\u60FD\u6141\u638D\u660F\u662C\u68D4\u6B99\u6D51\u6DBD\u6DF7\u6E3E\u6EB7\u711D\u7767\u776F\u7E49\u8364\u8477\u89E8\u8AE2\u8BE8\u8F4B\u95BD\u960D\u991B\u9984\u9B42\u9F32",
            "Huo": "\u4F19\u4F78\u4FF0\u5268\u5290\u5419\u549F\u55C0\u5684\u56AF\u56BF\u5925\u593B\u596F\u60D1\u6216\u6347\u639D\u64ED\u6509\u65E4\u66E4\u6AB4\u6C8E\u6D3B\u6E71\u6F37\u6FE9\u7016\u706B\u7372\u7668\u7713\u77C6\u77D0\u7978\u798D\u79EE\u79F3\u7A6B\u8020\u802F\u81DB\u8267\u83B7\u84A6\u85FF\u8816\u8B0B\u8C41\u8CA8\u8D27\u90A9\u9225\u9343\u944A\u94AC\u952A\u956C\u9584\u96D8\u970D\u9743\u9A1E",
            "Ji": "\u4E0C\u4E2E\u4E69\u4EBC\u4F0B\u4F0E\u4F76\u506E\u50DF\u517E\u5180\u51E0\u51FB\u5209\u520F\u5242\u525E\u5264\u5291\u52E3\u5359\u5373\u537D\u53CA\u53DD\u53FD\u5409\u54AD\u54DC\u5527\u559E\u55D8\u5630\u568C\u573E\u5756\u578D\u57FA\u5849\u588D\u58BC\u5980\u5993\u59DE\u59EC\u5AC9\u5B63\u5BC2\u5BC4\u5C50\u5C8C\u5CDC\u5D46\u5D47\u5D74\u5DAF\u5DF1\u5E7E\u5EB4\u5EED\u5F50\u5F51\u5F76\u5F9B\u5FCC\u5FE3\u6025\u60B8\u60CE\u6131\u61BF\u61FB\u621F\u6222\u6280\u6324\u638E\u63E4\u6483\u64A0\u64CA\u64E0\u6532\u6567\u65E1\u65E2\u65E3\u66A8\u66A9\u66C1\u673A\u6781\u6785\u689E\u68D8\u6956\u696B\u6975\u69C9\u69E3\u6A2D\u6A5F\u6A76\u6A95\u6A9D\u6AB5\u6AC5\u6B9B\u6BC4\u6C72\u6CF2\u6D0E\u6D4E\u6E08\u6E52\u6F03\u6F08\u6F57\u6FC0\u6FC8\u6FDF\u7031\u710F\u7284\u72B1\u72E4\u7391\u74A3\u74BE\u7578\u757F\u75BE\u75F5\u7620\u7660\u766A\u768D\u77F6\u78EF\u796D\u799D\u79A8\u79EF\u7A18\u7A29\u7A37\u7A44\u7A4A\u7A4D\u7A56\u7A67\u7B04\u7B08\u7B53\u7B95\u7BBF\u7C0A\u7C4D\u7CED\u7D00\u7D12\u7D1A\u7D99\u7DDD\u7E18\u7E3E\u7E4B\u7E6B\u7E7C\u7EA7\u7EAA\u7EE7\u7EE9\u7F7D\u7F81\u7F87\u7F88\u8024\u802D\u808C\u810A\u8128\u818C\u81EE\u8265\u82A8\u82B0\u82B6\u830D\u8415\u846A\u84BA\u84DF\u8507\u8540\u857A\u858A\u860E\u862E\u863B\u8640\u866E\u874D\u878F\u87E3\u88DA\u8940\u894B\u8989\u898A\u89AC\u89CA\u89D9\u89ED\u8A08\u8A18\u8A8B\u8AC5\u8B4F\u8B64\u8BA1\u8BA5\u8BB0\u8C3B\u8CEB\u8CF7\u8D4D\u8D8C\u8DE1\u8DFB\u8DFD\u8E16\u8E50\u8E5F\u8E8B\u8EA4\u8EB8\u8F2F\u8F5A\u8F91\u8FF9\u90C6\u913F\u9288\u92A1\u9324\u9353\u93F6\u9416\u9447\u9459\u9645\u969B\u96AE\u96C6\u96DE\u96E6\u96E7\u9701\u9735\u973D\u978A\u97BF\u97F2\u98E2\u9951\u9965\u9A65\u9AA5\u9AFB\u9B62\u9B86\u9BDA\u9BFD\u9C36\u9C3F\u9C40\u9C6D\u9C7E\u9C9A\u9CAB\u9CEE\u9D4B\u9D8F\u9DBA\u9DC4\u9DD1\u9E04\u9E21\u9E61\u9E82\u9F4C\u9F4E\u9F4F\u9F51",
            "Jia": "\u4EF7\u4F73\u5047\u50A2\u50F9\u52A0\u53DA\u550A\u55E7\u5609\u573F\u57C9\u5939\u593E\u5A7D\u5AC1\u5B8A\u5BB6\u5CAC\u5E4F\u5FA6\u605D\u621B\u621E\u6274\u62B8\u62C1\u659A\u659D\u67B6\u67B7\u689C\u6935\u698E\u69A2\u69DA\u6A9F\u6BE0\u6CC7\u6D43\u6D79\u728C\u7333\u73BE\u73C8\u7532\u75C2\u7615\u7A3C\u7B33\u7CD8\u801E\u80DB\u8125\u8175\u835A\u83A2\u846D\u86F1\u86FA\u8888\u88B7\u88CC\u8C6D\u8C91\u8CC8\u8D3E\u8DCF\u8DF2\u8FE6\u90CF\u90DF\u9240\u926B\u92CF\u93B5\u94BE\u94D7\u9553\u982C\u9830\u988A\u9904\u99D5\u9A7E\u9D36\u9D4A\u9E9A",
            "Jian": "\u4EF6\u4F9F\u4FED\u4FF4\u5039\u5065\u50ED\u5109\u517C\u51BF\u51CF\u5251\u5263\u526A\u5271\u528D\u528E\u5292\u5294\u56CF\u56DD\u575A\u5805\u58B9\u5978\u59E6\u59E7\u5BCB\u5C16\u5E34\u5E75\u5EFA\u5F3F\u5F45\u5FA4\u60E4\u620B\u6214\u6229\u622C\u62E3\u6338\u6361\u63C0\u63C3\u641B\u64BF\u64F6\u65D4\u6695\u67A7\u67EC\u682B\u6898\u68C0\u691C\u6937\u693E\u6957\u6997\u69DB\u6A2B\u6A7A\u6AA2\u6ABB\u6AFC\u6B7C\u6BB1\u6BB2\u6BFD\u6D0A\u6DA7\u6E10\u6E1B\u6E54\u6E55\u6E85\u6F38\u6F97\u6FFA\u7010\u7033\u7038\u703D\u714E\u719E\u71B8\u724B\u726E\u728D\u730F\u73AA\u73D4\u744A\u7450\u76D1\u76E3\u7751\u7777\u77AF\u77B7\u77BC\u7877\u788A\u78B1\u78F5\u7900\u7906\u791B\u7B15\u7B3A\u7B67\u7B80\u7B8B\u7BAD\u7BEF\u7C21\u7C5B\u7CCB\u7D78\u7DD8\u7E11\u7E5D\u7E6D\u7F04\u7F23\u7FE6\u807B\u80A9\u8171\u81F6\u8230\u8266\u8270\u8271\u8327\u8350\u83C5\u83FA\u844C\u844F\u8465\u84B9\u8551\u8573\u85A6\u85C6\u8643\u87B9\u8812\u88B8\u88E5\u8947\u8949\u897A\u898B\u89B5\u89B8\u89C1\u8A43\u8AD3\u8AEB\u8B07\u8B2D\u8B7C\u8B7E\u8C0F\u8C2B\u8C5C\u8C63\u8CCE\u8CE4\u8D31\u8D9D\u8DBC\u8DC8\u8DF5\u8E10\u8E3A\u8E47\u8F5E\u91FC\u9274\u92FB\u9373\u9375\u93E9\u9417\u9427\u9451\u9452\u946C\u946F\u9473\u950F\u952E\u9592\u9593\u95F4\u976C\u97AC\u97AF\u97C0\u97C9\u991E\u9930\u996F\u99A2\u9B0B\u9C0E\u9C14\u9C1C\u9C39\u9CA3\u9CD2\u9CFD\u9D73\u9DBC\u9E63\u9E78\u9E7B\u9E7C\u9E89",
            "Jiang": "\u508B\u50F5\u52E5\u531E\u5320\u58C3\u5905\u5956\u5968\u596C\u59DC\u5C06\u5C07\u5D79\u5F1C\u5F36\u5F4A\u646A\u647E\u6762\u6868\u69F3\u6A7F\u6AE4\u6BAD\u6C5F\u6D1A\u6D46\u6EF0\u6F3F\u729F\u734E\u7555\u757A\u7585\u7586\u7913\u7CE1\u7CE8\u7D73\u7E6E\u7EDB\u7F30\u7FDE\u8029\u8199\u8333\u8441\u848B\u8523\u8591\u8780\u87BF\u88B6\u8B1B\u8B3D\u8BB2\u8C47\u9171\u91A4\u91AC\u964D\u97C1\u985C\u9C42\u9CC9",
            "Jiao": "\u4EA4\u4F7C\u50E5\u50EC\u510C\u528B\u52E6\u53EB\u544C\u5602\u5604\u5626\u564D\u566D\u59E3\u5A07\u5B0C\u5B13\u5B42\u5CE4\u5CE7\u5D95\u5DA0\u5DA3\u5FBC\u618D\u630D\u6322\u6341\u6405\u6477\u649F\u64B9\u652A\u654E\u6559\u656B\u657D\u657F\u65A0\u6648\u669E\u66D2\u6912\u6AF5\u6D47\u6E6B\u6E6C\u6ED8\u6F16\u6F50\u6F86\u705A\u70C4\u7126\u7133\u714D\u71CB\u72E1\u7365\u73D3\u74AC\u768E\u76A6\u76AD\u77EB\u77EF\u7901\u7A5A\u7A8C\u7A96\u7B05\u7B4A\u7C25\u7D5E\u7E73\u7E90\u7EDE\u7F34\u80F6\u8173\u81A0\u81B2\u81EB\u827D\u8281\u832D\u832E\u8549\u85E0\u8660\u86DF\u87DC\u87ED\u8A06\u8B51\u8B65\u8CCB\u8DAD\u8DE4\u8E0B\u8F03\u8F47\u8F4E\u8F7F\u8F83\u90CA\u9175\u91AE\u91C2\u9278\u940E\u94F0\u9903\u997A\u9A55\u9A84\u9BAB\u9C4E\u9C9B\u9D41\u9D64\u9DE6\u9DEE\u9E6A",
            "Jie": "\u4E2F\u4ECB\u501F\u5022\u507C\u5091\u5226\u5227\u523C\u52AB\u52BC\u5369\u536A\u5424\u5588\u55DF\u5826\u583A\u5979\u59D0\u5A55\u5A8E\u5A98\u5AAB\u5AC5\u5B51\u5C10\u5C46\u5C4A\u5C8A\u5C95\u5D28\u5D65\u5DBB\u5DC0\u5E6F\u5E8E\u5FA3\u5FE6\u6088\u6212\u622A\u62EE\u6377\u63A5\u63B2\u63ED\u64D1\u64EE\u64F3\u65BA\u6605\u6770\u6840\u685D\u6904\u6950\u696C\u6976\u69A4\u6A9E\u6AED\u6BD1\u6D01\u6E5D\u6ED0\u6F54\u716F\u7297\u73A0\u743E\u754C\u754D\u758C\u7596\u75A5\u75CE\u7664\u7686\u776B\u780E\u78A3\u790D\u79F8\u7A2D\u7AED\u7BC0\u7D50\u7E72\u7ED3\u7FAF\u813B\u8282\u83AD\u83E8\u84F5\u86A7\u86E3\u86F6\u8710\u8754\u8818\u881E\u883D\u8857\u8871\u8878\u88BA\u892F\u89E7\u8A10\u8A70\u8AA1\u8AB1\u8BA6\u8BEB\u8E15\u8FFC\u9263\u937B\u9636\u968E\u9782\u9821\u9889\u98F7\u9AB1\u9B5D\u9B6A\u9B9A\u9C92\u9D9B",
            "Jin": "\u4EC5\u4ECA\u4F12\u4FAD\u50C5\u50F8\u5118\u5153\u51DA\u52A4\u52C1\u537A\u53AA\u5664\u568D\u57D0\u5807\u583B\u5890\u58D7\u5997\u5AE4\u5B27\u5BD6\u5C3D\u5D9C\u5DF9\u5DFE\u5ED1\u60CD\u616C\u6422\u65A4\u6649\u664B\u6783\u69FF\u6B4F\u6BA3\u6D25\u6D55\u6D78\u6E8D\u6F0C\u6FC5\u6FDC\u70EC\u7161\u71FC\u73D2\u740E\u743B\u7468\u747E\u74A1\u74B6\u76E1\u781B\u7972\u7981\u7B4B\u7D1F\u7D27\u7DCA\u7E09\u7F19\u8355\u8369\u83EB\u84F3\u85CE\u887F\u895F\u89B2\u89D0\u89D4\u8B39\u8C28\u8CEE\u8D10\u8D46\u8FD1\u8FDB\u9032\u91D1\u91D2\u9326\u9485\u9526\u9773\u9949\u9991\u9E76\u9EC5\u9F7D",
            "Jing": "\u4E3C\u4E95\u4EAC\u4EB0\u4FD3\u501E\u50B9\u5106\u5162\u51C0\u51C8\u522D\u5244\u5753\u5755\u5759\u5883\u598C\u5A59\u5A5B\u5A67\u5B91\u5DE0\u5E5C\u5F2A\u5F33\u5F84\u5F91\u60CA\u61AC\u61BC\u656C\u65CC\u65CD\u666F\u6676\u66BB\u66D4\u6871\u68B7\u6A78\u6C6B\u6C6C\u6CFE\u6D44\u6D87\u6DE8\u701E\u71DD\u71DE\u7304\u734D\u7484\u749F\u74A5\u75C9\u75D9\u775B\u79D4\u7A09\u7A7D\u7ADE\u7ADF\u7AE7\u7AEB\u7AF6\u7AF8\u7CB3\u7CBE\u7D4C\u7D93\u7ECF\u8059\u80BC\u80EB\u811B\u8148\u830E\u8346\u834A\u8396\u83C1\u87FC\u8AA9\u8B66\u8E01\u8FF3\u9015\u93E1\u955C\u9631\u9753\u9756\u9759\u975A\u975C\u981A\u9838\u9A5A\u9BE8\u9CB8\u9D5B\u9D81\u9D84\u9E96\u9EA0\u9F31",
            "Jiong": "\u4FB0\u50D2\u5182\u518B\u518F\u56E7\u5770\u57DB\u6243\u6CC2\u6D7B\u6F83\u70AF\u70F1\u715A\u715B\u71B2\u71D1\u71DB\u7A98\u7D45\u7D97\u860F\u8614\u8927\u8FE5\u9008\u9848\u988E\u99C9\u99EB",
            "Jiu": "\u4E29\u4E45\u4E46\u4E5D\u4E63\u5003\u50E6\u52FC\u5313\u531B\u5336\u53A9\u548E\u557E\u597A\u5C31\u5EC4\u5ECF\u5ED0\u6166\u63C2\u63EA\u63EB\u644E\u6551\u65E7\u673B\u6766\u67E9\u67FE\u6855\u6A1B\u6B0D\u6BA7\u6C63\u7078\u725E\u7396\u7542\u759A\u7A76\u7CFA\u7CFE\u7D24\u7EA0\u81FC\u8205\u820A\u820F\u841B\u8D73\u9152\u9579\u9604\u97ED\u97EE\u9B0F\u9B2E\u9BE6\u9CE9\u9DF2\u9E20\u9E6B\u9E94\u9F68",
            "Ju": "\u4E3E\u4FB7\u4FF1\u5028\u5036\u50EA\u5177\u51A3\u51E5\u5267\u5287\u52EE\u530A\u53E5\u5727\u57E7\u57FE\u58C9\u59D6\u5A35\u5A45\u5A6E\u5BE0\u5C40\u5C45\u5C66\u5C68\u5CA0\u5D0C\u5DC8\u5DE8\u5F06\u6007\u601A\u60E7\u6133\u61C5\u61FC\u6285\u62D2\u62D8\u62E0\u6319\u6336\u6344\u636E\u63AC\u64DA\u64E7\u661B\u6854\u68AE\u6907\u6908\u6910\u6989\u6998\u6A58\u6A8B\u6AF8\u6B05\u6B6B\u6BE9\u6BF1\u6CAE\u6CC3\u6CE6\u6D30\u6DBA\u6DD7\u6E68\u6FBD\u70AC\u7117\u7123\u7220\u728B\u7291\u72CA\u72D9\u741A\u75BD\u75C0\u7717\u77BF\u77E9\u7820\u79EC\u7AAD\u7AB6\u7B65\u7C34\u7C94\u7CB7\u7F5D\u801F\u805A\u8065\u8152\u8209\u824D\u82E3\u82F4\u8392\u83CA\u849F\u84FB\u861C\u8661\u86B7\u871B\u8893\u88FE\u8977\u8A4E\u8ACA\u8BB5\u8C66\u8C97\u8D9C\u8DD4\u8DD9\u8DDD\u8DFC\u8E18\u8E1E\u8E3D\u8E6B\u8E86\u8EB9\u8F02\u907D\u90AD\u90F9\u91B5\u9245\u92E6\u92F8\u943B\u949C\u9514\u952F\u95B0\u9671\u96CE\u97A0\u97AB\u98B6\u98D3\u99CF\u99D2\u99F6\u9A67\u9A79\u9B88\u9B94\u9D21\u9D59\u9D74\u9D8B\u9DAA\u9F30\u9F33\u9F5F\u9F83",
            "Juan": "\u5026\u52B5\u52CC\u52EC\u5377\u545F\u57CD\u5946\u59E2\u5A1F\u5E23\u5F2E\u617B\u6350\u6372\u684A\u6D93\u6DC3\u72F7\u7367\u74F9\u7737\u774A\u7760\u7D6D\u7D79\u7EE2\u7F65\u7F82\u8127\u81C7\u83E4\u8528\u8832\u88D0\u9104\u92D1\u92D7\u9308\u93B8\u942B\u9529\u954C\u96BD\u96CB\u98EC\u990B\u9D51\u9E43",
            "Jue": "\u4E85\u5014\u5095\u51B3\u5214\u5282\u52EA\u53A5\u5658\u5671\u599C\u5B52\u5B53\u5C69\u5C6B\u5D1B\u5DA1\u5DA5\u5F4F\u61A0\u61B0\u6204\u6289\u6317\u6354\u6398\u6485\u64A7\u652B\u658D\u6877\u6A5B\u6A5C\u6B14\u6B2E\u6B8C\u6C12\u6C7A\u6CEC\u6F4F\u704D\u7106\u71A6\u7211\u721D\u7234\u7235\u7357\u7383\u73A6\u73A8\u73CF\u7474\u761A\u77CD\u77E1\u7804\u7D55\u7D76\u7EDD\u81C4\u82B5\u855D\u8568\u8673\u8697\u87E8\u87E9\u8990\u899A\u89BA\u89C9\u89D6\u89FC\u8A23\u8B4E\u8BC0\u8C32\u8C9C\u8D7D\u8D89\u8DB9\u8E76\u8E77\u8EA9\u902B\u920C\u940D\u941D\u9481\u9562\u957C\u99C3\u9D02\u9D03\u9D8C\u9DE2\u9FA3",
            "Jun": "\u4FCA\u5101\u519B\u541B\u5441\u5747\u57C8\u59F0\u5BEF\u5CFB\u61CF\u6343\u6508\u6659\u687E\u6C6E\u6D5A\u6FEC\u710C\u71C7\u73FA\u756F\u76B2\u76B8\u76B9\u7885\u7AE3\u7B60\u7B98\u7B9F\u8399\u83CC\u8690\u8720\u8880\u89A0\u8ECD\u90E1\u921E\u9281\u929E\u9355\u94A7\u9656\u9915\u9982\u99FF\u9A8F\u9BB6\u9CAA\u9D54\u9D55\u9D58\u9E87\u9E8F\u9E95",
            "Ka": "\u4F67\u5494\u5496\u5580\u57B0\u80E9\u88C3\u9272",
            "Ke": "\u514B\u523B\u524B\u52C0\u52CA\u533C\u53EF\u55D1\u5777\u5801\u5A14\u5BA2\u5C05\u5CA2\u5CC7\u5D51\u5D59\u5DB1\u606A\u6119\u63E2\u6415\u6564\u67EF\u68F5\u69BC\u6A16\u6BBB\u6C2A\u6E07\u6E34\u6E98\u70A3\u7241\u7290\u73C2\u75B4\u75FE\u778C\u78A6\u78D5\u790A\u791A\u79D1\u7A1E\u7AA0\u7DD9\u7F02\u7FD7\u80E2\u82DB\u842A\u8596\u874C\u8AB2\u8BFE\u8DB7\u8EFB\u8F72\u9198\u9233\u9301\u94B6\u951E\u9826\u9846\u988F\u9897\u9A0D\u9A92\u9AC1",
            "Kai": "\u4E6B\u51EF\u51F1\u5240\u5274\u52D3\u5605\u57B2\u584F\u5952\u5F00\u5FFE\u607A\u6137\u613E\u6168\u63E9\u669F\u6977\u6B2C\u708C\u708F\u70D7\u8488\u8849\u8F06\u9347\u938E\u93A7\u9426\u94E0\u950E\u9534\u958B\u95D3\u95FF\u98BD",
            "Kan": "\u4F83\u5058\u519A\u520A\u52D8\u574E\u57F3\u582A\u583F\u586A\u5888\u5D01\u5D41\u60C2\u6221\u681E\u6B3F\u6B41\u770B\u77B0\u77D9\u780D\u78E1\u7AF7\u83B0\u884E\u8F21\u8F41\u8F57\u95DE\u961A\u9851\u9F95\u9F9B",
            "Kang": "\u4EA2\u4F09\u531F\u56E5\u5ADD\u5D7B\u5EB7\u5FFC\u6177\u6297\u6443\u69FA\u6F2E\u7095\u72BA\u780A\u7A45\u7C87\u7CE0\u8EBF\u909F\u9227\u93EE\u94AA\u958C\u95F6\u9C47",
            "Kao": "\u4E02\u5C3B\u62F7\u6537\u6832\u6D18\u70E4\u7292\u8003\u92AC\u94D0\u9760\u9ADB\u9BB3\u9BCC\u9C93",
            "Ken": "\u5543\u57A6\u58BE\u6073\u61C7\u63AF\u808E\u80AF\u80BB\u88C9\u8903\u8C64\u8C87\u9339",
            "Keng": "\u4E6C\u52A5\u53BC\u551F\u5748\u5751\u5DEA\u603E\u6333\u727C\u7841\u785C\u787B\u8A99\u92B5\u935E\u93D7\u94FF",
            "Kong": "\u5025\u57EA\u5B54\u5D06\u6050\u60BE\u63A7\u6DB3\u787F\u7A7A\u7B9C\u8EBB\u8EBC\u9313\u979A\u9D7C",
            "Kou": "\u51A6\u527E\u52B6\u53E3\u53E9\u5BBC\u5BC7\u5EE4\u5F44\u6010\u6263\u62A0\u6473\u6542\u6EF1\u770D\u7789\u7798\u7A9B\u7B58\u7C06\u82A4\u8532\u853B\u91E6\u9DC7",
            "Ku": "\u4FC8\u5233\u54ED\u55BE\u56B3\u5710\u5800\u5D2B\u5E93\u5EAB\u625D\u67AF\u684D\u695B\u7105\u72DC\u7614\u77FB\u79D9\u7A9F\u7D5D\u7ED4\u82E6\u88B4\u88E4\u8932\u8DCD\u90C0\u9177\u9AB7\u9BAC",
            "Kua": "\u4F89\u54B5\u57AE\u5938\u59F1\u630E\u6647\u80EF\u823F\u8A87\u8DE8\u9299\u9ABB",
            "Kuai": "\u4FA9\u5108\u51F7\u54D9\u5672\u5726\u5757\u584A\u58A4\u5DDC\u5EE5\u5FEB\u64D3\u65DD\u72EF\u736A\u7B77\u7CE9\u810D\u81BE\u84AF\u90D0\u9136\u9C60\u9C99",
            "Kuan": "\u5BBD\u5BDB\u5BEC\u68A1\u6B35\u6B3E\u6B40\u7ABD\u7ABE\u9467\u9ACB\u9AD6",
            "Kuang": "\u5123\u51B5\u52BB\u5321\u5329\u54D0\u5739\u58D9\u593C\u5CB2\u6047\u61EC\u61ED\u6282\u65F7\u663F\u66E0\u6846\u6CC1\u6D2D\u720C\u72C2\u72C5\u7716\u7736\u77CC\u77FF\u783F\u7926\u7A6C\u7B50\u7B7A\u7D4B\u7D56\u7E8A\u7EA9\u8A86\u8A91\u8BD3\u8BF3\u8CBA\u8D36\u8ED6\u8EE0\u8EE6\u8EED\u909D\u90BC\u913A\u9271\u92DB\u945B\u9D5F\u9ECB",
            "Kui": "\u4E8F\u5080\u5232\u532E\u5331\u537C\u559F\u55B9\u5633\u5914\u594E\u5ABF\u5B07\u5C2F\u5CBF\u5DCB\u5DD9\u609D\u6126\u6127\u6192\u6223\u63C6\u6646\u668C\u694F\u6951\u6A3B\u6AC6\u6B33\u6BA8\u6F70\u7143\u76D4\u777D\u78C8\u7AA5\u7ABA\u7BD1\u7C23\u7C44\u8067\u8069\u806D\u8075\u8475\u8489\u848A\u8562\u85C8\u862C\u8637\u8641\u8667\u8770\u8B09\u8DEC\u8E5E\u8EA8\u9035\u9108\u9368\u9377\u9400\u944E\u95DA\u9804\u980D\u982F\u985D\u993D\u994B\u9988\u9997\u9A24\u9A99\u9B41",
            "Kun": "\u56F0\u5764\u5803\u5812\u58F8\u58FC\u5A6B\u5C21\u5D10\u5D11\u6083\u6346\u6606\u665C\u68B1\u6D83\u6F49\u711C\u71B4\u7311\u7428\u747B\u774F\u7871\u7975\u7A07\u7A1B\u7D91\u81D7\u83CE\u872B\u88C8\u88CD\u88E9\u890C\u918C\u9315\u951F\u95AB\u95B8\u9603\u9A09\u9AE0\u9AE1\u9AE8\u9BE4\u9CB2\u9D7E\u9DA4\u9E4D",
            "Kuo": "\u564B\u5ED3\u61D6\u6269\u62E1\u6304\u64F4\u681D\u6870\u6FF6\u7A52\u7B48\u843F\u8440\u86DE\u95CA\u9614\u9729\u979F\u97B9\u97D5\u9822\u9AFA\u9B20",
            "La": "\u524C\u5566\u5587\u56B9\u5783\u62C9\u63E6\u63E7\u641A\u650B\u65EF\u67C6\u694B\u6AF4\u6E82\u7209\u74CE\u760C\u782C\u78D6\u7FCB\u814A\u81C8\u81D8\u83C8\u85DE\u8721\u874B\u8772\u881F\u8FA2\u8FA3\u908B\u945E\u9574\u97A1\u9B0E\u9BFB",
            "Lai": "\u4F86\u4FEB\u5008\u553B\u5A61\u5D03\u5D0D\u5EB2\u5F95\u5FA0\u6765\u68BE\u68F6\u6D9E\u6DF6\u6FD1\u7028\u702C\u730D\u741C\u765E\u7669\u7750\u775E\u7B59\u7B82\u7C41\u7C5F\u83B1\u840A\u85FE\u8970\u8CDA\u8CF4\u8D49\u8D56\u9028\u90F2\u9338\u94FC\u983C\u9842\u9A0B\u9BE0\u9D63\u9D86\u9EB3",
            "Lan": "\u5116\u5170\u53B1\u5682\u56D2\u58C8\u58CF\u5A6A\u5B3E\u5B44\u5B4F\u5C9A\u5D50\u5E71\u61D2\u61E2\u61F6\u62E6\u63FD\u64E5\u6514\u652C\u6593\u6595\u680F\u6984\u6B04\u6B16\u6B17\u6D68\u6EE5\u6F24\u6F9C\u6FEB\u703E\u7046\u7060\u7061\u70C2\u71D7\u71E3\u7201\u721B\u7224\u7226\u74BC\u74D3\u7937\u7BEE\u7C43\u7C63\u7CF7\u7E7F\u7E9C\u7F06\u7F71\u847B\u84DD\u84DE\u85CD\u862D\u8934\u8955\u8964\u8974\u897D\u89A7\u89BD\u89C8\u8B4B\u8B95\u8C30\u8E9D\u9182\u946D\u9484\u9567\u95CC\u9611\u97CA",
            "Lang": "\u52C6\u5525\u5577\u57CC\u5871\u5ACF\u5D00\u5ECA\u60A2\u6716\u6717\u6724\u6879\u6994\u6A03\u6B34\u6D6A\u70FA\u72FC\u7405\u746F\u7860\u7A02\u7B64\u8246\u83A8\u8497\u84C8\u84E2\u870B\u8782\u8A8F\u8EB4\u90CE\u90D2\u90DE\u92C3\u93AF\u9512\u95AC\u9606\u99FA",
            "Lao": "\u4F6C\u50D7\u52B3\u52B4\u52DE\u54BE\u54F0\u5520\u55E0\u562E\u59E5\u5AEA\u5D02\u5D97\u6045\u61A5\u61A6\u635E\u6488\u6725\u6833\u6A51\u6A6F\u6D76\u6D9D\u6F87\u7262\u72EB\u73EF\u75E8\u7646\u7853\u78F1\u7A82\u7C29\u7CA9\u8001\u8002\u8022\u802E\u8356\u86EF\u87E7\u8EC2\u8F51\u916A\u91AA\u92A0\u9412\u94D1\u94F9\u985F\u9ADD\u9BB1",
            "Le": "\u4EC2\u52D2\u53FB\u5FC7\u6250\u697D\u6A02\u6C3B\u6CD0\u738F\u7833\u7AFB\u7C15\u827B\u961E\u97F7\u990E\u9979\u9C33\u9CD3",
            "Lei": "\u50AB\u5121\u513D\u53BD\u561E\u5792\u5841\u58D8\u58E8\u5AD8\u64C2\u6502\u6A0F\u6A91\u6AD0\u6AD1\u6B19\u6CEA\u6D21\u6D99\u6DDA\u7045\u74C3\u757E\u7657\u77CB\u78CA\u78E5\u790C\u7927\u7928\u79B7\u7C7B\u7D2F\u7D6B\u7E32\u7E87\u7E8D\u7E9D\u7F27\u7F4D\u7FB8\u8012\u8137\u8502\u854C\u857E\u85DF\u8631\u8632\u863D\u8646\u881D\u8A84\u8B84\u8BD4\u8F60\u9179\u9287\u9311\u9433\u9458\u9478\u956D\u96F7\u9741\u981B\u982A\u985E\u98A3\u9C69\u9E13\u9F3A",
            "Ling": "\u4EE4\u4F36\u51CC\u5222\u53E6\u5464\u56F9\u577D\u590C\u59C8\u5A48\u5B41\u5CAD\u5CBA\u5D1A\u5DBA\u5F7E\u6395\u6624\u670E\u67C3\u68C2\u6AFA\u6B1E\u6CE0\u6DE9\u6FAA\u702E\u7075\u70A9\u71EF\u7227\u72D1\u73B2\u740C\u74F4\u768A\u7831\u797E\u79E2\u7ADB\u7B2D\u7D37\u7DBE\u7EEB\u7F9A\u7FCE\u8046\u8232\u82D3\u83F1\u84E4\u8506\u8576\u8626\u86C9\u8851\u888A\u88EC\u8A45\u8DC9\u8EE8\u8F18\u9143\u91BD\u9234\u9302\u94C3\u959D\u963E\u9675\u96F6\u970A\u9717\u971B\u971D\u9748\u9818\u9886\u99D6\u9B7F\u9BEA\u9CAE\u9D12\u9E30\u9E77\u9EA2\u9F61\u9F62\u9F84\u9F97",
            "Leng": "\u5030\u51B7\u580E\u5844\u6123\u68F1\u695E\u7756\u7890\u7A1C\u8590\u8E1C",
            "Li": "\u4E3D\u4F8B\u4FD0\u4FDA\u4FEA\u5088\u512E\u5137\u51D3\u5215\u5229\u5253\u527A\u5299\u529B\u52B1\u52F5\u5386\u5389\u5398\u53A4\u53AF\u53B2\u540F\u5456\u54E9\u550E\u5533\u55B1\u569F\u56A6\u56C4\u56C7\u575C\u585B\u58E2\u5A0C\u5A33\u5A6F\u5AE0\u5B4B\u5B77\u5C74\u5CA6\u5CDB\u5CF2\u5DC1\u5EF2\u60A1\u60A7\u60B7\u6144\u623E\u642E\u650A\u6526\u652D\u6584\u66A6\u66C6\u66DE\u6738\u674E\u67A5\u6803\u680E\u6817\u681B\u6835\u68A8\u68B8\u68C3\u68D9\u6A06\u6AAA\u6AD4\u6ADF\u6AEA\u6B10\u6B1A\u6B74\u6B77\u6C02\u6CA5\u6CB4\u6D6C\u6D96\u6EA7\u6F13\u6FA7\u6FFF\u701D\u7055\u7204\u720F\u7281\u7282\u729B\u72A1\u72F8\u7301\u73D5\u7406\u740D\u746E\u7483\u74C5\u74C8\u74D1\u74E5\u75A0\u75AC\u75E2\u7658\u7667\u76AA\u76E0\u76ED\u775D\u7805\u783A\u783E\u78FF\u792A\u792B\u7930\u793C\u79AE\u79B2\u79BB\u79DD\u7A72\u7ACB\u7AF0\u7B20\u7B63\u7BE5\u7BF1\u7C6C\u7C92\u7C9D\u7CB4\u7CCE\u7CF2\u7D9F\u7E2D\u7F21\u7F79\u8243\u82C8\u82D9\u8318\u8354\u8372\u8385\u8389\u83DE\u849A\u849E\u84E0\u853E\u85DC\u85F6\u863A\u86B8\u86CE\u86E0\u870A\u8727\u87CD\u87F8\u8807\u8821\u8823\u882B\u88CF\u88E1\u8935\u8A48\u8B27\u8B88\u8C4A\u8C8D\u8D72\u8DDE\u8E92\u8F62\u8F63\u8F79\u9026\u908C\u9090\u90E6\u9148\u91A8\u91B4\u91CC\u91D0\u925D\u92EB\u92F0\u9305\u93EB\u9457\u9502\u96B6\u96B7\u96B8\u96E2\u96F3\u9742\u974B\u9A6A\u9A8A\u9B01\u9BC9\u9BCF\u9BEC\u9C67\u9C71\u9C7A\u9CA1\u9CA4\u9CE2\u9CE8\u9D17\u9D79\u9DC5\u9E1D\u9E42\u9E97\u9E9C\u9ECE\u9EE7",
            "Lian": "\u4EB7\u50C6\u5286\u5332\u5333\u55F9\u5652\u581C\u5941\u5969\u5A08\u5AA1\u5AFE\u5B1A\u5E18\u5EC9\u601C\u604B\u6169\u6190\u6200\u6459\u655B\u6582\u68BF\u695D\u69E4\u6AE3\u6B5B\u6B93\u6BAE\u6D70\u6D9F\u6E45\u6E93\u6F23\u6F4B\u6FB0\u6FC2\u6FD3\u7032\u70BC\u7149\u7191\u71EB\u740F\u7453\u7489\u78CF\u7A34\u7C3E\u7C62\u7C68\u7DF4\u7E3A\u7E9E\u7EC3\u7FB7\u7FF4\u8054\u8068\u806B\u806E\u806F\u8138\u81C1\u81C9\u83B2\u8430\u84EE\u8539\u8595\u861D\u861E\u878A\u880A\u88E2\u88E3\u8933\u895D\u899D\u8B30\u8B67\u8E65\u8FDE\u9023\u913B\u932C\u934A\u938C\u93C8\u942E\u94FE\u9570\u9B11\u9C0A\u9C31\u9CA2",
            "Liang": "\u4E21\u4E24\u4EAE\u4FCD\u5169\u51C9\u54F4\u5521\u5562\u55A8\u589A\u639A\u667E\u6881\u690B\u6A11\u6DBC\u6E78\u7177\u7C17\u7CAE\u7CB1\u7CE7\u7DA1\u7DC9\u813C\u826F\u873D\u88F2\u8AD2\u8C05\u8E09\u8F0C\u8F1B\u8F2C\u8F86\u8F8C\u91CF\u9344\u9B49\u9B4E",
            "Liao": "\u4E86\u50DA\u5639\u5AFD\u5BE5\u5BEE\u5C1E\u5C25\u5C26\u5C6A\u5D7A\u5D9A\u5D9B\u5ED6\u5EEB\u6180\u61AD\u6482\u64A9\u6579\u6599\u66B8\u6F3B\u7093\u71CE\u720E\u7212\u7360\u7499\u7597\u7642\u77AD\u7AB7\u7AC2\u7C1D\u7E5A\u7F2D\u804A\u818B\u81AB\u84FC\u87DF\u8C42\u8CFF\u8E58\u8E7D\u8FBD\u907C\u911D\u91D5\u9410\u948C\u9563\u957D\u98C9\u9ACE\u9DEF\u9E69",
            "Lie": "\u5120\u51BD\u5217\u52A3\u52BD\u54A7\u57D2\u57D3\u59F4\u5CE2\u5DE4\u6312\u6318\u6369\u64F8\u6BDF\u6D0C\u6D56\u70C8\u70EE\u716D\u72A3\u730E\u731F\u7375\u7759\u8057\u811F\u8322\u86DA\u88C2\u8D94\u8E90\u8FFE\u98B2\u9B1B\u9B23\u9BA4\u9C72\u9D37",
            "Lin": "\u4E34\u4E83\u50EF\u51DB\u51DC\u53B8\u541D\u5549\u58E3\u5D0A\u5D99\u5EE9\u5EEA\u6061\u608B\u60CF\u61CD\u61D4\u62CE\u649B\u65B4\u667D\u66BD\u6797\u6A49\u6A81\u6AA9\u6DCB\u6F7E\u6F9F\u7036\u711B\u71D0\u735C\u7433\u7498\u7510\u7584\u75F3\u765B\u765D\u77B5\u7884\u78F7\u7A1F\u7B96\u7CA6\u7CBC\u7E57\u7FF7\u81A6\u81E8\u83FB\u853A\u85FA\u8CC3\u8D41\u8E78\u8E8F\u8E99\u8EAA\u8F54\u8F65\u8F9A\u9074\u90BB\u9130\u93FB\u95B5\u96A3\u9716\u9872\u9A4E\u9C57\u9CDE\u9E90\u9E9F",
            "Liu": "\u516D\u5218\u5289\u56A0\u56D6\u586F\u5AB9\u5B3C\u5D67\u5EC7\u61F0\u65C8\u65D2\u67F3\u6801\u685E\u687A\u69B4\u6A4A\u6A6E\u6CA0\u6D41\u6D4F\u6E9C\u6F91\u700F\u7198\u71AE\u73CB\u7409\u7460\u746C\u74A2\u74FC\u7505\u7544\u7559\u7571\u7581\u7624\u7645\u786B\u78C2\u78DF\u7DB9\u7EFA\u7F76\u7F80\u7FCF\u84A5\u84C5\u85F0\u87C9\u88D7\u8E53\u905B\u92F6\u938F\u93A6\u93D0\u9402\u950D\u954F\u9560\u96E1\u9724\u98C0\u98C2\u98C5\u98D7\u993E\u998F\u99E0\u99F5\u9A2E\u9A51\u9A9D\u9B38\u9C21\u9DB9\u9DDA\u9E60\u9E68\u9E8D",
            "Long": "\u5131\u5499\u54E2\u56A8\u5784\u5785\u58DF\u58E0\u5C78\u5D90\u5DC3\u5DC4\u5FBF\u62E2\u650F\u663D\u66E8\u6727\u680A\u6887\u69DE\u6AF3\u6CF7\u6E70\u6F0B\u7027\u7216\u73D1\u74CF\u7643\u772C\u77D3\u783B\u7866\u7931\u7932\u7ABF\u7AC9\u7ADC\u7B3C\u7BED\u7C60\u804B\u807E\u80E7\u830F\u856F\u8622\u882A\u882C\u8856\u8971\u8C45\u8D1A\u8E98\u93E7\u9468\u9647\u9686\u96B4\u9733\u9747\u9A61\u9E17\u9F8D\u9F92\u9F93\u9F99",
            "Lou": "\u50C2\u55BD\u560D\u587F\u5A04\u5A41\u5C5A\u5D5D\u5D81\u5ED4\u617A\u6402\u645F\u697C\u6A13\u6E87\u6F0A\u6F0F\u71A1\u750A\u7618\u763A\u763B\u779C\u7BD3\u7C0D\u8027\u802C\u825B\u848C\u851E\u877C\u87BB\u8B31\u8EC1\u9071\u93E4\u9542\u964B\u97BB\u9AC5\u9ACF",
            "Lu": "\u4F93\u50C7\u5279\u52CE\u52E0\u5362\u5364\u565C\u5695\u56A7\u5725\u5774\u5786\u5876\u5877\u58DA\u5A3D\u5CCD\u5E90\u5ED8\u5EEC\u5F54\u5F55\u622E\u6314\u635B\u63B3\u645D\u64B8\u64C4\u64FC\u650E\u67A6\u680C\u6902\u6A10\u6A1A\u6A79\u6AD3\u6AE8\u6C07\u6C0C\u6CF8\u6DD5\u6DE5\u6E0C\u6EE4\u6EF7\u6F09\u6F5E\u6F9B\u6FFE\u7002\u7018\u7089\u719D\u7210\u7379\u7388\u742D\u7490\u74B7\u74D0\u752A\u76DD\u76E7\u7769\u77D1\u7849\u7875\u78E0\u797F\u7984\u7A11\u7A4B\u7B93\u7C0F\u7C2C\u7C35\u7C36\u7C59\u7C5A\u7CB6\u7E91\u7F4F\u80EA\u8194\u819F\u81DA\u822E\u823B\u8263\u826A\u826B\u82A6\u83C9\u84FE\u850D\u8557\u8606\u8642\u864F\u865C\u87B0\u8826\u89EE\u89FB\u8CC2\u8D42\u8DA2\u8DEF\u8E1B\u8E57\u8F05\u8F46\u8F64\u8F73\u8F82\u8F98\u902F\u9181\u9229\u9304\u9332\u9334\u93C0\u93D5\u93F4\u942A\u9465\u946A\u9565\u9646\u9678\u9871\u9885\u9A04\u9A3C\u9AD7\u9B6F\u9B72\u9BE5\u9C78\u9C81\u9C88\u9D3C\u9D66\u9D71\u9DFA\u9E15\u9E2C\u9E6D\u9E75\u9E7F\u9E93\u9EF8",
            "Lv": "\u4FA3\u4FB6\u5122\u52F4\u5415\u5442\u54F7\u578F\u5BFD\u5C61\u5C62\u5C65\u5D42\u5F8B\u616E\u65C5\u66E5\u68A0\u6988\u6AD6\u6ADA\u6C00\u6C2F\u7112\u7208\u7387\u7963\u7A06\u7A5E\u7A6D\u7BBB\u7D7D\u7DA0\u7DD1\u7E37\u7E42\u7EFF\u7F15\u8182\u8190\u81A2\u844E\u85D8\u8651\u891B\u8938\u90D8\u92C1\u9462\u94DD\u95AD\u95FE\u99BF\u9A62\u9A74\u9DDC",
            "Luan": "\u4E71\u4E82\u5375\u571D\u571E\u5971\u5B4C\u5B6A\u5B7F\u5CE6\u5DD2\u631B\u6523\u66EB\u683E\u6B12\u6EE6\u7053\u7064\u7674\u7675\u7F89\u8114\u81E0\u864A\u91E0\u92AE\u947E\u9D49\u9E1E\u9E3E",
            "lue": "\u63a0\u7565\u950a",
            "Lun": "\u4ED1\u4F26\u4F96\u502B\u56F5\u5707\u57E8\u5A68\u5D18\u5D19\u60C0\u62A1\u6384\u68C6\u6CA6\u6DEA\u6EA3\u7896\u78EE\u7A10\u7DB8\u8023\u8140\u83D5\u8726\u8AD6\u8BBA\u8E1A\u8F2A\u8F6E\u9300\u966F\u9BE9",
            "Luo": "\u502E\u5138\u5246\u5570\u56C9\u5CC8\u645E\u651E\u66EA\u6924\u6B0F\u6CFA\u6D1B\u6D1C\u6F2F\u6FFC\u7296\u7321\u7380\u73DE\u7630\u7673\u7822\u7B3F\u7BA9\u7C6E\u7D61\u7E99\u7F57\u7F85\u8136\u8161\u81DD\u8366\u841D\u84CF\u863F\u87BA\u8803\u88F8\u89B6\u89BC\u8EB6\u903B\u908F\u93CD\u947C\u9523\u9559\u96D2\u9831\u9960\u99F1\u9A3E\u9A58\u9A86\u9AA1\u9BA5\u9C73\u9D45\u9E01",
            "Ma": "\u4E87\u508C\u5417\u551B\u55CE\u561B\u561C\u5988\u5ABD\u5AF2\u5B24\u5B37\u6769\u69AA\u6EA4\u7298\u72B8\u7341\u739B\u746A\u75F2\u7770\u7801\u78BC\u7923\u7943\u79A1\u7F75\u8534\u8682\u879E\u87C6\u87C7\u9064\u93B7\u9581\u99AC\u99E1\u9A6C\u9A82\u9B15\u9C22\u9DCC\u9EBB",
            "Mai": "\u4E70\u4F45\u52A2\u52F1\u5356\u562A\u58F2\u8108\u836C\u8552\u85B6\u8847\u8CB7\u8CE3\u8FC8\u9081\u9721\u9722\u973E\u9DF6\u9EA5\u9EA6",
            "Man": "\u50C8\u5881\u59CF\u5ADA\u5C58\u5E54\u6097\u6162\u6172\u6471\u66FC\u69FE\u6A20\u6E80\u6EE1\u6EFF\u6F2B\u6FAB\u6FB7\u71B3\u734C\u774C\u7792\u779E\u77D5\u7E35\u7F26\u8504\u8630\u86EE\u87A8\u87C3\u87CE\u883B\u8954\u8B3E\u8C29\u9124\u93CB\u93DD\u9558\u9794\u9862\u989F\u9945\u9992\u9B17\u9B18\u9C3B\u9CD7",
            "Mang": "\u5301\u5396\u5402\u54E4\u58FE\u5A0F\u5C28\u5FD9\u607E\u6757\u6767\u6C52\u6D5D\u6F2D\u7264\u727B\u72F5\u75DD\u76F2\u786D\u7B00\u8292\u832B\u833B\u83BD\u83BE\u8609\u86D6\u87D2\u880E\u9099\u91EF\u92E9\u94D3\u99F9",
            "Meng": "\u511A\u51A1\u52D0\u5922\u5923\u5B5F\u5E6A\u5EAC\u61DC\u61DE\u61F5\u63B9\u64DD\u66DA\u6726\u68A6\u6A57\u6AAC\u6C0B\u6E95\u6FDB\u731B\u7374\u74FE\u750D\u753F\u76DF\u77A2\u77C7\u77D2\u791E\u7F5E\u824B\u8268\u8394\u840C\u8420\u8499\u8544\u867B\u8722\u8771\u8813\u9133\u9138\u9333\u9530\u96FA\u9725\u973F\u9740\u986D\u995B\u9BCD\u9BED\u9E0F\u9E72\u9F06",
            "Miao": "\u55B5\u5999\u5A8C\u5AF9\u5E99\u5EBF\u5EDF\u63CF\u676A\u6DFC\u6E3A\u7385\u7707\u7784\u79D2\u7AD7\u7BCE\u7DF2\u7F08\u82D7\u85D0\u9088\u9C59\u9D93\u9E4B",
            "Mao": "\u5183\u5187\u5190\u5192\u536F\u551C\u5825\u5918\u5AA2\u5CC1\u5E3D\u6117\u61CB\u623C\u65C4\u6634\u6693\u6786\u6959\u6BDB\u6BDC\u6BDD\u6BF7\u6CD6\u6E35\u7266\u732B\u7441\u7683\u770A\u7780\u77DB\u7B37\u7DE2\u8004\u82BC\u8302\u8305\u8306\u84E9\u86D1\u8750\u8765\u87CA\u88A4\u8992\u8C8C\u8C93\u8CBF\u8D38\u8EDE\u911A\u912E\u9155\u925A\u9328\u94C6\u951A\u9AE6\u9AF3\u9D9C",
            "Me": "\u4E48\u5692\u56B0\u5E85\u6FF9\u7666",
            "Mei": "\u51C2\u5445\u569C\u5833\u587A\u59B9\u5A84\u5A92\u5A9A\u5ABA\u5B0D\u5BD0\u5D44\u5D4B\u5FBE\u62BA\u6334\u6517\u651F\u6627\u679A\u67D0\u6802\u6885\u6963\u6973\u69D1\u6BCE\u6BCF\u6C92\u6CAC\u6D7C\u6E3C\u6E44\u6E48\u715D\u7164\u71D8\u7338\u73AB\u73FB\u7442\u75D7\u7709\u771B\u7742\u7778\u77C0\u7959\u7996\u7BC3\u7F8E\u8104\u8122\u815C\u82FA\u8393\u847F\u862A\u875E\u8882\u8DCA\u8EBE\u90FF\u9176\u92C2\u9382\u9387\u9541\u9545\u9709\u97CE\u9B3D\u9B45\u9DA5\u9E5B\u9EE3\u9EF4",
            "Men": "\u4EEC\u5011\u60B6\u61D1\u61E3\u626A\u636B\u66AA\u691A\u7116\u71DC\u73A3\u748A\u7A48\u83DB\u864B\u9346\u9494\u9580\u9585\u95E8\u95F7",
            "Mi": "\u4F8E\u5196\u519E\u51AA\u54AA\u5627\u5853\u5B4A\u5B93\u5BBB\u5BC6\u5CDA\u5E42\u5E4E\u5E66\u5F25\u5F2D\u5F4C\u6202\u64DF\u6520\u6549\u6993\u6A12\u6AC1\u6C68\u6C95\u6CB5\u6D23\u6DE7\u6E33\u6EF5\u6F1E\u6FD4\u6FD7\u7030\u7056\u7190\u7222\u7315\u737C\u74D5\u772B\u772F\u7787\u7955\u7962\u79B0\u7C1A\u7C73\u7C8E\u7CDC\u7CF8\u7E3B\u7F83\u7F8B\u8112\u8288\u845E\u84BE\u851D\u8524\u85CC\u863C\u871C\u8746\u88AE\u8993\u8994\u899B\u89C5\u8A78\u8B0E\u8B10\u8C1C\u8C27\u8E0E\u8FF7\u919A\u91BE\u91BF\u91C4\u92A4\u957E\u9761\u9E0D\u9E8A\u9E8B\u9E9B\u9F0F",
            "Mian": "\u4E0F\u4FDB\u506D\u514D\u5195\u52C9\u52D4\u5595\u5A29\u5A42\u5A94\u5B35\u5B80\u6110\u68C9\u6AB0\u6ACB\u6C45\u6C94\u6E4E\u7704\u7720\u77C8\u77CA\u77CF\u7CC6\u7DBF\u7DDC\u7DEC\u7EF5\u7F05\u817C\u81F1\u8287\u8442\u8752\u9762\u9763\u9BB8\u9EAA\u9EAB\u9EB5\u9EBA\u9EFE",
            "Mie": "\u4E5C\u5400\u54A9\u54F6\u5B6D\u5E6D\u61F1\u6423\u6AD7\u6EC5\u700E\u706D\u74F1\u7BFE\u8511\u858E\u881B\u884A\u8995\u9456\u9C74\u9D13",
            "Min": "\u50F6\u51A7\u51BA\u5221\u52C4\u578A\u59C4\u5CB7\u5D0F\u5FDE\u600B\u60AF\u610D\u615C\u61AB\u62BF\u636A\u6543\u654F\u656F\u65FB\u65FC\u668B\u6C11\u6CEF\u6E63\u6F63\u739F\u73C9\u7418\u741D\u7449\u75FB\u76BF\u76FF\u7888\u7B22\u7B3D\u7C22\u7DCD\u7DE1\u7F17\u7F60\u82E0\u8820\u8CEF\u9231\u9309\u9372\u9594\u95A9\u95F5\u95FD\u9C35\u9CD8\u9D16\u9EFD",
            "Ming": "\u4F72\u51A5\u51D5\u540D\u547D\u59F3\u5AC7\u614F\u63B5\u660E\u669D\u6719\u69A0\u6D3A\u6E9F\u733D\u7700\u7733\u7791\u8317\u84C2\u879F\u89AD\u8A7A\u910D\u9169\u9298\u94ED\u9CF4\u9E23",
            "Miu": "\u7E46\u8B2C\u8C2C",
            "Mo": "\u4E6E\u5298\u52B0\u55FC\u56A4\u56A9\u573D\u587B\u58A8\u59BA\u5AEB\u5AFC\u5BDE\u5C1B\u5E13\u5E1E\u603D\u61E1\u6478\u6479\u64F5\u6629\u66AF\u672B\u67BA\u6A45\u6B7E\u6B7F\u6B81\u6CAB\u6F20\u7205\u763C\u768C\u771C\u773D\u773F\u7790\u7799\u781E\u78E8\u7933\u79E3\u7C96\u7CE2\u7D48\u7E38\u7E86\u8031\u819C\u8309\u8388\u83AB\u84E6\u85E6\u8611\u86E8\u87D4\u88B9\u8B28\u8B29\u8B55\u8C1F\u8C83\u8C8A\u8C98\u9286\u93CC\u9546\u964C\u977A\u9943\u995D\u998D\u9A40\u9ACD\u9B54\u9B69\u9B79\u9EBC\u9EBD\u9EBF\u9ED8\u9ED9",
            "Mou": "\u4F94\u52BA\u54DE\u6048\u6859\u6D20\u725F\u7738\u77B4\u87F1\u8B00\u8C0B\u927E\u936A\u9D3E\u9EB0",
            "Mu": "\u4E06\u4EA9\u4EEB\u51E9\u52DF\u5776\u5893\u58B2\u59C6\u5A12\u5CD4\u5E55\u5E59\u6154\u6155\u62C7\u65C0\u66AE\u6728\u6927\u6958\u6A22\u6BCD\u6BE3\u6BEA\u6C01\u6C90\u7091\u7261\u7267\u7273\u72C7\u734F\u7546\u7552\u755D\u755E\u756E\u76EE\u7766\u782A\u7A46\u80DF\u8252\u82DC\u83AF\u843A\u869E\u8E07\u9267\u926C\u94BC\u96EE\u9702\u97AA",
            "Na": "\u4E78\u5185\u5436\u54EA\u55F1\u59A0\u62CF\u62FF\u6310\u637A\u7B1D\u7D0D\u7EB3\u80AD\u84B3\u8872\u88A6\u8ABD\u8C7D\u8C80\u8EDC\u90A3\u9209\u93BF\u94A0\u954E\u96EB\u9779\u9B76",
            "Nai": "\u4E43\u5037\u5948\u5976\u59B3\u5B2D\u5B7B\u5EFC\u6468\u67F0\u6C16\u6E3F\u718B\u7593\u8010\u8149\u827F\u8418\u879A\u8926\u8FFA\u91E2\u933C\u9F10",
            "Nan": "\u4FBD\u5357\u5583\u56E1\u5A1A\u5A7B\u6201\u62A9\u63C7\u6694\u678F\u67AC\u67DF\u6960\u6E73\u7175\u7537\u7558\u8169\u83AE\u8433\u877B\u8AF5\u8D67\u9056\u96BE\u96E3",
            "Nao": "\u5318\u5476\u57B4\u5816\u5912\u5A65\u5AD0\u5B6C\u5CF1\u5DA9\u5DCE\u6013\u607C\u60A9\u60F1\u6320\u6493\u6A82\u6DD6\u7331\u7376\u737F\u7459\u7847\u7899\u78AF\u8111\u8133\u8166\u81D1\u86F2\u87EF\u8A49\u8B4A\u9403\u94D9\u9599\u95F9\u9B27",
            "Ne": "\u5450\u5462\u6290\u7592\u7732\u8A25\u8BB7",
            "Nei": "\u5167\u5A1E\u6C1D\u713E\u8147\u9912\u9981\u9BBE\u9BD8",
            "Nen": "\u5AE9\u80FD",
            "Ni": "\u4F31\u4F32\u4F60\u502A\u5117\u511E\u533F\u576D\u57FF\u5804\u59AE\u5A57\u5ADF\u5B3A\u5B74\u5C3C\u5C54\u5C70\u6029\u60C4\u6135\u62B3\u62DF\u639C\u64EC\u65CE\u6635\u6672\u66B1\u67C5\u68FF\u6AB7\u6C3C\u6CE5\u6DE3\u6EBA\u72D4\u730A\u75C6\u7724\u7768\u79DC\u7C7E\u7E0C\u80D2\u817B\u81A9\u81E1\u82E8\u85BF\u86AD\u873A\u89EC\u8C8E\u8DDC\u8F17\u8FE1\u9006\u90F3\u922E\u9268\u9448\u94CC\u96AC\u9713\u999C\u9BE2\u9CB5\u9E91\u9F6F",
            "Nian": "\u5344\u54D6\u57DD\u59E9\u5E74\u5EFF\u5FF5\u62C8\u637B\u649A\u64B5\u6506\u6D8A\u6DF0\u78BE\u79CA\u79E5\u7C10\u824C\u8E68\u8E8E\u8F26\u8F87\u9B8E\u9BF0\u9C87\u9CB6\u9D47\u9ECF",
            "Niang": "\u5A18\u5B22\u5B43\u917F\u91B8\u91C0",
            "Niao": "\u5ACB\u5B1D\u5B32\u5C3F\u8132\u8311\u8312\u8526\u8885\u88CA\u892D\u9CE5\u9E1F",
            "Nie": "\u556E\u55A6\u55EB\u565B\u5699\u56C1\u56D3\u573C\u5B7C\u5B7D\u5D72\u5DAD\u5DD5\u5E07\u60D7\u634F\u63D1\u6470\u655C\u67BF\u69F7\u6AF1\u6D85\u7BDE\u7C4B\u7CF1\u7CF5\u8042\u8076\u8080\u81EC\u81F2\u82F6\u83CD\u8616\u8825\u8B98\u8E02\u8E17\u8E19\u8E51\u8EA1\u9269\u931C\u93B3\u9477\u9480\u954A\u954D\u95D1\u9667\u9689\u9873\u989E\u9F67",
            "Nin": "\u56DC\u60A8\u62F0\u810C",
            "Ning": "\u4F5E\u4FAB\u511C\u51DD\u549B\u5680\u5B23\u5B81\u5BCD\u5BD5\u5BD7\u5BDC\u5BE7\u62E7\u64F0\u67E0\u6A63\u6AB8\u6CDE\u6F9D\u6FD8\u72DE\u7370\u752F\u77C3\u804D\u8079\u85B4\u944F\u9B21\u9E0B",
            "Niu": "\u599E\u5FF8\u626D\u677B\u6C7C\u6C91\u7084\u725B\u725C\u72C3\u7D10\u7EBD\u83A5\u9215\u94AE\u9775",
            "Nong": "\u4FAC\u5102\u519C\u54DD\u5665\u61B9\u630A\u6335\u6B01\u6D53\u6FC3\u7651\u79AF\u79FE\u7A60\u7E77\u8113\u81BF\u857D\u895B\u8FB2\u8FB3\u91B2\u9F48",
            "Nu": "\u4F16\u4F2E\u5089\u52AA\u5974\u5B65\u5F29\u6012\u6419\u782E\u7B2F\u80EC\u99D1\u9A7D",
            "Nv": "\u5973\u6067\u6712\u7C79\u8842\u8844\u91F9\u9495",
            "Nuan": "\u597B\u6696\u6E1C\u7156\u7157\u992A",
            "nue": "\u8c11\u8650",
            "Nuo": "\u50A9\u513A\u558F\u61E6\u61E7\u632A\u63BF\u6426\u643B\u685B\u689B\u6992\u6A60\u71F6\u7878\u7A2C\u7A64\u7CD1\u7CE5\u7CEF\u8AFE\u8BFA\u8E43\u903D\u90CD\u9369\u9518\u9EC1",
            "Ou": "\u4E6F\u5076\u5418\u5455\u54E6\u5614\u5662\u5878\u591E\u6004\u616A\u6AD9\u6B27\u6B50\u6BB4\u6BC6\u6BEE\u6CA4\u6F1A\u71B0\u74EF\u750C\u7B7D\u8026\u8162\u8192\u8545\u85D5\u85F2\u8B33\u8BB4\u93C2\u97B0\u9D0E\u9DD7\u9E25\u9F75",
            "Pa": "\u556A\u5991\u5E0A\u5E15\u6015\u63B1\u6777\u6F56\u722C\u7436\u7685\u7B62\u8019\u8225\u8469\u8899\u8DB4",
            "Pai": "\u4FF3\u54CC\u5F98\u62CD\u6392\u68D1\u6D3E\u6E43\u724C\u72A4\u7305\u78D7\u7B84\u7C30\u848E\u8F2B\u9383",
            "Pan": "\u51B8\u5224\u53DB\u5762\u5ABB\u5E4B\u642B\u6500\u67C8\u69C3\u6C9C\u6CEE\u6EBF\u6F58\u700A\u708D\u723F\u7249\u7554\u7568\u76D8\u76E4\u76FC\u7705\u78D0\u7E0F\u84B0\u87E0\u88A2\u897B\u8A4A\u8DD8\u8E52\u8E63\u92EC\u939C\u947B\u97B6\u9816\u9D65",
            "Pang": "\u4E53\u5390\u55D9\u5ACE\u5E9E\u65C1\u6C78\u6C97\u6EC2\u7090\u7BE3\u802A\u80A8\u80EE\u8196\u823D\u8783\u882D\u89AB\u9004\u96F1\u9736\u9AC8\u9C1F\u9CD1\u9F8E\u9F90",
            "Pao": "\u530F\u5486\u5789\u5945\u5E96\u629B\u62CB\u6CE1\u70B0\u722E\u72CD\u75B1\u76B0\u7832\u791F\u792E\u812C\u8422\u86AB\u888D\u891C\u8DD1\u8EF3\u9784\u9E85\u9EAD",
            "Pei": "\u4F02\u4F69\u4FD6\u5478\u57F9\u59F5\u5D8F\u5E14\u600C\u65BE\u65C6\u67F8\u6BF0\u6C9B\u6D7F\u73EE\u7B29\u80A7\u80DA\u84DC\u8843\u88F4\u88F5\u8CE0\u8D54\u8F61\u8F94\u914D\u9185\u9307\u952B\u962B\u966A\u966B\u9708\u99B7",
            "Pen": "\u5460\u55AF\u55B7\u5674\u6B55\u6E53\u6FC6\u74EB\u76C6\u7FC9\u7FF8\u8450",
            "Peng": "\u4E76\u5017\u50B0\u527B\u5309\u55B8\u562D\u580B\u585C\u5873\u5DFC\u5F38\u5F6D\u6026\u6072\u6189\u62A8\u6337\u6367\u63BD\u6412\u670B\u6888\u68DA\u6916\u692A\u69F0\u6A25\u6CD9\u6D4C\u6DCE\u6F28\u6F30\u6F8E\u70F9\u71A2\u768F\u7830\u7851\u787C\u78B0\u78DE\u7A1D\u7AFC\u7BF7\u7E84\u80D3\u81A8\u8283\u8391\u84EC\u87DA\u87DB\u8E2B\u8EEF\u8F23\u930B\u945D\u959B\u95CF\u97F8\u97FC\u99CD\u9A2F\u9AFC\u9B05\u9B14\u9D6C\u9E4F",
            "Pi": "\u4E15\u4EF3\u4F13\u4F3E\u50FB\u5288\u5339\u5564\u567C\u567D\u568A\u56AD\u572E\u576F\u57E4\u58C0\u5AB2\u5AD3\u5C41\u5CAF\u5D25\u5E80\u6036\u6082\u61B5\u6279\u62AB\u62B7\u63CA\u64D7\u65C7\u6707\u6787\u6911\u698C\u6BD7\u6BD8\u6BDE\u6DE0\u6E12\u6F4E\u6FBC\u708B\u7137\u72C9\u72D3\u7435\u7513\u7588\u75B2\u75DE\u7656\u76AE\u7764\u7765\u7812\u78C7\u7914\u7915\u79DB\u79E0\u7B13\u7BFA\u7C32\u7D15\u7EB0\u7F74\u7F86\u7FCD\u801A\u80B6\u8134\u813E\u8157\u818D\u8298\u82C9\u868D\u86BD\u8731\u87B7\u882F\u8AC0\u8B6C\u8C7C\u8C7E\u8C94\u90B3\u90EB\u91FD\u921A\u9239\u925F\u9294\u92A2\u9303\u930D\u94CD\u95E2\u9630\u9674\u96A6\u9739\u99D3\u9AEC\u9B6E\u9B7E\u9B8D\u9C8F\u9D04\u9D67\u9DFF\u9E0A\u9F19",
            "Pian": "\u504F\u56E8\u5AA5\u6944\u6969\u7247\u728F\u7BC7\u7FE9\u80FC\u8141\u8991\u8ADA\u8ADE\u8C1D\u8CB5\u8CC6\u8E41\u99E2\u9A08\u9A17\u9A19\u9A88\u9A97\u9ABF\u9B78\u9DA3",
            "Piao": "\u50C4\u527D\u52E1\u560C\u5AD6\u5F6F\u5FB1\u6153\u65DA\u6B8D\u6F02\u72A5\u74E2\u76AB\u779F\u78E6\u7968\u7BFB\u7E39\u7F25\u7FF2\u85B8\u87B5\u91A5\u95DD\u9860\u98C3\u98C4\u98D8\u9B52",
            "Pie": "\u4E3F\u5AF3\u6486\u6487\u66BC\u6C15\u77A5\u82E4\u9405",
            "Pin": "\u54C1\u56AC\u59D8\u5A09\u5AD4\u5B2A\u62FC\u6729\u6980\u6C56\u725D\u73AD\u7415\u77C9\u7917\u7A66\u8058\u85B2\u8CA7\u8D2B\u983B\u9870\u9891\u98A6\u99AA\u9A5E",
            "Ping": "\u4E52\u4FDC\u51ED\u51F4\u546F\u576A\u5840\u5A26\u5C5B\u5CBC\u5E21\u5E32\u5E48\u5E73\u617F\u6191\u67B0\u6A98\u6D34\u6D84\u6DDC\u7129\u73B6\u74F6\u7501\u7539\u782F\u7AEE\u7BB3\u7C08\u7F3E\u8060\u8275\u82F9\u8353\u840D\u84F1\u860B\u86B2\u86E2\u8A55\u8BC4\u8EFF\u8F27\u90F1\u9829\u9B83\u9C86",
            "Po": "\u53F5\u54F1\u5619\u5761\u5964\u5A1D\u5A46\u5C00\u5CA5\u5CB6\u5EF9\u6540\u6622\u6AC7\u6CFC\u6D26\u6E8C\u6F51\u70DE\u73C0\u76A4\u7834\u7836\u7B38\u7C95\u84AA\u8522\u8B08\u9131\u9166\u91B1\u91D9\u9255\u93FA\u948B\u94B7\u9817\u9887\u99CA\u9B44",
            "Pou": "\u517A\u5256\u5485\u54DB\u54E3\u5837\u5A44\u6294\u6299\u634A\u638A\u7283\u7B81\u88D2\u9892",
            "Pu": "\u4EC6\u50D5\u530D\u5657\u5703\u5711\u5724\u57D4\u58A3\u5DEC\u5DED\u6251\u62AA\u64B2\u64C8\u6534\u6535\u666E\u669C\u67E8\u6A38\u6A8F\u6C06\u6D66\u6EA5\u6F7D\u6FEE\u7087\u70F3\u749E\u75E1\u77A8\u7A59\u7E80\u8216\u8217\u8386\u83D0\u83E9\u8461\u84B1\u84B2\u8AE9\u8B5C\u8C31\u8D0C\u8E7C\u917A\u92EA\u93F7\u9420\u94FA\u9564\u9568\u9660\u99C7\u9BC6",
            "Qi": "\u4E03\u4E5E\u4E93\u4E9D\u4F01\u501B\u50DB\u5176\u51C4\u5258\u542F\u5447\u546E\u54A0\u5518\u552D\u5553\u5554\u555F\u5601\u5650\u5668\u573B\u57FC\u5921\u5951\u59BB\u5A38\u5A4D\u5C7A\u5C82\u5C90\u5C93\u5D0E\u5D5C\u5E3A\u5F03\u5FEF\u6053\u60BD\u6112\u612D\u617C\u617D\u6187\u61A9\u61E0\u621A\u637F\u6391\u6456\u6589\u658A\u65C2\u65D7\u6675\u66A3\u671E\u671F\u675E\u67D2\u6814\u6864\u687C\u68C4\u68CA\u68CB\u68E8\u68F2\u69BF\u69ED\u6AB1\u6AC0\u6B2B\u6B3A\u6B67\u6C14\u6C17\u6C23\u6C54\u6C7D\u6C8F\u6CE3\u6DC7\u6DD2\u6E0F\u6E46\u6E47\u6F06\u6FDD\u7081\u7309\u7382\u7398\u7426\u742A\u7482\u7508\u7566\u75A7\u76C0\u76F5\u77F5\u780C\u7881\u7895\u789B\u78B6\u78CE\u78DC\u78E7\u78E9\u7918\u7941\u7947\u7948\u797A\u79A5\u7AD2\u7C2F\u7C31\u7C4F\u7CB8\u7D2A\u7DA5\u7DA6\u7DA8\u7DAE\u7DBA\u7DC0\u7DD5\u7E83\u7EEE\u7F3C\u7F4A\u8006\u80B5\u8110\u81CD\u8269\u8291\u829E\u82AA\u8360\u8401\u840B\u847A\u8572\u85BA\u85C4\u8604\u8691\u8694\u869A\u86F4\u871D\u871E\u87A7\u87FF\u8810\u88FF\u8900\u8904\u8A16\u8AC6\u8AEC\u8AFF\u8BAB\u8C48\u8D77\u8DC2\u8E11\u8E26\u8EDD\u8FC4\u8FC9\u9094\u90EA\u91EE\u9321\u93DA\u951C\u95D9\u970B\u980E\u9880\u9A0E\u9A0F\u9A39\u9A90\u9A91\u9B10\u9B3E\u9B3F\u9B4C\u9B55\u9BD5\u9C2D\u9CAF\u9CCD\u9D78\u9D80\u9D88\u9E92\u9EA1\u9F4A\u9F50",
            "Qia": "\u51BE\u5736\u5E22\u6070\u6118\u62E4\u6390\u6B8E\u6D3D\u7848\u845C\u8DD2\u9160\u9790\u9AC2",
            "Qian": "\u4E79\u4E7E\u4EDF\u4EF1\u4F23\u4F65\u4FD4\u5029\u5042\u5094\u50C9\u5119\u51F5\u520B\u524D\u5343\u55DB\u5731\u5732\u5811\u5879\u5898\u58CD\u5977\u5A5C\u5A8A\u5B31\u5B6F\u5C8D\u5C92\u5D4C\u5D70\u5FF4\u6093\u60AD\u6106\u614A\u6173\u6266\u6272\u62D1\u62EA\u6394\u63AE\u63F5\u6434\u647C\u6481\u6510\u6511\u6513\u6744\u68C8\u6920\u69A9\u69CF\u69E7\u6A6C\u6AB6\u6ACF\u6B20\u6B26\u6B49\u6B6C\u6C58\u6C67\u6D45\u6DFA\u6F5B\u6F5C\u6FF3\u704A\u7275\u727D\u7698\u7ACF\u7B7E\u7B9D\u7B9E\u7BCF\u7BDF\u7C3D\u7C56\u7C64\u7C81\u7DAA\u7E34\u7E7E\u7F31\u7FAC\u80B7\u8181\u81E4\u828A\u82A1\u831C\u833E\u84A8\u8533\u8541\u8654\u8688\u8738\u8930\u8AD0\u8B19\u8B74\u8C26\u8C34\u8C38\u8EE1\u8F24\u8FC1\u9063\u9077\u91FA\u9206\u9210\u9246\u9257\u925B\u92AD\u9322\u9386\u93F2\u9431\u9453\u948E\u94A4\u94B1\u94B3\u94C5\u9621\u96C3\u97C6\u9845\u9A1A\u9A1D\u9A2B\u9A9E\u9B1C\u9B1D\u9C2C\u9D6E\u9E50\u9ED4\u9EDA",
            "Qiang": "\u515B\u545B\u5534\u55C6\u55F4\u588F\u5899\u58BB\u5AF1\u5B19\u5D88\u5EE7\u5F37\u6215\u6217\u6227\u62A2\u6436\u6464\u65A8\u67AA\u690C\u69CD\u6A2F\u6AA3\u6EAC\u6F12\u709D\u7197\u7244\u7246\u7310\u7347\u73B1\u7437\u7472\u74E9\u7BEC\u7E48\u7E66\u7F8C\u7F97\u7F9F\u7FA5\u7FAB\u7FBB\u8154\u8262\u8503\u8537\u8594\u8620\u8723\u8941\u8B12\u8DC4\u8E4C\u8E61\u9306\u9397\u93D8\u93F9\u9516\u9535\u956A",
            "Qiao": "\u4E54\u4FA8\u4FCF\u50D1\u50FA\u5281\u55AC\u563A\u589D\u58BD\u5AF6\u5CED\u5D6A\u5DE7\u5E29\u5E67\u6084\u6100\u6194\u64AC\u64BD\u6572\u6865\u69D7\u6A35\u6A47\u6A4B\u6BBC\u71C6\u729E\u7644\u7744\u77A7\u7857\u785A\u78BB\u78FD\u7904\u7A8D\u7AC5\u7E51\u7E70\u7F32\u7FD8\u7FF9\u834D\u835E\u83EC\u854E\u85EE\u8A9A\u8B59\u8BEE\u8C2F\u8DAB\u8DAC\u8DF7\u8E0D\u8E7A\u8E7B\u8E88\u90FB\u9117\u9121\u9125\u91E5\u936B\u936C\u9408\u9430\u9539\u9657\u9792\u9798\u97A9\u97BD\u97D2\u981D\u9866\u9AB9\u9ADA\u9ADC",
            "Qie": "\u4E14\u503F\u5207\u5327\u5392\u59BE\u602F\u608F\u60EC\u611C\u6308\u6705\u6D2F\u6DC1\u767F\u7A55\u7A83\u7ACA\u7B21\u7BA7\u7BCB\u7C61\u7DC1\u807A\u82C6\u85D2\u86EA\u8E25\u9365\u9411\u9532\u9B65\u9BDC",
            "Qin": "\u4FB5\u52E4\u5422\u5423\u551A\u55EA\u5659\u5745\u57C1\u5A87\u5AC0\u5BD1\u5BDD\u5BE2\u5BF4\u5D5A\u5D94\u5E88\u61C3\u61C4\u628B\u6366\u63FF\u6407\u64B3\u64D2\u65B3\u6611\u68AB\u6A8E\u6B3D\u6C81\u6EB1\u6FBF\u7019\u73E1\u7434\u7439\u763D\u77DD\u79BD\u79E6\u7B09\u7D85\u8039\u82A9\u82B9\u83E3\u83E6\u83F3\u85FD\u8699\u8793\u87BC\u8804\u887E\u89AA\u8A9B\u8D7A\u8D7E\u9219\u92DF\u94A6\u9513\u96C2\u9772\u9849\u99F8\u9A8E\u9BBC\u9CF9",
            "Qing": "\u503E\u50BE\u512C\u51CA\u5260\u52CD\u537F\u570A\u57E5\u591D\u5E86\u5EBC\u5ECE\u60C5\u6176\u6385\u64CE\u64CF\u6674\u6692\u68FE\u6A08\u6AA0\u6ABE\u6AE6\u6B91\u6BB8\u6C22\u6C2B\u6C30\u6DF8\u6E05\u6F00\u6FEA\u7520\u7858\u7883\u78EC\u7B90\u7F44\u82D8\u845D\u873B\u8ACB\u8B26\u8BF7\u8EFD\u8F15\u8F7B\u90EC\u944B\u9751\u9752\u9758\u9803\u9877\u9BD6\u9CAD\u9EE5",
            "Qiong": "\u511D\u536D\u5B86\u60F8\u618C\u684F\u6A69\u712A\u712D\u7162\u718D\u743C\u749A\u74CA\u74D7\u7758\u778F\u7A77\u7A79\u7AAE\u7AC6\u7B3B\u7B47\u823C\u8315\u85D1\u85ED\u86E9\u86EC\u8D79\u8DEB\u909B\u928E",
            "Qiu": "\u4E18\u4E20\u4FC5\u53F4\u5512\u56DA\u5775\u5A9D\u5BC8\u5D37\u5DEF\u5DF0\u6058\u624F\u641D\u6739\u6882\u6978\u6B8F\u6BEC\u6C42\u6C53\u6CC5\u6D57\u6E1E\u6E6D\u716A\u72B0\u738C\u7403\u7486\u76B3\u76DA\u79CB\u79CC\u7A50\u7BCD\u7CD7\u7D0C\u7D7F\u7DE7\u808D\u838D\u8429\u84F2\u8612\u866C\u866F\u86AF\u86F7\u8764\u8775\u87D7\u8824\u88D8\u89D3\u89E9\u8A04\u8A05\u8CD5\u8D47\u8DA5\u900E\u9011\u9052\u90B1\u914B\u9194\u91DA\u91FB\u92B6\u97A6\u97A7\u9B82\u9BC4\u9C0C\u9C0D\u9C3D\u9C43\u9CC5\u9D6D\u9D96\u9E59\u9F3D\u9F9D",
            "Qu": "\u4F39\u4F49\u4F62\u521E\u52AC\u5324\u5337\u533A\u5340\u53BA\u53BB\u53D6\u547F\u5765\u5A36\u5C48\u5C96\u5CA8\u5CB4\u5D87\u5FC2\u6188\u6235\u62BE\u657A\u65AA\u66F2\u6710\u6711\u6B0B\u6C0D\u6D40\u6DED\u6E20\u7048\u7496\u74A9\u766F\u78F2\u795B\u7AD8\u7AEC\u7B41\u7C67\u7CAC\u7D36\u7D47\u7FD1\u7FF5\u801D\u80CA\u80E0\u81DE\u83C3\u844B\u8556\u8627\u86C6\u86D0\u877A\u87B6\u87DD\u8837\u883C\u8850\u8862\u88AA\u89B0\u89B7\u89BB\u89D1\u8A53\u8A58\u8AB3\u8BCE\u8D8B\u8DA3\u8DA8\u8EA3\u8EAF\u8EC0\u8EE5\u8FF2\u90E5\u947A\u95B4\u95C3\u9612\u9639\u99C6\u99C8\u9A45\u9A71\u9AF7\u9B7C\u9C38\u9C4B\u9D1D\u9E1C\u9E32\u9EAE\u9EAF\u9EB4\u9EB9\u9EE2\u9F01\u9F29\u9F72\u9F8B",
            "Quan": "\u4F7A\u5168\u5238\u529D\u52E7\u52F8\u5573\u570F\u57E2\u59FE\u5A58\u5B49\u5CD1\u5DCF\u5DFB\u606E\u609B\u60D3\u62F3\u643C\u6743\u68EC\u6926\u697E\u6A29\u6B0A\u6C71\u6CC9\u6D24\u6E76\u70C7\u7276\u7277\u7288\u72AC\u72AD\u7454\u753D\u754E\u75CA\u7842\u7B4C\u7D5F\u7DA3\u7E13\u7EFB\u8143\u8343\u8472\u8647\u8737\u8838\u89E0\u8A6E\u8BE0\u8DE7\u8E21\u8F07\u8F81\u919B\u9293\u9409\u94E8\u95CE\u97CF\u9874\u98A7\u99E9\u9A21\u9B08\u9C01\u9CC8\u9F64",
            "Que": "\u5374\u537B\u57C6\u5859\u58A7\u5D05\u60AB\u6128\u6164\u6409\u69B7\u6BC3\u7094\u71E9\u7638\u76B5\u785E\u786E\u788F\u78BA\u7910\u792D\u7F3A\u8203\u849B\u8D9E\u95CB\u95D5\u9615\u9619\u9D72\u9E4A",
            "Qun": "\u56F7\u590B\u5BAD\u5CEE\u5E2C\u7FA3\u7FA4\u88D9\u88E0\u8F11\u9021",
            "Ran": "\u5184\u5189\u5465\u562B\u59CC\u5AA3\u67D3\u6A6A\u7136\u71C3\u73C3\u7E4E\u80B0\u82D2\u8485\u86A6\u86BA\u887B\u8887\u88A1\u9AE5\u9AEF",
            "Rang": "\u5134\u52F7\u56B7\u58CC\u58E4\u61F9\u6518\u703C\u7219\u737D\u74E4\u79B3\u7A63\u7A70\u7E95\u8618\u8B72\u8B93\u8BA9\u8E9F\u9B24",
            "Rao": "\u5A06\u5B08\u6270\u64FE\u6861\u6A48\u72AA\u7E5E\u7ED5\u835B\u8558\u8953\u9076\u96A2\u9952\u9976",
            "Ruo": "\u504C\u53D2\u5A7C\u5D76\u5F31\u633C\u637C\u6949\u6E03\u712B\u7207\u7BAC\u7BDB\u82E5\u84BB\u9100\u9C19\u9C2F\u9DB8",
            "Re": "\u60F9\u70ED\u71B1",
            "Ren": "\u4EBA\u4EBB\u4EC1\u4EDE\u4EED\u4EFB\u5203\u5204\u58EC\u598A\u59D9\u5C7B\u5FC8\u5FCD\u5FCE\u6041\u6268\u6732\u6752\u6820\u6823\u6895\u68EF\u7263\u79C2\u79F9\u7A14\u7D09\u7D1D\u7D4D\u7D9B\u7EAB\u7EB4\u8095\u814D\u82A2\u834F\u8375\u887D\u88B5\u8A12\u8A8D\u8BA4\u8BB1\u8EB5\u8ED4\u8F6B\u9213\u928B\u976D\u9771\u97CC\u97E7\u98EA\u9901\u996A\u9B5C\u9D40",
            "Reng": "\u4ECD\u6254\u793D\u82BF\u8FB8\u967E",
            "Ri": "\u56F8\u65E5\u91F0\u9224\u99B9\u9A72",
            "Rong": "\u5087\u5197\u5AB6\u5AC6\u5B2B\u5B82\u5BB9\u5CF5\u5D58\u5D64\u5DB8\u620E\u6408\u6411\u6449\u66E7\u6804\u6995\u69AE\u69B5\u6BE7\u6C04\u6EB6\u701C\u70FF\u7194\u7203\u72E8\u7462\u7A41\u7A43\u7D68\u7E19\u7ED2\u7FA2\u809C\u8319\u8338\u8363\u84C9\u877E\u878D\u878E\u8811\u8923\u8EF5\u9394\u9555\u99E5\u9AF6",
            "Rou": "\u53B9\u5A83\u5B8D\u63C9\u67D4\u697A\u6E18\u7163\u7448\u74C7\u79B8\u7C88\u7CC5\u8089\u816C\u8447\u875A\u8E42\u8F2E\u9352\u97A3\u97D6\u9A25\u9C07\u9D94",
            "Ru": "\u4E73\u4F9E\u5112\u5165\u55D5\u5685\u5982\u5AB7\u5B2C\u5B7A\u5DBF\u5E24\u6256\u64E9\u66D8\u6741\u6847\u6C5D\u6D33\u6E2A\u6EBD\u6FE1\u71F8\u7B4E\u7E1F\u7E7B\u7F1B\u8097\u8339\u8498\u84D0\u8560\u85B7\u8815\u88BD\u8925\u8966\u8FB1\u8FBC\u909A\u910F\u91B9\u92A3\u94F7\u986C\u98A5\u9C6C\u9CF0\u9D11\u9D3D",
            "Ruan": "\u5044\u5827\u58D6\u5A86\u5AF0\u611E\u648B\u670A\u744C\u74C0\u789D\u791D\u7DDB\u800E\u815D\u8761\u8EDF\u8F2D\u8F6F\u962E",
            "Rui": "\u53E1\u58E1\u6798\u6875\u6A64\u6C6D\u745E\u7524\u777F\u7DCC\u7E60\u82AE\u854A\u854B\u8564\u8602\u8603\u868B\u8739\u92B3\u92ED\u9510",
            "Run": "\u6A4D\u6DA6\u6F64\u958F\u95A0\u95F0",
            "Sa": "\u4EE8\u5345\u644B\u6492\u680D\u686C\u6AD2\u6D12\u6F75\u7051\u810E\u8428\u85A9\u8A2F\u9212\u9491\u96A1\u9778\u98AF\u98D2\u99BA",
            "Sai": "\u50FF\u55EE\u5625\u567B\u6122\u63CC\u6BE2\u6BF8\u7C3A\u816E\u8644\u8CFD\u8D5B\u984B\u9C13\u9CC3",
            "San": "\u4E09\u4F1E\u4FD5\u5098\u5381\u53C1\u58ED\u5F0E\u6563\u6A75\u6BF5\u6BF6\u6BFF\u7299\u7CC1\u7CC2\u7CDD\u7CE3\u7CE4\u7E56\u93D2\u9590\u994A\u9993\u9B16",
            "Sang": "\u4E27\u55AA\u55D3\u6421\u6851\u6852\u69E1\u78C9\u892C\u939F\u9859\u98A1",
            "Sao": "\u57FD\u5AC2\u6145\u626B\u6383\u63BB\u6414\u6C09\u6E9E\u7619\u77C2\u7E45\u7F2B\u81CA\u98BE\u9A12\u9A37\u9A9A\u9ADE\u9C20\u9C62\u9CCB",
            "Se": "\u556C\u55C7\u61CE\u64CC\u681C\u69EE\u6B6E\u6B70\u6D13\u6DA9\u6E0B\u6F80\u6F81\u6FC7\u6FCF\u7012\u7417\u745F\u74B1\u7637\u7A51\u7A61\u7A6F\u7BF8\u7E07\u7E6C\u8053\u88C7\u8942\u8B45\u8F56\u92AB\u93FC\u94EF\u95AA\u96ED\u98CB\u9B19",
            "sen": "\u68ee",
            "seng": "\u50e7",
            "Sha": "\u4E77\u503D\u50BB\u510D\u5239\u5526\u553C\u5565\u55A2\u5E39\u6331\u6740\u699D\u6A27\u6B43\u6BBA\u6C99\u715E\u7300\u75E7\u7802\u7870\u7B91\u7C86\u7D17\u7E4C\u7E7A\u7EB1\u7FDC\u7FE3\u838E\u8410\u8531\u88DF\u93A9\u94E9\u95AF\u95B7\u970E\u9B66\u9BCA\u9BCB\u9CA8",
            "Shai": "\u6652\u66EC\u7B5B\u7BE9\u7C01\u7C1B",
            "Shan": "\u5093\u50D0\u5220\u522A\u5261\u527C\u5584\u5607\u5738\u57CF\u58A0\u58A1\u59CD\u59D7\u5B17\u5C71\u5E53\u5F61\u6247\u633B\u6427\u64C5\u657E\u6671\u66D1\u6763\u692B\u6A3F\u6A86\u6C55\u6F78\u6F98\u7057\u70B6\u70FB\u7154\u717D\u718C\u72E6\u73CA\u759D\u75C1\u7752\u78F0\u7B18\u7E3F\u7E55\u7F2E\u7FB4\u7FB6\u8120\u81B3\u81BB\u8222\u829F\u82EB\u852A\u87EE\u87FA\u886B\u89A2\u8A15\u8B06\u8B71\u8BAA\u8D0D\u8D61\u8D78\u8DDA\u8ED5\u9096\u912F\u91E4\u928F\u9425\u9490\u9583\u958A\u95EA\u9655\u965D\u994D\u9A38\u9A9F\u9BC5\u9C53\u9C54\u9CDD",
            "Shang": "\u4E04\u4E0A\u4EE9\u4F24\u50B7\u5546\u57A7\u5892\u5C19\u5C1A\u6066\u6113\u616F\u6244\u664C\u6B87\u6BA4\u6EF3\u6F21\u71B5\u7DD4\u7EF1\u850F\u87AA\u89DE\u89F4\u8B2A\u8CDE\u8D4F\u945C\u9B3A",
            "Shao": "\u52AD\u52FA\u5372\u54E8\u5A0B\u5C11\u5F30\u634E\u65D3\u67D6\u68A2\u6F72\u70E7\u713C\u713D\u71D2\u73BF\u7A0D\u7B72\u7D39\u7DA4\u7ECD\u8244\u828D\u82D5\u83A6\u8414\u8571\u86F8\u8891\u8F0E\u90B5\u97F6\u98B5\u9AFE\u9BB9",
            "She": "\u4F58\u538D\u5399\u5962\u5C04\u5F3D\u6151\u6174\u61FE\u6368\u6442\u6444\u6475\u651D\u6AA8\u6B07\u6D89\u6DBB\u6E09\u6EE0\u7044\u731E\u7572\u793E\u820C\u820D\u820E\u850E\u8675\u86C7\u86E5\u8802\u8A2D\u8BBE\u8CD2\u8CD6\u8D4A\u8D66\u8F0B\u97D8\u9A07\u9E9D",
            "Shen": "\u4F38\u4F81\u4FBA\u515F\u547B\u54C2\u5814\u59BD\u59FA\u5A20\u5A76\u5B38\u5BA1\u5BB7\u5BE9\u5C7E\u5CF7\u5F1E\u613C\u614E\u625F\u628C\u661A\u66CB\u67DB\u692E\u6939\u698A\u6C20\u6C88\u6D81\u6DF1\u6E16\u6E17\u6EF2\u700B\u71CA\u73C5\u751A\u7521\u7527\u7533\u7606\u762E\u7712\u7718\u77AB\u77E4\u77E7\u7837\u795E\u7973\u7A7C\u7C76\u7C78\u7D33\u7EC5\u7F59\u7F67\u80BE\u80C2\u8124\u814E\u8460\u84E1\u8518\u8593\u8703\u88D1\u89BE\u8A20\u8A37\u8A75\u8AD7\u8B85\u8BDC\u8C02\u8C09\u8EAB\u90A5\u926E\u92E0\u9823\u99EA\u9B6B\u9BD3\u9BF5\u9C30\u9C3A\u9CB9\u9D62",
            "Sheng": "\u5057\u5269\u5270\u52DD\u5347\u544F\u5723\u58AD\u58F0\u5D4A\u61B4\u6598\u6607\u665F\u6660\u66FB\u67A1\u69BA\u6A73\u6B85\u6CE9\u6E11\u6E3B\u6E66\u6FA0\u713A\u7272\u73C4\u741E\u751F\u7525\u76DB\u771A\u7AD4\u7B19\u7E04\u7E69\u7EF3\u8056\u8072\u80DC\u82FC\u8542\u8B5D\u8CB9\u8CF8\u924E\u935F\u9629\u965E\u9679\u9C66\u9D7F\u9F2A",
            "Shi": "\u4E16\u4E17\u4E68\u4E8A\u4E8B\u4ED5\u4F66\u4F7F\u4F8D\u5158\u5159\u519F\u52BF\u52E2\u5341\u534B\u53D3\u53F2\u545E\u5469\u55DC\u566C\u57D8\u5852\u58EB\u5931\u596D\u59CB\u59FC\u5B15\u5B9E\u5B9F\u5BA4\u5BA9\u5BD4\u5BE6\u5C38\u5C4D\u5C4E\u5CD5\u5D3C\u5D75\u5E02\u5E08\u5E2B\u5F0F\u5F11\u5F12\u5FA5\u5FD5\u6040\u6043\u623A\u62ED\u63D3\u65BD\u65F6\u65F9\u662F\u6630\u6642\u67BE\u67F9\u67FF\u683B\u6981\u69AF\u6AA1\u6C0F\u6D49\u6E5C\u6E64\u6E7F\u6EA1\u6EAE\u6EBC\u6FA8\u6FD5\u70BB\u70D2\u7176\u72EE\u7345\u7461\u74E7\u7702\u770E\u7721\u7757\u77E2\u77F3\u793A\u793B\u794F\u7ACD\u7B36\u7B39\u7B6E\u7BB7\u7BD2\u7C2D\u7C42\u7C6D\u7D41\u8210\u8213\u83B3\u8479\u8492\u8494\u84CD\u8671\u8672\u8680\u8755\u8768\u87AB\u8906\u8937\u896B\u8979\u8996\u89C6\u89E2\u8A66\u8A69\u8A93\u8ADF\u8AE1\u8B1A\u8B58\u8BD5\u8BD7\u8C25\u8C55\u8CB0\u8D33\u8EFE\u8F7C\u8FBB\u9002\u901D\u9048\u9069\u907E\u90BF\u917E\u91C3\u91C8\u91CA\u91CB\u91F6\u9230\u9242\u9243\u9247\u9250\u927D\u92B4\u9366\u94C8\u98DF\u98E0\u98FE\u991D\u9963\u9970\u99DB\u9A76\u9B96\u9BF4\u9C18\u9C23\u9C24\u9CA5\u9CBA\u9CF2\u9CFE\u9DB3\u9E24\u9F2B\u9F2D\u9F5B",
            "Shou": "\u517D\u53CE\u53D7\u552E\u57A8\u58FD\u5900\u5B88\u5BFF\u624B\u624C\u6388\u6536\u6DAD\u72E9\u7363\u7378\u75E9\u7626\u7DAC\u7EF6\u8184\u824F\u93C9\u9996",
            "Shu": "\u4E66\u4FB8\u500F\u5010\u5135\u53D4\u54B0\u587E\u5885\u59DD\u5A4C\u5B70\u5C0C\u5C17\u5EB6\u5EBB\u6037\u6055\u620D\u6292\u6393\u6445\u6504\u6578\u668F\u6691\u66D9\u66F8\u672E\u672F\u675F\u6778\u67A2\u67D5\u6811\u68B3\u6A1E\u6A39\u6A7E\u6B8A\u6BB3\u6BF9\u6BFA\u6CAD\u6DD1\u6F31\u6F44\u6F7B\u6F8D\u6FD6\u702D\u7102\u7479\u74B9\u758E\u758F\u7659\u79EB\u7AD6\u7AEA\u7C54\u7CEC\u7D13\u7D49\u7D80\u7EBE\u7F72\u8167\u8212\u8357\u83FD\u8481\u852C\u85A5\u85AF\u85F7\u866A\u8700\u8834\u8853\u88CB\u8961\u8969\u8C4E\u8D16\u8D4E\u8DFE\u8E08\u8ED7\u8F38\u8F93\u8FF0\u9103\u9265\u9330\u93E3\u964E\u9B9B\u9C6A\u9C70\u9D68\u9D90\u9D91\u9E00\u9ECD\u9F20\u9F21",
            "Shua": "\u5237\u5530\u800D\u8A9C",
            "Shuai": "\u535B\u5E05\u5E25\u6454\u7529\u87C0\u8870",
            "Shuan": "\u62F4\u6813\u6DAE\u8168\u9582\u95E9",
            "Shuang": "\u53CC\u587D\u5B40\u5B47\u6161\u6A09\u6B06\u6EDD\u7040\u723D\u7935\u7E14\u826D\u93EF\u96D9\u971C\u9A3B\u9A66\u9AA6\u9DDE\u9E18\u9E74",
            "Shui": "\u542E\u54FE\u5E28\u696F\u6A53\u6C34\u6C35\u6C3A\u6D97\u6D9A\u7761\u779A\u77A4\u77AC\u7971\u7A05\u7A0E\u813D\u821C\u8563\u88DE\u8AAA\u8AAC\u8AB0\u8C01\u9596\u9806\u987A\u9B0A",
            "shuan": "\u6813\u62f4\u95e9",
            "Shuo": "\u55CD\u55FD\u5981\u6420\u6714\u69CA\u6B36\u70C1\u720D\u7361\u77DF\u7855\u78A9\u7BBE\u84B4\u9399\u9460\u94C4",
            "Si": "\u4E1D\u4E7A\u4E96\u4F40\u4FA1\u4FDF\u4FEC\u5129\u5155\u51D8\u53AE\u53B6\u53F8\u549D\u55E3\u5636\u565D\u56DB\u59D2\u5A30\u5AA4\u5B60\u5BFA\u5DF3\u5EDD\u601D\u6056\u6495\u65AF\u67B1\u67F6\u68A9\u6952\u69B9\u6B7B\u6C5C\u6CC0\u6CD7\u6CE4\u6D0D\u6D98\u6F8C\u7003\u71CD\u726D\u78C3\u7940\u7997\u79A0\u79A9\u79C1\u7AE2\u7B25\u7CF9\u7D72\u7DE6\u7E9F\u7F0C\u7F52\u7F73\u801C\u8082\u8086\u856C\u857C\u8652\u86F3\u8724\u8784\u87A6\u87D6\u87F4\u8997\u8C84\u91F2\u923B\u9270\u92AF\u92D6\u9376\u9401\u9536\u98B8\u98D4\u98E4\u98FC\u9972\u99DF\u9A03\u9A26\u9A77\u9DE5\u9E36\u9F36",
            "Song": "\u502F\u50B1\u51C7\u5A00\u5B8B\u5D27\u5D69\u5D77\u5EBA\u6002\u609A\u612F\u616B\u61BD\u6352\u677E\u6780\u67A9\u67D7\u68A5\u6AA7\u6DDE\u6FCD\u7879\u7AE6\u8038\u8073\u83D8\u8719\u8A1F\u8AA6\u8BBC\u8BF5\u9001\u93B9\u980C\u9882\u9938\u99F7\u9B06",
            "Sou": "\u5081\u51C1\u53DC\u53DF\u55D6\u55FE\u5EC0\u5ECB\u635C\u641C\u6457\u64DE\u64FB\u6AE2\u6EB2\u7340\u7636\u778D\u8258\u8490\u84C3\u85AE\u85EA\u878B\u910B\u9199\u93AA\u953C\u98BC\u98D5\u993F\u998A\u9A2A",
            "Su": "\u4FD7\u5083\u50F3\u55C9\u56CC\u5850\u5851\u5919\u5ACA\u612B\u612C\u619F\u6880\u69A1\u6A0E\u6A15\u6A5A\u6AEF\u6B90\u6CDD\u6D2C\u6D91\u6EAF\u6EB8\u6F5A\u6F65\u738A\u73DF\u749B\u7526\u78BF\u7A23\u7A4C\u7AA3\u7C0C\u7C9B\u7C9F\u7D20\u7E24\u8083\u8085\u8186\u82CF\u850C\u85D7\u8607\u8613\u89EB\u8A34\u8B16\u8BC9\u8C21\u8D9A\u8E5C\u901F\u9061\u906C\u9165\u92C9\u9917\u9A4C\u9A95\u9BC2\u9C50\u9DEB\u9E54",
            "Suan": "\u5334\u72FB\u75E0\u7958\u7B07\u7B6D\u7B97\u849C\u9178",
            "Sui": "\u4E97\u5020\u54F8\u57E3\u590A\u5B18\u5C81\u5D57\u65DE\u6A96\u6B72\u6B73\u6D7D\u6ED6\u6FBB\u6FC9\u7021\u716B\u71A3\u71E7\u74B2\u74CD\u772D\u775F\u7762\u7815\u788E\u795F\u79AD\u7A42\u7A57\u7A5F\u7C8B\u7D8F\u7E40\u7E50\u7E78\u7EE5\u813A\u81B8\u8295\u837D\u837E\u8470\u867D\u895A\u8AB6\u8B62\u8C07\u8CE5\u9040\u9042\u9083\u9406\u9429\u968B\u968F\u96A7\u96A8\u96D6\u9796\u9AC4\u9AD3",
            "Sun": "\u5B59\u5B6B\u5DFA\u635F\u640D\u640E\u69AB\u69C2\u6F60\u72F2\u733B\u7543\u7B0B\u7B4D\u7BB0\u7C28\u836A\u84C0\u8575\u859E\u93A8\u96BC\u98E7\u98F1\u9DBD",
            "Suo": "\u509E\u5506\u5522\u55E6\u55E9\u5A11\u60E2\u6240\u6332\u644D\u669B\u686B\u68AD\u6E91\u6EB9\u7410\u7411\u7463\u7743\u7C11\u7C14\u7D22\u7E2E\u7F29\u7FA7\u838F\u84D1\u8736\u8D96\u9024\u938D\u9396\u93BB\u93BC\u93C1\u9501\u9AFF\u9BBB",
            "Ta": "\u4ED6\u4FA4\u549C\u5683\u56BA\u584C\u5854\u5896\u5B83\u5D09\u631E\u6428\u64BB\u6999\u69BB\u6BFE\u6DBE\u6EBB\u6FBE\u6FCC\u7260\u72E7\u736D\u737A\u7942\u79A2\u891F\u8968\u8ABB\u8B76\u8DBF\u8E0F\u8E4B\u8E79\u8EA2\u905D\u9062\u9248\u9314\u94CA\u95D2\u95E5\u95FC\u9618\u979C\u97B3\u9B99\u9C28\u9CCE",
            "Tai": "\u5113\u51AD\u53F0\u56FC\u576E\u592A\u5933\u5B2F\u5B61\u5FF2\u6001\u614B\u62AC\u64E1\u65F2\u6AAF\u6C70\u6CF0\u6E99\u70B1\u70B2\u71E4\u73C6\u7B88\u7C49\u7C8F\u80BD\u80CE\u81FA\u8226\u82D4\u83ED\u85B9\u8DC6\u90B0\u915E\u9226\u949B\u98B1\u99D8\u9A80\u9B90\u9C90",
            "Tan": "\u5013\u509D\u50CB\u53F9\u5574\u55FF\u5606\u563D\u574D\u575B\u5766\u57EE\u58B0\u58B5\u58C7\u58DC\u5A52\u5F3E\u5FD0\u6039\u60D4\u619B\u61B3\u61BB\u63A2\u644A\u64A2\u64F9\u6524\u6619\u66BA\u66C7\u6983\u6A5D\u6A80\u6B4E\u6BEF\u6E60\u6EE9\u6F6C\u6F6D\u7058\u70AD\u74AE\u75D1\u75F0\u762B\u7671\u78B3\u7F48\u7F4E\u8211\u8215\u83FC\u85EB\u8892\u8962\u8983\u8AC7\u8B5A\u8B60\u8C08\u8C2D\u8C9A\u8CAA\u8CE7\u8D2A\u8D55\u90EF\u9188\u9193\u91B0\u926D\u931F\u94BD\u952C\u9843\u9DE4",
            "Tang": "\u5018\u5052\u508F\u50A5\u513B\u528F\u5510\u557A\u5621\u5763\u5802\u5858\u5D63\u5E11\u6203\u642A\u6465\u66ED\u68E0\u69B6\u6A18\u6A56\u6DCC\u6E6F\u6E8F\u6F1F\u70EB\u717B\u71D9\u7223\u746D\u77D8\u78C4\u799F\u7BD6\u7CC3\u7CD6\u7CDB\u7FB0\u8025\u8185\u819B\u84CE\u859A\u876A\u8797\u87B3\u8D6F\u8D9F\u8E3C\u8E5A\u8EBA\u910C\u91A3\u9395\u93B2\u93DC\u940B\u9482\u94F4\u954B\u9557\u95DB\u969A\u97BA\u9933\u9939\u9944\u9967\u9DB6\u9F1E",
            "Tao": "\u4ED0\u530B\u54B7\u5555\u5932\u5957\u5ACD\u5E4D\u5F22\u6146\u638F\u642F\u6843\u68BC\u69C4\u6AAE\u6D2E\u6D9B\u6DD8\u6ED4\u6FE4\u746B\u7553\u7979\u7D5B\u7DAF\u7E1A\u7E27\u7EE6\u7EF9\u8404\u872A\u88EA\u8A0E\u8A5C\u8B1F\u8BA8\u8FEF\u9003\u9184\u92FE\u932D\u9676\u9780\u9789\u97B1\u97DC\u97EC\u98F8\u9940\u9955\u99E3\u9A0A\u9F17",
            "Te": "\u5FD1\u5FD2\u615D\u7279\u7286\u8126\u87D8\u8CA3\u92F1\u94FD",
            "Teng": "\u512F\u551E\u5E50\u6730\u6ED5\u6F1B\u75BC\u75CB\u7C50\u7C58\u7E22\u817E\u81AF\u85E4\u8645\u87A3\u8A8A\u8B04\u9086\u972F\u99E6\u9A30\u9A63\u9C27\u9F1F",
            "Ti": "\u4F53\u501C\u504D\u5243\u5254\u5397\u557C\u55C1\u568F\u5694\u5A9E\u5C49\u5C5C\u5D39\u5FB2\u608C\u6090\u60D5\u60D6\u60FF\u623B\u632E\u63A6\u63E5\u66FF\u68AF\u6974\u6B52\u6BA2\u6D1F\u6D95\u6E27\u6F3D\u73F6\u7445\u74CB\u78AE\u7A0A\u7C4A\u7D88\u7DF9\u7EE8\u7F07\u7F64\u855B\u8599\u876D\u88FC\u8905\u8B15\u8DA7\u8DAF\u8E22\u8E44\u8E4F\u8EB0\u8EC6\u9016\u9037\u9046\u918D\u92BB\u9357\u941F\u9511\u984C\u9898\u9A20\u9AB5\u9AD4\u9AF0\u9B00\u9B04\u9BB7\u9BF7\u9CC0\u9D3A\u9D5C\u9D97\u9D99\u9DC8\u9DC9\u9E48",
            "Tian": "\u500E\u5172\u553A\u5861\u586B\u5929\u5A56\u5C47\u5FDD\u606C\u60BF\u6375\u63AD\u6437\u666A\u6B84\u6CBA\u6DDF\u6DFB\u6E49\u7420\u7471\u74B3\u751B\u751C\u7530\u754B\u7551\u7560\u75F6\u76F7\u7753\u777C\u78B5\u78CC\u7AB4\u7DC2\u80CB\u8146\u8214\u821A\u83FE\u89A5\u89CD\u8CDF\u915F\u932A\u95D0\u9617\u9754\u975D\u9766\u9902\u9D2B\u9DC6\u9DCF\u9EC7",
            "Tiao": "\u4F7B\u5B25\u5BA8\u5CA7\u5CB9\u5EA3\u604C\u6311\u65EB\u6640\u6713\u6761\u689D\u6A24\u773A\u7952\u7967\u7A95\u7AB1\u7B24\u7C9C\u7CF6\u7D69\u804E\u8101\u8280\u84DA\u84E8\u8729\u87A9\u899C\u8A82\u8D92\u8DF3\u8FE2\u92DA\u93A5\u94EB\u9797\u982B\u9AEB\u9BC8\u9C37\u9CA6\u9F60\u9F86",
            "Tie": "\u50E3\u546B\u5E16\u6017\u8051\u841C\u86C8\u8CBC\u8D34\u8DD5\u9244\u9295\u9421\u9422\u9435\u94C1\u98FB\u992E\u9A56\u9D29",
            "Ting": "\u4E6D\u4EAD\u4FB9\u505C\u5385\u539B\u542C\u5722\u5A17\u5A77\u5D49\u5E81\u5EAD\u5EF0\u5EF3\u5EF7\u633A\u686F\u6883\u695F\u69B3\u6C40\u6D8F\u6E1F\u6FCE\u70C3\u70F4\u70F6\u73FD\u753A\u7B73\u7D8E\u8013\u8064\u8074\u807C\u807D\u8121\u8247\u8248\u827C\u839B\u8476\u8713\u874F\u8A94\u8AEA\u9092\u92CC\u94E4\u95AE\u9706\u9793\u9832\u988B\u9F2E",
            "Tong": "\u4EDD\u4F5F\u50EE\u52ED\u540C\u54C3\u55F5\u56F2\u5CC2\u5E9D\u5F64\u6078\u615F\u6185\u6345\u664D\u66C8\u6723\u6850\u6876\u6A0B\u6A66\u6C03\u6D75\u6F7C\u70B5\u70D4\u71A5\u729D\u72EA\u735E\u75CC\u75DB\u772E\u77B3\u783C\u79F1\u7A5C\u7AE5\u7B52\u7B69\u7CA1\u7D67\u7D71\u7D82\u7EDF\u81A7\u833C\u84EA\u8692\u8855\u8D68\u901A\u916E\u9256\u9275\u9285\u94DC\u9907\u9BA6\u9C96",
            "Tou": "\u4EA0\u5077\u5078\u5934\u59B5\u5A7E\u5AAE\u6295\u6568\u65A2\u6B95\u7D0F\u7DF0\u8623\u900F\u936E\u982D\u9AB0\u9EC8",
            "Tu": "\u514E\u5154\u51C3\u51F8\u5410\u550B\u56F3\u56FE\u5716\u5717\u571F\u5721\u580D\u5817\u5857\u5C60\u5CF9\u5D5E\u5D80\u5EA9\u5EDC\u5F92\u6022\u6087\u6348\u6378\u63EC\u688C\u6C62\u6D82\u6D8B\u6E65\u6F73\u75DC\u760F\u79BF\u79C3\u7A0C\u7A81\u7B61\u816F\u837C\u83B5\u83DF\u8456\u84A4\u8DFF\u8FCC\u9014\u9174\u91F7\u922F\u92F5\u934E\u948D\u999F\u99FC\u9D4C\u9D5A\u9D75\u9D9F\u9DCB\u9DF5\u9F35",
            "Tuan": "\u526C\u5278\u56E2\u56E3\u5715\u5718\u587C\u5F56\u6171\u629F\u6476\u69EB\u6AB2\u6E4D\u6E6A\u6F19\u7153\u732F\u7583\u7BFF\u7CF0\u8916\u8C92\u93C4\u9DD2\u9DFB",
            "Tui": "\u4FC0\u50D3\u5A27\u5C35\u63A8\u717A\u7A68\u812E\u817F\u84F7\u85EC\u8608\u86FB\u8715\u8E46\u8E6A\u9000\u96A4\u9839\u983A\u983D\u9893\u99FE\u9ABD\u9B4B",
            "Tun": "\u541E\u5451\u554D\u5749\u5C6F\u5FF3\u65FD\u66BE\u671C\u6C3D\u6D92\u711E\u757D\u81C0\u81CB\u829A\u8C58\u8C5A\u8ED8\u9715\u98E9\u9968\u9B68\u9C80\u9ED7",
            "Tuo": "\u4E47\u4F57\u4F82\u4FBB\u5483\u553E\u5768\u5836\u59A5\u5AA0\u5AF7\u5CAE\u5EB9\u5F75\u6258\u6261\u62D5\u62D6\u6329\u635D\u64B1\u6754\u67C1\u67DD\u692D\u6955\u69D6\u6A50\u6A62\u6BE4\u6BFB\u6C51\u6CB0\u6CB1\u6DB6\u72CF\u7823\u7824\u78A2\u7BA8\u7C5C\u7D3D\u812B\u8131\u838C\u841A\u8600\u8889\u88A5\u8A17\u8A51\u8BAC\u8DC5\u8DCE\u8E3B\u8FF1\u9161\u9640\u9641\u98E5\u9966\u99B1\u99B2\u99C4\u99DD\u99DE\u9A28\u9A52\u9A5D\u9A6E\u9A7C\u9B60\u9B80\u9C16\u9D15\u9D4E\u9E35\u9F09\u9F0D\u9F27",
            "Wa": "\u4F64\u52B8\u5493\u54C7\u5558\u55D7\u55E2\u5A03\u5A32\u5AA7\u5C72\u5F8D\u6316\u6432\u6528\u6D3C\u6E9B\u6F25\u74E6\u74F2\u7556\u7819\u7A8A\u7AAA\u8049\u817D\u8183\u86D9\u889C\u896A\u90B7\u97C8\u97E4\u9F03",
            "Wai": "\u558E\u5916\u5D34\u6B6A\u7AF5\u9861",
            "Wan": "\u4E07\u4E38\u4E5B\u5007\u5213\u525C\u534D\u5350\u550D\u57E6\u5846\u58EA\u59A7\u5A49\u5A60\u5B8C\u5B9B\u5C8F\u5E35\u5F2F\u5F4E\u5FE8\u60CB\u628F\u633D\u6356\u6365\u665A\u6669\u667C\u6764\u689A\u6900\u6C4D\u6DB4\u6E7E\u6F6B\u7063\u70F7\u73A9\u7413\u742C\u7579\u7696\u76CC\u7755\u7897\u7B02\u7D08\u7DA9\u7DB0\u7EA8\u7EFE\u7FEB\u8118\u8155\u8284\u83C0\u842C\u858D\u873F\u8C4C\u8CA6\u8D03\u8D0E\u8E20\u8F13\u909C\u92C4\u92D4\u933D\u9350\u93AB\u9811\u987D",
            "Wang": "\u4EA1\u4EBE\u4EFC\u5166\u5984\u5C23\u5C29\u5C2A\u5C2B\u5F7A\u5F80\u5F83\u5FD8\u5FF9\u60D8\u65FA\u6680\u671B\u6722\u6789\u68E2\u6C6A\u7007\u7139\u738B\u76F3\u7DB2\u7F51\u7F54\u83A3\u83F5\u869F\u86E7\u8744\u8AB7\u8F1E\u8F8B\u8FCB\u9B4D",
            "Wei": "\u4E3A\u4EB9\u4F1F\u4F2A\u4F4D\u5049\u504E\u507D\u50DE\u5130\u536B\u5371\u5383\u53DE\u5473\u552F\u5582\u55A1\u55B4\u56D7\u56F4\u570D\u589B\u58DD\u59D4\u5A01\u5A13\u5A81\u5A99\u5AA6\u5BEA\u5C09\u5C3E\u5CD7\u5CDE\u5D23\u5D54\u5D6C\u5DB6\u5DCD\u5E0F\u5E37\u5E43\u5EC6\u5FAB\u5FAE\u60DF\u6104\u6107\u6170\u61C0\u6364\u63CB\u63FB\u6596\u6637\u6690\u672A\u6845\u68B6\u6932\u6933\u6972\u6CA9\u6D08\u6D27\u6D58\u6DA0\u6E28\u6E2D\u6E4B\u6E88\u6EA6\u6F4D\u6F59\u6F7F\u6FCA\u6FF0\u6FFB\u7022\u709C\u70BA\u70D3\u7140\u7152\u715F\u7168\u71AD\u71F0\u7232\u729A\u72A9\u7325\u732C\u73AE\u741F\u744B\u748F\u754F\u75CF\u75FF\u7650\u7653\u784A\u7859\u78A8\u78D1\u7DAD\u7DED\u7DEF\u7E05\u7EAC\u7EF4\u7F7B\u80C3\u8172\u8249\u829B\u82C7\u82FF\u8371\u83CB\u840E\u8466\u8468\u8473\u848D\u84F6\u851A\u853F\u8587\u85B3\u85EF\u8636\u8732\u873C\u875B\u875F\u87B1\u885B\u885E\u893D\u89A3\u89B9\u8A74\u8AC9\u8B02\u8B86\u8B8F\u8BFF\u8C13\u8E13\u8E97\u8E9B\u8ECE\u8F4A\u8FDD\u9036\u9055\u912C\u9180\u9317\u934F\u9361\u93CF\u95C8\u95F1\u9687\u9688\u9697\u9728\u973A\u973B\u97CB\u97D1\u97D9\u97E1\u97E6\u97EA\u9820\u98B9\u9927\u9935\u9956\u9AA9\u9AAA\u9AAB\u9B4F\u9B87\u9BA0\u9BAA\u9C03\u9C04\u9C94\u9CC2\u9CDA",
            "Wen": "\u520E\u543B\u545A\u5461\u554F\u586D\u598F\u5F63\u5FDF\u6286\u63FE\u6435\u6587\u687D\u6985\u69B2\u6B9F\u6C76\u6E02\u6E29\u6EAB\u7086\u73F3\u7465\u74BA\u7612\u761F\u7807\u7A33\u7A4F\u7A69\u7D0A\u7D0B\u7D7B\u7EB9\u805E\u80B3\u8115\u8117\u82A0\u83AC\u8689\u868A\u87A1\u87C1\u8C71\u8F3C\u8F40\u8F92\u922B\u93BE\u95BA\u95BF\u95C5\u95E6\u95E7\u95EE\u95FB\u960C\u96EF\u9850\u9942\u99BC\u9B70\u9C1B\u9C2E\u9CC1\u9CFC\u9D0D\u9F24",
            "Weng": "\u52DC\u55E1\u5855\u5963\u5D61\u66A1\u6EC3\u74EE\u7515\u7788\u7F4B\u7FC1\u806C\u84CA\u8579\u8789\u9393\u9DB2\u9E5F\u9F46",
            "Wo": "\u4EF4\u502D\u5053\u5367\u5529\u5594\u5A50\u5A51\u5A89\u5E44\u6211\u631D\u6370\u637E\u63E1\u64BE\u65A1\u6943\u6C83\u6DA1\u6DB9\u6E25\u6E26\u6FE3\u7125\u7327\u74C1\u7783\u786A\u7A9D\u7AA9\u809F\u815B\u81D2\u81E5\u83B4\u8435\u8717\u8778\u8E12\u9F77\u9F8C",
            "Wu": "\u4E44\u4E4C\u4E94\u4EF5\u4F06\u4F0D\u4FAE\u4FC9\u5035\u511B\u5140\u526D\u52A1\u52D9\u52FF\u5348\u5433\u5434\u543E\u5449\u545C\u5514\u554E\u55DA\u572C\u575E\u5862\u5966\u59A9\u5A2A\u5A2C\u5A7A\u5AF5\u5BE4\u5C4B\u5C7C\u5C89\u5D4D\u5D68\u5DEB\u5E91\u5EE1\u5F19\u5FE2\u5FE4\u6003\u609E\u609F\u60AE\u61AE\u620A\u6264\u6342\u6440\u6544\u65E0\u65FF\u6664\u6747\u674C\u68A7\u6A46\u6B4D\u6B66\u6BCB\u6C59\u6C5A\u6C61\u6D16\u6D3F\u6D6F\u6EA9\u6F55\u70CF\u7110\u7111\u7121\u7183\u7193\u7269\u727E\u739D\u73F7\u73F8\u7466\u7491\u7512\u75E6\u77F9\u7894\u7966\u7991\u7A8F\u7AB9\u7BBC\u7C85\u821E\u829C\u82B4\u8323\u8381\u856A\u8601\u8708\u8790\u8A88\u8AA3\u8AA4\u8BEC\u8BEF\u8DB6\u8E8C\u8FD5\u901C\u90AC\u90DA\u9114\u91EB\u92C8\u933B\u93A2\u94A8\u9622\u9696\u96FE\u971A\u9727\u9770\u9A16\u9A9B\u9BC3\u9C1E\u9D2E\u9D50\u9D61\u9DA9\u9DE1\u9E40\u9E49\u9E5C\u9F2F\u9F3F\u9F40",
            "Xi": "\u4E60\u4FC2\u4FD9\u5092\u50D6\u516E\u51DE\u5338\u534C\u5365\u5380\u5438\u546C\u54A5\u550F\u553D\u559C\u563B\u564F\u56B1\u5848\u58D0\u5915\u595A\u5A2D\u5AB3\u5B06\u5B09\u5C43\u5C56\u5C57\u5C63\u5D60\u5D8D\u5DC7\u5E0C\u5E2D\u5F86\u5F99\u5F9A\u5FAF\u5FDA\u5FE5\u602C\u6038\u6044\u606F\u6089\u6095\u60C1\u60DC\u6140\u6198\u6199\u620F\u622F\u6231\u6232\u6278\u6614\u665E\u6670\u6673\u66BF\u66E6\u676B\u6790\u67B2\u6878\u691E\u693A\u69BD\u69E2\u6A28\u6A40\u6A72\u6A84\u6B2F\u6B37\u6B56\u6B59\u6B5A\u6C25\u6C50\u6D17\u6D60\u6DC5\u6E13\u6EAA\u6ECA\u6F07\u6F1D\u6F5D\u6F5F\u6F99\u70EF\u7101\u7108\u711F\u712C\u7155\u7182\u7184\u7188\u7199\u71B9\u71BA\u71BB\u71E8\u7214\u727A\u7280\u7294\u72A0\u72A7\u72F6\u73BA\u740B\u74BD\u761C\u7699\u76FB\u774E\u77A6\u77D6\u77FD\u7852\u78F6\u7902\u798A\u79A7\u7A00\u7A27\u7A78\u7AB8\u7C9E\u7D30\u7D8C\u7DC6\u7E30\u7E65\u7E9A\u7EC6\u7EE4\u7FB2\u7FD2\u7FD5\u7FD6\u80B8\u80B9\u819D\u8204\u823E\u8383\u83E5\u8448\u8478\u84A0\u84B5\u84C6\u84F0\u856E\u8582\u8669\u8725\u8777\u8785\u8787\u87CB\u87E2\u8835\u884B\u88AD\u8972\u897F\u8980\u89A1\u89A4\u89CB\u89F9\u89FD\u89FF\u8A92\u8AF0\u8B11\u8B35\u8B46\u8BF6\u8C3F\u8C40\u8C68\u8C6F\u8C95\u8D65\u8D69\u8D87\u8D98\u8E5D\u8EA7\u90C4\u90CB\u90D7\u90E4\u910E\u9145\u91AF\u91F3\u91F8\u9222\u9291\u932B\u93B4\u93ED\u9474\u94E3\u9521\u95DF\u960B\u9699\u969F\u96B0\u96B5\u96DF\u972B\u973C\u98C1\u990F\u9919\u993C\u9969\u997B\u9A31\u9A3D\u9A68\u9B29\u9BD1\u9C3C\u9C5A\u9CDB\u9D57\u9E02\u9ED6\u9F37",
            "Xia": "\u4E05\u4E0B\u4FA0\u4FE0\u5084\u5323\u5477\u5687\u5737\u590F\u5913\u5CE1\u5CFD\u5EC8\u61D7\u6433\u656E\u6687\u67D9\u68BA\u6E8A\u70A0\u70DA\u7146\u72CE\u72ED\u72F9\u73E8\u7455\u759C\u75A8\u7771\u778E\u7856\u7864\u78AC\u78CD\u796B\u7B1A\u7B6A\u7E00\u7E16\u7F45\u7FC8\u821D\u823A\u8578\u8766\u8AD5\u8C3A\u8D6E\u8F44\u8F96\u9050\u935C\u938B\u93EC\u9595\u959C\u965C\u967F\u971E\u98AC\u9A22\u9B7B\u9C15\u9DB7\u9EE0",
            "Xian": "\u4ED9\u4EDA\u4F2D\u4F61\u50CA\u50E9\u50F2\u50F4\u5148\u51BC\u53BF\u549E\u54B8\u54EF\u550C\u5563\u5615\u57B7\u597E\u59B6\u59ED\u5A0A\u5A28\u5A34\u5A39\u5A71\u5ACC\u5AFA\u5AFB\u5B10\u5B45\u5BAA\u5C1F\u5C20\u5C73\u5C98\u5CF4\u5D04\u5DAE\u5E70\u5EEF\u5F26\u5FFA\u61AA\u61B2\u61B8\u6326\u6380\u641F\u648A\u648F\u6507\u6515\u663E\u665B\u66B9\u6774\u67AE\u6A4C\u6AF6\u6BE8\u6C19\u6D80\u6D8E\u6E7A\u6F96\u7017\u7066\u70CD\u71F9\u72DD\u7303\u732E\u736B\u736E\u737B\u7381\u73B0\u73D7\u73FE\u7509\u75EB\u7647\u764E\u770C\u774D\u784D\u7925\u7946\u7992\u79C8\u7B45\u7BB2\u7C7C\u7CAF\u7CEE\u7D43\u7D64\u7DAB\u7DDA\u7E23\u7E4A\u7E8E\u7E96\u7EBF\u7F10\u7FA1\u7FA8\u80D8\u817A\u81D4\u81FD\u8237\u82CB\u82EE\u83A7\u83B6\u859F\u85D3\u85D4\u85D6\u861A\u86AC\u86BF\u86DD\u8706\u8854\u8858\u893C\u8973\u8AA2\u8AB8\u8AF4\u8B63\u8C4F\u8CE2\u8D12\u8D24\u8D7B\u8DE3\u8DF9\u8E6E\u8E9A\u8F31\u9170\u918E\u929B\u929C\u92E7\u930E\u9341\u9342\u934C\u93FE\u9466\u94E6\u9528\u9591\u95F2\u9650\u9665\u9669\u9677\u967A\u96AA\u9730\u97C5\u97EF\u97F1\u9855\u986F\u9921\u9985\u99A6\u9BAE\u9C7B\u9C9C\u9DB1\u9DF3\u9DF4\u9DFC\u9E47\u9E79\u9EB2\u9F38",
            "Xiang": "\u4E61\u4EAB\u4EAF\u4F6D\u50CF\u52E8\u53A2\u5411\u54CD\u554C\u56AE\u59E0\u5D91\u5EA0\u5EC2\u5FC0\u60F3\u6651\u66CF\u6819\u697F\u6A61\u6B00\u6E58\u73E6\u74D6\u74E8\u76F8\u7965\u7BB1\u7D74\u7DD7\u7F03\u7F3F\u7FD4\u81B7\u8297\u842B\u8459\u858C\u8683\u87D3\u8801\u8944\u8950\u8A73\u8BE6\u8C61\u8DED\u90F7\u9109\u910A\u9115\u9284\u940C\u9472\u9576\u97FF\u9805\u9879\u98E8\u9909\u9957\u995F\u9977\u9999\u9A64\u9AA7\u9B9D\u9BD7\u9C4C\u9C5C\u9C76\u9C9E\u9E98",
            "Xiao": "\u4FBE\u4FF2\u509A\u52B9\u547A\u54B2\u54D3\u54EE\u554B\u5578\u560B\u5610\u5628\u562F\u5635\u56A3\u56BB\u56C2\u5A4B\u5B5D\u5BAF\u5BB5\u5C0F\u5D24\u5EA8\u5F47\u6054\u6077\u61A2\u63F1\u64A8\u6548\u6569\u6585\u6586\u6653\u6681\u66C9\u67AD\u67B5\u689F\u6AF9\u6B4A\u6B57\u6BCA\u6D28\u6D88\u6D8D\u6DC6\u6EE7\u6F47\u701F\u7071\u7072\u7107\u71BD\u7307\u7362\u75DA\u75DF\u769B\u76A2\u785D\u7863\u7A58\u7A99\u7B11\u7B71\u7B7F\u7BAB\u7BE0\u7C18\u7C2B\u7D83\u7EE1\u7FDB\u8096\u81AE\u8427\u8437\u856D\u85C3\u8648\u8653\u87C2\u87CF\u87F0\u8828\u8A24\u8A68\u8A9F\u8AB5\u8B0F\u8B1E\u8E03\u900D\u90E9\u92B7\u9500\u9704\u9A4D\u9A81\u9AC7\u9AD0\u9B48\u9D1E\u9D35\u9DCD\u9E2E",
            "Xie": "\u4E9B\u4EB5\u4F33\u5055\u5070\u50C1\u5199\u51A9\u52A6\u52F0\u534F\u5354\u5368\u5378\u55CB\u5667\u57A5\u586E\u5911\u594A\u5A0E\u5A9F\u5BEB\u5C51\u5C53\u5C5F\u5C67\u5C6D\u5CEB\u5DB0\u5EE8\u5FA2\u604A\u6136\u61C8\u62F9\u631F\u633E\u63F3\u643A\u64B7\u64D5\u64F7\u651C\u659C\u65EA\u66AC\u68B0\u6954\u698D\u69AD\u6B47\u6CC4\u6CFB\u6D29\u6E2B\u6FA5\u7009\u7023\u707A\u70A7\u70A8\u710E\u7181\u71EE\u71F2\u7215\u7332\u736C\u744E\u7944\u79BC\u7CCF\u7D32\u7D4F\u7D5C\u7D6C\u7D8A\u7DE4\u7DF3\u7E88\u7EC1\u7F2C\u7F37\u7FD3\u80C1\u8105\u8107\u810B\u818E\u85A2\u85A4\u85DB\u874E\u8762\u87F9\u880D\u880F\u887A\u8909\u893B\u896D\u8AE7\u8B1D\u8B97\u8C10\u8C22\u8E9E\u8EA0\u9082\u90AA\u9437\u978B\u97A2\u97B5\u97F0\u9F42\u9F58\u9F65\u9FA4",
            "Xin": "\u4F08\u4F29\u4FE1\u4FFD\u5677\u567A\u56DF\u59A1\u5B1C\u5B5E\u5EDE\u5FC3\u5FC4\u5FFB\u60DE\u65B0\u6615\u677A\u6794\u6B23\u6B46\u6F43\u7098\u712E\u76FA\u812A\u820B\u82AF\u8398\u85AA\u8845\u8A22\u8A2B\u8ED0\u8F9B\u90A4\u91C1\u920A\u92C5\u9414\u946B\u950C\u9620\u9856\u99A8\u99AB\u99B8\u9B35",
            "Xing": "\u4F80\u5016\u5174\u5211\u54D8\u578B\u57B6\u5842\u59D3\u5A19\u5A5E\u5B39\u5E78\u5F62\u6027\u60BB\u60FA\u64E4\u661F\u66D0\u674F\u6D10\u6DAC\u714B\u72CC\u7329\u7446\u76A8\u7772\u784E\u7BB5\u7BC2\u7DC8\u8165\u81D6\u8208\u8347\u8395\u86F5\u88C4\u89EA\u89F2\u8B03\u90A2\u90C9\u9192\u9203\u9276\u9292\u92DE\u9498\u94CF\u9649\u9658\u9A02\u9A8D\u9B8F\u9BF9",
            "Xiong": "\u5144\u5147\u51F6\u5308\u54C5\u5910\u5FF7\u605F\u657B\u6C79\u6D36\u718A\u80F7\u80F8\u828E\u8A29\u8A57\u8A7E\u8BBB\u8BC7\u96C4",
            "Xiu": "\u4F11\u4FE2\u4FEE\u54BB\u5CAB\u5EA5\u673D\u6A07\u6EB4\u6EEB\u70CB\u70CC\u73DB\u7407\u7493\u79C0\u7CD4\u7D87\u7D89\u7E4D\u7E61\u7EE3\u7F9E\u8119\u8129\u81F9\u82EC\u8791\u8896\u88E6\u890E\u890F\u8C85\u929D\u92B9\u9380\u93C5\u93E5\u93FD\u9508\u98CD\u9948\u9990\u9AE4\u9AF9\u9BB4\u9D42\u9E3A\u9F45",
            "Xu": "\u4F35\u4F90\u4FC6\u5066\u5194\u52D6\u52D7\u5379\u53D9\u5474\u55A3\u55C5\u5618\u5653\u57BF\u589F\u58FB\u59C1\u5A7F\u5AAD\u5B03\u5E41\u5E8F\u5F90\u6064\u6149\u620C\u63DF\u654D\u6558\u65ED\u65F4\u662B\u668A\u6702\u6829\u6948\u69D2\u6B28\u6B30\u6B3B\u6B54\u6B58\u6B88\u6C7F\u6C80\u6D2B\u6E51\u6E86\u6F35\u6F4A\u70C5\u70FC\u7166\u735D\u73DD\u73EC\u759E\u76E2\u76E8\u76F1\u7781\u77B2\u7809\u7A30\u7A38\u7AA2\u7CC8\u7D6E\u7D9A\u7DD2\u7DD6\u7E03\u7E8C\u7EEA\u7EED\u805F\u80E5\u84A3\u84C4\u84FF\u8566\u85C7\u85DA\u8657\u865A\u865B\u8751\u8A0F\u8A31\u8A39\u8A61\u8ADD\u8B43\u8BB8\u8BE9\u8C1E\u8CC9\u9126\u9157\u9191\u928A\u9450\u9700\u9808\u980A\u987B\u987C\u9A49\u9B1A\u9B46\u9B56\u9C6E",
            "Xuan": "\u5107\u5405\u54BA\u55A7\u5847\u5A97\u5AD9\u5B1B\u5BA3\u6030\u60AC\u6103\u610B\u61F8\u63CE\u65CB\u660D\u6621\u6645\u6684\u6685\u66B6\u688B\u6965\u6966\u6A88\u6CEB\u6E32\u6F29\u70AB\u70DC\u714A\u7384\u73B9\u7401\u7404\u7444\u7487\u74BF\u75C3\u7663\u766C\u7729\u7734\u777B\u77CE\u78B9\u79A4\u7BAE\u7D62\u7E3C\u7E4F\u7EDA\u7FE7\u7FFE\u8431\u8432\u84D2\u8519\u857F\u85FC\u8610\u8701\u8756\u8809\u8852\u88A8\u8AE0\u8AFC\u8B5E\u8B82\u8C16\u8D19\u8ED2\u8F69\u9009\u9078\u9249\u9379\u93C7\u94C9\u955F\u9799\u98B4\u99FD\u9C1A",
            "Xue": "\u4E74\u5437\u5779\u5B66\u5B78\u5CA4\u5CC3\u5DA8\u6034\u6588\u6856\u6A30\u6CE7\u6CF6\u6FA9\u7025\u70D5\u71E2\u72D8\u75A6\u75B6\u7A74\u81A4\u825D\u8313\u8486\u859B\u8895\u89F7\u8B14\u8C11\u8D90\u8E05\u8F4C\u8FA5\u96E4\u96EA\u9774\u97BE\u9C48\u9CD5\u9DFD\u9E34",
            "Xun": "\u4F28\u4F9A\u5071\u52CB\u52DB\u52F2\u52F3\u5342\u5640\u565A\u5691\u5743\u57D9\u5864\u58CE\u58E6\u595E\u5BFB\u5C0B\u5CCB\u5DE1\u5DFD\u5EF5\u5F87\u5FAA\u6042\u613B\u63D7\u6533\u65EC\u66DB\u674A\u6812\u686A\u6A33\u6B89\u6BBE\u6BE5\u6C5B\u6D35\u6D54\u6F6F\u7065\u7104\u718F\u71C2\u71C5\u71D6\u71FB\u720B\u72E5\u736F\u73E3\u7495\u77C4\u7AA8\u7D03\u7E81\u81D0\u8340\u8512\u8548\u85AB\u85B0\u860D\u87F3\u8951\u8A0A\u8A13\u8A19\u8A62\u8BAD\u8BAF\u8BE2\u8CD0\u8FC5\u8FFF\u900A\u905C\u9129\u91BA\u9442\u9868\u99B4\u99E8\u9A6F\u9C4F\u9C58\u9C9F",
            "Ya": "\u4E2B\u4E9A\u4E9C\u4E9E\u4F22\u4FF9\u529C\u538A\u538B\u5393\u5440\u54D1\u5516\u555E\u5714\u5720\u57AD\u57E1\u5810\u58D3\u5A05\u5A6D\u5B72\u5C88\u5D15\u5D16\u5E8C\u5E98\u62BC\u631C\u6397\u63E0\u6792\u6860\u690F\u6C29\u6C2C\u6DAF\u6F04\u7259\u72BD\u731A\u7330\u73A1\u740A\u7458\u758B\u75D6\u7602\u775A\u7811\u7A0F\u7A75\u7AAB\u7B0C\u8050\u82BD\u8565\u869C\u8859\u897E\u8A1D\u8BB6\u8FD3\u930F\u941A\u94D4\u96C5\u9D09\u9D28\u9D76\u9E26\u9E2D\u9F56\u9F7E",
            "Yan": "\u4E25\u4E75\u4FE8\u5043\u5050\u5063\u50BF\u513C\u5156\u5157\u5186\u5266\u533D\u538C\u53A3\u53AD\u53B3\u53B4\u5501\u55AD\u565E\u56A5\u56B4\u5830\u5869\u5895\u58DB\u58E7\u5935\u5944\u598D\u599F\u59F2\u59F8\u5A2B\u5A2E\u5AE3\u5B0A\u5B2E\u5B3F\u5B4D\u5BB4\u5CA9\u5D26\u5D43\u5D52\u5D53\u5D96\u5DCC\u5DD6\u5DD7\u5DD8\u5DDA\u5EF6\u5F07\u5F65\u5F66\u6079\u611D\u61D5\u622D\u624A\u6281\u639E\u63A9\u63C5\u63DC\u6565\u6616\u664F\u66A5\u66D5\u66EE\u68EA\u693B\u693C\u694C\u6A2E\u6A90\u6ABF\u6AE9\u6B15\u6C87\u6CBF\u6DF9\u6E30\u6E37\u6E6E\u6EDF\u6F14\u6F39\u704E\u7054\u7067\u7069\u708E\u70DF\u7109\u7114\u7130\u7131\u7159\u7196\u71C4\u71D5\u7213\u726A\u72FF\u7312\u73DA\u7402\u7430\u7517\u76D0\u773C\u7814\u781A\u784F\u786F\u787D\u789E\u7939\u7B75\u7BF6\u7C37\u7D96\u7E2F\u7F68\u80ED\u81D9\u8273\u8276\u8277\u82AB\u839A\u83F8\u8412\u8455\u8505\u852B\u8664\u8712\u8758\u884D\u88FA\u8917\u898E\u89C3\u89FE\u8A00\u8A01\u8A2E\u8A7D\u8AFA\u8B8C\u8B9E\u8BA0\u8C1A\u8C33\u8C53\u8C54\u8D0B\u8D17\u8D18\u8D5D\u8EBD\u8EC5\u9043\u90D4\u90FE\u9122\u9140\u9153\u917D\u9183\u91B6\u91BC\u91C5\u9586\u95B9\u95BB\u95EB\u9609\u960E\u9681\u9692\u96C1\u984F\u9854\u9869\u989C\u990D\u995C\u9A10\u9A13\u9A34\u9A57\u9A60\u9A8C\u9B33\u9B47\u9B58\u9C0B\u9CEB\u9D08\u9D33\u9DA0\u9DC3\u9DF0\u9E7D\u9E99\u9EA3\u9EE1\u9EE4\u9EEB\u9EEC\u9EED\u9EF6\u9F34\u9F39\u9F5E\u9F74\u9F91",
            "Yang": "\u4EF0\u4F52\u4F6F\u509F\u517B\u52B7\u536C\u5489\u5771\u579F\u592E\u594D\u59CE\u5C9F\u5D35\u5D38\u5F89\u600F\u6059\u6143\u61E9\u626C\u62B0\u63DA\u6501\u656D\u65F8\u661C\u6698\u6768\u67CD\u6837\u694A\u6967\u69D8\u6A23\u6B83\u6C1C\u6C27\u6C31\u6CF1\u6D0B\u6F3E\u7001\u7080\u70B4\u70CA\u716C\u73DC\u75A1\u75D2\u760D\u7662\u770F\u773B\u7922\u7993\u79E7\u7D3B\u7F8A\u7F8F\u7F95\u7FAA\u80E6\u86D8\u8A47\u8AF9\u8EEE\u8F30\u9260\u9348\u935A\u940A\u9496\u9626\u9633\u967D\u96F5\u9737\u9785\u98BA\u98CF\u990A\u99DA\u9C11\u9D26\u9D39\u9E09\u9E2F",
            "Yao": "\u4EF8\u5004\u5060\u509C\u5406\u54AC\u5593\u55C2\u579A\u582F\u592D\u5996\u59DA\u5A79\u5AB1\u5B8E\u5C27\u5C2D\u5C86\u5CE3\u5D3E\u5DA2\u5DA4\u5E7A\u5FAD\u5FBA\u612E\u62AD\u63FA\u6416\u6447\u647F\u669A\u66DC\u66E3\u6773\u6796\u67FC\u6946\u699A\u69A3\u6B80\u6BBD\u6E94\u70D1\u718E\u71FF\u723B\u72D5\u733A\u735F\u73E7\u7464\u7476\u7711\u77C5\u78D8\u7945\u7A7E\u7A85\u7A88\u7A91\u7A94\u7AAF\u7AB0\u7B44\u7E47\u7E85\u8000\u80B4\u8170\u8200\u825E\u82ED\u836F\u846F\u847D\u84D4\u85AC\u85E5\u8628\u888E\u8981\u899E\u8A1E\u8A4F\u8B20\u8B21\u8B91\u8C23\u8EFA\u8F7A\u9059\u9065\u9080\u929A\u9390\u9470\u95C4\u977F\u9864\u98BB\u98D6\u9906\u991A\u9A15\u9C29\u9CD0\u9D01\u9D22\u9DC2\u9DD5\u9E5E\u9F3C\u9F69",
            "Ye": "\u4E1A\u4E5F\u4EAA\u4EB1\u503B\u505E\u50F7\u51B6\u53F6\u5414\u5622\u564E\u5688\u57DC\u5828\u58B7\u58C4\u591C\u5DAA\u5DAB\u62B4\u6353\u6359\u6396\u63F6\u64D6\u64DB\u64E8\u64EA\u64EB\u6654\u668D\u66C4\u66C5\u66D7\u66F3\u67BC\u67BD\u6930\u696A\u696D\u6B4B\u6B97\u6D02\u6DB2\u6F1C\u6F71\u6FB2\u70E8\u71C1\u7217\u7237\u723A\u76A3\u77B1\u77B8\u790F\u8036\u814B\u8449\u882E\u8B01\u8C12\u90BA\u9113\u9134\u91CE\u91FE\u92E3\u9371\u9381\u9391\u94D8\u9765\u9768\u9801\u9875\u9923\u9941\u998C\u9A5C\u9D7A\u9E08",
            "Yi": "\u4E00\u4E41\u4E42\u4E49\u4E59\u4E84\u4EA6\u4EBF\u4EE1\u4EE5\u4EEA\u4F07\u4F0A\u4F3F\u4F41\u4F5A\u4F7E\u4F87\u4F9D\u4FCB\u501A\u506F\u5100\u5104\u517F\u519D\u5208\u5293\u52AE\u52DA\u52E9\u5307\u531C\u533B\u541A\u5453\u546D\u5479\u54A6\u54BF\u5508\u566B\u56C8\u571B\u572F\u5744\u57BC\u57F6\u57F8\u58BF\u58F1\u58F9\u5901\u5937\u5955\u59B7\u59E8\u5A90\u5AD5\u5ADB\u5B04\u5B11\u5B1F\u5B90\u5B9C\u5BA7\u5BF1\u5BF2\u5C79\u5CC4\u5CD3\u5D3A\u5DA7\u5DAC\u5DB7\u5DF2\u5DF8\u5E1F\u5E20\u5E46\u5EA1\u5ED9\u5F02\u5F08\u5F0B\u5F0C\u5F2C\u5F5B\u5F5C\u5F5D\u5F5E\u5F79\u5FC6\u5FD4\u6008\u6021\u603F\u605E\u6092\u6098\u60A5\u610F\u61B6\u61CC\u61FF\u6245\u6246\u6291\u6339\u63D6\u648E\u653A\u6561\u657C\u6581\u65D1\u65D6\u6613\u6679\u6686\u66C0\u66CE\u66F5\u6759\u675D\u678D\u67BB\u67C2\u6818\u6827\u683A\u684B\u68ED\u6905\u692C\u6938\u698F\u69F8\u6A8D\u6AA5\u6AB9\u6B2D\u6B39\u6B5D\u6B94\u6BAA\u6BB9\u6BC5\u6BC9\u6C82\u6CB6\u6CC6\u6D22\u6D42\u6D65\u6D73\u6E59\u6EA2\u6F2A\u6F69\u6FBA\u7037\u7088\u7132\u71A0\u71A4\u71AA\u71BC\u71DA\u71E1\u71F1\u72CB\u7317\u7348\u73B4\u747F\u74F5\u7569\u7570\u7591\u75AB\u75CD\u75EC\u7617\u761E\u7631\u7654\u76CA\u7719\u7796\u77E3\u7912\u794E\u7995\u79C7\u79FB\u7A26\u7A53\u7AE9\u7B16\u7C03\u7C4E\u7E0A\u7E44\u7E76\u7E79\u7ECE\u7F22\u7F9B\u7FA0\u7FA9\u7FBF\u7FCA\u7FCC\u7FF3\u7FFC\u8034\u8084\u808A\u80F0\u8189\u81C6\u8223\u8257\u8264\u827A\u8285\u82C5\u82E1\u82E2\u8351\u8413\u841F\u84FA\u858F\u85D9\u85DD\u8619\u8649\u8681\u86DC\u86E1\u86E6\u8734\u8794\u8798\u87A0\u87FB\u8863\u8864\u886A\u8875\u8898\u88A3\u88D4\u88DB\u8939\u897C\u89FA\u8A32\u8A33\u8A4D\u8A52\u8A63\u8A83\u8ABC\u8B3B\u8B69\u8B6F\u8B70\u8B89\u8B9B\u8BAE\u8BD1\u8BD2\u8BE3\u8C0A\u8C59\u8C5B\u8C77\u8C96\u8CA4\u8CBD\u8D00\u8D3B\u8DC7\u8DE0\u8EFC\u8F22\u8F59\u8F76\u8FB7\u8FC6\u8FE4\u8FFB\u9018\u9038\u907A\u9091\u90FC\u914F\u91AB\u91B3\u91B7\u91D4\u91F4\u9218\u9220\u926F\u92A5\u93B0\u93D4\u943F\u9487\u94F1\u9552\u9571\u9623\u966D\u96BF\u972C\u977E\u9809\u9824\u9825\u984A\u9857\u9890\u98F4\u9950\u9974\u99C5\u9A5B\u9A7F\u9AAE\u9BA7\u9BA8\u9BE3\u9CE6\u9D82\u9D83\u9D8D\u9DC1\u9DCA\u9DD6\u9DE7\u9DFE\u9E03\u9E5D\u9E62\u9E65\u9ED3\u9EDF\u9EF3\u9F6E\u9F78",
            "Yin": "\u4E51\u4E5A\u4F8C\u5198\u51D0\u5370\u541F\u5432\u552B\u5591\u5656\u567E\u569A\u56D9\u56E0\u5701\u5794\u57A0\u57BD\u5819\u5924\u59FB\u5A63\u5A6C\u5BC5\u5C39\u5CFE\u5D1F\u5D2F\u5DBE\u5ED5\u5EF4\u5F15\u6114\u6147\u616D\u6196\u6197\u61DA\u65A6\u6704\u6836\u6A83\u6AAD\u6ABC\u6AFD\u6B45\u6BA5\u6C24\u6CFF\u6D07\u6D15\u6DEB\u6DFE\u6E5A\u6EB5\u6EDB\u6FE5\u6FE6\u70CE\u72BE\u72FA\u730C\u73E2\u748C\u7616\u763E\u764A\u766E\u7892\u78E4\u798B\u79F5\u7B43\u7C8C\u7D6A\u7DF8\u80E4\u82C2\u831A\u8335\u836B\u8376\u8491\u8529\u852D\u861F\u8693\u87BE\u87EB\u88C0\u8A14\u8A1A\u8A21\u8ABE\u8AF2\u8B94\u8D9B\u911E\u9173\u91FF\u920F\u921D\u9280\u92A6\u94DF\u94F6\u95C9\u9625\u9634\u9670\u967B\u9682\u9690\u96A0\u96B1\u9712\u9720\u972A\u9777\u9787\u97F3\u97FE\u98EE\u98F2\u996E\u99F0\u9A83\u9BA3\u9DE3\u9F57\u9F66\u9F82\u9F88",
            "Ying": "\u5040\u50CC\u5568\u55B6\u5624\u565F\u56B6\u584B\u5A74\u5A96\u5AB5\u5AC8\u5B30\u5B34\u5B46\u5B7E\u5DC6\u5DCA\u5E94\u5EEE\u5F71\u5FDC\u6125\u61C9\u646C\u6484\u650D\u6516\u651A\u6620\u668E\u6720\u685C\u68AC\u6979\u6A31\u6AFB\u6AFF\u6D67\u6E36\u6E81\u6E8B\u6ECE\u6EE2\u6F41\u6F46\u6FD9\u6FDA\u6FF4\u7005\u701B\u7020\u702F\u7034\u7050\u705C\u7150\u7192\u71DF\u73F1\u745B\u7469\u748E\u74D4\u7507\u7516\u763F\u766D\u76C1\u76C8\u77E8\u786C\u78A4\u792F\u7A4E\u7C5D\u7C6F\u7DD3\u7E08\u7E93\u7EEC\u7F28\u7F42\u7F43\u7F4C\u81A1\u81BA\u82F1\u8314\u8365\u8367\u83B9\u83BA\u8424\u8425\u8426\u843E\u84E5\u85C0\u8621\u86CD\u8747\u8767\u877F\u87A2\u8805\u8833\u892E\u89AE\u8B0D\u8B4D\u8B7B\u8CCF\u8D0F\u8D62\u8EC8\u8FCE\u90E2\u93A3\u941B\u944D\u9533\u9719\u9795\u97FA\u9834\u988D\u9895\u9896\u9D2C\u9DA7\u9DAF\u9DEA\u9DF9\u9E0E\u9E1A\u9E66\u9E70",
            "Yo": "\u54DF\u5537\u55B2",
            "Yong": "\u4F63\u4FD1\u509B\u50AD\u52C7\u52C8\u548F\u5581\u55C8\u5670\u57C7\u584E\u5889\u58C5\u5ADE\u5D71\u5EB8\u5EF1\u5F6E\u603A\u607F\u6080\u60E5\u6111\u6139\u6142\u6175\u62E5\u64C1\u67E1\u6810\u69E6\u6C38\u6CF3\u6D8C\u6E67\u6EFD\u6FAD\u7049\u7245\u7528\u752C\u75C8\u7655\u7670\u783D\u7867\u799C\u81C3\u82DA\u86F9\u8A60\u8E0A\u8E34\u9095\u90FA\u9118\u919F\u92BF\u93DE\u955B\u96CD\u96DD\u9852\u9899\u9954\u9BD2\u9C2B\u9C45\u9CAC\u9CD9\u9DDB",
            "You": "\u4E23\u4EB4\u4F18\u4F51\u4F91\u5064\u512A\u5363\u53C8\u53CB\u53F3\u5466\u54CA\u5500\u5698\u56FF\u59F7\u5B67\u5BA5\u5C22\u5C24\u5CDF\u5CF3\u5E7C\u5E7D\u5EAE\u5FE7\u601E\u6023\u602E\u60A0\u6182\u61EE\u6538\u65BF\u6709\u67DA\u6884\u688E\u6962\u69F1\u6ACC\u6AFE\u6C8B\u6CB9\u6CD1\u6D5F\u6E38\u6E75\u6EFA\u7000\u7256\u7257\u7270\u72B9\u72D6\u7336\u7337\u7531\u75A3\u7950\u7989\u79DE\u7CFF\u7E8B\u7F90\u7F91\u8030\u8048\u80AC\u811C\u82C3\u839C\u83A0\u83A4\u83B8\u848F\u8555\u86B0\u86B4\u870F\u8763\u8A27\u8A98\u8BF1\u8C81\u8F0F\u8F36\u8FF6\u900C\u9030\u904A\u908E\u90AE\u90F5\u913E\u9149\u916D\u91C9\u923E\u92AA\u94C0\u94D5\u99C0\u9B77\u9B8B\u9C7F\u9C89\u9E80\u9EDD\u9F2C",
            "Yu": "\u4E0E\u4E88\u4E8E\u4E90\u4F03\u4F1B\u4F59\u4FC1\u4FDE\u4FE3\u4FFC\u504A\u50B4\u5125\u516A\u532C\u5539\u5585\u5590\u55A9\u55BB\u564A\u5673\u5704\u5709\u572B\u57DF\u5809\u5823\u582C\u59A4\u59AA\u5A1B\u5A2F\u5A31\u5A80\u5AD7\u5B29\u5B87\u5BD3\u5BD9\u5C7F\u5CEA\u5CFF\u5D33\u5D4E\u5D5B\u5D8E\u5DBC\u5EBD\u5EBE\u5F67\u5FA1\u5FEC\u6086\u60D0\u6108\u6109\u611A\u617E\u61D9\u622B\u625C\u6275\u6327\u63C4\u6554\u6594\u659E\u65BC\u65DF\u6631\u6745\u682F\u68DB\u68DC\u68EB\u6940\u6961\u6970\u6986\u6AF2\u6B0E\u6B1D\u6B24\u6B32\u6B48\u6B5F\u6B76\u6BD3\u6D74\u6DE2\u6DE4\u6DEF\u6E14\u6E1D\u6E61\u6EEA\u6F01\u6F9E\u6FA6\u706A\u7134\u715C\u71CF\u71E0\u7229\u724F\u72F1\u72F3\u7344\u7389\u7397\u7399\u7419\u7440\u745C\u74B5\u756C\u756D\u7600\u7609\u7610\u7652\u76C2\u76D3\u776E\u77DE\u7821\u7862\u7907\u7916\u791C\u7964\u79A6\u79B9\u79BA\u79D7\u7A22\u7A36\u7A65\u7A7B\u7AAC\u7AB3\u7AFD\u7B8A\u7BFD\u7C45\u7C5E\u7C72\u7D06\u7DCE\u7E58\u7EA1\u7F6D\u7FAD\u7FBD\u807F\u80B2\u8174\u81FE\u8201\u8206\u8207\u8245\u828B\u828C\u831F\u8330\u8362\u842D\u842E\u8438\u84AE\u84E3\u84F9\u854D\u8577\u8581\u860C\u861B\u865E\u8676\u871F\u872E\u8753\u87B8\u8867\u88AC\u88D5\u8915\u89A6\u89CE\u8A89\u8A9E\u8ADB\u8AED\u8B23\u8B7D\u8BED\u8C00\u8C15\u8C6B\u8C90\u8E30\u8EC9\u8F0D\u8F3F\u8F5D\u8FC2\u8FC3\u9033\u903E\u9047\u9079\u9098\u90C1\u9105\u9151\u91A7\u91EA\u923A\u9289\u92CA\u92D9\u9325\u935D\u942D\u94B0\u94FB\u95BE\u9608\u9653\u9683\u9685\u96A9\u96D3\u96E8\u96E9\u9731\u9810\u9884\u98EB\u9918\u9947\u996B\u9980\u99AD\u9A1F\u9A48\u9A6D\u9AAC\u9AC3\u9B30\u9B31\u9B3B\u9B4A\u9B5A\u9B63\u9BBD\u9BF2\u9C05\u9C4A\u9C7C\u9CFF\u9D25\u9D27\u9D2A\u9D52\u9DE0\u9DF8\u9E06\u9E12\u9E46\u9E6C\u9E8C\u9F6C\u9F89",
            "Yuan": "\u5086\u5143\u51A4\u5248\u539F\u53A1\u53B5\u5458\u54E1\u566E\u56E6\u56ED\u5706\u570E\u5712\u5713\u571C\u57A3\u57B8\u586C\u5917\u59B4\u5A9B\u5AB4\u5AC4\u5B3D\u5BC3\u5F32\u6028\u6081\u60CC\u613F\u63BE\u63F4\u676C\u68E9\u699E\u69AC\u6A7C\u6ADE\u6C85\u6DF5\u6E01\u6E06\u6E0A\u6E15\u6E72\u6E90\u6E92\u7041\u7230\u7328\u733F\u7342\u7457\u76F6\u7722\u7990\u7B0E\u7BA2\u7DE3\u7E01\u7F18\u7FB1\u8099\u82D1\u847E\u849D\u84AC\u8597\u8696\u870E\u8735\u875D\u876F\u8788\u884F\u8881\u88EB\u8911\u8924\u8B1C\u8C9F\u8D20\u8F45\u8F95\u8FDC\u903A\u9060\u908D\u90A7\u915B\u9228\u92FA\u93B1\u9662\u9858\u99CC\u9A35\u9B6D\u9CF6\u9D1B\u9D77\u9DA2\u9DB0\u9E22\u9E33\u9E53\u9EFF\u9F0B\u9F18\u9F1D",
            "Yue": "\u5216\u5B33\u5C84\u5CB3\u5DBD\u5F5F\u5F60\u6071\u6085\u60A6\u6209\u6288\u6373\u66F0\u66F1\u6708\u6782\u6A3E\u6C4B\u7039\u721A\u73A5\u77F1\u793F\u79B4\u7BB9\u7BD7\u7C46\u7C65\u7C70\u7CA4\u7CB5\u7D04\u7EA6\u8625\u868E\u868F\u8D8A\u8DC0\u8DC3\u8E8D\u8ECF\u9205\u925E\u94A5\u94BA\u95B1\u95B2\u9605\u9E11\u9E19\u9EE6\u9FA0\u9FA5",
            "Yun": "\u4E91\u4F1D\u508A\u5141\u52FB\u5300\u544D\u5597\u56E9\u593D\u596B\u5998\u5B55\u607D\u60F2\u6120\u612A\u614D\u628E\u62A3\u6600\u6655\u6688\u679F\u6A52\u6B92\u6B9E\u6C32\u6C33\u6C84\u6DA2\u6EB3\u6F90\u7174\u7185\u7189\u72C1\u73A7\u7547\u7703\u78D2\u79D0\u7B7C\u7BD4\u7D1C\u7DFC\u7E15\u7E1C\u7E67\u7EAD\u7F0A\u8018\u803A\u816A\u82B8\u837A\u8480\u8495\u84B7\u8553\u8570\u8574\u8580\u85F4\u860A\u8779\u891E\u8CF1\u8D07\u8D5F\u8FD0\u904B\u90D3\u90E7\u9106\u9116\u915D\u9196\u919E\u9217\u92C6\u962D\u9668\u9695\u96F2\u9723\u97D7\u97DE\u97EB\u97F5\u97FB\u9835\u992B\u99A7\u99BB\u9F6B\u9F73",
            "Za": "\u531D\u5482\u56D0\u5E00\u62F6\u6742\u685A\u6C9E\u6CAF\u7838\u78FC\u7D25\u7D2E\u81DC\u81E2\u894D\u9254\u96D1\u96DC\u96E5\u97F4\u9B73",
            "Zai": "\u50A4\u510E\u518D\u54C9\u5728\u5BB0\u5D3D\u6257\u683D\u6D05\u6E3D\u6EA8\u707D\u707E\u70D6\u753E\u7775\u7E21\u83D1\u8CF3\u8F09\u8F7D\u9168",
            "Zan": "\u507A\u5127\u5139\u5142\u54B1\u5592\u56CB\u5BC1\u648D\u6522\u661D\u6682\u66AB\u6FFD\u7052\u74C9\u74D2\u74DA\u79B6\u7C2A\u7C2E\u7CCC\u8978\u8B83\u8B9A\u8CDB\u8D0A\u8D5E\u8DB1\u8DB2\u8E54\u913C\u9142\u9147\u933E\u93E8\u9415\u9961",
            "Zang": "\u585F\u5958\u5F09\u7242\u7F98\u810F\u81D3\u81DF\u81E7\u846C\u8CCD\u8CD8\u8D13\u8D1C\u8D43\u92BA\u99D4\u9A75\u9AD2",
            "Zao": "\u50AE\u51FF\u5515\u5523\u55BF\u566A\u6165\u65E9\u67A3\u6806\u688D\u68D7\u6FA1\u7076\u7170\u71E5\u7485\u74AA\u7681\u7682\u7AC3\u7AC8\u7C09\u7CDF\u8241\u85BB\u85FB\u86A4\u8B5F\u8DAE\u8E67\u8E81\u9020\u906D\u91A9\u947F",
            "Ze": "\u4EC4\u4F2C\u5219\u5247\u5536\u5567\u556B\u5616\u5928\u5AE7\u5D31\u5E3B\u5E58\u5E82\u629E\u6351\u64C7\u6603\u6617\u6A0D\u6B75\u6C44\u6CA2\u6CCE\u6CFD\u6EAD\u6FA4\u769F\u7794\u77E0\u790B\u7A04\u7B2E\u7BA6\u7C00\u802B\u8234\u8536\u880C\u8957\u8ACE\u8B2E\u8CAC\u8CFE\u8D23\u8D5C\u8FEE\u9E05\u9F5A\u9F70",
            "Zei": "\u8808\u8CCA\u8D3C\u9C02\u9C61\u9C97",
            "Zen": "\u56CE\u600E\u8B56\u8B5B\u8C2E",
            "Zeng": "\u5897\u589E\u618E\u66FD\u6A67\u71B7\u7494\u7511\u77F0\u78F3\u7E52\u7F2F\u7F7E\u8B44\u8D08\u8D60\u912B\u92E5\u9503\u9C5B",
            "Zha": "\u4E4D\u5067\u5284\u538F\u5412\u54A4\u54F3\u55B3\u5953\u5BB1\u62AF\u6313\u63F8\u6429\u643E\u6463\u672D\u67E4\u67F5\u6805\u6942\u69A8\u6A1D\u6E23\u6EA0\u7079\u70B8\u7160\u7250\u7534\u75C4\u76B6\u76BB\u76BC\u7728\u781F\u7B9A\u81AA\u82F2\u86B1\u86BB\u89F0\u8A50\u8B47\u8B57\u8BC8\u8E37\u8ECB\u8FCA\u91A1\u9358\u94E1\u9598\u95F8\u9705\u9B93\u9BBA\u9C8A\u9C9D\u9F44\u9F47",
            "Zhai": "\u503A\u50B5\u5908\u5B85\u5BE8\u635A\u6458\u658B\u658E\u658F\u69B8\u7635\u7826\u7A84\u7C82\u7FDF\u9259\u9F4B",
            "Zhan": "\u4F54\u5061\u5360\u5661\u5AF8\u5C55\u5D2D\u5D83\u5D84\u5D98\u5DA6\u60C9\u6218\u6226\u6230\u62C3\u640C\u65A9\u65AC\u65C3\u65DC\u6808\u6834\u685F\u68E7\u6990\u6A4F\u6BE1\u6C08\u6C0A\u6CBE\u6E5B\u6FB6\u7416\u76BD\u76CF\u76DE\u77BB\u7AD9\u7DBB\u7EFD\u83DA\u859D\u8638\u8665\u8666\u86C5\u89B1\u8A40\u8A79\u8B6B\u8B9D\u8C35\u8D88\u8E4D\u8F1A\u8F3E\u8F4F\u8F97\u9085\u9186\u959A\u9711\u98AD\u98D0\u98E6\u9958\u9A4F\u9A59\u9AA3\u9B59\u9C63\u9CE3\u9E07\u9E6F\u9EF5",
            "Zhang": "\u4E08\u4EC9\u4ED7\u50BD\u5887\u5ADC\u5D82\u5E10\u5E33\u5E5B\u5E65\u5F20\u5F21\u5F35\u5F70\u615E\u6259\u638C\u66B2\u6756\u6A1F\u6DA8\u6DB1\u6F32\u6F33\u7350\u748B\u75EE\u762C\u7634\u7795\u7903\u7AE0\u7C80\u7CBB\u80C0\u8139\u8501\u87D1\u8CEC\u8D26\u9067\u9123\u93F1\u9423\u969C\u979D\u9926\u9A3F\u9C46\u9E9E",
            "Zhao": "\u4F4B\u5146\u53EC\u5541\u5797\u59B1\u5DF6\u627E\u62DB\u65D0\u662D\u66CC\u679B\u68F9\u6AC2\u6CBC\u70A4\u7167\u71F3\u722B\u72E3\u7475\u76C4\u77BE\u7ABC\u7B0A\u7B8C\u7F40\u7F69\u7F84\u8081\u8087\u8088\u8A54\u8BCF\u8D75\u8D99\u91D7\u924A\u9363\u948A\u99CB\u9BA1",
            "Zhe": "\u5387\u54F2\u5560\u5586\u55FB\u569E\u57D1\u5AEC\u608A\u6298\u647A\u6662\u6663\u67D8\u68CF\u6A00\u6A1C\u6B7D\u6D59\u6DDB\u77FA\u7813\u78D4\u7C77\u7C8D\u8005\u8517\u8674\u86F0\u8707\u87C4\u87C5\u88A9\u8936\u8975\u8A5F\u8B2B\u8B3A\u8B81\u8B8B\u8C2A\u8D6D\u8F12\u8F19\u8F4D\u8F84\u8F99\u8FD9\u9019\u906E\u92B8\u937A\u9517\u9BBF\u9DD3\u9E67",
            "Zhen": "\u4FA6\u4FB2\u5075\u5733\u5866\u59EB\u5AC3\u5BCA\u5C52\u5E2A\u5F2B\u62AE\u630B\u632F\u63D5\u6438\u6552\u6576\u659F\u6623\u6715\u6795\u6815\u681A\u6862\u686D\u6968\u699B\u69C7\u6A3C\u6B9D\u6D48\u6E5E\u6F67\u6FB5\u7349\u73CD\u73CE\u7467\u7504\u755B\u75B9\u7715\u771E\u771F\u7739\u7827\u78AA\u796F\u798E\u799B\u7A39\u7BB4\u7C48\u7D16\u7D3E\u7D7C\u7E1D\u7E25\u7EBC\u7F1C\u8044\u80D7\u81FB\u8419\u8474\u8496\u84C1\u85BD\u8704\u8897\u88D6\u8999\u8A3A\u8AAB\u8BCA\u8C9E\u8CD1\u8D1E\u8D48\u8EEB\u8F43\u8F78\u8FB4\u9049\u9159\u91DD\u9241\u92F4\u9331\u9356\u937C\u93AD\u93AE\u9488\u9547\u9635\u9663\u9707\u9755\u99D7\u9B12\u9C75\u9D06\u9E29\u9EEE\u9EF0",
            "Zheng": "\u4E89\u4F42\u51E7\u57E9\u5863\u59C3\u5A9C\u5CE5\u5D1D\u5D22\u5E27\u5E40\u5F81\u5FB0\u5FB4\u5FB5\u6014\u6138\u628D\u62EF\u6323\u6399\u639F\u63C1\u649C\u653F\u6574\u6678\u6B63\u6C36\u70A1\u70DD\u722D\u72F0\u7319\u75C7\u7665\u7710\u7741\u775C\u7B5D\u7B8F\u7BDC\u7CFD\u8047\u84B8\u8A3C\u8ACD\u8B49\u8BC1\u8BE4\u8E2D\u90D1\u912D\u9266\u931A\u94B2\u94EE\u9B07\u9D0A",
            "Zhi": "\u4E4B\u4E7F\u4F84\u4FE7\u5001\u5024\u503C\u506B\u5082\u5128\u51EA\u5236\u5295\u52A7\u536E\u5394\u53EA\u5431\u54AB\u5740\u5741\u5767\u5781\u57F4\u57F7\u5886\u588C\u5902\u59EA\u5A21\u5B02\u5BD8\u5CD9\u5D3B\u5DF5\u5E0B\u5E19\u5E1C\u5E5F\u5EA2\u5EA4\u5ECC\u5F58\u5F8F\u5F94\u5F9D\u5FD7\u5FEE\u6049\u6179\u6184\u61E5\u61EB\u6220\u6267\u627A\u627B\u62A7\u6303\u6307\u631A\u63B7\u6418\u6431\u646D\u646F\u64F2\u64FF\u652F\u65D8\u65E8\u664A\u667A\u679D\u67B3\u67E3\u6800\u6809\u684E\u6894\u68BD\u690D\u6925\u69B0\u69DC\u6A34\u6ACD\u6ADB\u6B62\u6C41\u6C65\u6C66\u6C9A\u6CBB\u6D14\u6D37\u6DFD\u6ECD\u6EDE\u6EEF\u6F10\u6F4C\u6F6A\u7004\u7099\u71AB\u72FE\u7318\u74C6\u74E1\u7564\u7590\u75B7\u75BB\u75D4\u75E3\u7608\u76F4\u77E5\u780B\u7929\u7949\u7951\u7957\u796C\u7983\u7994\u79B5\u79D3\u79D6\u79E9\u79EA\u79F2\u79F7\u7A19\u7A1A\u7A3A\u7A49\u7A92\u7B6B\u7D19\u7D29\u7D77\u7D95\u7DFB\u7E36\u7E54\u7EB8\u7EC7\u7F6E\u7FD0\u8040\u8041\u804C\u8077\u80A2\u80D1\u80DD\u8102\u81A3\u81B1\u81F3\u81F4\u81F8\u8296\u829D\u82B7\u830B\u85E2\u8635\u86ED\u8718\u87B2\u87D9\u8879\u887C\u889F\u88A0\u88FD\u8967\u899F\u89D7\u89EF\u89F6\u8A28\u8A8C\u8B22\u8C51\u8C52\u8C78\u8CAD\u8CEA\u8D04\u8D28\u8D3D\u8DBE\u8DD6\u8DF1\u8E2C\u8E2F\u8E60\u8E62\u8E91\u8E93\u8EC4\u8EF9\u8F0A\u8F75\u8F7E\u90C5\u916F\u91DE\u928D\u92D5\u9455\u94DA\u9527\u9624\u962F\u965F\u96B2\u96BB\u96C9\u99B6\u99BD\u99E4\u9A2D\u9A3A\u9A47\u9A98\u9BEF\u9CF7\u9D19\u9D32\u9DD9\u9E37\u9EF9\u9F05",
            "Zhong": "\u4E2D\u4EF2\u4F00\u4F17\u5045\u51A2\u5223\u55A0\u5839\u585A\u5990\u5995\u5A91\u5C30\u5E52\u5F78\u5FE0\u67CA\u6B71\u6C77\u6CC8\u7082\u7144\u72C6\u7607\u76C5\u773E\u794C\u794D\u79CD\u7A2E\u7B57\u7C66\u7D42\u7EC8\u80BF\u816B\u822F\u833D\u8520\u869B\u87A4\u87BD\u8846\u8873\u8876\u8877\u8AE5\u8E35\u8E71\u8FDA\u9221\u937E\u9418\u949F\u953A\u9D24\u9F28",
            "Zhou": "\u4F37\u4F9C\u50FD\u5191\u5468\u546A\u5492\u54AE\u558C\u5663\u568B\u59AF\u5A64\u5B99\u5DDE\u5E1A\u5F9F\u663C\u665D\u666D\u6D00\u6D32\u6DCD\u70BF\u70D0\u73D8\u7503\u759B\u76B1\u76BA\u76E9\u776D\u77EA\u78A1\u7B92\u7C40\u7C52\u7C55\u7C99\u7CA5\u7D02\u7E10\u7EA3\u7EC9\u8098\u80C4\u821F\u836E\u83F7\u8464\u8A4B\u8B05\u8B78\u8BCC\u8BEA\u8CD9\u8D52\u8EF8\u8F08\u8F16\u8F74\u8F80\u9031\u90EE\u914E\u9282\u970C\u99CE\u99F2\u9A06\u9A5F\u9AA4\u9BDE\u9D43\u9E3C",
            "Zhu": "\u4E36\u4E3B\u4F2B\u4F47\u4F4F\u4F8F\u529A\u52A9\u52AF\u5631\u56D1\u577E\u58B8\u58F4\u5B4E\u5B94\u5C6C\u5D40\u62C4\u65B8\u66EF\u6731\u677C\u67F1\u67F7\u682A\u69E0\u6A26\u6A65\u6AE7\u6AEB\u6B18\u6BB6\u6CCF\u6CE8\u6D19\u6E1A\u6F74\u6FD0\u7026\u705F\u70A2\u70B7\u70DB\u7151\u716E\u71ED\u7225\u732A\u73E0\u75B0\u7603\u771D\u77A9\u77DA\u782B\u7843\u795D\u7969\u79FC\u7A8B\u7ADA\u7AF9\u7AFA\u7B01\u7B1C\u7B51\u7B6F\u7BB8\u7BC9\u7BEB\u7D35\u7D38\u7D51\u7EBB\u7F5C\u7F9C\u7FE5\u8233\u82A7\u82CE\u82E7\u8331\u833F\u8387\u84EB\u85F8\u86C0\u86DB\u876B\u880B\u8829\u883E\u88BE\u8A3B\u8A5D\u8A85\u8AF8\u8BDB\u8BF8\u8C6C\u8CAF\u8D2E\u8DD3\u8DE6\u8E85\u8EF4\u8FEC\u9010\u90BE\u9252\u9296\u92F3\u9444\u9483\u94E2\u94F8\u967C\u9714\u98F3\u99B5\u99D0\u99EF\u9A7B\u9BA2\u9BFA\u9C41\u9D38\u9E86\u9E88\u9F04",
            "Zhua": "\u6293\u6A9B\u7C3B\u81BC\u9AFD",
            "Zhuai": "\u62FD\u8DE9",
            "Zhuan": "\u4E13\u50CE\u53C0\u556D\u56C0\u581F\u5AE5\u5B68\u5C02\u5C08\u64B0\u7077\u7451\u747C\u750E\u7816\u78DA\u7AF1\u7BC6\u7C51\u7E33\u819E\u8483\u87E4\u8948\u8AEF\u8B54\u8CFA\u8D5A\u8EE2\u8F49\u8F6C\u911F\u9853\u989B\u994C\u9994\u9C44",
            "Zhuang": "\u4E2C\u58EE\u58EF\u58F5\u5986\u599D\u5A24\u5E84\u5E92\u6205\u649E\u6869\u6889\u6A01\u6E77\u710B\u72B6\u72C0\u7CA7\u7CDA\u8358\u838A\u88C5\u88DD",
            "Zhui": "\u5760\u589C\u5A37\u60F4\u6C9D\u7500\u7577\u787E\u7908\u7B0D\u7DB4\u7E0B\u7F00\u7F12\u8187\u8AC8\u8D05\u8D58\u8F5B\u8FFD\u918A\u9310\u9323\u9446\u9525\u96B9\u991F\u9A05\u9A93\u9D7B",
            "Zhun": "\u51C6\u51D6\u57FB\u5B92\u6E96\u7A15\u7A80\u7DA7\u80AB\u8860\u8A30\u8AC4\u8C06\u8FCD",
            "Zhuo": "\u4E35\u502C\u5285\u5353\u53D5\u5544\u5545\u5734\u59B0\u5A3A\u5F74\u62D9\u6349\u64AF\u64C6\u64E2\u6580\u65AB\u65AE\u65B1\u65B2\u65B5\u666B\u684C\u68B2\u68C1\u68F3\u6913\u69D5\u6AE1\u6D4A\u6D5E\u6DBF\u6FC1\u6FEF\u7042\u707C\u70AA\u70F5\u72B3\u7422\u7438\u787A\u799A\u7A5B\u7A71\u7AA1\u7AA7\u7BE7\u7C57\u7C71\u7F6C\u8301\u8817\u883F\u8AC1\u8AD1\u8B36\u8BFC\u914C\u92DC\u942F\u9432\u956F\u9D6B\u9DDF",
            "Zi": "\u5033\u525A\u5407\u5470\u54A8\u5528\u5559\u55DE\u59C9\u59CA\u59D5\u59FF\u5B50\u5B56\u5B57\u5B5C\u5B73\u5B76\u5D30\u5D6B\u6063\u674D\u6825\u6893\u6914\u699F\u6A74\u6DC4\u6E0D\u6E7D\u6ECB\u6ED3\u6F2C\u6FAC\u7278\u7386\u7725\u7726\u77F7\u798C\u79C4\u79ED\u79F6\u7A35\u7B2B\u7C7D\u7CA2\u7D0E\u7D2B\u7DC7\u7F01\u8014\u80CF\u80D4\u80FE\u81EA\u8293\u830A\u8321\u8332\u8458\u8678\u89DC\u8A3E\u8A3F\u8AEE\u8C18\u8CB2\u8CC7\u8D40\u8D44\u8D7C\u8D91\u8DA6\u8F1C\u8F3A\u8F8E\u9111\u91E8\u922D\u9319\u937F\u93A1\u9531\u9543\u983E\u983F\u9AED\u9BD4\u9C26\u9CBB\u9D85\u9F12\u9F4D\u9F5C\u9F87",
            "Zong": "\u500A\u5027\u506C\u50AF\u582B\u5B97\u5D4F\u5D55\u5D78\u603B\u60E3\u60FE\u6121\u6374\u63D4\u6403\u6460\u662E\u6721\u68D5\u6936\u71A7\u71EA\u7314\u7323\u75AD\u7632\u7882\u78EB\u7A2F\u7CBD\u7CC9\u7D9C\u7DC3\u7DCF\u7DF5\u7E02\u7E26\u7E31\u7E3D\u7EB5\u7FEA\u8159\u8250\u847C\u84D7\u876C\u8C75\u8E28\u8E2A\u8E64\u931D\u936F\u93D3\u9441\u9A0C\u9A23\u9A94\u9B03\u9B09\u9B37\u9BEE\u9BFC",
            "Zou": "\u594F\u5AB0\u63AB\u63CD\u68F7\u68F8\u7B83\u7DC5\u83C6\u8ACF\u8BF9\u8D70\u8D71\u90B9\u90F0\u9112\u9139\u966C\u9A36\u9A7A\u9BD0\u9BEB\u9CB0\u9EC0\u9F7A",
            "Zu": "\u4FCE\u50B6\u5346\u5352\u54EB\u5D12\u5D2A\u65CF\u723C\u73C7\u7956\u79DF\u7A21\u7BA4\u7D44\u7EC4\u83F9\u8445\u84A9\u8A5B\u8B2F\u8BC5\u8DB3\u8E24\u8E3F\u93BA\u93C3\u955E\u963B\u977B",
            "Zuan": "\u5297\u63DD\u6525\u7C6B\u7E64\u7E82\u7E89\u7E98\u7F35\u8E9C\u8EA6\u945A\u947D\u94BB",
            "Zui": "\u539C\u55FA\u5634\u567F\u5D8A\u5DB5\u666C\u6700\u6718\u67A0\u682C\u6A36\u6A87\u6A8C\u6B08\u6FE2\u74BB\u797D\u7A5D\u7D4A\u7E97\u7F6A\u855E\u87D5\u8FA0\u9154\u917B\u9189\u92F7\u930A",
            "Zun": "\u50D4\u5642\u5C0A\u5D9F\u6358\u6499\u6A3D\u7E5C\u7F47\u8B50\u9075\u928C\u940F\u9C52\u9CDF\u9D8E\u9DF7",
            "Zuo": "\u4F50\u4F5C\u4FB3\u505A\u5497\u5511\u5750\u5C9D\u5C9E\u5DE6\u5EA7\u600D\u637D\u6628\u690A\u795A\u79E8\u7A13\u7B70\u7CF3\u7E53\u80D9\u838B\u8443\u8444\u84D9\u888F\u923C\u963C\u98F5",
            "Cou": "\u51D1\u6971\u6E4A\u8160\u8F33\u8F8F",
            "Nang": "\u4E6A\u513E\u56A2\u56CA\u56D4\u64C3\u652E\u66E9\u6B1C\u7062\u8830\u9962\u9995\u9B1E\u9F49",
            "Dia": "\u55F2",
            "o": "\u5594",
            "bia": "\u9adf",
            "Chuai": "\u555C\u562C\u63E3\u8197\u8E39",
            "Cen": "\u5C91\u5D7E\u68A3\u6D94\u7B12\u81A5",
            "Diu": "\u4E1F\u4E22\u92A9\u94E5\u98A9",
            "Nou": "\u5542\u69C8\u6ABD\u7373\u7FBA\u8028\u8B68\u8B73\u9392\u941E",
            "Fou": "\u57BA\u599A\u7D11\u7F36\u7F39\u7F3B\u96EC\u9D00"
        };
        this.PolyphoneTable = {
            "\u963f": ["a", "e"],
            "\u814c": ["a", "yan"],
            "\u62d7": ["ao", "niu"],
            "\u6252": ["ba", "pa"],
            "\u868c": ["bang", "beng"],
            "\u8584": ["bao", "bo"],
            "\u5821": ["bao", "pu", "bu"],
            "\u66b4": ["bao", "pu"],
            "\u81c2": ["bei", "bi"],
            "\u8f9f": ["bi", "pi"],
            "\u6241": ["bian", "pian"],
            "\u4fbf": ["bian", "pian"],
            "\u8180": ["bang", "pang"],
            "\u78c5": ["bang", "pang"],
            "\u9aa0": ["biao", "piao"],
            "\u5c4f": ["bing", "ping"],
            "\u5265": ["bo", "bao"],
            "\u6cca": ["bo", "po"],
            "\u4f2f": ["bo", "bai"],
            "\u535c": ["bo", "bu"],
            "\u4f27": ["cang", "chen"],
            "\u85cf": ["cang", "zang"],
            "\u66fe": ["ceng", "zeng"],
            "\u564c": ["ceng", "cheng"],
            "\u5dee": ["cha", "chai", "ci"],
            "\u7985": ["chan", "shan"],
            "\u98a4": ["chan", "zhan"],
            "\u5b71": ["chan", "can"],
            "\u88f3": ["chang", "shang"],
            "\u5632": ["chao", "zhao"],
            "\u8f66": ["che", "ju"],
            // 车
            "\u79f0": ["chen", "cheng"],
            "\u6f84": ["cheng", "deng"],
            "\u94db": ["cheng", "dang"],
            "\u4e58": ["cheng", "sheng"],
            "\u5319": ["chi", "shi"],
            "\u81ed": ["chou", "xiu"],
            "\u755c": ["chu", "xu"],
            "\u7ef0": ["chuo", "chao"],
            "\u4f3a": ["ci", "si"],
            "\u5179": ["ci", "zi"],
            "\u679e": ["cong", "zong"],
            "\u6512": ["cuan", "zan"],
            "\u64ae": ["cuo", "zuo"],
            "\u690e": ["chui", "zhui"],
            "\u5927": ["da", "dai", "tai"],
            "\u6c93": ["da", "ta"],
            "\u5355": ["dan", "chan", "shan"],
            "\u53e8": ["dao", "tao"],
            "\u63d0": ["di", "ti"],
            "\u7684": ["de", "di"],
            "\u5f97": ["de", "dei"],
            "\u94bf": ["dian", "tian"],
            "\u90fd": ["dou", "du"],
            "\u5ea6": ["du", "duo"],
            "\u56e4": ["dun", "tun"],
            "\u5426": ["fou", "pi"],
            "\u812f": ["fu", "pu"],
            "\u8f67": ['ga', "ya", "zha"],
            "\u625b": ["gang", "kang"],
            "\u54af": ["ge", "ka", "lo"],
            "\u9769": ["ge", "ji"],
            "\u7ed9": ["gei", "ji"],
            // 给
            "\u9888": ["geng", "jing"],
            "\u7ea2": ["gong", "hong"],
            "\u67b8": ["gou", "ju"],
            "\u5471": ["gu", "gua"],
            "\u9e44": ["gu", "hu"],
            "\u62ec": ["gua", "kuo"],
            "\u839e": ["guan", "wan"],
            "\u7eb6": ["guan", "lun"],
            "\u6867": ["gui", "hui"],
            "\u867e": ["ha", "xia"],
            "\u54b3": ["hai", "ke"],
            "\u5df7": ["hang", "xiang"],
            "\u542d": ["hang", "keng"],
            "\u548c": ["he", "huo"],
            "\u8c89": ["he", "hao"],
            "\u4f1a": ["hui", "kuai"],
            "\u5947": ["ji", "qi"],
            "\u7f09": ["ji", "qi"],
            "\u5048": ["ji", "jie"],
            "\u7a3d": ["ji", "qi"],
            "\u4e9f": ["ji", "qi"],
            "\u8bd8": ["ji", "jie"],
            "\u8304": ["jia", "qie"],
            "\u56bc": ["jiao", "jue"],
            "\u4fa5": ["jiao", "yao"],
            "\u89d2": ["jiao", "jue"],
            "\u811a": ["jiao", "jue"],
            "\u527f": ["jiao", "chao"],
            "\u6821": ["jiao", "xiao"],
            "\u89e3": ["jie", "xie"],
            "\u82a5": ["jie", "gai"],
            "\u85c9": ["jie", "ji"],
            "\u77dc": ["jin", "qin"],
            "\u52b2": ["jin", "jing"],
            "\u9f9f": ["jun", "gui", "qiu"],
            "\u5480": ["ju", "zui"],
            "\u5361": ["ka", "qia"],
            "\u58f3": ["ke", "qia"],
            "\u6e83": ["kui", "hui"],
            "\u70d9": ["lao", "luo"],
            "\u808b": ["le", "lei"],
            "\u4e50": ["le", "yue"],
            "\u4fe9": ["lia", "liang"],
            "\u6f66": ["liao", "lao"],
            "\u788c": ["liu", "lu"],
            "\u507b": ["lou", "lu"],
            "\u9732": ["lu", "lou"],
            "\u634b": ["lu", "luo"],
            "\u7edc": ["luo", "lao"],
            "\u843d": ["luo", "lao", "la"],
            "\u62b9": ["ma", "mo"],
            "\u8109": ["mo", "mai"],
            "\u57cb": ["mai", "man"],
            "\u8513": ["man", "wan"],
            "\u6c13": ["mang", "meng"],
            "\u6ca1": ["mei", "mo"],
            "\u79d8": ["mi", "bi"],
            "\u6ccc": ["mi", "bi"],
            "\u6a21": ["mo", "mu"],
            "\u6469": ["mo", "ma"],
            "\u7f2a": ["mou", "miu", "miao"],
            "\u5f04": ["nong", "long"],
            "\u759f": ["nue", "yao"],
            "\u5a1c": ["nuo", "na"],
            "\u8feb": ["pai", "po"],
            "\u80d6": ["pan", "pang"],
            "\u5228": ["pao", "bao"],
            "\u70ae": ["pao", "bao"],
            "\u6734": ["pu", "po", "piao"],
            "\u7011": ["pu", "bao"],
            "\u66dd": ["pu", "bao"],
            "\u6816": ["qi", "xi"],
            "\u8e4a": ["qi", "xi"],
            "\u8368": ["qian", "xun"],
            "\u5f3a": ["qiang", "jiang"],
            "\u8d84": ["qie", "ju"],
            "\u4eb2": ["qin", "qing"],
            "\u96c0": ["qiao", "que"],
            "\u5708": ["quan", "juan"],
            "\u8272": ["se", "shai"],
            "\u585e": ["se", "sai"],
            "\u53a6": ["sha", "xia"],
            "\u6749": ["sha", "shan"],
            "\u6c64": ["shang", "tang"],
            "\u62fe": ["she", "shi"],
            "\u4ec0": ["shen", "shi"],
            "\u845a": ["shen", "ren"],
            "\u8bc6": ["shi", "zhi"],
            "\u4f3c": ["shi", "si"],
            "\u5c5e": ["shu", "zhu"],
            "\u719f": ["shu", "shou"],
            "\u8bf4": ["shui", "shuo"],
            "\u6570": ["shu", "shuo"],
            "\u5fea": ["song", "zhong"],
            "\u5bbf": ["su", "xiu"],
            "\u8c03": ["tiao", "diao"],
            "\u892a": ["tui", "tun"],
            "\u62d3": ["tuo", "ta"],
            "\u5729": ["wei", "xu"],
            "\u9057": ["wei", "yi"],
            "\u7cfb": ["xi", "ji"],
            "\u5413": ["xia", "he"],
            "\u7ea4": ["xian", "qian"],
            "\u884c": ["xing", "heng", "hang"],
            "\u7701": ["xing", "sheng"],
            "\u524a": ["xiao", "xue"],
            "\u8840": ["xie", "xue"],
            "\u6bb7": ["yin", "yan"],
            "\u54bd": ["yan", "ye"],
            "\u827e": ["yi", "ai"],
            "\u71a8": ["yu", "yue"],
            "\u5401": ["yu", "xu"],
            "\u548b": ["za", "ze", "zha"],
            "\u62e9": ["ze", "zhai"],
            "\u624e": ["zha", "za"],
            "\u7c98": ["zhan", "nian"],
            "\u722a": ["zhao", "zhua"],
            "\u7740": ["zhao", "zhuo"],
            "\u6b96": ["zhi", "shi"],
            "\u8457": ["zhu", "zhuo", "zhe"],
            "\u5e62": ["zhuang", "chuang"],
            "\u7efc": ["zeng", "zong"],
            "\u4ed4": ["zi", "zai"],
            "\u67de": ["zuo", "zha"],
            "\u91cd": ["zhong", "chong"]
        };
        this.reg = new RegExp('[\u4e00-\u9fa5]+');
    }
    /**
     * @param {?} chinasInfo
     * @return {?}
     */
    ChineseToPinyinService.prototype.ConvertPinyin = function (chinasInfo) {
        var /** @type {?} */ variable = {
            self: this,
            chinas: (typeof chinasInfo.chinas == "number" ? chinasInfo.chinas : chinasInfo.chinas.replace(/(^\s*)|(\s*$)/g, '')),
            arr: (typeof chinasInfo.arr == "boolean" ? chinasInfo.arr : false),
            first: (typeof chinasInfo.first == "boolean" ? chinasInfo.first : false),
            capital: (typeof chinasInfo.firstCapital == "boolean" ? chinasInfo.firstCapital : false),
            bothShow: (typeof chinasInfo.bothShow == "boolean" ? chinasInfo.bothShow : false),
            indef: (typeof chinasInfo.chinas == "number" ? 0 : chinasInfo.chinas.length),
            changChina: null,
            vals: chinasInfo.vals,
            ind: 0,
            Division: (typeof chinasInfo.Division == "string" ? chinasInfo.Division : 'span')
        };
        var /** @type {?} */ myFun = {
            arraySearch: function (pin) {
                for (var /** @type {?} */ name in variable.self.MatchingTable) {
                    // 非多音字
                    if (variable.self.MatchingTable[name].indexOf(pin.vals) != -1) {
                        return (variable.bothShow ? (variable.ind++, myFun.ucfirst({ name: name }) + ':' + variable.chinas[variable.ind - 1] + ' ') : (myFun.ucfirst({ name: name })));
                    }
                }
                for (var /** @type {?} */ name in variable.self.PolyphoneTable) {
                    // 多音字
                    if (name === pin.vals) {
                        return (variable.bothShow ? (variable.ind++, myFun.getString({ Polyphone: variable.self.PolyphoneTable[name] }) + ':' + variable.chinas[variable.ind - 1] + ' ') :
                            (myFun.getString({ Polyphone: variable.self.PolyphoneTable[name] })));
                    }
                }
                return false;
            },
            getString: function (pin) {
                var /** @type {?} */ str = (variable.arr ? [] : '');
                for (var /** @type {?} */ i = 0; i < pin.Polyphone.length; i++) {
                    variable.arr ? str.push(myFun.ucfirst({ name: pin.Polyphone[i] })) :
                        (str += (i == pin.Polyphone.length - 1 ? myFun.ucfirst({ name: pin.Polyphone[i] }) : myFun.ucfirst({ name: pin.Polyphone[i] }) + "-"));
                }
                return (variable.arr ? str : '(' + str + ')');
            },
            ucfirst: function (pin) {
                if (pin.name.length > 0) {
                    var /** @type {?} */ first = pin.name.substr(0, 1).toUpperCase(); // toLowerCase()  小写   toUpperCase() 大写
                    var /** @type {?} */ spare = pin.name.substr(1, pin.name.length).toLowerCase();
                    return variable.first ? (variable.capital ? first : first.toLowerCase()) : (variable.capital ? (first + spare) : pin.name.toLowerCase());
                }
            },
            returnPin: function () {
                var /** @type {?} */ val = '', /** @type {?} */ name = '';
                variable.changChina = [] || '';
                for (var /** @type {?} */ i = 0; i < variable.indef; i++) {
                    val = variable.chinas.substr(i, 1);
                    if (!variable.self.reg.test(val)) {
                        variable.arr ? variable.changChina.push(variable.capital ? val.toUpperCase() : val.toLowerCase()) :
                            (variable.bothShow ? (variable.ind++, variable.changChina += (variable.capital ? val.toUpperCase() : val.toLowerCase()) + ':' + variable.chinas[variable.ind - 1] + ' ') :
                                (variable.changChina += (variable.capital ? val.toUpperCase() : val.toLowerCase())));
                    }
                    else if (Boolean(name) != false || typeof (name) != 'boolean') {
                        name = myFun.arraySearch({ vals: val });
                        variable.arr ? variable.changChina.push(name) : variable.changChina += name;
                    }
                }
                return (typeof chinasInfo.chinas == "number" ? variable.chinas : variable.changChina);
            }
        };
        if (typeof variable.vals === "object") {
            return variable.self.AgainTreatment({
                chinas: variable.chinas,
                pinyin: myFun.returnPin(),
                vals: variable.vals.str,
                getHtml: variable.vals.getHtml,
                className: variable.vals.className,
                Division: variable.vals.Division
            }); // 其他处理
        }
        else {
            return myFun.returnPin(); // 返回拼音
        }
    };
    /**
     * @param {?} chinas
     * @return {?}
     */
    ChineseToPinyinService.prototype.AgainTreatment = function (chinas) {
        var /** @type {?} */ variable = {
            self: this, sign: '', pinyin: '', stext: '', stextVal: '', serachT: [], retText: ''
        };
        var /** @type {?} */ myFun = {
            getPinYin: function (pin) {
                variable.sign = '';
                for (var /** @type {?} */ i = (typeof pin.num === "number" ? pin.num : 0); i < chinas.pinyin.length; i++) {
                    if ((typeof pin.split === "boolean" ? pin.split : false)) {
                        if (typeof chinas.pinyin[i] === "object") {
                            var /** @type {?} */ chars = myFun.matching({ str: chinas.pinyin[i] });
                            typeof chars === "string" ? (chars == chinas.vals ? variable.sign += "#&&#" : variable.sign += chars) :
                                (chinas.pinyin[i][0] == chinas.vals ? variable.sign += "#&&#" : variable.sign += chinas.pinyin[i][0]);
                        }
                        else {
                            chinas.pinyin[i] == chinas.vals ? variable.sign += "#&&#" : variable.sign += chinas.pinyin[i];
                        }
                    }
                    else {
                        typeof chinas.pinyin[i] === "object" ? (variable.sign += (typeof myFun.matching({ str: chinas.pinyin[i] }) === "string" ? myFun.matching({ str: chinas.pinyin[i] })
                            : chinas.pinyin[i][0])) : (variable.sign += chinas.pinyin[i]);
                    }
                }
                return variable.sign;
            },
            matching: function (pin) {
                for (var /** @type {?} */ i in pin.str) {
                    if ((typeof pin.sou === "boolean" ? pin.sou : false)) {
                        // 用于首拼
                        if (chinas.vals.indexOf(pin.str[i].substr(0, 1)) >= 0) {
                            return pin.str[i];
                        }
                    }
                    else if (chinas.vals.indexOf(pin.str[i]) >= 0) {
                        return pin.str[i];
                    }
                }
            },
            returnChinas: function () {
                variable.pinyin = myFun.getPinYin({ split: true });
                variable.stext = '';
                variable.stextVal = '';
                variable.serachT = [];
                var /** @type {?} */ fullFun = {
                    // 用于返回汉字
                    fullPin: function (pin) {
                        var /** @type {?} */ q = fullFun.fullNum({ one: pin.one, num: qian }), /** @type {?} */ h = fullFun.fullNum({ one: (pin.one == chinas.vals ? chinas.vals : pin.one + chinas.vals), num: hou });
                        var /** @type {?} */ k = (pin.one == chinas.vals ? qian : h);
                        qian = h;
                        hou = qian;
                        return (typeof h === "number" ? chinas.chinas.substr((pin.one == chinas.vals ? k + 1 : q + 1), (h - (pin.one == chinas.vals ? k : q))) : "");
                    },
                    fullNum: function (pin) {
                        var /** @type {?} */ Text = '';
                        for (var /** @type {?} */ s = pin.num + 1; s < chinas.chinas.length; s++) {
                            Text += typeof chinas.pinyin[s] === "object" ? (typeof myFun.matching({ str: chinas.pinyin[s], texts: Text }) === "string" ? myFun.matching({ str: chinas.pinyin[s], texts: Text })
                                : chinas.pinyin[s][0]) : (chinas.pinyin[s]);
                            // console.log(Text +'  '+s)
                            if (pin.one == Text) {
                                return s;
                            }
                        }
                    }
                };
                if (variable.pinyin.indexOf('#&&#') >= 0 && chinas.vals.length > 1) {
                    // 全拼(单个字)
                    var /** @type {?} */ b = variable.pinyin.split("#&&#"), /** @type {?} */ qian = -1, /** @type {?} */ hou = -1;
                    for (var /** @type {?} */ i = 0; i < b.length; i++) {
                        i > 0 ? (variable.retText = fullFun.fullPin({ one: (b[i - 1] != "" ? b[i - 1] : chinas.vals) }), (variable.retText != "" ? variable.serachT.push(variable.retText) :
                            variable.serachT)) : variable.serachT;
                    }
                }
                if (variable.pinyin.indexOf(chinas.vals) >= 0 && chinas.vals.length > 1) {
                    // 全拼（多个字或者一段话）
                    var /** @type {?} */ b = variable.pinyin.split(chinas.vals), /** @type {?} */ qian = -1, /** @type {?} */ hou = -1;
                    for (var /** @type {?} */ i = 0; i < b.length; i++) {
                        i > 0 ? (variable.retText = fullFun.fullPin({ one: (b[i - 1] != "" ? b[i - 1] : chinas.vals) }), (variable.retText != "" ? variable.serachT.push(variable.retText) :
                            variable.serachT)) : variable.serachT;
                    }
                }
                if (chinas.vals.length > 0) {
                    // 首字母
                    var /** @type {?} */ Text, /** @type {?} */ single = '';
                    for (var /** @type {?} */ s = 0; s < chinas.chinas.length; s++) {
                        Text += typeof chinas.pinyin[s] === "object" ?
                            (single = myFun.matching({ str: chinas.pinyin[s], texts: Text, sou: true }), typeof single === "string" ? single.substr(0, 1) : chinas.pinyin[s][0].substr(0, 1)) :
                            (chinas.pinyin[s].substr(0, 1));
                    }
                    // console.log(Text + '   '+ chinas.vals);
                    if (Text.indexOf(chinas.vals) >= 0) {
                        var /** @type {?} */ leng = 0;
                        Text = Text.split(chinas.vals);
                        // tslint:disable-next-line:one-line
                        // tslint:disable-next-line:no-shadowed-variable
                        // tslint:disable-next-line:forin
                        for (var /** @type {?} */ i_1 in Text) {
                            leng += Text[i_1].length;
                            leng + Number(i_1) * chinas.vals.length < chinas.chinas.length ? variable.serachT.push(chinas.chinas.substr(leng + Number(i_1) * chinas.vals.length, chinas.vals.length)) : variable.serachT;
                        }
                    }
                }
                // console.log(variable.serachT);
                variable.serachT = myFun.removeRepeat(variable.serachT); // 去掉重复的元素
                return variable.serachT;
            },
            removeRepeat: function (arr) {
                // 数组去重
                var /** @type {?} */ result = [], /** @type {?} */ temp = {};
                // tslint:disable-next-line:forin
                for (var /** @type {?} */ i in arr) {
                    typeof temp[arr[i]] !== "number" ? (result.push(arr[i]), temp[arr[i]] = 1) : null;
                }
                return result;
            },
            getThisText: function () {
                // 返回分割好的html
                var /** @type {?} */ thisT = '', /** @type {?} */ searchT = myFun.returnChinas();
                var /** @type {?} */ toolFun = {
                    seclectText: function () {
                        if (searchT.length > 0) {
                            var /** @type {?} */ searchSt = chinas.chinas;
                            var /** @type {?} */ searchAr = [];
                            for (var /** @type {?} */ i = 0; i < searchT.length; i++) {
                                searchAr = searchSt.split(searchT[i]);
                                searchSt = '';
                                for (var /** @type {?} */ k = 0; k < searchAr.length; k++) {
                                    searchAr[k] == "" ? (searchSt += ((k + 1) == searchAr.length ? '' : '^' + searchT[i] + '#') + searchAr[k]) :
                                        (searchSt += searchAr[k] + ((k + 1) == searchAr.length ? '' : '^' + searchT[i] + '#'));
                                }
                            }
                            thisT = searchSt;
                        }
                        else {
                            thisT = chinas.chinas;
                        }
                        thisT = thisT.replace(/[\^]/g, "<" + (typeof chinas.Division == "string" ? chinas.Division : 'span') + " " + (chinas.className ? ("class=" + chinas.className) : "") + ">");
                        thisT = thisT.replace(/[\#]/g, "</" + (typeof chinas.Division == "string" ? chinas.Division : 'span') + ">");
                    }
                };
                if (typeof chinas.vals != "undefined" && chinas.vals != "") {
                    if (chinas.chinas.indexOf(chinas.vals) >= 0 && variable.self.reg.test(chinas.vals)) {
                        // 汉字或者字母匹配
                        var /** @type {?} */ a = chinas.chinas.split(chinas.vals);
                        for (var /** @type {?} */ j = 0; j < a.length; j++) {
                            a[j] == "" ? (thisT += ((j + 1) == a.length ? '' :
                                '<' + (typeof chinas.Division == "string" ? chinas.Division : 'span') + ' '
                                    + (chinas.className ? ("class=" + chinas.className) : "") + '>' + chinas.vals + '</' + (typeof chinas.Division == "string" ? chinas.Division : 'span') + '>') + a[j]) :
                                (thisT += a[j] + ((j + 1) == a.length ? '' :
                                    '<' + (typeof chinas.Division == "string" ? chinas.Division : 'span') + ' '
                                        + (chinas.className ? ("class=" + chinas.className) : "") + '>' + chinas.vals + '</' + (typeof chinas.Division == "string" ? chinas.Division : 'span') + '>'));
                        }
                    }
                    else {
                        // 拼音匹配 pin
                        toolFun.seclectText();
                    }
                }
                else {
                    thisT = chinas.chinas;
                }
                return thisT;
            }
        };
        // myFun.getThisText();//返回分割好的html; myFun.returnChinas();//返回查找到的汉字数组
        return ((typeof chinas.getHtml === "boolean" ? chinas.getHtml : false) ? myFun.getThisText() : myFun.returnChinas());
    };
    return ChineseToPinyinService;
}());
ChineseToPinyinService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ChineseToPinyinService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectComponent = (function () {
    /**
     * @param {?} _elementRef
     * @param {?} _renderer
     * @param {?} ctp
     */
    function SelectComponent(_elementRef, _renderer, ctp) {
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this.ctp = ctp;
        this._prefixCls = "ant-select";
        this._isload = true;
        this._isOpen = false;
        this._triggerWidth = 0;
        this.antSelectValue = [];
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
        this._placeholder = 'ploceholder';
        this._selecteOptions = [];
        this._tagsOptions = [];
        this.curNum = 1;
        this._NotFoundContent = '无法找到';
        this._mode = true;
        this._antWidth = '150px';
        this._searchPlaceholder = '请输入关键字搜索';
        this.searchSource = new Subject.Subject();
        this.afterSelect = new core.EventEmitter();
        this._el = this._elementRef.nativeElement;
    }
    Object.defineProperty(SelectComponent.prototype, "antploceholder", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._placeholder = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antLabel", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._antLabel = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antWidth", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._antWidth = value + 'px';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antValue", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._antValue = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antSearchPlaceholder", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._searchPlaceholder = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antNotFoundContent", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._NotFoundContent = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "antSize", {
        /**
         * @return {?}
         */
        get: function () {
            return this._size;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._size = { large: 'lg', small: 'sm' }[value];
            this.setClassMap();
        },
        enumerable: true,
        configurable: true
    });
    
    Object.defineProperty(SelectComponent.prototype, "antMode", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                if (value === 'multiple') {
                    this._mode = true;
                }
                else {
                    this._mode = false;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} btn
     * @return {?}
     */
    SelectComponent.prototype.onClick = function (btn) {
        if (!this._elementRef.nativeElement.contains(event.target)) {
            // 关闭select
            // this._isDatepickerHide = false;
            this._isOpen = false;
            this._renderer.removeClass(this._selectDom.nativeElement, this._prefixCls + "-open");
        }
    };
    /**
     * 双向绑定，接收数据
     * @param {?} value
     * @return {?}
     */
    SelectComponent.prototype.writeValue = function (value) {
        if (value !== undefined) {
            this.antSelectValue = value;
            if (this._selecteOptions.length) {
                this.resetTagsOptions();
            }
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    SelectComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    SelectComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.ngOnInit = function () {
        this.setClassMap();
        // this._setTriggerWidth();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SelectComponent.prototype.ngOnChanges = function (changes) {
        if (changes["selecteOptions"]) {
            var /** @type {?} */ selecteOptions = changes["selecteOptions"];
            if (!selecteOptions.firstChange) {
                // 拼音搜索
                for (var /** @type {?} */ i = 0; i < selecteOptions.currentValue.length; i++) {
                    selecteOptions.currentValue[i].spell = this.ctp.ConvertPinyin({ chinas: selecteOptions.currentValue[i][this._antLabel] });
                    selecteOptions.currentValue[i].first = this.ctp.ConvertPinyin({ chinas: selecteOptions.currentValue[i][this._antLabel], first: true });
                }
                this._selecteOptions = selecteOptions.currentValue;
                this.options = selecteOptions.currentValue;
                this._isload = false;
                this.filterSpecificOption = selecteOptions.currentValue.slice(0, 10);
                this.total();
                this.resetTagsOptions();
            }
        }
    };
    /**
     * 是否显示下拉
     * \@memberof SelectComponent
     * @param {?} e
     * @return {?}
     */
    SelectComponent.prototype.isSelect = function (e) {
        var _this = this;
        if (this._isload) {
            return;
        }
        if (e.target.id === '_clear') {
            return;
        }
        this._isOpen = !this._isOpen;
        if (this._isOpen) {
            this._renderer.addClass(this._selectDom.nativeElement, this._prefixCls + "-open");
            // this.searchText = '';
            // this.options = this._selecteOptions;
            /**
                  * 创建容器
                  */
            // this._createBackdropElement();
            setTimeout(function () {
                _this._renderer.selectRootElement('.ant-select-search-input').focus();
            });
        }
        else {
            this._renderer.removeClass(this._selectDom.nativeElement, this._prefixCls + "-open");
            // this._removeBackdrop();
        }
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.setClassMap = function () {
        this._renderer.addClass(this._selectDom.nativeElement, this._prefixCls);
        this._renderer.setStyle(this._selectDom.nativeElement, 'width', this._antWidth);
        this.removeClass();
        if (this._size) {
            this._renderer.addClass(this._rootEl.nativeElement, this._prefixCls + "-" + this._size);
        }
        else {
            this.removeClass();
        }
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.removeClass = function () {
        this._renderer.removeClass(this._rootEl.nativeElement, this._prefixCls + "-lg");
        this._renderer.removeClass(this._rootEl.nativeElement, this._prefixCls + "-sm");
    };
    /**
     * 删除
     * @param {?} option
     * @param {?=} $event
     * @return {?}
     */
    SelectComponent.prototype.unSelectMultipleOption = function (option, $event) {
        var _this = this;
        if ((this._tagsOptions.indexOf(option) !== -1)) {
            this._tagsOptions.splice(this._tagsOptions.indexOf(option), 1);
            this.afterSelect.emit(this._tagsOptions);
            this.onChange(this._tagsOptions.map(function (item) { return item[_this._antValue]; }));
        }
        if ($event) {
            $event.preventDefault();
            $event.stopPropagation();
        }
    };
    /**
     * 选择
     * @param {?} option
     * @param {?=} $event
     * @return {?}
     */
    SelectComponent.prototype.clickOption = function (option, $event) {
        var _this = this;
        if (!option[this._antValue]) {
            return;
        }
        if (!this._mode) {
            this._tagsOptions = [];
            this._tagsOptions.push(option);
            this._backdropClick();
            this.afterSelect.emit(this._tagsOptions);
            this.onChange(this._tagsOptions.map(function (item) { return item[_this._antValue]; }));
            return;
        }
        if ((this._tagsOptions.indexOf(option) !== -1)) {
            this._tagsOptions.splice(this._tagsOptions.indexOf(option), 1);
        }
        else {
            this._tagsOptions.push(option);
        }
        this.afterSelect.emit(this._tagsOptions);
        this.onChange(this._tagsOptions.map(function (item) { return item[_this._antValue]; }));
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SelectComponent.prototype.clearSelect = function (e) {
        this._tagsOptions = [];
        this.onChange(this._tagsOptions);
        this.afterSelect.emit(this._tagsOptions);
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.total = function () {
        this._total = Math.ceil(this.options.length / 10);
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.filterData = function () {
        if (this.curNum === this._total) {
            this.filterSpecificOption = this.options.slice((this.curNum - 1) * 10);
            return;
        }
        this.filterSpecificOption = this.options.slice((this.curNum - 1) * 10, this.curNum * 10);
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.pageNext = function () {
        if (this._total === this.curNum) {
            return;
        }
        this.curNum += 1;
        this.filterData();
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.pageLess = function () {
        if (this.curNum === 1) {
            return;
        }
        this.curNum -= 1;
        this.filterData();
    };
    /**
     * 搜索
     * @param {?} text
     * @return {?}
     */
    SelectComponent.prototype._searchData = function (text) {
        this.options = this._selecteOptions;
        var /** @type {?} */ resultArr = this.screenData(text);
        this.curNum = 1;
        if (resultArr.length) {
            this.options = resultArr;
            this.total();
            this.filterData();
            return;
        }
        this.options = [{ content: this._NotFoundContent, nzDisabled: true }];
        this._total = 0;
        this.filterData();
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.resetTagsOptions = function () {
        var _this = this;
        this._tagsOptions = [];
        if (this.antSelectValue.length > 0 && this._selecteOptions.length > 0) {
            this.antSelectValue.forEach(function (item) {
                _this._selecteOptions.forEach(function (i) {
                    if (item === i[_this._antValue]) {
                        _this._tagsOptions.push(i);
                    }
                });
            });
        }
    };
    /**
     * @param {?} arr
     * @param {?} option
     * @return {?}
     */
    SelectComponent.prototype.isInSet = function (arr, option) {
        var _this = this;
        return arr.some(function (item) { return item[_this._antValue] === option[_this._antValue]; });
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype._backdropClick = function () {
        this._isOpen = false;
        this._renderer.removeClass(this._selectDom.nativeElement, this._prefixCls + "-open");
        // this._removeBackdrop();
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype._removeBackdrop = function () {
        // this._renderer.selectRootElement('.nz-overlay-contain').remove();
    };
    /**
     * @param {?} text
     * @return {?}
     */
    SelectComponent.prototype.screenData = function (text) {
        var _this = this;
        var /** @type {?} */ resultArr = [];
        this.options.forEach(function (item, index, arr) {
            if (item[_this._antLabel].indexOf(text) > -1 || item['spell'].indexOf(text) > -1 || item['first'].indexOf(text) > -1) {
                resultArr.push(item);
            }
        });
        return resultArr;
    };
    return SelectComponent;
}());
SelectComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-select',
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return SelectComponent; }),
                        multi: true
                    }, ChineseToPinyinService
                ],
                animations: [
                    DropDownAnimation,
                    TagAnimation
                ],
                template: "<div #rootEl style=\"display:inline-block;position:relative\">\n  <div class=\"ant-select-selection\" #antSelect [ngClass]=\"{'ant-select-selection--single': !_mode,\n'ant-select-selection--multiple': _mode}\" (click)=\"isSelect($event)\" [style.width]=\"_antWidth\">\n    <div class=\"ant-select-selection__rendered\">\n      <div *ngIf=\"_isload\" class=\"ant-select-loading\">\n        <i class=\"anticon anticon-loading anticon-spin\"></i>\n      </div>\n      <div class=\"ant-select-selection__placeholder\" [hidden]=\"_tagsOptions.length || _isload\">\n        {{_placeholder}}\n      </div>\n      <ul *ngIf=\"_mode\">\n        <li *ngFor=\"let option of _tagsOptions\" [@tagAnimation] [attr.title]=\"option?.label\" class=\"ant-select-selection__choice\"\n          style=\"-webkit-user-select: none;\">\n          <div class=\"ant-select-selection__choice__content\">\n            {{option[_antLabel]}}\n          </div>\n          <span class=\"ant-select-selection__choice__remove\" (click)=\"unSelectMultipleOption(option,$event)\"></span>\n        </li>\n      </ul>\n      <div *ngIf=\"!_mode\" class=\"ant-select-selection-selected-value\">\n        <span *ngFor=\"let option of _tagsOptions;let i = index;\">{{option[_antLabel]}}</span>\n      </div>\n    </div>\n    <span (click)=\"clearSelect($event)\" id=\"_clear\" class=\"ant-select-selection__clear\" style=\"-webkit-user-select: none;\" *ngIf=\"_tagsOptions.length==1&&!_mode\">\n  </span>\n    <span class=\"ant-select-arrow\"><b></b></span>\n  </div>\n\n\n  <div class=\"ant-select-dropdown ant-select-dropdown--multiple ant-select-dropdown-placement-bottomLeft ng-trigger ng-trigger-dropDownAnimation\"\n    [@dropDownAnimation]=\"bottom\" *ngIf=\"_isOpen\" [ngClass]=\"{'ant-select-dropdown--tags': !_mode ,\n'ant-select-dropdown--multiple': _mode }\" [style.width]=\"_antWidth\">\n    <div>\n      <div class=\"ant-select-search\">\n        <i class=\"anticon anticon-search ant-select-search-anticon\"></i>\n        <input type=\"text\" [placeholder]=\"_searchPlaceholder\" class=\"ant-select-search-input\" [(ngModel)]=\"searchText\" (ngModelChange)=\"_searchData($event)\">\n      </div>\n      <ul class=\"ant-select-dropdown-menu ant-select-dropdown-menu-vertical ant-select-dropdown-menu-root\" #dropdownUl>\n        <li *ngFor=\"let option of filterSpecificOption;let i = index;\" class=\"ant-select-dropdown-menu-item\" (click)=\"clickOption(option,$event)\"\n          [class.ant-select-dropdown-menu-item-disabled]=\"option?.nzDisabled\" [class.ant-select-dropdown-menu-item-selected]=\"isInSet(_tagsOptions,option)\"\n          class=\"ant-select-dropdown-menu-item\">\n          {{option[_antLabel] || option.content}}\n        </li>\n      </ul>\n      <div class=\"ant-select-page\" *ngIf=\"_total>1\">\n        <span class=\"ant-select-page-less\" (click)=\"pageLess()\" [ngClass]=\"{'ant-select-page-disabled':curNum == 1}\">\u4E0A\u4E00\u9875</span>\n        <span class=\"ant-select-page-num\">\n        <span class=\"ant-select-page-num-cur\">{{curNum}}</span>\n        <span class=\"ant-select-page-num-spe\">/</span>\n        <span class=\"ant-select-page-num-total\">{{ _total }}\n        </span>\n        </span>\n        <span class=\"ant-select-page-next\" (click)=\"pageNext()\" [ngClass]=\"{'ant-select-page-disabled':curNum == _total}\">\u4E0B\u4E00\u9875</span>\n      </div>\n    </div>\n  </div>\n</div>",
                styles: [".ant-select {\n  box-sizing: border-box;\n  display: inline-block;\n  position: relative;\n  color: rgba(0, 0, 0, 0.65);\n  font-size: 12px;\n}\n.ant-select > ul > li > a {\n  padding: 0;\n  background-color: #fff;\n}\n.ant-select-arrow {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  position: absolute;\n  top: 50%;\n  right: 8px;\n  line-height: 1;\n  margin-top: -6px;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 9px 9;\n  transform: scale(0.75) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n.ant-select-arrow:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-arrow {\n  filter: none;\n}\n:root .ant-select-arrow {\n  font-size: 12px;\n}\n.ant-select-arrow * {\n  display: none;\n}\n.ant-select-arrow:before {\n  content: \"\\e61d\";\n  transition: transform 0.2s ease;\n}\n.ant-select-selection {\n  outline: none;\n  user-select: none;\n  box-sizing: border-box;\n  display: block;\n  background-color: #fff;\n  border-radius: 4px;\n  border: 1px solid #d9d9d9;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection:hover {\n  border-color: #49a9ee;\n}\n.ant-select-focused .ant-select-selection,\n.ant-select-selection:focus,\n.ant-select-selection:active {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-selection__clear {\n  display: inline-block;\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: auto;\n  opacity: 0;\n  position: absolute;\n  right: 8px;\n  z-index: 1;\n  background: #fff;\n  top: 50%;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.25);\n  width: 12px;\n  height: 12px;\n  margin-top: -6px;\n  line-height: 12px;\n  cursor: pointer;\n  transition: color 0.3s ease, opacity 0.15s ease;\n}\n.ant-select-selection__clear:before {\n  display: block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e62e\";\n}\n.ant-select-selection__clear:hover {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-select-selection:hover .ant-select-selection__clear {\n  opacity: 1;\n}\n.ant-select-selection-selected-value {\n  float: left;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: 100%;\n  padding-right: 14px;\n}\n.ant-select-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-disabled .ant-select-selection {\n  background: #f7f7f7;\n  cursor: not-allowed;\n}\n.ant-select-disabled .ant-select-selection:hover,\n.ant-select-disabled .ant-select-selection:focus,\n.ant-select-disabled .ant-select-selection:active {\n  border-color: #d9d9d9;\n  box-shadow: none;\n}\n.ant-select-disabled .ant-select-selection__clear {\n  display: none;\n  visibility: hidden;\n  pointer-events: none;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice {\n  background: #eee;\n  color: #aaa;\n  padding-right: 10px;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  display: none;\n}\n.ant-select-selection--single {\n  height: 28px;\n  position: relative;\n  cursor: pointer;\n}\n.ant-select-selection__rendered {\n  display: block;\n  margin-left: 7px;\n  margin-right: 7px;\n  position: relative;\n  line-height: 26px;\n}\n.ant-select-selection__rendered:after {\n  content: '.';\n  visibility: hidden;\n  pointer-events: none;\n  display: inline-block;\n  width: 0;\n}\n.ant-select-lg .ant-select-selection--single {\n  height: 32px;\n}\n.ant-select-lg .ant-select-selection__rendered {\n  line-height: 30px;\n}\n.ant-select-lg .ant-select-selection--multiple {\n  min-height: 32px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 24px;\n  line-height: 24px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 16px;\n}\n.ant-select-sm .ant-select-selection--single {\n  height: 22px;\n}\n.ant-select-sm .ant-select-selection__rendered {\n  line-height: 20px;\n}\n.ant-select-sm .ant-select-selection--multiple {\n  min-height: 22px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 14px;\n  line-height: 14px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 11px;\n}\n.ant-select-disabled .ant-select-selection__choice__remove {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: default;\n}\n.ant-select-disabled .ant-select-selection__choice__remove:hover {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-search__field__wrap {\n  display: inline-block;\n  position: relative;\n}\n.ant-select-selection__placeholder,\n.ant-select-search__field__placeholder {\n  position: absolute;\n  top: 50%;\n  left: 0;\n  right: 9px;\n  color: rgba(0, 0, 0, 0.25);\n  line-height: 20px;\n  height: 20px;\n  max-width: 100%;\n  margin-top: -10px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: left;\n}\n.ant-select-search__field__placeholder {\n  left: 8px;\n}\n.ant-select-search--inline {\n  position: absolute;\n  height: 100%;\n  width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  float: left;\n  position: static;\n}\n.ant-select-search--inline .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-search--inline .ant-select-search__field {\n  border-width: 0;\n  font-size: 100%;\n  height: 100%;\n  width: 100%;\n  background: transparent;\n  outline: 0;\n  border-radius: 4px;\n}\n.ant-select-search--inline .ant-select-search__field__mirror {\n  position: absolute;\n  top: 0;\n  left: -9999px;\n  white-space: pre;\n  pointer-events: none;\n}\n.ant-select-search--inline > i {\n  float: right;\n}\n.ant-select-selection--multiple {\n  min-height: 28px;\n  cursor: text;\n  padding-bottom: 3px;\n  zoom: 1;\n}\n.ant-select-selection--multiple:before,\n.ant-select-selection--multiple:after {\n  content: \" \";\n  display: table;\n}\n.ant-select-selection--multiple:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  width: auto;\n  padding: 0;\n  max-width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline .ant-select-search__field {\n  max-width: 100%;\n  width: 0.75em;\n}\n.ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-left: 5px;\n  margin-bottom: -3px;\n  height: auto;\n}\n.ant-select-selection--multiple > ul > li,\n.ant-select-selection--multiple .ant-select-selection__rendered > ul > li {\n  margin-top: 3px;\n  height: 20px;\n  line-height: 20px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice {\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #f3f3f3;\n  border-radius: 4px;\n  cursor: default;\n  float: left;\n  margin-right: 4px;\n  max-width: 99%;\n  position: relative;\n  overflow: hidden;\n  transition: padding 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  padding: 0 20px 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__disabled {\n  padding: 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__content {\n  display: inline-block;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  max-width: 100%;\n  transition: margin 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  line-height: 1;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  color: rgba(0, 0, 0, 0.43);\n  line-height: inherit;\n  cursor: pointer;\n  font-weight: bold;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  position: absolute;\n  right: 4px;\n  padding: 0 0 0 8px;\n  top: 0;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  filter: none;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-size: 12px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:hover {\n  color: #404040;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  content: \"\\e633\";\n}\n.ant-select-selection--multiple .ant-select-selection__clear {\n  top: 14px;\n}\n.ant-select-allow-clear .ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-open .ant-select-arrow {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2)\";\n  -ms-transform: rotate(180deg);\n}\n.ant-select-open .ant-select-arrow:before {\n  transform: rotate(180deg);\n}\n.ant-select-open .ant-select-selection {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-combobox .ant-select-arrow {\n  display: none;\n}\n.ant-select-combobox .ant-select-search--inline {\n  height: 100%;\n  width: 100%;\n  float: none;\n}\n.ant-select-combobox .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-combobox .ant-select-search__field {\n  width: 100%;\n  height: 100%;\n  position: relative;\n  z-index: 1;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  box-shadow: none;\n}\n.ant-select-combobox.ant-select-allow-clear .ant-select-selection:hover .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-dropdown {\n  background-color: #fff;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  border-radius: 4px;\n  box-sizing: border-box;\n  z-index: 1050;\n  left: -9999px;\n  top: -9999px;\n  position: absolute;\n  outline: none;\n  overflow: hidden;\n  font-size: 12px;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-bottomLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpIn;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-topLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownIn;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpOut;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownOut;\n}\n.ant-select-dropdown-hidden {\n  display: none;\n}\n.ant-select-dropdown-menu {\n  outline: none;\n  margin-bottom: 0;\n  padding-left: 0;\n  list-style: none;\n  max-height: 250px;\n  overflow: auto;\n}\n.ant-select-dropdown-menu-item-group-list {\n  margin: 0;\n  padding: 0;\n}\n.ant-select-dropdown-menu-item-group-list > .ant-select-dropdown-menu-item {\n  padding-left: 16px;\n}\n.ant-select-dropdown-menu-item-group-title {\n  color: rgba(0, 0, 0, 0.43);\n  line-height: 1.5;\n  padding: 8px;\n}\n.ant-select-dropdown-menu-item {\n  position: relative;\n  display: block;\n  padding: 7px 8px;\n  font-weight: normal;\n  color: rgba(0, 0, 0, 0.65);\n  white-space: nowrap;\n  cursor: pointer;\n  overflow: hidden;\n  transition: background 0.3s ease;\n}\n.ant-select-dropdown-menu-item:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-active {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-disabled:hover {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-selected,\n.ant-select-dropdown-menu-item-selected:hover {\n  background-color: #f7f7f7;\n  font-weight: bold;\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-select-dropdown-menu-item-divider {\n  height: 1px;\n  margin: 1px 0;\n  overflow: hidden;\n  background-color: #e5e5e5;\n  line-height: 0;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e632\";\n  color: transparent;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  transition: all 0.2s ease;\n  position: absolute;\n  top: 50%;\n  transform: translateY(-50%);\n  right: 8px;\n  font-weight: bold;\n  text-shadow: 0 0.1px 0, 0.1px 0 0, 0 -0.1px 0, -0.1px 0;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  filter: none;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-size: 12px;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:hover:after {\n  color: #ddd;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-disabled:after {\n  display: none;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:after,\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:hover:after {\n  color: #108ee9;\n  display: inline-block;\n}\n.ant-select-dropdown-container-open .ant-select-dropdown,\n.ant-select-dropdown-open .ant-select-dropdown {\n  display: block;\n}\n/***/\nnz-select .ant-select {\n  width: 100%;\n}\n.ant-select-dropdown {\n  top: 100%;\n  left: 0;\n  position: relative;\n  width: 100%;\n  margin-top: 4px;\n  margin-bottom: 4px;\n}\n.ant-select-dropdown.ant-select-dropdown-placement-topLeft {\n  top: -100%;\n  transform: translateY(-100%) !important;\n}\n.ant-select-dropdown-menu-item {\n  line-height: 1.5;\n}\n.nz-overlay-pane {\n  position: absolute;\n}\n.ant-select-page {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  font-size: 12px;\n  line-height: 2em;\n  padding: 5px;\n  user-select: none;\n  text-align: center;\n  background-color: #f9f9f9;\n  border-top: 1px solid #ddd;\n}\n.ant-select-page-less,\n.ant-select-page-next {\n  color: #333;\n  cursor: pointer;\n}\n.ant-select-page-disabled {\n  color: #999!important;\n  cursor: not-allowed !important;\n}\n.ant-select-search {\n  background-color: #fff;\n  padding: 4px;\n  position: relative;\n}\n.ant-select-search-input {\n  width: 100%;\n  height: 30px;\n  padding: 0 8px;\n  border: 1px solid #eee;\n}\n.ant-select-search-input:focus {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-search-anticon {\n  position: absolute;\n  right: 13px;\n  top: 11px;\n  font-size: 15px;\n  font-weight: 600;\n  color: #999;\n  cursor: pointer;\n  height: 53%;\n}\n.ant-select-loading {\n  position: absolute;\n  left: 5px;\n  top: -1px;\n}\n.nz-overlay-contain {\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  position: fixed;\n  z-index: 1000;\n}\n.ant-select-dropdown {\n  position: absolute!important;\n  top: auto;\n  left: auto;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u9AD8\u5BBD\u53CA\u80CC\u666F \u9AD8\u5BBD\u5206\u522B\u5BF9\u5E94\u6A2A\u7AD6\u6EDA\u52A8\u6761\u7684\u5C3A\u5BF8*/\n::-webkit-scrollbar {\n  width: 8px;\n  height: 8px;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u8F68\u9053 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-track {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n}\n/*\u5B9A\u4E49\u6ED1\u5757 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-thumb {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n  background-color: #d7d7d7;\n}\n"]
            },] },
];
/** @nocollapse */
SelectComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core.Renderer2, },
    { type: ChineseToPinyinService, },
]; };
SelectComponent.propDecorators = {
    "_selectDom": [{ type: core.ViewChild, args: ['antSelect',] },],
    "_rootEl": [{ type: core.ViewChild, args: ['rootEl',] },],
    "afterSelect": [{ type: core.Output },],
    "antploceholder": [{ type: core.Input },],
    "antLabel": [{ type: core.Input },],
    "antWidth": [{ type: core.Input },],
    "antValue": [{ type: core.Input },],
    "antSearchPlaceholder": [{ type: core.Input },],
    "antNotFoundContent": [{ type: core.Input },],
    "antSize": [{ type: core.Input },],
    "antMode": [{ type: core.Input },],
    "selecteOptions": [{ type: core.Input },],
    "onClick": [{ type: core.HostListener, args: ['document:click', ['$event'],] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectModule = (function () {
    function SelectModule() {
    }
    return SelectModule;
}());
SelectModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule, forms.FormsModule, ngZorroAntd.NzSpinModule],
                declarations: [SelectComponent],
                exports: [SelectComponent]
            },] },
];
/** @nocollapse */
SelectModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CHECKBOX_VAL_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return CheckboxComponent; }),
    multi: true
};
var CheckboxComponent = (function () {
    function CheckboxComponent() {
        this._prefixCls = 'ant-checkbox';
        this._checked = false;
        this._disabled = false;
        this.indeterminate = false;
    }
    Object.defineProperty(CheckboxComponent.prototype, "disabled", {
        /**
         * @return {?}
         */
        get: function () {
            return this._disabled;
        },
        /**
         * @param {?} val
         * @return {?}
         */
        set: function (val) {
            if (!val) {
                return;
            }
            if (val && (typeof val === 'string') || val === true) {
                this._disabled = true;
                return;
            }
            this._disabled = false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CheckboxComponent.prototype, "checked", {
        /**
         * @return {?}
         */
        get: function () {
            return this._checked;
        },
        /**
         * @param {?} val
         * @return {?}
         */
        set: function (val) {
            this.handleChange(val);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} e
     * @return {?}
     */
    CheckboxComponent.prototype.onClick = function (e) {
        e.preventDefault();
        if (this._disabled) {
            return;
        }
        this.handleChange(!this._checked);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    CheckboxComponent.prototype.handleChange = function (val) {
        if (this._disabled) {
            return;
        }
        this.onChange(val);
        this._checked = val;
    };
    Object.defineProperty(CheckboxComponent.prototype, "_classMap", {
        /**
         * @return {?}
         */
        get: function () {
            return _b = {},
                _b[this._prefixCls] = true,
                _b[this._prefixCls + "-checked"] = this._checked && (!this.indeterminate),
                // [`${this._prefixCls}-focused`]: this._focused,
                _b[this._prefixCls + "-disabled"] = this._disabled,
                _b[this._prefixCls + "-indeterminate"] = this.indeterminate,
                _b["" + this.className] = this.className !== undefined,
                _b;
            var _b;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} val
     * @return {?}
     */
    CheckboxComponent.prototype.writeValue = function (val) {
        this._checked = val;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CheckboxComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CheckboxComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    CheckboxComponent.prototype.setDisabledState = function (isDisabled) {
    };
    /**
     * @return {?}
     */
    CheckboxComponent.prototype.ngOnInit = function () {
    };
    return CheckboxComponent;
}());
CheckboxComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-checkbox',
                encapsulation: core.ViewEncapsulation.None,
                template: "<span class=\"ant-checkbox-wrapper\">\n  <span [ngClass]=\"_classMap\">\n      <span class=\"ant-checkbox-inner\"></span>\n<input type=\"checkbox\" [name]=\"name\" [value]=\"value\" class=\"ant-checkbox-input\" [(ngModel)]=\"checked\">\n</span>\n<span>\n      <ng-content></ng-content>\n  </span>\n</span>\n",
                styles: ["@keyframes antCheckboxEffect {\n  0% {\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  100% {\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n.ant-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-checkbox-wrapper:hover .ant-checkbox-inner,\n.ant-checkbox:hover .ant-checkbox-inner,\n.ant-checkbox-input:focus + .ant-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-checkbox:hover:after,\n.ant-checkbox-wrapper:hover .ant-checkbox:after {\n  visibility: visible;\n}\n.ant-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-checkbox-indeterminate .ant-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-checkbox-indeterminate.ant-checkbox-disabled .ant-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-checked .ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-checkbox-checked .ant-checkbox-inner,\n.ant-checkbox-indeterminate .ant-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled.ant-checkbox-checked .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-disabled .ant-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled .ant-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-checkbox-disabled .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-checkbox-wrapper + span,\n.ant-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-checkbox-group {\n  font-size: 12px;\n}\n.ant-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-checkbox-checked .ant-checkbox-inner:before,\n  .ant-checkbox-checked .ant-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n"],
                providers: [CHECKBOX_VAL_ACCESSOR]
            },] },
];
/** @nocollapse */
CheckboxComponent.ctorParameters = function () { return []; };
CheckboxComponent.propDecorators = {
    "disabled": [{ type: core.Input },],
    "checked": [{ type: core.Input },],
    "indeterminate": [{ type: core.Input },],
    "id": [{ type: core.Input },],
    "name": [{ type: core.Input },],
    "value": [{ type: core.Input },],
    "className": [{ type: core.Input },],
    "onClick": [{ type: core.HostListener, args: ['click', ['$event'],] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CHECKBOX_VAL_ACCESSOR$1 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return CheckboxGroupComponent; }),
    multi: true
};
var CheckboxGroupComponent = (function () {
    function CheckboxGroupComponent() {
        this._checked = false;
        this._disabled = false;
    }
    Object.defineProperty(CheckboxGroupComponent.prototype, "disabled", {
        /**
         * @return {?}
         */
        get: function () {
            return this._disabled;
        },
        /**
         * @param {?} val
         * @return {?}
         */
        set: function (val) {
            if (!val) {
                return;
            }
            if (val && (typeof val === 'string') || val === true) {
                this._disabled = true;
                return;
            }
            this._disabled = false;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CheckboxGroupComponent.prototype._optionChange = function () {
        this.onChange(this._options);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    CheckboxGroupComponent.prototype.writeValue = function (val) {
        this._options = val;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CheckboxGroupComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CheckboxGroupComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    CheckboxGroupComponent.prototype.setDisabledState = function (isDisabled) {
    };
    /**
     * @return {?}
     */
    CheckboxGroupComponent.prototype.ngOnInit = function () {
    };
    return CheckboxGroupComponent;
}());
CheckboxGroupComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-checkbox-group',
                encapsulation: core.ViewEncapsulation.None,
                template: "<label class=\"ant-checkbox-group\" *ngFor=\"let option of _options\">\n    <ant-checkbox\n    [name]=\"option.name\"\n    [value]=\"option.value\" \n    [disabled]=\"option.disabled||_disabled\" \n    [(ngModel)]=\"option.checked\" \n    (ngModelChange)=\"_optionChange()\">{{option.label}}</ant-checkbox>\n</label>\n",
                styles: ["@keyframes antCheckboxEffect {\n  0% {\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  100% {\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n.ant-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-checkbox-wrapper:hover .ant-checkbox-inner,\n.ant-checkbox:hover .ant-checkbox-inner,\n.ant-checkbox-input:focus + .ant-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-checkbox:hover:after,\n.ant-checkbox-wrapper:hover .ant-checkbox:after {\n  visibility: visible;\n}\n.ant-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-checkbox-indeterminate .ant-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-checkbox-indeterminate.ant-checkbox-disabled .ant-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-checked .ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-checkbox-checked .ant-checkbox-inner,\n.ant-checkbox-indeterminate .ant-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled.ant-checkbox-checked .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-disabled .ant-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled .ant-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-checkbox-disabled .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-checkbox-wrapper + span,\n.ant-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-checkbox-group {\n  font-size: 12px;\n}\n.ant-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-checkbox-checked .ant-checkbox-inner:before,\n  .ant-checkbox-checked .ant-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n"],
                providers: [CHECKBOX_VAL_ACCESSOR$1]
            },] },
];
/** @nocollapse */
CheckboxGroupComponent.ctorParameters = function () { return []; };
CheckboxGroupComponent.propDecorators = {
    "disabled": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$2 = [CheckboxComponent, CheckboxGroupComponent];
var CheckboxModule = (function () {
    function CheckboxModule() {
    }
    return CheckboxModule;
}());
CheckboxModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: COMPONENTS$2.slice(),
                imports: [common.CommonModule, forms.FormsModule],
                exports: COMPONENTS$2.slice(),
                entryComponents: COMPONENTS$2.slice(),
                providers: [],
            },] },
];
/** @nocollapse */
CheckboxModule.ctorParameters = function () { return []; };
/**
 * @license Angular v5.1.1
 * (c) 2010-2017 Google, Inc. https://angular.io/
 * License: MIT
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * A backend for http that uses the `XMLHttpRequest` browser API.
 *
 * Take care not to evaluate this in non-browser contexts.
 *
 * @deprecated use \@angular/common/http instead
 */
var BrowserXhr = (function () {
    function BrowserXhr() {
    }
    /**
     * @return {?}
     */
    BrowserXhr.prototype.build =
        function () { return ((new XMLHttpRequest())); };
    BrowserXhr.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BrowserXhr.ctorParameters = function () { return []; };
    return BrowserXhr;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/** @enum {number} */
var RequestMethod = {
    Get: 0,
    Post: 1,
    Put: 2,
    Delete: 3,
    Options: 4,
    Head: 5,
    Patch: 6,
};
RequestMethod[RequestMethod.Get] = "Get";
RequestMethod[RequestMethod.Post] = "Post";
RequestMethod[RequestMethod.Put] = "Put";
RequestMethod[RequestMethod.Delete] = "Delete";
RequestMethod[RequestMethod.Options] = "Options";
RequestMethod[RequestMethod.Head] = "Head";
RequestMethod[RequestMethod.Patch] = "Patch";
/** @enum {number} */
var ReadyState = {
    Unsent: 0,
    Open: 1,
    HeadersReceived: 2,
    Loading: 3,
    Done: 4,
    Cancelled: 5,
};
ReadyState[ReadyState.Unsent] = "Unsent";
ReadyState[ReadyState.Open] = "Open";
ReadyState[ReadyState.HeadersReceived] = "HeadersReceived";
ReadyState[ReadyState.Loading] = "Loading";
ReadyState[ReadyState.Done] = "Done";
ReadyState[ReadyState.Cancelled] = "Cancelled";
/** @enum {number} */
var ResponseType = {
    Basic: 0,
    Cors: 1,
    Default: 2,
    Error: 3,
    Opaque: 4,
};
ResponseType[ResponseType.Basic] = "Basic";
ResponseType[ResponseType.Cors] = "Cors";
ResponseType[ResponseType.Default] = "Default";
ResponseType[ResponseType.Error] = "Error";
ResponseType[ResponseType.Opaque] = "Opaque";
/** @enum {number} */
var ContentType = {
    NONE: 0,
    JSON: 1,
    FORM: 2,
    FORM_DATA: 3,
    TEXT: 4,
    BLOB: 5,
    ARRAY_BUFFER: 6,
};
ContentType[ContentType.NONE] = "NONE";
ContentType[ContentType.JSON] = "JSON";
ContentType[ContentType.FORM] = "FORM";
ContentType[ContentType.FORM_DATA] = "FORM_DATA";
ContentType[ContentType.TEXT] = "TEXT";
ContentType[ContentType.BLOB] = "BLOB";
ContentType[ContentType.ARRAY_BUFFER] = "ARRAY_BUFFER";
/** @enum {number} */
var ResponseContentType = {
    Text: 0,
    Json: 1,
    ArrayBuffer: 2,
    Blob: 3,
};
ResponseContentType[ResponseContentType.Text] = "Text";
ResponseContentType[ResponseContentType.Json] = "Json";
ResponseContentType[ResponseContentType.ArrayBuffer] = "ArrayBuffer";
ResponseContentType[ResponseContentType.Blob] = "Blob";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Polyfill for [Headers](https://developer.mozilla.org/en-US/docs/Web/API/Headers/Headers), as
 * specified in the [Fetch Spec](https://fetch.spec.whatwg.org/#headers-class).
 *
 * The only known difference between this `Headers` implementation and the spec is the
 * lack of an `entries` method.
 *
 * ### Example
 *
 * ```
 * import {Headers} from '\@angular/http';
 *
 * var firstHeaders = new Headers();
 * firstHeaders.append('Content-Type', 'image/jpeg');
 * console.log(firstHeaders.get('Content-Type')) //'image/jpeg'
 *
 * // Create headers from Plain Old JavaScript Object
 * var secondHeaders = new Headers({
 *   'X-My-Custom-Header': 'Angular'
 * });
 * console.log(secondHeaders.get('X-My-Custom-Header')); //'Angular'
 *
 * var thirdHeaders = new Headers(secondHeaders);
 * console.log(thirdHeaders.get('X-My-Custom-Header')); //'Angular'
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var Headers = (function () {
    // TODO(vicb): any -> string|string[]
    function Headers(headers) {
        var _this = this;
        /**
         * \@internal header names are lower case
         */
        this._headers = new Map();
        /**
         * \@internal map lower case names to actual names
         */
        this._normalizedNames = new Map();
        if (!headers) {
            return;
        }
        if (headers instanceof Headers) {
            headers.forEach(function (values, name) {
                values.forEach(function (value) { return _this.append(name, value); });
            });
            return;
        }
        Object.keys(headers).forEach(function (name) {
            var /** @type {?} */ values = Array.isArray(headers[name]) ? headers[name] : [headers[name]];
            _this.delete(name);
            values.forEach(function (value) { return _this.append(name, value); });
        });
    }
    /**
     * Returns a new Headers instance from the given DOMString of Response Headers
     */
    /**
     * Returns a new Headers instance from the given DOMString of Response Headers
     * @param {?} headersString
     * @return {?}
     */
    Headers.fromResponseHeaderString =
        function (headersString) {
            var /** @type {?} */ headers = new Headers();
            headersString.split('\n').forEach(function (line) {
                var /** @type {?} */ index = line.indexOf(':');
                if (index > 0) {
                    var /** @type {?} */ name_1 = line.slice(0, index);
                    var /** @type {?} */ value = line.slice(index + 1).trim();
                    headers.set(name_1, value);
                }
            });
            return headers;
        };
    /**
     * Appends a header to existing list of header values for a given header name.
     */
    /**
     * Appends a header to existing list of header values for a given header name.
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    Headers.prototype.append =
        function (name, value) {
            var /** @type {?} */ values = this.getAll(name);
            if (values === null) {
                this.set(name, value);
            }
            else {
                values.push(value);
            }
        };
    /**
     * Deletes all header values for the given name.
     */
    /**
     * Deletes all header values for the given name.
     * @param {?} name
     * @return {?}
     */
    Headers.prototype.delete =
        function (name) {
            var /** @type {?} */ lcName = name.toLowerCase();
            this._normalizedNames.delete(lcName);
            this._headers.delete(lcName);
        };
    /**
     * @param {?} fn
     * @return {?}
     */
    Headers.prototype.forEach =
        function (fn) {
            var _this = this;
            this._headers.forEach(function (values, lcName) { return fn(values, _this._normalizedNames.get(lcName), _this._headers); });
        };
    /**
     * Returns first header that matches given name.
     */
    /**
     * Returns first header that matches given name.
     * @param {?} name
     * @return {?}
     */
    Headers.prototype.get =
        function (name) {
            var /** @type {?} */ values = this.getAll(name);
            if (values === null) {
                return null;
            }
            return values.length > 0 ? values[0] : null;
        };
    /**
     * Checks for existence of header by given name.
     */
    /**
     * Checks for existence of header by given name.
     * @param {?} name
     * @return {?}
     */
    Headers.prototype.has =
        function (name) { return this._headers.has(name.toLowerCase()); };
    /**
     * Returns the names of the headers
     */
    /**
     * Returns the names of the headers
     * @return {?}
     */
    Headers.prototype.keys =
        function () { return Array.from(this._normalizedNames.values()); };
    /**
     * Sets or overrides header value for given name.
     */
    /**
     * Sets or overrides header value for given name.
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    Headers.prototype.set =
        function (name, value) {
            if (Array.isArray(value)) {
                if (value.length) {
                    this._headers.set(name.toLowerCase(), [value.join(',')]);
                }
            }
            else {
                this._headers.set(name.toLowerCase(), [value]);
            }
            this.mayBeSetNormalizedName(name);
        };
    /**
     * Returns values of all headers.
     */
    /**
     * Returns values of all headers.
     * @return {?}
     */
    Headers.prototype.values =
        function () { return Array.from(this._headers.values()); };
    /**
     * Returns string of all headers.
     */
    // TODO(vicb): returns {[name: string]: string[]}
    /**
     * Returns string of all headers.
     * @return {?}
     */
    Headers.prototype.toJSON =
        function () {
            var _this = this;
            var /** @type {?} */ serialized = {};
            this._headers.forEach(function (values, name) {
                var /** @type {?} */ split = [];
                values.forEach(function (v) { return split.push.apply(split, v.split(',')); });
                serialized[((_this._normalizedNames.get(name)))] = split;
            });
            return serialized;
        };
    /**
     * Returns list of header values for a given name.
     */
    /**
     * Returns list of header values for a given name.
     * @param {?} name
     * @return {?}
     */
    Headers.prototype.getAll =
        function (name) {
            return this.has(name) ? this._headers.get(name.toLowerCase()) || null : null;
        };
    /**
     * This method is not implemented.
     */
    /**
     * This method is not implemented.
     * @return {?}
     */
    Headers.prototype.entries =
        function () { throw new Error('"entries" method is not implemented on Headers class'); };
    /**
     * @param {?} name
     * @return {?}
     */
    Headers.prototype.mayBeSetNormalizedName =
        function (name) {
            var /** @type {?} */ lcName = name.toLowerCase();
            if (!this._normalizedNames.has(lcName)) {
                this._normalizedNames.set(lcName, name);
            }
        };
    return Headers;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Creates a response options object to be optionally provided when instantiating a
 * {\@link Response}.
 *
 * This class is based on the `ResponseInit` description in the [Fetch
 * Spec](https://fetch.spec.whatwg.org/#responseinit).
 *
 * All values are null by default. Typical defaults can be found in the
 * {\@link BaseResponseOptions} class, which sub-classes `ResponseOptions`.
 *
 * This class may be used in tests to build {\@link Response Responses} for
 * mock responses (see {\@link MockBackend}).
 *
 * ### Example ([live demo](http://plnkr.co/edit/P9Jkk8e8cz6NVzbcxEsD?p=preview))
 *
 * ```typescript
 * import {ResponseOptions, Response} from '\@angular/http';
 *
 * var options = new ResponseOptions({
 *   body: '{"name":"Jeff"}'
 * });
 * var res = new Response(options);
 *
 * console.log('res.json():', res.json()); // Object {name: "Jeff"}
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var ResponseOptions = (function () {
    function ResponseOptions(opts) {
        if (opts === void 0) {
            opts = {};
        }
        var body = opts.body, status = opts.status, headers = opts.headers, statusText = opts.statusText, type = opts.type, url = opts.url;
        this.body = body != null ? body : null;
        this.status = status != null ? status : null;
        this.headers = headers != null ? headers : null;
        this.statusText = statusText != null ? statusText : null;
        this.type = type != null ? type : null;
        this.url = url != null ? url : null;
    }
    /**
     * Creates a copy of the `ResponseOptions` instance, using the optional input as values to
     * override
     * existing values. This method will not change the values of the instance on which it is being
     * called.
     *
     * This may be useful when sharing a base `ResponseOptions` object inside tests,
     * where certain properties may change from test to test.
     *
     * ### Example ([live demo](http://plnkr.co/edit/1lXquqFfgduTFBWjNoRE?p=preview))
     *
     * ```typescript
     * import {ResponseOptions, Response} from '@angular/http';
     *
     * var options = new ResponseOptions({
     *   body: {name: 'Jeff'}
     * });
     * var res = new Response(options.merge({
     *   url: 'https://google.com'
     * }));
     * console.log('options.url:', options.url); // null
     * console.log('res.json():', res.json()); // Object {name: "Jeff"}
     * console.log('res.url:', res.url); // https://google.com
     * ```
     */
    /**
     * Creates a copy of the `ResponseOptions` instance, using the optional input as values to
     * override
     * existing values. This method will not change the values of the instance on which it is being
     * called.
     *
     * This may be useful when sharing a base `ResponseOptions` object inside tests,
     * where certain properties may change from test to test.
     *
     * ### Example ([live demo](http://plnkr.co/edit/1lXquqFfgduTFBWjNoRE?p=preview))
     *
     * ```typescript
     * import {ResponseOptions, Response} from '\@angular/http';
     *
     * var options = new ResponseOptions({
     *   body: {name: 'Jeff'}
     * });
     * var res = new Response(options.merge({
     *   url: 'https://google.com'
     * }));
     * console.log('options.url:', options.url); // null
     * console.log('res.json():', res.json()); // Object {name: "Jeff"}
     * console.log('res.url:', res.url); // https://google.com
     * ```
     * @param {?=} options
     * @return {?}
     */
    ResponseOptions.prototype.merge =
        function (options) {
            return new ResponseOptions({
                body: options && options.body != null ? options.body : this.body,
                status: options && options.status != null ? options.status : this.status,
                headers: options && options.headers != null ? options.headers : this.headers,
                statusText: options && options.statusText != null ? options.statusText : this.statusText,
                type: options && options.type != null ? options.type : this.type,
                url: options && options.url != null ? options.url : this.url,
            });
        };
    return ResponseOptions;
}());
/**
 * Subclass of {\@link ResponseOptions}, with default values.
 *
 * Default values:
 *  * status: 200
 *  * headers: empty {\@link Headers} object
 *
 * This class could be extended and bound to the {\@link ResponseOptions} class
 * when configuring an {\@link Injector}, in order to override the default options
 * used by {\@link Http} to create {\@link Response Responses}.
 *
 * ### Example ([live demo](http://plnkr.co/edit/qv8DLT?p=preview))
 *
 * ```typescript
 * import {provide} from '\@angular/core';
 * import {bootstrap} from '\@angular/platform-browser/browser';
 * import {HTTP_PROVIDERS, Headers, Http, BaseResponseOptions, ResponseOptions} from
 * '\@angular/http';
 * import {App} from './myapp';
 *
 * class MyOptions extends BaseResponseOptions {
 *   headers:Headers = new Headers({network: 'github'});
 * }
 *
 * bootstrap(App, [HTTP_PROVIDERS, {provide: ResponseOptions, useClass: MyOptions}]);
 * ```
 *
 * The options could also be extended when manually creating a {\@link Response}
 * object.
 *
 * ### Example ([live demo](http://plnkr.co/edit/VngosOWiaExEtbstDoix?p=preview))
 *
 * ```
 * import {BaseResponseOptions, Response} from '\@angular/http';
 *
 * var options = new BaseResponseOptions();
 * var res = new Response(options.merge({
 *   body: 'Angular',
 *   headers: new Headers({framework: 'angular'})
 * }));
 * console.log('res.headers.get("framework"):', res.headers.get('framework')); // angular
 * console.log('res.text():', res.text()); // Angular;
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var BaseResponseOptions = (function (_super) {
    __extends(BaseResponseOptions, _super);
    function BaseResponseOptions() {
        return _super.call(this, { status: 200, statusText: 'Ok', type: ResponseType.Default, headers: new Headers() }) || this;
    }
    BaseResponseOptions.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BaseResponseOptions.ctorParameters = function () { return []; };
    return BaseResponseOptions;
}(ResponseOptions));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Abstract class from which real backends are derived.
 *
 * The primary purpose of a `ConnectionBackend` is to create new connections to fulfill a given
 * {\@link Request}.
 *
 * @deprecated use \@angular/common/http instead
 * @abstract
 */
var ConnectionBackend = (function () {
    function ConnectionBackend() {
    }
    return ConnectionBackend;
}());
/**
 * An XSRFStrategy configures XSRF protection (e.g. via headers) on an HTTP request.
 *
 * @deprecated use \@angular/common/http instead
 * @abstract
 */
var XSRFStrategy = (function () {
    function XSRFStrategy() {
    }
    return XSRFStrategy;
}());
/**
 * Interface for options to construct a RequestOptions, based on
 * [RequestInit](https://fetch.spec.whatwg.org/#requestinit) from the Fetch spec.
 *
 * @deprecated use \@angular/common/http instead
 * @record
 */
/**
 * Required structure when constructing new Request();
 * @record
 */
/**
 * Interface for options to construct a Response, based on
 * [ResponseInit](https://fetch.spec.whatwg.org/#responseinit) from the Fetch spec.
 *
 * @deprecated use \@angular/common/http instead
 * @record
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @param {?} method
 * @return {?}
 */
function normalizeMethodName(method) {
    if (typeof method !== 'string')
        return method;
    switch (method.toUpperCase()) {
        case 'GET':
            return RequestMethod.Get;
        case 'POST':
            return RequestMethod.Post;
        case 'PUT':
            return RequestMethod.Put;
        case 'DELETE':
            return RequestMethod.Delete;
        case 'OPTIONS':
            return RequestMethod.Options;
        case 'HEAD':
            return RequestMethod.Head;
        case 'PATCH':
            return RequestMethod.Patch;
    }
    throw new Error("Invalid request method. The method \"" + method + "\" is not supported.");
}
var isSuccess = function (status) { return (status >= 200 && status < 300); };
/**
 * @param {?} xhr
 * @return {?}
 */
function getResponseURL(xhr) {
    if ('responseURL' in xhr) {
        return xhr.responseURL;
    }
    if (/^X-Request-URL:/m.test(xhr.getAllResponseHeaders())) {
        return xhr.getResponseHeader('X-Request-URL');
    }
    return null;
}
/**
 * @param {?} input
 * @return {?}
 */
/**
 * @param {?} input
 * @return {?}
 */
function stringToArrayBuffer(input) {
    var /** @type {?} */ view = new Uint16Array(input.length);
    for (var /** @type {?} */ i = 0, /** @type {?} */ strLen = input.length; i < strLen; i++) {
        view[i] = input.charCodeAt(i);
    }
    return view.buffer;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @param {?=} rawParams
 * @return {?}
 */
function paramParser(rawParams) {
    if (rawParams === void 0) {
        rawParams = '';
    }
    var /** @type {?} */ map = new Map();
    if (rawParams.length > 0) {
        var /** @type {?} */ params = rawParams.split('&');
        params.forEach(function (param) {
            var /** @type {?} */ eqIdx = param.indexOf('=');
            var _a = eqIdx == -1 ? [param, ''] : [param.slice(0, eqIdx), param.slice(eqIdx + 1)], key = _a[0], val = _a[1];
            var /** @type {?} */ list = map.get(key) || [];
            list.push(val);
            map.set(key, list);
        });
    }
    return map;
}
/**
 * @deprecated use \@angular/common/http instead
 *
 */
var QueryEncoder = (function () {
    function QueryEncoder() {
    }
    /**
     * @param {?} k
     * @return {?}
     */
    QueryEncoder.prototype.encodeKey =
        function (k) { return standardEncoding(k); };
    /**
     * @param {?} v
     * @return {?}
     */
    QueryEncoder.prototype.encodeValue =
        function (v) { return standardEncoding(v); };
    return QueryEncoder;
}());
/**
 * @param {?} v
 * @return {?}
 */
function standardEncoding(v) {
    return encodeURIComponent(v)
        .replace(/%40/gi, '@')
        .replace(/%3A/gi, ':')
        .replace(/%24/gi, '$')
        .replace(/%2C/gi, ',')
        .replace(/%3B/gi, ';')
        .replace(/%2B/gi, '+')
        .replace(/%3D/gi, '=')
        .replace(/%3F/gi, '?')
        .replace(/%2F/gi, '/');
}
/**
 * Map-like representation of url search parameters, based on
 * [URLSearchParams](https://url.spec.whatwg.org/#urlsearchparams) in the url living standard,
 * with several extensions for merging URLSearchParams objects:
 *   - setAll()
 *   - appendAll()
 *   - replaceAll()
 *
 * This class accepts an optional second parameter of ${\@link QueryEncoder},
 * which is used to serialize parameters before making a request. By default,
 * `QueryEncoder` encodes keys and values of parameters using `encodeURIComponent`,
 * and then un-encodes certain characters that are allowed to be part of the query
 * according to IETF RFC 3986: https://tools.ietf.org/html/rfc3986.
 *
 * These are the characters that are not encoded: `! $ \' ( ) * + , ; A 9 - . _ ~ ? /`
 *
 * If the set of allowed query characters is not acceptable for a particular backend,
 * `QueryEncoder` can be subclassed and provided as the 2nd argument to URLSearchParams.
 *
 * ```
 * import {URLSearchParams, QueryEncoder} from '\@angular/http';
 * class MyQueryEncoder extends QueryEncoder {
 *   encodeKey(k: string): string {
 *     return myEncodingFunction(k);
 *   }
 *
 *   encodeValue(v: string): string {
 *     return myEncodingFunction(v);
 *   }
 * }
 *
 * let params = new URLSearchParams('', new MyQueryEncoder());
 * ```
 * @deprecated use \@angular/common/http instead
 */
var URLSearchParams = (function () {
    function URLSearchParams(rawParams, queryEncoder) {
        if (rawParams === void 0) {
            rawParams = '';
        }
        if (queryEncoder === void 0) {
            queryEncoder = new QueryEncoder();
        }
        this.rawParams = rawParams;
        this.queryEncoder = queryEncoder;
        this.paramsMap = paramParser(rawParams);
    }
    /**
     * @return {?}
     */
    URLSearchParams.prototype.clone =
        function () {
            var /** @type {?} */ clone = new URLSearchParams('', this.queryEncoder);
            clone.appendAll(this);
            return clone;
        };
    /**
     * @param {?} param
     * @return {?}
     */
    URLSearchParams.prototype.has =
        function (param) { return this.paramsMap.has(param); };
    /**
     * @param {?} param
     * @return {?}
     */
    URLSearchParams.prototype.get =
        function (param) {
            var /** @type {?} */ storedParam = this.paramsMap.get(param);
            return Array.isArray(storedParam) ? storedParam[0] : null;
        };
    /**
     * @param {?} param
     * @return {?}
     */
    URLSearchParams.prototype.getAll =
        function (param) { return this.paramsMap.get(param) || []; };
    /**
     * @param {?} param
     * @param {?} val
     * @return {?}
     */
    URLSearchParams.prototype.set =
        function (param, val) {
            if (val === void 0 || val === null) {
                this.delete(param);
                return;
            }
            var /** @type {?} */ list = this.paramsMap.get(param) || [];
            list.length = 0;
            list.push(val);
            this.paramsMap.set(param, list);
        };
    // A merge operation
    // For each name-values pair in `searchParams`, perform `set(name, values[0])`
    //
    // E.g: "a=[1,2,3], c=[8]" + "a=[4,5,6], b=[7]" = "a=[4], c=[8], b=[7]"
    //
    // TODO(@caitp): document this better
    /**
     * @param {?} searchParams
     * @return {?}
     */
    URLSearchParams.prototype.setAll =
        function (searchParams) {
            var _this = this;
            searchParams.paramsMap.forEach(function (value, param) {
                var /** @type {?} */ list = _this.paramsMap.get(param) || [];
                list.length = 0;
                list.push(value[0]);
                _this.paramsMap.set(param, list);
            });
        };
    /**
     * @param {?} param
     * @param {?} val
     * @return {?}
     */
    URLSearchParams.prototype.append =
        function (param, val) {
            if (val === void 0 || val === null)
                return;
            var /** @type {?} */ list = this.paramsMap.get(param) || [];
            list.push(val);
            this.paramsMap.set(param, list);
        };
    // A merge operation
    // For each name-values pair in `searchParams`, perform `append(name, value)`
    // for each value in `values`.
    //
    // E.g: "a=[1,2], c=[8]" + "a=[3,4], b=[7]" = "a=[1,2,3,4], c=[8], b=[7]"
    //
    // TODO(@caitp): document this better
    /**
     * @param {?} searchParams
     * @return {?}
     */
    URLSearchParams.prototype.appendAll =
        function (searchParams) {
            var _this = this;
            searchParams.paramsMap.forEach(function (value, param) {
                var /** @type {?} */ list = _this.paramsMap.get(param) || [];
                for (var /** @type {?} */ i = 0; i < value.length; ++i) {
                    list.push(value[i]);
                }
                _this.paramsMap.set(param, list);
            });
        };
    // A merge operation
    // For each name-values pair in `searchParams`, perform `delete(name)`,
    // followed by `set(name, values)`
    //
    // E.g: "a=[1,2,3], c=[8]" + "a=[4,5,6], b=[7]" = "a=[4,5,6], c=[8], b=[7]"
    //
    // TODO(@caitp): document this better
    /**
     * @param {?} searchParams
     * @return {?}
     */
    URLSearchParams.prototype.replaceAll =
        function (searchParams) {
            var _this = this;
            searchParams.paramsMap.forEach(function (value, param) {
                var /** @type {?} */ list = _this.paramsMap.get(param) || [];
                list.length = 0;
                for (var /** @type {?} */ i = 0; i < value.length; ++i) {
                    list.push(value[i]);
                }
                _this.paramsMap.set(param, list);
            });
        };
    /**
     * @return {?}
     */
    URLSearchParams.prototype.toString =
        function () {
            var _this = this;
            var /** @type {?} */ paramsList = [];
            this.paramsMap.forEach(function (values, k) {
                values.forEach(function (v) {
                    return paramsList.push(_this.queryEncoder.encodeKey(k) + '=' + _this.queryEncoder.encodeValue(v));
                });
            });
            return paramsList.join('&');
        };
    /**
     * @param {?} param
     * @return {?}
     */
    URLSearchParams.prototype.delete =
        function (param) { this.paramsMap.delete(param); };
    return URLSearchParams;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * HTTP request body used by both {\@link Request} and {\@link Response}
 * https://fetch.spec.whatwg.org/#body
 * @abstract
 */
var Body = (function () {
    function Body() {
    }
    /**
     * Attempts to return body as parsed `JSON` object, or raises an exception.
     */
    /**
     * Attempts to return body as parsed `JSON` object, or raises an exception.
     * @return {?}
     */
    Body.prototype.json =
        function () {
            if (typeof this._body === 'string') {
                return JSON.parse(/** @type {?} */ (this._body));
            }
            if (this._body instanceof ArrayBuffer) {
                return JSON.parse(this.text());
            }
            return this._body;
        };
    /**
     * Returns the body as a string, presuming `toString()` can be called on the response body.
     *
     * When decoding an `ArrayBuffer`, the optional `encodingHint` parameter determines how the
     * bytes in the buffer will be interpreted. Valid values are:
     *
     * - `legacy` - incorrectly interpret the bytes as UTF-16 (technically, UCS-2). Only characters
     *   in the Basic Multilingual Plane are supported, surrogate pairs are not handled correctly.
     *   In addition, the endianness of the 16-bit octet pairs in the `ArrayBuffer` is not taken
     *   into consideration. This is the default behavior to avoid breaking apps, but should be
     *   considered deprecated.
     *
     * - `iso-8859` - interpret the bytes as ISO-8859 (which can be used for ASCII encoded text).
     */
    /**
     * Returns the body as a string, presuming `toString()` can be called on the response body.
     *
     * When decoding an `ArrayBuffer`, the optional `encodingHint` parameter determines how the
     * bytes in the buffer will be interpreted. Valid values are:
     *
     * - `legacy` - incorrectly interpret the bytes as UTF-16 (technically, UCS-2). Only characters
     *   in the Basic Multilingual Plane are supported, surrogate pairs are not handled correctly.
     *   In addition, the endianness of the 16-bit octet pairs in the `ArrayBuffer` is not taken
     *   into consideration. This is the default behavior to avoid breaking apps, but should be
     *   considered deprecated.
     *
     * - `iso-8859` - interpret the bytes as ISO-8859 (which can be used for ASCII encoded text).
     * @param {?=} encodingHint
     * @return {?}
     */
    Body.prototype.text =
        function (encodingHint) {
            if (encodingHint === void 0) {
                encodingHint = 'legacy';
            }
            if (this._body instanceof URLSearchParams) {
                return this._body.toString();
            }
            if (this._body instanceof ArrayBuffer) {
                switch (encodingHint) {
                    case 'legacy':
                        return String.fromCharCode.apply(null, new Uint16Array(/** @type {?} */ (this._body)));
                    case 'iso-8859':
                        return String.fromCharCode.apply(null, new Uint8Array(/** @type {?} */ (this._body)));
                    default:
                        throw new Error("Invalid value for encodingHint: " + encodingHint);
                }
            }
            if (this._body == null) {
                return '';
            }
            if (typeof this._body === 'object') {
                return JSON.stringify(this._body, null, 2);
            }
            return this._body.toString();
        };
    /**
     * Return the body as an ArrayBuffer
     */
    /**
     * Return the body as an ArrayBuffer
     * @return {?}
     */
    Body.prototype.arrayBuffer =
        function () {
            if (this._body instanceof ArrayBuffer) {
                return (this._body);
            }
            return stringToArrayBuffer(this.text());
        };
    /**
      * Returns the request's body as a Blob, assuming that body exists.
      */
    /**
     * Returns the request's body as a Blob, assuming that body exists.
     * @return {?}
     */
    Body.prototype.blob =
        function () {
            if (this._body instanceof Blob) {
                return (this._body);
            }
            if (this._body instanceof ArrayBuffer) {
                return new Blob([this._body]);
            }
            throw new Error('The request body isn\'t either a blob or an array buffer');
        };
    return Body;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Creates `Response` instances from provided values.
 *
 * Though this object isn't
 * usually instantiated by end-users, it is the primary object interacted with when it comes time to
 * add data to a view.
 *
 * ### Example
 *
 * ```
 * http.request('my-friends.txt').subscribe(response => this.friends = response.text());
 * ```
 *
 * The Response's interface is inspired by the Response constructor defined in the [Fetch
 * Spec](https://fetch.spec.whatwg.org/#response-class), but is considered a static value whose body
 * can be accessed many times. There are other differences in the implementation, but this is the
 * most significant.
 *
 * @deprecated use \@angular/common/http instead
 */
var Response = (function (_super) {
    __extends(Response, _super);
    function Response(responseOptions) {
        var _this = _super.call(this) || this;
        _this._body = responseOptions.body;
        _this.status = ((responseOptions.status));
        _this.ok = (_this.status >= 200 && _this.status <= 299);
        _this.statusText = responseOptions.statusText;
        _this.headers = responseOptions.headers;
        _this.type = ((responseOptions.type));
        _this.url = ((responseOptions.url));
        return _this;
    }
    /**
     * @return {?}
     */
    Response.prototype.toString =
        function () {
            return "Response with status: " + this.status + " " + this.statusText + " for URL: " + this.url;
        };
    return Response;
}(Body));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
var _nextRequestId = 0;
var JSONP_HOME = '__ng_jsonp__';
var _jsonpConnections = null;
/**
 * @return {?}
 */
function _getJsonpConnections() {
    var /** @type {?} */ w = typeof window == 'object' ? window : {};
    if (_jsonpConnections === null) {
        _jsonpConnections = w[JSONP_HOME] = {};
    }
    return _jsonpConnections;
}
var BrowserJsonp = (function () {
    function BrowserJsonp() {
    }
    // Construct a <script> element with the specified URL
    /**
     * @param {?} url
     * @return {?}
     */
    BrowserJsonp.prototype.build =
        function (url) {
            var /** @type {?} */ node = document.createElement('script');
            node.src = url;
            return node;
        };
    /**
     * @return {?}
     */
    BrowserJsonp.prototype.nextRequestID =
        function () { return "__req" + _nextRequestId++; };
    /**
     * @param {?} id
     * @return {?}
     */
    BrowserJsonp.prototype.requestCallback =
        function (id) { return JSONP_HOME + "." + id + ".finished"; };
    /**
     * @param {?} id
     * @param {?} connection
     * @return {?}
     */
    BrowserJsonp.prototype.exposeConnection =
        function (id, connection) {
            var /** @type {?} */ connections = _getJsonpConnections();
            connections[id] = connection;
        };
    /**
     * @param {?} id
     * @return {?}
     */
    BrowserJsonp.prototype.removeConnection =
        function (id) {
            var /** @type {?} */ connections = _getJsonpConnections();
            connections[id] = null;
        };
    // Attach the <script> element to the DOM
    /**
     * @param {?} node
     * @return {?}
     */
    BrowserJsonp.prototype.send =
        function (node) { document.body.appendChild(/** @type {?} */ ((node))); };
    // Remove <script> element from the DOM
    /**
     * @param {?} node
     * @return {?}
     */
    BrowserJsonp.prototype.cleanup =
        function (node) {
            if (node.parentNode) {
                node.parentNode.removeChild(/** @type {?} */ ((node)));
            }
        };
    BrowserJsonp.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BrowserJsonp.ctorParameters = function () { return []; };
    return BrowserJsonp;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
var JSONP_ERR_NO_CALLBACK = 'JSONP injected script did not invoke callback.';
var JSONP_ERR_WRONG_METHOD = 'JSONP requests must use GET request method.';
/**
 * Base class for an in-flight JSONP request.
 *
 * @deprecated use \@angular/common/http instead
 */
var JSONPConnection = (function () {
    /** @internal */
    function JSONPConnection(req, _dom, baseResponseOptions) {
        var _this = this;
        this._dom = _dom;
        this.baseResponseOptions = baseResponseOptions;
        this._finished = false;
        if (req.method !== RequestMethod.Get) {
            throw new TypeError(JSONP_ERR_WRONG_METHOD);
        }
        this.request = req;
        this.response = new Observable.Observable(function (responseObserver) {
            _this.readyState = ReadyState.Loading;
            var /** @type {?} */ id = _this._id = _dom.nextRequestID();
            _dom.exposeConnection(id, _this);
            // Workaround Dart
            // url = url.replace(/=JSONP_CALLBACK(&|$)/, `generated method`);
            var /** @type {?} */ callback = _dom.requestCallback(_this._id);
            var /** @type {?} */ url = req.url;
            if (url.indexOf('=JSONP_CALLBACK&') > -1) {
                url = url.replace('=JSONP_CALLBACK&', "=" + callback + "&");
            }
            else if (url.lastIndexOf('=JSONP_CALLBACK') === url.length - '=JSONP_CALLBACK'.length) {
                url = url.substring(0, url.length - '=JSONP_CALLBACK'.length) + ("=" + callback);
            }
            var /** @type {?} */ script = _this._script = _dom.build(url);
            var /** @type {?} */ onLoad = function (event) {
                if (_this.readyState === ReadyState.Cancelled)
                    return;
                _this.readyState = ReadyState.Done;
                _dom.cleanup(script);
                if (!_this._finished) {
                    var /** @type {?} */ responseOptions_1 = new ResponseOptions({ body: JSONP_ERR_NO_CALLBACK, type: ResponseType.Error, url: url });
                    if (baseResponseOptions) {
                        responseOptions_1 = baseResponseOptions.merge(responseOptions_1);
                    }
                    responseObserver.error(new Response(responseOptions_1));
                    return;
                }
                var /** @type {?} */ responseOptions = new ResponseOptions({ body: _this._responseData, url: url });
                if (_this.baseResponseOptions) {
                    responseOptions = _this.baseResponseOptions.merge(responseOptions);
                }
                responseObserver.next(new Response(responseOptions));
                responseObserver.complete();
            };
            var /** @type {?} */ onError = function (error) {
                if (_this.readyState === ReadyState.Cancelled)
                    return;
                _this.readyState = ReadyState.Done;
                _dom.cleanup(script);
                var /** @type {?} */ responseOptions = new ResponseOptions({ body: error.message, type: ResponseType.Error });
                if (baseResponseOptions) {
                    responseOptions = baseResponseOptions.merge(responseOptions);
                }
                responseObserver.error(new Response(responseOptions));
            };
            script.addEventListener('load', onLoad);
            script.addEventListener('error', onError);
            _dom.send(script);
            return function () {
                _this.readyState = ReadyState.Cancelled;
                script.removeEventListener('load', onLoad);
                script.removeEventListener('error', onError);
                _this._dom.cleanup(script);
            };
        });
    }
    /**
     * Callback called when the JSONP request completes, to notify the application
     * of the new data.
     */
    /**
     * Callback called when the JSONP request completes, to notify the application
     * of the new data.
     * @param {?=} data
     * @return {?}
     */
    JSONPConnection.prototype.finished =
        function (data) {
            // Don't leak connections
            this._finished = true;
            this._dom.removeConnection(this._id);
            if (this.readyState === ReadyState.Cancelled)
                return;
            this._responseData = data;
        };
    return JSONPConnection;
}());
/**
 * A {\@link ConnectionBackend} that uses the JSONP strategy of making requests.
 *
 * @deprecated use \@angular/common/http instead
 */
var JSONPBackend = (function (_super) {
    __extends(JSONPBackend, _super);
    /** @internal */
    function JSONPBackend(_browserJSONP, _baseResponseOptions) {
        var _this = _super.call(this) || this;
        _this._browserJSONP = _browserJSONP;
        _this._baseResponseOptions = _baseResponseOptions;
        return _this;
    }
    /**
     * @param {?} request
     * @return {?}
     */
    JSONPBackend.prototype.createConnection =
        function (request) {
            return new JSONPConnection(request, this._browserJSONP, this._baseResponseOptions);
        };
    JSONPBackend.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    JSONPBackend.ctorParameters = function () {
        return [
            { type: BrowserJsonp, },
            { type: ResponseOptions, },
        ];
    };
    return JSONPBackend;
}(ConnectionBackend));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
var XSSI_PREFIX = /^\)\]\}',?\n/;
/**
 * Creates connections using `XMLHttpRequest`. Given a fully-qualified
 * request, an `XHRConnection` will immediately create an `XMLHttpRequest` object and send the
 * request.
 *
 * This class would typically not be created or interacted with directly inside applications, though
 * the {\@link MockConnection} may be interacted with in tests.
 *
 * @deprecated use \@angular/common/http instead
 */
var XHRConnection = (function () {
    function XHRConnection(req, browserXHR, baseResponseOptions) {
        var _this = this;
        this.request = req;
        this.response = new Observable.Observable(function (responseObserver) {
            var /** @type {?} */ _xhr = browserXHR.build();
            _xhr.open(RequestMethod[req.method].toUpperCase(), req.url);
            if (req.withCredentials != null) {
                _xhr.withCredentials = req.withCredentials;
            }
            // load event handler
            var /** @type {?} */ onLoad = function () {
                // normalize IE9 bug (http://bugs.jquery.com/ticket/1450)
                var /** @type {?} */ status = _xhr.status === 1223 ? 204 : _xhr.status;
                var /** @type {?} */ body = null;
                // HTTP 204 means no content
                if (status !== 204) {
                    // responseText is the old-school way of retrieving response (supported by IE8 & 9)
                    // response/responseType properties were introduced in ResourceLoader Level2 spec
                    // (supported by IE10)
                    body = (typeof _xhr.response === 'undefined') ? _xhr.responseText : _xhr.response;
                    // Implicitly strip a potential XSSI prefix.
                    if (typeof body === 'string') {
                        body = body.replace(XSSI_PREFIX, '');
                    }
                }
                // fix status code when it is 0 (0 status is undocumented).
                // Occurs when accessing file resources or on Android 4.1 stock browser
                // while retrieving files from application cache.
                if (status === 0) {
                    status = body ? 200 : 0;
                }
                var /** @type {?} */ headers = Headers.fromResponseHeaderString(_xhr.getAllResponseHeaders());
                // IE 9 does not provide the way to get URL of response
                var /** @type {?} */ url = getResponseURL(_xhr) || req.url;
                var /** @type {?} */ statusText = _xhr.statusText || 'OK';
                var /** @type {?} */ responseOptions = new ResponseOptions({ body: body, status: status, headers: headers, statusText: statusText, url: url });
                if (baseResponseOptions != null) {
                    responseOptions = baseResponseOptions.merge(responseOptions);
                }
                var /** @type {?} */ response = new Response(responseOptions);
                response.ok = isSuccess(status);
                if (response.ok) {
                    responseObserver.next(response);
                    // TODO(gdi2290): defer complete if array buffer until done
                    responseObserver.complete();
                    return;
                }
                responseObserver.error(response);
            };
            // error event handler
            var /** @type {?} */ onError = function (err) {
                var /** @type {?} */ responseOptions = new ResponseOptions({
                    body: err,
                    type: ResponseType.Error,
                    status: _xhr.status,
                    statusText: _xhr.statusText,
                });
                if (baseResponseOptions != null) {
                    responseOptions = baseResponseOptions.merge(responseOptions);
                }
                responseObserver.error(new Response(responseOptions));
            };
            _this.setDetectedContentType(req, _xhr);
            if (req.headers == null) {
                req.headers = new Headers();
            }
            if (!req.headers.has('Accept')) {
                req.headers.append('Accept', 'application/json, text/plain, */*');
            }
            req.headers.forEach(function (values, name) { return _xhr.setRequestHeader(/** @type {?} */ ((name)), values.join(',')); });
            // Select the correct buffer type to store the response
            if (req.responseType != null && _xhr.responseType != null) {
                switch (req.responseType) {
                    case ResponseContentType.ArrayBuffer:
                        _xhr.responseType = 'arraybuffer';
                        break;
                    case ResponseContentType.Json:
                        _xhr.responseType = 'json';
                        break;
                    case ResponseContentType.Text:
                        _xhr.responseType = 'text';
                        break;
                    case ResponseContentType.Blob:
                        _xhr.responseType = 'blob';
                        break;
                    default:
                        throw new Error('The selected responseType is not supported');
                }
            }
            _xhr.addEventListener('load', onLoad);
            _xhr.addEventListener('error', onError);
            _xhr.send(_this.request.getBody());
            return function () {
                _xhr.removeEventListener('load', onLoad);
                _xhr.removeEventListener('error', onError);
                _xhr.abort();
            };
        });
    }
    /**
     * @param {?} req
     * @param {?} _xhr
     * @return {?}
     */
    XHRConnection.prototype.setDetectedContentType =
        function (req /** TODO Request */, _xhr /** XMLHttpRequest */) {
            // Skip if a custom Content-Type header is provided
            if (req.headers != null && req.headers.get('Content-Type') != null) {
                return;
            }
            // Set the detected content type
            switch (req.contentType) {
                case ContentType.NONE:
                    break;
                case ContentType.JSON:
                    _xhr.setRequestHeader('content-type', 'application/json');
                    break;
                case ContentType.FORM:
                    _xhr.setRequestHeader('content-type', 'application/x-www-form-urlencoded;charset=UTF-8');
                    break;
                case ContentType.TEXT:
                    _xhr.setRequestHeader('content-type', 'text/plain');
                    break;
                case ContentType.BLOB:
                    var /** @type {?} */ blob = req.blob();
                    if (blob.type) {
                        _xhr.setRequestHeader('content-type', blob.type);
                    }
                    break;
            }
        };
    return XHRConnection;
}());
/**
 * `XSRFConfiguration` sets up Cross Site Request Forgery (XSRF) protection for the application
 * using a cookie. See https://www.owasp.org/index.php/Cross-Site_Request_Forgery_(CSRF)
 * for more information on XSRF.
 *
 * Applications can configure custom cookie and header names by binding an instance of this class
 * with different `cookieName` and `headerName` values. See the main HTTP documentation for more
 * details.
 *
 * @deprecated use \@angular/common/http instead
 */
var CookieXSRFStrategy = (function () {
    function CookieXSRFStrategy(_cookieName, _headerName) {
        if (_cookieName === void 0) {
            _cookieName = 'XSRF-TOKEN';
        }
        if (_headerName === void 0) {
            _headerName = 'X-XSRF-TOKEN';
        }
        this._cookieName = _cookieName;
        this._headerName = _headerName;
    }
    /**
     * @param {?} req
     * @return {?}
     */
    CookieXSRFStrategy.prototype.configureRequest =
        function (req) {
            var /** @type {?} */ xsrfToken = platformBrowser.ɵgetDOM().getCookie(this._cookieName);
            if (xsrfToken) {
                req.headers.set(this._headerName, xsrfToken);
            }
        };
    return CookieXSRFStrategy;
}());
/**
 * Creates {\@link XHRConnection} instances.
 *
 * This class would typically not be used by end users, but could be
 * overridden if a different backend implementation should be used,
 * such as in a node backend.
 *
 * ### Example
 *
 * ```
 * import {Http, MyNodeBackend, HTTP_PROVIDERS, BaseRequestOptions} from '\@angular/http';
 * \@Component({
 *   viewProviders: [
 *     HTTP_PROVIDERS,
 *     {provide: Http, useFactory: (backend, options) => {
 *       return new Http(backend, options);
 *     }, deps: [MyNodeBackend, BaseRequestOptions]}]
 * })
 * class MyComponent {
 *   constructor(http:Http) {
 *     http.request('people.json').subscribe(res => this.people = res.json());
 *   }
 * }
 * ```
 * @deprecated use \@angular/common/http instead
 */
var XHRBackend = (function () {
    function XHRBackend(_browserXHR, _baseResponseOptions, _xsrfStrategy) {
        this._browserXHR = _browserXHR;
        this._baseResponseOptions = _baseResponseOptions;
        this._xsrfStrategy = _xsrfStrategy;
    }
    /**
     * @param {?} request
     * @return {?}
     */
    XHRBackend.prototype.createConnection =
        function (request) {
            this._xsrfStrategy.configureRequest(request);
            return new XHRConnection(request, this._browserXHR, this._baseResponseOptions);
        };
    XHRBackend.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    XHRBackend.ctorParameters = function () {
        return [
            { type: BrowserXhr, },
            { type: ResponseOptions, },
            { type: XSRFStrategy, },
        ];
    };
    return XHRBackend;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Creates a request options object to be optionally provided when instantiating a
 * {\@link Request}.
 *
 * This class is based on the `RequestInit` description in the [Fetch
 * Spec](https://fetch.spec.whatwg.org/#requestinit).
 *
 * All values are null by default. Typical defaults can be found in the {\@link BaseRequestOptions}
 * class, which sub-classes `RequestOptions`.
 *
 * ```typescript
 * import {RequestOptions, Request, RequestMethod} from '\@angular/http';
 *
 * const options = new RequestOptions({
 *   method: RequestMethod.Post,
 *   url: 'https://google.com'
 * });
 * const req = new Request(options);
 * console.log('req.method:', RequestMethod[req.method]); // Post
 * console.log('options.url:', options.url); // https://google.com
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var RequestOptions = (function () {
    // TODO(Dzmitry): remove search when this.search is removed
    function RequestOptions(opts) {
        if (opts === void 0) {
            opts = {};
        }
        var method = opts.method, headers = opts.headers, body = opts.body, url = opts.url, search = opts.search, params = opts.params, withCredentials = opts.withCredentials, responseType = opts.responseType;
        this.method = method != null ? normalizeMethodName(method) : null;
        this.headers = headers != null ? headers : null;
        this.body = body != null ? body : null;
        this.url = url != null ? url : null;
        this.params = this._mergeSearchParams(params || search);
        this.withCredentials = withCredentials != null ? withCredentials : null;
        this.responseType = responseType != null ? responseType : null;
    }
    Object.defineProperty(RequestOptions.prototype, "search", {
        /**
         * @deprecated from 4.0.0. Use params instead.
         */
        get: /**
         * @deprecated from 4.0.0. Use params instead.
         * @return {?}
         */ function () { return this.params; },
        /**
         * @deprecated from 4.0.0. Use params instead.
         */
        set: /**
         * @deprecated from 4.0.0. Use params instead.
         * @param {?} params
         * @return {?}
         */ function (params) { this.params = params; },
        enumerable: true,
        configurable: true
    });
    /**
     * Creates a copy of the `RequestOptions` instance, using the optional input as values to override
     * existing values. This method will not change the values of the instance on which it is being
     * called.
     *
     * Note that `headers` and `search` will override existing values completely if present in
     * the `options` object. If these values should be merged, it should be done prior to calling
     * `merge` on the `RequestOptions` instance.
     *
     * ```typescript
     * import {RequestOptions, Request, RequestMethod} from '@angular/http';
     *
     * const options = new RequestOptions({
     *   method: RequestMethod.Post
     * });
     * const req = new Request(options.merge({
     *   url: 'https://google.com'
     * }));
     * console.log('req.method:', RequestMethod[req.method]); // Post
     * console.log('options.url:', options.url); // null
     * console.log('req.url:', req.url); // https://google.com
     * ```
     */
    /**
     * Creates a copy of the `RequestOptions` instance, using the optional input as values to override
     * existing values. This method will not change the values of the instance on which it is being
     * called.
     *
     * Note that `headers` and `search` will override existing values completely if present in
     * the `options` object. If these values should be merged, it should be done prior to calling
     * `merge` on the `RequestOptions` instance.
     *
     * ```typescript
     * import {RequestOptions, Request, RequestMethod} from '\@angular/http';
     *
     * const options = new RequestOptions({
     *   method: RequestMethod.Post
     * });
     * const req = new Request(options.merge({
     *   url: 'https://google.com'
     * }));
     * console.log('req.method:', RequestMethod[req.method]); // Post
     * console.log('options.url:', options.url); // null
     * console.log('req.url:', req.url); // https://google.com
     * ```
     * @param {?=} options
     * @return {?}
     */
    RequestOptions.prototype.merge =
        function (options) {
            return new RequestOptions({
                method: options && options.method != null ? options.method : this.method,
                headers: options && options.headers != null ? options.headers : new Headers(this.headers),
                body: options && options.body != null ? options.body : this.body,
                url: options && options.url != null ? options.url : this.url,
                params: options && this._mergeSearchParams(options.params || options.search),
                withCredentials: options && options.withCredentials != null ? options.withCredentials :
                    this.withCredentials,
                responseType: options && options.responseType != null ? options.responseType :
                    this.responseType
            });
        };
    /**
     * @param {?=} params
     * @return {?}
     */
    RequestOptions.prototype._mergeSearchParams =
        function (params) {
            if (!params)
                return this.params;
            if (params instanceof URLSearchParams) {
                return params.clone();
            }
            if (typeof params === 'string') {
                return new URLSearchParams(params);
            }
            return this._parseParams(params);
        };
    /**
     * @param {?=} objParams
     * @return {?}
     */
    RequestOptions.prototype._parseParams =
        function (objParams) {
            var _this = this;
            if (objParams === void 0) {
                objParams = {};
            }
            var /** @type {?} */ params = new URLSearchParams();
            Object.keys(objParams).forEach(function (key) {
                var /** @type {?} */ value = objParams[key];
                if (Array.isArray(value)) {
                    value.forEach(function (item) { return _this._appendParam(key, item, params); });
                }
                else {
                    _this._appendParam(key, value, params);
                }
            });
            return params;
        };
    /**
     * @param {?} key
     * @param {?} value
     * @param {?} params
     * @return {?}
     */
    RequestOptions.prototype._appendParam =
        function (key, value, params) {
            if (typeof value !== 'string') {
                value = JSON.stringify(value);
            }
            params.append(key, value);
        };
    return RequestOptions;
}());
/**
 * Subclass of {\@link RequestOptions}, with default values.
 *
 * Default values:
 *  * method: {\@link RequestMethod RequestMethod.Get}
 *  * headers: empty {\@link Headers} object
 *
 * This class could be extended and bound to the {\@link RequestOptions} class
 * when configuring an {\@link Injector}, in order to override the default options
 * used by {\@link Http} to create and send {\@link Request Requests}.
 *
 * ```typescript
 * import {BaseRequestOptions, RequestOptions} from '\@angular/http';
 *
 * class MyOptions extends BaseRequestOptions {
 *   search: string = 'coreTeam=true';
 * }
 *
 * {provide: RequestOptions, useClass: MyOptions};
 * ```
 *
 * The options could also be extended when manually creating a {\@link Request}
 * object.
 *
 * ```
 * import {BaseRequestOptions, Request, RequestMethod} from '\@angular/http';
 *
 * const options = new BaseRequestOptions();
 * const req = new Request(options.merge({
 *   method: RequestMethod.Post,
 *   url: 'https://google.com'
 * }));
 * console.log('req.method:', RequestMethod[req.method]); // Post
 * console.log('options.url:', options.url); // null
 * console.log('req.url:', req.url); // https://google.com
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var BaseRequestOptions = (function (_super) {
    __extends(BaseRequestOptions, _super);
    function BaseRequestOptions() {
        return _super.call(this, { method: RequestMethod.Get, headers: new Headers() }) || this;
    }
    BaseRequestOptions.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    BaseRequestOptions.ctorParameters = function () { return []; };
    return BaseRequestOptions;
}(RequestOptions));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * Creates `Request` instances from provided values.
 *
 * The Request's interface is inspired by the Request constructor defined in the [Fetch
 * Spec](https://fetch.spec.whatwg.org/#request-class),
 * but is considered a static value whose body can be accessed many times. There are other
 * differences in the implementation, but this is the most significant.
 *
 * `Request` instances are typically created by higher-level classes, like {\@link Http} and
 * {\@link Jsonp}, but it may occasionally be useful to explicitly create `Request` instances.
 * One such example is when creating services that wrap higher-level services, like {\@link Http},
 * where it may be useful to generate a `Request` with arbitrary headers and search params.
 *
 * ```typescript
 * import {Injectable, Injector} from '\@angular/core';
 * import {HTTP_PROVIDERS, Http, Request, RequestMethod} from '\@angular/http';
 *
 * \@Injectable()
 * class AutoAuthenticator {
 *   constructor(public http:Http) {}
 *   request(url:string) {
 *     return this.http.request(new Request({
 *       method: RequestMethod.Get,
 *       url: url,
 *       search: 'password=123'
 *     }));
 *   }
 * }
 *
 * var injector = Injector.resolveAndCreate([HTTP_PROVIDERS, AutoAuthenticator]);
 * var authenticator = injector.get(AutoAuthenticator);
 * authenticator.request('people.json').subscribe(res => {
 *   //URL should have included '?password=123'
 *   console.log('people', res.json());
 * });
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var Request = (function (_super) {
    __extends(Request, _super);
    function Request(requestOptions) {
        var _this = _super.call(this) || this;
        // TODO: assert that url is present
        var /** @type {?} */ url = requestOptions.url;
        _this.url = ((requestOptions.url));
        var /** @type {?} */ paramsArg = requestOptions.params || requestOptions.search;
        if (paramsArg) {
            var /** @type {?} */ params = void 0;
            if (typeof paramsArg === 'object' && !(paramsArg instanceof URLSearchParams)) {
                params = urlEncodeParams(paramsArg).toString();
            }
            else {
                params = paramsArg.toString();
            }
            if (params.length > 0) {
                var /** @type {?} */ prefix = '?';
                if (_this.url.indexOf('?') != -1) {
                    prefix = (_this.url[_this.url.length - 1] == '&') ? '' : '&';
                }
                // TODO: just delete search-query-looking string in url?
                // TODO: just delete search-query-looking string in url?
                _this.url = url + prefix + params;
            }
        }
        _this._body = requestOptions.body;
        _this.method = normalizeMethodName(/** @type {?} */ ((requestOptions.method)));
        // TODO(jeffbcross): implement behavior
        // Defaults to 'omit', consistent with browser
        // TODO(jeffbcross): implement behavior
        // Defaults to 'omit', consistent with browser
        _this.headers = new Headers(requestOptions.headers);
        _this.contentType = _this.detectContentType();
        _this.withCredentials = ((requestOptions.withCredentials));
        _this.responseType = ((requestOptions.responseType));
        return _this;
    }
    /**
     * Returns the content type enum based on header options.
     */
    /**
     * Returns the content type enum based on header options.
     * @return {?}
     */
    Request.prototype.detectContentType =
        function () {
            switch (this.headers.get('content-type')) {
                case 'application/json':
                    return ContentType.JSON;
                case 'application/x-www-form-urlencoded':
                    return ContentType.FORM;
                case 'multipart/form-data':
                    return ContentType.FORM_DATA;
                case 'text/plain':
                case 'text/html':
                    return ContentType.TEXT;
                case 'application/octet-stream':
                    return this._body instanceof ArrayBuffer$1 ? ContentType.ARRAY_BUFFER : ContentType.BLOB;
                default:
                    return this.detectContentTypeFromBody();
            }
        };
    /**
     * Returns the content type of request's body based on its type.
     */
    /**
     * Returns the content type of request's body based on its type.
     * @return {?}
     */
    Request.prototype.detectContentTypeFromBody =
        function () {
            if (this._body == null) {
                return ContentType.NONE;
            }
            else if (this._body instanceof URLSearchParams) {
                return ContentType.FORM;
            }
            else if (this._body instanceof FormData$1) {
                return ContentType.FORM_DATA;
            }
            else if (this._body instanceof Blob$1) {
                return ContentType.BLOB;
            }
            else if (this._body instanceof ArrayBuffer$1) {
                return ContentType.ARRAY_BUFFER;
            }
            else if (this._body && typeof this._body === 'object') {
                return ContentType.JSON;
            }
            else {
                return ContentType.TEXT;
            }
        };
    /**
     * Returns the request's body according to its type. If body is undefined, return
     * null.
     */
    /**
     * Returns the request's body according to its type. If body is undefined, return
     * null.
     * @return {?}
     */
    Request.prototype.getBody =
        function () {
            switch (this.contentType) {
                case ContentType.JSON:
                    return this.text();
                case ContentType.FORM:
                    return this.text();
                case ContentType.FORM_DATA:
                    return this._body;
                case ContentType.TEXT:
                    return this.text();
                case ContentType.BLOB:
                    return this.blob();
                case ContentType.ARRAY_BUFFER:
                    return this.arrayBuffer();
                default:
                    return null;
            }
        };
    return Request;
}(Body));
/**
 * @param {?} params
 * @return {?}
 */
function urlEncodeParams(params) {
    var /** @type {?} */ searchParams = new URLSearchParams();
    Object.keys(params).forEach(function (key) {
        var /** @type {?} */ value = params[key];
        if (value && Array.isArray(value)) {
            value.forEach(function (element) { return searchParams.append(key, element.toString()); });
        }
        else {
            searchParams.append(key, value.toString());
        }
    });
    return searchParams;
}
var noop = function () { };
var w = typeof window == 'object' ? window : noop;
var FormData$1 = ((w /** TODO #9100 */) /** TODO #9100 */)['FormData'] || noop;
var Blob$1 = ((w /** TODO #9100 */) /** TODO #9100 */)['Blob'] || noop;
var ArrayBuffer$1 = ((w /** TODO #9100 */) /** TODO #9100 */)['ArrayBuffer'] || noop;
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @param {?} backend
 * @param {?} request
 * @return {?}
 */
function httpRequest(backend, request) {
    return backend.createConnection(request).response;
}
/**
 * @param {?} defaultOpts
 * @param {?} providedOpts
 * @param {?} method
 * @param {?} url
 * @return {?}
 */
function mergeOptions(defaultOpts, providedOpts, method, url) {
    var /** @type {?} */ newOptions = defaultOpts;
    if (providedOpts) {
        // Hack so Dart can used named parameters
        return (newOptions.merge(new RequestOptions({
            method: providedOpts.method || method,
            url: providedOpts.url || url,
            search: providedOpts.search,
            params: providedOpts.params,
            headers: providedOpts.headers,
            body: providedOpts.body,
            withCredentials: providedOpts.withCredentials,
            responseType: providedOpts.responseType
        })));
    }
    return (newOptions.merge(new RequestOptions({ method: method, url: url })));
}
/**
 * Performs http requests using `XMLHttpRequest` as the default backend.
 *
 * `Http` is available as an injectable class, with methods to perform http requests. Calling
 * `request` returns an `Observable` which will emit a single {\@link Response} when a
 * response is received.
 *
 * ### Example
 *
 * ```typescript
 * import {Http, HTTP_PROVIDERS} from '\@angular/http';
 * import 'rxjs/add/operator/map'
 * \@Component({
 *   selector: 'http-app',
 *   viewProviders: [HTTP_PROVIDERS],
 *   templateUrl: 'people.html'
 * })
 * class PeopleComponent {
 *   constructor(http: Http) {
 *     http.get('people.json')
 *       // Call map on the response observable to get the parsed people object
 *       .map(res => res.json())
 *       // Subscribe to the observable to get the parsed people object and attach it to the
 *       // component
 *       .subscribe(people => this.people = people);
 *   }
 * }
 * ```
 *
 *
 * ### Example
 *
 * ```
 * http.get('people.json').subscribe((res:Response) => this.people = res.json());
 * ```
 *
 * The default construct used to perform requests, `XMLHttpRequest`, is abstracted as a "Backend" (
 * {\@link XHRBackend} in this case), which could be mocked with dependency injection by replacing
 * the {\@link XHRBackend} provider, as in the following example:
 *
 * ### Example
 *
 * ```typescript
 * import {BaseRequestOptions, Http} from '\@angular/http';
 * import {MockBackend} from '\@angular/http/testing';
 * var injector = Injector.resolveAndCreate([
 *   BaseRequestOptions,
 *   MockBackend,
 *   {provide: Http, useFactory:
 *       function(backend, defaultOptions) {
 *         return new Http(backend, defaultOptions);
 *       },
 *       deps: [MockBackend, BaseRequestOptions]}
 * ]);
 * var http = injector.get(Http);
 * http.get('request-from-mock-backend.json').subscribe((res:Response) => doSomething(res));
 * ```
 *
 * @deprecated use \@angular/common/http instead
 */
var Http = (function () {
    function Http(_backend, _defaultOptions) {
        this._backend = _backend;
        this._defaultOptions = _defaultOptions;
    }
    /**
     * Performs any type of http request. First argument is required, and can either be a url or
     * a {@link Request} instance. If the first argument is a url, an optional {@link RequestOptions}
     * object can be provided as the 2nd argument. The options object will be merged with the values
     * of {@link BaseRequestOptions} before performing the request.
     */
    /**
     * Performs any type of http request. First argument is required, and can either be a url or
     * a {\@link Request} instance. If the first argument is a url, an optional {\@link RequestOptions}
     * object can be provided as the 2nd argument. The options object will be merged with the values
     * of {\@link BaseRequestOptions} before performing the request.
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.request =
        function (url, options) {
            var /** @type {?} */ responseObservable;
            if (typeof url === 'string') {
                responseObservable = httpRequest(this._backend, new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Get, /** @type {?} */ (url))));
            }
            else if (url instanceof Request) {
                responseObservable = httpRequest(this._backend, url);
            }
            else {
                throw new Error('First argument must be a url string or Request instance.');
            }
            return responseObservable;
        };
    /**
     * Performs a request with `get` http method.
     */
    /**
     * Performs a request with `get` http method.
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.get =
        function (url, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Get, url)));
        };
    /**
     * Performs a request with `post` http method.
     */
    /**
     * Performs a request with `post` http method.
     * @param {?} url
     * @param {?} body
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.post =
        function (url, body, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions.merge(new RequestOptions({ body: body })), options, RequestMethod.Post, url)));
        };
    /**
     * Performs a request with `put` http method.
     */
    /**
     * Performs a request with `put` http method.
     * @param {?} url
     * @param {?} body
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.put =
        function (url, body, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions.merge(new RequestOptions({ body: body })), options, RequestMethod.Put, url)));
        };
    /**
     * Performs a request with `delete` http method.
     */
    /**
     * Performs a request with `delete` http method.
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.delete =
        function (url, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Delete, url)));
        };
    /**
     * Performs a request with `patch` http method.
     */
    /**
     * Performs a request with `patch` http method.
     * @param {?} url
     * @param {?} body
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.patch =
        function (url, body, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions.merge(new RequestOptions({ body: body })), options, RequestMethod.Patch, url)));
        };
    /**
     * Performs a request with `head` http method.
     */
    /**
     * Performs a request with `head` http method.
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.head =
        function (url, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Head, url)));
        };
    /**
     * Performs a request with `options` http method.
     */
    /**
     * Performs a request with `options` http method.
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Http.prototype.options =
        function (url, options) {
            return this.request(new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Options, url)));
        };
    Http.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    Http.ctorParameters = function () {
        return [
            { type: ConnectionBackend, },
            { type: RequestOptions, },
        ];
    };
    return Http;
}());
/**
 * @deprecated use \@angular/common/http instead
 */
var Jsonp = (function (_super) {
    __extends(Jsonp, _super);
    function Jsonp(backend, defaultOptions) {
        return _super.call(this, backend, defaultOptions) || this;
    }
    /**
     * Performs any type of http request. First argument is required, and can either be a url or
     * a {@link Request} instance. If the first argument is a url, an optional {@link RequestOptions}
     * object can be provided as the 2nd argument. The options object will be merged with the values
     * of {@link BaseRequestOptions} before performing the request.
     *
     * @security Regular XHR is the safest alternative to JSONP for most applications, and is
     * supported by all current browsers. Because JSONP creates a `<script>` element with
     * contents retrieved from a remote source, attacker-controlled data introduced by an untrusted
     * source could expose your application to XSS risks. Data exposed by JSONP may also be
     * readable by malicious third-party websites. In addition, JSONP introduces potential risk for
     * future security issues (e.g. content sniffing).  For more detail, see the
     * [Security Guide](http://g.co/ng/security).
     */
    /**
     * Performs any type of http request. First argument is required, and can either be a url or
     * a {\@link Request} instance. If the first argument is a url, an optional {\@link RequestOptions}
     * object can be provided as the 2nd argument. The options object will be merged with the values
     * of {\@link BaseRequestOptions} before performing the request.
     *
     * \@security Regular XHR is the safest alternative to JSONP for most applications, and is
     * supported by all current browsers. Because JSONP creates a `<script>` element with
     * contents retrieved from a remote source, attacker-controlled data introduced by an untrusted
     * source could expose your application to XSS risks. Data exposed by JSONP may also be
     * readable by malicious third-party websites. In addition, JSONP introduces potential risk for
     * future security issues (e.g. content sniffing).  For more detail, see the
     * [Security Guide](http://g.co/ng/security).
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    Jsonp.prototype.request =
        function (url, options) {
            var /** @type {?} */ responseObservable;
            if (typeof url === 'string') {
                url =
                    new Request(mergeOptions(this._defaultOptions, options, RequestMethod.Get, /** @type {?} */ (url)));
            }
            if (url instanceof Request) {
                if (url.method !== RequestMethod.Get) {
                    throw new Error('JSONP requests must use GET request method.');
                }
                responseObservable = httpRequest(this._backend, url);
            }
            else {
                throw new Error('First argument must be a url string or Request instance.');
            }
            return responseObservable;
        };
    Jsonp.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    Jsonp.ctorParameters = function () {
        return [
            { type: ConnectionBackend, },
            { type: RequestOptions, },
        ];
    };
    return Jsonp;
}(Http));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @module
 * @description
 * The http module provides services to perform http requests. To get started, see the {@link Http}
 * class.
 */
/**
 * @return {?}
 */
function _createDefaultCookieXSRFStrategy() {
    return new CookieXSRFStrategy();
}
/**
 * @param {?} xhrBackend
 * @param {?} requestOptions
 * @return {?}
 */
function httpFactory(xhrBackend, requestOptions) {
    return new Http(xhrBackend, requestOptions);
}
/**
 * The module that includes http's providers
 *
 * @deprecated use \@angular/common/http instead
 */
var HttpModule = (function () {
    function HttpModule() {
    }
    HttpModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [
                        // TODO(pascal): use factory type annotations once supported in DI
                        // issue: https://github.com/angular/angular/issues/3183
                        { provide: Http, useFactory: httpFactory, deps: [XHRBackend, RequestOptions] },
                        BrowserXhr,
                        { provide: RequestOptions, useClass: BaseRequestOptions },
                        { provide: ResponseOptions, useClass: BaseResponseOptions },
                        XHRBackend,
                        { provide: XSRFStrategy, useFactory: _createDefaultCookieXSRFStrategy },
                    ],
                },] },
    ];
    /** @nocollapse */
    HttpModule.ctorParameters = function () { return []; };
    return HttpModule;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @module
 * @description
 * Entry point for all public APIs of the common package.
 */
/**
 * @deprecated use \@angular/common/http instead
 */
var VERSION = new core.Version('5.1.1');
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DropDownService = (function () {
    function DropDownService() {
        this.subject$ = new Subject.Subject();
    }
    /**
     * @param {?} str
     * @return {?}
     */
    DropDownService.prototype.observeData = function (str) {
        this.subject$.next(str);
    };
    return DropDownService;
}());
DropDownService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
DropDownService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DropDownComponent = (function () {
    /**
     * @param {?} renderer
     * @param {?} _http
     * @param {?} _ob
     */
    function DropDownComponent(renderer, _http, _ob) {
        this.renderer = renderer;
        this._http = _http;
        this._ob = _ob;
        this._isToggle = false;
        this._isMouseDown = false;
        this.messages = [];
        this.title = 'toggle';
        this._flagTouch_del = false;
        this._flagTouch_add = false;
        this._flagTouch_reserve = false;
        this._flagTouch_default = false;
        this.uploadMessage = new core.EventEmitter();
        this.addMessage = new core.EventEmitter();
        this.delMessage = new core.EventEmitter();
        this.defaultMessage = new core.EventEmitter();
    }
    /**
     * @return {?}
     */
    DropDownComponent.prototype.ngOnInit = function () {
        // this.options.searchMessage(this._http, this._ob);
        // this._ob.subject$.subscribe((data: Array<any>) => {
        //   // this.messages = data;
        // })
    };
    /**
     * @param {?} options
     * @return {?}
     */
    DropDownComponent.prototype.ngOnChanges = function (options) {
        var /** @type {?} */ changeValue = options["searchMessage"];
        if (!changeValue.firstChange) {
            this.messages = changeValue.currentValue.map(function (item) {
                item._isFlag = true;
                item._isFocusLine = false;
                return item;
            });
        }
    };
    /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    DropDownComponent.prototype.editItem = function (event, index) {
        this.messages[index]['_isFlag'] = false;
        this.messages[index]['_isFocusLine'] = true;
    };
    /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    DropDownComponent.prototype.delItem = function (event, index) {
        var _this = this;
        this._flagTouch_del = true;
        this.delMessage.emit(this.messages[index]);
        var /** @type {?} */ return_cb = this._ob.subject$.subscribe(function (data) {
            if (data) {
                _this.messages.splice(index, 1);
                return_cb.unsubscribe();
                alert('删除成功');
                return;
            }
            return_cb.unsubscribe();
            alert('删除失败');
        });
    };
    /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    DropDownComponent.prototype.reserveItem = function (event, index) {
        var _this = this;
        this._flagTouch_reserve = true;
        this.uploadMessage.emit(this.messages[index]);
        var /** @type {?} */ return_cb = this._ob.subject$.subscribe(function (data) {
            // if (data[0]['result']) {
            if (data) {
                _this.messages[index]['_isFlag'] = true;
                _this.messages[index]['_isFocusLine'] = false;
                return_cb.unsubscribe();
                alert('修改成功');
                return;
            }
            return_cb.unsubscribe();
            alert('修改失败');
        });
    };
    /**
     * @return {?}
     */
    DropDownComponent.prototype.addItem = function () {
        var _this = this;
        this._flagTouch_add = true;
        if (!this.addText) {
            alert('不能为空');
            return;
        }
        this.addMessage.emit(this.addText);
        var /** @type {?} */ return_cb = this._ob.subject$.subscribe(function (data) {
            // if (data[0]['result']) {
            console.log(data);
            if (data) {
                // id: data[0]['data']['id'],
                _this.messages.unshift({ id: data.length + 1, title: _this.addText, _isFlag: true, _isFocusLine: false });
                return_cb.unsubscribe();
                _this.addText = '';
            }
            else {
                return_cb.unsubscribe();
                alert(data[0]['message']);
            }
        });
    };
    /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    DropDownComponent.prototype.defaultItem = function (event, index) {
        var _this = this;
        this._flagTouch_default = true;
        this.defaultMessage.emit(this.messages[index]);
        var /** @type {?} */ return_cb = this._ob.subject$.subscribe(function (data) {
            // if (data[0]['result']) {
            if (data) {
                if (data) {
                    _this.messages[index].isDefault = false;
                }
                else {
                    _this.messages[index].isDefault = true;
                }
                return_cb.unsubscribe();
                return;
            }
            alert(data[0]['message']);
            return_cb.unsubscribe();
        });
    };
    return DropDownComponent;
}());
DropDownComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-dropdown-search',
                template: "<div class=\"container ant-dropdown-link\" [ngClass]=\"{mousedown:_isMouseDown}\">{{title}}<i class='anticon anticon-down' (click)=\"_isToggle = !_isToggle;_isMouseDown = !_isMouseDown;\" ></i></div>\n<ul class=\"menu ant-dropdown-menu  ant-dropdown-menu-container\" *ngIf=\"_isToggle\" >\n    <li class=\"ant-dropdown-menu-item\" *ngFor=\"let message of messages;let i = index;\">\n        <input class=\"ant-dropdown-input\" [(ngModel)]=\"message.title\" type=\"text\" [readonly]=\"message?._isFlag\" [ngClass]=\"{antfocusline:message?._isFocusLine,'color-change':message?.isDefault}\">\n        <p class=\"ant-dropdown-operate\">\n            <!-- <span *ngIf=\"_flagTouch_default\" class=\"anticon anticon-check \" (click)=\"defaultItem($event,i)\"></span> -->\n            <span class=\"anticon anticon-edit \" (click)=\"editItem($event,i)\"></span>\n            <span class=\"anticon anticon-save \"  (click)=\"reserveItem($event,i)\"></span>\n            <span class=\"anticon anticon-delete \" (click)=\"delItem($event,i)\"></span>\n        </p>  \n    </li>\n    <li class=\"ant-dropdown-menu-item\">\n        <input type=\"text\" placeholder=\"search message\" style=\"border:none;width:90px;margin-right:5px\" [(ngModel)]=\"addText\">\n        <i class=\"anticon anticon-file-add\" (click)=\"addItem()\"></i>\n    </li>\n</ul>\n\n<!-- _flagTouch_del = false;\n_flagTouch_add = false;\n_flagTouch_reserve = false;\n_flagTouch_default = false; -->",
                styles: [".ant-dropdown {\n  position: absolute;\n  left: -9999px;\n  top: -9999px;\n  z-index: 1050;\n  display: block;\n  font-size: 12px;\n  font-weight: normal;\n  line-height: 1.5;\n}\n.ant-dropdown-wrap {\n  position: relative;\n}\n.ant-dropdown-wrap .ant-btn > .anticon-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n:root .ant-dropdown-wrap .ant-btn > .anticon-down {\n  filter: none;\n}\n:root .ant-dropdown-wrap .ant-btn > .anticon-down {\n  font-size: 12px;\n}\n.ant-dropdown-wrap .anticon-down:before {\n  transition: transform 0.2s ease;\n}\n.ant-dropdown-wrap-open .anticon-down:before {\n  transform: rotate(180deg);\n}\n.ant-dropdown-hidden,\n.ant-dropdown-menu-hidden {\n  display: none;\n}\n.ant-dropdown-menu {\n  outline: none;\n  position: relative;\n  list-style-type: none;\n  padding: 0;\n  margin: 0;\n  text-align: left;\n  background-color: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  background-clip: padding-box;\n}\n.ant-dropdown-menu-item,\n.ant-dropdown-menu-submenu-title {\n  padding: 7px 8px;\n  margin: 0;\n  clear: both;\n  font-size: 12px;\n  font-weight: normal;\n  color: rgba(0, 0, 0, 0.65);\n  white-space: nowrap;\n  cursor: pointer;\n  transition: all .3s;\n}\n.ant-dropdown-menu-item > a,\n.ant-dropdown-menu-submenu-title > a {\n  color: rgba(0, 0, 0, 0.65);\n  display: block;\n  padding: 7px 8px;\n  margin: -7px -8px;\n  transition: all .3s;\n}\n.ant-dropdown-menu-item > a:focus,\n.ant-dropdown-menu-submenu-title > a:focus {\n  text-decoration: none;\n}\n.ant-dropdown-menu-item-selected,\n.ant-dropdown-menu-submenu-title-selected,\n.ant-dropdown-menu-item-selected > a,\n.ant-dropdown-menu-submenu-title-selected > a {\n  color: #108ee9;\n  background-color: #ecf6fd;\n}\n.ant-dropdown-menu-item:hover,\n.ant-dropdown-menu-submenu-title:hover {\n  background-color: #ecf6fd;\n}\n.ant-dropdown-menu-item-disabled,\n.ant-dropdown-menu-submenu-title-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-dropdown-menu-item-disabled:hover,\n.ant-dropdown-menu-submenu-title-disabled:hover {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n  cursor: not-allowed;\n}\n.ant-dropdown-menu-item:first-child,\n.ant-dropdown-menu-submenu-title:first-child,\n.ant-dropdown-menu-item:first-child > a,\n.ant-dropdown-menu-submenu-title:first-child > a {\n  border-radius: 4px 4px 0 0;\n}\n.ant-dropdown-menu-item:last-child,\n.ant-dropdown-menu-submenu-title:last-child,\n.ant-dropdown-menu-item:last-child > a,\n.ant-dropdown-menu-submenu-title:last-child > a {\n  border-radius: 0 0 4px 4px;\n}\n.ant-dropdown-menu-item:only-child,\n.ant-dropdown-menu-submenu-title:only-child,\n.ant-dropdown-menu-item:only-child > a,\n.ant-dropdown-menu-submenu-title:only-child > a {\n  border-radius: 4px;\n}\n.ant-dropdown-menu-item-divider,\n.ant-dropdown-menu-submenu-title-divider {\n  height: 1px;\n  overflow: hidden;\n  background-color: #e9e9e9;\n  line-height: 0;\n}\n.ant-dropdown-menu-submenu-title:after {\n  font-family: \"anticon\" !important;\n  position: absolute;\n  content: \"\\e61f\";\n  right: 8px;\n  color: rgba(0, 0, 0, 0.43);\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n:root .ant-dropdown-menu-submenu-title:after {\n  filter: none;\n}\n:root .ant-dropdown-menu-submenu-title:after {\n  font-size: 12px;\n}\n.ant-dropdown-menu-submenu-vertical {\n  position: relative;\n}\n.ant-dropdown-menu-submenu-vertical > .ant-dropdown-menu {\n  top: 0;\n  left: 100%;\n  position: absolute;\n  min-width: 100%;\n  margin-left: 4px;\n  transform-origin: 0 0;\n}\n.ant-dropdown-menu-submenu.ant-dropdown-menu-submenu-disabled .ant-dropdown-menu-submenu-title,\n.ant-dropdown-menu-submenu.ant-dropdown-menu-submenu-disabled .ant-dropdown-menu-submenu-title:after {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-dropdown-menu-submenu:first-child .ant-dropdown-menu-submenu-title {\n  border-radius: 4px 4px 0 0;\n}\n.ant-dropdown-menu-submenu:last-child .ant-dropdown-menu-submenu-title {\n  border-radius: 0 0 4px 4px;\n}\n.ant-dropdown.slide-down-enter.slide-down-enter-active.ant-dropdown-placement-bottomLeft,\n.ant-dropdown.slide-down-appear.slide-down-appear-active.ant-dropdown-placement-bottomLeft,\n.ant-dropdown.slide-down-enter.slide-down-enter-active.ant-dropdown-placement-bottomCenter,\n.ant-dropdown.slide-down-appear.slide-down-appear-active.ant-dropdown-placement-bottomCenter,\n.ant-dropdown.slide-down-enter.slide-down-enter-active.ant-dropdown-placement-bottomRight,\n.ant-dropdown.slide-down-appear.slide-down-appear-active.ant-dropdown-placement-bottomRight {\n  animation-name: antSlideUpIn;\n}\n.ant-dropdown.slide-up-enter.slide-up-enter-active.ant-dropdown-placement-topLeft,\n.ant-dropdown.slide-up-appear.slide-up-appear-active.ant-dropdown-placement-topLeft,\n.ant-dropdown.slide-up-enter.slide-up-enter-active.ant-dropdown-placement-topCenter,\n.ant-dropdown.slide-up-appear.slide-up-appear-active.ant-dropdown-placement-topCenter,\n.ant-dropdown.slide-up-enter.slide-up-enter-active.ant-dropdown-placement-topRight,\n.ant-dropdown.slide-up-appear.slide-up-appear-active.ant-dropdown-placement-topRight {\n  animation-name: antSlideDownIn;\n}\n.ant-dropdown.slide-down-leave.slide-down-leave-active.ant-dropdown-placement-bottomLeft,\n.ant-dropdown.slide-down-leave.slide-down-leave-active.ant-dropdown-placement-bottomCenter,\n.ant-dropdown.slide-down-leave.slide-down-leave-active.ant-dropdown-placement-bottomRight {\n  animation-name: antSlideUpOut;\n}\n.ant-dropdown.slide-up-leave.slide-up-leave-active.ant-dropdown-placement-topLeft,\n.ant-dropdown.slide-up-leave.slide-up-leave-active.ant-dropdown-placement-topCenter,\n.ant-dropdown.slide-up-leave.slide-up-leave-active.ant-dropdown-placement-topRight {\n  animation-name: antSlideDownOut;\n}\n.ant-dropdown-trigger .anticon-down,\n.ant-dropdown-link .anticon-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n:root .ant-dropdown-trigger .anticon-down,\n:root .ant-dropdown-link .anticon-down {\n  filter: none;\n}\n:root .ant-dropdown-trigger .anticon-down,\n:root .ant-dropdown-link .anticon-down {\n  font-size: 12px;\n}\n.ant-dropdown-button {\n  white-space: nowrap;\n}\n.ant-dropdown-button.ant-btn-group > .ant-btn:last-child:not(:first-child) {\n  padding-right: 8px;\n}\n.ant-dropdown-button .anticon-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n:root .ant-dropdown-button .anticon-down {\n  filter: none;\n}\n:root .ant-dropdown-button .anticon-down {\n  font-size: 12px;\n}\n.ant-dropdown-menu-dark,\n.ant-dropdown-menu-dark .ant-dropdown-menu {\n  background: #404040;\n}\n.ant-dropdown-menu-dark .ant-dropdown-menu-item,\n.ant-dropdown-menu-dark .ant-dropdown-menu-submenu-title,\n.ant-dropdown-menu-dark .ant-dropdown-menu-item > a {\n  color: rgba(255, 255, 255, 0.67);\n}\n.ant-dropdown-menu-dark .ant-dropdown-menu-item:after,\n.ant-dropdown-menu-dark .ant-dropdown-menu-submenu-title:after,\n.ant-dropdown-menu-dark .ant-dropdown-menu-item > a:after {\n  color: rgba(255, 255, 255, 0.67);\n}\n.ant-dropdown-menu-dark .ant-dropdown-menu-item:hover,\n.ant-dropdown-menu-dark .ant-dropdown-menu-submenu-title:hover,\n.ant-dropdown-menu-dark .ant-dropdown-menu-item > a:hover {\n  color: #fff;\n  background: transparent;\n}\n.ant-dropdown-menu-dark .ant-dropdown-menu-item-selected,\n.ant-dropdown-menu-dark .ant-dropdown-menu-item-selected:hover,\n.ant-dropdown-menu-dark .ant-dropdown-menu-item-selected > a {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-dropdown-menu-container {\n  overflow: hidden;\n  width: 150px;\n}\n.ant-dropdown-link {\n  color: #108ee9;\n  background: transparent;\n  text-decoration: none;\n  outline: none;\n  cursor: pointer;\n  transition: color .3s ease;\n}\n.ant-dropdown-link i {\n  margin-left: 5px;\n  box-sizing: border-box;\n  width: 20px;\n  height: 20px;\n}\n.ant-dropdown-input {\n  display: inline-block;\n  height: 20px;\n  width: 70px;\n  border: none;\n  background: transparent;\n}\n.ant-dropdown-operate {\n  display: inline-block;\n  position: absolute;\n  top: 1px;\n  right: 4px;\n  background: transparent;\n  padding: 7px 2px;\n}\n.ant-dropdown-menu-item {\n  position: relative;\n  width: 150px;\n}\n.mousedown {\n  color: blue;\n}\n.antfocusline {\n  border: 1px solid  #108ee9;\n}\n.color-change {\n  color: #108ee9;\n}\n"]
            },] },
];
/** @nocollapse */
DropDownComponent.ctorParameters = function () { return [
    { type: core.Renderer2, },
    { type: Http, },
    { type: DropDownService, },
]; };
DropDownComponent.propDecorators = {
    "options": [{ type: core.Input },],
    "searchMessage": [{ type: core.Input },],
    "uploadMessage": [{ type: core.Output },],
    "addMessage": [{ type: core.Output },],
    "delMessage": [{ type: core.Output },],
    "defaultMessage": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DropDownModule = (function () {
    function DropDownModule() {
    }
    return DropDownModule;
}());
DropDownModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule, forms.ReactiveFormsModule, forms.FormsModule, HttpModule],
                exports: [DropDownComponent],
                declarations: [DropDownComponent],
                providers: [DropDownService]
            },] },
];
/** @nocollapse */
DropDownModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var OffClickDirective = (function () {
    /**
     * @param {?} platformId
     */
    function OffClickDirective(platformId) {
        this.platformId = platformId;
    }
    /**
     * @return {?}
     */
    OffClickDirective.prototype.ngOnInit = function () {
        var _this = this;
        if (common.isPlatformBrowser(this.platformId)) {
            setTimeout(function () { document.addEventListener('click', _this.offClickHandler); }, 0);
        }
    };
    /**
     * @return {?}
     */
    OffClickDirective.prototype.ngOnDestroy = function () {
        if (common.isPlatformBrowser(this.platformId)) {
            document.removeEventListener('click', this.offClickHandler);
        }
    };
    return OffClickDirective;
}());
OffClickDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[off-click]'
            },] },
];
/** @nocollapse */
OffClickDirective.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] },] },
]; };
OffClickDirective.propDecorators = {
    "offClickHandler": [{ type: core.Input, args: ['off-click',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectableItem = (function () {
    /**
     * @param {?} id
     * @param {?} text
     * @param {?} py
     * @param {?} firstPy
     * @param {?} data
     * @param {?} svc
     */
    function SelectableItem(id, text, py, firstPy, data, svc) {
        this.id = id;
        this.text = text;
        this.py = py;
        this.firstPy = firstPy;
        this.data = data;
        this.svc = svc;
        this._selected = false;
        this.isOpen = false;
        this.matchFilter = true;
        this.isVisible = false;
    }
    Object.defineProperty(SelectableItem.prototype, "hasChild", {
        /**
         * @return {?}
         */
        get: function () {
            return this.children && this.children.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectableItem.prototype, "checked", {
        /**
         * @return {?}
         */
        get: function () {
            if (this.hasChild && this.svc.Configuration.allowMultiple) {
                if (this.children.every(function (child) { return child.selected; })) {
                    return true;
                }
                else if (this.children.every(function (child) { return child.selected === false; })) {
                    return this._selected;
                }
                return null;
            }
            return this._selected;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectableItem.prototype, "selected", {
        /**
         * @return {?}
         */
        get: function () {
            if (this.hasChild && this.svc.Configuration.allowMultiple) {
                if (this.children.some(function (child) { return child.selected; })) {
                    if (this.svc.Configuration.allowParentSelection) {
                        this._selected = false;
                    }
                    return true;
                }
                else if (this.children.every(function (child) { return child.selected === false; })) {
                    if (this.svc.Configuration.allowParentSelection) {
                        return this._selected;
                    }
                    else {
                        return this._selected = false;
                    }
                }
                return false;
            }
            else if (this.hasChild && this._selected === true) {
                for (var _i = 0, _b = this.children; _i < _b.length; _i++) {
                    var itm = _b[_i];
                    itm.selected = false;
                }
            }
            return this._selected;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this.hasChild) {
                // if (this.hasChild && !this.svc.Configuration.allowParentSelection) {
                if (value !== null) {
                    this.children.forEach(function (child) { return child.selected = value; });
                }
            }
            else {
                this._selected = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    return SelectableItem;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectOption = (function () {
    function SelectOption() {
        this.idProperty = 'id';
        this.textProperty = 'name';
        this.childProperty = null;
        this.allowMultiple = true;
        this.closeOnSelection = true;
        this.items = [];
        this.isOpen = false;
        this.filter = '';
        this.allowParentSelection = true;
    }
    /**
     * @return {?}
     */
    SelectOption.prototype.isHierarchy = function () {
        return this.childProperty && this.childProperty.trim().length > 0;
    };
    /**
     * @return {?}
     */
    SelectOption.prototype.displayCheckbox = function () {
        return this.allowMultiple && this.isHierarchy();
    };
    /**
     * @return {?}
     */
    SelectOption.prototype.isValid = function () {
        // Check id property value
        return this.idProperty && this.idProperty.trim().length > 0 &&
            // Check text property value
            this.textProperty && this.textProperty.trim().length > 0 &&
            // Check items value
            this.items && Array.isArray(this.items) && this.items.length > 0;
    };
    return SelectOption;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectService = (function () {
    /**
     * @param {?} ctp
     */
    function SelectService(ctp) {
        this.ctp = ctp;
        this.modelChanged$ = new Subject.Subject();
        this._options = new SelectOption();
    }
    /**
     * @return {?}
     */
    SelectService.prototype.close = function () {
        if (this.Configuration.isOpen) {
            this.setConfiguration(function (opt) { return opt.isOpen = false; }, false);
        }
    };
    /**
     * @return {?}
     */
    SelectService.prototype.open = function () {
        if (!this.Configuration.isOpen) {
            this.setConfiguration(function (opt) { return opt.isOpen = true; }, false);
        }
    };
    /**
     * @return {?}
     */
    SelectService.prototype.toggleOpen = function () {
        this.setConfiguration(function (opt) { return opt.isOpen = !opt.isOpen; }, false);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SelectService.prototype.setItems = function (value) {
        this.setConfiguration(function (opt) {
            opt.items = value;
            // opt.spells = spells;
        }, true);
    };
    /**
     * @return {?}
     */
    SelectService.prototype.getInternalItems = function () {
        return this._items;
    };
    /**
     * @param {?} values
     * @return {?}
     */
    SelectService.prototype.setSelection = function (values) {
        this.setConfiguration(function (opt) { return opt.model = values; }, true);
    };
    /**
     * @param {?} items
     * @param {?} destination
     * @return {?}
     */
    SelectService.prototype.setSelectedItemOrChild = function (items, destination) {
        for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
            var itm = items_1[_i];
            if (itm.hasChild) {
                if (itm.id === destination) {
                    itm.selected = true;
                }
                this.setSelectedItemOrChild(itm.children, destination);
            }
            else if (itm.id === destination) {
                itm.selected = true;
            }
        }
    };
    /**
     * @return {?}
     */
    SelectService.prototype.getSelection = function () {
        if (this.Configuration.allowMultiple) {
            return this.getInternalSelection().map(function (v) { return v.data; });
        }
        else {
            var /** @type {?} */ result = this.getInternalSelection();
            if (result && result.length > 0) {
                return result[0].data;
            }
        }
        return null;
    };
    /**
     * @return {?}
     */
    SelectService.prototype.getInternalSelection = function () {
        var /** @type {?} */ selectedItems = this.getSelectedItems(this._items);
        if (selectedItems && selectedItems.length > 0) {
            var /** @type {?} */ i = 0;
            var /** @type {?} */ max = this._options.maxVisibleItemCount ? this._options.maxVisibleItemCount : 0;
            for (var _i = 0, selectedItems_1 = selectedItems; _i < selectedItems_1.length; _i++) {
                var item = selectedItems_1[_i];
                item.isVisible =
                    // Max not reached or not max value
                    (i < max || max === 0) &&
                        // all my children are unselected
                        (!item.hasChild || item.children.every(function (child) { return child.selected === false; }));
                if (item.isVisible && max > 0) {
                    i++;
                }
            }
        }
        return selectedItems;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    SelectService.prototype.toggleItemSelection = function (item) {
        var _this = this;
        if (!this.Configuration.allowMultiple) {
            this.setAllUnselected(this._items);
        }
        item.selected = !item.selected;
        if (item.hasChild) {
            item.children.map(function (opt) {
                opt.selected = item.selected;
                // opt.isOpen = !opt.isOpen;
            });
        }
        this.setConfiguration(function (opt) { return opt.model = _this.getSelection(); }, false);
        if (this.Configuration.closeOnSelection) {
            this.setConfiguration(function (opt) { return opt.isOpen = false; }, false);
        }
    };
    /**
     * @param {?} items
     * @return {?}
     */
    SelectService.prototype.setAllUnselected = function (items) {
        for (var _i = 0, items_2 = items; _i < items_2.length; _i++) {
            var itm = items_2[_i];
            if (itm.hasChild) {
                itm.selected = false;
                this.setAllUnselected(itm.children);
            }
            else {
                itm.selected = false;
            }
        }
    };
    /**
     * @param {?} delegate
     * @param {?} processItems
     * @return {?}
     */
    SelectService.prototype.setConfiguration = function (delegate, processItems) {
        var /** @type {?} */ modelBck = this._options.model;
        delegate(this._options);
        if (this._options.isValid()) {
            this.reconfigure(processItems); // 设置！！！
        }
        // if model changed, raise event
        if (modelBck !== undefined && this._options.model !== modelBck) {
            this.modelChanged$.next(this._options.model);
        }
    };
    Object.defineProperty(SelectService.prototype, "Configuration", {
        /**
         * @return {?}
         */
        get: function () {
            return this._options;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} sources
     * @return {?}
     */
    SelectService.prototype.toSelectableItems = function (sources) {
        var _this = this;
        if (sources && Array.isArray(sources)) {
            var /** @type {?} */ i_2 = 1;
            return sources.map(function (srcItem) {
                var /** @type {?} */ item;
                if (srcItem[_this._options.idProperty] &&
                    srcItem[_this._options.idProperty] !== '' &&
                    srcItem[_this._options.textProperty]) {
                    var /** @type {?} */ py = _this.ctp.ConvertPinyin({ chinas: /** @type {?} */ (srcItem[_this._options.textProperty]) });
                    var /** @type {?} */ first = _this.ctp.ConvertPinyin({ chinas: /** @type {?} */ (srcItem[_this._options.textProperty]), first: true });
                    srcItem.py = py;
                    srcItem.first = first;
                    item = new SelectableItem((srcItem[_this._options.idProperty] || '').toString(), /** @type {?} */ (srcItem[_this._options.textProperty]), py, first, srcItem, _this);
                }
                else {
                    item = new SelectableItem(i_2.toString(), /** @type {?} */ (srcItem), /** @type {?} */ (srcItem), /** @type {?} */ (srcItem), srcItem, _this);
                    i_2++;
                }
                if (_this._options.isHierarchy()) {
                    item.children = _this.toSelectableItems(srcItem[_this._options.childProperty]);
                }
                return item;
            });
        }
        return [];
    };
    /**
     * 获取选中的项
     * @param {?} array
     * @return {?}
     */
    SelectService.prototype.getSelectedItems = function (array) {
        if (this.Configuration.isValid()) {
            // 验证是否符合选择标准
            var /** @type {?} */ res = [];
            for (var _i = 0, array_1 = array; _i < array_1.length; _i++) {
                var v = array_1[_i];
                if (v.hasChild && v.selected === true) {
                    // 如果当前父节点选中
                    // v.children.map(opt => opt.selected = true);
                    // res = [...res, v];
                    if (v.children.every(function (child) { return child.selected === false; })) {
                        // 当所有子节点都未选中时候
                        res = res.concat([v]);
                    }
                    else {
                        res = res.concat(this.getSelectedItems(v.children));
                    }
                }
                else if (v.hasChild) {
                    res = res.concat(this.getSelectedItems(v.children));
                }
                else if (v.selected === true) {
                    res = res.concat([v]);
                }
            }
            return res;
        }
        else {
            return [];
        }
    };
    /**
     * @param {?} processItems
     * @return {?}
     */
    SelectService.prototype.reconfigure = function (processItems) {
        var _this = this;
        if (this.Configuration.isValid()) {
            this.checkConfig();
            if (processItems) {
                this._items = this.toSelectableItems(this.Configuration.items);
            }
            var /** @type {?} */ model = this.getModel();
            var /** @type {?} */ select_1 = [];
            model.forEach(function (v) {
                select_1 = select_1.concat(_this.getItemForModel(v, _this._items));
            });
            select_1.forEach(function (v) { return v._selected = true; });
        }
    };
    /**
     * @return {?}
     */
    SelectService.prototype.checkConfig = function () {
        if (this.Configuration.allowMultiple && this.Configuration.closeOnSelection) {
            this.Configuration.closeOnSelection = false;
        }
        else if (!this.Configuration.allowMultiple && !this.Configuration.closeOnSelection) {
            this.Configuration.closeOnSelection = true;
        }
    };
    /**
     * @return {?}
     */
    SelectService.prototype.getModel = function () {
        if (!this.Configuration.model) {
            return [];
        }
        else if (!Array.isArray(this.Configuration.model)) {
            return [this.Configuration.model];
        }
        else {
            return this.Configuration.model;
        }
    };
    /**
     * @param {?} value
     * @param {?} array
     * @return {?}
     */
    SelectService.prototype.getItemForModel = function (value, array) {
        var /** @type {?} */ result = [];
        for (var _i = 0, array_2 = array; _i < array_2.length; _i++) {
            var v = array_2[_i];
            if (value) {
                if (typeof value !== 'object') {
                    if (v.data === value) {
                        result.push(v);
                    }
                }
                else {
                    if (value[this.Configuration.idProperty]) {
                        if (v.id === (value[this.Configuration.idProperty] || '').toString()) {
                            result.push(v);
                        }
                    }
                    if (this.Configuration.isHierarchy() && v.children && v.children.length > 0) {
                        result = result.concat(this.getItemForModel(value, v.children));
                    }
                }
            }
        }
        return result;
    };
    /**
     * @param {?} arr
     * @return {?}
     */
    SelectService.prototype.convertPy = function (arr) {
    };
    return SelectService;
}());
SelectService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
SelectService.ctorParameters = function () { return [
    { type: ChineseToPinyinService, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TreeSelectDefaultOptions = (function () {
    function TreeSelectDefaultOptions() {
    }
    return TreeSelectDefaultOptions;
}());
TreeSelectDefaultOptions.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
TreeSelectDefaultOptions.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable-next-line:no-empty
var noop$1 = function () { };
var CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    // tslint:disable-next-line:no-forward-ref
    useExisting: core.forwardRef(function () { return TreeSelectComponent; }),
    multi: true
};
var TreeSelectComponent = (function () {
    /**
     * @param {?} svc
     * @param {?} defaultOpts
     * @param {?} eleRef
     */
    function TreeSelectComponent(svc, defaultOpts, eleRef) {
        var _this = this;
        this.svc = svc;
        this.defaultOpts = defaultOpts;
        this.eleRef = eleRef;
        this.onTouchedCallback = noop$1;
        this.showMoreLink = false;
        this.moreLoaded = false;
        this.disabled = false;
        this.placeholder = '';
        this.filterPlaceholder = '请输入关键词';
        this.allowFilter = true;
        this.maxHeight = 300;
        this.width = 300;
        this.className = '';
        this._isOpen = false;
        this.onChangeCallback = noop$1;
        this.haveFocus = false;
        this.inputFocus = false;
        this.clickedOutside = this.clickedOutside.bind(this);
        this.svc.modelChanged$.subscribe(function (result) {
            _this.onChangeCallback(result);
        });
        this.maxVisibleItemCount = (defaultOpts.maxVisibleItemCount || 3);
        this.allowParentSelection = ((defaultOpts.allowParentSelection === undefined ||
            defaultOpts.allowParentSelection === null) ?
            true :
            defaultOpts.allowParentSelection);
        this.allowFilter = ((defaultOpts.allowFilter === undefined || defaultOpts.allowFilter === null) ?
            true :
            defaultOpts.allowFilter);
        this.filterPlaceholder = (defaultOpts.filterPlaceholder || '请输入关键词');
        this.idField = (defaultOpts.idField || 'id');
        this.textField = (defaultOpts.textField || 'id');
        this.childrenField = (defaultOpts.childrenField || '');
    }
    Object.defineProperty(TreeSelectComponent.prototype, "items", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setItems(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "idField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.idProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "textField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.textProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "allowParentSelection", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowParentSelection;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.allowParentSelection = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "childrenField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.childProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "multiple", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowMultiple;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.allowMultiple = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "maxVisibleItemCount", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.maxVisibleItemCount;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.maxVisibleItemCount = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "internalItems", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.getInternalItems() || [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "selection", {
        /**
         * @return {?}
         */
        get: function () {
            this.showMoreLink = (this.maxVisibleItemCount > 0 &&
                ((this.svc.getInternalSelection().length - this.maxVisibleItemCount) > 0));
            return this.svc.getInternalSelection();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectComponent.prototype, "filter", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.filter;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.filter = value; }, false);
            for (var _i = 0, _b = this.internalItems; _i < _b.length; _i++) {
                var item = _b[_i];
                this.ProcessMatchFilterTreeItem(item, this.svc.Configuration.filter);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectComponent.prototype.keyUp = function ($event) { };
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectComponent.prototype.toggle = function ($event) {
        $event.preventDefault();
        this.haveFocus = true;
        this.svc.toggleOpen();
    };
    /**
     * @param {?} $event
     * @param {?} item
     * @return {?}
     */
    TreeSelectComponent.prototype.removeItem = function ($event, item) {
        $event.stopPropagation();
        this.svc.toggleItemSelection(item);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectComponent.prototype.clearAll = function ($event) {
        $event.stopPropagation();
        this.svc.setConfiguration(function (opt) { return opt.model = []; }, true);
    };
    Object.defineProperty(TreeSelectComponent.prototype, "isOpen", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.isOpen;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectComponent.prototype.clickedOutside = function ($event) {
        if (!this.inputFocus) {
            if (!this.haveFocus && this.isOpen || this.haveFocus && !this.isOpen) {
                this.onTouched();
            }
            this.haveFocus = false;
        }
    };
    /**
     * @return {?}
     */
    TreeSelectComponent.prototype._style = function () {
        var /** @type {?} */ ro = this.eleRef.nativeElement.getBoundingClientRect();
        return {
            'width': ro.width + 'px',
            // 'left': ro.left + 'px',
            // 'top': ro.top + 'px',
            'max-height': this.maxHeight + 'px'
        };
    };
    /**
     * @return {?}
     */
    TreeSelectComponent.prototype.onTouched = function () {
        this.svc.close();
        this.onTouchedCallback();
    };
    /**
     * @return {?}
     */
    TreeSelectComponent.prototype.setInputFocus = function () {
        this.inputFocus = true;
    };
    /**
     * @return {?}
     */
    TreeSelectComponent.prototype.setInputFocusOut = function () {
        this.inputFocus = false;
    };
    /**
     * Write a new value to the element.
     *
     * \@memberof TreeSelectComponent
     * @param {?} value
     * @return {?}
     */
    TreeSelectComponent.prototype.writeValue = function (value) {
        this.svc.setSelection(value);
    };
    /**
     * Set the function to be called when the control receives a change event.
     *
     * @param {?} fn
     * @return {?}
     */
    TreeSelectComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    /**
     * Set the function to be called when the control receives a touch event.
     *
     * @param {?} fn
     * @return {?}
     */
    TreeSelectComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    /**
     * This function is called when the control status changes to or from "DISABLED".
     * Depending on the value, it will enable or disable the appropriate DOM element.
     *
     * @param {?} isDisabled
     * @return {?}
     */
    TreeSelectComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * This finction is called when user click on show more link.
     *
     * @param {?} $event
     * @return {?}
     */
    TreeSelectComponent.prototype.loadMore = function ($event) {
        $event.stopPropagation();
        this.moreLoaded = !this.moreLoaded;
    };
    /**
     * @return {?}
     */
    TreeSelectComponent.prototype.ngAfterContentChecked = function () {
        this._style();
    };
    /**
     * @param {?} tree
     * @param {?} filter
     * @return {?}
     */
    TreeSelectComponent.prototype.ProcessMatchFilterTreeItem = function (tree, filter) {
        var /** @type {?} */ result = false;
        if (tree && tree.children && tree.children.length > 0) {
            for (var _i = 0, _b = tree.children; _i < _b.length; _i++) {
                var child = _b[_i];
                result = this.ProcessMatchFilterTreeItem(child, filter) || result;
            }
        }
        tree.matchFilter = (tree.id.indexOf(filter) > -1 ||
            tree.text.indexOf(filter) > -1 ||
            tree.py.indexOf(filter) > -1 ||
            tree.firstPy.indexOf(filter) > -1 ||
            result);
        return tree.matchFilter;
    };
    return TreeSelectComponent;
}());
TreeSelectComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-tree-select',
                template: "<span class=\"ant-select ant-select-enabled\"\n  [class.ant-select-open]=\"isOpen\"\n  [class.ant-select-focused]=\"isOpen\" [ngStyle]=\"{'width': width + 'px'}\"\n  (blur)=\"onTouched()\" (keyup)=\"keyUp($event)\" [off-click]=\"clickedOutside\">\n<span class=\"ant-select-selection\"\n  [ngClass]=\"{'ant-select-selection--multiple': multiple === true, 'ant-select-selection--single': multiple === false}\"\n  (click)=\"toggle($event)\">\n  <ul class=\"ant-select-selection__rendered\" *ngIf=\"selection.length > 0 && selection.length > 1\">\n    <li *ngFor=\"let s of selection; let i=index\" class=\"ant-select-selection__choice\" title=\"{{s.text}}\" style=\"user-select: none;\">\n      <span class=\"ant-select-selection__choice__remove\" (click)=\"removeItem($event, s)\"></span>\n      <span class=\"ant-select-selection__choice__content\">{{s.text}}</span>\n    </li>\n  </ul>\n<span class=\"ant-select-selection__rendered\" *ngIf=\"selection.length > 0 && selection.length === 1\">\n    <span title=\"{{selection[0].text}}\" class=\"ant-select-selection-selected-value\">{{selection[0].text}}</span>\n</span>\n<span class=\"ant-select-selection__clear\" (click)=\"clearAll($event)\"></span>\n<span *ngIf=\"multiple === false\" class=\"ant-select-arrow\" style=\"outline: none;\"><b></b></span>\n<span *ngIf=\"selection.length <= 0\" class=\"ant-select-search__field__placeholder\">{{placeholder}}</span>\n</span>\n<div *ngIf=\"!disabled && isOpen && internalItems && internalItems.length > 0\"\n  class=\"ant-select-dropdown ant-select-tree-dropdown ant-select-dropdown--multiple ant-select-dropdown-placement-bottomLeft\"\n  [ngClass]=\"{'ant-select-dropdown-hidden': isOpen === false}\" style=\"overflow: auto;overflow-x:hidden\" [ngStyle]=\"_style()\">\n  <div>\n    <span class=\"ant-select-dropdown-search\" *ngIf=\"allowFilter\">\n      <span class=\"ant-select-search__field__wrap\">\n        <input value=\"\" class=\"ant-select-search__field\" role=\"textbox\"\n          [(ngModel)]=\"filter\" (click)=\"setInputFocus()\" (blur)=\"setInputFocusOut()\"\n          placeholder=\"{{filterPlaceholder}}\" [ngModelOptions]=\"{standalone: true}\" >\n      </span>\n    </span>\n    <ul class=\"ant-select-tree\" role=\"tree-node\" unselectable=\"true\">\n      <li *ngFor=\"let o of internalItems | itemPipe: filter\">\n        <ant-tree-select-item [item]=\"o\" (TouchedCallBack)=\"onTouchedCallback\"></ant-tree-select-item>\n      </li>\n    </ul>\n  </div>\n</div>\n</span>\n",
                providers: [CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR, SelectService, ChineseToPinyinService],
                styles: [".ant-select {\n  box-sizing: border-box;\n  display: inline-block;\n  position: relative;\n  color: rgba(0, 0, 0, 0.65);\n  font-size: 12px;\n}\n.ant-select > ul > li > a {\n  padding: 0;\n  background-color: #fff;\n}\n.ant-select-arrow {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  position: absolute;\n  top: 50%;\n  right: 8px;\n  line-height: 1;\n  margin-top: -6px;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 9px 9;\n  transform: scale(0.75) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n.ant-select-arrow:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-arrow {\n  filter: none;\n}\n:root .ant-select-arrow {\n  font-size: 12px;\n}\n.ant-select-arrow * {\n  display: none;\n}\n.ant-select-arrow:before {\n  content: \"\\e61d\";\n  transition: transform 0.2s ease;\n}\n.ant-select-selection {\n  outline: none;\n  user-select: none;\n  box-sizing: border-box;\n  display: block;\n  background-color: #fff;\n  border-radius: 4px;\n  border: 1px solid #d9d9d9;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection:hover {\n  border-color: #49a9ee;\n}\n.ant-select-focused .ant-select-selection,\n.ant-select-selection:focus,\n.ant-select-selection:active {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-selection__clear {\n  display: inline-block;\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: auto;\n  opacity: 0;\n  position: absolute;\n  right: 8px;\n  z-index: 1;\n  background: #fff;\n  top: 50%;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.25);\n  width: 12px;\n  height: 12px;\n  margin-top: -6px;\n  line-height: 12px;\n  cursor: pointer;\n  transition: color 0.3s ease, opacity 0.15s ease;\n}\n.ant-select-selection__clear:before {\n  display: block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e62e\";\n}\n.ant-select-selection__clear:hover {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-select-selection:hover .ant-select-selection__clear {\n  opacity: 1;\n}\n.ant-select-selection-selected-value {\n  float: left;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: 100%;\n  padding-right: 14px;\n}\n.ant-select-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-disabled .ant-select-selection {\n  background: #f7f7f7;\n  cursor: not-allowed;\n}\n.ant-select-disabled .ant-select-selection:hover,\n.ant-select-disabled .ant-select-selection:focus,\n.ant-select-disabled .ant-select-selection:active {\n  border-color: #d9d9d9;\n  box-shadow: none;\n}\n.ant-select-disabled .ant-select-selection__clear {\n  display: none;\n  visibility: hidden;\n  pointer-events: none;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice {\n  background: #eee;\n  color: #aaa;\n  padding-right: 10px;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  display: none;\n}\n.ant-select-selection--single {\n  height: 28px;\n  position: relative;\n  cursor: pointer;\n}\n.ant-select-selection__rendered {\n  display: block;\n  margin-left: 7px;\n  margin-right: 7px;\n  position: relative;\n  line-height: 26px;\n}\n.ant-select-selection__rendered:after {\n  content: '.';\n  visibility: hidden;\n  pointer-events: none;\n  display: inline-block;\n  width: 0;\n}\n.ant-select-lg .ant-select-selection--single {\n  height: 32px;\n}\n.ant-select-lg .ant-select-selection__rendered {\n  line-height: 30px;\n}\n.ant-select-lg .ant-select-selection--multiple {\n  min-height: 32px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 24px;\n  line-height: 24px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 16px;\n}\n.ant-select-sm .ant-select-selection--single {\n  height: 22px;\n}\n.ant-select-sm .ant-select-selection__rendered {\n  line-height: 20px;\n}\n.ant-select-sm .ant-select-selection--multiple {\n  min-height: 22px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 14px;\n  line-height: 14px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 11px;\n}\n.ant-select-disabled .ant-select-selection__choice__remove {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: default;\n}\n.ant-select-disabled .ant-select-selection__choice__remove:hover {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-search__field__wrap {\n  display: inline-block;\n  position: relative;\n}\n.ant-select-selection__placeholder,\n.ant-select-search__field__placeholder {\n  position: absolute;\n  top: 50%;\n  left: 0;\n  right: 9px;\n  color: rgba(0, 0, 0, 0.25);\n  line-height: 20px;\n  height: 20px;\n  max-width: 100%;\n  margin-top: -10px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: left;\n}\n.ant-select-search__field__placeholder {\n  left: 8px;\n}\n.ant-select-search--inline {\n  position: absolute;\n  height: 100%;\n  width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  float: left;\n  position: static;\n}\n.ant-select-search--inline .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-search--inline .ant-select-search__field {\n  border-width: 0;\n  font-size: 100%;\n  height: 100%;\n  width: 100%;\n  background: transparent;\n  outline: 0;\n  border-radius: 4px;\n}\n.ant-select-search--inline .ant-select-search__field__mirror {\n  position: absolute;\n  top: 0;\n  left: -9999px;\n  white-space: pre;\n  pointer-events: none;\n}\n.ant-select-search--inline > i {\n  float: right;\n}\n.ant-select-selection--multiple {\n  min-height: 28px;\n  cursor: text;\n  padding-bottom: 3px;\n  zoom: 1;\n}\n.ant-select-selection--multiple:before,\n.ant-select-selection--multiple:after {\n  content: \" \";\n  display: table;\n}\n.ant-select-selection--multiple:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  width: auto;\n  padding: 0;\n  max-width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline .ant-select-search__field {\n  max-width: 100%;\n  width: 0.75em;\n}\n.ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-left: 5px;\n  margin-bottom: -3px;\n  height: auto;\n}\n.ant-select-selection--multiple > ul > li,\n.ant-select-selection--multiple .ant-select-selection__rendered > ul > li {\n  margin-top: 3px;\n  height: 20px;\n  line-height: 20px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice {\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #f3f3f3;\n  border-radius: 4px;\n  cursor: default;\n  float: left;\n  margin-right: 4px;\n  max-width: 99%;\n  position: relative;\n  overflow: hidden;\n  transition: padding 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  padding: 0 20px 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__disabled {\n  padding: 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__content {\n  display: inline-block;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  max-width: 100%;\n  transition: margin 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  line-height: 1;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  color: rgba(0, 0, 0, 0.43);\n  line-height: inherit;\n  cursor: pointer;\n  font-weight: bold;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  position: absolute;\n  right: 4px;\n  padding: 0 0 0 8px;\n  top: 0;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  filter: none;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-size: 12px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:hover {\n  color: #404040;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  content: \"\\e633\";\n}\n.ant-select-selection--multiple .ant-select-selection__clear {\n  top: 14px;\n}\n.ant-select-allow-clear .ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-open .ant-select-arrow {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2)\";\n  -ms-transform: rotate(180deg);\n}\n.ant-select-open .ant-select-arrow:before {\n  transform: rotate(180deg);\n}\n.ant-select-open .ant-select-selection {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-combobox .ant-select-arrow {\n  display: none;\n}\n.ant-select-combobox .ant-select-search--inline {\n  height: 100%;\n  width: 100%;\n  float: none;\n}\n.ant-select-combobox .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-combobox .ant-select-search__field {\n  width: 100%;\n  height: 100%;\n  position: relative;\n  z-index: 1;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  box-shadow: none;\n}\n.ant-select-combobox.ant-select-allow-clear .ant-select-selection:hover .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-dropdown {\n  background-color: #fff;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  border-radius: 4px;\n  box-sizing: border-box;\n  z-index: 1050;\n  left: -9999px;\n  top: -9999px;\n  position: absolute;\n  outline: none;\n  overflow: hidden;\n  font-size: 12px;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-bottomLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpIn;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-topLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownIn;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpOut;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownOut;\n}\n.ant-select-dropdown-hidden {\n  display: none;\n}\n.ant-select-dropdown-menu {\n  outline: none;\n  margin-bottom: 0;\n  padding-left: 0;\n  list-style: none;\n  max-height: 250px;\n  overflow: auto;\n}\n.ant-select-dropdown-menu-item-group-list {\n  margin: 0;\n  padding: 0;\n}\n.ant-select-dropdown-menu-item-group-list > .ant-select-dropdown-menu-item {\n  padding-left: 16px;\n}\n.ant-select-dropdown-menu-item-group-title {\n  color: rgba(0, 0, 0, 0.43);\n  line-height: 1.5;\n  padding: 8px;\n}\n.ant-select-dropdown-menu-item {\n  position: relative;\n  display: block;\n  padding: 7px 8px;\n  font-weight: normal;\n  color: rgba(0, 0, 0, 0.65);\n  white-space: nowrap;\n  cursor: pointer;\n  overflow: hidden;\n  transition: background 0.3s ease;\n}\n.ant-select-dropdown-menu-item:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-active {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-disabled:hover {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-selected,\n.ant-select-dropdown-menu-item-selected:hover {\n  background-color: #f7f7f7;\n  font-weight: bold;\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-select-dropdown-menu-item-divider {\n  height: 1px;\n  margin: 1px 0;\n  overflow: hidden;\n  background-color: #e5e5e5;\n  line-height: 0;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e632\";\n  color: transparent;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  transition: all 0.2s ease;\n  position: absolute;\n  top: 50%;\n  transform: translateY(-50%);\n  right: 8px;\n  font-weight: bold;\n  text-shadow: 0 0.1px 0, 0.1px 0 0, 0 -0.1px 0, -0.1px 0;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  filter: none;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-size: 12px;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:hover:after {\n  color: #ddd;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-disabled:after {\n  display: none;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:after,\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:hover:after {\n  color: #108ee9;\n  display: inline-block;\n}\n.ant-select-dropdown-container-open .ant-select-dropdown,\n.ant-select-dropdown-open .ant-select-dropdown {\n  display: block;\n}\n/***/\nnz-select .ant-select {\n  width: 100%;\n}\n.ant-select-dropdown {\n  top: 100%;\n  left: 0;\n  position: relative;\n  width: 100%;\n  margin-top: 4px;\n  margin-bottom: 4px;\n}\n.ant-select-dropdown.ant-select-dropdown-placement-topLeft {\n  top: -100%;\n  transform: translateY(-100%) !important;\n}\n.ant-select-dropdown-menu-item {\n  line-height: 1.5;\n}\n.nz-overlay-pane {\n  position: absolute;\n}\n.ant-select-page {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  font-size: 12px;\n  line-height: 2em;\n  padding: 5px;\n  user-select: none;\n  text-align: center;\n  background-color: #f9f9f9;\n  border-top: 1px solid #ddd;\n}\n.ant-select-page-less,\n.ant-select-page-next {\n  color: #333;\n  cursor: pointer;\n}\n.ant-select-page-disabled {\n  color: #999!important;\n  cursor: not-allowed !important;\n}\n.ant-select-search {\n  background-color: #fff;\n  padding: 4px;\n  position: relative;\n}\n.ant-select-search-input {\n  width: 100%;\n  height: 30px;\n  padding: 0 8px;\n  border: 1px solid #eee;\n}\n.ant-select-search-input:focus {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-search-anticon {\n  position: absolute;\n  right: 13px;\n  top: 11px;\n  font-size: 15px;\n  font-weight: 600;\n  color: #999;\n  cursor: pointer;\n  height: 53%;\n}\n.ant-select-loading {\n  position: absolute;\n  left: 5px;\n  top: -1px;\n}\n.nz-overlay-contain {\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  position: fixed;\n  z-index: 1000;\n}\n.ant-select-dropdown {\n  position: absolute!important;\n  top: auto;\n  left: auto;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u9AD8\u5BBD\u53CA\u80CC\u666F \u9AD8\u5BBD\u5206\u522B\u5BF9\u5E94\u6A2A\u7AD6\u6EDA\u52A8\u6761\u7684\u5C3A\u5BF8*/\n::-webkit-scrollbar {\n  width: 8px;\n  height: 8px;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u8F68\u9053 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-track {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n}\n/*\u5B9A\u4E49\u6ED1\u5757 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-thumb {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n  background-color: #d7d7d7;\n}\n@keyframes antCheckboxEffect {\n  0% {\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  100% {\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n.ant-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-checkbox-wrapper:hover .ant-checkbox-inner,\n.ant-checkbox:hover .ant-checkbox-inner,\n.ant-checkbox-input:focus + .ant-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-checkbox:hover:after,\n.ant-checkbox-wrapper:hover .ant-checkbox:after {\n  visibility: visible;\n}\n.ant-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-checkbox-indeterminate .ant-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-checkbox-indeterminate.ant-checkbox-disabled .ant-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-checked .ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-checkbox-checked .ant-checkbox-inner,\n.ant-checkbox-indeterminate .ant-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled.ant-checkbox-checked .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-disabled .ant-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled .ant-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-checkbox-disabled .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-checkbox-wrapper + span,\n.ant-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-checkbox-group {\n  font-size: 12px;\n}\n.ant-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-checkbox-checked .ant-checkbox-inner:before,\n  .ant-checkbox-checked .ant-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-tree-checkbox-wrapper:hover .ant-tree-checkbox-inner,\n.ant-tree-checkbox:hover .ant-tree-checkbox-inner,\n.ant-tree-checkbox-input:focus + .ant-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-tree-checkbox:hover:after,\n.ant-tree-checkbox-wrapper:hover .ant-tree-checkbox:after {\n  visibility: visible;\n}\n.ant-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-tree-checkbox-indeterminate .ant-tree-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-tree-checkbox-indeterminate.ant-tree-checkbox-disabled .ant-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-tree-checkbox-checked .ant-tree-checkbox-inner,\n.ant-tree-checkbox-indeterminate .ant-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-disabled.ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-tree-checkbox-wrapper + span,\n.ant-tree-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-tree-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-tree-checkbox-checked .ant-tree-checkbox-inner:before,\n  .ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-tree {\n  margin: 0;\n  padding: 0;\n  font-size: 12px;\n}\n.ant-tree li {\n  padding: 4px 0;\n  margin: 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-tree li span[draggable],\n.ant-tree li span[draggable=\"true\"] {\n  user-select: none;\n  border-top: 2px transparent solid;\n  border-bottom: 2px transparent solid;\n  margin-top: -2px;\n  /* Required to make elements draggable in old WebKit */\n  -khtml-user-drag: element;\n  -webkit-user-drag: element;\n}\n.ant-tree li.drag-over > span[draggable] {\n  background-color: #108ee9;\n  color: white;\n  opacity: 0.8;\n}\n.ant-tree li.drag-over-gap-top > span[draggable] {\n  border-top-color: #108ee9;\n}\n.ant-tree li.drag-over-gap-bottom > span[draggable] {\n  border-bottom-color: #108ee9;\n}\n.ant-tree li.filter-node > span {\n  color: #f04134 !important;\n  font-weight: 500 !important;\n}\n.ant-tree li ul {\n  margin: 0;\n  padding: 0 0 0 18px;\n}\n.ant-tree li .ant-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  vertical-align: top;\n  color: rgba(0, 0, 0, 0.65);\n  transition: all 0.3s ease;\n}\n.ant-tree li .ant-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-tree li .ant-tree-node-content-wrapper.ant-tree-node-selected {\n  background-color: #d2eafb;\n}\n.ant-tree li span.ant-tree-checkbox {\n  margin: 0 4px 0 2px;\n  vertical-align: middle;\n}\n.ant-tree li span.ant-tree-switcher,\n.ant-tree li span.ant-tree-iconEle {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 24px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\n.ant-tree li span.ant-tree-icon_loading:after {\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e6ae\";\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher-noop {\n  cursor: default;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  transform: rotate(270deg) scale(0.59);\n}\n.ant-tree li:last-child > span.ant-tree-switcher:before,\n.ant-tree li:last-child > span.ant-tree-iconEle:before {\n  display: none;\n}\n.ant-tree > li:first-child {\n  padding-top: 7px;\n}\n.ant-tree > li:last-child {\n  padding-bottom: 7px;\n}\n.ant-tree-child-tree {\n  display: none;\n}\n.ant-tree-child-tree-open {\n  display: block;\n}\nli.ant-tree-treenode-disabled > span,\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper,\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper span,\nli.ant-tree-treenode-disabled > span.ant-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-tree-icon__close {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-tree.ant-tree-show-line li {\n  position: relative;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher {\n  background: #fff;\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e664\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e621\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e645\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li:not(:last-child):before {\n  content: ' ';\n  width: 1px;\n  border-left: 1px solid #d9d9d9;\n  height: 100%;\n  position: absolute;\n  left: 12px;\n  margin: 18px 0;\n}\n.ant-select-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-input:focus + .ant-select-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-select-tree-checkbox:hover:after,\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox:after {\n  visibility: visible;\n}\n.ant-select-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-select-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-select-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-select-tree-checkbox-indeterminate.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-select-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-select-tree-checkbox-wrapper + span,\n.ant-select-tree-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-select-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-select-tree-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:before,\n  .ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-select-tree {\n  margin: 0;\n  padding: 0 4px;\n  margin-top: -4px;\n  font-size: 12px;\n}\n.ant-select-tree li {\n  padding: 0;\n  margin: 8px 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-select-tree li.filter-node > span {\n  font-weight: 500;\n}\n.ant-select-tree li ul {\n  margin: 0;\n  padding: 0 0 0 18px;\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  color: rgba(0, 0, 0, 0.65);\n  transition: all .3s;\n  width: calc(100% - 24px);\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper.ant-select-tree-node-selected {\n  background-color: #d2eafb;\n}\n.ant-select-tree li span.ant-select-tree-checkbox {\n  margin: 0 4px 0 0;\n}\n.ant-select-tree li span.ant-select-tree-checkbox + .ant-select-tree-node-content-wrapper {\n  width: calc(100% - 46px);\n}\n.ant-select-tree li span.ant-select-tree-switcher,\n.ant-select-tree li span.ant-select-tree-iconEle {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 22px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\n.ant-select-tree li span.ant-select-tree-icon_loading:after {\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e6ae\";\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher-noop {\n  cursor: auto;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  transform: rotate(270deg) scale(0.59);\n}\n.ant-select-tree-child-tree {\n  display: none;\n}\n.ant-select-tree-child-tree-open {\n  display: block;\n}\nli.ant-select-tree-treenode-disabled > span,\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper,\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper span,\nli.ant-select-tree-treenode-disabled > span.ant-select-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-select-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-select-tree-icon__close {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search {\n  display: block;\n  padding: 4px;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search .ant-select-search__field__wrap {\n  width: 100%;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search .ant-select-search__field {\n  padding: 4px 7px;\n  width: 100%;\n  box-sizing: border-box;\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n  outline: none;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search.ant-select-search--hide {\n  display: none;\n}\n.ant-select-tree-dropdown .ant-select-not-found {\n  cursor: not-allowed;\n  color: rgba(0, 0, 0, 0.25);\n  padding: 7px 16px;\n  display: block;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u9AD8\u5BBD\u53CA\u80CC\u666F \u9AD8\u5BBD\u5206\u522B\u5BF9\u5E94\u6A2A\u7AD6\u6EDA\u52A8\u6761\u7684\u5C3A\u5BF8*/\n::-webkit-scrollbar {\n  width: 8px;\n  height: 8px;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u8F68\u9053 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-track {\n  background-color: #f5f5f5;\n}\n/*\u5B9A\u4E49\u6ED1\u5757 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-thumb {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n  background-color: #d7d7d7;\n}\n"]
            },] },
];
/** @nocollapse */
TreeSelectComponent.ctorParameters = function () { return [
    { type: SelectService, },
    { type: TreeSelectDefaultOptions, },
    { type: core.ElementRef, },
]; };
TreeSelectComponent.propDecorators = {
    "disabled": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "filterPlaceholder": [{ type: core.Input },],
    "allowFilter": [{ type: core.Input },],
    "maxHeight": [{ type: core.Input },],
    "width": [{ type: core.Input },],
    "className": [{ type: core.Input },],
    "items": [{ type: core.Input },],
    "idField": [{ type: core.Input },],
    "textField": [{ type: core.Input },],
    "allowParentSelection": [{ type: core.Input },],
    "childrenField": [{ type: core.Input },],
    "multiple": [{ type: core.Input },],
    "maxVisibleItemCount": [{ type: core.Input },],
    "onTouched": [{ type: core.HostListener, args: ['blur',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var noop$2 = function () { };
var TreeSelectItemComponent = (function () {
    /**
     * @param {?} svc
     */
    function TreeSelectItemComponent(svc) {
        this.svc = svc;
        this.TouchedCallBack = noop$2;
    }
    Object.defineProperty(TreeSelectItemComponent.prototype, "isOpen", {
        /**
         * @return {?}
         */
        get: function () {
            return this.item.isOpen;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectItemComponent.prototype.toggleOpen = function ($event) {
        $event.stopPropagation();
        if (this.haveChildren) {
            this.item.isOpen = !this.item.isOpen;
        }
        else {
            this.select($event);
        }
    };
    Object.defineProperty(TreeSelectItemComponent.prototype, "allowParentSelection", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowParentSelection;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectItemComponent.prototype, "needCheckBox", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.isHierarchy() && this.svc.Configuration.allowMultiple;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeSelectItemComponent.prototype, "haveChildren", {
        /**
         * @return {?}
         */
        get: function () {
            return this.item && this.item.children && this.item.children.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    TreeSelectItemComponent.prototype.select = function ($event) {
        $event.stopPropagation();
        if (this.svc.Configuration.allowMultiple ||
            this.svc.Configuration.allowParentSelection ||
            !this.haveChildren) {
            this.svc.toggleItemSelection(this.item);
        }
        // this.TouchedCallBack();
    };
    Object.defineProperty(TreeSelectItemComponent.prototype, "filter", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.filter;
        },
        enumerable: true,
        configurable: true
    });
    return TreeSelectItemComponent;
}());
TreeSelectItemComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-tree-select-item',
                template: "<span *ngIf=\"!haveChildren\" class=\"ant-select-tree-switcher ant-select-tree-switcher-noop\"></span>\n<span *ngIf=\"haveChildren\" class=\"ant-select-tree-switcher\" (click)=\"toggleOpen($event)\"\n  [class.ant-select-tree-switcher-open]=\"isOpen\"\n  [class.ant-select-tree-switcher-close]=\"!isOpen\"></span>\n<span *ngIf=\"needCheckBox\" class=\"ant-select-tree-checkbox\"\n  [class.ant-select-tree-checkbox-indeterminate]=\"item.checked === null\"\n  [class.ant-select-tree-checkbox-checked]=\"item.checked === true\" (click)=\"select($event)\">\n    <span class=\"ant-select-tree-checkbox-inner\"></span>\n</span>\n<span\n    title=\"{{item.text}}\" class=\"ant-select-tree-node-content-wrapper\"\n    [class.ant-select-tree-node-content-wrapper-open]=\"isOpen===true\"\n    [class.ant-select-tree-node-selected]=\"item.selected\"\n    (click)=\"toggleOpen($event)\">\n    <span class=\"ant-select-tree-title\">{{item.text}}</span>\n</span>\n<ul class=\"ant-select-tree-child-tree\" \n  [class.ant-select-tree-child-tree-open]=\"isOpen===true\"\n  [class.ant-select-tree-child-tree-close]=\"isOpen===false\">\n  <li *ngFor=\"let o of item.children | itemPipe: filter\">\n      <ant-tree-select-item [item]=\"o\" (TouchedCallback)=\"TouchedCallback\"></ant-tree-select-item>\n  </li>\n</ul>\n",
                styles: [".ant-select-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-select-tree-checkbox-input:focus + .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox:hover .ant-select-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: \"\";\n  -webkit-animation: antCheckboxEffect 0.36s ease-in-out;\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  -webkit-animation-fill-mode: both;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox:after,\n.ant-select-tree-checkbox:hover:after {\n  visibility: visible;\n}\n.ant-select-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  -webkit-transition: all .3s;\n  transition: all 0.3s;\n}\n.ant-select-tree-checkbox-inner:after {\n  -webkit-transform: rotate(45deg) scale(0);\n  -ms-transform: rotate(45deg) scale(0);\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: \" \";\n  -webkit-transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-select-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner:after {\n  content: \" \";\n  -webkit-transform: scale(1);\n  -ms-transform: scale(1);\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-select-tree-checkbox-indeterminate.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  -webkit-transform: rotate(45deg) scale(1);\n  -ms-transform: rotate(45deg) scale(1);\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: \" \";\n  -webkit-transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  -webkit-animation-name: none;\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner {\n  border-color: #d9d9d9!important;\n  background-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  -webkit-animation-name: none;\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-select-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-select-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-select-tree-checkbox-group-item {\n  display: inline-block;\n}\nli {\n  padding: 0;\n  margin: 5px 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-select-tree li.filter-node > span {\n  font-weight: 500;\n}\nul {\n  margin: 0;\n  padding: 0 0 0 18px;\n}\n.ant-select-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  color: rgba(0, 0, 0, 0.65);\n  -webkit-transition: all .3s;\n  transition: all .3s;\n  width: calc(90%);\n}\n.ant-select-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-tree-node-content-wrapper.ant-select-tree-node-selected {\n  background-color: #d2eafb;\n}\nspan.ant-select-tree-checkbox {\n  margin: 0 4px 0 0;\n}\nspan.ant-select-tree-checkbox + .ant-select-tree-node-content-wrapper {\n  width: calc(50%);\n}\nspan.ant-select-tree-iconEle,\nspan.ant-select-tree-switcher {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 22px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\nspan.ant-select-tree-icon_loading:after {\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E6AE\";\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-noop {\n  cursor: auto;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-open:after {\n  font-size: 12px;\n  font-size: 7px9;\n  -webkit-transform: scale(0.58333333) rotate(0deg);\n  -ms-transform: scale(0.58333333) rotate(0deg);\n  transform: scale(0.58333333) rotate(0deg);\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E606\";\n  font-weight: 700;\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform .3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-open:after {\n  -webkit-filter: none;\n  filter: none;\n  font-size: 12px;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  font-size: 12px;\n  font-size: 7px9;\n  -webkit-transform: scale(0.58333333) rotate(0deg);\n  -ms-transform: scale(0.58333333) rotate(0deg);\n  transform: scale(0.58333333) rotate(0deg);\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E606\";\n  font-weight: 700;\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform .3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  -webkit-transform: rotate(270deg) scale(0.59);\n  -ms-transform: rotate(270deg) scale(0.59);\n  transform: rotate(270deg) scale(0.59);\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  -webkit-filter: none;\n  filter: none;\n  font-size: 12px;\n}\n.ant-select-tree-child-tree {\n  display: none;\n}\n.ant-select-tree-child-tree-open {\n  display: block;\n}\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper,\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper span,\n.ant-select-tree-treenode-disabled > span,\n.ant-select-tree-treenode-disabled > span.ant-select-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-select-tree-icon__close,\n.ant-select-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\n@-webkit-keyframes antCheckboxEffect {\n  0% {\n    -webkit-transform: scale(1);\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  to {\n    -webkit-transform: scale(1.6);\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n@keyframes antCheckboxEffect {\n  0% {\n    -webkit-transform: scale(1);\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  to {\n    -webkit-transform: scale(1.6);\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n"]
            },] },
];
/** @nocollapse */
TreeSelectItemComponent.ctorParameters = function () { return [
    { type: SelectService, },
]; };
TreeSelectItemComponent.propDecorators = {
    "TouchedCallBack": [{ type: core.Input },],
    "item": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ItemPipe = (function () {
    function ItemPipe() {
    }
    /**
     * @param {?} value
     * @param {...?} arg
     * @return {?}
     */
    ItemPipe.prototype.transform = function (value) {
        var arg = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            arg[_i - 1] = arguments[_i];
        }
        // ES6 array destructuring
        var /** @type {?} */ ret = value.filter(function (item) { return item.matchFilter; });
        if (arg.toString() !== '' && ret.length > 0) {
            ret.map(function (opt) { return opt.isOpen = true; });
        }
        else {
            ret.map(function (opt) { return opt.isOpen = false; });
        }
        return ret;
    };
    return ItemPipe;
}());
ItemPipe.decorators = [
    { type: core.Pipe, args: [{ name: 'itemPipe' },] },
];
/** @nocollapse */
ItemPipe.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$3 = [TreeSelectComponent, TreeSelectItemComponent];
var TreeSelectModule = (function () {
    function TreeSelectModule() {
    }
    /**
     * @param {?} options
     * @return {?}
     */
    TreeSelectModule.forRoot = function (options) {
        return {
            ngModule: TreeSelectModule,
            providers: [
                { provide: TreeSelectDefaultOptions, useValue: options }
            ]
        };
    };
    return TreeSelectModule;
}());
TreeSelectModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: COMPONENTS$3.concat([OffClickDirective, ItemPipe]),
                imports: [common.CommonModule, forms.FormsModule],
                exports: COMPONENTS$3.slice(),
                entryComponents: COMPONENTS$3.slice(),
                providers: [TreeSelectDefaultOptions],
                schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
            },] },
];
/** @nocollapse */
TreeSelectModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectableItem$1 = (function () {
    /**
     * @param {?} id
     * @param {?} text
     * @param {?} py
     * @param {?} firstPy
     * @param {?} data
     * @param {?} svc
     */
    function SelectableItem$1(id, text, py, firstPy, data, svc) {
        this.id = id;
        this.text = text;
        this.py = py;
        this.firstPy = firstPy;
        this.data = data;
        this.svc = svc;
        this._selected = false;
        this.isOpen = false;
        this.matchFilter = true;
        this.isVisible = false;
    }
    Object.defineProperty(SelectableItem$1.prototype, "hasChild", {
        /**
         * @return {?}
         */
        get: function () {
            return this.children && this.children.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectableItem$1.prototype, "checked", {
        /**
         * @return {?}
         */
        get: function () {
            if (this.hasChild && this.svc.Configuration.allowMultiple) {
                if (this.children.every(function (child) { return child.selected; })) {
                    return true;
                }
                else if (this.children.every(function (child) { return child.selected === false; })) {
                    return this._selected;
                }
                return null;
            }
            return this._selected;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectableItem$1.prototype, "selected", {
        /**
         * @return {?}
         */
        get: function () {
            if (this.hasChild && this.svc.Configuration.allowMultiple) {
                if (this.children.some(function (child) { return child.selected; })) {
                    if (this.svc.Configuration.allowParentSelection) {
                        this._selected = false;
                    }
                    return true;
                }
                else if (this.children.every(function (child) { return child.selected === false; })) {
                    if (this.svc.Configuration.allowParentSelection) {
                        return this._selected;
                    }
                    else {
                        return this._selected = false;
                    }
                }
                return false;
            }
            else if (this.hasChild && this._selected === true) {
                for (var _i = 0, _b = this.children; _i < _b.length; _i++) {
                    var itm = _b[_i];
                    itm.selected = false;
                }
            }
            return this._selected;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this.hasChild) {
                // if (this.hasChild && !this.svc.Configuration.allowParentSelection) {
                if (value !== null) {
                    this.children.forEach(function (child) { return child.selected = value; });
                }
            }
            else {
                this._selected = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    return SelectableItem$1;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectOption$1 = (function () {
    function SelectOption$1() {
        this.idProperty = 'id';
        this.textProperty = 'name';
        this.childProperty = null;
        this.allowMultiple = true;
        this.closeOnSelection = true;
        this.items = [];
        this.isOpen = false;
        this.filter = '';
        this.allowParentSelection = true;
    }
    /**
     * @return {?}
     */
    SelectOption$1.prototype.isHierarchy = function () {
        return this.childProperty && this.childProperty.trim().length > 0;
    };
    /**
     * @return {?}
     */
    SelectOption$1.prototype.displayCheckbox = function () {
        return this.allowMultiple && this.isHierarchy();
    };
    /**
     * @return {?}
     */
    SelectOption$1.prototype.isValid = function () {
        // Check id property value
        return this.idProperty && this.idProperty.trim().length > 0 &&
            // Check text property value
            this.textProperty && this.textProperty.trim().length > 0 &&
            // Check items value
            this.items && Array.isArray(this.items) && this.items.length > 0;
    };
    return SelectOption$1;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectService$1 = (function () {
    /**
     * @param {?} ctp
     */
    function SelectService$1(ctp) {
        this.ctp = ctp;
        this.modelChanged$ = new Subject.Subject();
        this._options = new SelectOption$1();
    }
    /**
     * @return {?}
     */
    SelectService$1.prototype.close = function () {
        if (this.Configuration.isOpen) {
            this.setConfiguration(function (opt) { return opt.isOpen = false; }, false);
        }
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.open = function () {
        if (!this.Configuration.isOpen) {
            this.setConfiguration(function (opt) { return opt.isOpen = true; }, false);
        }
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.toggleOpen = function () {
        this.setConfiguration(function (opt) { return opt.isOpen = !opt.isOpen; }, false);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SelectService$1.prototype.setItems = function (value) {
        this.setConfiguration(function (opt) {
            opt.items = value;
            // opt.spells = spells;
        }, true);
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.getInternalItems = function () {
        return this._items;
    };
    /**
     * @param {?} values
     * @return {?}
     */
    SelectService$1.prototype.setSelection = function (values) {
        this.setConfiguration(function (opt) { return opt.model = values; }, true);
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.getSelection = function () {
        if (this.Configuration.allowMultiple) {
            return this.getInternalSelection().map(function (v) { return v.data; });
        }
        else {
            var /** @type {?} */ result = this.getInternalSelection();
            if (result && result.length > 0) {
                return result[0].data;
            }
        }
        return null;
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.getInternalSelection = function () {
        var /** @type {?} */ selectedItems = this.getSelectedItems(this._items);
        if (selectedItems && selectedItems.length > 0) {
            var /** @type {?} */ i = 0;
            var /** @type {?} */ max = this._options.maxVisibleItemCount ? this._options.maxVisibleItemCount : 0;
            for (var _i = 0, selectedItems_2 = selectedItems; _i < selectedItems_2.length; _i++) {
                var item = selectedItems_2[_i];
                item.isVisible =
                    // Max not reached or not max value
                    (i < max || max === 0) &&
                        // all my children are unselected
                        (!item.hasChild || item.children.every(function (child) { return child.selected === false; }));
                if (item.isVisible && max > 0) {
                    i++;
                }
            }
        }
        return selectedItems;
    };
    /**
     * @param {?} item
     * @return {?}
     */
    SelectService$1.prototype.toggleItemSelection = function (item) {
        var _this = this;
        if (!this.Configuration.allowMultiple) {
            this.setAllUnselected(this._items);
        }
        item.selected = !item.selected;
        if (item.hasChild) {
            item.children.map(function (opt) {
                opt.selected = item.selected;
                // opt.isOpen = !opt.isOpen;
            });
        }
        this.setConfiguration(function (opt) { return opt.model = _this.getSelection(); }, false);
        if (this.Configuration.closeOnSelection) {
            this.setConfiguration(function (opt) { return opt.isOpen = false; }, false);
        }
    };
    /**
     * @param {?} items
     * @return {?}
     */
    SelectService$1.prototype.setAllUnselected = function (items) {
        for (var _i = 0, items_3 = items; _i < items_3.length; _i++) {
            var itm = items_3[_i];
            if (itm.hasChild) {
                itm.selected = false;
                this.setAllUnselected(itm.children);
            }
            else {
                itm.selected = false;
            }
        }
    };
    /**
     * @param {?} delegate
     * @param {?} processItems
     * @return {?}
     */
    SelectService$1.prototype.setConfiguration = function (delegate, processItems) {
        var /** @type {?} */ modelBck = this._options.model;
        delegate(this._options);
        if (this._options.isValid()) {
            this.reconfigure(processItems); // 设置！！！
        }
        // if model changed, raise event
        if (modelBck !== undefined && this._options.model !== modelBck) {
            this.modelChanged$.next(this._options.model);
        }
    };
    Object.defineProperty(SelectService$1.prototype, "Configuration", {
        /**
         * @return {?}
         */
        get: function () {
            return this._options;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} sources
     * @return {?}
     */
    SelectService$1.prototype.toSelectableItems = function (sources) {
        var _this = this;
        if (sources && Array.isArray(sources)) {
            var /** @type {?} */ i_3 = 1;
            return sources.map(function (srcItem) {
                var /** @type {?} */ item;
                if (srcItem[_this._options.idProperty] &&
                    srcItem[_this._options.idProperty] !== '' &&
                    srcItem[_this._options.textProperty]) {
                    var /** @type {?} */ py = _this.ctp.ConvertPinyin({ chinas: /** @type {?} */ (srcItem[_this._options.textProperty]) });
                    var /** @type {?} */ first = _this.ctp.ConvertPinyin({ chinas: /** @type {?} */ (srcItem[_this._options.textProperty]), first: true });
                    srcItem.py = py;
                    srcItem.first = first;
                    item = new SelectableItem$1((srcItem[_this._options.idProperty] || '').toString(), /** @type {?} */ (srcItem[_this._options.textProperty]), py, first, srcItem, _this);
                }
                else {
                    item = new SelectableItem$1(i_3.toString(), /** @type {?} */ (srcItem), /** @type {?} */ (srcItem), /** @type {?} */ (srcItem), srcItem, _this);
                    i_3++;
                }
                if (_this._options.isHierarchy()) {
                    item.children = _this.toSelectableItems(srcItem[_this._options.childProperty]);
                }
                return item;
            });
        }
        return [];
    };
    /**
     * 获取选中的项
     * @param {?} array
     * @return {?}
     */
    SelectService$1.prototype.getSelectedItems = function (array) {
        if (this.Configuration.isValid()) {
            // 验证是否符合选择标准
            var /** @type {?} */ res = [];
            for (var _i = 0, array_3 = array; _i < array_3.length; _i++) {
                var v = array_3[_i];
                if (v.hasChild && v.selected === true) {
                    // 如果当前父节点选中
                    // v.children.map(opt => opt.selected = true);
                    // res = [...res, v];
                    if (v.children.every(function (child) { return child.selected === false; })) {
                        // 当所有子节点都未选中时候
                        res = res.concat([v]);
                    }
                    else {
                        res = res.concat(this.getSelectedItems(v.children));
                    }
                }
                else if (v.hasChild) {
                    res = res.concat(this.getSelectedItems(v.children));
                }
                else if (v.selected === true) {
                    res = res.concat([v]);
                }
            }
            return res;
        }
        else {
            return [];
        }
    };
    /**
     * @param {?} processItems
     * @return {?}
     */
    SelectService$1.prototype.reconfigure = function (processItems) {
        var _this = this;
        if (this.Configuration.isValid()) {
            this.checkConfig();
            if (processItems) {
                this._items = this.toSelectableItems(this.Configuration.items);
            }
            var /** @type {?} */ model = this.getModel();
            var /** @type {?} */ select_2 = [];
            model.forEach(function (v) {
                select_2 = select_2.concat(_this.getItemForModel(v, _this._items));
            });
            select_2.forEach(function (v) { return v._selected = true; });
        }
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.checkConfig = function () {
        if (this.Configuration.allowMultiple && this.Configuration.closeOnSelection) {
            this.Configuration.closeOnSelection = false;
        }
        else if (!this.Configuration.allowMultiple && !this.Configuration.closeOnSelection) {
            this.Configuration.closeOnSelection = true;
        }
    };
    /**
     * @return {?}
     */
    SelectService$1.prototype.getModel = function () {
        if (!this.Configuration.model) {
            return [];
        }
        else if (!Array.isArray(this.Configuration.model)) {
            return [this.Configuration.model];
        }
        else {
            return this.Configuration.model;
        }
    };
    /**
     * @param {?} value
     * @param {?} array
     * @return {?}
     */
    SelectService$1.prototype.getItemForModel = function (value, array) {
        var /** @type {?} */ result = [];
        for (var _i = 0, array_4 = array; _i < array_4.length; _i++) {
            var v = array_4[_i];
            if (value) {
                if (typeof value !== 'object') {
                    if (v.data === value) {
                        result.push(v);
                    }
                }
                else {
                    if (value[this.Configuration.idProperty]) {
                        if (v.id === (value[this.Configuration.idProperty] || '').toString()) {
                            result.push(v);
                        }
                    }
                    if (this.Configuration.isHierarchy() && v.children && v.children.length > 0) {
                        result = result.concat(this.getItemForModel(value, v.children));
                    }
                }
            }
        }
        return result;
    };
    return SelectService$1;
}());
SelectService$1.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
SelectService$1.ctorParameters = function () { return [
    { type: ChineseToPinyinService, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SelectBoxDefaultOptions = (function () {
    function SelectBoxDefaultOptions() {
        this.allowFilter = true;
        this.filterPlaceholder = '请输入关键字';
        this.maxVisibleItemCount = 3;
        this.allowParentSelection = true;
        this.idField = 'id';
        this.textField = 'name';
        this.childrenField = 'children';
    }
    return SelectBoxDefaultOptions;
}());
SelectBoxDefaultOptions.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
SelectBoxDefaultOptions.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// tslint:disable-next-line:no-empty
var noop$3 = function () { };
var CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR$1 = {
    provide: forms.NG_VALUE_ACCESSOR,
    // tslint:disable-next-line:no-forward-ref
    useExisting: core.forwardRef(function () { return SelectBoxComponent; }),
    multi: true
};
var SelectBoxComponent = (function () {
    /**
     * @param {?} svc
     * @param {?} defaultOpts
     * @param {?} eleRef
     */
    function SelectBoxComponent(svc, defaultOpts, eleRef) {
        var _this = this;
        this.svc = svc;
        this.defaultOpts = defaultOpts;
        this.eleRef = eleRef;
        this.onTouchedCallback = noop$3;
        this.showMoreLink = false;
        this.moreLoaded = false;
        this.disabled = false;
        this.placeholder = '';
        this.filterPlaceholder = '请输入关键词';
        this.allowFilter = true;
        this.maxHeight = 300;
        this.width = 300;
        this.span = 6;
        this._isOpen = false;
        this.selectionCount = 0;
        this.onChangeCallback = noop$3;
        this.haveFocus = false;
        this.inputFocus = false;
        this.clickedOutside = this.clickedOutside.bind(this);
        this.svc.modelChanged$.subscribe(function (result) {
            _this.onChangeCallback(result);
        });
        this.maxVisibleItemCount = (defaultOpts.maxVisibleItemCount || 3);
        this.allowParentSelection = ((defaultOpts.allowParentSelection === undefined ||
            defaultOpts.allowParentSelection === null) ?
            true :
            defaultOpts.allowParentSelection);
        this.allowFilter = ((defaultOpts.allowFilter === undefined || defaultOpts.allowFilter === null) ?
            true :
            defaultOpts.allowFilter);
        this.filterPlaceholder = (defaultOpts.filterPlaceholder || '请输入关键词');
        this.idField = (defaultOpts.idField || 'id');
        this.textField = (defaultOpts.textField || 'id');
        this.childrenField = (defaultOpts.childrenField || '');
    }
    Object.defineProperty(SelectBoxComponent.prototype, "items", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setItems(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "idField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.idProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "textField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.textProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "allowParentSelection", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowParentSelection;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.allowParentSelection = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "childrenField", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.childProperty = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "multiple", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowMultiple;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.allowMultiple = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "maxVisibleItemCount", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.maxVisibleItemCount;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.maxVisibleItemCount = value; }, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "isOpen", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.isOpen;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (!value || value === undefined) {
                return;
            }
            this._isOpen = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "internalItems", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.getInternalItems() || [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "selection", {
        /**
         * @return {?}
         */
        get: function () {
            var /** @type {?} */ selection = this.svc.getInternalSelection();
            this.showMoreLink = (this.maxVisibleItemCount > 0 &&
                ((selection.length - this.maxVisibleItemCount) > 0));
            this.selectionCount = selection.length;
            return selection;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxComponent.prototype, "filter", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.filter;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.svc.setConfiguration(function (opt) { return opt.filter = value; }, false);
            for (var _i = 0, _b = this.internalItems; _i < _b.length; _i++) {
                var item = _b[_i];
                this.ProcessMatchFilterTreeItem(item, this.svc.Configuration.filter);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxComponent.prototype.keyUp = function ($event) { };
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxComponent.prototype.toggle = function ($event) {
        $event.preventDefault();
        this.haveFocus = true;
        this.svc.toggleOpen();
    };
    /**
     * @param {?} $event
     * @param {?} item
     * @return {?}
     */
    SelectBoxComponent.prototype.removeItem = function ($event, item) {
        $event.stopPropagation();
        this.svc.toggleItemSelection(item);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxComponent.prototype.clearAll = function ($event) {
        $event.stopPropagation();
        this.svc.setConfiguration(function (opt) { return opt.model = []; }, true);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxComponent.prototype.clickedOutside = function ($event) {
        if (!this.inputFocus) {
            if (!this.haveFocus && this.isOpen || this.haveFocus && !this.isOpen) {
                this.onTouched();
            }
            this.haveFocus = false;
        }
    };
    /**
     * @return {?}
     */
    SelectBoxComponent.prototype._style = function () {
        var /** @type {?} */ ro = this.eleRef.nativeElement.getBoundingClientRect();
        return {
            'width': '600px',
            // 'left': ro.left + 'px',
            // 'top': ro.top + ro.height + 'px',
            'max-width': '700px',
            'max-height': this.maxHeight + 'px'
        };
    };
    /**
     * @return {?}
     */
    SelectBoxComponent.prototype.onTouched = function () {
        this.svc.close();
        this.onTouchedCallback();
    };
    /**
     * @return {?}
     */
    SelectBoxComponent.prototype.setInputFocus = function () {
        this.inputFocus = true;
    };
    /**
     * @return {?}
     */
    SelectBoxComponent.prototype.setInputFocusOut = function () {
        this.inputFocus = false;
    };
    /**
     * Write a new value to the element.
     * @param {?} value
     * @return {?}
     */
    SelectBoxComponent.prototype.writeValue = function (value) {
        this.svc.setSelection(value);
    };
    /**
     * Set the function to be called when the control receives a change event.
     *
     * @param {?} fn
     * @return {?}
     */
    SelectBoxComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    /**
     * Set the function to be called when the control receives a touch event.
     *
     * @param {?} fn
     * @return {?}
     */
    SelectBoxComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    /**
     * This function is called when the control status changes to or from "DISABLED".
     * Depending on the value, it will enable or disable the appropriate DOM element.
     *
     * @param {?} isDisabled
     * @return {?}
     */
    SelectBoxComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * This finction is called when user click on show more link.
     *
     * @param {?} $event
     * @return {?}
     */
    SelectBoxComponent.prototype.loadMore = function ($event) {
        $event.stopPropagation();
        this.moreLoaded = !this.moreLoaded;
    };
    /**
     * @return {?}
     */
    SelectBoxComponent.prototype.ngAfterContentChecked = function () {
        this._style();
    };
    /**
     * @param {?} tree
     * @param {?} filter
     * @return {?}
     */
    SelectBoxComponent.prototype.ProcessMatchFilterTreeItem = function (tree, filter) {
        var /** @type {?} */ result = false;
        if (tree && tree.children && tree.children.length > 0) {
            for (var _i = 0, _b = tree.children; _i < _b.length; _i++) {
                var child = _b[_i];
                result = this.ProcessMatchFilterTreeItem(child, filter) || result;
            }
        }
        tree.matchFilter = (tree.id.indexOf(filter) > -1 ||
            tree.text.indexOf(filter) > -1 ||
            tree.py.indexOf(filter) > -1 ||
            tree.firstPy.indexOf(filter) > -1 ||
            result);
        return tree.matchFilter;
    };
    return SelectBoxComponent;
}());
SelectBoxComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-select-box',
                template: "<span class=\"ant-select ant-select-enabled\"\n[class.ant-select-open]=\"isOpen\"\n[class.ant-select-focused]=\"isOpen\" [ngStyle]=\"{'width': width + 'px'}\"\n(blur)=\"onTouched()\" (keyup)=\"keyUp($event)\" [off-click]=\"clickedOutside\">\n<span class=\"ant-select-selection ant-select-selection--multiple\"\n(click)=\"toggle($event)\">\n  <span class=\"ant-select-selection__rendered1\">\n    <span *ngFor=\"let s of selection; let idx=index\">\n      <span *ngIf=\"moreLoaded || maxVisibleItemCount == 0 || idx<maxVisibleItemCount\"\n        class=\"ant-select-selection__choice1\" title=\"{{s.text}}\">\n        <span class=\"ant-select-selection__choice__remove\" (click)=\"removeItem($event, s)\"></span>\n        <span class=\"ant-select-selection__choice__content\">{{s.text}}</span>\n      </span>\n  </span>\n</span>\n<span class=\"more-items-icon\" (click)=\"loadMore($event)\" *ngIf=\"showMoreLink\">({{selectionCount}}\u9879)</span>\n<span *ngIf=\"selection.length <= 0\" class=\"ant-select-search__field__placeholder\">{{placeholder}}</span>\n</span>\n<div *ngIf=\"!disabled && isOpen && internalItems && internalItems.length > 0\"\nclass=\"ant-select-dropdown ant-select-tree-dropdown ant-select-dropdown--multiple ant-select-dropdown-placement-bottomLeft\"\n[ngClass]=\"{'ant-select-dropdown-hidden': isOpen === false}\" style=\"overflow: auto;overflow-x:hidden;padding-bottom: 10px;\" [ngStyle]=\"_style()\">\n<div>\n  <span class=\"ant-select-dropdown-search\" *ngIf=\"allowFilter\">\n    <span class=\"ant-select-search__field__wrap\">\n      <input value=\"\" class=\"ant-select-search__field\" role=\"textbox\"\n        [(ngModel)]=\"filter\" (click)=\"setInputFocus()\" (blur)=\"setInputFocusOut()\"\n        placeholder=\"{{filterPlaceholder}}\" [ngModelOptions]=\"{standalone: true}\">\n        <ant-button type=\"default\">\n          <span (click)=\"clearAll($event)\">\u6E05\u7A7A</span>\n        </ant-button>\n    </span>\n  </span>\n  <ul class=\"ant-select-tree\" role=\"tree-node\" unselectable=\"true\">\n    <li *ngFor=\"let o of internalItems | itemPipe: filter\">\n      <ant-select-box-item [item]=\"o\" [span]=\"span\" [isOpen]=\"_isOpen\" (TouchedCallBack)=\"onTouchedCallback\"></ant-select-box-item>\n    </li>\n  </ul>\n</div>\n</div>\n</span>\n",
                providers: [CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR$1, SelectService$1, ChineseToPinyinService],
                styles: [".ant-select {\n  box-sizing: border-box;\n  display: inline-block;\n  position: relative;\n  color: rgba(0, 0, 0, 0.65);\n  font-size: 12px;\n}\n.ant-select > ul > li > a {\n  padding: 0;\n  background-color: #fff;\n}\n.ant-select-arrow {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  position: absolute;\n  top: 50%;\n  right: 8px;\n  line-height: 1;\n  margin-top: -6px;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 9px 9;\n  transform: scale(0.75) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n}\n.ant-select-arrow:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-arrow {\n  filter: none;\n}\n:root .ant-select-arrow {\n  font-size: 12px;\n}\n.ant-select-arrow * {\n  display: none;\n}\n.ant-select-arrow:before {\n  content: \"\\e61d\";\n  transition: transform 0.2s ease;\n}\n.ant-select-selection {\n  outline: none;\n  user-select: none;\n  box-sizing: border-box;\n  display: block;\n  background-color: #fff;\n  border-radius: 4px;\n  border: 1px solid #d9d9d9;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection:hover {\n  border-color: #49a9ee;\n}\n.ant-select-focused .ant-select-selection,\n.ant-select-selection:focus,\n.ant-select-selection:active {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-selection__clear {\n  display: inline-block;\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  text-rendering: auto;\n  opacity: 0;\n  position: absolute;\n  right: 8px;\n  z-index: 1;\n  background: #fff;\n  top: 50%;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.25);\n  width: 12px;\n  height: 12px;\n  margin-top: -6px;\n  line-height: 12px;\n  cursor: pointer;\n  transition: color 0.3s ease, opacity 0.15s ease;\n}\n.ant-select-selection__clear:before {\n  display: block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e62e\";\n}\n.ant-select-selection__clear:hover {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-select-selection:hover .ant-select-selection__clear {\n  opacity: 1;\n}\n.ant-select-selection-selected-value {\n  float: left;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: 100%;\n  padding-right: 14px;\n}\n.ant-select-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-disabled .ant-select-selection {\n  background: #f7f7f7;\n  cursor: not-allowed;\n}\n.ant-select-disabled .ant-select-selection:hover,\n.ant-select-disabled .ant-select-selection:focus,\n.ant-select-disabled .ant-select-selection:active {\n  border-color: #d9d9d9;\n  box-shadow: none;\n}\n.ant-select-disabled .ant-select-selection__clear {\n  display: none;\n  visibility: hidden;\n  pointer-events: none;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice {\n  background: #eee;\n  color: #aaa;\n  padding-right: 10px;\n}\n.ant-select-disabled .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  display: none;\n}\n.ant-select-selection--single {\n  height: 28px;\n  position: relative;\n  cursor: pointer;\n}\n.ant-select-selection__rendered {\n  display: block;\n  margin-left: 7px;\n  margin-right: 7px;\n  position: relative;\n  line-height: 26px;\n}\n.ant-select-selection__rendered:after {\n  content: '.';\n  visibility: hidden;\n  pointer-events: none;\n  display: inline-block;\n  width: 0;\n}\n.ant-select-lg .ant-select-selection--single {\n  height: 32px;\n}\n.ant-select-lg .ant-select-selection__rendered {\n  line-height: 30px;\n}\n.ant-select-lg .ant-select-selection--multiple {\n  min-height: 32px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 24px;\n  line-height: 24px;\n}\n.ant-select-lg .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 16px;\n}\n.ant-select-sm .ant-select-selection--single {\n  height: 22px;\n}\n.ant-select-sm .ant-select-selection__rendered {\n  line-height: 20px;\n}\n.ant-select-sm .ant-select-selection--multiple {\n  min-height: 22px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__rendered li {\n  height: 14px;\n  line-height: 14px;\n}\n.ant-select-sm .ant-select-selection--multiple .ant-select-selection__clear {\n  top: 11px;\n}\n.ant-select-disabled .ant-select-selection__choice__remove {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: default;\n}\n.ant-select-disabled .ant-select-selection__choice__remove:hover {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-search__field__wrap {\n  display: inline-block;\n  position: relative;\n}\n.ant-select-selection__placeholder,\n.ant-select-search__field__placeholder {\n  position: absolute;\n  top: 50%;\n  left: 0;\n  right: 9px;\n  color: rgba(0, 0, 0, 0.25);\n  line-height: 20px;\n  height: 20px;\n  max-width: 100%;\n  margin-top: -10px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  text-align: left;\n}\n.ant-select-search__field__placeholder {\n  left: 8px;\n}\n.ant-select-search--inline {\n  position: absolute;\n  height: 100%;\n  width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  float: left;\n  position: static;\n}\n.ant-select-search--inline .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-search--inline .ant-select-search__field {\n  border-width: 0;\n  font-size: 100%;\n  height: 100%;\n  width: 100%;\n  background: transparent;\n  outline: 0;\n  border-radius: 4px;\n}\n.ant-select-search--inline .ant-select-search__field__mirror {\n  position: absolute;\n  top: 0;\n  left: -9999px;\n  white-space: pre;\n  pointer-events: none;\n}\n.ant-select-search--inline > i {\n  float: right;\n}\n.ant-select-selection--multiple {\n  min-height: 28px;\n  cursor: text;\n  padding-bottom: 3px;\n  zoom: 1;\n}\n.ant-select-selection--multiple:before,\n.ant-select-selection--multiple:after {\n  content: \" \";\n  display: table;\n}\n.ant-select-selection--multiple:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-select-selection--multiple .ant-select-search--inline {\n  width: auto;\n  padding: 0;\n  max-width: 100%;\n}\n.ant-select-selection--multiple .ant-select-search--inline .ant-select-search__field {\n  max-width: 100%;\n  width: 0.75em;\n}\n.ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-left: 5px;\n  margin-bottom: -3px;\n  height: auto;\n}\n.ant-select-selection--multiple > ul > li,\n.ant-select-selection--multiple .ant-select-selection__rendered > ul > li {\n  margin-top: 3px;\n  height: 20px;\n  line-height: 20px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice {\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #f3f3f3;\n  border-radius: 4px;\n  cursor: default;\n  float: left;\n  margin-right: 4px;\n  max-width: 99%;\n  position: relative;\n  overflow: hidden;\n  transition: padding 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  padding: 0 20px 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__disabled {\n  padding: 0 10px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__content {\n  display: inline-block;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  max-width: 100%;\n  transition: margin 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-style: normal;\n  vertical-align: baseline;\n  text-align: center;\n  text-transform: none;\n  line-height: 1;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  color: rgba(0, 0, 0, 0.43);\n  line-height: inherit;\n  cursor: pointer;\n  font-weight: bold;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  position: absolute;\n  right: 4px;\n  padding: 0 0 0 8px;\n  top: 0;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  display: block;\n  font-family: \"anticon\" !important;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  filter: none;\n}\n:root .ant-select-selection--multiple .ant-select-selection__choice__remove {\n  font-size: 12px;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:hover {\n  color: #404040;\n}\n.ant-select-selection--multiple .ant-select-selection__choice__remove:before {\n  content: \"\\e633\";\n}\n.ant-select-selection--multiple .ant-select-selection__clear {\n  top: 14px;\n}\n.ant-select-allow-clear .ant-select-selection--multiple .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-open .ant-select-arrow {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=2)\";\n  -ms-transform: rotate(180deg);\n}\n.ant-select-open .ant-select-arrow:before {\n  transform: rotate(180deg);\n}\n.ant-select-open .ant-select-selection {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-combobox .ant-select-arrow {\n  display: none;\n}\n.ant-select-combobox .ant-select-search--inline {\n  height: 100%;\n  width: 100%;\n  float: none;\n}\n.ant-select-combobox .ant-select-search__field__wrap {\n  width: 100%;\n  height: 100%;\n}\n.ant-select-combobox .ant-select-search__field {\n  width: 100%;\n  height: 100%;\n  position: relative;\n  z-index: 1;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  box-shadow: none;\n}\n.ant-select-combobox.ant-select-allow-clear .ant-select-selection:hover .ant-select-selection__rendered {\n  margin-right: 20px;\n}\n.ant-select-dropdown {\n  background-color: #fff;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  border-radius: 4px;\n  box-sizing: border-box;\n  z-index: 1050;\n  left: -9999px;\n  top: -9999px;\n  position: absolute;\n  outline: none;\n  overflow: hidden;\n  font-size: 12px;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-bottomLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpIn;\n}\n.ant-select-dropdown.slide-up-enter.slide-up-enter-active.ant-select-dropdown-placement-topLeft,\n.ant-select-dropdown.slide-up-appear.slide-up-appear-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownIn;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-bottomLeft {\n  animation-name: antSlideUpOut;\n}\n.ant-select-dropdown.slide-up-leave.slide-up-leave-active.ant-select-dropdown-placement-topLeft {\n  animation-name: antSlideDownOut;\n}\n.ant-select-dropdown-hidden {\n  display: none;\n}\n.ant-select-dropdown-menu {\n  outline: none;\n  margin-bottom: 0;\n  padding-left: 0;\n  list-style: none;\n  max-height: 250px;\n  overflow: auto;\n}\n.ant-select-dropdown-menu-item-group-list {\n  margin: 0;\n  padding: 0;\n}\n.ant-select-dropdown-menu-item-group-list > .ant-select-dropdown-menu-item {\n  padding-left: 16px;\n}\n.ant-select-dropdown-menu-item-group-title {\n  color: rgba(0, 0, 0, 0.43);\n  line-height: 1.5;\n  padding: 8px;\n}\n.ant-select-dropdown-menu-item {\n  position: relative;\n  display: block;\n  padding: 7px 8px;\n  font-weight: normal;\n  color: rgba(0, 0, 0, 0.65);\n  white-space: nowrap;\n  cursor: pointer;\n  overflow: hidden;\n  transition: background 0.3s ease;\n}\n.ant-select-dropdown-menu-item:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-active {\n  background-color: #ecf6fd;\n}\n.ant-select-dropdown-menu-item-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-disabled:hover {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n  cursor: not-allowed;\n}\n.ant-select-dropdown-menu-item-selected,\n.ant-select-dropdown-menu-item-selected:hover {\n  background-color: #f7f7f7;\n  font-weight: bold;\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-select-dropdown-menu-item-divider {\n  height: 1px;\n  margin: 1px 0;\n  overflow: hidden;\n  background-color: #e5e5e5;\n  line-height: 0;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e632\";\n  color: transparent;\n  display: inline-block;\n  font-size: 12px;\n  font-size: 10px 9;\n  transform: scale(0.83333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  transition: all 0.2s ease;\n  position: absolute;\n  top: 50%;\n  transform: translateY(-50%);\n  right: 8px;\n  font-weight: bold;\n  text-shadow: 0 0.1px 0, 0.1px 0 0, 0 -0.1px 0, -0.1px 0;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  filter: none;\n}\n:root .ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:after {\n  font-size: 12px;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item:hover:after {\n  color: #ddd;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-disabled:after {\n  display: none;\n}\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:after,\n.ant-select-dropdown.ant-select-dropdown--multiple .ant-select-dropdown-menu-item-selected:hover:after {\n  color: #108ee9;\n  display: inline-block;\n}\n.ant-select-dropdown-container-open .ant-select-dropdown,\n.ant-select-dropdown-open .ant-select-dropdown {\n  display: block;\n}\n/***/\nnz-select .ant-select {\n  width: 100%;\n}\n.ant-select-dropdown {\n  top: 100%;\n  left: 0;\n  position: relative;\n  width: 100%;\n  margin-top: 4px;\n  margin-bottom: 4px;\n}\n.ant-select-dropdown.ant-select-dropdown-placement-topLeft {\n  top: -100%;\n  transform: translateY(-100%) !important;\n}\n.ant-select-dropdown-menu-item {\n  line-height: 1.5;\n}\n.nz-overlay-pane {\n  position: absolute;\n}\n.ant-select-page {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  font-size: 12px;\n  line-height: 2em;\n  padding: 5px;\n  user-select: none;\n  text-align: center;\n  background-color: #f9f9f9;\n  border-top: 1px solid #ddd;\n}\n.ant-select-page-less,\n.ant-select-page-next {\n  color: #333;\n  cursor: pointer;\n}\n.ant-select-page-disabled {\n  color: #999!important;\n  cursor: not-allowed !important;\n}\n.ant-select-search {\n  background-color: #fff;\n  padding: 4px;\n  position: relative;\n}\n.ant-select-search-input {\n  width: 100%;\n  height: 30px;\n  padding: 0 8px;\n  border: 1px solid #eee;\n}\n.ant-select-search-input:focus {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-select-search-anticon {\n  position: absolute;\n  right: 13px;\n  top: 11px;\n  font-size: 15px;\n  font-weight: 600;\n  color: #999;\n  cursor: pointer;\n  height: 53%;\n}\n.ant-select-loading {\n  position: absolute;\n  left: 5px;\n  top: -1px;\n}\n.nz-overlay-contain {\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100%;\n  position: fixed;\n  z-index: 1000;\n}\n.ant-select-dropdown {\n  position: absolute!important;\n  top: auto;\n  left: auto;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u9AD8\u5BBD\u53CA\u80CC\u666F \u9AD8\u5BBD\u5206\u522B\u5BF9\u5E94\u6A2A\u7AD6\u6EDA\u52A8\u6761\u7684\u5C3A\u5BF8*/\n::-webkit-scrollbar {\n  width: 8px;\n  height: 8px;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u8F68\u9053 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-track {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n}\n/*\u5B9A\u4E49\u6ED1\u5757 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-thumb {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n  background-color: #d7d7d7;\n}\n@keyframes antCheckboxEffect {\n  0% {\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  100% {\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n.ant-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-checkbox-wrapper:hover .ant-checkbox-inner,\n.ant-checkbox:hover .ant-checkbox-inner,\n.ant-checkbox-input:focus + .ant-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-checkbox:hover:after,\n.ant-checkbox-wrapper:hover .ant-checkbox:after {\n  visibility: visible;\n}\n.ant-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-checkbox-indeterminate .ant-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-checkbox-indeterminate.ant-checkbox-disabled .ant-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-checked .ant-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-checkbox-checked .ant-checkbox-inner,\n.ant-checkbox-indeterminate .ant-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled.ant-checkbox-checked .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-checkbox-disabled .ant-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-checkbox-disabled .ant-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-checkbox-disabled .ant-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-checkbox-wrapper + span,\n.ant-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-checkbox-group {\n  font-size: 12px;\n}\n.ant-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-checkbox-checked .ant-checkbox-inner:before,\n  .ant-checkbox-checked .ant-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-tree-checkbox-wrapper:hover .ant-tree-checkbox-inner,\n.ant-tree-checkbox:hover .ant-tree-checkbox-inner,\n.ant-tree-checkbox-input:focus + .ant-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-tree-checkbox:hover:after,\n.ant-tree-checkbox-wrapper:hover .ant-tree-checkbox:after {\n  visibility: visible;\n}\n.ant-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-tree-checkbox-indeterminate .ant-tree-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-tree-checkbox-indeterminate.ant-tree-checkbox-disabled .ant-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-tree-checkbox-checked .ant-tree-checkbox-inner,\n.ant-tree-checkbox-indeterminate .ant-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-disabled.ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-tree-checkbox-disabled .ant-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-tree-checkbox-wrapper + span,\n.ant-tree-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-tree-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-tree-checkbox-checked .ant-tree-checkbox-inner:before,\n  .ant-tree-checkbox-checked .ant-tree-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-tree {\n  margin: 0;\n  padding: 0;\n  font-size: 12px;\n}\n.ant-tree li {\n  padding: 4px 0;\n  margin: 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-tree li span[draggable],\n.ant-tree li span[draggable=\"true\"] {\n  user-select: none;\n  border-top: 2px transparent solid;\n  border-bottom: 2px transparent solid;\n  margin-top: -2px;\n  /* Required to make elements draggable in old WebKit */\n  -khtml-user-drag: element;\n  -webkit-user-drag: element;\n}\n.ant-tree li.drag-over > span[draggable] {\n  background-color: #108ee9;\n  color: white;\n  opacity: 0.8;\n}\n.ant-tree li.drag-over-gap-top > span[draggable] {\n  border-top-color: #108ee9;\n}\n.ant-tree li.drag-over-gap-bottom > span[draggable] {\n  border-bottom-color: #108ee9;\n}\n.ant-tree li.filter-node > span {\n  color: #f04134 !important;\n  font-weight: 500 !important;\n}\n.ant-tree li ul {\n  margin: 0;\n  padding: 0 0 0 18px;\n}\n.ant-tree li .ant-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  vertical-align: top;\n  color: rgba(0, 0, 0, 0.65);\n  transition: all 0.3s ease;\n}\n.ant-tree li .ant-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-tree li .ant-tree-node-content-wrapper.ant-tree-node-selected {\n  background-color: #d2eafb;\n}\n.ant-tree li span.ant-tree-checkbox {\n  margin: 0 4px 0 2px;\n  vertical-align: middle;\n}\n.ant-tree li span.ant-tree-switcher,\n.ant-tree li span.ant-tree-iconEle {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 24px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\n.ant-tree li span.ant-tree-icon_loading:after {\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e6ae\";\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher-noop {\n  cursor: default;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-tree li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  transform: rotate(270deg) scale(0.59);\n}\n.ant-tree li:last-child > span.ant-tree-switcher:before,\n.ant-tree li:last-child > span.ant-tree-iconEle:before {\n  display: none;\n}\n.ant-tree > li:first-child {\n  padding-top: 7px;\n}\n.ant-tree > li:last-child {\n  padding-bottom: 7px;\n}\n.ant-tree-child-tree {\n  display: none;\n}\n.ant-tree-child-tree-open {\n  display: block;\n}\nli.ant-tree-treenode-disabled > span,\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper,\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper span,\nli.ant-tree-treenode-disabled > span.ant-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\nli.ant-tree-treenode-disabled > .ant-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-tree-icon__close {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-tree.ant-tree-show-line li {\n  position: relative;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher {\n  background: #fff;\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e664\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher-noop:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e621\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 12px 9;\n  transform: scale(1) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e645\";\n  vertical-align: baseline;\n  font-weight: normal;\n  transition: transform .3s;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-tree.ant-tree-show-line li span.ant-tree-switcher.ant-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-tree.ant-tree-show-line li:not(:last-child):before {\n  content: ' ';\n  width: 1px;\n  border-left: 1px solid #d9d9d9;\n  height: 100%;\n  position: absolute;\n  left: 12px;\n  margin: 18px 0;\n}\n.ant-select-search__field__wrap {\n  padding-left: 5px;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search .ant-select-search__field {\n  width: 88% !important;\n}\n.hidden-selection {\n  display: none;\n}\n.ant-select-selection__rendered1 {\n  display: block;\n  margin-left: 7px;\n  margin-right: 7px;\n  position: relative;\n  line-height: 26px;\n}\n.ant-select-selection__choice1 {\n  margin-top: 3px;\n  height: 20px;\n  line-height: 20px;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #f3f3f3;\n  border-radius: 4px;\n  cursor: default;\n  float: left;\n  margin-right: 4px;\n  max-width: 99%;\n  position: relative;\n  overflow: hidden;\n  transition: padding 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  padding: 0 20px 0 10px;\n}\n.more-items-icon {\n  bottom: 10px;\n  height: 10px;\n  opacity: .8;\n  position: absolute;\n  right: 8px;\n  z-index: 100;\n  cursor: pointer;\n}\n.ant-select-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-input:focus + .ant-select-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: '';\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-select-tree-checkbox:hover:after,\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox:after {\n  visibility: visible;\n}\n.ant-select-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  transition: all .3s;\n}\n.ant-select-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-select-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner:after {\n  content: ' ';\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-select-tree-checkbox-indeterminate.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: ' ';\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner {\n  border-color: #d9d9d9 !important;\n  background-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-select-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-select-tree-checkbox-wrapper + span,\n.ant-select-tree-checkbox + span {\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-select-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-select-tree-checkbox-group-item {\n  display: inline-block;\n}\n@media \0screen {\n  .ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:before,\n  .ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n    font-family: 'anticon';\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n    content: \"\\e632\";\n    font-weight: bold;\n    font-size: 8px;\n    border: 0;\n    color: #fff;\n    left: 2px;\n    top: 3px;\n    position: absolute;\n  }\n}\n.ant-select-tree {\n  margin: 0;\n  padding: 0 10px;\n  margin-top: -4px;\n  font-size: 12px;\n}\n.ant-select-tree li {\n  padding: 0;\n  margin: 2px 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-select-tree li.filter-node > span {\n  font-weight: 500;\n}\n.ant-select-tree li ul {\n  margin: 0;\n  padding: 0 0 0 18px;\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  color: rgba(0, 0, 0, 0.65);\n  transition: all .3s;\n  width: calc(95%);\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-tree li .ant-select-tree-node-content-wrapper.ant-select-tree-node-selected {\n  background-color: #d2eafb;\n  width: 75%;\n}\n.ant-select-tree li span.ant-select-tree-checkbox {\n  margin: 0 4px 0 0;\n}\n.ant-select-tree li span.ant-select-tree-checkbox + .ant-select-tree-node-content-wrapper {\n  width: calc(95%);\n}\n.ant-select-tree li span.ant-select-tree-switcher,\n.ant-select-tree li span.ant-select-tree-iconEle {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 22px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\n.ant-select-tree li span.ant-select-tree-icon_loading:after {\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e6ae\";\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher-noop {\n  cursor: auto;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  filter: none;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_open:after {\n  font-size: 12px;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  font-size: 12px;\n  font-size: 7px 9;\n  transform: scale(0.58333333) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e606\";\n  font-weight: bold;\n  transition: transform .3s;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  filter: none;\n}\n:root .ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  font-size: 12px;\n}\n.ant-select-tree li span.ant-select-tree-switcher.ant-select-tree-switcher_close:after {\n  transform: rotate(270deg) scale(0.59);\n}\n.ant-select-tree-child-tree {\n  display: none;\n}\n.ant-select-tree-child-tree-open {\n  display: block;\n}\nli.ant-select-tree-treenode-disabled > span,\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper,\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper span,\nli.ant-select-tree-treenode-disabled > span.ant-select-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\nli.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-select-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-select-tree-icon__close {\n  margin-right: 2px;\n  vertical-align: top;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search {\n  display: block;\n  padding: 4px;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search .ant-select-search__field__wrap {\n  width: 100%;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search .ant-select-search__field {\n  padding: 4px 7px;\n  width: 100%;\n  box-sizing: border-box;\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n  outline: none;\n}\n.ant-select-tree-dropdown .ant-select-dropdown-search.ant-select-search--hide {\n  display: none;\n}\n.ant-select-tree-dropdown .ant-select-not-found {\n  cursor: not-allowed;\n  color: rgba(0, 0, 0, 0.25);\n  padding: 7px 16px;\n  display: block;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u9AD8\u5BBD\u53CA\u80CC\u666F \u9AD8\u5BBD\u5206\u522B\u5BF9\u5E94\u6A2A\u7AD6\u6EDA\u52A8\u6761\u7684\u5C3A\u5BF8*/\n::-webkit-scrollbar {\n  width: 8px;\n  height: 8px;\n}\n/*\u5B9A\u4E49\u6EDA\u52A8\u6761\u8F68\u9053 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-track {\n  background-color: #f5f5f5;\n}\n/*\u5B9A\u4E49\u6ED1\u5757 \u5185\u9634\u5F71+\u5706\u89D2*/\n::-webkit-scrollbar-thumb {\n  -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);\n  background-color: #d7d7d7;\n}\n"]
            },] },
];
/** @nocollapse */
SelectBoxComponent.ctorParameters = function () { return [
    { type: SelectService$1, },
    { type: SelectBoxDefaultOptions, },
    { type: core.ElementRef, },
]; };
SelectBoxComponent.propDecorators = {
    "disabled": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "filterPlaceholder": [{ type: core.Input },],
    "allowFilter": [{ type: core.Input },],
    "maxHeight": [{ type: core.Input },],
    "width": [{ type: core.Input },],
    "span": [{ type: core.Input },],
    "items": [{ type: core.Input },],
    "idField": [{ type: core.Input },],
    "textField": [{ type: core.Input },],
    "allowParentSelection": [{ type: core.Input },],
    "childrenField": [{ type: core.Input },],
    "multiple": [{ type: core.Input },],
    "maxVisibleItemCount": [{ type: core.Input },],
    "isOpen": [{ type: core.Input },],
    "onTouched": [{ type: core.HostListener, args: ['blur',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var noop$4 = function () { };
var SelectBoxItemComponent = (function () {
    /**
     * @param {?} svc
     */
    function SelectBoxItemComponent(svc) {
        this.svc = svc;
        this._isOpen = false;
        this.TouchedCallBack = noop$4;
    }
    Object.defineProperty(SelectBoxItemComponent.prototype, "isOpen", {
        /**
         * @return {?}
         */
        get: function () {
            return this._isOpen;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (!value || value === undefined) {
                return;
            }
            this._isOpen = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxItemComponent.prototype.toggleOpen = function ($event) {
        $event.stopPropagation();
        if (this.haveChildren) {
            this._isOpen = !this._isOpen;
        }
        else {
            this.select($event);
        }
    };
    Object.defineProperty(SelectBoxItemComponent.prototype, "allowParentSelection", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.allowParentSelection;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxItemComponent.prototype, "needCheckBox", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.isHierarchy() && this.svc.Configuration.allowMultiple;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectBoxItemComponent.prototype, "haveChildren", {
        /**
         * @return {?}
         */
        get: function () {
            return this.item && this.item.children && this.item.children.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} $event
     * @return {?}
     */
    SelectBoxItemComponent.prototype.select = function ($event) {
        $event.stopPropagation();
        if (this.svc.Configuration.allowMultiple ||
            this.svc.Configuration.allowParentSelection ||
            !this.haveChildren) {
            this.svc.toggleItemSelection(this.item);
        }
        // this.TouchedCallBack();
    };
    Object.defineProperty(SelectBoxItemComponent.prototype, "filter", {
        /**
         * @return {?}
         */
        get: function () {
            return this.svc.Configuration.filter;
        },
        enumerable: true,
        configurable: true
    });
    return SelectBoxItemComponent;
}());
SelectBoxItemComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-select-box-item',
                template: "<!-- <span *ngIf=\"!haveChildren\" class=\"ant-select-tree-switcher ant-select-tree-switcher-noop\"></span> -->\n<!-- <span *ngIf=\"haveChildren\" class=\"ant-select-tree-switcher\" (click)=\"toggleOpen($event)\"\n  [class.ant-select-tree-switcher-open]=\"isOpen\"\n  [class.ant-select-tree-switcher-close]=\"!isOpen\"></span> -->\n<span *ngIf=\"needCheckBox\" class=\"ant-select-tree-checkbox\"\n  [class.ant-select-tree-checkbox-indeterminate]=\"item.checked === null\"\n  [class.ant-select-tree-checkbox-checked]=\"item.checked === true\" (click)=\"select($event)\">\n    <span class=\"ant-select-tree-checkbox-inner\"></span>\n</span>\n<span\n    title=\"{{item.text}}\" class=\"ant-select-tree-node-content-wrapper\"\n    [class.change-width]=\"haveChildren\"\n    [class.ant-select-tree-node-content-wrapper-open]=\"isOpen===true\"\n    [class.ant-select-tree-node-selected]=\"item.selected\"\n    (click)=\"toggleOpen($event)\">\n    <span class=\"ant-select-tree-title\">{{item.text}}</span>\n    <i *ngIf=\"haveChildren\" [class.ant-steps-finished]=\"isOpen\"></i>\n</span>\n<ul nz-row class=\"ant-select-tree-child-tree\" \n  [class.ant-select-tree-child-tree-open]=\"isOpen===true\"\n  [class.ant-select-tree-child-tree-close]=\"isOpen===false\">\n  <li nz-col [nzSpan]=\"span\" *ngFor=\"let o of item.children | itemPipe: filter\">\n      <ant-select-box-item [item]=\"o\" [span]=\"span\" (TouchedCallback)=\"TouchedCallback\"></ant-select-box-item>\n  </li>\n</ul>\n",
                styles: [".ant-select-tree-checkbox {\n  white-space: nowrap;\n  cursor: pointer;\n  outline: none;\n  display: inline-block;\n  line-height: 1;\n  position: relative;\n  vertical-align: text-bottom;\n}\n.ant-select-tree-checkbox-input:focus + .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox:hover .ant-select-tree-checkbox-inner {\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-checked:after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  border-radius: 2px;\n  border: 1px solid #108ee9;\n  content: \"\";\n  -webkit-animation: antCheckboxEffect 0.36s ease-in-out;\n  animation: antCheckboxEffect 0.36s ease-in-out;\n  -webkit-animation-fill-mode: both;\n  animation-fill-mode: both;\n  visibility: hidden;\n}\n.ant-select-tree-checkbox-wrapper:hover .ant-select-tree-checkbox:after,\n.ant-select-tree-checkbox:hover:after {\n  visibility: visible;\n}\n.ant-select-tree-checkbox-inner {\n  position: relative;\n  top: 0;\n  left: 0;\n  display: block;\n  width: 14px;\n  height: 14px;\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  background-color: #fff;\n  -webkit-transition: all .3s;\n  transition: all 0.3s;\n}\n.ant-select-tree-checkbox-inner:after {\n  -webkit-transform: rotate(45deg) scale(0);\n  -ms-transform: rotate(45deg) scale(0);\n  transform: rotate(45deg) scale(0);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: \" \";\n  -webkit-transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n  transition: all 0.1s cubic-bezier(0.71, -0.46, 0.88, 0.6);\n}\n.ant-select-tree-checkbox-input {\n  position: absolute;\n  left: 0;\n  z-index: 1;\n  cursor: pointer;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  top: 0;\n  bottom: 0;\n  right: 0;\n  width: 100%;\n  height: 100%;\n}\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner:after {\n  content: \" \";\n  -webkit-transform: scale(1);\n  -ms-transform: scale(1);\n  transform: scale(1);\n  position: absolute;\n  left: 2px;\n  top: 5px;\n  width: 8px;\n  height: 1px;\n}\n.ant-select-tree-checkbox-indeterminate.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  -webkit-transform: rotate(45deg) scale(1);\n  -ms-transform: rotate(45deg) scale(1);\n  transform: rotate(45deg) scale(1);\n  position: absolute;\n  left: 4px;\n  top: 1px;\n  display: table;\n  width: 5px;\n  height: 8px;\n  border: 2px solid #fff;\n  border-top: 0;\n  border-left: 0;\n  content: \" \";\n  -webkit-transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n  transition: all 0.2s cubic-bezier(0.12, 0.4, 0.29, 1.46) 0.1s;\n}\n.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner,\n.ant-select-tree-checkbox-indeterminate .ant-select-tree-checkbox-inner {\n  background-color: #108ee9;\n  border-color: #108ee9;\n}\n.ant-select-tree-checkbox-disabled {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled.ant-select-tree-checkbox-checked .ant-select-tree-checkbox-inner:after {\n  -webkit-animation-name: none;\n  animation-name: none;\n  border-color: rgba(0, 0, 0, 0.25);\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-input {\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner {\n  border-color: #d9d9d9!important;\n  background-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled .ant-select-tree-checkbox-inner:after {\n  -webkit-animation-name: none;\n  animation-name: none;\n  border-color: #f7f7f7;\n}\n.ant-select-tree-checkbox-disabled + span {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-checkbox-wrapper {\n  cursor: pointer;\n  font-size: 12px;\n  display: inline-block;\n}\n.ant-select-tree-checkbox-wrapper:not(:last-child) {\n  margin-right: 8px;\n}\n.ant-select-tree-checkbox-group {\n  font-size: 12px;\n}\n.ant-select-tree-checkbox-group-item {\n  display: inline-block;\n}\nli {\n  padding: 0;\n  margin: 5px 0;\n  list-style: none;\n  white-space: nowrap;\n  outline: 0;\n}\n.ant-select-tree li.filter-node > span {\n  font-weight: 500;\n}\nul {\n  margin: 0;\n}\n.ant-select-tree-node-content-wrapper {\n  display: inline-block;\n  padding: 3px 5px;\n  border-radius: 2px;\n  margin: 0;\n  cursor: pointer;\n  text-decoration: none;\n  color: rgba(0, 0, 0, 0.65);\n  -webkit-transition: all .3s;\n  transition: all .3s;\n  width: calc(90%);\n}\n.ant-select-tree-node-content-wrapper:hover {\n  background-color: #ecf6fd;\n}\n.ant-select-tree-node-content-wrapper.ant-select-tree-node-selected {\n  background-color: #d2eafb;\n}\nspan.ant-select-tree-checkbox {\n  margin: 0 4px 0 0;\n}\nspan.ant-select-tree-checkbox + .ant-select-tree-node-content-wrapper {\n  width: calc(75%);\n  position: relative;\n  top: 7px;\n  overflow: hidden;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n}\nspan.change-width {\n  width: 95% !important;\n}\nspan.ant-select-tree-iconEle,\nspan.ant-select-tree-switcher {\n  margin: 0;\n  width: 24px;\n  height: 24px;\n  line-height: 22px;\n  display: inline-block;\n  vertical-align: middle;\n  border: 0 none;\n  cursor: pointer;\n  outline: none;\n  text-align: center;\n}\nspan.ant-select-tree-icon_loading:after {\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E6AE\";\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n  color: #108ee9;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-noop {\n  cursor: auto;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-open:after {\n  font-size: 12px;\n  font-size: 7px9;\n  -webkit-transform: scale(0.58333333) rotate(0deg);\n  -ms-transform: scale(0.58333333) rotate(0deg);\n  transform: scale(0.58333333) rotate(0deg);\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E606\";\n  font-weight: 700;\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform .3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-open:after {\n  -webkit-filter: none;\n  filter: none;\n  font-size: 12px;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close {\n  -ms-filter: \"progid:DXImageTransform.Microsoft.BasicImage(rotation=3)\";\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  font-size: 12px;\n  font-size: 7px9;\n  -webkit-transform: scale(0.58333333) rotate(0deg);\n  -ms-transform: scale(0.58333333) rotate(0deg);\n  transform: scale(0.58333333) rotate(0deg);\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  display: inline-block;\n  font-family: anticon;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E606\";\n  font-weight: 700;\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform .3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  -webkit-transform: rotate(270deg) scale(0.59);\n  -ms-transform: rotate(270deg) scale(0.59);\n  transform: rotate(270deg) scale(0.59);\n}\nspan.ant-select-tree-switcher.ant-select-tree-switcher-close:after {\n  -webkit-filter: none;\n  filter: none;\n  font-size: 12px;\n}\n.ant-select-tree-child-tree {\n  display: none;\n}\n.ant-select-tree-child-tree-open {\n  display: block;\n}\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper,\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper span,\n.ant-select-tree-treenode-disabled > span,\n.ant-select-tree-treenode-disabled > span.ant-select-tree-switcher {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-select-tree-treenode-disabled > .ant-select-tree-node-content-wrapper:hover {\n  background: transparent;\n}\n.ant-select-tree-icon__close,\n.ant-select-tree-icon__open {\n  margin-right: 2px;\n  vertical-align: top;\n}\nspan.ant-select-tree-node-content-wrapper > i {\n  display: inline-block;\n  vertical-align: top;\n  background: #e9e9e9;\n  height: 1px;\n  border-radius: 1px;\n  width: 100%;\n  position: relative;\n  top: 10px;\n  left: 7px;\n}\nspan.ant-select-tree-node-content-wrapper > i:after {\n  position: absolute;\n  content: \"\";\n  top: 0;\n  width: 0;\n  background: #e9e9e9;\n  height: 100%;\n  opacity: 0;\n}\nspan.ant-select-tree-node-content-wrapper .ant-steps-finished {\n  width: 100%;\n  background: #108ee9;\n  transition: all .8s;\n  opacity: 1;\n  box-shadow: 0 0 0 0 #108ee9;\n  -webkit-animation: tailEffect .4s;\n  animation: tailEffect .4s;\n}\n@keyframes tailEffect {\n  to {\n    box-shadow: 0 0 3px 3px transparent;\n  }\n}\n@-webkit-keyframes antCheckboxEffect {\n  0% {\n    -webkit-transform: scale(1);\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  to {\n    -webkit-transform: scale(1.6);\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n@keyframes antCheckboxEffect {\n  0% {\n    -webkit-transform: scale(1);\n    transform: scale(1);\n    opacity: 0.5;\n  }\n  to {\n    -webkit-transform: scale(1.6);\n    transform: scale(1.6);\n    opacity: 0;\n  }\n}\n"]
            },] },
];
/** @nocollapse */
SelectBoxItemComponent.ctorParameters = function () { return [
    { type: SelectService$1, },
]; };
SelectBoxItemComponent.propDecorators = {
    "TouchedCallBack": [{ type: core.Input },],
    "span": [{ type: core.Input },],
    "item": [{ type: core.Input },],
    "isOpen": [{ type: core.Input },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var OffClickDirective$1 = (function () {
    /**
     * @param {?} platformId
     */
    function OffClickDirective$1(platformId) {
        this.platformId = platformId;
    }
    /**
     * @return {?}
     */
    OffClickDirective$1.prototype.ngOnInit = function () {
        var _this = this;
        if (common.isPlatformBrowser(this.platformId)) {
            setTimeout(function () { document.addEventListener('click', _this.offClickHandler); }, 0);
        }
    };
    /**
     * @return {?}
     */
    OffClickDirective$1.prototype.ngOnDestroy = function () {
        if (common.isPlatformBrowser(this.platformId)) {
            document.removeEventListener('click', this.offClickHandler);
        }
    };
    return OffClickDirective$1;
}());
OffClickDirective$1.decorators = [
    { type: core.Directive, args: [{
                selector: '[off-click]'
            },] },
];
/** @nocollapse */
OffClickDirective$1.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] },] },
]; };
OffClickDirective$1.propDecorators = {
    "offClickHandler": [{ type: core.Input, args: ['off-click',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ItemPipe$1 = (function () {
    function ItemPipe$1() {
    }
    /**
     * @param {?} value
     * @param {...?} arg
     * @return {?}
     */
    ItemPipe$1.prototype.transform = function (value) {
        var arg = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            arg[_i - 1] = arguments[_i];
        }
        // ES6 array destructuring
        var /** @type {?} */ ret = value.filter(function (item) { return item.matchFilter; });
        if (arg.toString() !== '' && ret.length > 0) {
            ret.map(function (opt) { return opt.isOpen = true; });
        }
        else {
            ret.map(function (opt) { return opt.isOpen = false; });
        }
        return ret;
    };
    return ItemPipe$1;
}());
ItemPipe$1.decorators = [
    { type: core.Pipe, args: [{ name: 'itemPipe' },] },
];
/** @nocollapse */
ItemPipe$1.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$4 = [SelectBoxComponent, SelectBoxItemComponent];
var SelectBoxModule = (function () {
    function SelectBoxModule() {
    }
    /**
     * @param {?} options
     * @return {?}
     */
    SelectBoxModule.forRoot = function (options) {
        return {
            ngModule: SelectBoxModule,
            providers: [
                { provide: SelectBoxDefaultOptions, useValue: options }
            ]
        };
    };
    return SelectBoxModule;
}());
SelectBoxModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: COMPONENTS$4.concat([ItemPipe$1, OffClickDirective$1]),
                imports: [common.CommonModule, forms.FormsModule, ngZorroAntd.NzGridModule, ButtonModule],
                exports: COMPONENTS$4.slice(),
                entryComponents: COMPONENTS$4.slice(),
                providers: [SelectBoxDefaultOptions],
            },] },
];
/** @nocollapse */
SelectBoxModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LayerService = (function () {
    function LayerService() {
        ready.run($);
        // layer.ready();
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    LayerService.prototype.config = function (options) {
        layer.config(options);
    };
    /**
     * @param {?} options
     * @return {?}
     */
    LayerService.prototype.open = function (options) {
        return layer.open(options);
    };
    /**
     * @param {?} content
     * @param {?=} options
     * @param {?=} yes
     * @return {?}
     */
    LayerService.prototype.alert = function (content, options, yes) {
        return layer.alert(content, options, yes);
    };
    /**
     * @param {?} content
     * @param {?=} options
     * @param {?=} yes
     * @param {?=} cancel
     * @return {?}
     */
    LayerService.prototype.confirm = function (content, options, yes, cancel) {
        return layer.confirm(content, options, yes, cancel);
    };
    /**
     * @param {?} content
     * @param {?=} options
     * @param {?=} end
     * @return {?}
     */
    LayerService.prototype.msg = function (content, options, end) {
        return layer.msg(content, options, end);
    };
    /**
     * @param {?=} icon
     * @param {?=} options
     * @return {?}
     */
    LayerService.prototype.load = function (icon, options) {
        return layer.load(icon, options);
    };
    /**
     * @param {?} content
     * @param {?=} follow
     * @param {?=} options
     * @return {?}
     */
    LayerService.prototype.tips = function (content, follow, options) {
        return layer.tips(content, follow, options);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    LayerService.prototype.close = function (index) {
        layer.close(index);
    };
    /**
     * @param {?=} type
     * @return {?}
     */
    LayerService.prototype.closeAll = function (type) {
        layer.closeAll(type);
    };
    /**
     * @param {?} index
     * @param {?} cssStyle
     * @return {?}
     */
    LayerService.prototype.style = function (index, cssStyle) {
        layer.style(index, cssStyle);
    };
    /**
     * @param {?} title
     * @param {?} index
     * @return {?}
     */
    LayerService.prototype.title = function (title, index) {
        layer.title(title, index);
    };
    /**
     * @param {?} selector
     * @param {?} index
     * @return {?}
     */
    LayerService.prototype.getChildFrame = function (selector, index) {
        return layer.getChildFrame(selector, index);
    };
    /**
     * @param {?} windowName
     * @return {?}
     */
    LayerService.prototype.getFrameIndex = function (windowName) {
        return layer.getFrameIndex(windowName);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    LayerService.prototype.iframeAuto = function (index) {
        return layer.iframeAuto(index);
    };
    /**
     * @param {?} index
     * @param {?} url
     * @return {?}
     */
    LayerService.prototype.iframeSrc = function (index, url) {
        return layer.iframeSrc(index, url);
    };
    /**
     * @param {?} layero
     * @return {?}
     */
    LayerService.prototype.setTop = function (layero) {
        layer.setTop(layero);
    };
    /**
     * @param {?=} index
     * @return {?}
     */
    LayerService.prototype.full = function (index) {
        layer.full(index);
    };
    /**
     * @param {?=} index
     * @return {?}
     */
    LayerService.prototype.min = function (index) {
        layer.min(index);
    };
    /**
     * @param {?=} index
     * @return {?}
     */
    LayerService.prototype.restore = function (index) {
        layer.restore(index);
    };
    /**
     * @param {?} options
     * @param {?=} yes
     * @return {?}
     */
    LayerService.prototype.prompt = function (options, yes) {
        return layer.prompt(options, yes);
    };
    /**
     * @param {?} options
     * @return {?}
     */
    LayerService.prototype.tab = function (options) {
        return layer.tab(options);
    };
    /**
     * @param {?} options
     * @return {?}
     */
    LayerService.prototype.photos = function (options) {
        return layer.photos(options);
    };
    return LayerService;
}());
LayerService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
LayerService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LayerComponent = (function () {
    /**
     * @param {?} layer
     */
    function LayerComponent(layer) {
        this.layer = layer;
    }
    /**
     * @return {?}
     */
    LayerComponent.prototype.ngOnInit = function () {
    };
    return LayerComponent;
}());
LayerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-layer',
                template: "",
                styles: ["/**\n \n @Name: layer\n @Author: \u8D24\u5FC3\n \n **/\n*html {\n  background-attachment: fixed;\n}\nhtml #layuicss-skinlayercss {\n  display: none;\n  position: absolute;\n  width: 1989px;\n}\n/* common */\n.layui-layer-shade,\n.layui-layer {\n  position: fixed;\n  _position: absolute;\n  pointer-events: auto;\n}\n.layui-layer-shade {\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n}\n.layui-layer {\n  -webkit-overflow-scrolling: touch;\n}\n.layui-layer {\n  top: 150px;\n  left: 0;\n  margin: 0;\n  padding: 0;\n  background-color: #fff;\n  -webkit-background-clip: content;\n  box-shadow: 1px 1px 50px rgba(0, 0, 0, 0.3);\n}\n.layui-layer-close {\n  position: absolute;\n}\n.layui-layer-content {\n  position: relative;\n}\n.layui-layer-border {\n  border: 1px solid #B2B2B2;\n  border: 1px solid rgba(0, 0, 0, 0.1);\n  box-shadow: 1px 1px 5px rgba(0, 0, 0, 0.2);\n}\n.layui-layer-load {\n  background: url(img/loading-1.gif) #eee center center no-repeat;\n}\n.layui-layer-ico {\n  background: url(img/icon.png) no-repeat;\n}\n.layui-layer-dialog .layui-layer-ico,\n.layui-layer-setwin a,\n.layui-layer-btn a {\n  display: inline-block;\n  *display: inline;\n  *zoom: 1;\n  vertical-align: top;\n}\n.layui-layer-move {\n  display: none;\n  position: fixed;\n  *position: absolute;\n  left: 0px;\n  top: 0px;\n  width: 100%;\n  height: 100%;\n  cursor: move;\n  opacity: 0;\n  filter: alpha(opacity=0);\n  background-color: #fff;\n  z-index: 2147483647;\n}\n.layui-layer-resize {\n  position: absolute;\n  width: 15px;\n  height: 15px;\n  right: 0;\n  bottom: 0;\n  cursor: se-resize;\n}\n/* \u52A8\u753B */\n.layui-layer {\n  border-radius: 2px;\n  -webkit-animation-fill-mode: both;\n  animation-fill-mode: both;\n  -webkit-animation-duration: .3s;\n  animation-duration: .3s;\n}\n@-webkit-keyframes layer-bounceIn {\n  /* \u9ED8\u8BA4 */\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.5);\n    transform: scale(0.5);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: scale(1);\n    transform: scale(1);\n  }\n}\n@keyframes layer-bounceIn {\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.5);\n    -ms-transform: scale(0.5);\n    transform: scale(0.5);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: scale(1);\n    -ms-transform: scale(1);\n    transform: scale(1);\n  }\n}\n.layer-anim {\n  -webkit-animation-name: layer-bounceIn;\n  animation-name: layer-bounceIn;\n}\n@-webkit-keyframes layer-zoomInDown {\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.1) translateY(-2000px);\n    transform: scale(0.1) translateY(-2000px);\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n  60% {\n    opacity: 1;\n    -webkit-transform: scale(0.475) translateY(60px);\n    transform: scale(0.475) translateY(60px);\n    -webkit-animation-timing-function: ease-out;\n    animation-timing-function: ease-out;\n  }\n}\n@keyframes layer-zoomInDown {\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.1) translateY(-2000px);\n    -ms-transform: scale(0.1) translateY(-2000px);\n    transform: scale(0.1) translateY(-2000px);\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n  60% {\n    opacity: 1;\n    -webkit-transform: scale(0.475) translateY(60px);\n    -ms-transform: scale(0.475) translateY(60px);\n    transform: scale(0.475) translateY(60px);\n    -webkit-animation-timing-function: ease-out;\n    animation-timing-function: ease-out;\n  }\n}\n.layer-anim-01 {\n  -webkit-animation-name: layer-zoomInDown;\n  animation-name: layer-zoomInDown;\n}\n@-webkit-keyframes layer-fadeInUpBig {\n  0% {\n    opacity: 0;\n    -webkit-transform: translateY(2000px);\n    transform: translateY(2000px);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: translateY(0);\n    transform: translateY(0);\n  }\n}\n@keyframes layer-fadeInUpBig {\n  0% {\n    opacity: 0;\n    -webkit-transform: translateY(2000px);\n    -ms-transform: translateY(2000px);\n    transform: translateY(2000px);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: translateY(0);\n    -ms-transform: translateY(0);\n    transform: translateY(0);\n  }\n}\n.layer-anim-02 {\n  -webkit-animation-name: layer-fadeInUpBig;\n  animation-name: layer-fadeInUpBig;\n}\n@-webkit-keyframes layer-zoomInLeft {\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.1) translateX(-2000px);\n    transform: scale(0.1) translateX(-2000px);\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n  60% {\n    opacity: 1;\n    -webkit-transform: scale(0.475) translateX(48px);\n    transform: scale(0.475) translateX(48px);\n    -webkit-animation-timing-function: ease-out;\n    animation-timing-function: ease-out;\n  }\n}\n@keyframes layer-zoomInLeft {\n  0% {\n    opacity: 0;\n    -webkit-transform: scale(0.1) translateX(-2000px);\n    -ms-transform: scale(0.1) translateX(-2000px);\n    transform: scale(0.1) translateX(-2000px);\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n  60% {\n    opacity: 1;\n    -webkit-transform: scale(0.475) translateX(48px);\n    -ms-transform: scale(0.475) translateX(48px);\n    transform: scale(0.475) translateX(48px);\n    -webkit-animation-timing-function: ease-out;\n    animation-timing-function: ease-out;\n  }\n}\n.layer-anim-03 {\n  -webkit-animation-name: layer-zoomInLeft;\n  animation-name: layer-zoomInLeft;\n}\n@-webkit-keyframes layer-rollIn {\n  0% {\n    opacity: 0;\n    -webkit-transform: translateX(-100%) rotate(-120deg);\n    transform: translateX(-100%) rotate(-120deg);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: translateX(0px) rotate(0deg);\n    transform: translateX(0px) rotate(0deg);\n  }\n}\n@keyframes layer-rollIn {\n  0% {\n    opacity: 0;\n    -webkit-transform: translateX(-100%) rotate(-120deg);\n    -ms-transform: translateX(-100%) rotate(-120deg);\n    transform: translateX(-100%) rotate(-120deg);\n  }\n  100% {\n    opacity: 1;\n    -webkit-transform: translateX(0px) rotate(0deg);\n    -ms-transform: translateX(0px) rotate(0deg);\n    transform: translateX(0px) rotate(0deg);\n  }\n}\n.layer-anim-04 {\n  -webkit-animation-name: layer-rollIn;\n  animation-name: layer-rollIn;\n}\n@keyframes layer-fadeIn {\n  0% {\n    opacity: 0;\n  }\n  100% {\n    opacity: 1;\n  }\n}\n.layer-anim-05 {\n  -webkit-animation-name: layer-fadeIn;\n  animation-name: layer-fadeIn;\n}\n@-webkit-keyframes layer-shake {\n  0%,\n  100% {\n    -webkit-transform: translateX(0);\n    transform: translateX(0);\n  }\n  10%,\n  30%,\n  50%,\n  70%,\n  90% {\n    -webkit-transform: translateX(-10px);\n    transform: translateX(-10px);\n  }\n  20%,\n  40%,\n  60%,\n  80% {\n    -webkit-transform: translateX(10px);\n    transform: translateX(10px);\n  }\n}\n@keyframes layer-shake {\n  0%,\n  100% {\n    -webkit-transform: translateX(0);\n    -ms-transform: translateX(0);\n    transform: translateX(0);\n  }\n  10%,\n  30%,\n  50%,\n  70%,\n  90% {\n    -webkit-transform: translateX(-10px);\n    -ms-transform: translateX(-10px);\n    transform: translateX(-10px);\n  }\n  20%,\n  40%,\n  60%,\n  80% {\n    -webkit-transform: translateX(10px);\n    -ms-transform: translateX(10px);\n    transform: translateX(10px);\n  }\n}\n.layer-anim-06 {\n  -webkit-animation-name: layer-shake;\n  animation-name: layer-shake;\n}\n@-webkit-keyframes fadeIn {\n  0% {\n    opacity: 0;\n  }\n  100% {\n    opacity: 1;\n  }\n}\n/* \u6807\u9898\u680F */\n.layui-layer-title {\n  padding: 0 80px 0 20px;\n  height: 42px;\n  line-height: 42px;\n  border-bottom: 1px solid #eee;\n  font-size: 14px;\n  color: #333;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  background-color: #F8F8F8;\n  border-radius: 2px 2px 0 0;\n}\n.layui-layer-setwin {\n  position: absolute;\n  right: 15px;\n  *right: 0;\n  top: 15px;\n  font-size: 0;\n  line-height: initial;\n}\n.layui-layer-setwin a {\n  position: relative;\n  width: 16px;\n  height: 16px;\n  margin-left: 10px;\n  font-size: 12px;\n  _overflow: hidden;\n}\n.layui-layer-setwin .layui-layer-min cite {\n  position: absolute;\n  width: 14px;\n  height: 2px;\n  left: 0;\n  top: 50%;\n  margin-top: -1px;\n  background-color: #2E2D3C;\n  cursor: pointer;\n  _overflow: hidden;\n}\n.layui-layer-setwin .layui-layer-min:hover cite {\n  background-color: #2D93CA;\n}\n.layui-layer-setwin .layui-layer-max {\n  background-position: -32px -40px;\n}\n.layui-layer-setwin .layui-layer-max:hover {\n  background-position: -16px -40px;\n}\n.layui-layer-setwin .layui-layer-maxmin {\n  background-position: -65px -40px;\n}\n.layui-layer-setwin .layui-layer-maxmin:hover {\n  background-position: -49px -40px;\n}\n.layui-layer-setwin .layui-layer-close1 {\n  background-position: 1px -40px;\n  cursor: pointer;\n}\n.layui-layer-setwin .layui-layer-close1:hover {\n  opacity: 0.7;\n}\n.layui-layer-setwin .layui-layer-close2 {\n  position: absolute;\n  right: -28px;\n  top: -28px;\n  width: 30px;\n  height: 30px;\n  margin-left: 0;\n  background-position: -149px -31px;\n  *right: -18px;\n  _display: none;\n}\n.layui-layer-setwin .layui-layer-close2:hover {\n  background-position: -180px -31px;\n}\n/* \u6309\u94AE\u680F */\n.layui-layer-btn {\n  text-align: right;\n  padding: 0 10px 12px;\n  pointer-events: auto;\n  user-select: none;\n  -webkit-user-select: none;\n}\n.layui-layer-btn a {\n  height: 28px;\n  line-height: 28px;\n  margin: 6px 6px 0;\n  padding: 0 15px;\n  border: 1px #dedede solid;\n  background-color: #f1f1f1;\n  color: #333;\n  border-radius: 2px;\n  font-weight: 400;\n  cursor: pointer;\n  text-decoration: none;\n}\n.layui-layer-btn a:hover {\n  opacity: 0.9;\n  text-decoration: none;\n}\n.layui-layer-btn a:active {\n  opacity: 0.8;\n}\n.layui-layer-btn .layui-layer-btn0 {\n  border-color: #4898d5;\n  background-color: #2e8ded;\n  color: #fff;\n}\n.layui-layer-btn-l {\n  text-align: left;\n}\n.layui-layer-btn-c {\n  text-align: center;\n}\n/* \u5B9A\u5236\u5316 */\n.layui-layer-dialog {\n  min-width: 260px;\n}\n.layui-layer-dialog .layui-layer-content {\n  position: relative;\n  padding: 20px;\n  line-height: 24px;\n  word-break: break-all;\n  overflow: hidden;\n  font-size: 14px;\n  overflow-x: hidden;\n  overflow-y: auto;\n}\n.layui-layer-dialog .layui-layer-content .layui-layer-ico {\n  position: absolute;\n  top: 16px;\n  left: 15px;\n  _left: -40px;\n  width: 30px;\n  height: 30px;\n}\n.layui-layer-ico1 {\n  background-position: -30px 0;\n}\n.layui-layer-ico2 {\n  background-position: -60px 0;\n}\n.layui-layer-ico3 {\n  background-position: -90px 0;\n}\n.layui-layer-ico4 {\n  background-position: -120px 0;\n}\n.layui-layer-ico5 {\n  background-position: -150px 0;\n}\n.layui-layer-ico6 {\n  background-position: -180px 0;\n}\n.layui-layer-rim {\n  border: 6px solid #8D8D8D;\n  border: 6px solid rgba(0, 0, 0, 0.3);\n  border-radius: 5px;\n  box-shadow: none;\n}\n.layui-layer-msg {\n  min-width: 180px;\n  border: 1px solid #D3D4D3;\n  box-shadow: none;\n}\n.layui-layer-hui {\n  min-width: 100px;\n  background-color: #000;\n  filter: alpha(opacity=60);\n  background-color: rgba(0, 0, 0, 0.6);\n  color: #fff;\n  border: none;\n}\n.layui-layer-hui .layui-layer-content {\n  padding: 12px 25px;\n  text-align: center;\n}\n.layui-layer-dialog .layui-layer-padding {\n  padding: 20px 20px 20px 55px;\n  text-align: left;\n}\n.layui-layer-page .layui-layer-content {\n  position: relative;\n  /* overflow: auto; */\n}\n.layui-layer-page .layui-layer-btn,\n.layui-layer-iframe .layui-layer-btn {\n  padding-top: 10px;\n}\n.layui-layer-nobg {\n  background: none;\n}\n.layui-layer-iframe iframe {\n  display: block;\n  width: 100%;\n}\n.layui-layer-loading {\n  border-radius: 100%;\n  background: none;\n  box-shadow: none;\n  border: none;\n}\n.layui-layer-loading .layui-layer-content {\n  width: 60px;\n  height: 24px;\n  background: url(img/loading-0.gif) no-repeat;\n}\n.layui-layer-loading .layui-layer-loading1 {\n  width: 37px;\n  height: 37px;\n  background: url(img/loading-1.gif) no-repeat;\n}\n.layui-layer-loading .layui-layer-loading2,\n.layui-layer-ico16 {\n  width: 32px;\n  height: 32px;\n  background: url(img/loading-2.gif) no-repeat;\n}\n.layui-layer-tips {\n  background: none;\n  box-shadow: none;\n  border: none;\n}\n.layui-layer-tips .layui-layer-content {\n  position: relative;\n  line-height: 22px;\n  min-width: 12px;\n  padding: 5px 10px;\n  font-size: 12px;\n  _float: left;\n  border-radius: 2px;\n  box-shadow: 1px 1px 3px rgba(0, 0, 0, 0.2);\n  background-color: #000;\n  color: #fff;\n}\n.layui-layer-tips .layui-layer-close {\n  right: -2px;\n  top: -1px;\n}\n.layui-layer-tips i.layui-layer-TipsG {\n  position: absolute;\n  width: 0;\n  height: 0;\n  border-width: 8px;\n  border-color: transparent;\n  border-style: dashed;\n  *overflow: hidden;\n}\n.layui-layer-tips i.layui-layer-TipsT,\n.layui-layer-tips i.layui-layer-TipsB {\n  left: 5px;\n  border-right-style: solid;\n  border-right-color: #000;\n}\n.layui-layer-tips i.layui-layer-TipsT {\n  bottom: -8px;\n}\n.layui-layer-tips i.layui-layer-TipsB {\n  top: -8px;\n}\n.layui-layer-tips i.layui-layer-TipsR,\n.layui-layer-tips i.layui-layer-TipsL {\n  top: 1px;\n  border-bottom-style: solid;\n  border-bottom-color: #000;\n}\n.layui-layer-tips i.layui-layer-TipsR {\n  left: -8px;\n}\n.layui-layer-tips i.layui-layer-TipsL {\n  right: -8px;\n}\n/* skin */\n.layui-layer-lan[type=\"dialog\"] {\n  min-width: 280px;\n}\n.layui-layer-lan .layui-layer-title {\n  background: #4476A7;\n  color: #fff;\n  border: none;\n}\n.layui-layer-lan .layui-layer-btn {\n  padding: 5px 10px 10px;\n  text-align: right;\n  border-top: 1px solid #E9E7E7;\n}\n.layui-layer-lan .layui-layer-btn a {\n  background: #BBB5B5;\n  border: none;\n}\n.layui-layer-lan .layui-layer-btn .layui-layer-btn1 {\n  background: #C9C5C5;\n}\n.layui-layer-molv .layui-layer-title {\n  background: #009f95;\n  color: #fff;\n  border: none;\n}\n.layui-layer-molv .layui-layer-btn a {\n  background: #009f95;\n}\n.layui-layer-molv .layui-layer-btn .layui-layer-btn1 {\n  background: #92B8B1;\n}\n/**\n  \n  @Name: layer\u62D3\u5C55\u6837\u5F0F\n  \n  */\n.layui-layer-iconext {\n  background: url(img/icon-ext.png) no-repeat;\n}\n/* prompt\u6A21\u5F0F */\n.layui-layer-prompt .layui-layer-input {\n  display: block;\n  width: 220px;\n  height: 30px;\n  margin: 0 auto;\n  line-height: 30px;\n  padding: 0 5px;\n  border: 1px solid #ccc;\n  box-shadow: 1px 1px 5px rgba(0, 0, 0, 0.1) inset;\n  color: #333;\n}\n.layui-layer-prompt textarea.layui-layer-input {\n  width: 300px;\n  height: 100px;\n  line-height: 20px;\n}\n.layui-layer-prompt .layui-layer-content {\n  padding: 20px;\n}\n.layui-layer-prompt .layui-layer-btn {\n  padding-top: 0;\n}\n/* tab\u6A21\u5F0F */\n.layui-layer-tab {\n  box-shadow: 1px 1px 50px rgba(0, 0, 0, 0.4);\n}\n.layui-layer-tab .layui-layer-title {\n  padding-left: 0;\n  border-bottom: 1px solid #ccc;\n  background-color: #eee;\n  overflow: visible;\n}\n.layui-layer-tab .layui-layer-title span {\n  position: relative;\n  float: left;\n  min-width: 80px;\n  max-width: 260px;\n  padding: 0 20px;\n  text-align: center;\n  cursor: default;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n}\n.layui-layer-tab .layui-layer-title span.layui-layer-tabnow {\n  height: 43px;\n  border-left: 1px solid #ccc;\n  border-right: 1px solid #ccc;\n  background-color: #fff;\n  z-index: 10;\n}\n.layui-layer-tab .layui-layer-title span:first-child {\n  border-left: none;\n}\n.layui-layer-tabmain {\n  line-height: 24px;\n  clear: both;\n}\n.layui-layer-tabmain .layui-layer-tabli {\n  display: none;\n}\n.layui-layer-tabmain .layui-layer-tabli.xubox_tab_layer {\n  display: block;\n}\n.xubox_tabclose {\n  position: absolute;\n  right: 10px;\n  top: 5px;\n  cursor: pointer;\n}\n/* photo\u6A21\u5F0F */\n.layui-layer-photos {\n  -webkit-animation-duration: .8s;\n  animation-duration: .8s;\n}\n.layui-layer-photos .layui-layer-content {\n  overflow: hidden;\n  text-align: center;\n}\n.layui-layer-photos .layui-layer-phimg img {\n  position: relative;\n  width: 100%;\n  display: inline-block;\n  *display: inline;\n  *zoom: 1;\n  vertical-align: top;\n}\n.layui-layer-imguide,\n.layui-layer-imgbar {\n  display: none;\n}\n.layui-layer-imgprev,\n.layui-layer-imgnext {\n  position: absolute;\n  top: 50%;\n  width: 27px;\n  _width: 44px;\n  height: 44px;\n  margin-top: -22px;\n  outline: none;\n}\n.layui-layer-imgprev {\n  left: 10px;\n  background-position: -5px -5px;\n  _background-position: -70px -5px;\n}\n.layui-layer-imgprev:hover {\n  background-position: -33px -5px;\n  _background-position: -120px -5px;\n}\n.layui-layer-imgnext {\n  right: 10px;\n  _right: 8px;\n  background-position: -5px -50px;\n  _background-position: -70px -50px;\n}\n.layui-layer-imgnext:hover {\n  background-position: -33px -50px;\n  _background-position: -120px -50px;\n}\n.layui-layer-imgbar {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  width: 100%;\n  height: 32px;\n  line-height: 32px;\n  background-color: rgba(0, 0, 0, 0.8);\n  background-color: #0009;\n  filter: alpha(opacity=80);\n  color: #fff;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n  font-size: 0;\n}\n.layui-layer-imgtit {\n  /*position:absolute; left:20px;*/\n}\n.layui-layer-imgtit * {\n  display: inline-block;\n  *display: inline;\n  *zoom: 1;\n  vertical-align: top;\n  font-size: 12px;\n}\n.layui-layer-imgtit a {\n  max-width: 65%;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n  color: #fff;\n}\n.layui-layer-imgtit a:hover {\n  color: #fff;\n  text-decoration: underline;\n}\n.layui-layer-imgtit em {\n  padding-left: 10px;\n  font-style: normal;\n}\n/* \u5173\u95ED\u52A8\u753B */\n@-webkit-keyframes layer-bounceOut {\n  100% {\n    opacity: 0;\n    -webkit-transform: scale(0.7);\n    transform: scale(0.7);\n  }\n  30% {\n    -webkit-transform: scale(1.05);\n    transform: scale(1.05);\n  }\n  0% {\n    -webkit-transform: scale(1);\n    transform: scale(1);\n  }\n}\n@keyframes layer-bounceOut {\n  100% {\n    opacity: 0;\n    -webkit-transform: scale(0.7);\n    -ms-transform: scale(0.7);\n    transform: scale(0.7);\n  }\n  30% {\n    -webkit-transform: scale(1.05);\n    -ms-transform: scale(1.05);\n    transform: scale(1.05);\n  }\n  0% {\n    -webkit-transform: scale(1);\n    -ms-transform: scale(1);\n    transform: scale(1);\n  }\n}\n.layer-anim-close {\n  -webkit-animation-name: layer-bounceOut;\n  animation-name: layer-bounceOut;\n  -webkit-animation-duration: .2s;\n  animation-duration: .2s;\n}\n@media screen and (max-width: 1100px) {\n  .layui-layer-iframe {\n    overflow-y: auto;\n    -webkit-overflow-scrolling: touch;\n  }\n}\n"],
                encapsulation: core.ViewEncapsulation.None
            },] },
];
/** @nocollapse */
LayerComponent.ctorParameters = function () { return [
    { type: LayerService, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LayerModule = (function () {
    function LayerModule() {
    }
    return LayerModule;
}());
LayerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [LayerComponent],
                exports: [LayerComponent],
                providers: [LayerService]
            },] },
];
/** @nocollapse */
LayerModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var JqGridService = (function () {
    function JqGridService() {
        // 设置默认参数：覆盖掉jqGrid的默认参数。
        this.defaultOptions = {
            pager: 'jqGridPager' + Date.now(),
            altRows: false,
            altclass: 'ng-jq-grid-even',
        };
    }
    /**
     * @param {?} source
     * @return {?}
     */
    JqGridService.prototype.deepCopyObject = function (source) {
        if (typeof source !== 'object') {
            return source;
        }
        var /** @type {?} */ result = Array.isArray(source) ? [] : {};
        var /** @type {?} */ sourceArr = Object.keys(source);
        for (var _i = 0, sourceArr_1 = sourceArr; _i < sourceArr_1.length; _i++) {
            var key = sourceArr_1[_i];
            result[key] = typeof source[key] === 'object' ? this.deepCopyObject(source[key]) : source[key];
        }
        return result;
    };
    /**
     * @param {?} interdaceOptions
     * @param {?} eventOptions
     * @return {?}
     */
    JqGridService.prototype.handleInitOptions = function (interdaceOptions, eventOptions) {
        if (interdaceOptions['hidePagerBar']) {
            interdaceOptions['pager'] = undefined;
        }
        return Object.assign(interdaceOptions, eventOptions, this.deepCopyObject(this.defaultOptions));
    };
    /**
     * @param {?} functionOptions
     * @return {?}
     */
    JqGridService.prototype.handleFunctionOptions = function (functionOptions) {
        if (!functionOptions) {
            return;
        }
        if (functionOptions['toolBarSettings']) {
            var /** @type {?} */ argsArr = [];
            functionOptions['toolBarSettings']['edit'] && argsArr.push({
                editCaption: '编辑行',
                recreateForm: true,
                checkOnUpdate: true,
                checkOnSubmit: true,
                closeAfterEdit: true,
                errorTextFormat: function (data) {
                    return 'Error: ' + data.responseText;
                }
            });
            functionOptions['toolBarSettings']['add'] && argsArr.push({
                addCaption: '添加行',
                closeAfterAdd: true,
                recreateForm: true,
                errorTextFormat: function (data) {
                    return 'Error: ' + data.responseText;
                }
            });
            functionOptions['toolBarSettings']['del'] && argsArr.push({
                delCaption: '删除行',
                errorTextFormat: function (data) {
                    return 'Error: ' + data.responseText;
                }
            });
            (_b = this.$jqGridEle).navGrid.apply(_b, ['#' + this.defaultOptions.pager, {
                    edit: functionOptions['toolBarSettings']['edit'] || false,
                    add: functionOptions['toolBarSettings']['add'] || false,
                    del: functionOptions['toolBarSettings']['del'] || false,
                    search: functionOptions['toolBarSettings']['search'] || false,
                    refresh: functionOptions['toolBarSettings']['refresh'] || false,
                    view: functionOptions['toolBarSettings']['view'] || false,
                    position: 'left',
                    cloneToTop: false
                }].concat(argsArr));
        }
        if (functionOptions['showFiltertoolBar']) {
            this.$jqGridEle.jqGrid('filterToolbar');
        }
        if (functionOptions['flozenColums']) {
            this.$jqGridEle.jqGrid('setFrozenColumns');
        }
        if (functionOptions['groupHeaders']) {
            this.$jqGridEle.setGroupHeaders({
                useColSpanStyle: true,
                groupHeaders: functionOptions['groupHeaders']
            });
        }
        if (functionOptions['bindKeys']) {
            this.$jqGridEle.jqGrid('bindKeys');
        }
        var _b;
    };
    /**
     * @param {?} newData
     * @param {?=} pageNum
     * @return {?}
     */
    JqGridService.prototype.updateData = function (newData, pageNum) {
        this.$jqGridEle && pageNum === undefined && (pageNum = this.$jqGridEle.getGridParam('page'));
        this.$jqGridEle && this.$jqGridEle.jqGrid('clearGridData');
        this.$jqGridEle && this.$jqGridEle.jqGrid('setGridParam', {
            datatype: 'local',
            data: newData,
            page: pageNum || 1
        }).trigger('reloadGrid');
    };
    /**
     * @param {?} jqGridEle
     * @param {?} jqGridPagerEle
     * @param {?} inputData
     * @param {?} interdaceOptions
     * @param {?} eventOptions
     * @param {?} functionOptions
     * @return {?}
     */
    JqGridService.prototype.init = function (jqGridEle, jqGridPagerEle, inputData, interdaceOptions, eventOptions, functionOptions) {
        this.$jqGridEle = $(jqGridEle);
        $(jqGridPagerEle).attr('id', this.defaultOptions.pager);
        interdaceOptions['url'] || (interdaceOptions['data'] = inputData);
        var /** @type {?} */ newInterdaceOptions = this.deepCopyObject(this.handleInitOptions(interdaceOptions, eventOptions));
        this.$jqGridEle.jqGrid(newInterdaceOptions);
        this.handleFunctionOptions(functionOptions);
    };
    /**
     * @return {?}
     */
    JqGridService.prototype.destroy = function () {
        this.$jqGridEle = null;
    };
    return JqGridService;
}());
JqGridService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
JqGridService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var JqGridComponent = (function () {
    /**
     * @param {?} gird
     * @param {?} elementRef
     * @param {?} differs
     */
    function JqGridComponent(gird, elementRef, differs) {
        this.gird = gird;
        this.elementRef = elementRef;
        this.differs = differs;
        /* 导出组件事件 */
        this.rightClickRow = new core.EventEmitter();
        this.dblClickRow = new core.EventEmitter();
        this.clickCell = new core.EventEmitter();
        this.paging = new core.EventEmitter();
        this.beforeSelectRow = new core.EventEmitter();
        this.afterInsertRow = new core.EventEmitter();
        this.beforeRequest = new core.EventEmitter();
        this.gridComplete = new core.EventEmitter();
        this.loadComplete = new core.EventEmitter();
        this.loadError = new core.EventEmitter();
        this.dataDiffer = differs.find({}).create();
    }
    Object.defineProperty(JqGridComponent.prototype, "data", {
        /**
         * @return {?}
         */
        get: function () {
            return this.inputData;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this.inputData = value;
            this.gird.updateData(value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    JqGridComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.jqGridTable.nativeElement.id = 'jqGrid' + Date.now();
        this.interfaceOptions = {
            colModel: this.colModel || undefined,
            viewrecords: this.viewrecords || false,
            rownumbers: this.rownumbers || false,
            rownumWidth: this.rownumWidth || 25,
            altRows: this.altRows || false,
            caption: this.caption || undefined,
            hidegrid: this.hidegrid === undefined ? true : this.hidegrid,
            hiddengrid: this.hiddengrid || false,
            rowNum: this.rowNum || 10,
            rowList: this.rowList || undefined,
            sortname: this.sortname || undefined,
            sortorder: this.sortorder || 'asc',
            multiSort: this.multiSort || false,
            forceFit: this.forceFit || false,
            grouping: this.grouping || false,
            groupingView: this.groupingView || undefined,
            shrinkToFit: this.shrinkToFit === undefined ? true : this.shrinkToFit,
            autowidth: this.autowidth === undefined ? true : this.autowidth,
            width: this.width || undefined,
            colNames: this.colNames || undefined,
            deselectAfterSort: this.deselectAfterSort === undefined ? true : this.deselectAfterSort,
            height: this.height || 'auto',
            page: this.page || 1,
            pgbuttons: this.pgbuttons === undefined ? true : this.pgbuttons,
            pginput: this.pginput === undefined ? true : this.pginput,
            hidePagerBar: this.hidePagerBar || false,
            url: this.url || undefined,
            mtype: this.mtype || 'GET',
            datatype: this.datatype || 'local',
            jsonReader: this.jsonReader || { root: 'rows', page: 'page', total: 'total', records: 'records', repeatitems: false },
            editurl: this.editurl || undefined,
            loadonce: this.loadonce || false,
        };
        this.functionOptions = {
            groupHeaders: this.groupHeaders || undefined,
            showFiltertoolBar: this.showFiltertoolBar || false,
            toolBarSettings: this.toolBarSettings || undefined,
            flozenColums: this.flozenColums || false,
        };
        this.eventOptions = {
            onRightClickRow: function (rowid, iRow, iCol, event) { _this.rightClickRow.emit({ rowid: rowid, iRow: iRow, iCol: iCol, event: event }); },
            ondblClickRow: function (rowid, iRow, iCol, event) { _this.dblClickRow.emit({ rowid: rowid, iRow: iRow, iCol: iCol, event: event }); },
            onCellSelect: function (rowid, iCol, cellcontent, event) { _this.clickCell.emit({ rowid: rowid, iCol: iCol, cellcontent: cellcontent, event: event }); },
            onPaging: function (pgButton) { _this.paging.emit({ pgButton: pgButton }); },
            beforeSelectRow: function (rowid, event) { _this.beforeSelectRow.emit({ rowid: rowid, event: event }); },
            afterInsertRow: function (rowid, rowdata) { _this.afterInsertRow.emit({ rowid: rowid, rowdata: rowdata }); },
            beforeRequest: function () { _this.beforeRequest.emit(); },
            gridComplete: function () { _this.gridComplete.emit(); },
            loadComplete: function (xhr) { _this.loadComplete.emit({ xhr: xhr }); },
            loadError: function (xhr, status, error) { _this.loadError.emit({ xhr: xhr, status: status, error: error }); },
        };
        this.gird.init(this.jqGridTable.nativeElement, this.jqGridPager.nativeElement, this.data, this.interfaceOptions, this.eventOptions, this.functionOptions);
    };
    /**
     * @return {?}
     */
    JqGridComponent.prototype.ngDoCheck = function () {
        if (this.dataDiffer.diff(this.data)) {
            this.gird.updateData(this.data);
        }
    };
    /**
     * @return {?}
     */
    JqGridComponent.prototype.ngOnDestroy = function () {
        this.gird.destroy();
    };
    return JqGridComponent;
}());
JqGridComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-jq-grid',
                template: "<div class=\"jq-grid-container\">\n    <table id=\"#jqGridTableTempId\" #jqGridTable class=\"ng-jq-grid-table\"></table>\n    <div #jqGridPager></div>\n</div>",
                styles: ["/* \u4EE5\u4E0B\u662FjqGrid\u9ED8\u8BA4\u6837\u5F0F\u3010\u67D0\u4E9B\u5DF2\u8FDB\u884C\u6CE8\u91CA\u6216\u4FEE\u6539\uFF1A\u51CF\u5C11\u6587\u4EF6\u5927\u5C0F\u548C\u66F4\u9002\u5E94\u672Cbang-UI\u7EC4\u4EF6\u6837\u5F0F\u3011 */\n/*Grid*/\n.ui-jqgrid {\n  position: relative;\n  -moz-box-sizing: content-box;\n  -webkit-box-sizing: content-box;\n  box-sizing: content-box;\n}\n.ui-jqgrid .ui-jqgrid-view {\n  position: relative;\n  left: 0;\n  top: 0;\n  padding: 0;\n  font-size: 11px;\n  z-index: 100;\n}\n.ui-jqgrid .ui-common-table {\n  border-width: 0px;\n  border-style: none;\n  border-spacing: 0px;\n  padding: 0;\n}\n/* caption*/\n.ui-jqgrid .ui-jqgrid-titlebar {\n  height: 19px;\n  padding: .3em .2em .2em .3em;\n  position: relative;\n  font-size: 12px;\n  border-left: 0 none;\n  border-right: 0 none;\n  border-top: 0 none;\n}\n.ui-jqgrid .ui-jqgrid-caption {\n  text-align: left;\n}\n.ui-jqgrid .ui-jqgrid-title {\n  margin: .1em 0 .2em;\n}\n.ui-jqgrid .ui-jqgrid-titlebar-close {\n  position: absolute;\n  top: 50%;\n  width: 19px;\n  margin: -10px 0 0 0;\n  padding: 1px;\n  height: 18px;\n  cursor: pointer;\n}\n.ui-jqgrid .ui-jqgrid-titlebar-close span {\n  display: block;\n  margin: 1px;\n}\n/* header*/\n.ui-jqgrid .ui-jqgrid-hdiv {\n  position: relative;\n  margin: 0;\n  padding: 0;\n  overflow: hidden;\n  border-left: 0 none !important;\n  border-top: 0 none !important;\n  border-right: 0 none !important;\n}\n.ui-jqgrid .ui-jqgrid-hbox {\n  float: left;\n  padding-right: 20px;\n}\n.ui-jqgrid .ui-jqgrid-htable {\n  table-layout: fixed;\n  margin: 0;\n  border-collapse: separate;\n}\n.ui-jqgrid .ui-jqgrid-htable th {\n  height: 27px;\n  padding: 0 2px 0 2px;\n}\n.ui-jqgrid .ui-jqgrid-htable th div {\n  overflow: hidden;\n  position: relative;\n  margin: .1em 0em .1em 0em;\n}\n.ui-th-column,\n.ui-jqgrid .ui-jqgrid-htable th.ui-th-column {\n  overflow: hidden;\n  white-space: nowrap;\n  text-align: center;\n  border-top: 0 none;\n  border-bottom: 0 none;\n}\n.ui-th-column-header,\n.ui-jqgrid .ui-jqgrid-htable th.ui-th-column-header {\n  overflow: hidden;\n  white-space: nowrap;\n  text-align: center;\n  border-top: 0 none;\n  height: 26px;\n}\n.ui-th-ltr,\n.ui-jqgrid .ui-jqgrid-htable th.ui-th-ltr {\n  border-left: 0 none;\n}\n.ui-th-rtl,\n.ui-jqgrid .ui-jqgrid-htable th.ui-th-rtl {\n  border-right: 0 none;\n}\n.ui-first-th-ltr {\n  border-right: 1px solid;\n}\n.ui-first-th-rtl {\n  border-left: 1px solid;\n}\n.ui-jqgrid .ui-th-div-ie {\n  white-space: nowrap;\n  zoom: 1;\n  height: 17px;\n}\n.ui-jqgrid .ui-jqgrid-resize {\n  height: 20px !important;\n  position: relative;\n  cursor: e-resize;\n  display: inline;\n  overflow: hidden;\n}\n.ui-jqgrid .ui-grid-ico-sort {\n  overflow: hidden;\n  position: absolute;\n  display: inline;\n  cursor: pointer !important;\n}\n.ui-jqgrid .ui-icon-asc {\n  margin-top: -3px;\n  height: 12px;\n}\n.ui-jqgrid .ui-icon-desc {\n  margin-top: 3px;\n  margin-left: -1px;\n  height: 12px;\n}\n.ui-jqgrid .ui-i-asc {\n  margin-top: 0;\n  height: 18px;\n}\n.ui-jqgrid .ui-i-desc {\n  margin-top: 0;\n  margin-left: 12px;\n  height: 18px;\n}\n.ui-jqgrid .ui-single-sort-asc {\n  margin-top: 0;\n  height: 18px;\n}\n.ui-jqgrid .ui-single-sort-desc {\n  margin-top: -1px;\n  height: 18px;\n}\n.ui-jqgrid .ui-jqgrid-sortable {\n  cursor: pointer;\n  height: 14px;\n}\n.ui-jqgrid .ui-search-table td.ui-search-clear {\n  width: 25px;\n}\n.ui-jqgrid tr.ui-search-toolbar td > input {\n  padding-right: 0px;\n  width: 95%;\n}\n/* body */\n.ui-jqgrid .ui-jqgrid-bdiv {\n  position: relative;\n  margin: 0;\n  padding: 0;\n  overflow: auto;\n  text-align: left;\n  z-index: 101;\n}\n.ui-jqgrid .ui-jqgrid-btable {\n  table-layout: fixed;\n  margin: 0;\n  outline-style: none;\n  border-collapse: separate;\n}\n.ui-jqgrid tr.jqgrow {\n  outline-style: none;\n}\n.ui-jqgrid tr.jqgroup {\n  outline-style: none;\n}\n.ui-jqgrid tr.jqgrow td {\n  font-weight: normal;\n  overflow: hidden;\n  white-space: pre;\n  height: 23px;\n  padding: 1px 2px 1px 2px;\n  border-bottom-width: 1px;\n  border-bottom-color: inherit;\n  border-bottom-style: solid;\n}\n.ui-jqgrid tr.jqgfirstrow td {\n  padding: 0 2px 0 2px;\n  border-right-width: 1px;\n  border-right-style: solid;\n  height: auto;\n}\n.ui-jqgrid tr.jqgroup td {\n  font-weight: normal;\n  overflow: hidden;\n  white-space: pre;\n  height: 22px;\n  padding: 0 2px 0 2px;\n  border-bottom-width: 1px;\n  border-bottom-color: inherit;\n  border-bottom-style: solid;\n}\n.ui-jqgrid tr.jqfoot td {\n  font-weight: bold;\n  overflow: hidden;\n  white-space: pre;\n  height: 22px;\n  padding: 0 2px 0 2px;\n  border-bottom-width: 1px;\n  border-bottom-color: inherit;\n  border-bottom-style: solid;\n}\n.ui-jqgrid tr.ui-row-ltr td {\n  text-align: left;\n  border-right-width: 1px;\n  border-right-color: inherit;\n  border-right-style: solid;\n}\n.ui-jqgrid tr.ui-row-rtl td {\n  text-align: right;\n  border-left-width: 1px;\n  border-left-color: inherit;\n  border-left-style: solid;\n}\n.ui-jqgrid td.jqgrid-rownum {\n  padding: 0 2px 0 2px;\n  margin: 0;\n  border: 0 none;\n}\n.ui-jqgrid .ui-jqgrid-resize-mark {\n  width: 2px;\n  left: 0;\n  background-color: #777;\n  cursor: e-resize;\n  cursor: col-resize;\n  position: absolute;\n  top: 0;\n  height: 100px;\n  overflow: hidden;\n  display: none;\n  border: 0 none;\n  z-index: 99999;\n}\n/* footer */\n.ui-jqgrid .ui-jqgrid-sdiv {\n  position: relative;\n  margin: 0;\n  padding: 0;\n  overflow: hidden;\n  border-left: 0 none !important;\n  border-top: 0 none !important;\n  border-right: 0 none !important;\n}\n.ui-jqgrid .ui-jqgrid-ftable {\n  table-layout: fixed;\n  margin-bottom: 0;\n  border-collapse: separate;\n}\n.ui-jqgrid tr.footrow td {\n  font-weight: bold;\n  overflow: hidden;\n  white-space: nowrap;\n  height: 20px;\n  padding: 0 2px 0 2px;\n  border-top-width: 1px;\n  border-top-color: inherit;\n  border-top-style: solid;\n  border-bottom-width: 1px;\n  border-bottom-color: inherit;\n  border-bottom-style: solid;\n}\n.ui-jqgrid tr.footrow-ltr td {\n  text-align: left;\n  border-right-width: 1px;\n  border-right-color: inherit;\n  border-right-style: solid;\n}\n.ui-jqgrid tr.footrow-rtl td {\n  text-align: right;\n  border-left-width: 1px;\n  border-left-color: inherit;\n  border-left-style: solid;\n}\n/* Pager*/\n.ui-jqgrid .ui-jqgrid-pager {\n  border-left: 0 none !important;\n  border-right: 0 none !important;\n  border-bottom: 0 none !important;\n  border-top: 0 none;\n  margin: 0 !important;\n  padding: 0 !important;\n  position: relative;\n  height: auto;\n  min-height: 28px;\n  white-space: nowrap;\n  overflow: hidden;\n  font-size: 11px;\n  z-index: 101;\n}\n.ui-jqgrid .ui-jqgrid-toppager .ui-pager-control,\n.ui-jqgrid .ui-jqgrid-pager .ui-pager-control {\n  position: relative;\n  border-left: 0;\n  border-bottom: 0;\n  border-top: 0;\n  height: 28px;\n}\n.ui-jqgrid .ui-pg-table {\n  position: relative;\n  padding: 1px 0;\n  width: auto;\n  margin: 0;\n}\n.ui-jqgrid .ui-pg-table td {\n  font-weight: normal;\n  vertical-align: middle;\n  padding: 0px 1px;\n}\n.ui-jqgrid .ui-pg-button {\n  height: auto;\n}\n.ui-jqgrid .ui-pg-button span {\n  display: block;\n  margin: 2px;\n  float: left;\n}\n.ui-jqgrid .ui-pg-input,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-input {\n  height: 14px;\n  width: auto;\n  font-size: .9em;\n  margin: 0;\n  line-height: inherit;\n  border: none;\n  padding: 3px 2px;\n}\n.ui-jqgrid .ui-pg-selbox,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-selbox {\n  font-size: .9em;\n  line-height: inherit;\n  display: block;\n  height: 19px;\n  margin: 0;\n  padding: 3px 0px;\n  border: none;\n}\n.ui-jqgrid .ui-separator {\n  height: 18px;\n  border-left: 2px solid #ccc ;\n}\n.ui-separator-li {\n  height: 2px;\n  border: none;\n  border-top: 2px solid #ccc ;\n  margin: 0;\n  padding: 0;\n  width: 100%;\n}\n.ui-jqgrid .dropdownmenu {\n  padding: 3px 0 3px 0;\n  margin-left: 4px;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-pg-div,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-div {\n  padding: 1px 0;\n  float: left;\n  position: relative;\n  line-height: 20px;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-pg-button,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-button {\n  cursor: pointer;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-pg-div span.ui-icon,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-div span.ui-icon {\n  float: left;\n  margin: 2px;\n  width: 18px;\n}\n.ui-jqgrid td input,\n.ui-jqgrid td select,\n.ui-jqgrid td textarea {\n  margin: 0;\n  padding-top: 5px;\n  padding-bottom: 5px;\n}\n.ui-jqgrid td textarea {\n  width: auto;\n  height: auto;\n}\n.ui-jqgrid .ui-jqgrid-toppager {\n  border-left: 0 none !important;\n  border-right: 0 none !important;\n  border-top: 0 none !important;\n  margin: 0 !important;\n  padding: 0 !important;\n  position: relative;\n  white-space: nowrap;\n  overflow: hidden;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-pager-table,\n.ui-jqgrid .ui-jqgrid-toppager .ui-pager-table {\n  width: 100%;\n  table-layout: fixed;\n  height: 100%;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-paging-info,\n.ui-jqgrid .ui-jqgrid-toppager .ui-paging-info {\n  font-weight: normal;\n  height: auto;\n  margin-top: 3px;\n  margin-right: 4px;\n  display: inline;\n}\n.ui-jqgrid .ui-jqgrid-pager .ui-paging-pager,\n.ui-jqgrid .ui-jqgrid-toppager .ui-paging-pager {\n  table-layout: auto;\n  height: 100%;\n}\n.ui-jqgrid .ui-jqgrid-pager .navtable,\n.ui-jqgrid .ui-jqgrid-toppager .navtable {\n  float: left;\n  table-layout: auto;\n  height: 100%;\n}\n/*\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-div {padding:1px 0;float:left;position:relative; line-height: 20px; margin-right:3px;}\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-button { cursor:pointer; }\n.ui-jqgrid .ui-jqgrid-toppager .ui-pg-div  span.ui-icon {float:left;margin: 2px; width:18px;}\n*/\n/*subgrid*/\n.ui-jqgrid .ui-jqgrid-btable .ui-sgcollapsed span {\n  display: block;\n}\n.ui-jqgrid .ui-subgrid {\n  margin: 0;\n  padding: 0;\n  width: 100%;\n}\n.ui-jqgrid .ui-subgrid table {\n  table-layout: fixed;\n}\n.ui-jqgrid .ui-subgrid tr.ui-subtblcell td {\n  height: 18px;\n  border-right-width: 1px;\n  border-right-color: inherit;\n  border-right-style: solid;\n  border-bottom-width: 1px;\n  border-bottom-color: inherit;\n  border-bottom-style: solid;\n}\n.ui-jqgrid .ui-subgrid td.subgrid-data {\n  border-top: 0 none !important;\n  border-left: 0 none !important;\n}\n.ui-jqgrid .ui-subgrid td.subgrid-cell {\n  border-width: 0 1px 1px 0;\n}\n.ui-jqgrid .ui-th-subgrid {\n  height: 20px;\n}\n/* loading */\n.ui-jqgrid .loading {\n  position: absolute;\n  top: 45%;\n  left: 45%;\n  width: auto;\n  z-index: 101;\n  padding: 6px;\n  margin: 5px;\n  text-align: center;\n  font-weight: bold;\n  display: none;\n  border-width: 2px !important;\n  font-size: 11px;\n}\n.ui-jqgrid .jqgrid-overlay {\n  display: none;\n  z-index: 100;\n}\n/* IE * html .jqgrid-overlay {width: expression(this.parentNode.offsetWidth+'px');height: expression(this.parentNode.offsetHeight+'px');} */\n* .jqgrid-overlay iframe {\n  position: absolute;\n  top: 0;\n  left: 0;\n  z-index: -1;\n}\n/* IE width: expression(this.parentNode.offsetWidth+'px');height: expression(this.parentNode.offsetHeight+'px');}*/\n/* end loading div */\n/* toolbar */\n.ui-jqgrid .ui-userdata {\n  border-left: 0 none;\n  border-right: 0 none;\n  height: 27px;\n  overflow: hidden;\n}\n/*Modal Window */\n.ui-jqdialog {\n  font-size: 11px !important;\n}\n.ui-jqdialog {\n  display: none;\n  width: 300px;\n  position: absolute;\n  padding: .2em;\n  font-size: 11px;\n  overflow: visible;\n}\n.ui-jqdialog .ui-jqdialog-titlebar {\n  padding: .3em .2em;\n  position: relative;\n  height: 20px;\n}\n.ui-jqdialog .ui-jqdialog-title {\n  margin: .3em .2em .2em .2em;\n}\n.ui-jqdialog .ui-jqdialog-titlebar-close {\n  position: absolute;\n  top: 50%;\n  width: 19px;\n  margin: -12px 0 0 0;\n  padding: 1px;\n  height: 18px;\n  cursor: pointer;\n}\n.ui-jqdialog .ui-jqdialog-titlebar-close span {\n  display: block;\n  margin: 1px;\n}\n.ui-jqdialog-content,\n.ui-jqdialog .ui-jqdialog-content {\n  border: 0;\n  padding: .3em .2em;\n  background: none;\n  height: auto;\n}\n.ui-jqdialog .ui-jqconfirm {\n  padding: .4em 1em;\n  border-width: 3px;\n  position: absolute;\n  bottom: 10px;\n  right: 10px;\n  overflow: visible;\n  display: none;\n  height: 80px;\n  width: 220px;\n  text-align: center;\n}\n.ui-jqdialog > .ui-resizable-se {\n  bottom: -3px;\n  right: -3px;\n}\n.ui-jqgrid > .ui-resizable-se {\n  bottom: -3px;\n  right: -3px;\n}\n/* end Modal window*/\n/* Form edit */\n.ui-jqdialog-content .FormGrid {\n  margin: 0;\n  overflow: auto;\n  position: relative;\n}\n.ui-jqdialog-content .EditTable {\n  width: 100%;\n  margin-bottom: 0;\n}\n.ui-jqdialog-content .DelTable {\n  width: 100%;\n  margin-bottom: 0;\n}\n.EditTable td input,\n.EditTable td select,\n.EditTable td textarea {\n  margin: 0;\n}\n.EditTable td textarea {\n  width: auto;\n  height: auto;\n}\n.ui-jqdialog-content td.EditButton {\n  text-align: right;\n  border-top: 0 none;\n  border-left: 0 none;\n  border-right: 0 none;\n  padding-bottom: 5px;\n  padding-top: 5px;\n}\n.ui-jqdialog-content td.navButton {\n  text-align: center;\n  border-left: 0 none;\n  border-top: 0 none;\n  border-right: 0 none;\n  padding-bottom: 5px;\n  padding-top: 5px;\n}\n.ui-jqdialog-content input.FormElement {\n  padding: .5em .3em;\n  margin-bottom: 3px;\n}\n.ui-jqdialog-content select.FormElement {\n  padding: .3em;\n  margin-bottom: 3px;\n}\n.ui-jqdialog-content .data-line {\n  padding-top: .1em;\n  border: 0 none;\n}\n.ui-jqdialog-content .CaptionTD {\n  vertical-align: middle;\n  border: 0 none;\n  padding: 2px;\n  white-space: nowrap;\n}\n.ui-jqdialog-content .DataTD {\n  padding: 2px;\n  border: 0 none;\n  vertical-align: top;\n}\n.ui-jqdialog-content .form-view-data {\n  white-space: pre;\n}\n.fm-button {\n  height: 18px;\n  display: inline-block;\n  margin: 2px 4px 0 0;\n  padding: .6em .5em .2em .5em;\n  text-decoration: none !important;\n  cursor: pointer;\n  position: relative;\n  text-align: center;\n  zoom: 1;\n}\n.fm-button-icon-left {\n  padding-left: 1.9em;\n}\n.fm-button-icon-right {\n  padding-right: 1.9em;\n}\n.fm-button-icon-left .ui-icon {\n  right: auto;\n  left: .2em;\n  margin-left: 0;\n  position: absolute;\n  top: 50%;\n  margin-top: -8px;\n}\n.fm-button-icon-right .ui-icon {\n  left: auto;\n  right: .2em;\n  margin-left: 0;\n  position: absolute;\n  top: 50%;\n  margin-top: -8px;\n}\n#nData,\n#pData {\n  float: left;\n  margin: 3px;\n  padding: 0;\n  width: 15px;\n}\n.ViewTable {\n  border-width: 0;\n  border-style: none;\n  border-spacing: 1px;\n  padding: 4px;\n  table-layout: fixed;\n}\n.ViewTable .CaptionTD,\n.ViewTable .DataTD {\n  padding: 4px;\n}\n/* End Eorm edit */\n/*cell edit*/\n.ui-jqgrid .edit-cell {\n  padding: 4px 0px 4px 4px;\n}\n.ui-jqgrid .selected-row,\ndiv.ui-jqgrid .selected-row td {\n  font-style: normal;\n  border-left: 0 none;\n}\n/* inline edit actions button*/\n.ui-inline-del.ui-state-hover span,\n.ui-inline-edit.ui-state-hover span,\n.ui-inline-save.ui-state-hover span,\n.ui-inline-cancel.ui-state-hover span {\n  margin: -1px;\n}\n.ui-inline-del,\n.ui-inline-cancel {\n  margin-left: 8px;\n}\n.ui-jqgrid .inline-edit-cell {\n  padding: 4px 0px 4px 4px;\n}\n/* Tree Grid */\n.ui-jqgrid .tree-wrap {\n  float: left;\n  position: relative;\n  height: 18px;\n  white-space: nowrap;\n  overflow: hidden;\n}\n.ui-jqgrid .tree-minus {\n  position: absolute;\n  height: 18px;\n  width: 18px;\n  overflow: hidden;\n}\n.ui-jqgrid .tree-plus {\n  position: absolute;\n  height: 18px;\n  width: 18px;\n  overflow: hidden;\n}\n.ui-jqgrid .tree-leaf {\n  position: absolute;\n  height: 18px;\n  width: 18px;\n  overflow: hidden;\n}\n.ui-jqgrid .treeclick {\n  cursor: pointer;\n}\n/* moda dialog */\n* iframe.jqm {\n  position: absolute;\n  top: 0;\n  left: 0;\n  z-index: -1;\n}\n/*\t width: expression(this.parentNode.offsetWidth+'px');height: expression(this.parentNode.offsetHeight+'px');}*/\n.ui-jqgrid-dnd tr td {\n  border-right-width: 1px;\n  border-right-color: inherit;\n  border-right-style: solid;\n  height: 20px;\n}\n/* RTL Support */\n.ui-jqgrid .ui-jqgrid-caption-rtl {\n  text-align: right;\n}\n.ui-jqgrid .ui-jqgrid-hbox-rtl {\n  float: right;\n}\n.ui-jqgrid .ui-jqgrid-resize-ltr {\n  float: right;\n  margin: -2px -2px -2px 0;\n}\n.ui-jqgrid .ui-jqgrid-resize-rtl {\n  float: left;\n  margin: -2px 0 -1px -3px;\n}\n.ui-jqgrid .ui-sort-rtl {\n  left: 0;\n}\n.ui-jqgrid .tree-wrap-ltr {\n  float: left;\n}\n.ui-jqgrid .tree-wrap-rtl {\n  float: right;\n}\n.ui-jqgrid .ui-ellipsis {\n  -moz-text-overflow: ellipsis;\n  text-overflow: ellipsis;\n}\n/* Toolbar Search Menu , Nav menu*/\n.ui-search-menu,\n.ui-nav-menu {\n  position: absolute;\n  padding: 2px 5px;\n  z-index: 99999;\n  -webkit-box-shadow: 7px 7px 5px 0px rgba(50, 50, 50, 0.75);\n  -moz-box-shadow: 7px 7px 5px 0px rgba(50, 50, 50, 0.75);\n  box-shadow: 7px 7px 5px 0px rgba(50, 50, 50, 0.75);\n}\n.ui-search-menu.ui-menu .ui-menu-item,\n.ui-nav-menu.ui-menu .ui-menu-item {\n  list-style-image: none;\n  padding-right: 0;\n  padding-left: 0;\n}\n.ui-search-menu.ui-menu .ui-menu-item a,\n.ui-nav-menu.ui-menu .ui-menu-item a {\n  display: block;\n}\n.ui-search-menu.ui-menu .ui-menu-item a.g-menu-item:hover,\n.ui-nav-menu.ui-menu .ui-menu-item a.g-menu-item:hover {\n  margin: -1px;\n  font-weight: normal;\n}\n.ui-jqgrid .ui-search-table {\n  padding: 0;\n  border: 0 none;\n  height: 20px;\n  width: 100%;\n}\n.ui-jqgrid .ui-search-table .ui-search-oper {\n  width: 20px;\n}\na.g-menu-item,\na.soptclass,\na.clearsearchclass {\n  cursor: pointer;\n}\n.ui-jqgrid .ui-jqgrid-view input,\n.ui-jqgrid .ui-jqgrid-view select,\n.ui-jqgrid .ui-jqgrid-view textarea,\n.ui-jqgrid .ui-jqgrid-view button {\n  font-size: 11px;\n}\n.ui-jqgrid .ui-scroll-popup {\n  width: 95px;\n}\n.ui-search-table select,\n.ui-search-table input {\n  padding: 4px 3px;\n}\n/* Column menu */\n.ui-jqgrid .ui-jqgrid-htable .colmenu {\n  position: absolute;\n  right: 1px;\n  height: 100%;\n  color: black;\n}\n.ui-jqgrid .ui-jqgrid-htable .colmenu-rtl {\n  right: auto;\n  left: 1px;\n}\n.ui-jqgrid .ui-jqgrid-htable .colmenuspan {\n  display: inline-block;\n}\n.ui-jqgrid .ui-jqgrid-htable .ui-th-div {\n  height: 17px;\n  margin-top: 5px;\n  display: inine-block;\n}\n.column-menu,\n.ui-search-menu {\n  padding: 10px 10px;\n}\n.column-menu .divider {\n  background-color: #e5e5e5;\n  height: 1px;\n  padding: 0 0;\n  margin: 5px 0;\n  overflow: hidden;\n}\n.ui-menu-item .ui-common-table .menu_icon {\n  white-space: pre;\n  padding-right: 4px;\n  padding-left: 4px;\n  width: auto;\n}\n.ui-menu-item .ui-common-table .menu_icon .ui-icon {\n  display: inline-block;\n  position: relative;\n}\ntd.menu_text {\n  width: auto;\n  white-space: nowrap;\n}\n.ui-search-menu .ui-menu-item {\n  padding: 0 0;\n}\n.ui-col-menu .ui-menu-item td.menu_text {\n  padding-top: 0;\n  padding-bottom: 0;\n  padding-left: 1px;\n}\n.ui-col-menu .ui-menu-item td.menu_icon {\n  padding-top: 0;\n  padding-bottom: 0;\n  vertical-align: middle;\n}\n.ui-col-menu .ui-menu-item td.menu_icon input {\n  margin: 2px 0;\n}\n#search_menu .ui-menu-item div {\n  margin: 3px 0;\n  white-space: nowrap;\n}\n#search_menu .ui-menu-item div input,\n#search_menu .ui-menu-item div select {\n  padding: 3px 2px;\n}\n#search_menu .search_buttons {\n  display: inline-block;\n  width: 50%;\n}\n#column_menu.ui-menu .ui-menu-item {\n  position: static;\n}\n/* \u4FEE\u6539jqGrid\u6837\u5F0F\u548Cbang-UI\u7EDF\u4E00\u6837\u5F0F\u98CE\u683C */\n.jq-grid-container {\n  /* \u81EA\u5B9A\u4E49\u7C7B\u540D\u6837\u5F0F */\n  /* \u884C\u7F16\u8F91\u3001\u6DFB\u52A0\u3001\u5220\u9664 */\n}\n.jq-grid-container .jqgroup b {\n  font-weight: 700;\n  color: #494949;\n  font-size: 14px;\n}\n.jq-grid-container .jqgroup .ui-icon-circlesmall-minus {\n  border-radius: 2px;\n  display: inline-block;\n  margin-top: 6px;\n  width: 0;\n  height: 0;\n  border-left: 8px dashed transparent;\n  border-right: 8px dashed transparent;\n  border-top: 10px solid #494949;\n}\n.jq-grid-container .jqgroup .ui-icon-circlesmall-plus {\n  border-radius: 2px;\n  display: inline-block;\n  margin-top: 2px;\n  width: 0;\n  height: 0;\n  border-bottom: 8px dashed transparent;\n  border-top: 8px dashed transparent;\n  border-left: 10px solid #494949;\n}\n.jq-grid-container .ui-jqgrid-caption {\n  min-height: 30px;\n  padding: 4px 8px;\n  border: 1px solid #E9E9E9;\n  margin-bottom: -1px;\n}\n.jq-grid-container .ui-jqgrid-caption .HeaderButton {\n  margin-right: 12px;\n}\n.jq-grid-container .ui-jqgrid-caption .ui-jqgrid-headlink {\n  font-family: Arial;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 50%;\n  min-width: 20px;\n  height: 20px;\n  line-height: 18px;\n  font-size: 18px;\n  text-align: center;\n  transition: all .3s;\n  vertical-align: middle;\n  border: 1px solid #999;\n}\n.jq-grid-container .ui-jqgrid-caption .ui-jqgrid-headlink.ui-icon-circle-triangle-n:after {\n  content: '-';\n}\n.jq-grid-container .ui-jqgrid-caption .ui-jqgrid-headlink.ui-icon-circle-triangle-s:after {\n  content: '+';\n}\n.jq-grid-container .ng-jq-grid-table tr {\n  transition: all .3s;\n  background-color: #FFF;\n}\n.jq-grid-container .ng-jq-grid-table tr:hover {\n  background-color: #ECF6FD;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable {\n  empty-cells: hide;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable .ui-jqgrid-sortable .s-ico .ui-grid-ico-sort {\n  display: inline-block;\n  margin-left: 4px;\n  width: 0;\n  height: 0;\n  border-left: 6px dashed transparent;\n  border-right: 6px dashed transparent;\n  border-radius: 2px;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable .ui-jqgrid-sortable .s-ico .ui-grid-ico-sort.ui-icon-asc {\n  border-bottom: 6px solid #333;\n  margin-top: 3px;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable .ui-jqgrid-sortable .s-ico .ui-grid-ico-sort.ui-icon-asc.ui-state-disabled {\n  border-bottom-color: #999;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable .ui-jqgrid-sortable .s-ico .ui-grid-ico-sort.ui-icon-desc {\n  border-top: 6px solid #333;\n  margin-top: 11px;\n}\n.jq-grid-container .ui-jqgrid table.ui-jqgrid-htable .ui-jqgrid-sortable .s-ico .ui-grid-ico-sort.ui-icon-desc.ui-state-disabled {\n  border-top-color: #999;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view tr.ui-state-highlight {\n  background-color: #DFF0D8;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view th {\n  border-right: 1px solid #E9E9E9;\n  border-bottom: 1px solid #E9E9E9 !important;\n  border-top: 1px solid #E9E9E9 !important;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view th:first-of-type {\n  border-left: 1px solid #E9E9E9;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view td {\n  border-right: 1px solid #E9E9E9;\n  border-bottom: 1px solid #E9E9E9;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view td:first-of-type {\n  border-left: 1px solid #E9E9E9;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view td {\n  padding: 10px 8px;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view td:empty {\n  padding: 0;\n  border: 0 none;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-view th {\n  background-color: #F5F5F5;\n  color: #494949;\n  padding: 6px 0;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager .ui-pager-control {\n  height: 26px;\n  padding: 2px 8px 10px;\n  box-sizing: content-box;\n  color: #494949;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr {\n  height: 30px;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon {\n  font-family: Arial;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 4px;\n  min-width: 26px;\n  height: 26px;\n  line-height: 26px;\n  text-align: center;\n  transition: all .3s;\n  vertical-align: middle;\n  border: 1px solid #999;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr input.ui-pg-input,\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr select.ui-pg-selbox {\n  height: 22px;\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  margin: 0 4px;\n  border-radius: 4px;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr input.ui-pg-input:focus,\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr select.ui-pg-selbox:focus {\n  outline: none !important;\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(16, 142, 233, 0.6);\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-separator {\n  border: 0 none;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon:hover {\n  border-color: #108ee9;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon-seek-first:after {\n  content: \"|<\";\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon-seek-prev:after {\n  content: \"<\";\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon-seek-next:after {\n  content: \">\";\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-icon-seek-end:after {\n  content: \">|\";\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-corner-all.ui-state-disabled {\n  cursor: not-allowed !important;\n}\n.jq-grid-container .ui-jqgrid .ui-jqgrid-pager tr .ui-corner-all.ui-state-disabled .ui-icon {\n  border-color: #d9d9d9;\n  color: rgba(0, 0, 0, 0.15);\n}\n.jq-grid-container .ui-jqgrid .ui-search-toolbar th {\n  padding: 0;\n}\n.jq-grid-container .ui-jqgrid .ui-search-toolbar .ui-search-input input {\n  display: block;\n  width: 100%;\n  height: 34px;\n  padding: 6px 12px;\n  font-size: 14px;\n  line-height: 1.42857143;\n  color: #555;\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #ccc;\n  border-radius: 4px;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  -webkit-transition: border-color ease-in-out 0.15s, -webkit-box-shadow ease-in-out 0.15s;\n  -o-transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n  transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n}\n.jq-grid-container .ui-jqgrid .ui-search-toolbar .ui-search-input input:focus {\n  border-color: #66afe9;\n  outline: 0;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n}\n.jq-grid-container .ui-pg-table.ui-common-table .ui-state-disabled:empty {\n  display: none;\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-document:after {\n  content: '\u67E5\u770B';\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-search:after {\n  content: '\u67E5\u627E';\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-refresh:after {\n  content: '\u5237\u65B0';\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-pencil:after {\n  content: '\u7F16\u8F91';\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-plus:after {\n  content: '\u6DFB\u52A0';\n}\n.jq-grid-container .ui-pg-table.ui-common-table span.ui-icon-trash:after {\n  content: '\u5220\u9664';\n}\n.jq-grid-container .frozen-bdiv {\n  margin-top: -1px;\n}\n.jq-grid-container tr.ng-jq-grid-even {\n  background-color: #F9F9F9;\n}\n.jq-grid-container .ng-jq-grid-btn {\n  display: inline-block;\n  margin-right: 4px;\n  font-weight: 500;\n  text-align: center;\n  -ms-touch-action: manipulation;\n  touch-action: manipulation;\n  cursor: pointer;\n  border: 1px solid #d9d9d9;\n  white-space: nowrap;\n  padding: 4px 10px;\n  font-size: 12px;\n  border-radius: 4px;\n  -webkit-user-select: none;\n  -moz-user-select: none;\n  -ms-user-select: none;\n  user-select: none;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  position: relative;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n}\n.jq-grid-container .ng-jq-grid-btn:hover {\n  color: #108ee9;\n  border-color: #108ee9;\n}\n.jq-grid-container .ng-jq-grid-btn:focus {\n  outline: 0;\n}\n.jq-grid-container .jqgrow .ui-pg-div {\n  cursor: pointer;\n  font-family: Arial;\n  color: rgba(0, 0, 0, 0.65);\n  min-width: 26px;\n  height: 26px;\n  line-height: 26px;\n  text-align: center;\n  transition: all .3s;\n  vertical-align: middle;\n}\n.jq-grid-container .jqgrow .ui-pg-div.ui-inline-edit:after {\n  content: '\u7F16\u8F91';\n  transform: scale(0.8);\n}\n.jq-grid-container .jqgrow .ui-pg-div.ui-inline-del:after {\n  content: '\u5220\u9664';\n}\n.jq-grid-container .jqgrow .ui-pg-div.ui-inline-save:after {\n  content: '\u4FDD\u5B58';\n}\n.jq-grid-container .jqgrow .ui-pg-div.ui-inline-cancel:after {\n  content: '\u53D6\u6D88';\n}\n.jq-grid-container .jqgrow input.inline-edit-cell.ui-corner-all {\n  display: block;\n  width: 94%;\n  height: 34px;\n  padding: 6px 12px;\n  font-size: 14px;\n  line-height: 1.42857143;\n  color: #555;\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #ccc;\n  border-radius: 4px;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  -webkit-transition: border-color ease-in-out 0.15s, -webkit-box-shadow ease-in-out 0.15s;\n  -o-transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n  transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n}\n.jq-grid-container .jqgrow input.inline-edit-cell.ui-corner-all:focus {\n  border-color: #66afe9;\n  outline: 0;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n}\n/* \u5DE5\u5177\u680F\u76F8\u5173 */\n.ui-jqdialog {\n  height: auto !important;\n  background-color: #fff;\n  padding: 0 0 10px;\n  -webkit-background-clip: padding-box;\n  background-clip: padding-box;\n  border: 1px solid #999;\n  border: 1px solid rgba(0, 0, 0, 0.2);\n  border-radius: 6px;\n  outline: 0;\n  -webkit-box-shadow: 0 3px 9px rgba(0, 0, 0, 0.5);\n  box-shadow: 0 3px 9px rgba(0, 0, 0, 0.5);\n}\n.ui-jqdialog .ui-jqdialog-titlebar {\n  border-bottom: 1px solid #E5E5E5;\n  min-height: 35px;\n}\n.ui-jqdialog .ui-jqdialog-title {\n  margin: .4em .2em .2em .5em;\n}\n.ui-jqdialog .ui-jqdialog-titlebar-close {\n  margin-right: 6px;\n}\n.ui-jqdialog .ui-icon-closethick {\n  display: inline-block;\n  font-family: Arial;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 9px;\n  min-width: 18px;\n  height: 18px;\n  line-height: 18px;\n  text-align: center;\n  transition: all .3s;\n  vertical-align: middle;\n  border: 1px solid #999;\n}\n.ui-jqdialog .ui-icon-closethick span {\n  display: inline-block;\n}\n.ui-jqdialog .ui-icon-closethick:hover {\n  border-color: #108ee9;\n}\n.ui-jqdialog .ui-icon-closethick:after {\n  content: \"X\";\n}\n.ui-jqdialog .navButton #nData,\n.ui-jqdialog .navButton #pData {\n  margin: 3px 12px;\n}\n.ui-jqdialog .navButton .ui-icon {\n  display: inline-block;\n  font-family: Arial;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 4px;\n  min-width: 26px;\n  height: 26px;\n  line-height: 26px;\n  text-align: center;\n  transition: all .3s;\n  vertical-align: middle;\n  border: 1px solid #999;\n}\n.ui-jqdialog .navButton .ui-icon:hover {\n  border-color: #108ee9;\n}\n.ui-jqdialog .navButton .ui-icon-triangle-1-w:after {\n  content: '<';\n}\n.ui-jqdialog .navButton .ui-icon-triangle-1-e:after {\n  content: '>';\n}\n.ui-jqdialog .CaptionTD label {\n  font-weight: 700;\n  padding-left: 8px;\n}\n.ui-jqdialog input.FormElement.ui-corner-all {\n  margin-top: -10px;\n  margin-left: -14px;\n  display: block;\n  width: 94%;\n  height: 34px;\n  padding: 6px 12px;\n  font-size: 14px;\n  line-height: 1.42857143;\n  color: #555;\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #ccc;\n  border-radius: 4px;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  -webkit-transition: border-color ease-in-out 0.15s, -webkit-box-shadow ease-in-out 0.15s;\n  -o-transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n  transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n}\n.ui-jqdialog input.FormElement.ui-corner-all:focus {\n  border-color: #66afe9;\n  outline: 0;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n}\n.ui-jqdialog hr {\n  border: 0 none;\n  border-top: 1px solid #E5E5E5;\n}\n.ui-jqdialog .ui-search-table select.ui-widget-content,\n.ui-jqdialog .ui-search-table input.input-elm {\n  display: block;\n  width: 100%;\n  height: 34px;\n  padding: 6px 12px;\n  font-size: 14px;\n  line-height: 1.42857143;\n  color: #555;\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #ccc;\n  border-radius: 4px;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075);\n  -webkit-transition: border-color ease-in-out 0.15s, -webkit-box-shadow ease-in-out 0.15s;\n  -o-transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n  transition: border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s;\n}\n.ui-jqdialog .ui-search-table select.ui-widget-content:focus,\n.ui-jqdialog .ui-search-table input.input-elm:focus {\n  border-color: #66afe9;\n  outline: 0;\n  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n  box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(102, 175, 233, 0.6);\n}\n.ui-jqdialog .confirm.ui-jqconfirm {\n  background-color: #fff;\n  border-radius: 4px;\n  border: 1px solid rgba(0, 0, 0, 0.1);\n}\n"],
                encapsulation: core.ViewEncapsulation.None,
                providers: [JqGridService]
            },] },
];
/** @nocollapse */
JqGridComponent.ctorParameters = function () { return [
    { type: JqGridService, },
    { type: core.ElementRef, },
    { type: core.KeyValueDiffers, },
]; };
JqGridComponent.propDecorators = {
    "data": [{ type: core.Input },],
    "colModel": [{ type: core.Input },],
    "viewrecords": [{ type: core.Input },],
    "rownumbers": [{ type: core.Input },],
    "rownumWidth": [{ type: core.Input },],
    "altRows": [{ type: core.Input },],
    "caption": [{ type: core.Input },],
    "hidegrid": [{ type: core.Input },],
    "hiddengrid": [{ type: core.Input },],
    "rowNum": [{ type: core.Input },],
    "rowList": [{ type: core.Input },],
    "sortname": [{ type: core.Input },],
    "sortorder": [{ type: core.Input },],
    "multiSort": [{ type: core.Input },],
    "forceFit": [{ type: core.Input },],
    "grouping": [{ type: core.Input },],
    "groupingView": [{ type: core.Input },],
    "shrinkToFit": [{ type: core.Input },],
    "autowidth": [{ type: core.Input },],
    "width": [{ type: core.Input },],
    "colNames": [{ type: core.Input },],
    "deselectAfterSort": [{ type: core.Input },],
    "height": [{ type: core.Input },],
    "page": [{ type: core.Input },],
    "pgbuttons": [{ type: core.Input },],
    "pginput": [{ type: core.Input },],
    "hidePagerBar": [{ type: core.Input },],
    "url": [{ type: core.Input },],
    "mtype": [{ type: core.Input },],
    "datatype": [{ type: core.Input },],
    "jsonReader": [{ type: core.Input },],
    "editurl": [{ type: core.Input },],
    "loadonce": [{ type: core.Input },],
    "groupHeaders": [{ type: core.Input },],
    "showFiltertoolBar": [{ type: core.Input },],
    "toolBarSettings": [{ type: core.Input },],
    "flozenColums": [{ type: core.Input },],
    "rightClickRow": [{ type: core.Output },],
    "dblClickRow": [{ type: core.Output },],
    "clickCell": [{ type: core.Output },],
    "paging": [{ type: core.Output },],
    "beforeSelectRow": [{ type: core.Output },],
    "afterInsertRow": [{ type: core.Output },],
    "beforeRequest": [{ type: core.Output },],
    "gridComplete": [{ type: core.Output },],
    "loadComplete": [{ type: core.Output },],
    "loadError": [{ type: core.Output },],
    "jqGridTable": [{ type: core.ViewChild, args: ['jqGridTable',] },],
    "jqGridPager": [{ type: core.ViewChild, args: ['jqGridPager',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var JqGridModule = (function () {
    function JqGridModule() {
    }
    return JqGridModule;
}());
JqGridModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [JqGridComponent],
                exports: [JqGridComponent],
                entryComponents: [JqGridComponent],
                providers: [JqGridService]
            },] },
];
/** @nocollapse */
JqGridModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EChartsService = (function () {
    function EChartsService() {
    }
    /**
     * @param {?} value
     * @return {?}
     */
    EChartsService.prototype.setCharts = function (value) {
        this.myECharts = value;
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.getECharts = function () {
        return this.myECharts;
    };
    /**
     * @param {?} option
     * @param {?=} notMerge
     * @param {?=} lazyUpdate
     * @return {?}
     */
    EChartsService.prototype.setOption = function (option, notMerge, lazyUpdate) {
        this.myECharts.setOption(option, notMerge, lazyUpdate);
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.getWidth = function () {
        return this.myECharts.getWidth();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.getHeight = function () {
        return this.myECharts.getHeight();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.getDom = function () {
        return this.myECharts.getDom();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.getOption = function () {
        return this.myECharts.getOption();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.resize = function () {
        this.myECharts.resize();
    };
    /**
     * @param {?} payload
     * @return {?}
     */
    EChartsService.prototype.dispatchAction = function (payload) {
        this.myECharts.dispatchAction(payload);
    };
    /**
     * @param {?} eventName
     * @param {?} handler
     * @param {?=} context
     * @return {?}
     */
    EChartsService.prototype.on = function (eventName, handler, context) {
        this.myECharts.on(eventName, handler, context);
    };
    /**
     * @param {?} eventName
     * @param {?=} handler
     * @return {?}
     */
    EChartsService.prototype.off = function (eventName, handler) {
        this.myECharts.off(eventName, handler);
    };
    /**
     * @param {?} finder
     * @param {?} value
     * @return {?}
     */
    EChartsService.prototype.convertToPixel = function (finder, 
        // 要被转换的值。
        // 转换的结果为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。)
        // 要被转换的值。
        // 转换的结果为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。)
        value) {
        return this.myECharts.convertToPixel(finder, value);
    };
    /**
     * @param {?} finder
     * @param {?} value
     * @return {?}
     */
    EChartsService.prototype.convertFromPixel = function (finder, 
        // 要被转换的值，为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。
        // 要被转换的值，为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。
        value) {
        return this.myECharts.convertFromPixel(finder, value);
    };
    /**
     * @param {?} finder
     * @param {?} value
     * @return {?}
     */
    EChartsService.prototype.containPixel = function (finder, 
        // 要被判断的点，为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。
        // 要被判断的点，为像素坐标值，以 echarts 实例的 dom 节点的左上角为坐标 [0, 0] 点。
        value) {
        return this.myECharts.containPixel(finder, value);
    };
    /**
     * @param {?=} type
     * @param {?=} opts
     * @return {?}
     */
    EChartsService.prototype.showLoading = function (type, opts) {
        this.myECharts.showLoading();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.hideLoading = function () {
        this.myECharts.hideLoading();
    };
    /**
     * @param {?} opts
     * @return {?}
     */
    EChartsService.prototype.getDataURL = function (opts) {
        return this.myECharts.getDataURL(opts);
    };
    /**
     * @param {?} opts
     * @return {?}
     */
    EChartsService.prototype.getConnectedDataURL = function (opts) {
        return this.myECharts.getConnectedDataURL(opts);
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.clear = function () {
        this.myECharts.clear();
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.dispose = function () {
        this.myECharts.dispose();
        this.myECharts = null;
    };
    /**
     * @return {?}
     */
    EChartsService.prototype.isDisposed = function () {
        return this.myECharts ? this.myECharts.isDisposed() : true;
    };
    return EChartsService;
}());
EChartsService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
EChartsService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var BgEChartsComponent = (function () {
    /**
     * @param {?} el
     * @param {?} ngZone
     * @param {?} ecs
     */
    function BgEChartsComponent(el, ngZone, ecs) {
        this.el = el;
        this.ngZone = ngZone;
        this.ecs = ecs;
        this.echarts = require('echarts');
        this.currentWindowWidth = null;
        this.theme = 'default';
        this.onBeforeInit = new core.EventEmitter();
        this.onAfterInit = new core.EventEmitter();
        this.onOptionChange = new core.EventEmitter();
        // chart events:
        this.chartClick = new core.EventEmitter();
        this.chartDblClick = new core.EventEmitter();
        this.chartMouseDown = new core.EventEmitter();
        this.chartMouseUp = new core.EventEmitter();
        this.chartMouseOver = new core.EventEmitter();
        this.chartMouseOut = new core.EventEmitter();
        this.chartGlobalOut = new core.EventEmitter();
        this.chartContextMenu = new core.EventEmitter();
        this.chartDataZoom = new core.EventEmitter();
    }
    Object.defineProperty(BgEChartsComponent.prototype, "option", {
        /**
         * @return {?}
         */
        get: function () {
            return this._option;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._option = value;
            if (this._eCharts) {
                this._eCharts.setOption(value);
                this.onOptionChange.emit(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BgEChartsComponent.prototype, "group", {
        /**
         * @return {?}
         */
        get: function () {
            return this._gourp;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._gourp = value;
            this.setGroup();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BgEChartsComponent.prototype.setGroup = function () {
        this._eCharts && (typeof this._gourp !== 'undefined') && (((this._eCharts)).group = this._gourp);
    };
    /**
     * @return {?}
     */
    BgEChartsComponent.prototype.init = function () {
        var _this = this;
        if (!this._eCharts) {
            this.ngZone.runOutsideAngular(function () {
                _this.onBeforeInit.emit();
                _this._eCharts = ((_this.echarts.init(_this.host.nativeElement, _this.theme, _this.style ? {} : { 'height': '400px' })));
                _this.ecs.setCharts(_this._eCharts);
                _this.onAfterInit.emit();
                // this.ecs.showLoading();
                _this.option && _this._eCharts.setOption(_this.option);
                _this.registerEvents(_this._eCharts);
                _this.setGroup();
                // this.ecs.hideLoading();
                _this.currentWindowWidth = window.innerWidth;
            });
        }
        else {
            this.option && this._eCharts.setOption(this.option);
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BgEChartsComponent.prototype.onWindowResize = function (event) {
        if (event.target.innerWidth !== this.currentWindowWidth) {
            this.currentWindowWidth = event.target.innerWidth;
            if (this._eCharts) {
                this.ecs.resize();
            }
        }
    };
    /**
     * @param {?} group
     * @return {?}
     */
    BgEChartsComponent.prototype.connect = function (group) {
        this.echarts.connect(group);
    };
    /**
     * @param {?} group
     * @return {?}
     */
    BgEChartsComponent.prototype.disconnect = function (group) {
        ((this.echarts)).disconnect(group);
    };
    /**
     * @return {?}
     */
    BgEChartsComponent.prototype.dispose = function () {
        this._eCharts.dispose();
        this._eCharts = null;
    };
    /**
     * @param {?} eCharts
     * @return {?}
     */
    BgEChartsComponent.prototype.registerEvents = function (eCharts) {
        var _this = this;
        if (eCharts) {
            // register mouse events:
            this.ecs.on('click', function (e) { _this.chartClick.emit(e); });
            this.ecs.on('dblClick', function (e) { _this.chartDblClick.emit(e); });
            this.ecs.on('mousedown', function (e) { _this.chartMouseDown.emit(e); });
            this.ecs.on('mouseup', function (e) { _this.chartMouseUp.emit(e); });
            this.ecs.on('mouseover', function (e) { _this.chartMouseOver.emit(e); });
            this.ecs.on('mouseout', function (e) { _this.chartMouseOut.emit(e); });
            this.ecs.on('globalout', function (e) { _this.chartGlobalOut.emit(e); });
            this.ecs.on('contextmenu', function (e) { _this.chartContextMenu.emit(e); });
            // other events;
            this.ecs.on('dataZoom', function (e) { _this.chartDataZoom.emit(e); });
        }
    };
    /**
     * @return {?}
     */
    BgEChartsComponent.prototype.ngAfterViewInit = function () {
        this.init();
    };
    /**
     * @return {?}
     */
    BgEChartsComponent.prototype.ngOnDestroy = function () {
        this.dispose();
    };
    return BgEChartsComponent;
}());
BgEChartsComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bgc-echarts',
                template: "<div #host [ngStyle]=\"style\"></div>\n",
                styles: [""],
                providers: [EChartsService]
            },] },
];
/** @nocollapse */
BgEChartsComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core.NgZone, },
    { type: EChartsService, },
]; };
BgEChartsComponent.propDecorators = {
    "style": [{ type: core.Input },],
    "theme": [{ type: core.Input },],
    "option": [{ type: core.Input },],
    "group": [{ type: core.Input },],
    "onBeforeInit": [{ type: core.Output },],
    "onAfterInit": [{ type: core.Output },],
    "onOptionChange": [{ type: core.Output },],
    "chartClick": [{ type: core.Output },],
    "chartDblClick": [{ type: core.Output },],
    "chartMouseDown": [{ type: core.Output },],
    "chartMouseUp": [{ type: core.Output },],
    "chartMouseOver": [{ type: core.Output },],
    "chartMouseOut": [{ type: core.Output },],
    "chartGlobalOut": [{ type: core.Output },],
    "chartContextMenu": [{ type: core.Output },],
    "chartDataZoom": [{ type: core.Output },],
    "host": [{ type: core.ViewChild, args: ['host',] },],
    "onWindowResize": [{ type: core.HostListener, args: ['window:resize', ['$event'],] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$5 = [BgEChartsComponent];
var BgEChartsModule = (function () {
    function BgEChartsModule() {
    }
    return BgEChartsModule;
}());
BgEChartsModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                ],
                exports: COMPONENTS$5.slice(),
                declarations: COMPONENTS$5.slice(),
                providers: [EChartsService]
            },] },
];
/** @nocollapse */
BgEChartsModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DaterangepickerComponent = (function () {
    /**
     * @param {?} _elementRef
     * @param {?} _renderer
     */
    function DaterangepickerComponent(_elementRef, _renderer) {
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this.nextMonth = new Date().setMonth(new Date().getMonth() + 1);
        this.nowMonth = new Date();
        this._showMonth = moment().month();
        this._showYear = moment().year();
        this._showLastYear = moment().month() == 11 ? moment().year() + 1 : moment().year();
        this._showLastMonth = moment().month() == 11 ? 0 : moment().month() + 1;
        this._showMiddleBg = [];
        this._startDate = null;
        this._endDate = null;
        this._width = '180px';
        this._isRemoveBtn = true;
        this._isDatepickerHide = false;
        this._btnType = 'default';
        this._placeholder = '请选择...';
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
    }
    Object.defineProperty(DaterangepickerComponent.prototype, "antShortcuts", {
        /**
         * @return {?}
         */
        get: function () {
            return this._shortcuts;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._shortcuts = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DaterangepickerComponent.prototype, "antCustomShortcuts", {
        /**
         * @return {?}
         */
        get: function () {
            return this._customShortcuts;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._customShortcuts = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DaterangepickerComponent.prototype, "isDatepickerHide", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            value = value ? value : false;
            this._isDatepickerHide = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DaterangepickerComponent.prototype, "antploceholder", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value !== undefined) {
                this._placeholder = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DaterangepickerComponent.prototype, "antWidth", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (value) {
                this._width = value + 'px';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DaterangepickerComponent.prototype, "antSize", {
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._size = { large: 'ant-input-lg', small: 'ant-input-sm' }[value];
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} btn
     * @return {?}
     */
    DaterangepickerComponent.prototype.onClick = function (btn) {
        if (!this._elementRef.nativeElement.contains(event.target)) {
            // 关闭datepicker
            this._isDatepickerHide = false;
        }
    };
    /**
     * 双向绑定，接收数据
     * @param {?} value
     * @return {?}
     */
    DaterangepickerComponent.prototype.writeValue = function (value) {
        var _this = this;
        if (value) {
            if (value.indexOf('~') > -1 && value.length > 15) {
                var /** @type {?} */ arr_1 = value.split('~');
                var /** @type {?} */ month = moment(arr_1[0]).month(), /** @type {?} */ year = moment(arr_1[0]).year(), /** @type {?} */ monthLast = moment(arr_1[1]).month(), /** @type {?} */ yearLast = moment(arr_1[1]).year();
                this._showMonth = month;
                this._showYear = year;
                if (month === monthLast && year === yearLast) {
                    // const _month = moment().month();
                    // const _year = moment().year();
                    this._showLastMonth = this._showMonth == 11 ? 0 : this._showMonth + 1;
                    this._showLastYear = this._showMonth == 11 ? this._showYear + 1 : this._showYear;
                    setTimeout(function (_) {
                        _this._startDate = _this.findItemDay(_this.datepickerData, moment(arr_1[0]).format('YYYY-MM-DD'));
                        _this._endDate = _this.findItemDay(_this.datepickerData, moment(arr_1[1]).format('YYYY-MM-DD'));
                        _this.enterStartAndEnd();
                    });
                }
                else {
                    this._showLastMonth = monthLast;
                    this._showLastYear = yearLast;
                    setTimeout(function (_) {
                        _this._startDate = _this.findItemDay(_this.datepickerData, moment(arr_1[0]).format('YYYY-MM-DD'));
                        _this._endDate = _this.findItemDay(_this.datepickerDataLast, moment(arr_1[1]).format('YYYY-MM-DD'));
                        _this.enterStartAndEnd();
                    });
                }
            }
        }
        else {
            this.remove();
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    DaterangepickerComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    DaterangepickerComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.ngOnInit = function () {
        // this._shortcuts = [
        //   {
        //     title: '过去',
        //     tag: 'prev',
        //     datas: [1, 3, 5, 7]
        //   },
        //   {
        //     title: '将来',
        //     tag: 'next',
        //     datas: [1, 3, 9]
        //   }
        // ];
        //   this._customShortcuts = [{
        //     name: '这个月',
        //     dates : [moment().startOf('month').toDate(), moment().endOf('month').toDate()]
        // }, {
        //     name: '上个月',
        //     dates : [
        //             moment().subtract(1, 'month').startOf('month').toDate(),
        //             moment().subtract(1, 'month').endOf('month').toDate()
        //         ]
        // }];
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._preMonth = function () {
        var _this = this;
        if (this._showMonth - 1 < 0) {
            this._showMonth = 11;
            this._preYear();
        }
        else {
            this._showMonth = this._showMonth - 1;
        }
        setTimeout(function (_) {
            _this.showStartAndEnd();
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._nextMonth = function () {
        var _this = this;
        if (this._showMonth + 1 > 11) {
            this._showMonth = 0;
            this._nextYear();
        }
        else {
            this._showMonth = this._showMonth + 1;
        }
        setTimeout(function (_) {
            _this.showStartAndEnd();
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._preYear = function () {
        this._showYear = this._showYear - 1;
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._nextYear = function () {
        this._showYear = this._showYear + 1;
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._preLastMonth = function () {
        var _this = this;
        if (this._showLastMonth - 1 < 0) {
            this._showLastMonth = 11;
            this._preLastYear();
        }
        else {
            this._showLastMonth = this._showLastMonth - 1;
        }
        setTimeout(function (_) {
            _this.showStartAndEnd();
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._nextLastMonth = function () {
        var _this = this;
        if (this._showLastMonth + 1 > 11) {
            this._showLastMonth = 0;
            this._nextLastYear();
        }
        else {
            this._showLastMonth = this._showLastMonth + 1;
        }
        setTimeout(function (_) {
            _this.showStartAndEnd();
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._preLastYear = function () {
        this._showLastYear = this._showLastYear - 1;
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype._nextLastYear = function () {
        this._showLastYear = this._showLastYear + 1;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    DaterangepickerComponent.prototype.clickDay = function (data) {
        if (!data.day.isSelectedDay) {
            data.day.isSelectedDay = true;
        }
        if (!this.isEmptyObject(this._startDate)) {
            this._startDate = data.day;
            this._endDate = { title: '...' };
            // this._result = '';
            // this.onChange('');
            return;
        }
        if (this.isEmptyObject(this._startDate) && !this.isEmptyObject(this._endDate)) {
            if (this._startDate['title'] > data.day['title']) {
                this._endDate = this._startDate;
                this._startDate = data.day;
            }
            else {
                this._endDate = data.day;
            }
            this._result = this._startDate['title'] + "~" + this._endDate['title'];
            this._btnType = 'primary';
            this.onChange(this._result);
            return;
        }
        this.resetDatepicker(this.datepickerData);
        this.resetDatepicker(this.datepickerDataLast);
        this._startDate = data.day;
        data.day.isSelectedDay = true;
        this._endDate = { title: '...' };
        // this._result = '';
        // this.onChange('');
    };
    /**
     * 鼠标移入
     * @param {?} data
     * @return {?}
     */
    DaterangepickerComponent.prototype.mouseDay = function (data) {
        if (this.isEmptyObject(this._startDate) && !this.isEmptyObject(this._endDate)) {
            this.isMiddleDay(this.datepickerData._weeksCalendar, data.day);
            this.isMiddleDay(this.datepickerDataLast._weeksCalendar, data.day);
        }
    };
    /**
     * @param {?} array
     * @param {?} day
     * @return {?}
     */
    DaterangepickerComponent.prototype.isMiddleDay = function (array, day) {
        var _this = this;
        array.forEach(function (element) {
            element.days.forEach(function (item) {
                if (item.title > _this._startDate['title']) {
                    if (item.title <= day.title) {
                        item.isMiddleDay = true;
                        item.distanceStartDay = _this.DateDiff(_this._startDate['title'], item.title);
                    }
                    else {
                        item.isMiddleDay = false;
                    }
                    return;
                }
                if (item.title < _this._startDate['title']) {
                    if (item.title >= day.title) {
                        item.isMiddleDay = true;
                        item.distanceStartDay = _this.DateDiff(_this._startDate['title'], item.title);
                    }
                    else {
                        item.isMiddleDay = false;
                    }
                }
            });
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.showStartAndEnd = function () {
        if (this.isEmptyObject(this._startDate)) {
            this.showSelected(this.datepickerData);
            this.showSelected(this.datepickerDataLast);
        }
        if (this.isEmptyObject(this._endDate)) {
            this.showSelected(this.datepickerData, true);
            this.showSelected(this.datepickerDataLast, true);
        }
    };
    /**
     * @param {?} sDate1
     * @param {?} sDate2
     * @return {?}
     */
    DaterangepickerComponent.prototype.DateDiff = function (sDate1, sDate2) {
        // sDate1和sDate2是2006-12-18格式
        if (!sDate2) {
            return;
        }
        var /** @type {?} */ aDate, /** @type {?} */ oDate1, /** @type {?} */ oDate2, /** @type {?} */ iDays;
        aDate = sDate1.split('-');
        oDate1 = new Date(aDate[1] + "-" + aDate[2] + "-" + aDate[0]); // 转换为12-18-2006格式
        aDate = sDate2.split('-');
        oDate2 = new Date(aDate[1] + "-" + aDate[2] + "-" + aDate[0]);
        iDays = parseInt(String(Math.abs(oDate1 - oDate2) / 1000 / 60 / 60 / 24), 10);
        return iDays + 1;
    };
    /**
     * @param {?} object
     * @return {?}
     */
    DaterangepickerComponent.prototype.isEmptyObject = function (object) {
        if (object === null) {
            return false;
        }
        return object.hasOwnProperty('isSelectedDay');
    };
    /**
     * @param {?} obj
     * @param {?=} isMiddle
     * @return {?}
     */
    DaterangepickerComponent.prototype.showSelected = function (obj, isMiddle) {
        var /** @type {?} */ _this = this;
        obj['_weeksCalendar'].forEach(function (element) {
            element.days.forEach(function (item) {
                if (_this._startDate['title'] === item.title && !item.isLastMonth && !item.isNextMonth) {
                    item.isSelectedDay = true;
                }
                if (isMiddle) {
                    if (_this._endDate['title'] === item.title && !item.isLastMonth && !item.isNextMonth) {
                        item.isSelectedDay = true;
                    }
                    if (_this._startDate['title'] < item.title && _this._endDate['title'] > item.title) {
                        item.isMiddleDay = true;
                    }
                }
            });
        });
    };
    /**
     * @param {?} obj
     * @return {?}
     */
    DaterangepickerComponent.prototype.resetDatepicker = function (obj) {
        obj['_weeksCalendar'].forEach(function (element) {
            element.days.forEach(function (item) {
                item.isMiddleDay = false;
                item.isSelectedDay = false;
            });
        });
    };
    /**
     * @param {?} day
     * @param {?=} tag
     * @return {?}
     */
    DaterangepickerComponent.prototype.shortcutOption = function (day, tag) {
        var _this = this;
        var /** @type {?} */ arrDate = [];
        this.resetDatepicker(this.datepickerData);
        this.resetDatepicker(this.datepickerDataLast);
        if (typeof day === 'number') {
            this.assignStartEndDay(day, tag);
        }
        if (typeof day === 'object') {
            arrDate = day['dates'];
            var /** @type {?} */ _month = moment(arrDate[0]).month();
            var /** @type {?} */ _year = moment(arrDate[0]).year();
            var /** @type {?} */ _monthLast = moment(arrDate[1]).month();
            var /** @type {?} */ _yearLast = moment(arrDate[1]).year();
            this._showMonth = _month;
            this._showYear = _year;
            if (_month === _monthLast && _year === _yearLast) {
                this._showLastMonth = _month == 11 ? 0 : _month + 1;
                this._showLastYear = _month == 11 ? _year + 1 : _year;
                setTimeout(function (_) {
                    _this._startDate = _this.findItemDay(_this.datepickerData, moment(arrDate[0]).format('YYYY-MM-DD'));
                    _this._endDate = _this.findItemDay(_this.datepickerData, moment(arrDate[1]).format('YYYY-MM-DD'));
                    _this.enterStartAndEnd();
                    _this.onChange(_this._result);
                });
                return;
            }
            this._showLastMonth = _monthLast;
            this._showLastYear = _yearLast;
            setTimeout(function (_) {
                _this._startDate = _this.findItemDay(_this.datepickerData, moment(arrDate[0]).format('YYYY-MM-DD'));
                _this._endDate = _this.findItemDay(_this.datepickerDataLast, moment(arrDate[1]).format('YYYY-MM-DD'));
                _this.enterStartAndEnd();
                _this.onChange(_this._result);
            });
        }
    };
    /**
     * @param {?} obj
     * @param {?} day
     * @return {?}
     */
    DaterangepickerComponent.prototype.findItemDay = function (obj, day) {
        var /** @type {?} */ result;
        obj['_weeksCalendar'].forEach(function (element) {
            element.days.forEach(function (item) {
                if (day === item.title) {
                    result = item;
                    return;
                }
            });
        });
        return result;
    };
    /**
     * @param {?} start
     * @param {?} end
     * @return {?}
     */
    DaterangepickerComponent.prototype.sortStartEndDay = function (start, end) {
        if (start['title'] > end['title']) {
            this._startDate = end;
            this._endDate = start;
        }
    };
    /**
     * @param {?} day
     * @param {?} tag
     * @return {?}
     */
    DaterangepickerComponent.prototype.assignStartEndDay = function (day, tag) {
        var _this = this;
        var /** @type {?} */ _startDays, /** @type {?} */ _endDays;
        if (tag === 'prev') {
            _startDays = moment(moment().subtract(day, 'days')).format('YYYY-MM-DD');
            _endDays = moment(moment().subtract(1, 'days')).format('YYYY-MM-DD');
        }
        if (tag === 'next') {
            _startDays = moment(moment().add(1, 'days')).format('YYYY-MM-DD');
            _endDays = moment(moment().add(day, 'days')).format('YYYY-MM-DD');
        }
        var /** @type {?} */ _month = moment(_startDays).month(), /** @type {?} */ _year = moment(_startDays).year(), /** @type {?} */ _monthLast = moment(_endDays).month(), /** @type {?} */ _yearLast = moment(_endDays).year();
        this._showMonth = _month;
        this._showYear = _year;
        if (_month === _monthLast && _year === _yearLast) {
            this._showLastMonth = _month == 11 ? 0 : _month + 1;
            this._showLastYear = _month == 11 ? _year + 1 : _year;
        }
        else {
            this._showLastMonth = _monthLast;
            this._showLastYear = _yearLast;
        }
        setTimeout(function (_) {
            _this._startDate = _this.findItemDay(_this.datepickerData, _startDays);
            _this._endDate = _this.findItemDay(_this.datepickerData, _endDays) || _this.findItemDay(_this.datepickerDataLast, _endDays);
            _this.enterStartAndEnd();
            _this.onChange(_this._result);
        });
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.remove = function () {
        this._isRemoveBtn = true;
        this._btnType = 'default';
        this._result = '';
        this._startDate = null;
        this._endDate = null;
        if (this._isDatepickerHide) {
            this.resetDatepicker(this.datepickerData);
            this.resetDatepicker(this.datepickerDataLast);
        }
        this.onChange('');
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.init = function () {
        this._isDatepickerHide = !this._isDatepickerHide;
        if (this._startDate) {
            return false;
        }
        if (!this._result) {
            this.resetDatepicker(this.datepickerData);
            this.resetDatepicker(this.datepickerDataLast);
        }
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.confirmBtn = function () {
        this._isDatepickerHide = false;
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.removeBtn = function () {
        if (this._result) {
            this._isRemoveBtn = false;
        }
    };
    /**
     * @return {?}
     */
    DaterangepickerComponent.prototype.enterStartAndEnd = function () {
        this.resetDatepicker(this.datepickerData);
        this.resetDatepicker(this.datepickerDataLast);
        this.sortStartEndDay(this._startDate, this._endDate);
        this.showStartAndEnd();
        this._result = this._startDate['title'] + "~" + this._endDate['title'];
        this._btnType = 'primary';
    };
    return DaterangepickerComponent;
}());
DaterangepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-daterangepicker',
                template: "<div style=\"position:relative;display:inline-block;\" [class]=\"_size\">\n  <div class=\"ant-input-content\" [style.width]=\"_width\" (mouseenter)=\"removeBtn()\" (mouseleave)=\"_isRemoveBtn=true\">\n    <input type=\"text\"  class=\"ant-input ant-input-default \" readonly [@tagAnimation] [value]=\"_result?_result:''\" \n    [placeholder]='_placeholder' (click)=\"init()\">\n    <span class=\"ant-input-clear\" (click)=\"remove()\" [@tagAnimation] [hidden]=\"_isRemoveBtn\"></span>\n  </div>\n  <div class=\"container\" [@dropDownAnimation]=\"'top'\" [hidden]=\"!_isDatepickerHide\" >\n    <div class=\"ant-result\">\n      <div [hidden]=\"_startDate?.title\" style=\"font-size:12px;color:#aaa;line-height:28px;\">\u8BF7\u9009\u62E9\u4E00\u4E2A\u65E5\u671F\u8303\u56F4</div>\n      <div [hidden]=\"!_startDate?.title\">\n        <span class=\"ant-result-header\">\u5DF2\u9009\u62E9\uFF1A</span>\n        <span class=\"ant-startDate\">{{_startDate?.title}}</span>\n        <span [hidden]=\"!_startDate?.title\">~</span>\n        <span class=\"ant-endDate\">{{_endDate?.title}}</span>\n        <span [hidden]=\"_endDate?.title == '...' || !_endDate?.title\">({{DateDiff(_startDate?.title, _endDate?.title)}}\u5929)</span>\n      </div>\n      <button nz-button [nzType]=\"_btnType\" style=\"text-align:right;\" (click)=\"confirmBtn()\">\n          <span>\u786E\u5B9A</span>\n      </button>\n    </div>  \n    <div class=\"ant-calendar-date-panel ant-container\">\n      <div class=\"ant-datepicker\">\n        <div class=\"ant-calendar-header\" style=\"border-bottom:none;\">\n          <div class=\"ant-calendar-month-panel-body\">\n            <div style=\"position: relative;width:170px;\">\n              <!-- <a class=\"ant-calendar-prev-year-btn\"></a> -->\n              <a class=\"ant-calendar-prev-month-btn\" style=\"left:12px;\" (click)=\"_preMonth()\"></a>\n              <span class=\"ant-calendar-ym-select\">\n                <a class=\"ant-calendar-year-select\">{{_showYear}}\u5E74</a>\n                <a class=\"ant-calendar-month-select\">{{_showMonth + 1}}\u6708</a>\n              </span>\n              <a  style=\"right:12px;\" (click)=\"_nextMonth()\" [class.ant-calendar-next-month-btn]=\"(_showMonth!=11)?((_showMonth+1) != _showLastMonth || _showYear != _showLastYear):(_showYear+1 != _showLastYear || _showLastMonth != 0)\"></a>\n              <!-- <a class=\"ant-calendar-next-year-btn\"></a> -->\n            </div>\n          </div>\n        </div>\n        <ant-datepicker #datepickerData [nzValue]=\"nowMonth\" [nzShowMonth]=\"_showMonth\" [nzShowYear]=\"_showYear\" (nzClickDay)=\"clickDay($event)\" (nzMouseDay)=\"mouseDay($event)\"></ant-datepicker>\n      </div>\n      <div class=\"ant-middle-bg ant-hidden-bg\" [class.ant-show-bg]=\"(_showMonth!=11)?((_showMonth+1) != _showLastMonth || _showYear != _showLastYear):(_showYear+1 != _showLastYear || _showLastMonth != 0)\">\n          <div class=\"gap-line\">\n            <div class=\"gap-1\"></div>\n            <div class=\"gap-2\"></div>\n            <div class=\"gap-3\"></div>\n          </div>\n          <div class=\"gap-line\">\n              <div class=\"gap-1\"></div>\n              <div class=\"gap-2\"></div>\n              <div class=\"gap-3\"></div>\n          </div>\n          <div class=\"gap-line\">\n              <div class=\"gap-1\"></div>\n              <div class=\"gap-2\"></div>\n              <div class=\"gap-3\"></div>\n          </div>\n          <div class=\"gap-line\">\n              <div class=\"gap-1\"></div>\n              <div class=\"gap-2\"></div>\n              <div class=\"gap-3\"></div>\n          </div>\n          <div class=\"gap-line\">\n              <div class=\"gap-1\"></div>\n              <div class=\"gap-2\"></div>\n              <div class=\"gap-3\"></div>\n            </div>\n            <div class=\"gap-line\">\n                <div class=\"gap-1\"></div>\n                <div class=\"gap-2\"></div>\n                <div class=\"gap-3\"></div>\n            </div>\n            <div class=\"gap-line\">\n                <div class=\"gap-1\"></div>\n                <div class=\"gap-2\"></div>\n                <div class=\"gap-3\"></div>\n            </div>\n            <div class=\"gap-line\">\n                <div class=\"gap-1\"></div>\n                <div class=\"gap-2\"></div>\n                <div class=\"gap-3\"></div>\n            </div>\n            <div class=\"gap-line\">\n                <div class=\"gap-1\"></div>\n                <div class=\"gap-2\"></div>\n                <div class=\"gap-3\"></div>\n              </div>\n              <div class=\"gap-line\">\n                  <div class=\"gap-1\"></div>\n                  <div class=\"gap-2\"></div>\n                  <div class=\"gap-3\"></div>\n              </div>\n              <div class=\"gap-line\">\n                  <div class=\"gap-1\"></div>\n                  <div class=\"gap-2\"></div>\n                  <div class=\"gap-3\"></div>\n              </div>\n              <div class=\"gap-line\">\n                  <div class=\"gap-1\"></div>\n                  <div class=\"gap-2\"></div>\n                  <div class=\"gap-3\"></div>\n              </div>\n              <div class=\"gap-line\">\n                  <div class=\"gap-1\"></div>\n                  <div class=\"gap-2\"></div>\n                  <div class=\"gap-3\"></div>\n              </div>\n              <div class=\"gap-line\">\n                  <div class=\"gap-1\"></div>\n                  <div class=\"gap-2\"></div>\n                  <div class=\"gap-3\"></div>\n              </div>\n      </div>\n      <div class=\"ant-datepicker\">\n        <div class=\"ant-calendar-header\" style=\"border-bottom:none;\">\n          <div class=\"ant-calendar-month-panel-body\">\n            <div style=\"position: relative;width:170px;\">\n              <!-- <a class=\"ant-calendar-prev-year-btn\"></a> -->\n              <a style=\"left:12px;\" (click)=\"_preLastMonth()\" [class.ant-calendar-prev-month-btn]=\"(_showMonth!=11)?((_showMonth+1) != _showLastMonth || _showYear != _showLastYear):(_showYear+1 != _showLastYear || _showLastMonth != 0)\"></a>\n              <span class=\"ant-calendar-ym-select\">\n                <a class=\"ant-calendar-year-select\">{{_showLastYear}}\u5E74</a>\n                <a class=\"ant-calendar-month-select\">{{_showLastMonth + 1}}\u6708</a>\n              </span>\n              <a class=\"ant-calendar-next-month-btn\" style=\"right:12px;\" (click)=\"_nextLastMonth()\"></a>\n              <!-- <a class=\"ant-calendar-next-year-btn\"></a> -->\n            </div>\n          </div>\n        </div>\n        <ant-datepicker #datepickerDataLast [nzValue]=\"nextMonth\" [nzShowMonth]=\"_showLastMonth\" [nzShowYear]=\"_showLastYear\" (nzClickDay)=\"clickDay($event)\" (nzMouseDay)=\"mouseDay($event)\"></ant-datepicker>\n      </div>\n    </div>\n    <div class=\"ant-footer\" *ngIf=\"_shortcuts || _customShortcuts\">\n      <span class=\"ant-footer-title\">\u5FEB\u6377\u9009\u62E9</span>\n      <div class=\"ant-footer-cell\" *ngFor=\"let item of _shortcuts\" >\n        <span class=\"ant-footer-cell-title\">{{item.title}}</span>\n        <a *ngFor=\"let cell of item.datas\" class=\"ant-footer-cell-content\" (click)=\"shortcutOption(cell, item.tag)\">{{cell | filterData}}</a>\n      </div>\n      <a *ngFor=\"let shortcut of _customShortcuts\" class=\"ant-footer-cell-content\" (click)=\"shortcutOption(shortcut)\">{{shortcut | filterData}}</a>\n    </div>\n  </div>\n</div>\n",
                styles: ["::ng-deep .ant-btn-group {\n  position: relative;\n  display: inline-block;\n  font-size: 0px;\n}\n::ng-deep .ant-btn-group > .ant-btn {\n  position: relative;\n  z-index: 1;\n}\n::ng-deep .ant-btn-group > .ant-btn:hover,\n::ng-deep .ant-btn-group > .ant-btn:focus,\n::ng-deep .ant-btn-group > .ant-btn:active,\n::ng-deep .ant-btn-group > .ant-btn.active {\n  z-index: 2;\n}\n::ng-deep .ant-btn-group > .ant-btn:disabled {\n  z-index: 0;\n}\n::ng-deep .ant-btn-group-lg > .ant-btn {\n  padding: 0 15px;\n  font-size: 14px;\n  border-radius: 4px;\n  height: 32px;\n}\n::ng-deep .ant-btn-group-sm > .ant-btn {\n  padding: 0 7px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 22px;\n}\n::ng-deep .ant-btn-group-sm > .ant-btn > .anticon {\n  font-size: 12px;\n}\n::ng-deep .ant-btn-group ant-button .ant-btn + ant-button .ant-btn,\nant-button .ant-btn + ::ng-deep .ant-btn-group,\n::ng-deep .ant-btn-group ant-button + .ant-btn,\n::ng-deep .ant-btn-group ant-button + ::ng-deep .ant-btn-group ant-button {\n  margin-left: -1px;\n}\n::ng-deep .ant-btn-group ant-button {\n  box-sizing: border-box;\n}\n::ng-deep .ant-btn-group ant-button:not(:first-child):not(:last-child) .ant-btn {\n  border-radius: 0;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ant-button:first-child:not(:last-child) > .ant-btn {\n  margin-left: 0;\n  border-bottom-right-radius: 0;\n  border-top-right-radius: 0;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ant-button:last-child:not(:first-child) > .ant-btn {\n  border-bottom-left-radius: 0;\n  border-top-left-radius: 0;\n  padding-left: 8px;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group {\n  float: left;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:not(:first-child):not(:last-child) .ant-btn {\n  border-radius: 0;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:first-child:not(:last-child) > .ant-btn:last-child {\n  border-bottom-right-radius: 0;\n  border-top-right-radius: 0;\n  padding-right: 8px;\n}\n::ng-deep .ant-btn-group ::ng-deep .ant-btn-group:last-child:not(:first-child) .ant-btn:first-child {\n  border-bottom-left-radius: 0;\n  border-top-left-radius: 0;\n  padding-left: 8px;\n}\n@keyframes buttonEffect {\n  to {\n    opacity: 0;\n    top: -6px;\n    left: -6px;\n    bottom: -6px;\n    right: -6px;\n    border-width: 6px;\n  }\n}\n.ant-calendar-picker-container {\n  position: absolute;\n  z-index: 1050;\n}\n.ant-calendar-picker-container.slide-up-enter.slide-up-enter-active.ant-calendar-picker-container-placement-topLeft,\n.ant-calendar-picker-container.slide-up-enter.slide-up-enter-active.ant-calendar-picker-container-placement-topRight,\n.ant-calendar-picker-container.slide-up-appear.slide-up-appear-active.ant-calendar-picker-container-placement-topLeft,\n.ant-calendar-picker-container.slide-up-appear.slide-up-appear-active.ant-calendar-picker-container-placement-topRight {\n  animation-name: antSlideDownIn;\n}\n.ant-calendar-picker-container.slide-up-enter.slide-up-enter-active.ant-calendar-picker-container-placement-bottomLeft,\n.ant-calendar-picker-container.slide-up-enter.slide-up-enter-active.ant-calendar-picker-container-placement-bottomRight,\n.ant-calendar-picker-container.slide-up-appear.slide-up-appear-active.ant-calendar-picker-container-placement-bottomLeft,\n.ant-calendar-picker-container.slide-up-appear.slide-up-appear-active.ant-calendar-picker-container-placement-bottomRight {\n  animation-name: antSlideUpIn;\n}\n.ant-calendar-picker-container.slide-up-leave.slide-up-leave-active.ant-calendar-picker-container-placement-topLeft,\n.ant-calendar-picker-container.slide-up-leave.slide-up-leave-active.ant-calendar-picker-container-placement-topRight {\n  animation-name: antSlideDownOut;\n}\n.ant-calendar-picker-container.slide-up-leave.slide-up-leave-active.ant-calendar-picker-container-placement-bottomLeft,\n.ant-calendar-picker-container.slide-up-leave.slide-up-leave-active.ant-calendar-picker-container-placement-bottomRight {\n  animation-name: antSlideUpOut;\n}\n.ant-calendar-picker {\n  position: relative;\n  display: inline-block;\n  outline: none;\n  font-size: 12px;\n  transition: opacity 0.3s;\n}\n.ant-calendar-picker-input {\n  outline: none;\n  display: block;\n}\n.ant-calendar-picker:hover .ant-calendar-picker-input:not(.ant-input-disabled) {\n  border-color: #108ee9;\n}\n.ant-calendar-picker-clear,\n.ant-calendar-picker-icon {\n  position: absolute;\n  width: 14px;\n  height: 14px;\n  right: 8px;\n  top: 50%;\n  margin-top: -7px;\n  line-height: 14px;\n  font-size: 12px;\n  transition: all .3s;\n  user-select: none;\n}\n.ant-calendar-picker-clear {\n  opacity: 0;\n  z-index: 1;\n  color: rgba(0, 0, 0, 0.25);\n  background: #fff;\n  pointer-events: none;\n  cursor: pointer;\n}\n.ant-calendar-picker-clear:hover {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-calendar-picker:hover .ant-calendar-picker-clear {\n  opacity: 1;\n  pointer-events: auto;\n}\n.ant-calendar-picker-icon {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-calendar-picker-icon:after {\n  content: \"\\e6bb\";\n  font-family: \"anticon\";\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n  display: inline-block;\n  line-height: 1;\n}\n.ant-calendar {\n  position: relative;\n  outline: none;\n  width: 231px;\n  border: 1px solid #fff;\n  list-style: none;\n  font-size: 12px;\n  text-align: left;\n  background-color: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  background-clip: padding-box;\n  line-height: 1.5;\n}\n.ant-calendar-input-wrap {\n  height: 34px;\n  padding: 6px;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-calendar-input {\n  border: 0;\n  width: 100%;\n  cursor: auto;\n  outline: 0;\n  height: 22px;\n  color: rgba(0, 0, 0, 0.65);\n  background: #fff;\n}\n.ant-calendar-input::-moz-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n  opacity: 1;\n}\n.ant-calendar-input:-ms-input-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-input::-webkit-input-placeholder {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-week-number {\n  width: 286px;\n}\n.ant-calendar-week-number-cell {\n  text-align: center;\n}\n.ant-calendar-header {\n  height: 34px;\n  line-height: 34px;\n  text-align: center;\n  user-select: none;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-calendar-header a:hover {\n  color: #49a9ee;\n}\n.ant-calendar-header .ant-calendar-century-select,\n.ant-calendar-header .ant-calendar-decade-select,\n.ant-calendar-header .ant-calendar-year-select,\n.ant-calendar-header .ant-calendar-month-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-header .ant-calendar-century-select-arrow,\n.ant-calendar-header .ant-calendar-decade-select-arrow,\n.ant-calendar-header .ant-calendar-year-select-arrow,\n.ant-calendar-header .ant-calendar-month-select-arrow {\n  display: none;\n}\n.ant-calendar-header .ant-calendar-prev-century-btn,\n.ant-calendar-header .ant-calendar-next-century-btn,\n.ant-calendar-header .ant-calendar-prev-decade-btn,\n.ant-calendar-header .ant-calendar-next-decade-btn,\n.ant-calendar-header .ant-calendar-prev-month-btn,\n.ant-calendar-header .ant-calendar-next-month-btn,\n.ant-calendar-header .ant-calendar-prev-year-btn,\n.ant-calendar-header .ant-calendar-next-year-btn {\n  position: absolute;\n  top: 0;\n  color: rgba(0, 0, 0, 0.43);\n  font-family: Arial, \"Hiragino Sans GB\", \"Microsoft Yahei\", \"Microsoft Sans Serif\", sans-serif;\n  padding: 0 5px;\n  font-size: 16px;\n  display: inline-block;\n  line-height: 34px;\n}\n.ant-calendar-header .ant-calendar-prev-century-btn,\n.ant-calendar-header .ant-calendar-prev-decade-btn,\n.ant-calendar-header .ant-calendar-prev-year-btn {\n  left: 7px;\n}\n.ant-calendar-header .ant-calendar-prev-century-btn:after,\n.ant-calendar-header .ant-calendar-prev-decade-btn:after,\n.ant-calendar-header .ant-calendar-prev-year-btn:after {\n  content: '\u00AB';\n}\n.ant-calendar-header .ant-calendar-next-century-btn,\n.ant-calendar-header .ant-calendar-next-decade-btn,\n.ant-calendar-header .ant-calendar-next-year-btn {\n  right: 7px;\n}\n.ant-calendar-header .ant-calendar-next-century-btn:after,\n.ant-calendar-header .ant-calendar-next-decade-btn:after,\n.ant-calendar-header .ant-calendar-next-year-btn:after {\n  content: '\u00BB';\n}\n.ant-calendar-header .ant-calendar-prev-month-btn {\n  left: 29px;\n}\n.ant-calendar-header .ant-calendar-prev-month-btn:after {\n  content: '\u2039';\n}\n.ant-calendar-header .ant-calendar-next-month-btn {\n  right: 29px;\n}\n.ant-calendar-header .ant-calendar-next-month-btn:after {\n  content: '\u203A';\n}\n.ant-calendar-body {\n  padding: 4px 8px;\n}\n.ant-calendar table {\n  border-collapse: collapse;\n  max-width: 100%;\n  background-color: transparent;\n  width: 100%;\n}\n.ant-calendar table,\n.ant-calendar th,\n.ant-calendar td {\n  border: 0;\n}\n.ant-calendar-calendar-table {\n  border-spacing: 0;\n  margin-bottom: 0;\n}\n.ant-calendar-column-header {\n  line-height: 18px;\n  width: 33px;\n  padding: 6px 0;\n  text-align: center;\n}\n.ant-calendar-column-header .ant-calendar-column-header-inner {\n  display: block;\n  font-weight: normal;\n}\n.ant-calendar-week-number-header .ant-calendar-column-header-inner {\n  display: none;\n}\n.ant-calendar-cell {\n  padding: 4px 0;\n}\n.ant-calendar-date {\n  display: block;\n  margin: 0 auto;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 2px;\n  width: 20px;\n  height: 20px;\n  line-height: 18px;\n  border: 1px solid transparent;\n  padding: 0;\n  background: transparent;\n  text-align: center;\n  transition: background 0.3s ease;\n}\n.ant-calendar-date-panel {\n  position: relative;\n}\n.ant-calendar-date:hover {\n  background: #ecf6fd;\n  cursor: pointer;\n}\n.ant-calendar-date:active {\n  color: #fff;\n  background: #49a9ee;\n}\n.ant-calendar-today .ant-calendar-date {\n  border-color: #108ee9;\n  font-weight: bold;\n  color: #108ee9;\n}\n.ant-calendar-last-month-cell .ant-calendar-date,\n.ant-calendar-next-month-btn-day .ant-calendar-date {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-selected-day .ant-calendar-date {\n  background: #108ee9;\n  color: #fff;\n  border: 1px solid transparent;\n}\n.ant-calendar-selected-day .ant-calendar-date:hover {\n  background: #108ee9;\n}\n.ant-calendar-disabled-cell .ant-calendar-date {\n  cursor: not-allowed;\n  color: #bcbcbc;\n  background: #f7f7f7;\n  border-radius: 0;\n  width: auto;\n  border: 1px solid transparent;\n}\n.ant-calendar-disabled-cell .ant-calendar-date:hover {\n  background: #f7f7f7;\n}\n.ant-calendar-disabled-cell.ant-calendar-today .ant-calendar-date {\n  position: relative;\n  margin-right: 5px;\n  padding-left: 5px;\n}\n.ant-calendar-disabled-cell.ant-calendar-today .ant-calendar-date:before {\n  content: \" \";\n  position: absolute;\n  top: -1px;\n  left: 5px;\n  width: 20px;\n  height: 20px;\n  border: 1px solid #bcbcbc;\n  border-radius: 4px;\n}\n.ant-calendar-disabled-cell-first-of-row .ant-calendar-date {\n  border-top-left-radius: 4px;\n  border-bottom-left-radius: 4px;\n}\n.ant-calendar-disabled-cell-last-of-row .ant-calendar-date {\n  border-top-right-radius: 4px;\n  border-bottom-right-radius: 4px;\n}\n.ant-calendar-footer {\n  border-top: 1px solid #e9e9e9;\n  line-height: 38px;\n  padding: 0 12px;\n}\n.ant-calendar-footer:empty {\n  border-top: 0;\n}\n.ant-calendar-footer-btn {\n  text-align: center;\n  display: block;\n}\n.ant-calendar-footer-extra + .ant-calendar-footer-btn {\n  border-top: 1px solid #e9e9e9;\n  margin: 0 -12px;\n  padding: 0 12px;\n}\n.ant-calendar .ant-calendar-today-btn,\n.ant-calendar .ant-calendar-clear-btn {\n  display: inline-block;\n  text-align: center;\n  margin: 0 0 0 8px;\n}\n.ant-calendar .ant-calendar-today-btn-disabled,\n.ant-calendar .ant-calendar-clear-btn-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  cursor: not-allowed;\n}\n.ant-calendar .ant-calendar-today-btn:only-child,\n.ant-calendar .ant-calendar-clear-btn:only-child {\n  margin: 0;\n}\n.ant-calendar .ant-calendar-clear-btn {\n  display: none;\n  position: absolute;\n  right: 5px;\n  text-indent: -76px;\n  overflow: hidden;\n  width: 20px;\n  height: 20px;\n  text-align: center;\n  line-height: 20px;\n  top: 7px;\n  margin: 0;\n}\n.ant-calendar .ant-calendar-clear-btn:after {\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\e62e\";\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.25);\n  display: inline-block;\n  line-height: 1;\n  width: 20px;\n  text-indent: 43px;\n  transition: color 0.3s ease;\n}\n.ant-calendar .ant-calendar-clear-btn:hover:after {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-calendar .ant-calendar-ok-btn {\n  display: inline-block;\n  margin-bottom: 0;\n  font-weight: 500;\n  text-align: center;\n  touch-action: manipulation;\n  cursor: pointer;\n  background-image: none;\n  border: 1px solid transparent;\n  white-space: nowrap;\n  padding: 0 15px;\n  height: 28px;\n  user-select: none;\n  transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);\n  position: relative;\n  color: #fff;\n  background-color: #108ee9;\n  border-color: #108ee9;\n  padding: 0 7px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 22px;\n  line-height: 1.5;\n}\n.ant-calendar .ant-calendar-ok-btn > .anticon {\n  line-height: 1;\n}\n.ant-calendar .ant-calendar-ok-btn,\n.ant-calendar .ant-calendar-ok-btn:active,\n.ant-calendar .ant-calendar-ok-btn:focus {\n  outline: 0;\n}\n.ant-calendar .ant-calendar-ok-btn:not([disabled]):hover {\n  text-decoration: none;\n}\n.ant-calendar .ant-calendar-ok-btn:not([disabled]):active {\n  outline: 0;\n  transition: none;\n}\n.ant-calendar .ant-calendar-ok-btn.disabled,\n.ant-calendar .ant-calendar-ok-btn[disabled] {\n  cursor: not-allowed;\n}\n.ant-calendar .ant-calendar-ok-btn.disabled > *,\n.ant-calendar .ant-calendar-ok-btn[disabled] > * {\n  pointer-events: none;\n}\n.ant-calendar .ant-calendar-ok-btn-lg {\n  padding: 0 15px;\n  font-size: 14px;\n  border-radius: 4px;\n  height: 32px;\n}\n.ant-calendar .ant-calendar-ok-btn-sm {\n  padding: 0 7px;\n  font-size: 12px;\n  border-radius: 4px;\n  height: 22px;\n}\n.ant-calendar .ant-calendar-ok-btn > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar .ant-calendar-ok-btn:hover,\n.ant-calendar .ant-calendar-ok-btn:focus {\n  color: #fff;\n  background-color: #49a9ee;\n  border-color: #49a9ee;\n}\n.ant-calendar .ant-calendar-ok-btn:hover > a:only-child,\n.ant-calendar .ant-calendar-ok-btn:focus > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn:hover > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn:focus > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar .ant-calendar-ok-btn:active,\n.ant-calendar .ant-calendar-ok-btn.active {\n  color: #fff;\n  background-color: #0e77ca;\n  border-color: #0e77ca;\n}\n.ant-calendar .ant-calendar-ok-btn:active > a:only-child,\n.ant-calendar .ant-calendar-ok-btn.active > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn:active > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn.active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar .ant-calendar-ok-btn.disabled,\n.ant-calendar .ant-calendar-ok-btn[disabled],\n.ant-calendar .ant-calendar-ok-btn.disabled:hover,\n.ant-calendar .ant-calendar-ok-btn[disabled]:hover,\n.ant-calendar .ant-calendar-ok-btn.disabled:focus,\n.ant-calendar .ant-calendar-ok-btn[disabled]:focus,\n.ant-calendar .ant-calendar-ok-btn.disabled:active,\n.ant-calendar .ant-calendar-ok-btn[disabled]:active,\n.ant-calendar .ant-calendar-ok-btn.disabled.active,\n.ant-calendar .ant-calendar-ok-btn[disabled].active {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-calendar .ant-calendar-ok-btn.disabled > a:only-child,\n.ant-calendar .ant-calendar-ok-btn[disabled] > a:only-child,\n.ant-calendar .ant-calendar-ok-btn.disabled:hover > a:only-child,\n.ant-calendar .ant-calendar-ok-btn[disabled]:hover > a:only-child,\n.ant-calendar .ant-calendar-ok-btn.disabled:focus > a:only-child,\n.ant-calendar .ant-calendar-ok-btn[disabled]:focus > a:only-child,\n.ant-calendar .ant-calendar-ok-btn.disabled:active > a:only-child,\n.ant-calendar .ant-calendar-ok-btn[disabled]:active > a:only-child,\n.ant-calendar .ant-calendar-ok-btn.disabled.active > a:only-child,\n.ant-calendar .ant-calendar-ok-btn[disabled].active > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn.disabled > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn[disabled] > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn.disabled:hover > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn[disabled]:hover > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn.disabled:focus > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn[disabled]:focus > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn.disabled:active > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn[disabled]:active > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn.disabled.active > a:only-child:after,\n.ant-calendar .ant-calendar-ok-btn[disabled].active > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n  cursor: not-allowed;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled:hover {\n  color: rgba(0, 0, 0, 0.25);\n  background-color: #f7f7f7;\n  border-color: #d9d9d9;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled:hover > a:only-child {\n  color: currentColor;\n}\n.ant-calendar .ant-calendar-ok-btn-disabled:hover > a:only-child:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background: transparent;\n}\n.ant-calendar-time-picker {\n  position: absolute;\n  width: 100%;\n  top: 34px;\n  background-color: #fff;\n}\n.ant-calendar-time-picker-panel {\n  z-index: 1050;\n  position: absolute;\n  width: 100%;\n}\n.ant-calendar-time-picker-inner {\n  display: inline-block;\n  position: relative;\n  outline: none;\n  list-style: none;\n  font-size: 12px;\n  text-align: left;\n  background-color: #fff;\n  background-clip: padding-box;\n  line-height: 1.5;\n  overflow: hidden;\n  width: 100%;\n}\n.ant-calendar-time-picker-combobox {\n  width: 100%;\n}\n.ant-calendar-time-picker-column-1,\n.ant-calendar-time-picker-column-1 .ant-calendar-time-picker-select {\n  width: 100%;\n}\n.ant-calendar-time-picker-column-2 .ant-calendar-time-picker-select {\n  width: 50%;\n}\n.ant-calendar-time-picker-column-3 .ant-calendar-time-picker-select {\n  width: 33.33%;\n}\n.ant-calendar-time-picker-column-4 .ant-calendar-time-picker-select {\n  width: 25%;\n}\n.ant-calendar-time-picker-input-wrap {\n  display: none;\n}\n.ant-calendar-time-picker-select {\n  float: left;\n  font-size: 12px;\n  border-right: 1px solid #e9e9e9;\n  box-sizing: border-box;\n  overflow: hidden;\n  position: relative;\n  height: 206px;\n}\n.ant-calendar-time-picker-select:hover {\n  overflow-y: auto;\n}\n.ant-calendar-time-picker-select:first-child {\n  border-left: 0;\n  margin-left: 0;\n}\n.ant-calendar-time-picker-select:last-child {\n  border-right: 0;\n}\n.ant-calendar-time-picker-select ul {\n  list-style: none;\n  box-sizing: border-box;\n  margin: 0;\n  padding: 0;\n  width: 100%;\n  max-height: 206px;\n}\n.ant-calendar-time-picker-select li {\n  text-align: center;\n  list-style: none;\n  box-sizing: content-box;\n  margin: 0;\n  width: 100%;\n  height: 24px;\n  line-height: 24px;\n  cursor: pointer;\n  user-select: none;\n  transition: background 0.3s ease;\n}\n.ant-calendar-time-picker-select li:last-child:after {\n  content: '';\n  height: 182px;\n  display: block;\n}\n.ant-calendar-time-picker-select li:hover {\n  background: #ecf6fd;\n}\nli.ant-calendar-time-picker-select-option-selected {\n  background: #f7f7f7;\n  font-weight: bold;\n}\nli.ant-calendar-time-picker-select-option-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\nli.ant-calendar-time-picker-select-option-disabled:hover {\n  background: transparent;\n  cursor: not-allowed;\n}\n.ant-calendar-time .ant-calendar-day-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-time .ant-calendar-footer {\n  position: relative;\n  height: auto;\n  line-height: auto;\n}\n.ant-calendar-time .ant-calendar-footer-btn {\n  text-align: right;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-today-btn {\n  float: left;\n  margin: 0;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-time-picker-btn {\n  display: inline-block;\n  margin-right: 8px;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-time-picker-btn-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-time-picker {\n  position: absolute;\n  width: 100%;\n  top: 34px;\n  background-color: #fff;\n}\n.ant-calendar-time-picker-panel {\n  z-index: 1050;\n  position: absolute;\n  width: 100%;\n}\n.ant-calendar-time-picker-inner {\n  display: inline-block;\n  position: relative;\n  outline: none;\n  list-style: none;\n  font-size: 12px;\n  text-align: left;\n  background-color: #fff;\n  background-clip: padding-box;\n  line-height: 1.5;\n  overflow: hidden;\n  width: 100%;\n}\n.ant-calendar-time-picker-combobox {\n  width: 100%;\n}\n.ant-calendar-time-picker-column-1,\n.ant-calendar-time-picker-column-1 .ant-calendar-time-picker-select {\n  width: 100%;\n}\n.ant-calendar-time-picker-column-2 .ant-calendar-time-picker-select {\n  width: 50%;\n}\n.ant-calendar-time-picker-column-3 .ant-calendar-time-picker-select {\n  width: 33.33%;\n}\n.ant-calendar-time-picker-column-4 .ant-calendar-time-picker-select {\n  width: 25%;\n}\n.ant-calendar-time-picker-input-wrap {\n  display: none;\n}\n.ant-calendar-time-picker-select {\n  float: left;\n  font-size: 12px;\n  border-right: 1px solid #e9e9e9;\n  box-sizing: border-box;\n  overflow: hidden;\n  position: relative;\n  height: 206px;\n}\n.ant-calendar-time-picker-select:hover {\n  overflow-y: auto;\n}\n.ant-calendar-time-picker-select:first-child {\n  border-left: 0;\n  margin-left: 0;\n}\n.ant-calendar-time-picker-select:last-child {\n  border-right: 0;\n}\n.ant-calendar-time-picker-select ul {\n  list-style: none;\n  box-sizing: border-box;\n  margin: 0;\n  padding: 0;\n  width: 100%;\n  max-height: 206px;\n}\n.ant-calendar-time-picker-select li {\n  text-align: center;\n  list-style: none;\n  box-sizing: content-box;\n  margin: 0;\n  width: 100%;\n  height: 24px;\n  line-height: 24px;\n  cursor: pointer;\n  user-select: none;\n  transition: background 0.3s ease;\n}\n.ant-calendar-time-picker-select li:last-child:after {\n  content: '';\n  height: 182px;\n  display: block;\n}\n.ant-calendar-time-picker-select li:hover {\n  background: #ecf6fd;\n}\nli.ant-calendar-time-picker-select-option-selected {\n  background: #f7f7f7;\n  font-weight: bold;\n}\nli.ant-calendar-time-picker-select-option-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\nli.ant-calendar-time-picker-select-option-disabled:hover {\n  background: transparent;\n  cursor: not-allowed;\n}\n.ant-calendar-time .ant-calendar-day-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-time .ant-calendar-footer {\n  position: relative;\n  height: auto;\n  line-height: auto;\n}\n.ant-calendar-time .ant-calendar-footer-btn {\n  text-align: right;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-today-btn {\n  float: left;\n  margin: 0;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-time-picker-btn {\n  display: inline-block;\n  margin-right: 8px;\n}\n.ant-calendar-time .ant-calendar-footer .ant-calendar-time-picker-btn-disabled {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-month-panel {\n  position: absolute;\n  top: 1px;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  z-index: 10;\n  border-radius: 4px;\n  background: #fff;\n  outline: none;\n}\n.ant-calendar-month-panel > div {\n  height: 100%;\n}\n.ant-calendar-month-panel-hidden {\n  display: none;\n}\n.ant-calendar-month-panel-header {\n  height: 34px;\n  line-height: 34px;\n  text-align: center;\n  user-select: none;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-calendar-month-panel-header a:hover {\n  color: #49a9ee;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-century-select,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-decade-select,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-year-select,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-month-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-century-select-arrow,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-decade-select-arrow,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-year-select-arrow,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-month-select-arrow {\n  display: none;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-century-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-century-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-decade-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-decade-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-month-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-month-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-year-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-year-btn {\n  position: absolute;\n  top: 0;\n  color: rgba(0, 0, 0, 0.43);\n  font-family: Arial, \"Hiragino Sans GB\", \"Microsoft Yahei\", \"Microsoft Sans Serif\", sans-serif;\n  padding: 0 5px;\n  font-size: 16px;\n  display: inline-block;\n  line-height: 34px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-century-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-decade-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-year-btn {\n  left: 7px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-century-btn:after,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-decade-btn:after,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-year-btn:after {\n  content: '\u00AB';\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-century-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-decade-btn,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-year-btn {\n  right: 7px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-century-btn:after,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-decade-btn:after,\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-year-btn:after {\n  content: '\u00BB';\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-month-btn {\n  left: 29px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-prev-month-btn:after {\n  content: '\u2039';\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-month-btn {\n  right: 29px;\n}\n.ant-calendar-month-panel-header .ant-calendar-month-panel-next-month-btn:after {\n  content: '\u203A';\n}\n.ant-calendar-month-panel-body {\n  height: calc(100% - 34px);\n}\n.ant-calendar-month-panel-table {\n  table-layout: fixed;\n  width: 100%;\n  height: 100%;\n  border-collapse: separate;\n}\n.ant-calendar-month-panel-selected-cell .ant-calendar-month-panel-month {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-month-panel-selected-cell .ant-calendar-month-panel-month:hover {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-month-panel-cell {\n  text-align: center;\n}\n.ant-calendar-month-panel-cell-disabled .ant-calendar-month-panel-month,\n.ant-calendar-month-panel-cell-disabled .ant-calendar-month-panel-month:hover {\n  cursor: not-allowed;\n  color: #bcbcbc;\n  background: #f7f7f7;\n}\n.ant-calendar-month-panel-month {\n  display: inline-block;\n  margin: 0 auto;\n  color: rgba(0, 0, 0, 0.65);\n  background: transparent;\n  text-align: center;\n  height: 24px;\n  line-height: 24px;\n  padding: 0 6px;\n  border-radius: 4px;\n  transition: background 0.3s ease;\n}\n.ant-calendar-month-panel-month:hover {\n  background: #ecf6fd;\n  cursor: pointer;\n}\n.ant-calendar-year-panel {\n  position: absolute;\n  top: 1px;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  z-index: 10;\n  border-radius: 4px;\n  background: #fff;\n  outline: none;\n}\n.ant-calendar-year-panel > div {\n  height: 100%;\n}\n.ant-calendar-year-panel-hidden {\n  display: none;\n}\n.ant-calendar-year-panel-header {\n  height: 34px;\n  line-height: 34px;\n  text-align: center;\n  user-select: none;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-calendar-year-panel-header a:hover {\n  color: #49a9ee;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-century-select,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-decade-select,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-year-select,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-month-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-century-select-arrow,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-decade-select-arrow,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-year-select-arrow,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-month-select-arrow {\n  display: none;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-century-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-century-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-decade-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-decade-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-month-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-month-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-year-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-year-btn {\n  position: absolute;\n  top: 0;\n  color: rgba(0, 0, 0, 0.43);\n  font-family: Arial, \"Hiragino Sans GB\", \"Microsoft Yahei\", \"Microsoft Sans Serif\", sans-serif;\n  padding: 0 5px;\n  font-size: 16px;\n  display: inline-block;\n  line-height: 34px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-century-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-decade-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-year-btn {\n  left: 7px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-century-btn:after,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-decade-btn:after,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-year-btn:after {\n  content: '\u00AB';\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-century-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-decade-btn,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-year-btn {\n  right: 7px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-century-btn:after,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-decade-btn:after,\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-year-btn:after {\n  content: '\u00BB';\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-month-btn {\n  left: 29px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-prev-month-btn:after {\n  content: '\u2039';\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-month-btn {\n  right: 29px;\n}\n.ant-calendar-year-panel-header .ant-calendar-year-panel-next-month-btn:after {\n  content: '\u203A';\n}\n.ant-calendar-year-panel-body {\n  height: calc(100% - 34px);\n}\n.ant-calendar-year-panel-table {\n  table-layout: fixed;\n  width: 100%;\n  height: 100%;\n  border-collapse: separate;\n}\n.ant-calendar-year-panel-cell {\n  text-align: center;\n}\n.ant-calendar-year-panel-year {\n  display: inline-block;\n  margin: 0 auto;\n  color: rgba(0, 0, 0, 0.65);\n  background: transparent;\n  text-align: center;\n  height: 24px;\n  line-height: 24px;\n  padding: 0 6px;\n  border-radius: 4px;\n  transition: background 0.3s ease;\n}\n.ant-calendar-year-panel-year:hover {\n  background: #ecf6fd;\n  cursor: pointer;\n}\n.ant-calendar-year-panel-selected-cell .ant-calendar-year-panel-year {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-year-panel-selected-cell .ant-calendar-year-panel-year:hover {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-year-panel-last-decade-cell .ant-calendar-year-panel-year,\n.ant-calendar-year-panel-next-decade-cell .ant-calendar-year-panel-year {\n  user-select: none;\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-decade-panel {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  z-index: 10;\n  background: #fff;\n  border-radius: 4px;\n  outline: none;\n}\n.ant-calendar-decade-panel-hidden {\n  display: none;\n}\n.ant-calendar-decade-panel-header {\n  height: 34px;\n  line-height: 34px;\n  text-align: center;\n  user-select: none;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-calendar-decade-panel-header a:hover {\n  color: #49a9ee;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-century-select,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-decade-select,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-year-select,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-month-select {\n  padding: 0 2px;\n  font-weight: bold;\n  display: inline-block;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 34px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-century-select-arrow,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-decade-select-arrow,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-year-select-arrow,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-month-select-arrow {\n  display: none;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-century-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-century-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-decade-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-decade-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-month-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-month-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-year-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-year-btn {\n  position: absolute;\n  top: 0;\n  color: rgba(0, 0, 0, 0.43);\n  font-family: Arial, \"Hiragino Sans GB\", \"Microsoft Yahei\", \"Microsoft Sans Serif\", sans-serif;\n  padding: 0 5px;\n  font-size: 16px;\n  display: inline-block;\n  line-height: 34px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-century-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-decade-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-year-btn {\n  left: 7px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-century-btn:after,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-decade-btn:after,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-year-btn:after {\n  content: '\u00AB';\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-century-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-decade-btn,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-year-btn {\n  right: 7px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-century-btn:after,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-decade-btn:after,\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-year-btn:after {\n  content: '\u00BB';\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-month-btn {\n  left: 29px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-prev-month-btn:after {\n  content: '\u2039';\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-month-btn {\n  right: 29px;\n}\n.ant-calendar-decade-panel-header .ant-calendar-decade-panel-next-month-btn:after {\n  content: '\u203A';\n}\n.ant-calendar-decade-panel-body {\n  height: calc(100% - 34px);\n}\n.ant-calendar-decade-panel-table {\n  table-layout: fixed;\n  width: 100%;\n  height: 100%;\n  border-collapse: separate;\n}\n.ant-calendar-decade-panel-cell {\n  text-align: center;\n  white-space: nowrap;\n}\n.ant-calendar-decade-panel-decade {\n  display: inline-block;\n  margin: 0 auto;\n  color: rgba(0, 0, 0, 0.65);\n  background: transparent;\n  text-align: center;\n  height: 24px;\n  line-height: 24px;\n  padding: 0 6px;\n  border-radius: 4px;\n  transition: background 0.3s ease;\n}\n.ant-calendar-decade-panel-decade:hover {\n  background: #ecf6fd;\n  cursor: pointer;\n}\n.ant-calendar-decade-panel-selected-cell .ant-calendar-decade-panel-decade {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-decade-panel-selected-cell .ant-calendar-decade-panel-decade:hover {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-calendar-decade-panel-last-century-cell .ant-calendar-decade-panel-decade,\n.ant-calendar-decade-panel-next-century-cell .ant-calendar-decade-panel-decade {\n  user-select: none;\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-calendar-month .ant-calendar-month-panel,\n.ant-calendar-month .ant-calendar-year-panel {\n  top: 0;\n  height: 248px;\n}\nnz-datepicker {\n  display: inline-block;\n  position: relative;\n}\n.ant-calendar-picker-container {\n  position: relative;\n  left: -2px;\n}\n.ant-calendar-picker-container.top {\n  bottom: -2px;\n}\n.ant-calendar-picker-container.bottom {\n  top: -2px;\n}\n.container {\n  position: absolute;\n  width: 375px;\n  z-index: 1001;\n  background: #fff;\n  border: 1px solid #ddd;\n  box-shadow: 0 6px 12px rgba(0, 0, 0, 0.175);\n  padding: 0 10px;\n}\n.container .ant-result {\n  padding: 10px 0;\n  display: flex;\n  justify-content: space-between;\n}\n.container .ant-footer {\n  border-top: 1px solid #e9e9e9;\n  padding: 5px 0 ;\n  display: flex;\n}\n.container .ant-footer-title {\n  font-weight: 900;\n  padding-right: 3px;\n}\n.container .ant-footer-cell {\n  padding-right: 2px;\n}\n.container .ant-footer-cell-title {\n  padding-right: 2px;\n  color: #aaa;\n}\n.container .ant-footer-cell-content {\n  text-decoration: underline;\n  color: #6bb4d6;\n  cursor: pointer;\n  padding-right: 3px;\n}\n.ant-container {\n  display: flex;\n}\n.ant-startDate,\n.ant-endDate {\n  font-weight: bold;\n}\n.ant-datepicker {\n  height: auto!important;\n}\n.ant-hidden-bg {\n  visibility: hidden;\n}\n.ant-show-bg {\n  visibility: visible;\n}\n.ant-middle-bg {\n  width: 15px;\n  height: 100%;\n  overflow: hidden;\n}\n.ant-middle-bg .gap-line {\n  height: 15px;\n  width: 15px;\n  position: relative;\n}\n.ant-middle-bg .gap-line .gap-1 {\n  z-index: 1;\n  height: 0px;\n  border-left: 8px solid #ffffff;\n  border-top: 8px solid #eeeeee;\n  border-bottom: 8px solid #eeeeee;\n}\n.ant-middle-bg .gap-line .gap-2 {\n  position: absolute;\n  right: 0px;\n  top: 0px;\n  z-index: 2;\n  height: 0px;\n  border-left: 8px solid transparent;\n  border-top: 8px solid #ffffff;\n}\n.ant-middle-bg .gap-line .gap-3 {\n  position: absolute;\n  right: 0px;\n  top: 8px;\n  z-index: 2;\n  height: 0px;\n  border-left: 8px solid transparent;\n  border-bottom: 8px solid #ffffff;\n}\n.ant-result {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-result-header {\n  font-size: 14px;\n  font-weight: 500;\n}\n.ant-input {\n  position: relative;\n  display: inline-block;\n  padding: 4px 7px;\n  width: 100%;\n  height: 28px;\n  cursor: text;\n  font-size: 12px;\n  line-height: 1.5;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n  transition: all .3s;\n}\n.ant-input:focus {\n  border-color: #49a9ee;\n  outline: 0;\n  box-shadow: 0 0 0 2px rgba(16, 142, 233, 0.2);\n}\n.ant-input-content {\n  position: relative;\n  display: inline-block;\n}\n.ant-input-clear {\n  position: absolute;\n  right: 5px;\n  top: 5px;\n  cursor: pointer;\n}\n.ant-input-clear:before {\n  display: block;\n  font-family: 'anticon';\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  content: \"\\E62E\";\n}\n.ant-input-lg .ant-input-default {\n  height: 32px!important;\n}\n.ant-input-lg .ant-input-clear {\n  top: 7px;\n}\n.ant-input-sm .ant-input-default {\n  height: 22px!important;\n}\n.ant-input-sm .ant-input-clear {\n  top: 2px;\n}\n"],
                providers: [{
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return DaterangepickerComponent; }),
                        multi: true
                    }],
                animations: [
                    DropDownAnimation,
                    TagAnimation
                ],
            },] },
];
/** @nocollapse */
DaterangepickerComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core.Renderer2, },
]; };
DaterangepickerComponent.propDecorators = {
    "antShortcuts": [{ type: core.Input },],
    "antCustomShortcuts": [{ type: core.Input },],
    "isDatepickerHide": [{ type: core.Input },],
    "antploceholder": [{ type: core.Input },],
    "antWidth": [{ type: core.Input },],
    "antSize": [{ type: core.Input },],
    "datepickerData": [{ type: core.ViewChild, args: ['datepickerData',] },],
    "datepickerDataLast": [{ type: core.ViewChild, args: ['datepickerDataLast',] },],
    "onClick": [{ type: core.HostListener, args: ['document:click', ['$event'],] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
/**
 * @record
 */
/**
 * @record
 */
var DatepickerComponent = (function () {
    function DatepickerComponent() {
        this._weeksCalendar = [];
        // _quartersCalendar: Array<QuartersType> = [];
        this._listOfWeekName = [];
        this._listOfMonthName = [];
        this._listOfYearName = [];
        this._yearUnit = '年';
        this._monthUnit = '月';
        this._showMonth = moment(new Date()).month();
        this._showYear = moment(new Date()).year();
        this._nowMonth = moment(new Date()).month();
        this._value = new Date();
        this._locale = 'zh-cn';
        this.nzClearTime = true;
        this.nzClickDay = new core.EventEmitter();
        this.nzMouseDay = new core.EventEmitter();
    }
    Object.defineProperty(DatepickerComponent.prototype, "nzValue", {
        /**
         * @return {?}
         */
        get: function () {
            return this._value || new Date();
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            if (this._value === value) {
                return;
            }
            this._value = value || new Date();
            this._showMonth = moment(this._value).month();
            this._showYear = moment(this._value).year();
            this._buildCalendar();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatepickerComponent.prototype, "nzShowYear", {
        /**
         * @return {?}
         */
        get: function () {
            return this._showYear;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._showYear = value;
            this._buildCalendar();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatepickerComponent.prototype, "nzShowMonth", {
        /**
         * @return {?}
         */
        get: function () {
            return this._showMonth;
        },
        /**
         * @param {?} value
         * @return {?}
         */
        set: function (value) {
            this._showMonth = value;
            this._buildCalendar();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DatepickerComponent.prototype.ngOnInit = function () {
        this._buildCalendar();
    };
    /**
     * @return {?}
     */
    DatepickerComponent.prototype._buildCalendar = function () {
        this._weeksCalendar = [];
        moment.locale(this._locale);
        this._listOfYearName = this._generateYears(this._showYear);
        this._listOfWeekName = moment.weekdaysMin();
        this._listOfMonthName = moment.months();
        var /** @type {?} */ date = moment(this.nzValue).year(this._showYear).month(this._showMonth);
        this._weeksCalendar = this._buildMonth(date);
        // this._quartersCalendar = this._buildYears(date);
    };
    
    /**
     * @param {?} year
     * @return {?}
     */
    DatepickerComponent.prototype._generateYears = function (year) {
        var /** @type {?} */ listOfYears = [];
        for (var _i = 0, _b = Array.from(Array(20).keys()); _i < _b.length; _i++) {
            var i = _b[_i];
            listOfYears.push(i - 10 + year);
        }
        return listOfYears;
    };
    
    /**
     * @param {?} d
     * @return {?}
     */
    DatepickerComponent.prototype._buildMonth = function (d) {
        var /** @type {?} */ weeks = [];
        var /** @type {?} */ _rawDate = this._removeTime(d);
        var /** @type {?} */ start = _rawDate.clone().date(1).day(0);
        var /** @type {?} */ month = _rawDate.clone();
        var /** @type {?} */ done = false;
        var /** @type {?} */ date = start.clone();
        var /** @type {?} */ monthIndex = date.month();
        var /** @type {?} */ count = 0;
        while (!done) {
            weeks.push({ days: this._buildWeek(date.clone(), month) });
            date.add(1, 'w');
            done = count++ > 4;
            monthIndex = date.month();
        }
        return weeks;
    };
    
    /**
     * @param {?} date
     * @return {?}
     */
    DatepickerComponent.prototype._removeTime = function (date) {
        if (this.nzClearTime) {
            return date.hour(0).minute(0).second(0).millisecond(0);
        }
        else {
            return date;
        }
    };
    
    /**
     * @param {?} date
     * @param {?} month
     * @return {?}
     */
    DatepickerComponent.prototype._buildWeek = function (date, month) {
        var /** @type {?} */ days = [];
        for (var /** @type {?} */ i = 0; i < 7; i++) {
            days.push({
                number: date.date(),
                isLastMonth: date.month() < month.month(),
                isNextMonth: date.month() > month.month(),
                isCurrentDay: date.isSame(new Date(), 'day') && date.month() === this._nowMonth,
                isSelectedDay: false,
                isMiddleDay: false,
                distanceStartDay: null,
                title: date.format('YYYY-MM-DD'),
                date: date
            });
            date = date.clone();
            date.add(1, 'd');
        }
        return days;
    };
    
    /**
     * @param {?} $event
     * @param {?} day
     * @return {?}
     */
    DatepickerComponent.prototype._clickDay = function ($event, day) {
        $event.preventDefault();
        $event.stopPropagation();
        this.nzClickDay.emit({ day: day });
    };
    
    /**
     * @param {?} $event
     * @param {?} day
     * @return {?}
     */
    DatepickerComponent.prototype._mouseDay = function ($event, day) {
        $event.preventDefault();
        $event.stopPropagation();
        this.nzMouseDay.emit({ day: day });
    };
    
    return DatepickerComponent;
}());
DatepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ant-datepicker',
                template: "<table>\n  <thead>\n      <tr>\n        <th *ngFor=\"let _min of _listOfWeekName\">\n          <span class=\"ant-fullcalendar-column-header-inner\">{{_min}}</span>\n        </th>\n      </tr>\n    </thead>\n  <tbody class=\"ant-fullcalendar-month-panel-tbody\">\n    <tr *ngFor=\"let week of _weeksCalendar\">\n      <td *ngFor=\"let day of week.days\" \n          [class.ant-calendar-cell]=\"nzDatePicker\"\n          [class.ant-fullcalendar-last-month-cell]=\"day.isLastMonth\" \n          [class.ant-fullcalendar-next-month-btn-day]=\"day.isNextMonth\"\n          [class.ant-fullcalendar-selected-day]=\"day.isSelectedDay\" \n          [class.ant-fullcalendar-middle-day]=\"day.isMiddleDay && !day.isLastMonth && !day.isNextMonth\"\n          [class.ant-fullcalendar-today]=\"day.isCurrentDay\">\n        <div class=\"ant-fullcalendar-date\" [hidden]=\"day.isLastMonth || day.isNextMonth\">\n            <div class=\"ant-fullcalendar-value\" \n                  (click)=\"_clickDay($event,day)\" \n                  (mouseover)=\"_mouseDay($event,day)\">\n              {{day.number}}\n            </div>\n        </div>\n      </td>\n    </tr>\n  </tbody>\n  </table>\n",
                styles: [".ant-fullcalendar {\n  font-size: 12px;\n  line-height: 1.5;\n  outline: none;\n  border-top: 1px solid #d9d9d9;\n}\n.ant-fullcalendar-month-select {\n  margin-left: 5px;\n}\n.ant-fullcalendar-header {\n  padding: 11px 16px 11px 0;\n  text-align: right;\n}\n.ant-fullcalendar-header .ant-select-dropdown {\n  text-align: left;\n}\n.ant-fullcalendar-header .ant-radio-group {\n  margin-left: 8px;\n  text-align: left;\n}\n.ant-fullcalendar-header label.ant-radio-button {\n  height: 22px;\n  line-height: 20px;\n  padding: 0 10px;\n}\n.ant-fullcalendar-date-panel {\n  position: relative;\n  outline: none;\n}\n.ant-fullcalendar-calendar-body {\n  padding: 8px 8px 14px;\n}\n.ant-fullcalendar table {\n  border-collapse: collapse;\n  max-width: 100%;\n  background-color: transparent;\n  width: 100%;\n  height: 246px;\n}\n.ant-fullcalendar table,\n.ant-fullcalendar th,\n.ant-fullcalendar td {\n  border: 0;\n}\n.ant-fullcalendar td {\n  position: relative;\n}\n.ant-fullcalendar-calendar-table {\n  border-spacing: 0;\n  margin-bottom: 0;\n}\n.ant-fullcalendar-column-header {\n  line-height: 18px;\n  padding: 0;\n  width: 33px;\n  text-align: center;\n}\n.ant-fullcalendar-column-header .ant-fullcalendar-column-header-inner {\n  display: block;\n  font-weight: normal;\n}\n.ant-fullcalendar-week-number-header .ant-fullcalendar-column-header-inner {\n  display: none;\n}\n.ant-fullcalendar-month,\n.ant-fullcalendar-date {\n  text-align: center;\n  transition: all .3s;\n}\n.ant-fullcalendar-value {\n  display: block;\n  margin: 0 auto;\n  color: rgba(0, 0, 0, 0.65);\n  border-radius: 4px;\n  width: 22px;\n  height: 22px;\n  padding: 0;\n  background: transparent;\n  line-height: 22px;\n  transition: all .3s;\n}\n.ant-fullcalendar-value:hover {\n  cursor: pointer;\n}\n.ant-fullcalendar-value:active {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-fullcalendar-month-panel-cell .ant-fullcalendar-value {\n  width: 48px;\n}\n.ant-fullcalendar-today .ant-fullcalendar-value,\n.ant-fullcalendar-month-panel-current-cell .ant-fullcalendar-value {\n  box-shadow: 0 0 0 1px #108ee9;\n}\n.ant-fullcalendar-selected-day .ant-fullcalendar-value,\n.ant-fullcalendar-month-panel-selected-cell .ant-fullcalendar-value {\n  background: #108ee9;\n  color: #fff;\n}\n.ant-fullcalendar-disabled-cell-first-of-row .ant-fullcalendar-value {\n  border-top-left-radius: 4px;\n  border-bottom-left-radius: 4px;\n}\n.ant-fullcalendar-disabled-cell-last-of-row .ant-fullcalendar-value {\n  border-top-right-radius: 4px;\n  border-bottom-right-radius: 4px;\n}\n.ant-fullcalendar-last-month-cell .ant-fullcalendar-value,\n.ant-fullcalendar-next-month-btn-day .ant-fullcalendar-value {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-fullcalendar-month-panel-table {\n  table-layout: fixed;\n  width: 100%;\n  border-collapse: separate;\n}\n.ant-fullcalendar-content {\n  position: absolute;\n  width: 100%;\n  left: 0;\n  bottom: -9px;\n}\n.ant-fullcalendar-fullscreen {\n  border-top: 0;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-table {\n  table-layout: fixed;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-header .ant-radio-group {\n  margin-left: 16px;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-header label.ant-radio-button {\n  height: 28px;\n  line-height: 26px;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-date {\n  text-align: left;\n  margin: 0 4px;\n  display: block;\n  color: rgba(0, 0, 0, 0.65);\n  height: 116px;\n  padding: 4px 8px;\n  border-top: 2px solid #e9e9e9;\n  transition: background .3s;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month:hover,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-date:hover {\n  background: #ecf6fd;\n  cursor: pointer;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month:active,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-date:active {\n  background: #d2eafb;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-column-header {\n  text-align: right;\n  padding-right: 12px;\n  padding-bottom: 5px;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-value {\n  text-align: right;\n  background: transparent;\n  width: auto;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-today .ant-fullcalendar-value {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month-panel-current-cell .ant-fullcalendar-month,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-today .ant-fullcalendar-date {\n  border-top-color: #108ee9;\n  background: transparent;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month-panel-current-cell .ant-fullcalendar-value,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-today .ant-fullcalendar-value {\n  box-shadow: none;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month-panel-selected-cell .ant-fullcalendar-month,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-selected-day .ant-fullcalendar-date {\n  background: #ecf6fd;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-month-panel-selected-cell .ant-fullcalendar-value,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-selected-day .ant-fullcalendar-value {\n  color: #108ee9;\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-last-month-cell .ant-fullcalendar-date,\n.ant-fullcalendar-fullscreen .ant-fullcalendar-next-month-btn-day .ant-fullcalendar-date {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-fullcalendar-fullscreen .ant-fullcalendar-content {\n  height: 90px;\n  overflow-y: auto;\n  position: static;\n  width: auto;\n  left: auto;\n  bottom: auto;\n}\n.ant-fullcalendar-disabled-cell .ant-fullcalendar-date,\n.ant-fullcalendar-disabled-cell .ant-fullcalendar-date:hover {\n  cursor: not-allowed;\n}\n.ant-fullcalendar-disabled-cell:not(.ant-fullcalendar-today) .ant-fullcalendar-date,\n.ant-fullcalendar-disabled-cell:not(.ant-fullcalendar-today) .ant-fullcalendar-date:hover {\n  background: transparent;\n}\n.ant-fullcalendar-disabled-cell .ant-fullcalendar-value {\n  color: rgba(0, 0, 0, 0.25);\n  border-radius: 0;\n  width: auto;\n  cursor: not-allowed;\n}\nnz-calendar {\n  display: block;\n  position: relative;\n}\n.ant-patch-full-height {\n  height: 100%;\n}\ntable {\n  display: inline-block;\n}\n.ant-fullcalendar-middle-day {\n  background: #9cdbf7;\n  border-radius: 4px;\n}\n"]
            },] },
];
/** @nocollapse */
DatepickerComponent.ctorParameters = function () { return []; };
DatepickerComponent.propDecorators = {
    "nzValue": [{ type: core.Input },],
    "nzClearTime": [{ type: core.Input },],
    "nzShowYear": [{ type: core.Input },],
    "nzShowMonth": [{ type: core.Input },],
    "nzClickDay": [{ type: core.Output },],
    "nzMouseDay": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DaterangepickerPipe = (function () {
    function DaterangepickerPipe() {
    }
    /**
     * @param {?} value
     * @param {?=} args
     * @return {?}
     */
    DaterangepickerPipe.prototype.transform = function (value, args) {
        if (isNaN(value)) {
            return value.name;
        }
        return value + "\u5929";
    };
    return DaterangepickerPipe;
}());
DaterangepickerPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'filterData'
            },] },
];
/** @nocollapse */
DaterangepickerPipe.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DaterangepickerModule = (function () {
    function DaterangepickerModule() {
    }
    return DaterangepickerModule;
}());
DaterangepickerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    ngZorroAntd.NzButtonModule
                ],
                exports: [DaterangepickerComponent, DatepickerComponent],
                declarations: [
                    DaterangepickerComponent,
                    DatepickerComponent,
                    DaterangepickerPipe
                ]
            },] },
];
/** @nocollapse */
DaterangepickerModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return EditorComponent; }),
    multi: true
};
var VALUE_VALIDATOR = {
    provide: forms.NG_VALIDATORS,
    useExisting: core.forwardRef(function () { return EditorComponent; }),
    multi: true
};
var EditorComponent = (function () {
    /**
     * @param {?} elemRef
     * @param {?} doc
     * @param {?} render
     */
    function EditorComponent(elemRef, doc, render) {
        this.elemRef = elemRef;
        this.doc = doc;
        this.render = render;
        this.emptyArray = [];
        this.defatulModules = {
            // 默认配置模块
            toolbar: [
                ['bold', 'italic', 'underline', 'strike'],
                // 切换按钮
                ['blockquote', 'code-block'],
                [{ 'header': 1 }, { 'header': 2 }],
                // 自定义按钮值
                [{ 'list': 'ordered' }, { 'list': 'bullet' }],
                [{ 'script': 'sub' }, { 'script': 'super' }],
                // 上/下标
                [{ 'indent': '-1' }, { 'indent': '+1' }],
                // 缩进
                [{ 'direction': 'rtl' }],
                // 文本方向
                [{ 'size': ['small', false, 'large', 'huge'] }],
                // 自定义下拉
                [{ 'header': [1, 2, 3, 4, 5, 6, false] }],
                [{ 'color': this.emptyArray.slice() }, { 'background': this.emptyArray.slice() }],
                // 默认主题的下拉菜单
                [{ 'font': this.emptyArray.slice() }],
                [{ 'align': this.emptyArray.slice() }],
                ['clean'],
                // 清除格式按钮
                ['link', 'image', 'video'] // 链接、图像、视频按钮
            ]
        };
        this.style = {};
        this.strict = true;
        // 创建编辑器时
        this.onEditorCreated = new core.EventEmitter();
        // 内容改变时
        this.onContentChanged = new core.EventEmitter();
        // mark model as touched if editor lost focus
        this.onSelectionChanged = new core.EventEmitter();
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    /**
     * @return {?}
     */
    EditorComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var /** @type {?} */ toolbarElem = this.elemRef.nativeElement.querySelector('[quill-editor-toolbar]');
        var /** @type {?} */ modules = this.modules || this.defatulModules;
        if (toolbarElem) {
            modules['toolbar'] = toolbarElem;
        }
        this.elemRef.nativeElement.insertAdjacentHTML('beforeend', '<div quill-editor-element></div>');
        this.editorElem = this.elemRef.nativeElement.querySelector('[quill-editor-element]');
        if (this.style) {
            Object.keys(this.style).forEach(function (key) {
                _this.render.setStyle(_this.editorElem, key, _this.style[key]);
            });
        }
        this.editor = new Quill(this.editorElem, {
            modules: modules,
            placeholder: this.placeholder || '请输入内容',
            readOnly: this.readOnly || false,
            theme: this.theme || 'snow',
            formats: this.formats,
            bounds: this.bounds || this.doc.body,
            strict: this.strict,
            scrollingContainer: this.scrollingContainer
        });
        if (this.content) {
            var /** @type {?} */ contents = this.editor.clipboard.convert(this.content);
            this.editor.setContents(contents);
            this.editor.history.clear();
        }
        this.onEditorCreated.emit(this.editor);
        this.editor.on('selection-change', function (range, oldRange, source) {
            _this.onSelectionChanged.emit({
                editor: _this.editor,
                range: range,
                oldRange: oldRange,
                source: source
            });
            if (!range) {
                _this.onModelTouched();
            }
        });
        this.editor.on('text-change', function (delta, oldContents, source) {
            var /** @type {?} */ html = _this.editorElem.children[0].innerHTML;
            var /** @type {?} */ text = _this.editor.getText();
            if (html === '<p></br></p>') {
                html = null;
            }
            _this.onModelChange(html);
            _this.onContentChanged.emit({
                editor: _this.editor,
                html: html,
                text: text,
                delta: delta,
                oldContents: oldContents,
                source: source
            });
        });
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    EditorComponent.prototype.ngOnChanges = function (changes) {
        if (changes['readOnly'] && this.editor) {
            this.editor.enable(!changes['readOnly'].currentValue);
        }
    };
    /**
     * @param {?} currentValue
     * @return {?}
     */
    EditorComponent.prototype.writeValue = function (currentValue) {
        this.content = currentValue;
        if (this.editor) {
            if (currentValue) {
                this.editor.setContents(this.editor.clipboard.convert(this.content));
                return;
            }
            this.editor.setText('');
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    EditorComponent.prototype.registerOnChange = function (fn) {
        this.onModelChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    EditorComponent.prototype.registerOnTouched = function (fn) {
        this.onModelTouched = fn;
    };
    /**
     * @return {?}
     */
    EditorComponent.prototype.validate = function () {
        if (!this.editor) {
            return null;
        }
        var /** @type {?} */ err = {};
        var /** @type {?} */ valid = true;
        var /** @type {?} */ textLength = this.editor.getText().trim().length;
        if (this.minLength && textLength && textLength < this.minLength) {
            err['minLengthError'] = {
                given: textLength,
                minLength: this.minLength
            };
            valid = false;
        }
        if (this.maxLength && textLength && textLength > this.maxLength) {
            err['maxLengthError'] = {
                given: textLength,
                maxLength: this.maxLength
            };
            valid = false;
        }
        if (this.required && !textLength) {
            err['requiredError'] = {
                empty: true
            };
            valid = false;
        }
        return valid ? null : err;
    };
    return EditorComponent;
}());
EditorComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-editor',
                template: "<ng-content select=\"[quill-editor-toolbar]\"></ng-content>",
                providers: [VALUE_ACCESSOR, VALUE_VALIDATOR],
                encapsulation: core.ViewEncapsulation.None,
                styles: [
                    ".ql-toolbar.ql-snow {\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n}\n.ql-container.ql-snow {\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n}\n.ql-container .ql-editor {\n  min-height: 200px;\n  padding-bottom: 10px;\n}\n"
                ]
            },] },
];
/** @nocollapse */
EditorComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: undefined, decorators: [{ type: core.Inject, args: [platformBrowser.DOCUMENT,] },] },
    { type: core.Renderer2, },
]; };
EditorComponent.propDecorators = {
    "theme": [{ type: core.Input },],
    "modules": [{ type: core.Input },],
    "readOnly": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "maxLength": [{ type: core.Input },],
    "minLength": [{ type: core.Input },],
    "required": [{ type: core.Input },],
    "formats": [{ type: core.Input },],
    "style": [{ type: core.Input },],
    "strict": [{ type: core.Input },],
    "scrollingContainer": [{ type: core.Input },],
    "bounds": [{ type: core.Input },],
    "onEditorCreated": [{ type: core.Output },],
    "onContentChanged": [{ type: core.Output },],
    "onSelectionChanged": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EditorModule = (function () {
    function EditorModule() {
    }
    return EditorModule;
}());
EditorModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [EditorComponent],
                imports: [common.CommonModule],
                exports: [EditorComponent],
                providers: [],
            },] },
];
/** @nocollapse */
EditorModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ScriptService = (function () {
    function ScriptService() {
        this.loaded = false;
        this.list = {};
        this.emitter = new Subject.Subject();
    }
    /**
     * @return {?}
     */
    ScriptService.prototype.getChangeEmitter = function () {
        return this.emitter;
    };
    /**
     * @param {?} path
     * @param {?=} debug
     * @return {?}
     */
    ScriptService.prototype.load = function (path, debug) {
        var _this = this;
        if (this.loaded)
            return this;
        this.loaded = true;
        var /** @type {?} */ promises = [];
        if (!path.endsWith('/'))
            path += '/';
        [path + "ueditor.config.js", debug === true ? path + "ueditor.all.js" : path + "ueditor.all.min.js"].forEach(function (script) { return promises.push(_this.loadScript(script)); });
        Promise.all(promises).then(function (res) {
            _this.emitter.next(true);
        });
        return this;
    };
    /**
     * @param {?} path
     * @return {?}
     */
    ScriptService.prototype.loadScript = function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.list[path] === true) {
                resolve(/** @type {?} */ ({
                    path: path,
                    loaded: true,
                    status: 'Loaded'
                }));
                return;
            }
            _this.list[path] = true;
            var /** @type {?} */ node = document.createElement('script');
            node.type = 'text/javascript';
            node.src = path;
            node.charset = 'utf-8';
            if (node.readyState) {
                // IE
                node.onreadystatechange = function () {
                    if (node.readyState === "loaded" || node.readyState === "complete") {
                        node.onreadystatechange = null;
                        resolve(/** @type {?} */ ({
                            path: path,
                            loaded: true,
                            status: 'Loaded'
                        }));
                    }
                };
            }
            else {
                node.onload = function () {
                    resolve(/** @type {?} */ ({
                        path: path,
                        loaded: true,
                        status: 'Loaded'
                    }));
                };
            }
            node.onerror = function (error) { return resolve(/** @type {?} */ ({
                path: path,
                loaded: false,
                status: 'Loaded'
            })); };
            document.getElementsByTagName('head')[0].appendChild(node);
        });
    };
    return ScriptService;
}());
ScriptService.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ScriptService.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UEditorConfig = (function () {
    function UEditorConfig() {
        /**
         * 用于标记hook是否已经注册完成
         *
         */
        this.hook_finished = false;
    }
    return UEditorConfig;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var VALUE_ACCESSOR$1 = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return UEditorComponent; }),
    multi: true
};
var UEditorComponent = (function () {
    /**
     * @param {?} ss
     * @param {?} defaultConfig
     * @param {?} zone
     * @param {?} render
     */
    function UEditorComponent(ss, defaultConfig, zone, render) {
        this.ss = ss;
        this.defaultConfig = defaultConfig;
        this.zone = zone;
        this.render = render;
        this.events = {};
        this.loading = false;
        this.loadingTip = '加载中......';
        this.style = {};
        this.onPreReady = new core.EventEmitter();
        this.onReady = new core.EventEmitter();
        this.onDestroy = new core.EventEmitter();
        this.onContentChange = new core.EventEmitter();
        this.onChange = function () { };
        this.onTouched = function () { };
    }
    /**
     * @return {?}
     */
    UEditorComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.path = this.defaultConfig && this.defaultConfig.path;
        if (!this.path)
            this.path = '../assets/ueditor/';
        // 构建一个虚拟id
        this.id = 'ueditor-' + new Date().getTime();
        this.host.nativeElement.id = this.id;
        // 自定义样式
        if (this.style) {
            Object.keys(this.style).forEach(function (key) {
                _this.render.setStyle(_this.host.nativeElement, key, _this.style[key]);
            });
        }
        // 已经存在对象无须进入懒加载模式
        if (window.UE) {
            this.init();
            return;
        }
        this.ss.load(this.path, true).getChangeEmitter().subscribe(function (res) {
            _this.init();
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    UEditorComponent.prototype.init = function (options) {
        var _this = this;
        if (!window.UE) {
            throw new Error('ueditor js文件加载失败');
        }
        if (this.instance) {
            return;
        }
        // registrer hook
        if (this.defaultConfig && this.defaultConfig.hook) {
            if (!this.defaultConfig.hook_finished) {
                this.defaultConfig.hook_finished = true;
                this.defaultConfig.hook(UE);
            }
        }
        this.loading = false;
        this.onPreReady.emit(this);
        this.zone.runOutsideAngular(function () {
            var /** @type {?} */ opt = Object.assign({
                UEDITOR_HOME_URL: _this.path
            }, _this.defaultConfig && _this.defaultConfig.options, _this.config, options);
            var /** @type {?} */ ueditor = UE.getEditor(_this.id, opt);
            ueditor.ready(function () {
                _this.zone.run(function () {
                    _this.instance = ueditor;
                    _this.value && _this.instance.setContent(_this.value);
                    _this.onReady.emit(_this);
                });
            });
            ueditor.addListener('contentChange', function () {
                _this.updateValue(ueditor.getContent());
            });
        });
    };
    /**
     * @param {?} value
     * @return {?}
     */
    UEditorComponent.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            _this.value = value;
            _this.onChange(_this.value);
            _this.onTouched(_this.value);
            _this.onContentChange.emit(_this.value);
        });
    };
    /**
     * @return {?}
     */
    UEditorComponent.prototype.destroy = function () {
        if (this.instance) {
            for (var _i = 0, _b = this.events; _i < _b.length; _i++) {
                var k = _b[_i];
                this.instance.removeListener(k, this.events[k]);
            }
            this.instance.removeListener('ready');
            this.instance.removeListener('contentChange');
            this.instance.destroy();
            this.instance = null;
        }
        this.onDestroy.emit();
    };
    Object.defineProperty(UEditorComponent.prototype, "Instance", {
        /**
         * 获取UE实例
         *
         * @return {?}
         */
        get: function () {
            return this.instance;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * 设置编辑语言
     * @param {?} lang
     * @return {?}
     */
    UEditorComponent.prototype.setLang = function (lang) {
        var _this = this;
        this.ss.loadScript(this.path + "/lang/" + lang + "/" + lang + ".js").then(function (res) {
            _this.destroy();
            //清空语言
            if (!UE._bak_I18N) {
                UE._bak_I18N = UE.I18N;
            }
            UE.I18N = {};
            UE.I18N[lang] = UE._bak_I18N[lang];
            _this.init();
        });
    };
    /**
     * 添加编辑器事件
     * @param {?} eventName
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.addListener = function (eventName, fn) {
        if (this.events[eventName])
            return;
        this.events[eventName] = fn;
        this.instance.addListener(eventName, fn);
    };
    /**
     * 移除编辑器事件
     * @param {?} eventName
     * @return {?}
     */
    UEditorComponent.prototype.removeListener = function (eventName) {
        if (!this.events[eventName])
            return;
        this.instance.removeListener(eventName, this.events[eventName]);
        delete this.events[eventName];
    };
    /**
     * @param {?} value
     * @return {?}
     */
    UEditorComponent.prototype.writeValue = function (value) {
        this.value = value;
        if (this.instance) {
            this.instance.setContent(value);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    /**
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    UEditorComponent.prototype.setDisabledState = function (isDisabled) {
        if (isDisabled) {
            this.instance.setDisabled();
        }
        else {
            this.instance.setEnabled();
        }
    };
    /**
     * @return {?}
     */
    UEditorComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    return UEditorComponent;
}());
UEditorComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'bui-ueditor',
                template: "\n    <textarea #host class=\"ueditor-textarea\"></textarea>\n    <p class=\"loading\" *ngIf=\"loading\">{{loadingTip}}</p>",
                styles: [".ueditor-textarea{display:none;}"],
                encapsulation: core.ViewEncapsulation.Emulated,
                providers: [VALUE_ACCESSOR$1]
            },] },
];
/** @nocollapse */
UEditorComponent.ctorParameters = function () { return [
    { type: ScriptService, },
    { type: UEditorConfig, },
    { type: core.NgZone, },
    { type: core.Renderer2, },
]; };
UEditorComponent.propDecorators = {
    "config": [{ type: core.Input },],
    "loadingTip": [{ type: core.Input },],
    "style": [{ type: core.Input },],
    "host": [{ type: core.ViewChild, args: ['host',] },],
    "onPreReady": [{ type: core.Output },],
    "onReady": [{ type: core.Output },],
    "onDestroy": [{ type: core.Output },],
    "onContentChange": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var COMPONENTS$6 = [UEditorComponent];
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UEditorModule = (function () {
    function UEditorModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    UEditorModule.forRoot = function (config) {
        return {
            ngModule: UEditorModule,
            providers: [
                { provide: UEditorConfig, useValue: config }
            ]
        };
    };
    return UEditorModule;
}());
UEditorModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: COMPONENTS$6.slice(),
                imports: [common.CommonModule],
                exports: COMPONENTS$6.slice(),
                providers: [ScriptService],
            },] },
];
/** @nocollapse */
UEditorModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var modules = [TableModule, PaginationModule, ButtonModule, StepsModule, UploadModule, AvatarModule, SelectModule, CheckboxModule,
    DropDownModule, TreeSelectModule, SelectBoxModule, LayerModule, JqGridModule, BgEChartsModule, DaterangepickerModule, EditorModule, UEditorModule
];
var BangUiModule = (function () {
    function BangUiModule() {
    }
    return BangUiModule;
}());
BangUiModule.decorators = [
    { type: core.NgModule, args: [{
                exports: modules.slice()
            },] },
];
/** @nocollapse */
BangUiModule.ctorParameters = function () { return []; };

exports.TableModule = TableModule;
exports.PaginationModule = PaginationModule;
exports.ButtonModule = ButtonModule;
exports.StepsModule = StepsModule;
exports.UploadModule = UploadModule;
exports.AvatarModule = AvatarModule;
exports.SelectModule = SelectModule;
exports.CheckboxModule = CheckboxModule;
exports.DropDownModule = DropDownModule;
exports.TreeSelectModule = TreeSelectModule;
exports.SelectBoxModule = SelectBoxModule;
exports.LayerModule = LayerModule;
exports.JqGridModule = JqGridModule;
exports.BgEChartsModule = BgEChartsModule;
exports.DaterangepickerModule = DaterangepickerModule;
exports.UEditorModule = UEditorModule;
exports.EditorModule = EditorModule;
exports.UploadService = UploadService;
exports.modules = modules;
exports.BangUiModule = BangUiModule;
exports.ɵx = AvatarComponent;
exports.ɵca = BgEChartsComponent;
exports.ɵf = COMPONENTS$5;
exports.ɵcb = EChartsService;
exports.ɵt = ButtonGrouppComponent;
exports.ɵu = ButtonComponent;
exports.ɵb = COMPONENTS$1;
exports.ɵbe = CHECKBOX_VAL_ACCESSOR$1;
exports.ɵbf = CheckboxGroupComponent;
exports.ɵbc = CHECKBOX_VAL_ACCESSOR;
exports.ɵbd = CheckboxComponent;
exports.ɵc = COMPONENTS$2;
exports.ɵz = ChineseToPinyinService;
exports.ɵcd = DatepickerComponent;
exports.ɵcc = DaterangepickerComponent;
exports.ɵce = DaterangepickerPipe;
exports.ɵbg = DropDownComponent;
exports.ɵbh = DropDownService;
exports.ɵcf = EditorComponent;
exports.ɵby = JqGridComponent;
exports.ɵbz = JqGridService;
exports.ɵbw = LayerComponent;
exports.ɵbx = LayerService;
exports.ɵg = PaginationComponent;
exports.ɵa = COMPONENTS;
exports.ɵbv = OffClickDirective$1;
exports.ɵbu = ItemPipe$1;
exports.ɵbs = SelectBoxDefaultOptions;
exports.ɵbt = SelectBoxItemComponent;
exports.ɵbp = CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR$1;
exports.ɵbq = SelectBoxComponent;
exports.ɵe = COMPONENTS$4;
exports.ɵbr = SelectService$1;
exports.ɵba = DropDownAnimation;
exports.ɵy = SelectComponent;
exports.ɵbb = TagAnimation;
exports.ɵv = StepsComponent;
exports.ɵq = DataTableSortComponent;
exports.ɵh = DataTableComponent;
exports.ɵr = RowExpandIconComponent;
exports.ɵs = RowIndentComponent;
exports.ɵo = DataDividerDirective;
exports.ɵn = DataTbodyTrDirective;
exports.ɵm = DataTbodyDirective;
exports.ɵk = DataTdDirective;
exports.ɵj = DataThDirective;
exports.ɵl = DataTheadDirective;
exports.ɵp = DraggbleDirective;
exports.ɵi = TableService;
exports.ɵbn = OffClickDirective;
exports.ɵbo = ItemPipe;
exports.ɵbl = TreeSelectDefaultOptions;
exports.ɵbk = SelectService;
exports.ɵbm = TreeSelectItemComponent;
exports.ɵbi = CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR;
exports.ɵbj = TreeSelectComponent;
exports.ɵd = COMPONENTS$3;
exports.ɵcg = COMPONENTS$6;
exports.ɵci = ScriptService;
exports.ɵch = UEditorComponent;
exports.ɵcj = UEditorConfig;
exports.ɵw = UploadComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-bang-ui.umd.js.map
